--------------------------------------------------------------------------
-- Play this script in SCHEMA_250 to make it look like SCHEMA_260
--                                                                      --
-- Please review the script before using it to make sure it won't       --
-- cause any unacceptable data loss.                                    --
--                                                                      --
-- SCHEMA_250 Schema Extracted by User SCHEMA_250 
-- SCHEMA_260 Schema Extracted by User SCHEMA_260 
--------------------------------------------------------------------------

spool satellite-db-2.5.0-to-2.6.0.log

whenever sqlerror exit failure;

declare
	ignore number := 0;
begin
	select	1
	into	ignore
	from	rhnVersionInfo rvi
	where	rvi.label = 'schema'
		and rvi.name_id = lookup_package_name('rhn-satellite-schema')
		-- there are several versions from which upgrades should work
		and rvi.evr_id in (
			lookup_evr('','2.5','74'),
			lookup_evr('','2.5','74.1'),
			lookup_evr('','2.5','89'),
			lookup_evr('','2.5','89.1'),
			lookup_evr('','2.5','91'),
			lookup_evr('','2.5','91.1')
		);
end;
/

--
-- 16. RHN_HWPROPS_HID_FK  (Constraint) 
--
ALTER TABLE RHNHARDWAREPROPERTIES DROP CONSTRAINT RHN_HWPROPS_HID_FK;

--
-- 17. RHN_HWPROPS_NID_FK  (Constraint) 
--
ALTER TABLE RHNHARDWAREPROPERTIES DROP CONSTRAINT RHN_HWPROPS_NID_FK;

--
-- 18. RHN_HWPROPS_VID_FK  (Constraint) 
--
ALTER TABLE RHNHARDWAREPROPERTIES DROP CONSTRAINT RHN_HWPROPS_VID_FK;


--
-- 1. RHN_HW_CID_NN  (Constraint) 
--
ALTER TABLE RHNHARDWARE DROP CONSTRAINT RHN_HW_CID_NN;

--
-- 2. RHN_HW_ID_NN  (Constraint) 
--
ALTER TABLE RHNHARDWARE DROP CONSTRAINT RHN_HW_ID_NN;

--
-- 3. RHN_HW_ID_PK  (Constraint) 
--
ALTER TABLE RHNHARDWARE DROP PRIMARY KEY CASCADE;

--
-- 4. RHN_HW_CID_FK  (Constraint) 
--
ALTER TABLE RHNHARDWARE DROP CONSTRAINT RHN_HW_CID_FK;

--
-- 5. RHN_HWPNAME_ID_NN  (Constraint) 
--
ALTER TABLE RHNHARDWAREPROPNAME DROP CONSTRAINT RHN_HWPNAME_ID_NN;

--
-- 6. RHN_HWPNAME_NAME_NN  (Constraint) 
--
ALTER TABLE RHNHARDWAREPROPNAME DROP CONSTRAINT RHN_HWPNAME_NAME_NN;

--
-- 7. RHN_HWPNAME_ID_PK  (Constraint) 
--
ALTER TABLE RHNHARDWAREPROPNAME DROP PRIMARY KEY CASCADE;

--
-- 8. RHN_HWPNAME_NAME_UQ  (Constraint) 
--
ALTER TABLE RHNHARDWAREPROPNAME DROP CONSTRAINT RHN_HWPNAME_NAME_UQ;

--
-- 9. RHN_HWPVALUE_ID_NN  (Constraint) 
--
ALTER TABLE RHNHARDWAREPROPVALUE DROP CONSTRAINT RHN_HWPVALUE_ID_NN;

--
-- 10. RHN_HWPVALUE_ID_PK  (Constraint) 
--
ALTER TABLE RHNHARDWAREPROPVALUE DROP PRIMARY KEY CASCADE;

--
-- 11. RHN_HWPVALUE_VALUE_UQ  (Constraint) 
--
ALTER TABLE RHNHARDWAREPROPVALUE DROP CONSTRAINT RHN_HWPVALUE_VALUE_UQ;

--
-- 12. RHN_TRANSPACK_PAID_NN  (Constraint) 
--
ALTER TABLE RHNTRANSACTIONPACKAGE DROP CONSTRAINT RHN_TRANSPACK_PAID_NN;

--
-- 13. RHN_HWPROPS_HID_NN  (Constraint) 
--
ALTER TABLE RHNHARDWAREPROPERTIES DROP CONSTRAINT RHN_HWPROPS_HID_NN;

--
-- 14. RHN_HWPROPS_NID_NN  (Constraint) 
--
ALTER TABLE RHNHARDWAREPROPERTIES DROP CONSTRAINT RHN_HWPROPS_NID_NN;

--
-- 15. RHN_HWPROPS_VID_NN  (Constraint) 
--
ALTER TABLE RHNHARDWAREPROPERTIES DROP CONSTRAINT RHN_HWPROPS_VID_NN;

--
-- 19. LOOKUP_HW_PROP_VALUE  (Function) 
--
DROP FUNCTION LOOKUP_HW_PROP_VALUE;

--
-- 20. LOOKUP_HW_PROP_NAME  (Function) 
--
DROP FUNCTION LOOKUP_HW_PROP_NAME;

--
-- 21. LOOKUP_HW_DEVICE  (Function) 
--
DROP FUNCTION LOOKUP_HW_DEVICE;

--
-- 22. LOOKUP_HW_CLASS  (Function) 
--
DROP FUNCTION LOOKUP_HW_CLASS;

--
-- 23. LOOKUP_DISK_DEVICE  (Function) 
--
DROP FUNCTION LOOKUP_DISK_DEVICE;

--
-- 24. LOOKUP_CD_DEVICE  (Function) 
--
DROP FUNCTION LOOKUP_CD_DEVICE;

--
-- 25. ADD_HARDWARE_PROPERTY  (Procedure) 
--
DROP PROCEDURE ADD_HARDWARE_PROPERTY;

--
-- 26. RHN_HW_ID_IDX  (Index) 
--
DROP INDEX RHN_HW_ID_IDX;

--
-- 27. RHN_HW_CLASS_ID_IDX  (Index) 
--
DROP INDEX RHN_HW_CLASS_ID_IDX;

--
-- 28. RHN_HWPVALUE_VALUE_ID_IDX  (Index) 
--
DROP INDEX RHN_HWPVALUE_VALUE_ID_IDX;

--
-- 29. RHN_HWPVALUE_ID_IDX  (Index) 
--
DROP INDEX RHN_HWPVALUE_ID_IDX;

--
-- 30. RHN_HWPROPS_HID_NID_IDX  (Index) 
--
DROP INDEX RHN_HWPROPS_HID_NID_IDX;

--
-- 31. RHN_HWPNAME_NAME_ID_IDX  (Index) 
--
DROP INDEX RHN_HWPNAME_NAME_ID_IDX;

--
-- 32. RHN_HWPNAME_ID_IDX  (Index) 
--
DROP INDEX RHN_HWPNAME_ID_IDX;

--
-- 33. RHN_HWCLASS_LABEL_ID_IDX  (Index) 
--
alter table RHNHARDWARECLASS DROP constraint RHN_HWCLASS_LABEL_UQ;
DROP INDEX RHN_HWCLASS_LABEL_ID_IDX;

--
-- 34. RHN_HWCLASS_ID_IDX  (Index) 
--
ALTER TABLE RHNHARDWARECLASS DROP PRIMARY KEY CASCADE;
DROP INDEX RHN_HWCLASS_ID_IDX;

--
-- 35. RHN_FILE_OID_FSIZE_MD5_UQ  (Index) 
--
DROP INDEX RHN_FILE_OID_FSIZE_MD5_UQ;

--
-- 36. RHNHARDWARECLASS  (Table) 
--
DROP TABLE RHNHARDWARECLASS CASCADE CONSTRAINTS;

--
-- 37. RHN_HW_ID_SEQ  (Sequence) 
--
DROP SEQUENCE RHN_HW_ID_SEQ;

--
-- 38. RHN_HWPVALUE_ID_SEQ  (Sequence) 
--
DROP SEQUENCE RHN_HWPVALUE_ID_SEQ;

--
-- 39. RHN_HWPNAME_ID_SEQ  (Sequence) 
--
DROP SEQUENCE RHN_HWPNAME_ID_SEQ;

--
-- 40. RHN_HWCLASS_ID_SEQ  (Sequence) 
--
DROP SEQUENCE RHN_HWCLASS_ID_SEQ;

--
-- 41. RHN_CLIENT_CAPNAME_ID_SEQ  (Sequence) 
--
CREATE SEQUENCE RHN_CLIENT_CAPNAME_ID_SEQ
  START WITH 1
  NOMAXVALUE
  MINVALUE 1
  NOCYCLE
  CACHE 20
  NOORDER;

--
-- 42. RHN_CPERM_ROLE_ID_SEQ  (Sequence) 
--
CREATE SEQUENCE RHN_CPERM_ROLE_ID_SEQ
  START WITH 21
  NOMAXVALUE
  MINVALUE 1
  NOCYCLE
  CACHE 20
  NOORDER;

--
-- 43. RHN_HARDWARE_ID_SEQ  (Sequence) 
--
CREATE SEQUENCE RHN_HARDWARE_ID_SEQ
  START WITH 1
  NOMAXVALUE
  MINVALUE 1
  NOCYCLE
  CACHE 20
  NOORDER;

--
-- 44. RHN_HWPROPNAME_ID_SEQ  (Sequence) 
--
CREATE SEQUENCE RHN_HWPROPNAME_ID_SEQ
  START WITH 1
  NOMAXVALUE
  MINVALUE 1
  NOCYCLE
  CACHE 20
  NOORDER;

--
-- 45. RHN_HWPROPVAL_ID_SEQ  (Sequence) 
--
CREATE SEQUENCE RHN_HWPROPVAL_ID_SEQ
  START WITH 1
  NOMAXVALUE
  MINVALUE 1
  NOCYCLE
  CACHE 20
  NOORDER;

--
-- 46. RHN_OCSTNGS_TYPE_ID_SEQ  (Sequence) 
--
CREATE SEQUENCE RHN_OCSTNGS_TYPE_ID_SEQ
  START WITH 21
  NOMAXVALUE
  MINVALUE 1
  NOCYCLE
  CACHE 20
  NOORDER;

--
-- 47. RHNCHANNELPERMISSIONROLE  (Table) 
--
CREATE TABLE RHNCHANNELPERMISSIONROLE
(
  ID           NUMBER CONSTRAINT RHN_CPERM_ROLE_ID_NN NOT NULL,
  LABEL        VARCHAR2(32 BYTE) CONSTRAINT RHN_CPERM_ROLE_LABEL_NN NOT NULL,
  DESCRIPTION  VARCHAR2(128 BYTE) CONSTRAINT RHN_CPERM_ROLE_DESC_NN NOT NULL,
  CREATED      DATE                             DEFAULT (sysdate) CONSTRAINT RHN_CPERM_ROLE_CREATED_NN NOT NULL,
  MODIFIED     DATE                             DEFAULT (sysdate) CONSTRAINT RHN_CPERM_ROLE_MODIFIED_NN NOT NULL
)
LOGGING 
NOCACHE
NOPARALLEL;

insert into rhnChannelPermissionRole (id, label, description)
	values (rhn_cperm_role_id_seq.nextval,
		'subscribe',
		'Permission to subscribe to channel');
insert into rhnChannelPermissionRole (id, label, description)
	values (rhn_cperm_role_id_seq.nextval,
		'manage',
		'Permission to manage channel');

--
-- 48. RHNCLIENTCAPABILITYNAME  (Table) 
--
CREATE TABLE RHNCLIENTCAPABILITYNAME
(
  ID    NUMBER CONSTRAINT RHN_CLIENTCAPNAM_ID_NN NOT NULL,
  NAME  VARCHAR2(32 BYTE) CONSTRAINT RHN_CLIENTCAPNAM_NAME_NN NOT NULL
)
LOGGING 
NOCACHE
NOPARALLEL;

--
-- 49. NUM_PROPS  (Column) 
--
ALTER TABLE RHNHARDWARE ADD (NUM_PROPS  NUMBER CONSTRAINT RHN_HARDWARE_NP_NN NOT NULL);

--
-- 50. CLASS  (Column) 
--
ALTER TABLE RHNHARDWARE ADD (CLASS  VARCHAR2(16 BYTE));

--
-- 51. BUS  (Column) 
--
ALTER TABLE RHNHARDWARE ADD (BUS  VARCHAR2(32 BYTE));

--
-- 52. DESCRIPTION  (Column) 
--
ALTER TABLE RHNHARDWARE ADD (DESCRIPTION  VARCHAR2(256 BYTE));

--
-- 53. CSUM  (Column) 
--
ALTER TABLE RHNHARDWARE ADD (CSUM  NUMBER CONSTRAINT RHN_HARDWARE_CSUM_NN  NOT NULL);

--
-- 54. CREATED  (Column) 
--
ALTER TABLE RHNHARDWARE ADD (CREATED  DATE                                 DEFAULT (sysdate));

--
-- 55. MODIFIED  (Column) 
--
ALTER TABLE RHNHARDWARE ADD (MODIFIED  DATE                                DEFAULT (sysdate));

--
-- 56. CLASS_ID  (Column) 
--
ALTER TABLE RHNHARDWARE DROP COLUMN CLASS_ID;

--
-- 57. NAME  (Column) 
--
ALTER TABLE RHNHARDWAREPROPNAME
MODIFY(NAME VARCHAR2(20 BYTE));


--
-- 58. CSUM  (Column) 
--
ALTER TABLE RHNHARDWAREPROPVALUE ADD (CSUM  NUMBER);

--
-- 59. RHNORGCHANNELSETTINGSTYPE  (Table) 
--
CREATE TABLE RHNORGCHANNELSETTINGSTYPE
(
  ID        NUMBER CONSTRAINT RHN_OCSTNGS_TYPE_ID_NN NOT NULL,
  LABEL     VARCHAR2(32 BYTE) CONSTRAINT RHN_OCSTNGS_TYPE_LABEL_NN NOT NULL,
  CREATED   DATE                                DEFAULT (sysdate) CONSTRAINT RHN_OCSTNGS_TYPE_CREATED_NN NOT NULL,
  MODIFIED  DATE                                DEFAULT (sysdate) CONSTRAINT RHN_OCSTNGS_TYPE_MODIFIED_NN NOT NULL
)
LOGGING 
NOCACHE
NOPARALLEL;

insert into rhnOrgChannelSettingsType ( id, label )
	values ( rhn_ocstngs_type_id_seq.nextval, 'not_globally_subscribable' );

commit;

--
-- 60. PACKAGE_ARCH_ID  (Column) 
--
-- XXX why does it want to do this?  --pj
-- ALTER TABLE RHNTRANSACTIONPACKAGE
-- MODIFY(PACKAGE_ARCH_ID  NULL);


--
-- 61. RHN_CLIENTCAPNAM_ID_PK  (Index) 
--
CREATE UNIQUE INDEX RHN_CLIENTCAPNAM_ID_PK ON RHNCLIENTCAPABILITYNAME
(ID)
LOGGING
NOPARALLEL;

--
-- 62. RHN_CPERM_ROLE_ID_PK  (Index) 
--
CREATE INDEX RHN_CPERM_ROLE_ID_PK ON RHNCHANNELPERMISSIONROLE
(ID)
LOGGING
NOPARALLEL;

--
-- 63. RHN_CPERM_ROLE_LABEL_ID_IDX  (Index) 
--
CREATE INDEX RHN_CPERM_ROLE_LABEL_ID_IDX ON RHNCHANNELPERMISSIONROLE
(LABEL, ID)
LOGGING
NOPARALLEL;

--
-- 64. RHN_HARDWARE_ID_IDX  (Index) 
--
CREATE INDEX RHN_HARDWARE_ID_IDX ON RHNHARDWARE
(ID)
LOGGING
NOPARALLEL;

--
-- 65. RHN_HWARDWARE_CSUM_ID_IDX  (Index) 
--
CREATE INDEX RHN_HWARDWARE_CSUM_ID_IDX ON RHNHARDWARE
(CSUM, ID)
LOGGING
NOPARALLEL;

--
-- 66. RHN_HWPROPNAME_ID_IDX  (Index) 
--
CREATE INDEX RHN_HWPROPNAME_ID_IDX ON RHNHARDWAREPROPNAME
(ID)
LOGGING
NOPARALLEL;

--
-- 67. RHN_HWPROPNAME_NAME_ID_IDX  (Index) 
--
CREATE INDEX RHN_HWPROPNAME_NAME_ID_IDX ON RHNHARDWAREPROPNAME
(NAME, ID)
LOGGING
NOPARALLEL;

--
-- 68. RHN_HWPROPVAL_CSUM_ID_IDX  (Index) 
--
CREATE INDEX RHN_HWPROPVAL_CSUM_ID_IDX ON RHNHARDWAREPROPVALUE
(CSUM, ID)
LOGGING
NOPARALLEL;

--
-- 69. RHN_HWPROPVAL_ID_IDX  (Index) 
--
CREATE INDEX RHN_HWPROPVAL_ID_IDX ON RHNHARDWAREPROPVALUE
(ID)
LOGGING
NOPARALLEL;

--
-- 70. RHN_OCSTNGS_TYPE_ID_PK  (Index) 
--
CREATE UNIQUE INDEX RHN_OCSTNGS_TYPE_ID_PK ON RHNORGCHANNELSETTINGSTYPE
(ID)
LOGGING
NOPARALLEL;

--
-- 71. RHN_OCSTNGS_TYPE_L_ID_IDX  (Index) 
--
CREATE INDEX RHN_OCSTNGS_TYPE_L_ID_IDX ON RHNORGCHANNELSETTINGSTYPE
(LABEL, ID)
LOGGING
NOPARALLEL;

--
-- 72. RHN_BEL  (Package Body) 
--
create or replace
package body rhn_bel
is
	function find_state_of_org (
		org_id_in in number
	) return varchar2 is
		state_label rhnOrgAvailableStates.label%TYPE;
	begin
		select oas.label into state_label
		from    rhnOrgAvailableStates oas,
			rhnOrgState os
		where   os.org_id = org_id_in
			and os.state_id = oas.id;

		return state_label;
	end find_state_of_org;

	function is_state_legacy_unclassified (
		org_id_in in number
	) return number is
		cursor states is
			select	1
			from	rhnOrgAvailableStates oas,
					rhnOrgState os
			where	os.org_id = org_id_in
				and os.state_id = oas.id
					and oas.label = 'legacy_unclassified';
	begin
		for x in states loop return 1; end loop;
		return 0;
	end is_state_legacy_unclassified;

	function is_org_paid (
		org_id_in in number
	) return number is
		cursor paids is
			select	1
			from	rhnPaidOrgs
			where	org_id = org_id_in;
	begin
		for paid in paids loop return 1; end loop;
		return 0;
	end;

	function lookup_email_state (
		state_in in varchar2
	) return number is
		retval number;
	begin
		select id into retval from rhnEmailAddressState where label = state_in;
		return retval;
	exception
			when no_data_found then
				rhn_exception.raise_exception('invalid_state');
	end lookup_email_state;

	procedure check_org_state (
		state_id_in in number
	) is
		ignore number;
	begin
		select id into ignore from rhnOrgAvailableStates where id = state_id_in;
	exception
			when no_data_found then
				rhn_exception.raise_exception('invalid_state');
	end check_org_state;

	function lookup_org_state (
		state_in in varchar2
	) return number is
		retval number;
	begin
		select id into retval from rhnOrgAvailableStates where label = state_in;
		return retval;
	exception
			when no_data_found then
				rhn_exception.raise_exception('invalid_state');
	end lookup_org_state;

	procedure validate_org_state_change (
		from_state_in in number,
		to_state_in in number
	) is
		ignore	number;
	begin
		select	1
		into	ignore
		from	rhnOrgStateTransitions	rost
		where	1=1
			and rost.from_state = from_state_in
			and rost.to_state = to_state_in;
	exception
		when no_data_found then
			rhn_exception.raise_exception('invalid_state_transition');
	end;

	procedure join_rhn (
		org_id_in in number
	) is
		state_label	rhnOrgAvailableStates.label%TYPE;
	begin
	    	select OAS.label into state_label
		  from rhnOrgAvailableStates OAS,
		       rhnOrgState OS
		 where OS.state_id = OAS.id
		   and OS.org_id = org_id_in;

		if state_label = 'legacy_web'
		then
		    -- legacy_web with a timer flows a user into grace
		    update rhnOrgState
		       set next_action = sysdate
		     where org_id = org_id_in;
		     
    	    	    insert into rhnOrgStateLog
    	    	      (org_id, old_state_id, new_state_id, reason)
					  (
					  	select	org_id_in, os.state_id,
								rhn_bel.lookup_org_state('legacy_unclassified'),
								'rhn_bel.join_rhn package method'
						from	rhnOrgState os
						where	os.org_id = org_id_in
					);
		end if;
	end;

	procedure set_org_paid(
		org_id_in in number
	) is
	begin
    	insert into rhnOrgStateLog (
			org_id, old_state_id, new_state_id, reason
		) (
			select	org_id_in, os.state_id, rhn_bel.lookup_org_state('paid'),
					'rhn_bel.set_org_paid'
			from	rhnOrgState os
			where	os.org_id = org_id_in
		);

		update	rhnOrgState
		set		state_id =
				(select id from rhnOrgAvailableStates where label = 'paid'),
				next_action = NULL
		where	org_id = org_id_in;
    end set_org_paid;

	procedure set_org_unpaid (
		org_id_in in number
	) is
	begin
		update	rhnOrgState
		set		state_id = (select id from rhnOrgAvailableStates where label = 'falling_from_grace'),
				next_action = sysdate
		where	org_id = org_id_in;
		
    	    	insert into rhnOrgStateLog
    	    	  (org_id, old_state_id, new_state_id, reason)
				  (
				  	select	org_id_in, os.org_id,
							rhn_bel.lookup_org_state('falling_from_grace'),
							'rhn_bel.set_org_unpaid'
					from	rhnOrgState os
					where	os.org_id = org_id_in
				  );
	end set_org_unpaid;
end;
/
show errors

-- XXX toad doesn't know it needs to do packages *AND* bodies, so it
-- just does bodies.

create or replace
package rhn_user
is
    function check_role(user_id_in in number, role_in in varchar2) return number;
    PRAGMA RESTRICT_REFERENCES(check_role, WNDS, RNPS, WNPS);

    function get_org_id(user_id_in in number) return number;
    PRAGMA RESTRICT_REFERENCES(get_org_id, WNDS, RNPS, WNPS);
    
end rhn_user;
/
SHOW ERRORS

CREATE OR REPLACE
PACKAGE rhn_channel
IS
    CURSOR server_base_subscriptions(server_id_in NUMBER) IS
    	   SELECT C.id
	     FROM rhnChannel C, rhnServerChannel SC
	    WHERE C.id = SC.channel_id
	      AND SC.server_id = server_id_in
	      AND C.parent_channel IS NULL;
	      
    CURSOR check_server_subscription(server_id_in NUMBER, channel_id_in NUMBER) IS 
           SELECT channel_id 
	     FROM rhnServerChannel 
	    WHERE server_id = server_id_in 
	      AND channel_id = channel_id_in;

    CURSOR check_server_parent_membership(server_id_in NUMBER, channel_id_in NUMBER) IS
    	   SELECT C.id
	     FROM rhnChannel C, rhnServerChannel SC
	    WHERE C.parent_channel = channel_id_in
	      AND C.id = SC.channel_id
	      AND SC.server_id = server_id_in;
	    
    CURSOR channel_family_perm_cursor(channel_family_id_in NUMBER, org_id_in NUMBER) IS
           SELECT *
	     FROM rhnChannelFamilyPermissions
	    WHERE channel_family_id = channel_family_id_in
	      AND (org_id = org_id_in OR org_id IS NULL);

    PROCEDURE license_consent(channel_id_in IN NUMBER, user_id_in IN NUMBER, server_id_in IN NUMBER);
    FUNCTION get_license_path(channel_id_in IN NUMBER) RETURN VARCHAR2;

    PROCEDURE unsubscribe_server(server_id_in IN NUMBER, channel_id_in NUMBER, immediate_in NUMBER := 1, unsubscribe_children_in number := 0);
    PROCEDURE subscribe_server(server_id_in IN NUMBER, channel_id_in NUMBER, immediate_in NUMBER := 1, user_id_in number := null);

    FUNCTION guess_server_base(server_id_in IN NUMBER) RETURN NUMBER;

    PROCEDURE bulk_subscribe_server(channel_id_in IN NUMBER, set_label_in IN VARCHAR2, set_uid_in IN NUMBER);
    PROCEDURE bulk_unsubscribe_server(channel_id_in IN NUMBER, set_label_in IN VARCHAR2, set_uid_in IN NUMBER);
    
    PROCEDURE bulk_server_base_change(channel_id_in IN NUMBER, set_label_in IN VARCHAR2, set_uid_in IN NUMBER);
    procedure bulk_server_basechange_from(
	set_label_in in varchar2,
	set_uid_in in number,
	old_channel_id_in in number,
	new_channel_id_in in number);

    procedure bulk_guess_server_base(
	set_label_in in varchar2,
	set_uid_in in number);

    procedure bulk_guess_server_base_from(
	set_label_in in varchar2,
	set_uid_in in number,
	channel_id_in in number);

    PROCEDURE clear_subscriptions(server_id_in IN NUMBER);
    
    FUNCTION subscription_count(channel_id_in NUMBER) RETURN VARCHAR2;
    
    FUNCTION available_family_subscriptions(channel_family_id_in IN NUMBER, org_id_in IN NUMBER) RETURN NUMBER;
    PROCEDURE update_family_counts(channel_family_id_in IN NUMBER, org_id_in IN NUMBER);
    FUNCTION family_for_channel(channel_id_in IN NUMBER) RETURN NUMBER;

    FUNCTION available_chan_subscriptions(channel_id_in IN NUMBER, org_id_in IN NUMBER) RETURN NUMBER;

    procedure entitle_customer(customer_id_in in number, channel_family_id_in in number, quantity_in in number);
    procedure set_family_maxmembers(customer_id_in in number, channel_family_id_in in number, quantity_in in number);
    procedure unsubscribe_server_from_family(server_id_in in number, channel_family_id_in in number);

    procedure delete_server_channels(server_id_in in number);
    procedure refresh_newest_package(channel_id_in in number, caller_in in varchar2 := '(unknown)');
    
    function get_org_id(channel_id_in in number) return number;
    PRAGMA RESTRICT_REFERENCES(get_org_id, WNDS, RNPS, WNPS);

    function get_org_access(channel_id_in in number, org_id_in in number) return number;
    PRAGMA RESTRICT_REFERENCES(get_org_access, WNDS, RNPS, WNPS);
    
    function user_role_check_debug(channel_id_in in number, user_id_in in number, role_in in varchar2, reason_out out varchar2)
    	RETURN NUMBER;
    PRAGMA RESTRICT_REFERENCES(user_role_check_debug, WNDS, RNPS, WNPS);

    function user_role_check(channel_id_in in number, user_id_in in number, role_in in varchar2)
    	RETURN NUMBER;
    PRAGMA RESTRICT_REFERENCES(user_role_check, WNDS, RNPS, WNPS);
    
    function loose_user_role_check(channel_id_in in number, user_id_in in number, role_in in varchar2)
    	RETURN NUMBER;
    PRAGMA RESTRICT_REFERENCES(loose_user_role_check, WNDS, RNPS, WNPS);

    function direct_user_role_check(channel_id_in in number, user_id_in in number, role_in in varchar2)
    	RETURN NUMBER;
    PRAGMA RESTRICT_REFERENCES(direct_user_role_check, WNDS, RNPS, WNPS);

    function org_channel_setting(channel_id_in in number, org_id_in in number, setting_in in varchar2)
    	RETURN NUMBER;
    PRAGMA RESTRICT_REFERENCES(org_channel_setting, WNDS, RNPS, WNPS);

END rhn_channel;
/
SHOW ERRORS

--
-- 90. RHNCHANNELPERMISSION  (Table) 
--
CREATE TABLE RHNCHANNELPERMISSION
(
  CHANNEL_ID  NUMBER CONSTRAINT RHN_CPERM_CID_NN NOT NULL,
  USER_ID     NUMBER CONSTRAINT RHN_CPERM_UID_NN NOT NULL,
  ROLE_ID     NUMBER CONSTRAINT RHN_CPERM_RID_NN NOT NULL,
  CREATED     DATE                              DEFAULT (sysdate) CONSTRAINT RHN_CPERM_CREATED_NN NOT NULL,
  MODIFIED    DATE                              DEFAULT (sysdate) CONSTRAINT RHN_CPERM_MODIFIED_NN NOT NULL
)
LOGGING 
NOCACHE
NOPARALLEL;

--
-- 85. RHNORGCHANNELSETTINGS  (Table) 
--
CREATE TABLE RHNORGCHANNELSETTINGS
(
  ORG_ID      NUMBER CONSTRAINT RHN_ORGCSETTINGS_OID_NN NOT NULL,
  CHANNEL_ID  NUMBER CONSTRAINT RHN_ORGCSETTINGS_CID_NN NOT NULL,
  SETTING_ID  NUMBER CONSTRAINT RHN_ORGCSETTINGS_SID_NN NOT NULL,
  CREATED     DATE                              DEFAULT (sysdate) CONSTRAINT RHN_ORGCSETTINGS_CREATED_NN NOT NULL,
  MODIFIED    DATE                              DEFAULT (sysdate) CONSTRAINT RHN_ORGCSETTINGS_MODIFIED_NN NOT NULL
)
LOGGING 
NOCACHE
NOPARALLEL;

--
-- 73. RHN_CHANNEL  (Package Body) 
--

CREATE OR REPLACE PACKAGE BODY rhn_channel
IS
    FUNCTION get_license_path(channel_id_in IN NUMBER)
    RETURN VARCHAR2
    IS
    	license_val VARCHAR2(1000);
    BEGIN
    	SELECT CFL.license_path INTO license_val
	  FROM rhnChannelFamilyLicense CFL, rhnChannelFamilyMembers CFM
	 WHERE CFM.channel_id = channel_id_in
	   AND CFM.channel_family_id = CFL.channel_family_id;
    	RETURN license_val;
    EXCEPTION
    	WHEN NO_DATA_FOUND
	    THEN
	    RETURN NULL;
    END get_license_path;
    PROCEDURE license_consent(channel_id_in IN NUMBER, user_id_in IN NUMBER, server_id_in IN NUMBER)
    IS
    	channel_family_id_val NUMBER;
    BEGIN
    	channel_family_id_val := rhn_channel.family_for_channel(channel_id_in);
	IF channel_family_id_val IS NULL
	THEN
	    rhn_exception.raise_exception('channel_subscribe_no_family');
	END IF;
	IF rhn_channel.get_license_path(channel_id_in) IS NULL
	THEN
	    rhn_exception.raise_exception('channel_consent_no_license');
	END IF;
	INSERT INTO rhnChannelFamilyLicenseConsent (channel_family_id, user_id, server_id)
	VALUES (channel_family_id_val, user_id_in, server_id_in);
    END license_consent;
    PROCEDURE subscribe_server(server_id_in IN NUMBER, channel_id_in NUMBER, immediate_in NUMBER := 1, user_id_in in number := null)
    IS
        channel_parent_val      rhnChannel.parent_channel%TYPE;
        parent_subscribed       BOOLEAN;
        server_has_base_chan    BOOLEAN;
	server_already_in_chan  BOOLEAN;
	channel_family_id_val   NUMBER;
	server_org_id_val       NUMBER;
	available_subscriptions NUMBER;
	consenting_user         NUMBER;
	allowed			number := 0;
    BEGIN
    	if user_id_in is not null then
		allowed := rhn_channel.user_role_check(channel_id_in, user_id_in, 'subscribe');
	else
		allowed := 1;
	end if;
	if allowed = 0 then
		rhn_exception.raise_exception('no_subscribe_permissions');
	end if;
        SELECT parent_channel INTO channel_parent_val FROM rhnChannel WHERE id = channel_id_in;
        IF channel_parent_val IS NOT NULL
        THEN
            parent_subscribed := FALSE;
            FOR check_subscription IN check_server_subscription(server_id_in, channel_parent_val)
            LOOP
                parent_subscribed := TRUE;
            END LOOP check_subscription;
            IF NOT parent_subscribed
            THEN
    	    	RETURN;
            END IF;
        ELSE
            server_has_base_chan := FALSE;
            FOR base IN server_base_subscriptions(server_id_in)
            LOOP
                server_has_base_chan := TRUE;
            END LOOP base;
            IF server_has_base_chan
            THEN
                rhn_exception.raise_exception('channel_server_one_base');
            END IF;
        END IF;
        FOR check_subscription IN check_server_subscription(server_id_in, channel_id_in)
        LOOP
            server_already_in_chan := TRUE;
        END LOOP check_subscription;
        IF server_already_in_chan
        THEN
    	    RETURN;
        END IF;
	channel_family_id_val := rhn_channel.family_for_channel(channel_id_in);
	IF channel_family_id_val IS NULL
	THEN
	    rhn_exception.raise_exception('channel_subscribe_no_family');
	END IF;
	SELECT org_id INTO server_org_id_val
	  FROM rhnServer
	 WHERE id = server_id_in;
	available_subscriptions := rhn_channel.available_family_subscriptions(channel_family_id_val, server_org_id_val);
	IF available_subscriptions IS NULL OR available_subscriptions > 0
	THEN
	    IF rhn_channel.get_license_path(channel_id_in) IS NOT NULL
	    THEN
	    	BEGIN
	    	SELECT user_id INTO consenting_user
		  FROM rhnChannelFamilyLicenseConsent
		 WHERE channel_family_id = channel_family_id_val
		   AND server_id = server_id_in;
		EXCEPTION
    	    	    WHEN NO_DATA_FOUND
		    	THEN
			    rhn_exception.raise_exception('channel_subscribe_no_consent');
		END;
	    END IF;
	    insert into rhnServerHistory (id,server_id,summary,details) (
	    	select	rhn_event_id_seq.nextval,
			server_id_in,
			'subscribed to channel',
			c.label
		from	rhnChannel c
		where	c.id = channel_id_in
	    );
            INSERT INTO rhnServerChannel (server_id, channel_id) VALUES (server_id_in, channel_id_in);
    	    rhn_channel.update_family_counts(channel_family_id_val, server_org_id_val);
    	    queue_server(server_id_in, immediate_in);
	ELSE
	    rhn_exception.raise_exception('channel_family_no_subscriptions');
	END IF;
    END subscribe_server;
    PROCEDURE bulk_subscribe_server(channel_id_in IN NUMBER, set_label_in IN VARCHAR2, set_uid_in IN NUMBER)
    IS
    BEGIN
        FOR server IN rhn_set.set_iterator(set_label_in, set_uid_in)
        LOOP
            rhn_channel.subscribe_server(server.element, channel_id_in, 0, set_uid_in);
        END LOOP server;
    END bulk_subscribe_server;
    PROCEDURE bulk_server_base_change(channel_id_in IN NUMBER, set_label_in IN VARCHAR2, set_uid_in IN NUMBER)
    IS
		cursor is_changeable(server_id_in in number) is
			select	server_id_in id
			from	dual
			where	not exists (select 1 from rhnSatelliteInfo where server_id = server_id_in)
				and not exists (select 1 from rhnProxyInfo where server_id = server_id_in);
    BEGIN
        FOR server IN rhn_set.set_iterator(set_label_in, set_uid_in)
        LOOP
			for s in is_changeable(server.element) loop
            	rhn_channel.clear_subscriptions(TO_NUMBER(s.id));
            	rhn_channel.subscribe_server(s.id, channel_id_in, 0, set_uid_in);
			end loop;
        END LOOP server;
    END bulk_server_base_change;
    procedure bulk_server_basechange_from(
	set_label_in in varchar2,
	set_uid_in in number,
	old_channel_id_in in number,
	new_channel_id_in in number
    ) is
	cursor channels(server_id_in in number) is
	    select	rsc.channel_id
	    from	rhnServerChannel rsc,
			rhnChannel rc
	    where	server_id_in = rsc.server_id
			and rsc.channel_id = rc.id
			and rc.parent_channel is null;
    begin
	for server in rhn_set.set_iterator(set_label_in, set_uid_in)
	loop
	    for channel in channels(server.element)
	    loop
		if channel.channel_id = old_channel_id_in
		then
		    insert into rhnSet (user_id, label, element) values (set_uid_in, set_label_in || 'basechange', server.element);
		end if;
	    end loop channel;
	end loop server;
	bulk_server_base_change(new_channel_id_in, set_label_in||'basechange',set_uid_in);
	delete from rhnSet where label = set_label_in||'basechange' and user_id = set_uid_in;
    end;
    procedure bulk_guess_server_base(
	set_label_in in varchar2,
	set_uid_in in number
    ) is
	channel_id number;
    begin
	for server in rhn_set.set_iterator(set_label_in, set_uid_in)
	loop
	    begin
    	        channel_id := guess_server_base(TO_NUMBER(server.element));
	    	rhn_channel.clear_subscriptions(TO_NUMBER(server.element));
	    	rhn_channel.subscribe_server(TO_NUMBER(server.element), channel_id, 0, set_uid_in);
	    exception when others then
	    	null;
	    end;
	end loop server;
    end;
    function guess_server_base(
    	server_id_in in number
    ) RETURN number is
    	channel number;
        cursor base_channel_cursor is
            select rc.id
              from rhnChannelPermissions rcp,
                   rhnChannel rc,
                   rhnServerChannelArchCompat scac,
                   rhnDistChannelMap rdcm,
                   rhnServer rs
             where rs.id = server_id_in
                   and rs.release = rdcm.release
                   and rdcm.channel_id = rc.id
                   and rs.server_arch_id = scac.server_arch_id
                   and scac.channel_arch_id = rdcm.channel_arch_id
                   and rdcm.channel_id = rcp.channel_id
                   and (rcp.org_id is null or
                          rcp.org_id = rs.org_id)
                   and rdcm.channel_id = rc.id
                   and rc.parent_channel is null;
    begin
        for channel in base_channel_cursor loop
            return channel.id;
        end loop;
        return null;
    end;
    procedure bulk_guess_server_base_from(
	set_label_in in varchar2,
	set_uid_in in number,
	channel_id_in in number
    ) is
	cursor channels(server_id_in in number) is
	    select	rsc.channel_id
	    from	rhnServerChannel rsc,
			rhnChannel rc
	    where	server_id_in = rsc.server_id
			and rsc.channel_id = rc.id
			and rc.parent_channel is null;
    begin
	for server in rhn_set.set_iterator(set_label_in, set_uid_in)
	loop
	    for channel in channels(server.element)
	    loop
		if channel.channel_id = channel_id_in
		then
		    insert into rhnSet (user_id, label, element) values (set_uid_in, set_label_in || 'baseguess', server.element);
		end if;
	    end loop channel;
	end loop server;
	bulk_guess_server_base(set_label_in||'baseguess',set_uid_in);
	delete from rhnSet where label = set_label_in||'baseguess' and user_id = set_uid_in;
    end;
    PROCEDURE clear_subscriptions(server_id_in IN NUMBER)
    IS
    	cursor server_channels(server_id_in in number) is
		select	s.org_id, sc.channel_id, cfm.channel_family_id
		from	rhnServer s,
			rhnServerChannel sc,
			rhnChannelFamilyMembers cfm
		where	s.id = server_id_in
			and s.id = sc.server_id
			and sc.channel_id = cfm.channel_id;
    BEGIN
    	for channel in server_channels(server_id_in)
	loop
		unsubscribe_server(server_id_in, channel.channel_id, 1, 1);
		rhn_channel.update_family_counts(channel.channel_family_id, channel.org_id);
	end loop channel;
    END clear_subscriptions;
    PROCEDURE unsubscribe_server(server_id_in IN NUMBER, channel_id_in NUMBER, immediate_in NUMBER := 1, unsubscribe_children_in number := 0)
    IS
	channel_family_id_val   NUMBER;
	server_org_id_val       NUMBER;
	available_subscriptions NUMBER;
	server_already_in_chan  BOOLEAN;
	cursor	channel_family_is_proxy(channel_family_id_in in number) is
		select	1
		from	rhnChannelFamily
		where	id = channel_family_id_in
		    and label = 'rhn-proxy';
	cursor	channel_family_is_satellite(channel_family_id_in in number) is
		select	1
		from	rhnChannelFamily
		where	id = channel_family_id_in
		    and label = 'rhn-satellite';
	cursor local_chk_server_parent_memb (
			server_id_in number,
			channel_id_in number ) is
		select	c.id
		from	rhnChannel			c,
				rhnServerChannel	sc
		where	1=1
			and c.parent_channel = channel_id_in
			and c.id = sc.channel_id
			and sc.server_id = server_id_in;
    BEGIN
        FOR child IN local_chk_server_parent_memb(server_id_in, channel_id_in)
        LOOP
	    if unsubscribe_children_in = 1 then
	    	unsubscribe_server(server_id_in => server_id_in,
								channel_id_in => child.id,
								immediate_in => immediate_in,
								unsubscribe_children_in => unsubscribe_children_in);
	    else
	    	rhn_exception.raise_exception('channel_unsubscribe_child_exists');
	    end if;
        END LOOP child;
	server_already_in_chan := FALSE;
        FOR check_subscription IN check_server_subscription(server_id_in, channel_id_in)
        LOOP
            server_already_in_chan := TRUE;
        END LOOP check_subscription;
        IF NOT server_already_in_chan
        THEN
    	    RETURN;
        END IF;
	insert into rhnServerHistory (id,server_id,summary,details) (
	    select  rhn_event_id_seq.nextval,
	    	    server_id_in,
		    'unsubscribed from channel',
		    c.label
	    from    rhnChannel c
	    where   c.id = channel_id_in
	);
        DELETE FROM rhnServerChannel WHERE server_id = server_id_in AND channel_id = channel_id_in;
    	queue_server(server_id_in, immediate_in);
	channel_family_id_val := rhn_channel.family_for_channel(channel_id_in);
	IF channel_family_id_val IS NULL
	THEN
	    rhn_exception.raise_exception('channel_unsubscribe_no_family');
	END IF;
	for ignore in channel_family_is_satellite(channel_family_id_val) loop
		delete from rhnSatelliteInfo where server_id = server_id_in;
		delete from rhnSatelliteChannelFamily where server_id = server_id_in;
	end loop;
	for ignore in channel_family_is_proxy(channel_family_id_val) loop
		delete from rhnProxyInfo where server_id = server_id_in;
	end loop;
	DELETE FROM rhnChannelFamilyLicenseConsent
	 WHERE channel_family_id = channel_family_id_val
	   AND server_id = server_id_in;
	SELECT org_id INTO server_org_id_val
	  FROM rhnServer
	 WHERE id = server_id_in;
	rhn_channel.update_family_counts(channel_family_id_val, server_org_id_val);
    END unsubscribe_server;
    PROCEDURE bulk_unsubscribe_server(channel_id_in IN NUMBER, set_label_in IN VARCHAR2, set_uid_in IN NUMBER)
    IS
    BEGIN
        FOR server IN rhn_set.set_iterator(set_label_in, set_uid_in)
        LOOP
            rhn_channel.unsubscribe_server(server.element, channel_id_in, 0);
        END LOOP server;
    END bulk_unsubscribe_server;
    FUNCTION subscription_count(channel_id_in NUMBER)
    RETURN VARCHAR2
    IS
    	sub_count_val NUMBER;
	null_org    NUMBER;
    BEGIN
        SELECT COUNT(*) INTO sub_count_val FROM rhnChannelPermissions WHERE channel_id = channel_id_in;
	IF sub_count_val = 1
	THEN
	    SELECT org_id INTO null_org FROM rhnChannelPermissions WHERE channel_id = channel_id_in AND org_id IS NULL;
	    IF null_org IS NULL
	    THEN
	    	RETURN '(public)';
	    END IF;
	END IF;
	RETURN sub_count_val;
    EXCEPTION
        WHEN NO_DATA_FOUND
	THEN
	    RETURN 1;
    END subscription_count;
    FUNCTION family_for_channel(channel_id_in IN NUMBER)
    RETURN NUMBER
    IS
    	channel_family_id_val NUMBER;
    BEGIN
    	SELECT channel_family_id INTO channel_family_id_val
	  FROM rhnChannelFamilyMembers
         WHERE channel_id = channel_id_in;
	RETURN channel_family_id_val;
    EXCEPTION
        WHEN NO_DATA_FOUND
	THEN
	    RETURN NULL;
    END family_for_channel;
    FUNCTION available_family_subscriptions(channel_family_id_in IN NUMBER, org_id_in IN NUMBER)
    RETURN NUMBER
    IS
    	cfp channel_family_perm_cursor%ROWTYPE;
    	current_members_val NUMBER;
	max_members_val     NUMBER;
	found               NUMBER;
    BEGIN
	IF NOT channel_family_perm_cursor%ISOPEN
	THEN
	    OPEN channel_family_perm_cursor(channel_family_id_in, org_id_in);
	END IF;
	FETCH channel_family_perm_cursor INTO cfp;
	WHILE channel_family_perm_cursor%FOUND
    	LOOP
	    found := 1;
	    current_members_val := cfp.current_members;
	    max_members_val := cfp.max_members;
	    FETCH channel_family_perm_cursor INTO cfp;
	END LOOP;
	IF channel_family_perm_cursor%ISOPEN
	THEN
	    CLOSE channel_family_perm_cursor;
	END IF;
	IF found IS NULL
	THEN
	    RETURN 0;
	END IF;
	IF max_members_val IS NULL
	THEN
	    RETURN NULL;
	END IF;
	RETURN max_members_val - current_members_val;
    END available_family_subscriptions;
    PROCEDURE update_family_counts(channel_family_id_in IN NUMBER, org_id_in IN NUMBER)
    IS
    BEGIN
    	UPDATE rhnChannelFamilyPermissions
	   SET current_members = (SELECT COUNT(server_id)
	                            FROM rhnServerChannel
				   WHERE channel_id IN (SELECT channel_id FROM rhnChannelFamilyMembers
				                         WHERE channel_family_id = channel_family_id_in)
				     AND server_id IN (SELECT id FROM rhnServer WHERE org_id = org_id_in))
	 WHERE channel_family_id = channel_family_id_in
	   AND org_id = org_id_in;
    END update_family_counts;
    FUNCTION available_chan_subscriptions(channel_id_in IN NUMBER, org_id_in IN NUMBER)
    RETURN NUMBER
    IS
	channel_family_id_val NUMBER;
    BEGIN
    	SELECT channel_family_id INTO channel_family_id_val
	  FROM rhnChannelFamilyMembers
	 WHERE channel_id = channel_id_in;
	 RETURN rhn_channel.available_family_subscriptions(channel_family_id_val, org_id_in);
    END available_chan_subscriptions;
    procedure entitle_customer(customer_id_in in number, channel_family_id_in in number, quantity_in in number)
    is
		cursor permissions is
			select	1
			from	rhnChannelFamilyPermissions rcfp
			where	rcfp.org_id = customer_id_in
				and	rcfp.channel_family_id = channel_family_id_in;
    begin
		for perm in permissions loop
			set_family_maxmembers(
				customer_id_in,
				channel_family_id_in,
				quantity_in
			);
			rhn_channel.update_family_counts(
				channel_family_id_in,
				customer_id_in
			);
			return;
		end loop;
		insert
        into    rhnChannelFamilyPermissions
               (channel_family_id, org_id, max_members, current_members)
        values  (channel_family_id_in, customer_id_in, quantity_in, 0);
    end;
    procedure set_family_maxmembers(customer_id_in in number, channel_family_id_in in number, quantity_in in number)
    is
	cursor servers is
	    select  server_id from (
		select	rownum row_number, server_id, modified from (
		    select  rcfs.server_id,
			    rcfs.modified
		    from    rhnChannelFamilyServers rcfs
		    where   rcfs.customer_id = customer_id_in
			    and rcfs.channel_family_id = channel_family_id_in
		    order by modified
		)
		where rownum > quantity_in
	    );
    begin
	for server in servers
	loop
	    rhn_channel.unsubscribe_server_from_family(server.server_id, channel_family_id_in);
	end loop;
	update	rhnChannelFamilyPermissions rcfp
	set	rcfp.max_members = quantity_in
	where	rcfp.channel_family_id = channel_family_id_in
		and rcfp.org_id = customer_id_in;
    end;
    procedure unsubscribe_server_from_family(server_id_in in number, channel_family_id_in in number)
    is
    begin
	delete
	from	rhnServerChannel rsc
	where	rsc.server_id = server_id_in
		and channel_id in (
			select	rcfm.channel_id
			from	rhnChannelFamilyMembers rcfm
			where	rcfm.channel_family_id = channel_family_id_in);
    end;
    function get_org_id(channel_id_in in number)
    return number
    is
    	org_id_out number;
    begin
    	select org_id into org_id_out
	  from rhnChannel
	 where id = channel_id_in;
	return org_id_out;
    end get_org_id;
    function get_org_access(channel_id_in in number, org_id_in in number)
    return number
    is
    	throwaway number;
    begin
	select distinct 1 into throwaway
	  from rhnChannelFamilyMembers CFM,
	       rhnChannelFamilyPermissions CFP
	 where CFM.channel_family_id = CFP.channel_family_id
	   and CFM.channel_id = channel_id_in
	   and (CFP.org_id = org_id_in OR CFP.org_id IS NULL);
	return 1;
    exception
    	when no_data_found
	    then
	    return 0;
    end;
    function user_role_check_debug(channel_id_in in number, user_id_in in number, role_in in varchar2, reason_out out varchar2)
    return number
    is
    	org_id number;
    begin
    	org_id := rhn_user.get_org_id(user_id_in);
    	if role_in = 'manage' and NVL(rhn_channel.get_org_id(channel_id_in), -1) <> org_id
	then
	    reason_out := 'channel_not_owned';
	    return 0;
	end if;
    	if role_in = 'subscribe' and rhn_channel.get_org_access(channel_id_in, org_id) = 0
	then
	    reason_out := 'channel_not_available';
	    return 0;
	end if;
    	if rhn_user.check_role(user_id_in, 'org_admin') = 1
	then
	    reason_out := 'org_admin';
	    return 1;
	end if;
    	if rhn_user.check_role(user_id_in, 'channel_admin') = 1
	then
	    reason_out := 'channel_admin';
	    return 1;
	end if;
	if role_in = 'subscribe'
	then
	    if rhn_channel.org_channel_setting(channel_id_in, org_id, 'not_globally_subscribable') = 0
	    then
	    	reason_out := 'globally_subscribable';
		return 1;
	    end if;
	end if;
	reason_out := 'direct_permission';
	return rhn_channel.direct_user_role_check(channel_id_in, user_id_in, role_in);
    end;
    function user_role_check(channel_id_in in number, user_id_in in number, role_in in varchar2)
    return number
    is
  	throwaway varchar2(256);
    begin
    	return rhn_channel.user_role_check_debug(channel_id_in, user_id_in, role_in, throwaway);
    end;
    function loose_user_role_check(channel_id_in in number, user_id_in in number, role_in in varchar2)
    return number
    is
    begin
        if user_id_in is null then
            return 1;
        end if;
        return user_role_check(channel_id_in, user_id_in, role_in);
    end loose_user_role_check;
    function direct_user_role_check(channel_id_in in number, user_id_in in number, role_in in varchar2)
    return number
    is
    	throwaway number;
    begin
	select 1 into throwaway
	  from rhnChannelPermissionRole CPR,
	       rhnChannelPermission CP
	 where CP.user_id = user_id_in
	   and CP.channel_id = channel_id_in
	   and CPR.label = role_in
	   and CP.role_id = CPR.id;
	return 1;
    exception
    	when no_data_found
	    then
	    return 0;
    end;
    function org_channel_setting(channel_id_in in number, org_id_in in number, setting_in in varchar2)
    return number
    is
    	throwaway number;
    begin
	select 1 into throwaway
	  from rhnOrgChannelSettingsType OCST,
	       rhnOrgChannelSettings OCS
	 where OCS.org_id = org_id_in
	   and OCS.channel_id = channel_id_in
	   and OCST.label = setting_in
	   and OCS.setting_id = OCST.id;
	return 1;
    exception
    	when no_data_found
	    then
	    return 0;
    end;
    procedure delete_server_channels(server_id_in in number)
    is
    begin
	update	rhnChannelFamilyPermissions
	set	current_members = current_members -1
	where	org_id in (
			select	org_id
			from	rhnServer
			where	id = server_id_in
		)
		and channel_family_id in (
			select	rcfm.channel_family_id
			from	rhnChannelFamilyMembers rcfm,
				rhnServerChannel rsc
			where	rsc.server_id = server_id_in
				and rsc.channel_id = rcfm.channel_id
		);
    end;
	procedure refresh_newest_package(channel_id_in in number, caller_in in varchar2 := '(unknown)')
	is
	begin
		delete from rhnChannelNewestPackage where channel_id = channel_id_in;
		insert into rhnChannelNewestPackage
			( channel_id, name_id, evr_id, package_id, package_arch_id )
			(	select	channel_id,
						name_id, evr_id,
						package_id, package_arch_id
				from	rhnChannelNewestPackageView
				where	channel_id = channel_id_in
			);
                insert into rhnChannelNewestPackageAudit (channel_id, caller)
                    values (channel_id_in, caller_in);
                update rhnChannel
                    set last_modified = greatest(sysdate, last_modified + 1/86400)
                    where id = channel_id_in;
	end;
END rhn_channel;
/

SHOW ERRORS;

--
-- 74. RHN_USER  (Package Body) 
--
CREATE OR REPLACE package body rhn_user
is
    function check_role(user_id_in in number, role_in in varchar2)
    return number
    is
    	throwaway number;
    begin
	select 1 into throwaway
	  from rhnUserGroupType UGT,
	       rhnUserGroup UG,
	       rhnUserGroupMembers UGM
	 where UGM.user_id = user_id_in
	   and UGM.user_group_id = UG.id
	   and UG.group_type = UGT.id
	   and UGT.label = role_in;
	return 1;
    exception
    	when no_data_found
	    then
	    return 0;
    end check_role;
    function get_org_id(user_id_in in number)
    return number
    is
    	org_id_out number;
    begin
    	select org_id into org_id_out
	  from web_contact
	 where id = user_id_in;
	return org_id_out;
    end get_org_id;
end rhn_user;
/

SHOW ERRORS;

--
-- 75. LOOKUP_CLIENT_CAPABILITY  (Function) 
--
CREATE OR REPLACE FUNCTION
LOOKUP_CLIENT_CAPABILITY(name_in IN VARCHAR2)
RETURN NUMBER
DETERMINISTIC
IS
	PRAGMA AUTONOMOUS_TRANSACTION;
	cap_name_id		NUMBER;
BEGIN
	SELECT id
          INTO cap_name_id
          FROM rhnClientCapabilityName
         WHERE name = name_in;
	RETURN cap_name_id;
EXCEPTION
        WHEN NO_DATA_FOUND THEN
            INSERT INTO rhnClientCapabilityName (id, name)
                VALUES (rhn_client_capname_id_seq.nextval, name_in)
                RETURNING id INTO cap_name_id;
            COMMIT;
	RETURN cap_name_id;
END;
/

SHOW ERRORS;

--
-- 76. LOOKUP_HWPROPNAME  (Function) 
--
CREATE OR REPLACE function
lookup_hwpropname(name_in in varchar2)
return number
deterministic
is
	pragma autonomous_transaction;
	name_id number;
begin
	select  id
	into    name_id
	from    rhnHardwarePropName
	where   name = name_in;
	return name_id;
exception
	when no_data_found then
		insert into rhnHardwarePropName (id, name)
			values (rhn_hwpropname_id_seq.nextval, name_in)
			returning id
			into name_id;
		commit;
		return name_id;
end;
/

SHOW ERRORS;

--
-- 77. LOOKUP_HWPROPVAL  (Function) 
--
CREATE OR REPLACE function
lookup_hwpropval(value_in in varchar2)
return number
deterministic
is
	pragma autonomous_transaction;
	value_id number;
	our_csum number;
begin
	our_csum := adler32(value_in);
	select  id
	into    value_id
	from    rhnHardwarePropValue
	where   csum = our_csum;
	return value_id;
exception
	when no_data_found then
		insert into rhnHardwarePropValue (id, value, csum)
			values (rhn_hwpropval_id_seq.nextval,
				value_in, our_csum)
			returning id
			into value_id;
		commit;
		return value_id;
end;
/

SHOW ERRORS;

--
-- 78. LOOKUP_PACKAGE_DELTA  (Function) 
--
CREATE OR REPLACE FUNCTION
LOOKUP_PACKAGE_DELTA(n_in IN VARCHAR2)
RETURN NUMBER
DETERMINISTIC
IS
	PRAGMA AUTONOMOUS_TRANSACTION;
	name_id         NUMBER;
BEGIN
	SELECT id INTO name_id
	  FROM rhnPackageDelta
	 WHERE label = n_in;
	RETURN name_id;
EXCEPTION
	WHEN NO_DATA_FOUND THEN
	    INSERT INTO rhnPackageDelta (id, label)
	    VALUES (rhn_packagedelta_id_seq.nextval, n_in)
	    RETURNING id INTO name_id;
	COMMIT;
	RETURN name_id;
END;
/

SHOW ERRORS;

--
-- 79. LOOKUP_TRANSACTION_PACKAGE  (Function) 
--
CREATE OR REPLACE FUNCTION
LOOKUP_TRANSACTION_PACKAGE(o_in IN VARCHAR2, n_in IN VARCHAR2,
    e_in IN VARCHAR2, v_in IN VARCHAR2, r_in IN VARCHAR2, a_in IN VARCHAR2)
RETURN NUMBER
DETERMINISTIC
IS
	PRAGMA AUTONOMOUS_TRANSACTION;
        o_id        NUMBER;
        n_id        NUMBER;
	e_id	    NUMBER;
        p_arch_id   NUMBER;
        tp_id       NUMBER;
BEGIN
	BEGIN
	    SELECT id
	      INTO o_id
	      FROM rhnTransactionOperation
	     WHERE label = o_in;
	EXCEPTION
	    WHEN NO_DATA_FOUND THEN
		rhn_exception.raise_exception('invalid_transaction_operation');
	END;
	SELECT LOOKUP_PACKAGE_NAME(n_in)
	  INTO n_id
	  FROM dual;
	SELECT LOOKUP_EVR(e_in, v_in, r_in)
	  INTO e_id
	  FROM dual;
	p_arch_id := NULL;
	IF a_in IS NOT NULL
	THEN
		SELECT LOOKUP_PACKAGE_ARCH(a_in)
		  INTO p_arch_id
		  FROM dual;
	END IF;
	SELECT id
	  INTO tp_id
	  FROM rhnTransactionPackage
	 WHERE operation = o_id
	   AND name_id = n_id
	   AND evr_id = e_id
	   AND (package_arch_id = p_arch_id OR (p_arch_id IS NULL AND package_arch_id IS NULL));
	RETURN tp_id;
EXCEPTION
        WHEN NO_DATA_FOUND THEN
	    INSERT INTO rhnTransactionPackage
		(id, operation, name_id, evr_id, package_arch_id)
	    VALUES (rhn_transpack_id_seq.nextval, o_id, n_id, e_id, p_arch_id)
	    RETURNING id INTO tp_id;
	    COMMIT;
	    RETURN tp_id;
END;
/

SHOW ERRORS;

--
-- 80. RHN_CPERM_ROLE_MOD_TRIG  (Trigger) 
--
CREATE OR REPLACE TRIGGER RHN_CPERM_ROLE_MOD_TRIG
BEFORE INSERT OR UPDATE ON RHNCHANNELPERMISSIONROLE
FOR EACH ROW
begin
	:new.modified := sysdate;
end;
/
SHOW ERRORS;


--
-- 81. RHN_HARDWARE_MOD_TRIG  (Trigger) 
--
CREATE OR REPLACE TRIGGER RHN_HARDWARE_MOD_TRIG
BEFORE INSERT OR UPDATE ON RHNHARDWARE
FOR EACH ROW
begin
	:new.modified := sysdate;
end;
/
SHOW ERRORS;


--
-- 82. RHN_HWPROPVAL_MOD_TRIG  (Trigger) 
--
CREATE OR REPLACE TRIGGER RHN_HWPROPVAL_MOD_TRIG
BEFORE INSERT OR UPDATE ON RHNHARDWAREPROPVALUE
FOR EACH ROW
begin
	if :new.csum is null then
		:new.csum := adler32(:new.value);
	end if;
end;
/
SHOW ERRORS;


--
-- 83. RHN_ORGCSETTINGS_TYPE_MOD_TRIG  (Trigger) 
--
CREATE OR REPLACE TRIGGER RHN_ORGCSETTINGS_TYPE_MOD_TRIG
BEFORE INSERT OR UPDATE ON RHNORGCHANNELSETTINGSTYPE
FOR EACH ROW
begin
	:new.modified := sysdate;
end;
/
SHOW ERRORS;


--
-- 84. END_OF_LIFE  (Column) 
--
ALTER TABLE RHNCHANNEL ADD (END_OF_LIFE  DATE);

--
-- 86. RHN_HWPROP_HID_NID_VID_IDX  (Index) 
--
CREATE INDEX RHN_HWPROP_HID_NID_VID_IDX ON RHNHARDWAREPROPERTIES
(HARDWARE_ID, NAME_ID, VALUE_ID)
LOGGING
NOPARALLEL;

--
-- 87. RHN_ORGCSETTINGS_OID_CID_UQ  (Index) 
--
CREATE UNIQUE INDEX RHN_ORGCSETTINGS_OID_CID_UQ ON RHNORGCHANNELSETTINGS
(ORG_ID, CHANNEL_ID, SETTING_ID)
LOGGING
NOPARALLEL;

--
-- 88. ADD_HWPROP  (Procedure) 
--
CREATE OR REPLACE procedure
add_hwprop(hardware_id_in in number, name_in in varchar2, value_in in varchar2)
is
begin
	insert into rhnHardwareProperties ( hardware_id, name_id, value_id )
		values (
			hardware_id_in,
			lookup_hwpropname(name_in),
			lookup_hwpropval(value_in)
		);
end;
/

SHOW ERRORS;

--
-- 89. RHN_ORGCSETTINGS_MOD_TRIG  (Trigger) 
--
CREATE OR REPLACE TRIGGER RHN_ORGCSETTINGS_MOD_TRIG
BEFORE INSERT OR UPDATE ON RHNORGCHANNELSETTINGS
FOR EACH ROW
begin
	:new.modified := sysdate;
end;
/
SHOW ERRORS;


--
-- 91. RHNUSERDEFAULTSYSTEMGROUPS  (Table) 
--
CREATE TABLE RHNUSERDEFAULTSYSTEMGROUPS
(
  USER_ID          NUMBER CONSTRAINT RHN_UDSG_UID_NN NOT NULL,
  SYSTEM_GROUP_ID  NUMBER CONSTRAINT RHN_UDSG_CID_NN NOT NULL
)
LOGGING 
NOCACHE
NOPARALLEL;

--
-- 92. RHN_CPERM_CID_UID_RID_IDX  (Index) 
--
CREATE UNIQUE INDEX RHN_CPERM_CID_UID_RID_IDX ON RHNCHANNELPERMISSION
(CHANNEL_ID, USER_ID, ROLE_ID)
LOGGING
NOPARALLEL;

--
-- 93. RHN_UDSG_SGID_UID_IDX  (Index) 
--
CREATE INDEX RHN_UDSG_SGID_UID_IDX ON RHNUSERDEFAULTSYSTEMGROUPS
(SYSTEM_GROUP_ID, USER_ID)
LOGGING
NOPARALLEL;

--
-- 94. RHN_UDSG_UID_SGID_IDX  (Index) 
--
CREATE UNIQUE INDEX RHN_UDSG_UID_SGID_IDX ON RHNUSERDEFAULTSYSTEMGROUPS
(USER_ID, SYSTEM_GROUP_ID)
LOGGING
NOPARALLEL;

--
-- 95. RHN_USER  (Package) 
--
CREATE OR REPLACE package rhn_user
is
    function check_role(user_id_in in number, role_in in varchar2) return number;
    PRAGMA RESTRICT_REFERENCES(check_role, WNDS, RNPS, WNPS);
    function get_org_id(user_id_in in number) return number;
    PRAGMA RESTRICT_REFERENCES(get_org_id, WNDS, RNPS, WNPS);
end rhn_user;
/

SHOW ERRORS;

--
-- 96. DOES_USER_HAVE_ROLE  (Function) 
--
CREATE OR REPLACE function
does_user_have_role
(
	user_id_in in number,
	role_in in varchar2
)
return number
is
	org_admin	number;
begin
	select	1
	into	org_admin
	from
		rhnUserGroupType	ugt,
		rhnUserGroup		ug,
		rhnUserGroupMembers	ugm
	where	1=1
		and ugm.user_id = user_id_in
		and ugm.user_group_id = ug.id
		and ugt.label = role_in
		and ugt.id = ug.group_type;
	return org_admin;
exception
	when no_data_found then
		return 0;
end;
/

SHOW ERRORS;

--
-- 97. RHNSERVERNEEDEDPACKAGEVIEW  (View) 
--
CREATE OR REPLACE FORCE VIEW RHNSERVERNEEDEDPACKAGEVIEW
(ORG_ID, SERVER_ID, ERRATA_ID, PACKAGE_ID)
AS 
SELECT   S.org_id,
         S.id,
	  (SELECT EP.errata_id
	     FROM rhnErrataPackage EP,
	          rhnChannelErrata CE,
		  rhnServerChannel SC
	    WHERE SC.server_id = S.id
	      AND SC.channel_id = CE.channel_id
	      AND CE.errata_id = EP.errata_id
	      AND EP.package_id = P.id
	      AND ROWNUM = 1),
	 P.id
FROM
	 rhnPackage P,
	 rhnServerPackageArchCompat SPAC,
	 rhnPackageEVR P_EVR,
	 rhnPackageEVR SP_EVR,
	 rhnServerPackage SP,
	 rhnChannelPackage CP,
	 rhnServerChannel SC,
         rhnServer S
WHERE
    	 SC.server_id = S.id
  AND  	 SC.channel_id = CP.channel_id
  AND    CP.package_id = P.id
  AND    p.package_arch_id = spac.package_arch_id
  AND    spac.server_arch_id = s.server_arch_id
  AND    SP_EVR.id = SP.evr_id
  AND    P_EVR.id = P.evr_id
  AND    SP.server_id = S.id
  AND    SP.name_id = P.name_id
  AND    SP.evr_id != P.evr_id
  AND    SP_EVR.evr < P_EVR.evr
  AND    SP_EVR.evr = (SELECT MAX(PE.evr) FROM rhnServerPackage SP2, rhnPackageEvr PE WHERE PE.id = SP2.evr_id AND SP2.server_id = SP.server_id AND SP2.name_id = SP.name_id);

--
-- 98. RHN_CPERM_MOD_TRIG  (Trigger) 
--
CREATE OR REPLACE TRIGGER RHN_CPERM_MOD_TRIG
BEFORE INSERT OR UPDATE ON RHNCHANNELPERMISSION
FOR EACH ROW
begin
	:new.modified := sysdate;
end;
/
SHOW ERRORS;


--
-- 99. RHN_SERVER_GROUP_ORG_MAPPING  (Trigger) 
--
CREATE OR REPLACE TRIGGER RHN_SERVER_GROUP_ORG_MAPPING
BEFORE INSERT OR UPDATE ON RHNSERVERGROUPMEMBERS
FOR EACH ROW
DECLARE
        same_org        NUMBER;
BEGIN
        same_org := 0;
        SELECT 1 INTO same_org
          FROM rhnServer S, rhnServerGroup SG
         WHERE SG.org_id = S.org_id
           AND S.id = :new.server_id
           AND SG.id = :new.server_group_id;
        IF same_org = 0 THEN
          rhn_exception.raise_exception('sgm_insert_diff_orgs');
        END IF;
EXCEPTION
        WHEN NO_DATA_FOUND THEN
          rhn_exception.raise_exception('sgm_insert_diff_orgs');
END;
/
SHOW ERRORS;


--
-- 100. RHNCLIENTCAPABILITY  (Table) 
--
CREATE TABLE RHNCLIENTCAPABILITY
(
  SERVER_ID           NUMBER CONSTRAINT RHN_CLIENTCAP_SID_NN NOT NULL,
  CAPABILITY_NAME_ID  NUMBER CONSTRAINT RHN_CLIENTCAP_CAP_NID_NN NOT NULL,
  VERSION             VARCHAR2(32 BYTE) CONSTRAINT RHN_CLIENTCAP_VER_NN NOT NULL,
  CREATED             DATE                      DEFAULT (sysdate) CONSTRAINT RHN_CLIENTCAP_CREATED_NN NOT NULL,
  MODIFIED            DATE                      DEFAULT (sysdate) CONSTRAINT RHN_CLIENTCAP_MODIFIED_NN NOT NULL
)
LOGGING 
NOCACHE
NOPARALLEL;

--
-- 101. RHN_CLIENTCAP_SID_CAP_UQ  (Index) 
--
CREATE UNIQUE INDEX RHN_CLIENTCAP_SID_CAP_UQ ON RHNCLIENTCAPABILITY
(SERVER_ID, CAPABILITY_NAME_ID)
LOGGING
NOPARALLEL;

--
-- 102. RHN_CLIENTCAP_MOD_TRIG  (Trigger) 
--
CREATE OR REPLACE TRIGGER RHN_CLIENTCAP_MOD_TRIG
BEFORE INSERT OR UPDATE ON RHNCLIENTCAPABILITY
FOR EACH ROW
begin
	:new.modified := sysdate;
end;
/
SHOW ERRORS;


--
-- 103. RHN_CHANNEL  (Package) 
--
CREATE OR REPLACE PACKAGE rhn_channel
IS
    CURSOR server_base_subscriptions(server_id_in NUMBER) IS
    	   SELECT C.id
	     FROM rhnChannel C, rhnServerChannel SC
	    WHERE C.id = SC.channel_id
	      AND SC.server_id = server_id_in
	      AND C.parent_channel IS NULL;
    CURSOR check_server_subscription(server_id_in NUMBER, channel_id_in NUMBER) IS
           SELECT channel_id
	     FROM rhnServerChannel
	    WHERE server_id = server_id_in
	      AND channel_id = channel_id_in;
    CURSOR check_server_parent_membership(server_id_in NUMBER, channel_id_in NUMBER) IS
    	   SELECT C.id
	     FROM rhnChannel C, rhnServerChannel SC
	    WHERE C.parent_channel = channel_id_in
	      AND C.id = SC.channel_id
	      AND SC.server_id = server_id_in;
    CURSOR channel_family_perm_cursor(channel_family_id_in NUMBER, org_id_in NUMBER) IS
           SELECT *
	     FROM rhnChannelFamilyPermissions
	    WHERE channel_family_id = channel_family_id_in
	      AND (org_id = org_id_in OR org_id IS NULL);
    PROCEDURE license_consent(channel_id_in IN NUMBER, user_id_in IN NUMBER, server_id_in IN NUMBER);
    FUNCTION get_license_path(channel_id_in IN NUMBER) RETURN VARCHAR2;
    PROCEDURE unsubscribe_server(server_id_in IN NUMBER, channel_id_in NUMBER, immediate_in NUMBER := 1, unsubscribe_children_in number := 0);
    PROCEDURE subscribe_server(server_id_in IN NUMBER, channel_id_in NUMBER, immediate_in NUMBER := 1, user_id_in number := null);
    FUNCTION guess_server_base(server_id_in IN NUMBER) RETURN NUMBER;
    PROCEDURE bulk_subscribe_server(channel_id_in IN NUMBER, set_label_in IN VARCHAR2, set_uid_in IN NUMBER);
    PROCEDURE bulk_unsubscribe_server(channel_id_in IN NUMBER, set_label_in IN VARCHAR2, set_uid_in IN NUMBER);
    PROCEDURE bulk_server_base_change(channel_id_in IN NUMBER, set_label_in IN VARCHAR2, set_uid_in IN NUMBER);
    procedure bulk_server_basechange_from(
	set_label_in in varchar2,
	set_uid_in in number,
	old_channel_id_in in number,
	new_channel_id_in in number);
    procedure bulk_guess_server_base(
	set_label_in in varchar2,
	set_uid_in in number);
    procedure bulk_guess_server_base_from(
	set_label_in in varchar2,
	set_uid_in in number,
	channel_id_in in number);
    PROCEDURE clear_subscriptions(server_id_in IN NUMBER);
    FUNCTION subscription_count(channel_id_in NUMBER) RETURN VARCHAR2;
    FUNCTION available_family_subscriptions(channel_family_id_in IN NUMBER, org_id_in IN NUMBER) RETURN NUMBER;
    PROCEDURE update_family_counts(channel_family_id_in IN NUMBER, org_id_in IN NUMBER);
    FUNCTION family_for_channel(channel_id_in IN NUMBER) RETURN NUMBER;
    FUNCTION available_chan_subscriptions(channel_id_in IN NUMBER, org_id_in IN NUMBER) RETURN NUMBER;
    procedure entitle_customer(customer_id_in in number, channel_family_id_in in number, quantity_in in number);
    procedure set_family_maxmembers(customer_id_in in number, channel_family_id_in in number, quantity_in in number);
    procedure unsubscribe_server_from_family(server_id_in in number, channel_family_id_in in number);
    procedure delete_server_channels(server_id_in in number);
    procedure refresh_newest_package(channel_id_in in number, caller_in in varchar2 := '(unknown)');
    function get_org_id(channel_id_in in number) return number;
    PRAGMA RESTRICT_REFERENCES(get_org_id, WNDS, RNPS, WNPS);
    function get_org_access(channel_id_in in number, org_id_in in number) return number;
    PRAGMA RESTRICT_REFERENCES(get_org_access, WNDS, RNPS, WNPS);
    function user_role_check_debug(channel_id_in in number, user_id_in in number, role_in in varchar2, reason_out out varchar2)
    	RETURN NUMBER;
    PRAGMA RESTRICT_REFERENCES(user_role_check_debug, WNDS, RNPS, WNPS);
    function user_role_check(channel_id_in in number, user_id_in in number, role_in in varchar2)
    	RETURN NUMBER;
    PRAGMA RESTRICT_REFERENCES(user_role_check, WNDS, RNPS, WNPS);
    function loose_user_role_check(channel_id_in in number, user_id_in in number, role_in in varchar2)
    	RETURN NUMBER;
    PRAGMA RESTRICT_REFERENCES(loose_user_role_check, WNDS, RNPS, WNPS);
    function direct_user_role_check(channel_id_in in number, user_id_in in number, role_in in varchar2)
    	RETURN NUMBER;
    PRAGMA RESTRICT_REFERENCES(direct_user_role_check, WNDS, RNPS, WNPS);
    function org_channel_setting(channel_id_in in number, org_id_in in number, setting_in in varchar2)
    	RETURN NUMBER;
    PRAGMA RESTRICT_REFERENCES(org_channel_setting, WNDS, RNPS, WNPS);
END rhn_channel;
/

SHOW ERRORS;

--
-- 104. RHNUSERAVAILABLECHANNELS  (View) 
--
CREATE OR REPLACE FORCE VIEW RHNUSERAVAILABLECHANNELS
(USER_ID, CHANNEL_ID, CHANNEL_DEPTH, CHANNEL_NAME, CHANNEL_ARCH_ID, 
 PADDED_NAME, CURRENT_MEMBERS, AVAILABLE_MEMBERS, LAST_MODIFIED, CHANNEL_LABEL, 
 PARENT_OR_SELF_LABEL)
AS 
select
     wc.id,
     cperm.channel_id,
     CT.depth,
     CT.name,
     CT.channel_arch_id,
     CT.padded_name,
     (
     SELECT COUNT(1)
       FROM rhnUserServerPerms USP
      WHERE USP.user_id = wc.id
        AND EXISTS (SELECT 1 FROM rhnServerChannel WHERE channel_id = cperm.channel_id AND server_id = USP.server_id)
     ),
     rhn_channel.available_chan_subscriptions(cperm.channel_id, wc.org_id),
     CT.last_modified,
     CT.label,
     CT.parent_or_self_label
from
     web_contact wc,
     rhnChannelTreeView CT,
     rhnChannelPermissions CPerm
where
    CT.id = CPerm.channel_id
and (wc.org_id = cperm.org_id
 or cperm.org_id is null);

--
-- 105. RHNUSERCHANNEL  (View) 
--
CREATE OR REPLACE FORCE VIEW RHNUSERCHANNEL
(USER_ID, ORG_ID, CHANNEL_ID, ROLE)
AS 
select wc.id as user_id,
       wc.org_id as org_id,
       ac.channel_id as channel_id,
       'manage' as role
  from web_contact wc,
       rhnAvailableChannels ac
 where wc.org_id = ac.org_id
   and rhn_channel.user_role_check(ac.channel_id, wc.id, 'manage') = 1
union
select wc.id as user_id,
       wc.org_id as org_id,
       ac.channel_id as channel_id,
       'subscribe' as role
  from web_contact wc,
       rhnAvailableChannels ac
 where wc.org_id = ac.org_id
   and rhn_channel.user_role_check(ac.channel_id, wc.id, 'subscribe') = 1;

-- XXX toad likes to build not null and then check (foo is not null).  
--
-- 106. RHN_HARDWARE_CSUM_NN  (Constraint) 
--
-- ALTER TABLE RHNHARDWARE ADD CONSTRAINT RHN_HARDWARE_CSUM_NN CHECK ("CSUM" IS NOT NULL);

--
-- 107. RHN_HARDWARE_ID_NN  (Constraint) 
--
ALTER TABLE RHNHARDWARE ADD CONSTRAINT RHN_HARDWARE_ID_NN CHECK ("ID" IS NOT NULL);

--
-- 108. RHN_HARDWARE_NP_NN  (Constraint) 
--
-- ALTER TABLE RHNHARDWARE ADD CONSTRAINT RHN_HARDWARE_NP_NN CHECK ("NUM_PROPS" IS NOT NULL);

--
-- 109. RHN_HARDWARE_ID_PK  (Constraint) 
--
ALTER TABLE RHNHARDWARE ADD CONSTRAINT RHN_HARDWARE_ID_PK PRIMARY KEY (ID);

--
-- 110. RHN_HARDWARE_CSUM_UQ  (Constraint) 
--
ALTER TABLE RHNHARDWARE ADD CONSTRAINT RHN_HARDWARE_CSUM_UQ UNIQUE (CSUM);

--
-- 111. RHN_HWPROPNAME_ID_NN  (Constraint) 
--
--- YYY alter table RHNHARDWAREPROPNAME drop constraint RHN_HWPROPNAME_ID_NN;
ALTER TABLE RHNHARDWAREPROPNAME modify (
	id number CONSTRAINT RHN_HWPROPNAME_ID_NN NOT NULL
);

--
-- 112. RHN_HWPROPNAME_NAME_NN  (Constraint 
--

ALTER TABLE RHNHARDWAREPROPNAME modify (
	name varchar2(20) CONSTRAINT RHN_HWPROPNAME_NAME_NN NOT NULL
);

--
-- 113. RHN_HWPROPNAME_ID_PK  (Constraint) 
--
ALTER TABLE RHNHARDWAREPROPNAME ADD CONSTRAINT RHN_HWPROPNAME_ID_PK PRIMARY KEY (ID);

--
-- 114. RHN_HWPROPNAME_NAME_UQ  (Constraint) 
--
ALTER TABLE RHNHARDWAREPROPNAME ADD CONSTRAINT RHN_HWPROPNAME_NAME_UQ UNIQUE (NAME);

--
-- 115. RHN_HWPROPVAL_ID_NN  (Constraint) 
--
alter table rhnhardwarepropvalue modify (
	id number constraint rhn_hwpropval_id_nn not null
);

--
-- 116. RHN_HWPROPVAL_ID_PK  (Constraint) 
--
ALTER TABLE RHNHARDWAREPROPVALUE ADD CONSTRAINT RHN_HWPROPVAL_ID_PK PRIMARY KEY (ID);

--
-- 117. RHN_HWPROPVAL_CSUM_UQ  (Constraint) 
--
ALTER TABLE RHNHARDWAREPROPVALUE ADD CONSTRAINT RHN_HWPROPVAL_CSUM_UQ UNIQUE (CSUM);

--
-- 118. RHN_HWPROP_HID_NN  (Constraint) 
--
alter table rhnhardwareproperties modify (
	hardware_id number constraint rhn_hwprop_hid_nn not null
);

--
-- 119. RHN_HWPROP_NID_NN  (Constraint) 
--
alter table rhnhardwareproperties modify (
	name_id number constraint rhn_hwprop_nid_nn not null
);

--
-- 120. RHN_HWPROP_VID_NN  (Constraint) 
--
alter table rhnHardwareProperties modify (
	value_id number constraint rhn_hwprop_vid_nn not null
);

--
-- 121. RHN_HWPROP_HID_FK  (Constraint) 
--
ALTER TABLE RHNHARDWAREPROPERTIES ADD CONSTRAINT RHN_HWPROP_HID_FK FOREIGN KEY (HARDWARE_ID) 
    REFERENCES RHNHARDWARE (ID);

--
-- 122. RHN_HWPROP_NID_FK  (Constraint) 
--
ALTER TABLE RHNHARDWAREPROPERTIES ADD CONSTRAINT RHN_HWPROP_NID_FK FOREIGN KEY (NAME_ID) 
    REFERENCES RHNHARDWAREPROPNAME (ID);

--
-- 123. RHN_HWPROP_VID_FK  (Constraint) 
--
ALTER TABLE RHNHARDWAREPROPERTIES ADD CONSTRAINT RHN_HWPROP_VID_FK FOREIGN KEY (VALUE_ID) 
    REFERENCES RHNHARDWAREPROPVALUE (ID);

--
-- 124. RHN_ACT_PD_PDID_FK  (Constraint) 
--
ALTER TABLE RHNACTIONPACKAGEDELTA ADD CONSTRAINT RHN_ACT_PD_PDID_FK FOREIGN KEY (PACKAGE_DELTA_ID) 
    REFERENCES RHNPACKAGEDELTA (ID)
    ON DELETE CASCADE;

--
-- 125. RHN_EADDRESS_UID_FK  (Constraint) 
--
ALTER TABLE RHNEMAILADDRESS DROP CONSTRAINT RHN_EADDRESS_UID_FK;
ALTER TABLE RHNEMAILADDRESS ADD CONSTRAINT RHN_EADDRESS_UID_FK FOREIGN KEY (USER_ID) 
    REFERENCES WEB_CONTACT (ID)
    ON DELETE CASCADE;

--
-- 126. RHN_SERVERHW_HID_FK  (Constraint) 
--
-- XXX likes to drop things repeatedly, too
-- ALTER TABLE RHNSERVERHARDWARE DROP CONSTRAINT RHN_SERVERHW_HID_FK;
ALTER TABLE RHNSERVERHARDWARE ADD CONSTRAINT RHN_SERVERHW_HID_FK FOREIGN KEY (HARDWARE_ID) 
    REFERENCES RHNHARDWARE (ID);

--
-- 127. RHN_CPERM_ROLE_CREATED_NN  (Constraint) 
--
-- ALTER TABLE RHNCHANNELPERMISSIONROLE ADD CONSTRAINT RHN_CPERM_ROLE_CREATED_NN CHECK ("CREATED" IS NOT NULL);

--
-- 128. RHN_CPERM_ROLE_DESC_NN  (Constraint) 
--
-- ALTER TABLE RHNCHANNELPERMISSIONROLE ADD CONSTRAINT RHN_CPERM_ROLE_DESC_NN CHECK ("DESCRIPTION" IS NOT NULL);

--
-- 129. RHN_CPERM_ROLE_ID_NN  (Constraint) 
--
-- ALTER TABLE RHNCHANNELPERMISSIONROLE ADD CONSTRAINT RHN_CPERM_ROLE_ID_NN CHECK ("ID" IS NOT NULL);

--
-- 130. RHN_CPERM_ROLE_LABEL_NN  (Constraint) 
--
-- ALTER TABLE RHNCHANNELPERMISSIONROLE ADD CONSTRAINT RHN_CPERM_ROLE_LABEL_NN CHECK ("LABEL" IS NOT NULL);

--
-- 131. RHN_CPERM_ROLE_MODIFIED_NN  (Constraint) 
--
-- ALTER TABLE RHNCHANNELPERMISSIONROLE ADD CONSTRAINT RHN_CPERM_ROLE_MODIFIED_NN CHECK ("MODIFIED" IS NOT NULL);

--
-- 132. RHN_CPERM_ROLE_ID_PK  (Constraint) 
--
ALTER TABLE RHNCHANNELPERMISSIONROLE ADD CONSTRAINT RHN_CPERM_ROLE_ID_PK PRIMARY KEY (ID);

--
-- 133. RHN_CPERM_ROLE_LABEL_UQ  (Constraint) 
--
ALTER TABLE RHNCHANNELPERMISSIONROLE ADD CONSTRAINT RHN_CPERM_ROLE_LABEL_UQ UNIQUE (LABEL);

--
-- 134. RHN_CLIENTCAPNAM_ID_NN  (Constraint) 
--
-- ALTER TABLE RHNCLIENTCAPABILITYNAME ADD CONSTRAINT RHN_CLIENTCAPNAM_ID_NN CHECK ("ID" IS NOT NULL);

--
-- 135. RHN_CLIENTCAPNAM_NAME_NN  (Constraint) 
--
-- ALTER TABLE RHNCLIENTCAPABILITYNAME ADD CONSTRAINT RHN_CLIENTCAPNAM_NAME_NN CHECK ("NAME" IS NOT NULL);

--
-- 136. RHN_CLIENTCAPNAM_ID_PK  (Constraint) 
--
ALTER TABLE RHNCLIENTCAPABILITYNAME ADD CONSTRAINT RHN_CLIENTCAPNAM_ID_PK PRIMARY KEY (ID);

--
-- 137. RHN_OCSTNGS_TYPE_CREATED_NN  (Constraint) 
--
-- ALTER TABLE RHNORGCHANNELSETTINGSTYPE ADD CONSTRAINT RHN_OCSTNGS_TYPE_CREATED_NN CHECK ("CREATED" IS NOT NULL);

--
-- 138. RHN_OCSTNGS_TYPE_ID_NN  (Constraint) 
--
-- ALTER TABLE RHNORGCHANNELSETTINGSTYPE ADD CONSTRAINT RHN_OCSTNGS_TYPE_ID_NN CHECK ("ID" IS NOT NULL);

--
-- 139. RHN_OCSTNGS_TYPE_LABEL_NN  (Constraint) 
--
-- ALTER TABLE RHNORGCHANNELSETTINGSTYPE ADD CONSTRAINT RHN_OCSTNGS_TYPE_LABEL_NN CHECK ("LABEL" IS NOT NULL);

--
-- 140. RHN_OCSTNGS_TYPE_MODIFIED_NN  (Constraint) 
--
-- ALTER TABLE RHNORGCHANNELSETTINGSTYPE ADD CONSTRAINT RHN_OCSTNGS_TYPE_MODIFIED_NN CHECK ("MODIFIED" IS NOT NULL);

--
-- 141. RHN_OCSTNGS_TYPE_ID_PK  (Constraint) 
--
ALTER TABLE RHNORGCHANNELSETTINGSTYPE ADD CONSTRAINT RHN_OCSTNGS_TYPE_ID_PK PRIMARY KEY (ID);

--
-- 142. RHN_ORGCSETTINGS_CID_NN  (Constraint) 
--
-- ALTER TABLE RHNORGCHANNELSETTINGS ADD CONSTRAINT RHN_ORGCSETTINGS_CID_NN CHECK ("CHANNEL_ID" IS NOT NULL);

--
-- 143. RHN_ORGCSETTINGS_CREATED_NN  (Constraint) 
--
-- ALTER TABLE RHNORGCHANNELSETTINGS ADD CONSTRAINT RHN_ORGCSETTINGS_CREATED_NN CHECK ("CREATED" IS NOT NULL);

--
-- 144. RHN_ORGCSETTINGS_MODIFIED_NN  (Constraint) 
--
-- ALTER TABLE RHNORGCHANNELSETTINGS ADD CONSTRAINT RHN_ORGCSETTINGS_MODIFIED_NN CHECK ("MODIFIED" IS NOT NULL);

--
-- 145. RHN_ORGCSETTINGS_OID_NN  (Constraint) 
--
-- ALTER TABLE RHNORGCHANNELSETTINGS ADD CONSTRAINT RHN_ORGCSETTINGS_OID_NN CHECK ("ORG_ID" IS NOT NULL);

--
-- 146. RHN_ORGCSETTINGS_SID_NN  (Constraint) 
--
-- ALTER TABLE RHNORGCHANNELSETTINGS ADD CONSTRAINT RHN_ORGCSETTINGS_SID_NN CHECK ("SETTING_ID" IS NOT NULL);

--
-- 147. RHN_ORGCSETTINGS_CID_FK  (Constraint) 
--
ALTER TABLE RHNORGCHANNELSETTINGS ADD CONSTRAINT RHN_ORGCSETTINGS_CID_FK FOREIGN KEY (CHANNEL_ID) 
    REFERENCES RHNCHANNEL (ID)
    ON DELETE CASCADE;

--
-- 148. RHN_ORGCSETTINGS_OID_FK  (Constraint) 
--
ALTER TABLE RHNORGCHANNELSETTINGS ADD CONSTRAINT RHN_ORGCSETTINGS_OID_FK FOREIGN KEY (ORG_ID) 
    REFERENCES WEB_CUSTOMER (ID)
    ON DELETE CASCADE;

--
-- 149. RHN_ORGCSETTINGS_SID_FK  (Constraint) 
--
ALTER TABLE RHNORGCHANNELSETTINGS ADD CONSTRAINT RHN_ORGCSETTINGS_SID_FK FOREIGN KEY (SETTING_ID) 
    REFERENCES RHNORGCHANNELSETTINGSTYPE (ID);

--
-- 150. RHN_CPERM_CID_NN  (Constraint) 
--
-- ALTER TABLE RHNCHANNELPERMISSION ADD CONSTRAINT RHN_CPERM_CID_NN CHECK ("CHANNEL_ID" IS NOT NULL);

--
-- 151. RHN_CPERM_CREATED_NN  (Constraint) 
--
-- ALTER TABLE RHNCHANNELPERMISSION ADD CONSTRAINT RHN_CPERM_CREATED_NN CHECK ("CREATED" IS NOT NULL);

--
-- 152. RHN_CPERM_MODIFIED_NN  (Constraint) 
--
-- ALTER TABLE RHNCHANNELPERMISSION ADD CONSTRAINT RHN_CPERM_MODIFIED_NN CHECK ("MODIFIED" IS NOT NULL);

--
-- 153. RHN_CPERM_RID_NN  (Constraint) 
--
-- ALTER TABLE RHNCHANNELPERMISSION ADD CONSTRAINT RHN_CPERM_RID_NN CHECK ("ROLE_ID" IS NOT NULL);

--
-- 154. RHN_CPERM_UID_NN  (Constraint) 
--
-- ALTER TABLE RHNCHANNELPERMISSION ADD CONSTRAINT RHN_CPERM_UID_NN CHECK ("USER_ID" IS NOT NULL);

--
-- 155. RHN_CPERM_CIDFFK  (Constraint) 
--
ALTER TABLE RHNCHANNELPERMISSION ADD CONSTRAINT RHN_CPERM_CIDFFK FOREIGN KEY (CHANNEL_ID) 
    REFERENCES RHNCHANNEL (ID)
    ON DELETE CASCADE;

--
-- 156. RHN_CPERM_RID_FK  (Constraint) 
--
ALTER TABLE RHNCHANNELPERMISSION ADD CONSTRAINT RHN_CPERM_RID_FK FOREIGN KEY (ROLE_ID) 
    REFERENCES RHNCHANNELPERMISSIONROLE (ID);

--
-- 157. RHN_CPERM_UID_FK  (Constraint) 
--
ALTER TABLE RHNCHANNELPERMISSION ADD CONSTRAINT RHN_CPERM_UID_FK FOREIGN KEY (USER_ID) 
    REFERENCES WEB_CONTACT (ID)
    ON DELETE CASCADE;

--
-- 158. RHN_UDSG_CID_NN  (Constraint) 
--
-- ALTER TABLE RHNUSERDEFAULTSYSTEMGROUPS ADD CONSTRAINT RHN_UDSG_CID_NN CHECK ("SYSTEM_GROUP_ID" IS NOT NULL);

--
-- 159. RHN_UDSG_UID_NN  (Constraint) 
--
-- ALTER TABLE RHNUSERDEFAULTSYSTEMGROUPS ADD CONSTRAINT RHN_UDSG_UID_NN CHECK ("USER_ID" IS NOT NULL);

--
-- 160. RHN_UDSG_CIDFFK  (Constraint) 
--
ALTER TABLE RHNUSERDEFAULTSYSTEMGROUPS ADD CONSTRAINT RHN_UDSG_CIDFFK FOREIGN KEY (SYSTEM_GROUP_ID) 
    REFERENCES RHNSERVERGROUP (ID)
    ON DELETE CASCADE;

--
-- 161. RHN_UDSG_UID_FK  (Constraint) 
--
ALTER TABLE RHNUSERDEFAULTSYSTEMGROUPS ADD CONSTRAINT RHN_UDSG_UID_FK FOREIGN KEY (USER_ID) 
    REFERENCES WEB_CONTACT (ID)
    ON DELETE CASCADE;

--
-- 162. RHN_CLIENTCAP_CAP_NID_NN  (Constraint) 
--
-- ALTER TABLE RHNCLIENTCAPABILITY ADD CONSTRAINT RHN_CLIENTCAP_CAP_NID_NN CHECK ("CAPABILITY_NAME_ID" IS NOT NULL);

--
-- 163. RHN_CLIENTCAP_CREATED_NN  (Constraint) 
--
-- ALTER TABLE RHNCLIENTCAPABILITY ADD CONSTRAINT RHN_CLIENTCAP_CREATED_NN CHECK ("CREATED" IS NOT NULL);

--
-- 164. RHN_CLIENTCAP_MODIFIED_NN  (Constraint) 
--
-- ALTER TABLE RHNCLIENTCAPABILITY ADD CONSTRAINT RHN_CLIENTCAP_MODIFIED_NN CHECK ("MODIFIED" IS NOT NULL);

--
-- 165. RHN_CLIENTCAP_SID_NN  (Constraint) 
--
-- ALTER TABLE RHNCLIENTCAPABILITY ADD CONSTRAINT RHN_CLIENTCAP_SID_NN CHECK ("SERVER_ID" IS NOT NULL);

--
-- 166. RHN_CLIENTCAP_VER_NN  (Constraint) 
--
-- ALTER TABLE RHNCLIENTCAPABILITY ADD CONSTRAINT RHN_CLIENTCAP_VER_NN CHECK ("VERSION" IS NOT NULL);

--
-- 167. RHN_CLIENTCAP_SID_FK  (Constraint) 
--
ALTER TABLE RHNCLIENTCAPABILITY ADD CONSTRAINT RHN_CLIENTCAP_SID_FK FOREIGN KEY (SERVER_ID) 
    REFERENCES RHNSERVER (ID)
    ON DELETE CASCADE;

CREATE OR REPLACE PACKAGE rpm AS
    FUNCTION vercmp(
        e1 VARCHAR2, v1 VARCHAR2, r1 VARCHAR2, 
        e2 VARCHAR2, v2 VARCHAR2, r2 VARCHAR2)
    RETURN NUMBER
        DETERMINISTIC
        PARALLEL_ENABLE;
    PRAGMA RESTRICT_REFERENCES(vercmp, WNDS, RNDS);

    FUNCTION vercmpCounter
    return NUMBER
        DETERMINISTIC
        PARALLEL_ENABLE;
    PRAGMA RESTRICT_REFERENCES(vercmpCounter, WNDS, RNDS);

    FUNCTION vercmpResetCounter
    return NUMBER
        DETERMINISTIC
        PARALLEL_ENABLE;
    PRAGMA RESTRICT_REFERENCES(vercmpResetCounter, WNDS, RNDS);
    
END rpm;
/
SHOW ERRORS;

CREATE OR REPLACE PACKAGE BODY rpm AS
    vercmp_counter NUMBER := 0;

    FUNCTION isdigit(ch CHAR)
    RETURN BOOLEAN
    IS
    BEGIN
        if ascii(ch) between ascii('0') and ascii('9')
        then
            return TRUE;
        end if;
        return FALSE;
    END isdigit;

    
    FUNCTION isalpha(ch CHAR)
    RETURN BOOLEAN
    IS
    BEGIN
        if ascii(ch) between ascii('a') and ascii('z') or 
            ascii(ch) between ascii('A') and ascii('Z')
        then
            return TRUE;
        end if;
        return FALSE;
    END isalpha;


    FUNCTION isalphanum(ch CHAR)
    RETURN BOOLEAN
    IS
    BEGIN
        if ascii(ch) between ascii('a') and ascii('z') or 
            ascii(ch) between ascii('A') and ascii('Z') or
            ascii(ch) between ascii('0') and ascii('9')
        then
            return TRUE;
        end if;
        return FALSE;
    END isalphanum;


    FUNCTION rpmstrcmp (string1 IN VARCHAR2, string2 IN VARCHAR2)
    RETURN NUMBER
    IS
        digits CHAR(10) := '0123456789';
        lc_alpha CHAR(27) := 'abcdefghijklmnopqrstuvwxyz';
        uc_alpha CHAR(27) := 'ABCDEFGHIJKLMNOPQRSTUVWXYZ';
        alpha CHAR(54) := lc_alpha || uc_alpha;
        str1 VARCHAR2(32767) := string1;
        str2 VARCHAR2(32767) := string2;
        one VARCHAR2(32767);
        two VARCHAR2(32767);
        isnum BOOLEAN;
    BEGIN
        if str1 is NULL or str2 is NULL
        then
            raise VALUE_ERROR;
        end if;
        -- easy comparison to see if versions are identical
        if str1 = str2
        then
            return 0;
        end if;
        -- loop through each version segment of str1 and str2 and compare them
        one := str1;
        two := str2;

        <<segment_loop>>
        while one is not null and two is not null
        loop
            declare
                segm1 VARCHAR2(32767);
                segm2 VARCHAR2(32767);
            begin
                --DBMS_OUTPUT.PUT_LINE('Params: ' || one || ',' || two);
                -- Throw out all non-alphanum characters
                while one is not null and not isalphanum(one)
                loop
                    one := substr(one, 2);
                end loop;
                while two is not null and not isalphanum(two)
                loop
                    two := substr(two, 2);
                end loop;
                --DBMS_OUTPUT.PUT_LINE('new params: ' || one || ',' || two);

                str1 := one;
                str2 := two;

                /* grab first completely alpha or completely numeric segment */
                /* leave one and two pointing to the start of the alpha or numeric */
                /* segment and walk str1 and str2 to end of segment */
                
                if str1 is not null and isdigit(str1)
                then
                    str1 := ltrim(str1, digits);
                    str2 := ltrim(str2, digits);
                    isnum := true;
                else
                    str1 := ltrim(str1, alpha);
                    str2 := ltrim(str2, alpha);
                    isnum := false;
                end if;

                --DBMS_OUTPUT.PUT_LINE('Len: ' || length(str1) || ',' || length(str2));
                -- Oracle trats the length of an empty string as null
                if str1 is not null
                then segm1 := substr(one, 1, length(one) - length(str1));
                else segm1 := one;
                end if;
                    
                if str2 is not null
                then segm2 := substr(two, 1, length(two) - length(str2));
                else segm2 := two;
                end if;

                --DBMS_OUTPUT.PUT_LINE('Segments: ' || segm1 || ',' || segm2);
                --DBMS_OUTPUT.PUT_LINE('Rest: ' || str1 || ',' || str2);
                /* take care of the case where the two version segments are */
                /* different types: one numeric and one alpha */
                if segm1 is null then return -1; end if; /* arbitrary */
                if segm2 is null then
					if isnum then
						return 1;
					else
						return -1;
					end if;
				end if;

                if isnum
                then
                    /* this used to be done by converting the digit segments */
                    /* to ints using atoi() - it's changed because long */
                    /* digit segments can overflow an int - this should fix that. */

                    /* throw away any leading zeros - it's a number, right? */
                    segm1 := ltrim(segm1, '0');
                    segm2 := ltrim(segm2, '0');

                    /* whichever number has more digits wins */
                    -- length of empty string is null
                    if segm1 is null and segm2 is not null
                    then
                        return -1;
                    end if;
                    if segm1 is not null and segm2 is null
                    then
                        return 1;
                    end if;
                    if length(segm1) > length(segm2) then return 1; end if;
                    if length(segm2) > length(segm1) then return -1; end if;
                end if;
                
                /* strcmp will return which one is greater - even if the two */
                /* segments are alpha or if they are numeric.  don't return  */
                /* if they are equal because there might be more segments to */
                /* compare */
                
                if segm1 < segm2 then return -1; end if;
                if segm1 > segm2 then return 1; end if;

                one := str1;
                two := str2;
            end;
        end loop segment_loop;
        /* this catches the case where all numeric and alpha segments have */
        /* compared identically but the segment sepparating characters were */
        /* different */
        if one is null and two is null then return 0; end if;

        /* whichever version still has characters left over wins */
        if one is null then return -1; end if;
        return 1;
    END rpmstrcmp;


    FUNCTION vercmp(
        e1 VARCHAR2, v1 VARCHAR2, r1 VARCHAR2, 
        e2 VARCHAR2, v2 VARCHAR2, r2 VARCHAR2)
    RETURN NUMBER
    IS
        rc NUMBER;
    BEGIN
        vercmp_counter := vercmp_counter + 1;
        if e1 is not null and e2 is null then return 1; end if;
        if e1 is null and e2 is not null then return -1; end if;
        if e1 is not null and e2 is not null
        then
            DECLARE
                ep1 NUMBER;
                ep2 NUMBER;
            BEGIN
                -- Epochs are non-null; compare them
                ep1 := TO_NUMBER(e1);
                ep2 := TO_NUMBER(e2);
                if ep1 < ep2 then return -1; end if;
                if ep1 > ep2 then return 1; end if;
                -- Epoch is identical; fall through
            END;
        end if;
        rc := rpmstrcmp(v1, v2);
        if rc != 0 then return rc; end if;
        return rpmstrcmp(r1, r2);

    END vercmp;

    FUNCTION vercmpCounter
    RETURN NUMBER
    IS
    BEGIN
        return vercmp_counter;
    END vercmpCounter;

    FUNCTION vercmpResetCounter
    RETURN NUMBER
    IS
        result NUMBER;
    BEGIN
        result := vercmp_counter;
        vercmp_counter := 0;
        return result;
    END vercmpResetCounter;
END rpm;
/
SHOW ERRORS;

-- these showed up invalid when we're done, fix them

alter trigger rhn_channel_package_mod_trig compile;
alter trigger rhn_channel_package_del_trig compile;
alter trigger rhn_hwpropval_mod_trig compile;
alter trigger rhn_bl_obs_chan_last_mod_trig compile;
alter trigger rhn_channel_mod_trig compile;

alter function lookup_hwpropval compile;
alter function lookup_hwpropname compile;
alter package rhn_package compile;
alter package rhn_user compile;
alter package rhn_entitlements compile;
alter procedure add_hwprop compile;
alter procedure delete_server_bulk compile;
alter procedure delete_channel compile;
alter procedure delete_server compile;

delete from rhnEmailAddress;

insert into rhnEmailAddress (id, address, user_id, state_id, next_action) (
	select	rhn_eaddress_id_seq.nextval,
		wupi.email, wupi.web_user_id, eas.id, null
	from	rhnEmailAddressState eas,
		web_user_personal_info wupi
	where	eas.label = 'verified'
);

update rhnVersionInfo set evr_id = lookup_evr('','2.6.1','3.1')
	where label = 'schema'
	and name_id = lookup_package_name('rhn-satellite-schema');
commit;

quit;

