--------------------------------------------------------------------------
-- Play this script in SCHEMA_260@TEST01 to make it look like SCHEMA_270@TEST01
--                                                                      --
-- Please review the script before using it to make sure it won't       --
-- cause any unacceptable data loss.                                    --
--                                                                      --
-- SCHEMA_260@TEST01 Schema Extracted by User SCHEMA_260 
-- SCHEMA_270@TEST01 Schema Extracted by User SCHEMA_270 
--------------------------------------------------------------------------

spool satellite-db-2.6.0-to-2.7.0.log

whenever sqlerror exit failure;

declare
	ignore number := 0;
begin
	select	1
	into	ignore
	from	rhnVersionInfo rvi
	where	rvi.label = 'schema'
		and rvi.name_id = lookup_package_name('rhn-satellite-schema')
		and rvi.evr_id in (
			lookup_evr('','2.6.1','3'),,
			lookup_evr('','2.6.1','3.1')
		);
end;
/

INSERT
  INTO rhnUserGroupType
       (id, label, name)
VALUES (rhn_usergroup_type_seq.nextval, 'config_admin', 'Configuration Administrator');
  
commit;

-- nothing but bad sql scripts should have put any data here so far.
delete from rhnProduct;

--
-- 1. RHN_SERVERHW_MOD_TRIG  (Trigger) 
--
DROP TRIGGER RHN_SERVERHW_MOD_TRIG;

--
-- 2. RHN_HWPROPVAL_MOD_TRIG  (Trigger) 
--
DROP TRIGGER RHN_HWPROPVAL_MOD_TRIG;

--
-- 3. RHN_HARDWARE_MOD_TRIG  (Trigger) 
--
DROP TRIGGER RHN_HARDWARE_MOD_TRIG;

--
-- 4. LOOKUP_HWPROPVAL  (Function) 
--
DROP FUNCTION LOOKUP_HWPROPVAL;

--
-- 5. LOOKUP_HWPROPNAME  (Function) 
--
ALTER TABLE RHNHARDWAREPROPNAME DROP PRIMARY KEY CASCADE;
DROP FUNCTION LOOKUP_HWPROPNAME;

--
-- 6. ADLER32  (Function) 
--
DROP FUNCTION ADLER32;

--
-- 7. ADD_HWPROP  (Procedure) 
--
DROP PROCEDURE ADD_HWPROP;

--
-- 8. RHN_SERVERHW_SID_HID_IDX  (Index) 
--
DROP INDEX RHN_SERVERHW_SID_HID_IDX;

--
-- 9. RHN_HWPROP_HID_NID_VID_IDX  (Index) 
--
DROP INDEX RHN_HWPROP_HID_NID_VID_IDX;

--
-- 10. RHN_HWPROPVAL_ID_IDX  (Index) 
--
ALTER TABLE RHNHARDWAREPROPVALUE DROP PRIMARY KEY CASCADE;
DROP INDEX RHN_HWPROPVAL_ID_IDX;

--
-- 11. RHN_HWPROPVAL_CSUM_ID_IDX  (Index) 
--
alter table rhnHardwarePropValue drop constraint rhn_hwpropval_csum_uq;
DROP INDEX RHN_HWPROPVAL_CSUM_ID_IDX;

--
-- 12. RHN_HWPROPNAME_NAME_ID_IDX  (Index) 
--
alter table rhnhardwarepropname drop constraint RHN_HWPROPNAME_NAME_UQ;
DROP INDEX RHN_HWPROPNAME_NAME_ID_IDX;

--
-- 13. RHN_HWPROPNAME_ID_IDX  (Index) 
--
DROP INDEX RHN_HWPROPNAME_ID_IDX;

--
-- 14. RHN_HWARDWARE_CSUM_ID_IDX  (Index) 
--
alter table rhnhardware drop constraint RHN_HARDWARE_CSUM_UQ;
DROP INDEX RHN_HWARDWARE_CSUM_ID_IDX;

--
-- 15. RHN_HARDWARE_ID_IDX  (Index) 
--
ALTER TABLE RHNHARDWARE DROP PRIMARY KEY CASCADE;
DROP INDEX RHN_HARDWARE_ID_IDX;

--
-- 16. RHN_DLGROUPS_NC_UQ  (Index) 
--
DROP INDEX RHN_DLGROUPS_NC_UQ;

--
-- 17. RHNSERVERHARDWARE  (Table) 
--
DROP TABLE RHNSERVERHARDWARE CASCADE CONSTRAINTS;

--
-- 18. RHNHARDWAREPROPVALUE  (Table) 
--
DROP TABLE RHNHARDWAREPROPVALUE CASCADE CONSTRAINTS;

--
-- 19. RHNHARDWAREPROPNAME  (Table) 
--
DROP TABLE RHNHARDWAREPROPNAME CASCADE CONSTRAINTS;

--
-- 20. RHNHARDWAREPROPERTIES  (Table) 
--
DROP TABLE RHNHARDWAREPROPERTIES CASCADE CONSTRAINTS;

--
-- 21. RHNHARDWARE  (Table) 
--
DROP TABLE RHNHARDWARE CASCADE CONSTRAINTS;

--
-- 22. RHNDOWNLOADGROUPS  (Table) 
--
DROP TABLE RHNDOWNLOADGROUPS CASCADE CONSTRAINTS;

--
-- 23. RHN_HWPROPVAL_ID_SEQ  (Sequence) 
--
DROP SEQUENCE RHN_HWPROPVAL_ID_SEQ;

--
-- 24. RHN_HWPROPNAME_ID_SEQ  (Sequence) 
--
DROP SEQUENCE RHN_HWPROPNAME_ID_SEQ;

--
-- 25. RHN_HARDWARE_ID_SEQ  (Sequence) 
--
DROP SEQUENCE RHN_HARDWARE_ID_SEQ;

--
-- 26. RHN_CFILE_ID_SEQ  (Sequence) 
--
CREATE SEQUENCE RHN_CFILE_ID_SEQ
  START WITH 1
  NOMAXVALUE
  MINVALUE 1
  NOCYCLE
  CACHE 20
  NOORDER;

--
-- 27. RHN_CFNAME_ID_SEQ  (Sequence) 
--
CREATE SEQUENCE RHN_CFNAME_ID_SEQ
  START WITH 1
  NOMAXVALUE
  MINVALUE 1
  NOCYCLE
  CACHE 20
  NOORDER;

--
-- 28. RHN_NAMESPACE_ID_SEQ  (Sequence) 
--
CREATE SEQUENCE RHN_NAMESPACE_ID_SEQ
  START WITH 1
  NOMAXVALUE
  MINVALUE 1
  NOCYCLE
  CACHE 20
  NOORDER;

--
-- 29. RHNCONFIGFILENAME  (Table) 
--
CREATE TABLE RHNCONFIGFILENAME
(
  ID        NUMBER CONSTRAINT RHN_CFNAME_ID_NN  NOT NULL,
  PATH      VARCHAR2(1024 BYTE) CONSTRAINT RHN_CFNAME_PATH_NN NOT NULL,
  CREATED   DATE                                DEFAULT (sysdate) CONSTRAINT RHN_CFNAME_CREATED_NN NOT NULL,
  MODIFIED  DATE                                DEFAULT (sysdate) CONSTRAINT RHN_CFNAME_MODIFIED_NN NOT NULL
)
LOGGING 
NOCACHE
NOPARALLEL;

--
-- 30. RHNDOWNLOADTYPE  (Table) 
--
CREATE TABLE RHNDOWNLOADTYPE
(
  ID     NUMBER CONSTRAINT RHN_DOWNLOAD_TYPE_ID_NN NOT NULL,
  LABEL  VARCHAR2(48 BYTE) CONSTRAINT RHN_DOWNLOAD_TYPE_LABEL_NN NOT NULL,
  NAME   VARCHAR2(96 BYTE) CONSTRAINT RHN_DOWNLOAD_TYPE_NAME_NN NOT NULL
)
LOGGING 
NOCACHE
NOPARALLEL;

insert into rhnDownloadType values (1, 'iso', 'ISO Images');
insert into rhnDownloadType values (2, 'channel-xml-dump', 'Channel Dump');

commit;

--
-- 31. RHN_CFNAME_ID_PK  (Index) 
--
CREATE INDEX RHN_CFNAME_ID_PK ON RHNCONFIGFILENAME
(ID)
LOGGING
NOPARALLEL;

--
-- 32. RHN_CFNAME_PATH_UQ  (Index) 
--
CREATE UNIQUE INDEX RHN_CFNAME_PATH_UQ ON RHNCONFIGFILENAME
(PATH)
LOGGING
NOPARALLEL;

--
-- 33. RHN_DOWNLOAD_TYPE_LABEL_UQ  (Index) 
--
CREATE UNIQUE INDEX RHN_DOWNLOAD_TYPE_LABEL_UQ ON RHNDOWNLOADTYPE
(LABEL)
LOGGING
NOPARALLEL;

--
-- 34. RHN_DOWNLOAD_TYPE_NAME_UQ  (Index) 
--
CREATE UNIQUE INDEX RHN_DOWNLOAD_TYPE_NAME_UQ ON RHNDOWNLOADTYPE
(NAME)
LOGGING
NOPARALLEL;

--
-- 35. RHN_DOWNLOAD_TYPE_PK  (Index) 
--
CREATE UNIQUE INDEX RHN_DOWNLOAD_TYPE_PK ON RHNDOWNLOADTYPE
(ID)
LOGGING
NOPARALLEL;

--
-- 95. RHN_DOWNLOAD_TYPE_PK  (Constraint) 
--
ALTER TABLE RHNDOWNLOADTYPE ADD CONSTRAINT RHN_DOWNLOAD_TYPE_PK PRIMARY KEY (ID);



--
-- 36. RHN_CHANNEL  (Package Body) 
--

-- added create or replace package for all the packages we touch right here
create or replace
package rhn_server
is
    function can_change_base_channel(server_id_in in number) return number;
end rhn_server;
/
SHOW ERRORS

CREATE OR REPLACE
PACKAGE rhn_channel
IS
    CURSOR server_base_subscriptions(server_id_in NUMBER) IS
    	   SELECT C.id
	     FROM rhnChannel C, rhnServerChannel SC
	    WHERE C.id = SC.channel_id
	      AND SC.server_id = server_id_in
	      AND C.parent_channel IS NULL;
	      
    CURSOR check_server_subscription(server_id_in NUMBER, channel_id_in NUMBER) IS 
           SELECT channel_id 
	     FROM rhnServerChannel 
	    WHERE server_id = server_id_in 
	      AND channel_id = channel_id_in;

    CURSOR check_server_parent_membership(server_id_in NUMBER, channel_id_in NUMBER) IS
    	   SELECT C.id
	     FROM rhnChannel C, rhnServerChannel SC
	    WHERE C.parent_channel = channel_id_in
	      AND C.id = SC.channel_id
	      AND SC.server_id = server_id_in;
	    
    CURSOR channel_family_perm_cursor(channel_family_id_in NUMBER, org_id_in NUMBER) IS
           SELECT *
	     FROM rhnChannelFamilyPermissions
	    WHERE channel_family_id = channel_family_id_in
	      AND (org_id = org_id_in OR org_id IS NULL);

    PROCEDURE license_consent(channel_id_in IN NUMBER, user_id_in IN NUMBER, server_id_in IN NUMBER);
    FUNCTION get_license_path(channel_id_in IN NUMBER) RETURN VARCHAR2;

    PROCEDURE unsubscribe_server(server_id_in IN NUMBER, channel_id_in NUMBER, immediate_in NUMBER := 1, unsubscribe_children_in number := 0);
    PROCEDURE subscribe_server(server_id_in IN NUMBER, channel_id_in NUMBER, immediate_in NUMBER := 1, user_id_in number := null);

    FUNCTION guess_server_base(server_id_in IN NUMBER) RETURN NUMBER;

    PROCEDURE bulk_subscribe_server(channel_id_in IN NUMBER, set_label_in IN VARCHAR2, set_uid_in IN NUMBER);
    PROCEDURE bulk_unsubscribe_server(channel_id_in IN NUMBER, set_label_in IN VARCHAR2, set_uid_in IN NUMBER);
    
    PROCEDURE bulk_server_base_change(channel_id_in IN NUMBER, set_label_in IN VARCHAR2, set_uid_in IN NUMBER);
    procedure bulk_server_basechange_from(
	set_label_in in varchar2,
	set_uid_in in number,
	old_channel_id_in in number,
	new_channel_id_in in number);

    procedure bulk_guess_server_base(
	set_label_in in varchar2,
	set_uid_in in number);

    procedure bulk_guess_server_base_from(
	set_label_in in varchar2,
	set_uid_in in number,
	channel_id_in in number);

    PROCEDURE clear_subscriptions(server_id_in IN NUMBER);
    
    FUNCTION subscription_count(channel_id_in NUMBER) RETURN VARCHAR2;
    
    FUNCTION available_family_subscriptions(channel_family_id_in IN NUMBER, org_id_in IN NUMBER) RETURN NUMBER;
    PROCEDURE update_family_counts(channel_family_id_in IN NUMBER, org_id_in IN NUMBER);
    FUNCTION family_for_channel(channel_id_in IN NUMBER) RETURN NUMBER;

    FUNCTION available_chan_subscriptions(channel_id_in IN NUMBER, org_id_in IN NUMBER) RETURN NUMBER;

    procedure entitle_customer(customer_id_in in number, channel_family_id_in in number, quantity_in in number);
    procedure set_family_maxmembers(customer_id_in in number, channel_family_id_in in number, quantity_in in number);
    procedure unsubscribe_server_from_family(server_id_in in number, channel_family_id_in in number);

    procedure delete_server_channels(server_id_in in number);
    procedure refresh_newest_package(channel_id_in in number, caller_in in varchar2 := '(unknown)');
    
    function get_org_id(channel_id_in in number) return number;
    PRAGMA RESTRICT_REFERENCES(get_org_id, WNDS, RNPS, WNPS);

    function get_org_access(channel_id_in in number, org_id_in in number) return number;
    PRAGMA RESTRICT_REFERENCES(get_org_access, WNDS, RNPS, WNPS);
    
    function user_role_check_debug(channel_id_in in number, user_id_in in number, role_in in varchar2, reason_out out varchar2)
    	RETURN NUMBER;
    PRAGMA RESTRICT_REFERENCES(user_role_check_debug, WNDS, RNPS, WNPS);

    function user_role_check(channel_id_in in number, user_id_in in number, role_in in varchar2)
    	RETURN NUMBER;
    PRAGMA RESTRICT_REFERENCES(user_role_check, WNDS, RNPS, WNPS);
    
    function loose_user_role_check(channel_id_in in number, user_id_in in number, role_in in varchar2)
    	RETURN NUMBER;
    PRAGMA RESTRICT_REFERENCES(loose_user_role_check, WNDS, RNPS, WNPS);

    function direct_user_role_check(channel_id_in in number, user_id_in in number, role_in in varchar2)
    	RETURN NUMBER;
    PRAGMA RESTRICT_REFERENCES(direct_user_role_check, WNDS, RNPS, WNPS);

    function org_channel_setting(channel_id_in in number, org_id_in in number, setting_in in varchar2)
    	RETURN NUMBER;
    PRAGMA RESTRICT_REFERENCES(org_channel_setting, WNDS, RNPS, WNPS);

END rhn_channel;
/
SHOW ERRORS

create or replace
package body rhn_bel
is
	function find_state_of_org (
		org_id_in in number
	) return varchar2 is
		state_label rhnOrgAvailableStates.label%TYPE;
	begin
		select oas.label into state_label
		from    rhnOrgAvailableStates oas,
			rhnOrgState os
		where   os.org_id = org_id_in
			and os.state_id = oas.id;

		return state_label;
	end find_state_of_org;

	function is_state_legacy_unclassified (
		org_id_in in number
	) return number is
		cursor states is
			select	1
			from	rhnOrgAvailableStates oas,
					rhnOrgState os
			where	os.org_id = org_id_in
				and os.state_id = oas.id
					and oas.label = 'legacy_unclassified';
	begin
		for x in states loop return 1; end loop;
		return 0;
	end is_state_legacy_unclassified;

	function is_org_paid (
		org_id_in in number
	) return number is
		cursor paids is
			select	1
			from	rhnPaidOrgs
			where	org_id = org_id_in;
	begin
		for paid in paids loop return 1; end loop;
		return 0;
	end;

	function lookup_email_state (
		state_in in varchar2
	) return number is
		retval number;
	begin
		select id into retval from rhnEmailAddressState where label = state_in;
		return retval;
	exception
			when no_data_found then
				rhn_exception.raise_exception('invalid_state');
	end lookup_email_state;

	procedure check_org_state (
		state_id_in in number
	) is
		ignore number;
	begin
		select id into ignore from rhnOrgAvailableStates where id = state_id_in;
	exception
			when no_data_found then
				rhn_exception.raise_exception('invalid_state');
	end check_org_state;

	function lookup_org_state (
		state_in in varchar2
	) return number is
		retval number;
	begin
		select id into retval from rhnOrgAvailableStates where label = state_in;
		return retval;
	exception
			when no_data_found then
				rhn_exception.raise_exception('invalid_state');
	end lookup_org_state;

	procedure validate_org_state_change (
		from_state_in in number,
		to_state_in in number
	) is
		ignore	number;
	begin
		select	1
		into	ignore
		from	rhnOrgStateTransitions	rost
		where	1=1
			and rost.from_state = from_state_in
			and rost.to_state = to_state_in;
	exception
		when no_data_found then
			rhn_exception.raise_exception('invalid_state_transition');
	end;

	procedure join_rhn (
		org_id_in in number
	) is
		state_label	rhnOrgAvailableStates.label%TYPE;
	begin
	    	select OAS.label into state_label
		  from rhnOrgAvailableStates OAS,
		       rhnOrgState OS
		 where OS.state_id = OAS.id
		   and OS.org_id = org_id_in;

		if state_label = 'legacy_web'
		then
		    -- legacy_web with a timer flows a user into grace
		    update rhnOrgState
		       set next_action = sysdate
		     where org_id = org_id_in;
		     
    	    	    insert into rhnOrgStateLog
    	    	      (org_id, old_state_id, new_state_id, reason)
					  (
					  	select	org_id_in, os.state_id,
								rhn_bel.lookup_org_state('legacy_unclassified'),
								'rhn_bel.join_rhn package method'
						from	rhnOrgState os
						where	os.org_id = org_id_in
					);
		end if;
	end;

	procedure set_org_paid(
		org_id_in in number
	) is
	begin
    	insert into rhnOrgStateLog (
			org_id, old_state_id, new_state_id, reason
		) (
			select	org_id_in, os.state_id, rhn_bel.lookup_org_state('paid'),
					'rhn_bel.set_org_paid'
			from	rhnOrgState os
			where	os.org_id = org_id_in
		);

		update	rhnOrgState
		set		state_id =
				(select id from rhnOrgAvailableStates where label = 'paid'),
				next_action = NULL
		where	org_id = org_id_in;
    end set_org_paid;

	procedure set_org_unpaid (
		org_id_in in number
	) is
	begin
		update	rhnOrgState
		set		state_id = (select id from rhnOrgAvailableStates where label = 'falling_from_grace'),
				next_action = sysdate
		where	org_id = org_id_in;
		
    	    	insert into rhnOrgStateLog
    	    	  (org_id, old_state_id, new_state_id, reason)
				  (
				  	select	org_id_in, os.org_id,
							rhn_bel.lookup_org_state('falling_from_grace'),
							'rhn_bel.set_org_unpaid'
					from	rhnOrgState os
					where	os.org_id = org_id_in
				  );
	end set_org_unpaid;
end;
/
show errors

CREATE OR REPLACE PACKAGE BODY rhn_channel
IS
    FUNCTION get_license_path(channel_id_in IN NUMBER)
    RETURN VARCHAR2
    IS
    	license_val VARCHAR2(1000);
    BEGIN
    	SELECT CFL.license_path INTO license_val
	  FROM rhnChannelFamilyLicense CFL, rhnChannelFamilyMembers CFM
	 WHERE CFM.channel_id = channel_id_in
	   AND CFM.channel_family_id = CFL.channel_family_id;
    	RETURN license_val;
    EXCEPTION
    	WHEN NO_DATA_FOUND
	    THEN
	    RETURN NULL;
    END get_license_path;
    PROCEDURE license_consent(channel_id_in IN NUMBER, user_id_in IN NUMBER, server_id_in IN NUMBER)
    IS
    	channel_family_id_val NUMBER;
    BEGIN
    	channel_family_id_val := rhn_channel.family_for_channel(channel_id_in);
	IF channel_family_id_val IS NULL
	THEN
	    rhn_exception.raise_exception('channel_subscribe_no_family');
	END IF;
	IF rhn_channel.get_license_path(channel_id_in) IS NULL
	THEN
	    rhn_exception.raise_exception('channel_consent_no_license');
	END IF;
	INSERT INTO rhnChannelFamilyLicenseConsent (channel_family_id, user_id, server_id)
	VALUES (channel_family_id_val, user_id_in, server_id_in);
    END license_consent;
    PROCEDURE subscribe_server(server_id_in IN NUMBER, channel_id_in NUMBER, immediate_in NUMBER := 1, user_id_in in number := null)
    IS
        channel_parent_val      rhnChannel.parent_channel%TYPE;
        parent_subscribed       BOOLEAN;
        server_has_base_chan    BOOLEAN;
	server_already_in_chan  BOOLEAN;
	channel_family_id_val   NUMBER;
	server_org_id_val       NUMBER;
	available_subscriptions NUMBER;
	consenting_user         NUMBER;
	allowed			number := 0;
    BEGIN
    	if user_id_in is not null then
		allowed := rhn_channel.user_role_check(channel_id_in, user_id_in, 'subscribe');
	else
		allowed := 1;
	end if;
	if allowed = 0 then
		rhn_exception.raise_exception('no_subscribe_permissions');
	end if;
        SELECT parent_channel INTO channel_parent_val FROM rhnChannel WHERE id = channel_id_in;
        IF channel_parent_val IS NOT NULL
        THEN
            parent_subscribed := FALSE;
            FOR check_subscription IN check_server_subscription(server_id_in, channel_parent_val)
            LOOP
                parent_subscribed := TRUE;
            END LOOP check_subscription;
            IF NOT parent_subscribed
            THEN
    	    	RETURN;
            END IF;
        ELSE
            server_has_base_chan := FALSE;
            FOR base IN server_base_subscriptions(server_id_in)
            LOOP
                server_has_base_chan := TRUE;
            END LOOP base;
            IF server_has_base_chan
            THEN
                rhn_exception.raise_exception('channel_server_one_base');
            END IF;
        END IF;
        FOR check_subscription IN check_server_subscription(server_id_in, channel_id_in)
        LOOP
            server_already_in_chan := TRUE;
        END LOOP check_subscription;
        IF server_already_in_chan
        THEN
    	    RETURN;
        END IF;
	channel_family_id_val := rhn_channel.family_for_channel(channel_id_in);
	IF channel_family_id_val IS NULL
	THEN
	    rhn_exception.raise_exception('channel_subscribe_no_family');
	END IF;
	SELECT org_id INTO server_org_id_val
	  FROM rhnServer
	 WHERE id = server_id_in;
	available_subscriptions := rhn_channel.available_family_subscriptions(channel_family_id_val, server_org_id_val);
	IF available_subscriptions IS NULL OR available_subscriptions > 0
	THEN
	    IF rhn_channel.get_license_path(channel_id_in) IS NOT NULL
	    THEN
	    	BEGIN
	    	SELECT user_id INTO consenting_user
		  FROM rhnChannelFamilyLicenseConsent
		 WHERE channel_family_id = channel_family_id_val
		   AND server_id = server_id_in;
		EXCEPTION
    	    	    WHEN NO_DATA_FOUND
		    	THEN
			    rhn_exception.raise_exception('channel_subscribe_no_consent');
		END;
	    END IF;
	    insert into rhnServerHistory (id,server_id,summary,details) (
	    	select	rhn_event_id_seq.nextval,
			server_id_in,
			'subscribed to channel',
			c.label
		from	rhnChannel c
		where	c.id = channel_id_in
	    );
            INSERT INTO rhnServerChannel (server_id, channel_id) VALUES (server_id_in, channel_id_in);
    	    rhn_channel.update_family_counts(channel_family_id_val, server_org_id_val);
    	    queue_server(server_id_in, immediate_in);
	ELSE
	    rhn_exception.raise_exception('channel_family_no_subscriptions');
	END IF;
    END subscribe_server;
    PROCEDURE bulk_subscribe_server(channel_id_in IN NUMBER, set_label_in IN VARCHAR2, set_uid_in IN NUMBER)
    IS
    BEGIN
        FOR server IN rhn_set.set_iterator(set_label_in, set_uid_in)
        LOOP
            rhn_channel.subscribe_server(server.element, channel_id_in, 0, set_uid_in);
        END LOOP server;
    END bulk_subscribe_server;
    PROCEDURE bulk_server_base_change(channel_id_in IN NUMBER, set_label_in IN VARCHAR2, set_uid_in IN NUMBER)
    IS
    BEGIN
        FOR server IN rhn_set.set_iterator(set_label_in, set_uid_in)
        LOOP
	    IF rhn_server.can_change_base_channel(server.element) = 1
	    THEN
                rhn_channel.clear_subscriptions(TO_NUMBER(server.element));
                rhn_channel.subscribe_server(server.element, channel_id_in, 0, set_uid_in);
            END IF;
        END LOOP server;
    END bulk_server_base_change;
    procedure bulk_server_basechange_from(
	set_label_in in varchar2,
	set_uid_in in number,
	old_channel_id_in in number,
	new_channel_id_in in number
    ) is
	cursor channels(server_id_in in number) is
	    select	rsc.channel_id
	    from	rhnServerChannel rsc,
			rhnChannel rc
	    where	server_id_in = rsc.server_id
			and rsc.channel_id = rc.id
			and rc.parent_channel is null;
    begin
	for server in rhn_set.set_iterator(set_label_in, set_uid_in)
	loop
	    for channel in channels(server.element)
	    loop
		if channel.channel_id = old_channel_id_in
		then
		    insert into rhnSet (user_id, label, element) values (set_uid_in, set_label_in || 'basechange', server.element);
		end if;
	    end loop channel;
	end loop server;
	bulk_server_base_change(new_channel_id_in, set_label_in||'basechange',set_uid_in);
	delete from rhnSet where label = set_label_in||'basechange' and user_id = set_uid_in;
    end;
    procedure bulk_guess_server_base(
	set_label_in in varchar2,
	set_uid_in in number
    ) is
	channel_id number;
    begin
	for server in rhn_set.set_iterator(set_label_in, set_uid_in)
	loop
	    begin
	    	if rhn_server.can_change_base_channel(server.element) = 1
		then
    	            channel_id := guess_server_base(TO_NUMBER(server.element));
	    	    rhn_channel.clear_subscriptions(TO_NUMBER(server.element));
	    	    rhn_channel.subscribe_server(TO_NUMBER(server.element), channel_id, 0, set_uid_in);
		end if;
	    exception when others then
	    	null;
	    end;
	end loop server;
    end;
    function guess_server_base(
    	server_id_in in number
    ) RETURN number is
    	channel number;
        cursor base_channel_cursor is
            select rc.id
              from rhnChannelPermissions rcp,
                   rhnChannel rc,
                   rhnServerChannelArchCompat scac,
                   rhnDistChannelMap rdcm,
                   rhnServer rs
             where rs.id = server_id_in
                   and rs.release = rdcm.release
                   and rdcm.channel_id = rc.id
                   and rs.server_arch_id = scac.server_arch_id
                   and scac.channel_arch_id = rdcm.channel_arch_id
                   and rdcm.channel_id = rcp.channel_id
                   and (rcp.org_id is null or
                          rcp.org_id = rs.org_id)
                   and rdcm.channel_id = rc.id
                   and rc.parent_channel is null;
    begin
        for channel in base_channel_cursor loop
            return channel.id;
        end loop;
        return null;
    end;
    procedure bulk_guess_server_base_from(
	set_label_in in varchar2,
	set_uid_in in number,
	channel_id_in in number
    ) is
	cursor channels(server_id_in in number) is
	    select	rsc.channel_id
	    from	rhnServerChannel rsc,
			rhnChannel rc
	    where	server_id_in = rsc.server_id
			and rsc.channel_id = rc.id
			and rc.parent_channel is null;
    begin
	for server in rhn_set.set_iterator(set_label_in, set_uid_in)
	loop
	    for channel in channels(server.element)
	    loop
		if channel.channel_id = channel_id_in
		then
		    insert into rhnSet (user_id, label, element) values (set_uid_in, set_label_in || 'baseguess', server.element);
		end if;
	    end loop channel;
	end loop server;
	bulk_guess_server_base(set_label_in||'baseguess',set_uid_in);
	delete from rhnSet where label = set_label_in||'baseguess' and user_id = set_uid_in;
    end;
    PROCEDURE clear_subscriptions(server_id_in IN NUMBER)
    IS
    	cursor server_channels(server_id_in in number) is
		select	s.org_id, sc.channel_id, cfm.channel_family_id
		from	rhnServer s,
			rhnServerChannel sc,
			rhnChannelFamilyMembers cfm
		where	s.id = server_id_in
			and s.id = sc.server_id
			and sc.channel_id = cfm.channel_id;
    BEGIN
    	for channel in server_channels(server_id_in)
	loop
		unsubscribe_server(server_id_in, channel.channel_id, 1, 1);
		rhn_channel.update_family_counts(channel.channel_family_id, channel.org_id);
	end loop channel;
    END clear_subscriptions;
    PROCEDURE unsubscribe_server(server_id_in IN NUMBER, channel_id_in NUMBER, immediate_in NUMBER := 1, unsubscribe_children_in number := 0)
    IS
	channel_family_id_val   NUMBER;
	server_org_id_val       NUMBER;
	available_subscriptions NUMBER;
	server_already_in_chan  BOOLEAN;
	cursor	channel_family_is_proxy(channel_family_id_in in number) is
		select	1
		from	rhnChannelFamily
		where	id = channel_family_id_in
		    and label = 'rhn-proxy';
	cursor	channel_family_is_satellite(channel_family_id_in in number) is
		select	1
		from	rhnChannelFamily
		where	id = channel_family_id_in
		    and label = 'rhn-satellite';
	cursor local_chk_server_parent_memb (
			server_id_in number,
			channel_id_in number ) is
		select	c.id
		from	rhnChannel			c,
				rhnServerChannel	sc
		where	1=1
			and c.parent_channel = channel_id_in
			and c.id = sc.channel_id
			and sc.server_id = server_id_in;
    BEGIN
        FOR child IN local_chk_server_parent_memb(server_id_in, channel_id_in)
        LOOP
	    if unsubscribe_children_in = 1 then
	    	unsubscribe_server(server_id_in => server_id_in,
								channel_id_in => child.id,
								immediate_in => immediate_in,
								unsubscribe_children_in => unsubscribe_children_in);
	    else
	    	rhn_exception.raise_exception('channel_unsubscribe_child_exists');
	    end if;
        END LOOP child;
	server_already_in_chan := FALSE;
        FOR check_subscription IN check_server_subscription(server_id_in, channel_id_in)
        LOOP
            server_already_in_chan := TRUE;
        END LOOP check_subscription;
        IF NOT server_already_in_chan
        THEN
    	    RETURN;
        END IF;
	insert into rhnServerHistory (id,server_id,summary,details) (
	    select  rhn_event_id_seq.nextval,
	    	    server_id_in,
		    'unsubscribed from channel',
		    c.label
	    from    rhnChannel c
	    where   c.id = channel_id_in
	);
        DELETE FROM rhnServerChannel WHERE server_id = server_id_in AND channel_id = channel_id_in;
    	queue_server(server_id_in, immediate_in);
	channel_family_id_val := rhn_channel.family_for_channel(channel_id_in);
	IF channel_family_id_val IS NULL
	THEN
	    rhn_exception.raise_exception('channel_unsubscribe_no_family');
	END IF;
	for ignore in channel_family_is_satellite(channel_family_id_val) loop
		delete from rhnSatelliteInfo where server_id = server_id_in;
		delete from rhnSatelliteChannelFamily where server_id = server_id_in;
	end loop;
	for ignore in channel_family_is_proxy(channel_family_id_val) loop
		delete from rhnProxyInfo where server_id = server_id_in;
	end loop;
	DELETE FROM rhnChannelFamilyLicenseConsent
	 WHERE channel_family_id = channel_family_id_val
	   AND server_id = server_id_in;
	SELECT org_id INTO server_org_id_val
	  FROM rhnServer
	 WHERE id = server_id_in;
	rhn_channel.update_family_counts(channel_family_id_val, server_org_id_val);
    END unsubscribe_server;
    PROCEDURE bulk_unsubscribe_server(channel_id_in IN NUMBER, set_label_in IN VARCHAR2, set_uid_in IN NUMBER)
    IS
    BEGIN
        FOR server IN rhn_set.set_iterator(set_label_in, set_uid_in)
        LOOP
            rhn_channel.unsubscribe_server(server.element, channel_id_in, 0);
        END LOOP server;
    END bulk_unsubscribe_server;
    FUNCTION subscription_count(channel_id_in NUMBER)
    RETURN VARCHAR2
    IS
    	sub_count_val NUMBER;
	null_org    NUMBER;
    BEGIN
        SELECT COUNT(*) INTO sub_count_val FROM rhnChannelPermissions WHERE channel_id = channel_id_in;
	IF sub_count_val = 1
	THEN
	    SELECT org_id INTO null_org FROM rhnChannelPermissions WHERE channel_id = channel_id_in AND org_id IS NULL;
	    IF null_org IS NULL
	    THEN
	    	RETURN '(public)';
	    END IF;
	END IF;
	RETURN sub_count_val;
    EXCEPTION
        WHEN NO_DATA_FOUND
	THEN
	    RETURN 1;
    END subscription_count;
    FUNCTION family_for_channel(channel_id_in IN NUMBER)
    RETURN NUMBER
    IS
    	channel_family_id_val NUMBER;
    BEGIN
    	SELECT channel_family_id INTO channel_family_id_val
	  FROM rhnChannelFamilyMembers
         WHERE channel_id = channel_id_in;
	RETURN channel_family_id_val;
    EXCEPTION
        WHEN NO_DATA_FOUND
	THEN
	    RETURN NULL;
    END family_for_channel;
    FUNCTION available_family_subscriptions(channel_family_id_in IN NUMBER, org_id_in IN NUMBER)
    RETURN NUMBER
    IS
    	cfp channel_family_perm_cursor%ROWTYPE;
    	current_members_val NUMBER;
	max_members_val     NUMBER;
	found               NUMBER;
    BEGIN
	IF NOT channel_family_perm_cursor%ISOPEN
	THEN
	    OPEN channel_family_perm_cursor(channel_family_id_in, org_id_in);
	END IF;
	FETCH channel_family_perm_cursor INTO cfp;
	WHILE channel_family_perm_cursor%FOUND
    	LOOP
	    found := 1;
	    current_members_val := cfp.current_members;
	    max_members_val := cfp.max_members;
	    FETCH channel_family_perm_cursor INTO cfp;
	END LOOP;
	IF channel_family_perm_cursor%ISOPEN
	THEN
	    CLOSE channel_family_perm_cursor;
	END IF;
	IF found IS NULL
	THEN
	    RETURN 0;
	END IF;
	IF max_members_val IS NULL
	THEN
	    RETURN NULL;
	END IF;
	RETURN max_members_val - current_members_val;
    END available_family_subscriptions;
    PROCEDURE update_family_counts(channel_family_id_in IN NUMBER, org_id_in IN NUMBER)
    IS
    BEGIN
    	UPDATE rhnChannelFamilyPermissions
	   SET current_members = (SELECT COUNT(server_id)
	                            FROM rhnServerChannel
				   WHERE channel_id IN (SELECT channel_id FROM rhnChannelFamilyMembers
				                         WHERE channel_family_id = channel_family_id_in)
				     AND server_id IN (SELECT id FROM rhnServer WHERE org_id = org_id_in))
	 WHERE channel_family_id = channel_family_id_in
	   AND org_id = org_id_in;
    END update_family_counts;
    FUNCTION available_chan_subscriptions(channel_id_in IN NUMBER, org_id_in IN NUMBER)
    RETURN NUMBER
    IS
	channel_family_id_val NUMBER;
    BEGIN
    	SELECT channel_family_id INTO channel_family_id_val
	  FROM rhnChannelFamilyMembers
	 WHERE channel_id = channel_id_in;
	 RETURN rhn_channel.available_family_subscriptions(channel_family_id_val, org_id_in);
    END available_chan_subscriptions;
    procedure entitle_customer(customer_id_in in number, channel_family_id_in in number, quantity_in in number)
    is
		cursor permissions is
			select	1
			from	rhnChannelFamilyPermissions rcfp
			where	rcfp.org_id = customer_id_in
				and	rcfp.channel_family_id = channel_family_id_in;
    begin
		for perm in permissions loop
			set_family_maxmembers(
				customer_id_in,
				channel_family_id_in,
				quantity_in
			);
			rhn_channel.update_family_counts(
				channel_family_id_in,
				customer_id_in
			);
			return;
		end loop;
		insert
        into    rhnChannelFamilyPermissions
               (channel_family_id, org_id, max_members, current_members)
        values  (channel_family_id_in, customer_id_in, quantity_in, 0);
    end;
    procedure set_family_maxmembers(customer_id_in in number, channel_family_id_in in number, quantity_in in number)
    is
	cursor servers is
	    select  server_id from (
		select	rownum row_number, server_id, modified from (
		    select  rcfs.server_id,
			    rcfs.modified
		    from    rhnChannelFamilyServers rcfs
		    where   rcfs.customer_id = customer_id_in
			    and rcfs.channel_family_id = channel_family_id_in
		    order by modified
		)
		where rownum > quantity_in
	    );
    begin
	for server in servers
	loop
	    rhn_channel.unsubscribe_server_from_family(server.server_id, channel_family_id_in);
	end loop;
	update	rhnChannelFamilyPermissions rcfp
	set	rcfp.max_members = quantity_in
	where	rcfp.channel_family_id = channel_family_id_in
		and rcfp.org_id = customer_id_in;
    end;
    procedure unsubscribe_server_from_family(server_id_in in number, channel_family_id_in in number)
    is
    begin
	delete
	from	rhnServerChannel rsc
	where	rsc.server_id = server_id_in
		and channel_id in (
			select	rcfm.channel_id
			from	rhnChannelFamilyMembers rcfm
			where	rcfm.channel_family_id = channel_family_id_in);
    end;
    function get_org_id(channel_id_in in number)
    return number
    is
    	org_id_out number;
    begin
    	select org_id into org_id_out
	  from rhnChannel
	 where id = channel_id_in;
	return org_id_out;
    end get_org_id;
    function get_org_access(channel_id_in in number, org_id_in in number)
    return number
    is
    	throwaway number;
    begin
	select distinct 1 into throwaway
	  from rhnChannelFamilyMembers CFM,
	       rhnChannelFamilyPermissions CFP
	 where CFM.channel_family_id = CFP.channel_family_id
	   and CFM.channel_id = channel_id_in
	   and (CFP.org_id = org_id_in OR CFP.org_id IS NULL);
	return 1;
    exception
    	when no_data_found
	    then
	    return 0;
    end;
    function user_role_check_debug(channel_id_in in number, user_id_in in number, role_in in varchar2, reason_out out varchar2)
    return number
    is
    	org_id number;
    begin
    	org_id := rhn_user.get_org_id(user_id_in);
    	if role_in = 'manage' and NVL(rhn_channel.get_org_id(channel_id_in), -1) <> org_id
	then
	    reason_out := 'channel_not_owned';
	    return 0;
	end if;
    	if role_in = 'subscribe' and rhn_channel.get_org_access(channel_id_in, org_id) = 0
	then
	    reason_out := 'channel_not_available';
	    return 0;
	end if;
    	if rhn_user.check_role(user_id_in, 'org_admin') = 1
	then
	    reason_out := 'org_admin';
	    return 1;
	end if;
    	if rhn_user.check_role(user_id_in, 'channel_admin') = 1
	then
	    reason_out := 'channel_admin';
	    return 1;
	end if;
	if role_in = 'subscribe'
	then
	    if rhn_channel.org_channel_setting(channel_id_in, org_id, 'not_globally_subscribable') = 0
	    then
	    	reason_out := 'globally_subscribable';
		return 1;
	    end if;
	end if;
	reason_out := 'direct_permission';
	return rhn_channel.direct_user_role_check(channel_id_in, user_id_in, role_in);
    end;
    function user_role_check(channel_id_in in number, user_id_in in number, role_in in varchar2)
    return number
    is
  	throwaway varchar2(256);
    begin
    	return rhn_channel.user_role_check_debug(channel_id_in, user_id_in, role_in, throwaway);
    end;
    function loose_user_role_check(channel_id_in in number, user_id_in in number, role_in in varchar2)
    return number
    is
    begin
        if user_id_in is null then
            return 1;
        end if;
        return user_role_check(channel_id_in, user_id_in, role_in);
    end loose_user_role_check;
    function direct_user_role_check(channel_id_in in number, user_id_in in number, role_in in varchar2)
    return number
    is
    	throwaway number;
    begin
	select 1 into throwaway
	  from rhnChannelPermissionRole CPR,
	       rhnChannelPermission CP
	 where CP.user_id = user_id_in
	   and CP.channel_id = channel_id_in
	   and CPR.label = role_in
	   and CP.role_id = CPR.id;
	return 1;
    exception
    	when no_data_found
	    then
	    return 0;
    end;
    function org_channel_setting(channel_id_in in number, org_id_in in number, setting_in in varchar2)
    return number
    is
    	throwaway number;
    begin
	select 1 into throwaway
	  from rhnOrgChannelSettingsType OCST,
	       rhnOrgChannelSettings OCS
	 where OCS.org_id = org_id_in
	   and OCS.channel_id = channel_id_in
	   and OCST.label = setting_in
	   and OCS.setting_id = OCST.id;
	return 1;
    exception
    	when no_data_found
	    then
	    return 0;
    end;
    procedure delete_server_channels(server_id_in in number)
    is
    begin
	update	rhnChannelFamilyPermissions
	set	current_members = current_members -1
	where	org_id in (
			select	org_id
			from	rhnServer
			where	id = server_id_in
		)
		and channel_family_id in (
			select	rcfm.channel_family_id
			from	rhnChannelFamilyMembers rcfm,
				rhnServerChannel rsc
			where	rsc.server_id = server_id_in
				and rsc.channel_id = rcfm.channel_id
		);
    end;
	procedure refresh_newest_package(channel_id_in in number, caller_in in varchar2 := '(unknown)')
	is
	begin
		delete from rhnChannelNewestPackage where channel_id = channel_id_in;
		insert into rhnChannelNewestPackage
			( channel_id, name_id, evr_id, package_id, package_arch_id )
			(	select	channel_id,
						name_id, evr_id,
						package_id, package_arch_id
				from	rhnChannelNewestPackageView
				where	channel_id = channel_id_in
			);
                insert into rhnChannelNewestPackageAudit (channel_id, caller)
                    values (channel_id_in, caller_in);
                update rhnChannel
                    set last_modified = greatest(sysdate, last_modified + 1/86400)
                    where id = channel_id_in;
	end;
END rhn_channel;
/

SHOW ERRORS;

--
-- 37. RHN_SERVER  (Package Body) 
--
CREATE OR REPLACE package body rhn_server
is
    function can_change_base_channel(server_id_in IN NUMBER)
    return number
    is
    	throwaway number;
    begin
	select 1 into throwaway
	  from rhnServer S
	 where S.id = server_id_in
	   and not exists (select 1 from rhnSatelliteInfo SI where SI.server_id = S.id)
	   and not exists (select 1 from rhnProxyInfo PI where PI.server_id = S.id);
	return 1;
    exception
    	when no_data_found
	    then
	    return 0;
    end can_change_base_channel;
end rhn_server;
/

SHOW ERRORS;

--
-- 38. LOOKUP_CONFIG_FILENAME  (Function) 
--
CREATE OR REPLACE FUNCTION
LOOKUP_CONFIG_FILENAME(name_in IN VARCHAR2)
RETURN NUMBER
DETERMINISTIC
IS
	PRAGMA AUTONOMOUS_TRANSACTION;
	name_id		NUMBER;
BEGIN
	SELECT id
          INTO name_id
          FROM rhnConfigFileName
         WHERE path = name_in;
	RETURN name_id;
EXCEPTION
        WHEN NO_DATA_FOUND THEN
            INSERT INTO rhnConfigFileName (id, path)
                VALUES (rhn_cfname_id_seq.nextval, name_in)
                RETURNING id INTO name_id;
            COMMIT;
	RETURN name_id;
END;
/

SHOW ERRORS;

--
-- 39. RHN_CFNAME_MOD_TRIG  (Trigger) 
--
CREATE OR REPLACE TRIGGER RHN_CFNAME_MOD_TRIG
BEFORE INSERT OR UPDATE ON RHNCONFIGFILENAME
FOR EACH ROW
begin
	:new.modified := sysdate;
end;
/
SHOW ERRORS;


--
-- 40. RHNCONFIGFILE  (Table) 
--
CREATE TABLE RHNCONFIGFILE
(
  ID        NUMBER CONSTRAINT RHN_CFILE_ID_NN   NOT NULL,
  ORG_ID    NUMBER CONSTRAINT RHN_CFILE_OID_NN  NOT NULL,
  MD5SUM    VARCHAR2(64 BYTE) CONSTRAINT RHN_CFILE_MD5SUM_NN NOT NULL,
  CONTENTS  BLOB CONSTRAINT RHN_CFILE_CONTENTS_NN NOT NULL,
  CREATED   DATE                                DEFAULT (sysdate) CONSTRAINT RHN_CFILE_CREATED_NN NOT NULL,
  MODIFIED  DATE                                DEFAULT (sysdate) CONSTRAINT RHN_CFILE_MODIFIED_NN NOT NULL
)
LOGGING 
NOCACHE
NOPARALLEL;

--
-- 41. LOCALLY_MODIFIED  (Column) 
--
ALTER TABLE RHNERRATA ADD (LOCALLY_MODIFIED  CHAR(1 BYTE));

--
-- 42. LOCALLY_MODIFIED  (Column) 
--
ALTER TABLE RHNERRATATMP ADD (LOCALLY_MODIFIED  CHAR(1 BYTE));

--
-- 43. RHNNAMESPACE  (Table) 
--
CREATE TABLE RHNNAMESPACE
(
  ID           NUMBER CONSTRAINT RHN_NAMESPACE_ID_NN NOT NULL,
  ORG_ID       NUMBER CONSTRAINT RHN_NAMESPACE_OID_NN NOT NULL,
  NAME         VARCHAR2(128 BYTE) CONSTRAINT RHN_NAMESPACE_NAME_NN NOT NULL,
  DESCRIPTION  VARCHAR2(1024 BYTE) CONSTRAINT RHN_NAMESPACE_DESC_NN NOT NULL,
  CREATED      DATE                             DEFAULT (sysdate) CONSTRAINT RHN_NAMESPACE_CREATED_NN NOT NULL,
  MODIFIED     DATE                             DEFAULT (sysdate) CONSTRAINT RHN_NAMESPACE_MODIFIED_NN NOT NULL
)
LOGGING 
NOCACHE
NOPARALLEL;

--
-- 44. RHN_CFILE_ID_PK  (Index) 
--
CREATE INDEX RHN_CFILE_ID_PK ON RHNCONFIGFILE
(ID)
LOGGING
NOPARALLEL;

--
-- 45. RHN_ERRKW_EID_IDX  (Index) 
--
CREATE INDEX RHN_ERRKW_EID_IDX ON RHNERRATAKEYWORD
(ERRATA_ID)
LOGGING
NOPARALLEL;

--
-- 46. RHN_NAMESPACE_ID_PK  (Index) 
--
CREATE INDEX RHN_NAMESPACE_ID_PK ON RHNNAMESPACE
(ID)
LOGGING
NOPARALLEL;

--
-- 47. RHN_NAMESPACE_OID_NAME_UQ  (Index) 
--
CREATE UNIQUE INDEX RHN_NAMESPACE_OID_NAME_UQ ON RHNNAMESPACE
(ORG_ID, NAME)
LOGGING
NOPARALLEL;

--
-- 48. DELETE_ERRATA  (Procedure) 
--
CREATE OR REPLACE procedure
delete_errata (
	errata_id_in in number
) is
begin
	delete from rhnPaidErrataTempCache where errata_id = errata_id_in;
	delete from rhnErrata where id = errata_id_in;
	delete from rhnErrataTmp where id = errata_id_in;
end delete_errata;
/

SHOW ERRORS;

--
-- 49. RHN_CFILE_MOD_TRIG  (Trigger) 
--
CREATE OR REPLACE TRIGGER RHN_CFILE_MOD_TRIG
BEFORE INSERT OR UPDATE ON RHNCONFIGFILE
FOR EACH ROW
begin
	:new.modified := sysdate;
end;
/
SHOW ERRORS;


--
-- 50. RHN_NAMESPACE_MOD_TRIG  (Trigger) 
--
CREATE OR REPLACE TRIGGER RHN_NAMESPACE_MOD_TRIG
BEFORE INSERT OR UPDATE ON RHNNAMESPACE
FOR EACH ROW
begin
	:new.modified := sysdate;
end;
/
SHOW ERRORS;


--
-- 51. RHN_PACKAGE_MOD_TRIG  (Trigger) 
--
CREATE OR REPLACE TRIGGER RHN_PACKAGE_MOD_TRIG
BEFORE INSERT OR UPDATE ON RHNPACKAGE
FOR EACH ROW
begin
	if :new.last_modified = :old.last_modified then
		:new.last_modified := sysdate;
	end if;
	:new.modified := sysdate;
end;
/
SHOW ERRORS;


--
-- 52. RHNCONFIGFILENAMESPACE  (Table) 
--
CREATE TABLE RHNCONFIGFILENAMESPACE
(
  NAMESPACE_ID         NUMBER CONSTRAINT RHN_CFNAMESPACE_NID_NN NOT NULL,
  CONFIG_FILE_ID       NUMBER CONSTRAINT RHN_CFNAMESPACE_CFID_NN NOT NULL,
  CONFIG_FILE_NAME_ID  NUMBER CONSTRAINT RHN_CFNAMESPACE_CFNID_NN NOT NULL,
  REVISION             NUMBER CONSTRAINT RHN_CFNAMESPACE_REV_NN NOT NULL,
  LATEST               CHAR(1 BYTE),
  CREATED              DATE                     DEFAULT (sysdate) CONSTRAINT RHN_CFNAMESPACE_CREATED_NN NOT NULL,
  MODIFIED             DATE                     DEFAULT (sysdate) CONSTRAINT RHN_CFNAMESPACE_MODIFIED_NN NOT NULL
)
LOGGING 
NOCACHE
NOPARALLEL;

--
-- 53. DOWNLOAD_TYPE  (Column) 
--
ALTER TABLE RHNDOWNLOADS ADD (DOWNLOAD_TYPE  NUMBER);

--
-- 54. RHNSERVERNAMESPACE  (Table) 
--
CREATE TABLE RHNSERVERNAMESPACE
(
  SERVER_ID     NUMBER CONSTRAINT RHN_SERVERNS_SID_NN NOT NULL,
  NAMESPACE_ID  NUMBER CONSTRAINT RHN_SERVERNS_NID_NN NOT NULL,
  POSITION      NUMBER CONSTRAINT RHN_SERVERNS_POS_NN NOT NULL,
  CREATED       DATE                            DEFAULT (sysdate) CONSTRAINT RHN_SERVERNS_CREATED_NN NOT NULL,
  MODIFIED      DATE                            DEFAULT (sysdate) CONSTRAINT RHN_SERVERNS_MODIFIED_NN NOT NULL
)
LOGGING 
NOCACHE
NOPARALLEL;

--
-- 55. RHN_ACT_EU_EID_AID_IDX  (Index) 
--
CREATE INDEX RHN_ACT_EU_EID_AID_IDX ON RHNACTIONERRATAUPDATE
(ERRATA_ID, ACTION_ID)
LOGGING
NOPARALLEL;

--
-- 56. RHN_CFNAMESPACE_CFID_UQ  (Index) 
--
CREATE UNIQUE INDEX RHN_CFNAMESPACE_CFID_UQ ON RHNCONFIGFILENAMESPACE
(CONFIG_FILE_ID)
LOGGING
NOPARALLEL;

--
-- 57. RHN_CFNAMESPACE_CFNID_NID_R_UQ  (Index) 
--
CREATE UNIQUE INDEX RHN_CFNAMESPACE_CFNID_NID_R_UQ ON RHNCONFIGFILENAMESPACE
(CONFIG_FILE_NAME_ID, NAMESPACE_ID, REVISION)
LOGGING
NOPARALLEL;

--
-- 58. RHN_ERRKWTMP_EID_IDX  (Index) 
--
CREATE INDEX RHN_ERRKWTMP_EID_IDX ON RHNERRATAKEYWORDTMP
(ERRATA_ID)
LOGGING
NOPARALLEL;

--
-- 59. RHN_SERVERNS_SID_NID_POS_IDX  (Index) 
--
CREATE INDEX RHN_SERVERNS_SID_NID_POS_IDX ON RHNSERVERNAMESPACE
(SERVER_ID, NAMESPACE_ID, POSITION)
LOGGING
NOPARALLEL;

--
-- 60. RHN_SNPC_EID_SID_IDX  (Index) 
--
CREATE INDEX RHN_SNPC_EID_SID_IDX ON RHNSERVERNEEDEDPACKAGECACHE
(ERRATA_ID, SERVER_ID)
NOLOGGING
PARALLEL ( DEGREE 6 INSTANCES 1 );

--
-- 61. RHNACTIONOVERVIEW  (View) 
--
CREATE OR REPLACE FORCE VIEW RHNACTIONOVERVIEW
(ORG_ID, ACTION_ID, TYPE_ID, TYPE_NAME, NAME, 
 SCHEDULER, SCHEDULER_LOGIN, EARLIEST_ACTION, TOTAL_COUNT, SUCCESSFUL_COUNT, 
 FAILED_COUNT, IN_PROGRESS_COUNT, ARCHIVED)
AS 
SELECT    A.org_id,
	  A.id,
	  AT.id,
	  AT.name,
	  A.name,
	  A.scheduler,
	  U.login,
	  A.earliest_action,
	  (SELECT COUNT(*) FROM rhnServerAction WHERE action_id = A.id),
	  (SELECT COUNT(*) FROM rhnServerAction WHERE action_id = A.id AND status = 2), -- XXX: don''t hard code status here :)
	  (SELECT COUNT(*) FROM rhnServerAction WHERE action_id = A.id AND status = 3),
	  (SELECT COUNT(*) FROM rhnServerAction WHERE action_id = A.id AND status NOT IN (2, 3)),
	  A.archived
FROM
	  web_contact U,
	  rhnActionType AT,
	  rhnAction A
WHERE	  A.scheduler = U.id(+)
AND	  A.action_type = AT.id
ORDER BY  A.earliest_action;

--
-- 62. RHN_CFNAMESPACE_MOD_TRIG  (Trigger) 
--
CREATE OR REPLACE TRIGGER RHN_CFNAMESPACE_MOD_TRIG
BEFORE INSERT OR UPDATE ON RHNCONFIGFILENAMESPACE
FOR EACH ROW
begin
	:new.modified := sysdate;
end;
/
SHOW ERRORS;


--
-- 63. RHNCHANNELDOWNLOADS  (Table) 
--
CREATE TABLE RHNCHANNELDOWNLOADS
(
  CHANNEL_ID    NUMBER CONSTRAINT RHN_CD_CID_NN NOT NULL,
  DOWNLOADS_ID  NUMBER CONSTRAINT RHN_CD_DID_NN NOT NULL,
  CREATED       DATE                            DEFAULT (sysdate) CONSTRAINT RHN_CD_CREATED_NN NOT NULL,
  MODIFIED      DATE                            DEFAULT (sysdate) CONSTRAINT RHN_CD_MODIFIED_NN NOT NULL
)
LOGGING 
NOCACHE
NOPARALLEL;

--
-- 64. RHN_CD_CE_UQ  (Index) 
--
CREATE UNIQUE INDEX RHN_CD_CE_UQ ON RHNCHANNELDOWNLOADS
(CHANNEL_ID, DOWNLOADS_ID)
LOGGING
NOPARALLEL;

--
-- 65. RHN_CD_DID_CID_IDX  (Index) 
--
CREATE INDEX RHN_CD_DID_CID_IDX ON RHNCHANNELDOWNLOADS
(DOWNLOADS_ID, CHANNEL_ID)
LOGGING
NOPARALLEL;

--
-- 66. RHN_SERVER  (Package) 
--
CREATE OR REPLACE package rhn_server
is
    function can_change_base_channel(server_id_in in number) return number;
end rhn_server;
/

SHOW ERRORS;

--
-- 67. RHNUSERACTIONOVERVIEW  (View) 
--
CREATE OR REPLACE FORCE VIEW RHNUSERACTIONOVERVIEW
(ORG_ID, USER_ID, ID, TYPE_NAME, SCHEDULER, 
 EARLIEST_ACTION, ACTION_NAME, ACTION_STATUS_ID, ACTION_STATUS, TALLY, 
 ARCHIVED)
AS 
select	ao.org_id                                       org_id,
	uspd.user_id                                    user_id,
    	ao.action_id                                    id,
	ao.type_name                                    type_name,
        ao.scheduler                                    scheduler,
	ao.earliest_action                              earliest_action,
	decode(ao.name, null, ao.type_name, ao.name)	action_name,
	sa.status					action_status_id,
	astat.name                                      action_status,
	count(sa.action_id)				tally,
	ao.archived                                     archived
from	rhnActionStatus            astat,
    	rhnUserServerPermsDupes    uspd,
	rhnServerAction            sa,
	rhnActionOverview	   ao
where	ao.action_id = sa.action_id
  and   sa.server_id = uspd.server_id
  and   sa.status = astat.id
group by ao.org_id,
	 uspd.user_id,
	 ao.action_id,
	 ao.type_name,
	 ao.scheduler,
	 ao.earliest_action,
	 decode(ao.name, null, ao.type_name, ao.name),
	 sa.status,
	 astat.name,
	 ao.archived
order by earliest_action;

--
-- 68. RHN_ERRATA_LM_CK  (Constraint) 
--
ALTER TABLE RHNERRATA ADD CONSTRAINT RHN_ERRATA_LM_CK CHECK (locally_modified in ('Y','N'));

--
-- 69. RHN_ERRATA_BUGLIST_ERRATA_FK  (Constraint) 
--
ALTER TABLE RHNERRATABUGLIST DROP CONSTRAINT RHN_ERRATA_BUGLIST_ERRATA_FK;
ALTER TABLE RHNERRATABUGLIST ADD CONSTRAINT RHN_ERRATA_BUGLIST_ERRATA_FK FOREIGN KEY (ERRATA_ID) 
    REFERENCES RHNERRATA (ID)
    ON DELETE CASCADE;

--
-- 70. RHN_ERRATA_CSUM_ERRATA_FK  (Constraint) 
--
ALTER TABLE RHNERRATACHECKSUM DROP CONSTRAINT RHN_ERRATA_CSUM_ERRATA_FK;
ALTER TABLE RHNERRATACHECKSUM ADD CONSTRAINT RHN_ERRATA_CSUM_ERRATA_FK FOREIGN KEY (ERRATA_ID) 
    REFERENCES RHNERRATA (ID)
    ON DELETE CASCADE;

--
-- 71. RHN_ERR_CVE_EID_FK  (Constraint) 
--
ALTER TABLE RHNERRATACVE DROP CONSTRAINT RHN_ERR_CVE_EID_FK;
ALTER TABLE RHNERRATACVE ADD CONSTRAINT RHN_ERR_CVE_EID_FK FOREIGN KEY (ERRATA_ID) 
    REFERENCES RHNERRATA (ID)
    ON DELETE CASCADE;

--
-- 72. RHN_ERRATAFILE_ERRATA_FK  (Constraint) 
--
ALTER TABLE RHNERRATAFILE DROP CONSTRAINT RHN_ERRATAFILE_ERRATA_FK;
ALTER TABLE RHNERRATAFILE ADD CONSTRAINT RHN_ERRATAFILE_ERRATA_FK FOREIGN KEY (ERRATA_ID) 
    REFERENCES RHNERRATA (ID)
    ON DELETE CASCADE;

--
-- 73. RHN_ERR_KEYWORD_EID_FK  (Constraint) 
--
ALTER TABLE RHNERRATAKEYWORD DROP CONSTRAINT RHN_ERR_KEYWORD_EID_FK;
ALTER TABLE RHNERRATAKEYWORD ADD CONSTRAINT RHN_ERR_KEYWORD_EID_FK FOREIGN KEY (ERRATA_ID) 
    REFERENCES RHNERRATA (ID)
    ON DELETE CASCADE;

--
-- 74. RHN_ENQUEUE_EID_FK  (Constraint) 
--
ALTER TABLE RHNERRATANOTIFICATIONQUEUE DROP CONSTRAINT RHN_ENQUEUE_EID_FK;
ALTER TABLE RHNERRATANOTIFICATIONQUEUE ADD CONSTRAINT RHN_ENQUEUE_EID_FK FOREIGN KEY (ERRATA_ID) 
    REFERENCES RHNERRATA (ID)
    ON DELETE CASCADE;

--
-- 75. RHN_EQUEUE_EID_FK  (Constraint) 
--
ALTER TABLE RHNERRATAQUEUE DROP CONSTRAINT RHN_EQUEUE_EID_FK;
ALTER TABLE RHNERRATAQUEUE ADD CONSTRAINT RHN_EQUEUE_EID_FK FOREIGN KEY (ERRATA_ID) 
    REFERENCES RHNERRATA (ID)
    ON DELETE CASCADE;

--
-- 76. RHN_ERRATATMP_LM_CK  (Constraint) 
--
ALTER TABLE RHNERRATATMP ADD CONSTRAINT RHN_ERRATATMP_LM_CK CHECK (locally_modified in ('Y','N'));

--
-- 77. RHN_CE_EID_FK  (Constraint) 
--
ALTER TABLE RHNCHANNELERRATA DROP CONSTRAINT RHN_CE_EID_FK;
ALTER TABLE RHNCHANNELERRATA ADD CONSTRAINT RHN_CE_EID_FK FOREIGN KEY (ERRATA_ID) 
    REFERENCES RHNERRATA (ID)
    ON DELETE CASCADE;

--
-- 78. RHN_DL_DLTYPE_FK  (Constraint) 
--
ALTER TABLE RHNDOWNLOADS ADD CONSTRAINT RHN_DL_DLTYPE_FK FOREIGN KEY (DOWNLOAD_TYPE) 
    REFERENCES RHNDOWNLOADTYPE (ID);

--
-- 79. RHN_ERRATA_BUGLISTTMP_EID_FK  (Constraint) 
--
ALTER TABLE RHNERRATABUGLISTTMP DROP CONSTRAINT RHN_ERRATA_BUGLISTTMP_EID_FK;
ALTER TABLE RHNERRATABUGLISTTMP ADD CONSTRAINT RHN_ERRATA_BUGLISTTMP_EID_FK FOREIGN KEY (ERRATA_ID) 
    REFERENCES RHNERRATATMP (ID)
    ON DELETE CASCADE;

--
-- 80. RHN_ERRATA_CSUMTMP_ERRATA_FK  (Constraint) 
--
ALTER TABLE RHNERRATACHECKSUMTMP DROP CONSTRAINT RHN_ERRATA_CSUMTMP_ERRATA_FK;
ALTER TABLE RHNERRATACHECKSUMTMP ADD CONSTRAINT RHN_ERRATA_CSUMTMP_ERRATA_FK FOREIGN KEY (ERRATA_ID) 
    REFERENCES RHNERRATATMP (ID)
    ON DELETE CASCADE;

--
-- 81. RHN_ERR_CVET_EID_FK  (Constraint) 
--
ALTER TABLE RHNERRATACVETMP DROP CONSTRAINT RHN_ERR_CVET_EID_FK;
ALTER TABLE RHNERRATACVETMP ADD CONSTRAINT RHN_ERR_CVET_EID_FK FOREIGN KEY (ERRATA_ID) 
    REFERENCES RHNERRATATMP (ID)
    ON DELETE CASCADE;

--
-- 82. RHN_ERRATAFILETMP_ERRATA_FK  (Constraint) 
--
ALTER TABLE RHNERRATAFILETMP DROP CONSTRAINT RHN_ERRATAFILETMP_ERRATA_FK;
ALTER TABLE RHNERRATAFILETMP ADD CONSTRAINT RHN_ERRATAFILETMP_ERRATA_FK FOREIGN KEY (ERRATA_ID) 
    REFERENCES RHNERRATATMP (ID)
    ON DELETE CASCADE;

--
-- 83. RHN_ERR_KEYWORDTMP_EID_FK  (Constraint) 
--
ALTER TABLE RHNERRATAKEYWORDTMP DROP CONSTRAINT RHN_ERR_KEYWORDTMP_EID_FK;
ALTER TABLE RHNERRATAKEYWORDTMP ADD CONSTRAINT RHN_ERR_KEYWORDTMP_EID_FK FOREIGN KEY (ERRATA_ID) 
    REFERENCES RHNERRATATMP (ID)
    ON DELETE CASCADE;

--
-- 84. RHN_ERR_PKGTMP_EID_FK  (Constraint) 
--
ALTER TABLE RHNERRATAPACKAGETMP DROP CONSTRAINT RHN_ERR_PKGTMP_EID_FK;
ALTER TABLE RHNERRATAPACKAGETMP ADD CONSTRAINT RHN_ERR_PKGTMP_EID_FK FOREIGN KEY (ERRATA_ID) 
    REFERENCES RHNERRATATMP (ID)
    ON DELETE CASCADE;

--
-- 85. RHN_AT_FTID_FK  (Constraint) 
--
ALTER TABLE RHNACTIONTRANSACTIONS DROP CONSTRAINT RHN_AT_FTID_FK;
ALTER TABLE RHNACTIONTRANSACTIONS ADD CONSTRAINT RHN_AT_FTID_FK FOREIGN KEY (FROM_TRANS_ID) 
    REFERENCES RHNTRANSACTION (ID)
    ON DELETE CASCADE;

--
-- 86. RHN_AT_TTID_FK  (Constraint) 
--
ALTER TABLE RHNACTIONTRANSACTIONS DROP CONSTRAINT RHN_AT_TTID_FK;
ALTER TABLE RHNACTIONTRANSACTIONS ADD CONSTRAINT RHN_AT_TTID_FK FOREIGN KEY (TO_TRANS_ID) 
    REFERENCES RHNTRANSACTION (ID)
    ON DELETE CASCADE;

--
-- 87. RHN_CFNAME_CREATED_NN  (Constraint) 
--
-- ALTER TABLE RHNCONFIGFILENAME ADD CONSTRAINT RHN_CFNAME_CREATED_NN CHECK ("CREATED" IS NOT NULL);

--
-- 88. RHN_CFNAME_ID_NN  (Constraint) 
--
-- ALTER TABLE RHNCONFIGFILENAME ADD CONSTRAINT RHN_CFNAME_ID_NN CHECK ("ID" IS NOT NULL);

--
-- 89. RHN_CFNAME_MODIFIED_NN  (Constraint) 
--
-- ALTER TABLE RHNCONFIGFILENAME ADD CONSTRAINT RHN_CFNAME_MODIFIED_NN CHECK ("MODIFIED" IS NOT NULL);

--
-- 90. RHN_CFNAME_PATH_NN  (Constraint) 
--
-- ALTER TABLE RHNCONFIGFILENAME ADD CONSTRAINT RHN_CFNAME_PATH_NN CHECK ("PATH" IS NOT NULL);

--
-- 91. RHN_CFNAME_ID_PK  (Constraint) 
--
ALTER TABLE RHNCONFIGFILENAME ADD CONSTRAINT RHN_CFNAME_ID_PK PRIMARY KEY (ID);

--
-- 92. RHN_DOWNLOAD_TYPE_ID_NN  (Constraint) 
--
-- ALTER TABLE RHNDOWNLOADTYPE ADD CONSTRAINT RHN_DOWNLOAD_TYPE_ID_NN CHECK ("ID" IS NOT NULL);

--
-- 93. RHN_DOWNLOAD_TYPE_LABEL_NN  (Constraint) 
--
-- ALTER TABLE RHNDOWNLOADTYPE ADD CONSTRAINT RHN_DOWNLOAD_TYPE_LABEL_NN CHECK ("LABEL" IS NOT NULL);

--
-- 94. RHN_DOWNLOAD_TYPE_NAME_NN  (Constraint) 
--
-- ALTER TABLE RHNDOWNLOADTYPE ADD CONSTRAINT RHN_DOWNLOAD_TYPE_NAME_NN CHECK ("NAME" IS NOT NULL);

--
-- 96. RHN_CFILE_CONTENTS_NN  (Constraint) 
--
-- ALTER TABLE RHNCONFIGFILE ADD CONSTRAINT RHN_CFILE_CONTENTS_NN CHECK ("CONTENTS" IS NOT NULL);

--
-- 97. RHN_CFILE_CREATED_NN  (Constraint) 
--
-- ALTER TABLE RHNCONFIGFILE ADD CONSTRAINT RHN_CFILE_CREATED_NN CHECK ("CREATED" IS NOT NULL);

--
-- 98. RHN_CFILE_ID_NN  (Constraint) 
--
-- ALTER TABLE RHNCONFIGFILE ADD CONSTRAINT RHN_CFILE_ID_NN CHECK ("ID" IS NOT NULL);

--
-- 99. RHN_CFILE_MD5SUM_NN  (Constraint) 
--
-- ALTER TABLE RHNCONFIGFILE ADD CONSTRAINT RHN_CFILE_MD5SUM_NN CHECK ("MD5SUM" IS NOT NULL);

--
-- 100. RHN_CFILE_MODIFIED_NN  (Constraint) 
--
-- ALTER TABLE RHNCONFIGFILE ADD CONSTRAINT RHN_CFILE_MODIFIED_NN CHECK ("MODIFIED" IS NOT NULL);

--
-- 101. RHN_CFILE_OID_NN  (Constraint) 
--
-- ALTER TABLE RHNCONFIGFILE ADD CONSTRAINT RHN_CFILE_OID_NN CHECK ("ORG_ID" IS NOT NULL);

--
-- 102. RHN_CFILE_ID_PK  (Constraint) 
--
ALTER TABLE RHNCONFIGFILE ADD CONSTRAINT RHN_CFILE_ID_PK PRIMARY KEY (ID);

--
-- 103. RHN_CFILE_OID_FK  (Constraint) 
--
ALTER TABLE RHNCONFIGFILE ADD CONSTRAINT RHN_CFILE_OID_FK FOREIGN KEY (ORG_ID) 
    REFERENCES WEB_CUSTOMER (ID);

--
-- 104. RHN_NAMESPACE_CREATED_NN  (Constraint) 
--
-- ALTER TABLE RHNNAMESPACE ADD CONSTRAINT RHN_NAMESPACE_CREATED_NN CHECK ("CREATED" IS NOT NULL);

--
-- 105. RHN_NAMESPACE_DESC_NN  (Constraint) 
--
-- ALTER TABLE RHNNAMESPACE ADD CONSTRAINT RHN_NAMESPACE_DESC_NN CHECK ("DESCRIPTION" IS NOT NULL);

--
-- 106. RHN_NAMESPACE_ID_NN  (Constraint) 
--
-- ALTER TABLE RHNNAMESPACE ADD CONSTRAINT RHN_NAMESPACE_ID_NN CHECK ("ID" IS NOT NULL);

--
-- 107. RHN_NAMESPACE_MODIFIED_NN  (Constraint) 
--
-- ALTER TABLE RHNNAMESPACE ADD CONSTRAINT RHN_NAMESPACE_MODIFIED_NN CHECK ("MODIFIED" IS NOT NULL);

--
-- 108. RHN_NAMESPACE_NAME_NN  (Constraint) 
--
-- ALTER TABLE RHNNAMESPACE ADD CONSTRAINT RHN_NAMESPACE_NAME_NN CHECK ("NAME" IS NOT NULL);

--
-- 109. RHN_NAMESPACE_OID_NN  (Constraint) 
--
-- ALTER TABLE RHNNAMESPACE ADD CONSTRAINT RHN_NAMESPACE_OID_NN CHECK ("ORG_ID" IS NOT NULL);

--
-- 110. RHN_NAMESPACE_ID_PK  (Constraint) 
--
ALTER TABLE RHNNAMESPACE ADD CONSTRAINT RHN_NAMESPACE_ID_PK PRIMARY KEY (ID);

--
-- 111. RHN_NAMESPACE_OID_FK  (Constraint) 
--
ALTER TABLE RHNNAMESPACE ADD CONSTRAINT RHN_NAMESPACE_OID_FK FOREIGN KEY (ORG_ID) 
    REFERENCES WEB_CUSTOMER (ID);

--
-- 112. RHN_CFNAMESPACE_CFID_NN  (Constraint) 
--
-- ALTER TABLE RHNCONFIGFILENAMESPACE ADD CONSTRAINT RHN_CFNAMESPACE_CFID_NN CHECK ("CONFIG_FILE_ID" IS NOT NULL);

--
-- 113. RHN_CFNAMESPACE_CFNID_NN  (Constraint) 
--
-- ALTER TABLE RHNCONFIGFILENAMESPACE ADD CONSTRAINT RHN_CFNAMESPACE_CFNID_NN CHECK ("CONFIG_FILE_NAME_ID" IS NOT NULL);

--
-- 114. RHN_CFNAMESPACE_CREATED_NN  (Constraint) 
--
-- ALTER TABLE RHNCONFIGFILENAMESPACE ADD CONSTRAINT RHN_CFNAMESPACE_CREATED_NN CHECK ("CREATED" IS NOT NULL);

--
-- 115. RHN_CFNAMESPACE_LATEST_CK  (Constraint) 
--
ALTER TABLE RHNCONFIGFILENAMESPACE ADD CONSTRAINT RHN_CFNAMESPACE_LATEST_CK CHECK (latest = 'Y');

--
-- 116. RHN_CFNAMESPACE_MODIFIED_NN  (Constraint) 
--
-- ALTER TABLE RHNCONFIGFILENAMESPACE ADD CONSTRAINT RHN_CFNAMESPACE_MODIFIED_NN CHECK ("MODIFIED" IS NOT NULL);

--
-- 117. RHN_CFNAMESPACE_NID_NN  (Constraint) 
--
-- ALTER TABLE RHNCONFIGFILENAMESPACE ADD CONSTRAINT RHN_CFNAMESPACE_NID_NN CHECK ("NAMESPACE_ID" IS NOT NULL);

--
-- 118. RHN_CFNAMESPACE_REV_NN  (Constraint) 
--
-- ALTER TABLE RHNCONFIGFILENAMESPACE ADD CONSTRAINT RHN_CFNAMESPACE_REV_NN CHECK ("REVISION" IS NOT NULL);

--
-- 119. RHN_CFNAMESPACE_CFID_FK  (Constraint) 
--
ALTER TABLE RHNCONFIGFILENAMESPACE ADD CONSTRAINT RHN_CFNAMESPACE_CFID_FK FOREIGN KEY (CONFIG_FILE_ID) 
    REFERENCES RHNCONFIGFILE (ID)
    ON DELETE CASCADE;

--
-- 120. RHN_CFNAMESPACE_CFNID_FK  (Constraint) 
--
ALTER TABLE RHNCONFIGFILENAMESPACE ADD CONSTRAINT RHN_CFNAMESPACE_CFNID_FK FOREIGN KEY (CONFIG_FILE_NAME_ID) 
    REFERENCES RHNCONFIGFILENAME (ID);

--
-- 121. RHN_CFNAMESPACE_NID_FK  (Constraint) 
--
ALTER TABLE RHNCONFIGFILENAMESPACE ADD CONSTRAINT RHN_CFNAMESPACE_NID_FK FOREIGN KEY (NAMESPACE_ID) 
    REFERENCES RHNNAMESPACE (ID);

--
-- 122. RHN_SERVERNS_CREATED_NN  (Constraint) 
--
-- ALTER TABLE RHNSERVERNAMESPACE ADD CONSTRAINT RHN_SERVERNS_CREATED_NN CHECK ("CREATED" IS NOT NULL);

--
-- 123. RHN_SERVERNS_MODIFIED_NN  (Constraint) 
--
-- ALTER TABLE RHNSERVERNAMESPACE ADD CONSTRAINT RHN_SERVERNS_MODIFIED_NN CHECK ("MODIFIED" IS NOT NULL);

--
-- 124. RHN_SERVERNS_NID_NN  (Constraint) 
--
-- ALTER TABLE RHNSERVERNAMESPACE ADD CONSTRAINT RHN_SERVERNS_NID_NN CHECK ("NAMESPACE_ID" IS NOT NULL);

--
-- 125. RHN_SERVERNS_POS_NN  (Constraint) 
--
-- ALTER TABLE RHNSERVERNAMESPACE ADD CONSTRAINT RHN_SERVERNS_POS_NN CHECK ("POSITION" IS NOT NULL);

--
-- 126. RHN_SERVERNS_SID_NN  (Constraint) 
--
-- ALTER TABLE RHNSERVERNAMESPACE ADD CONSTRAINT RHN_SERVERNS_SID_NN CHECK ("SERVER_ID" IS NOT NULL);

--
-- 127. RHN_SERVERNS_SID_NID_UQ  (Constraint) 
--
ALTER TABLE RHNSERVERNAMESPACE ADD CONSTRAINT RHN_SERVERNS_SID_NID_UQ UNIQUE (SERVER_ID, NAMESPACE_ID);

--
-- 128. RHN_SERVERNS_NID_FK  (Constraint) 
--
ALTER TABLE RHNSERVERNAMESPACE ADD CONSTRAINT RHN_SERVERNS_NID_FK FOREIGN KEY (NAMESPACE_ID) 
    REFERENCES RHNNAMESPACE (ID);

--
-- 129. RHN_SERVERNS_SID_FK  (Constraint) 
--
ALTER TABLE RHNSERVERNAMESPACE ADD CONSTRAINT RHN_SERVERNS_SID_FK FOREIGN KEY (SERVER_ID) 
    REFERENCES RHNSERVER (ID)
    ON DELETE CASCADE;

--
-- 130. RHN_CD_CID_NN  (Constraint) 
--
-- ALTER TABLE RHNCHANNELDOWNLOADS ADD CONSTRAINT RHN_CD_CID_NN CHECK ("CHANNEL_ID" IS NOT NULL);

--
-- 131. RHN_CD_CREATED_NN  (Constraint) 
--
-- ALTER TABLE RHNCHANNELDOWNLOADS ADD CONSTRAINT RHN_CD_CREATED_NN CHECK ("CREATED" IS NOT NULL);

--
-- 132. RHN_CD_DID_NN  (Constraint) 
--
-- ALTER TABLE RHNCHANNELDOWNLOADS ADD CONSTRAINT RHN_CD_DID_NN CHECK ("DOWNLOADS_ID" IS NOT NULL);

--
-- 133. RHN_CD_MODIFIED_NN  (Constraint) 
--
-- ALTER TABLE RHNCHANNELDOWNLOADS ADD CONSTRAINT RHN_CD_MODIFIED_NN CHECK ("MODIFIED" IS NOT NULL);

--
-- 134. RHN_CD_CID_FK  (Constraint) 
--
ALTER TABLE RHNCHANNELDOWNLOADS ADD CONSTRAINT RHN_CD_CID_FK FOREIGN KEY (CHANNEL_ID) 
    REFERENCES RHNCHANNEL (ID)
    ON DELETE CASCADE;

--
-- 135. RHN_CD_DID_FK  (Constraint) 
--
ALTER TABLE RHNCHANNELDOWNLOADS ADD CONSTRAINT RHN_CD_DID_FK FOREIGN KEY (DOWNLOADS_ID) 
    REFERENCES RHNDOWNLOADS (ID);

CREATE OR REPLACE PACKAGE rpm AS
    FUNCTION vercmp(
        e1 VARCHAR2, v1 VARCHAR2, r1 VARCHAR2, 
        e2 VARCHAR2, v2 VARCHAR2, r2 VARCHAR2)
    RETURN NUMBER
        DETERMINISTIC
        PARALLEL_ENABLE;
    PRAGMA RESTRICT_REFERENCES(vercmp, WNDS, RNDS);

    FUNCTION vercmpCounter
    return NUMBER
        DETERMINISTIC
        PARALLEL_ENABLE;
    PRAGMA RESTRICT_REFERENCES(vercmpCounter, WNDS, RNDS);

    FUNCTION vercmpResetCounter
    return NUMBER
        DETERMINISTIC
        PARALLEL_ENABLE;
    PRAGMA RESTRICT_REFERENCES(vercmpResetCounter, WNDS, RNDS);
    
END rpm;
/
SHOW ERRORS;

CREATE OR REPLACE PACKAGE BODY rpm AS
    vercmp_counter NUMBER := 0;

    FUNCTION isdigit(ch CHAR)
    RETURN BOOLEAN
    IS
    BEGIN
        if ascii(ch) between ascii('0') and ascii('9')
        then
            return TRUE;
        end if;
        return FALSE;
    END isdigit;

    
    FUNCTION isalpha(ch CHAR)
    RETURN BOOLEAN
    IS
    BEGIN
        if ascii(ch) between ascii('a') and ascii('z') or 
            ascii(ch) between ascii('A') and ascii('Z')
        then
            return TRUE;
        end if;
        return FALSE;
    END isalpha;


    FUNCTION isalphanum(ch CHAR)
    RETURN BOOLEAN
    IS
    BEGIN
        if ascii(ch) between ascii('a') and ascii('z') or 
            ascii(ch) between ascii('A') and ascii('Z') or
            ascii(ch) between ascii('0') and ascii('9')
        then
            return TRUE;
        end if;
        return FALSE;
    END isalphanum;


    FUNCTION rpmstrcmp (string1 IN VARCHAR2, string2 IN VARCHAR2)
    RETURN NUMBER
    IS
        digits CHAR(10) := '0123456789';
        lc_alpha CHAR(27) := 'abcdefghijklmnopqrstuvwxyz';
        uc_alpha CHAR(27) := 'ABCDEFGHIJKLMNOPQRSTUVWXYZ';
        alpha CHAR(54) := lc_alpha || uc_alpha;
        str1 VARCHAR2(32767) := string1;
        str2 VARCHAR2(32767) := string2;
        one VARCHAR2(32767);
        two VARCHAR2(32767);
        isnum BOOLEAN;
    BEGIN
        if str1 is NULL or str2 is NULL
        then
            raise VALUE_ERROR;
        end if;
        -- easy comparison to see if versions are identical
        if str1 = str2
        then
            return 0;
        end if;
        -- loop through each version segment of str1 and str2 and compare them
        one := str1;
        two := str2;

        <<segment_loop>>
        while one is not null and two is not null
        loop
            declare
                segm1 VARCHAR2(32767);
                segm2 VARCHAR2(32767);
            begin
                --DBMS_OUTPUT.PUT_LINE('Params: ' || one || ',' || two);
                -- Throw out all non-alphanum characters
                while one is not null and not isalphanum(one)
                loop
                    one := substr(one, 2);
                end loop;
                while two is not null and not isalphanum(two)
                loop
                    two := substr(two, 2);
                end loop;
                --DBMS_OUTPUT.PUT_LINE('new params: ' || one || ',' || two);

                str1 := one;
                str2 := two;

                /* grab first completely alpha or completely numeric segment */
                /* leave one and two pointing to the start of the alpha or numeric */
                /* segment and walk str1 and str2 to end of segment */
                
                if str1 is not null and isdigit(str1)
                then
                    str1 := ltrim(str1, digits);
                    str2 := ltrim(str2, digits);
                    isnum := true;
                else
                    str1 := ltrim(str1, alpha);
                    str2 := ltrim(str2, alpha);
                    isnum := false;
                end if;

                --DBMS_OUTPUT.PUT_LINE('Len: ' || length(str1) || ',' || length(str2));
                -- Oracle trats the length of an empty string as null
                if str1 is not null
                then segm1 := substr(one, 1, length(one) - length(str1));
                else segm1 := one;
                end if;
                    
                if str2 is not null
                then segm2 := substr(two, 1, length(two) - length(str2));
                else segm2 := two;
                end if;

                --DBMS_OUTPUT.PUT_LINE('Segments: ' || segm1 || ',' || segm2);
                --DBMS_OUTPUT.PUT_LINE('Rest: ' || str1 || ',' || str2);
                /* take care of the case where the two version segments are */
                /* different types: one numeric and one alpha */
                if segm1 is null then return -1; end if; /* arbitrary */
                if segm2 is null then
					if isnum then
						return 1;
					else
						return -1;
					end if;
				end if;

                if isnum
                then
                    /* this used to be done by converting the digit segments */
                    /* to ints using atoi() - it's changed because long */
                    /* digit segments can overflow an int - this should fix that. */

                    /* throw away any leading zeros - it's a number, right? */
                    segm1 := ltrim(segm1, '0');
                    segm2 := ltrim(segm2, '0');

                    /* whichever number has more digits wins */
                    -- length of empty string is null
                    if segm1 is null and segm2 is not null
                    then
                        return -1;
                    end if;
                    if segm1 is not null and segm2 is null
                    then
                        return 1;
                    end if;
                    if length(segm1) > length(segm2) then return 1; end if;
                    if length(segm2) > length(segm1) then return -1; end if;
                end if;
                
                /* strcmp will return which one is greater - even if the two */
                /* segments are alpha or if they are numeric.  don't return  */
                /* if they are equal because there might be more segments to */
                /* compare */
                
                if segm1 < segm2 then return -1; end if;
                if segm1 > segm2 then return 1; end if;

                one := str1;
                two := str2;
            end;
        end loop segment_loop;
        /* this catches the case where all numeric and alpha segments have */
        /* compared identically but the segment sepparating characters were */
        /* different */
        if one is null and two is null then return 0; end if;

        /* whichever version still has characters left over wins */
        if one is null then return -1; end if;
        return 1;
    END rpmstrcmp;


    FUNCTION vercmp(
        e1 VARCHAR2, v1 VARCHAR2, r1 VARCHAR2, 
        e2 VARCHAR2, v2 VARCHAR2, r2 VARCHAR2)
    RETURN NUMBER
    IS
        rc NUMBER;
    BEGIN
        vercmp_counter := vercmp_counter + 1;
        if e1 is not null and e2 is null then return 1; end if;
        if e1 is null and e2 is not null then return -1; end if;
        if e1 is not null and e2 is not null
        then
            DECLARE
                ep1 NUMBER;
                ep2 NUMBER;
            BEGIN
                -- Epochs are non-null; compare them
                ep1 := TO_NUMBER(e1);
                ep2 := TO_NUMBER(e2);
                if ep1 < ep2 then return -1; end if;
                if ep1 > ep2 then return 1; end if;
                -- Epoch is identical; fall through
            END;
        end if;
        rc := rpmstrcmp(v1, v2);
        if rc != 0 then return rc; end if;
        return rpmstrcmp(r1, r2);

    END vercmp;

    FUNCTION vercmpCounter
    RETURN NUMBER
    IS
    BEGIN
        return vercmp_counter;
    END vercmpCounter;

    FUNCTION vercmpResetCounter
    RETURN NUMBER
    IS
        result NUMBER;
    BEGIN
        result := vercmp_counter;
        vercmp_counter := 0;
        return result;
    END vercmpResetCounter;
END rpm;
/
SHOW ERRORS;

alter function rhnhistoryview_erratalist compile;
alter package rhn_entitlements compile;
alter package rhn_server compile;
alter procedure delete_server_bulk compile;
alter procedure delete_server compile;
alter trigger rhn_errata_mod_trig compile;
alter trigger rhn_download_mod_trig compile;
alter trigger rhn_erratatmp_mod_trig compile;


update rhnVersionInfo set evr_id = lookup_evr('','2.7','7.1')
	where label = 'schema'
	and name_id = lookup_package_name('rhn-satellite-schema');
commit;

INSERT
  INTO rhnEmailAddress
       (id, address, user_id, state_id, next_action, created, modified)
 SELECT rhn_eaddress_id_seq.nextval, WUPI.email, WUPI.web_user_id, EAS.id,
	        NULL, sysdate, sysdate
          FROM web_user_personal_info WUPI, rhnEmailAddressState EAS
	 WHERE EAS.label = 'verified'
           AND NOT EXISTS (SELECT 1
                             FROM rhnEmailAddress EA
                            WHERE EA.user_id = WUPI.web_user_id
                              AND EA.state_id = EAS.id
                          );
quit;
