spool satellite-db-1.1-to-2.0-72.log

insert into rhnException values (-20239, 'arch_not_found','Architecture could not be found');
 
CREATE OR REPLACE FUNCTION
LOOKUP_ARCH(name_in IN VARCHAR2)
RETURN NUMBER
DETERMINISTIC
IS
        PRAGMA AUTONOMOUS_TRANSACTION;
        name_id         NUMBER;
BEGIN
        SELECT id
          INTO name_id
          FROM rhnArch
         WHERE name = name_in;
 
        RETURN name_id;
EXCEPTION
        WHEN NO_DATA_FOUND THEN
		rhn_exception.raise_exception('arch_not_found');
END;
/

begin
	insert into rhnArch (id, family, name, generation)
		values (16, 42, 'ppc', 1);
exception
	when others then null;
end;
/
begin
	insert into rhnArch (id, family, name, generation)
		values (19, 42, 'iSeries', 1);
exception
	when others then null;
end;
/

commit;

update rhnchannel set arch = LOOKUP_ARCH('iSeries') WHERE arch = LOOKUP_ARCH('ppc');

drop function lookup_arch;

insert into rhnUserGroupType (id, label, name) values (
	rhn_usergroup_type_seq.nextval,
	'rhn_support',
	'Red Hat Network Support Admin'
);

insert into rhnException values (-20240, 'channel_consent_no_license','No license agreement exists for that channel');
insert into rhnException values (-20241, 'channel_subscrib_no_consent','Channel requires consent to license for subscription');
 
insert into rhnException values (-20242, 'channel_arch_not_found','Channel architecture could not be found');
insert into rhnException values (-20243, 'package_arch_not_found','Package architecture could not be found');
insert into rhnException values (-20244, 'server_arch_not_found','Server architecture could not be found');
insert into rhnException values (-20245, 'cpu_arch_not_found','CPU architecture could not be found');
 
insert into rhnException values (-20246, 'channel_unsubscribe_child_exists','Unsubscribe failed because server is subscribed to child channels');
 
insert into rhnException values (-20247, 'null_email_address','A user must have either a pending or a validated email address');
 
insert into rhnException values (-20248, 'invalid_item_code','The specified item does not exist');
insert into rhnException values (-20249, 'invalid_server_group','The specified server group does not exist');
insert into rhnException values (-20250, 'invalid_channel_family','The specified channel family does not exist');
insert into rhnException values (-20251, 'invalid_state','The specified state does not exist');
insert into rhnException values (-20253, 'invalid_state_transition','The specified transition is not allowed');
insert into rhnException values (-20254, 'ep_error','Entitlement Proxy error');
insert into rhnException values (-20255, 'cannot_delete_user','The specified user may not be deleted.');
insert into rhnException values (-20256, 'no_channel_product','No products were found to entitle this channel');
insert into rhnException values (-20257, 'no_server_multiple_swmgr_entitlements','Server is already entitled');
insert into rhnException values (-20258, 'erratafile_type_not_found','No such errata file type exists');

-- Red Hat Linux Advanced Workstation 2.1 ia64
insert into rhnBeehivePathMap (path, beehive_path, ftp_path) values
   ('2.1AW/en/os/ia64',
    'beehive/updates/dist/2.1AW/ia64',
    'rhn/updates/2.1AW/en/os/ia64');
insert into rhnBeehivePathMap (path, beehive_path, ftp_path) values
   ('2.1AW/en/os/noarch',
    'beehive/updates/dist/2.1AW/noarch',
    'rhn/updates/2.1AW/en/os/noarch');
insert into rhnBeehivePathMap (path, beehive_path, ftp_path) values
   ('2.1AW/en/os/SRPMS',
    'beehive/updates/dist/2.1AW/SRPMS',
    'rhn/updates/2.1AW/en/os/SRPMS');

-- 2.1ES
insert into rhnBeehivePathMap (path, beehive_path, ftp_path) values
   ('2.1ES/en/os/noarch',
    'beehive/updates/dist/2.1ES/noarch',
    'rhn/updates/2.1ES/en/os/noarch');
insert into rhnBeehivePathMap (path, beehive_path, ftp_path) values
   ('2.1ES/en/os/athlon',
    'beehive/updates/dist/2.1ES/athlon',
    'rhn/updates/2.1ES/en/os/athlon');
insert into rhnBeehivePathMap (path, beehive_path, ftp_path) values
   ('2.1ES/en/os/i386',
    'beehive/updates/dist/2.1ES/i386',
    'rhn/updates/2.1ES/en/os/i386');
insert into rhnBeehivePathMap (path, beehive_path, ftp_path) values
   ('2.1ES/en/os/i686',
    'beehive/updates/dist/2.1ES/i686',
    'rhn/updates/2.1ES/en/os/i686');
insert into rhnBeehivePathMap (path, beehive_path, ftp_path) values
   ('2.1ES/en/os/SRPMS',
    'beehive/updates/dist/2.1ES/SRPMS',
    'rhn/updates/2.1ES/en/os/SRPMS');

-- 2.1WS
insert into rhnBeehivePathMap (path, beehive_path, ftp_path) values
   ('2.1WS/en/os/noarch',
    'beehive/updates/dist/2.1WS/noarch',
    'rhn/updates/2.1WS/en/os/noarch');
insert into rhnBeehivePathMap (path, beehive_path, ftp_path) values
   ('2.1WS/en/os/athlon',
    'beehive/updates/dist/2.1WS/athlon',
    'rhn/updates/2.1WS/en/os/athlon');
insert into rhnBeehivePathMap (path, beehive_path, ftp_path) values
   ('2.1WS/en/os/i386',
    'beehive/updates/dist/2.1WS/i386',
    'rhn/updates/2.1WS/en/os/i386');
insert into rhnBeehivePathMap (path, beehive_path, ftp_path) values
   ('2.1WS/en/os/i686',
    'beehive/updates/dist/2.1WS/i686',
    'rhn/updates/2.1WS/en/os/i686');
insert into rhnBeehivePathMap (path, beehive_path, ftp_path) values
   ('2.1WS/en/os/SRPMS',
    'beehive/updates/dist/2.1WS/SRPMS',
    'rhn/updates/2.1WS/en/os/SRPMS');

-- Stronghold
-- enterprise no longer used as prefix, the following three ones are
--deprecated
insert into rhnBeehivePathMap (path, beehive_path, ftp_path) values
   ('enterprise/2.1AS/en/SH4.0/noarch',
   'beehive/updates/stronghold/2.1AS/noarch',
   'rhn/updates/stronghold/2.1AS/noarch');
insert into rhnBeehivePathMap (path, beehive_path, ftp_path) values
   ('enterprise/2.1AS/en/SH4.0/i386',
   'beehive/updates/stronghold/2.1AS/i386',
   'rhn/updates/stronghold/2.1AS/i386');
insert into rhnBeehivePathMap (path, beehive_path, ftp_path) values
   ('enterprise/2.1AS/en/SH4.0/SRPMS',
   'beehive/updates/stronghold/2.1AS/SRPMS',
   'rhn/updates/stronghold/2.1AS/SRPMS');
-- The right mappings for stronghold
insert into rhnBeehivePathMap (path, beehive_path, ftp_path) values
   ('2.1AS/en/SH4.0/noarch',
   'beehive/updates/stronghold/2.1AS/noarch',
   'rhn/updates/stronghold/2.1AS/noarch');
insert into rhnBeehivePathMap (path, beehive_path, ftp_path) values
   ('2.1AS/en/SH4.0/i386',
   'beehive/updates/stronghold/2.1AS/i386',
   'rhn/updates/stronghold/2.1AS/i386');
insert into rhnBeehivePathMap (path, beehive_path, ftp_path) values
   ('2.1AS/en/SH4.0/SRPMS',
   'beehive/updates/stronghold/2.1AS/SRPMS',
   'rhn/updates/stronghold/2.1AS/SRPMS');

-- Red Hat 8.0 i386
insert into rhnBeehivePathMap (path, beehive_path, ftp_path) values
   ('8.0/en/os/noarch',
    'beehive/updates/dist/8.0/noarch',
    'redhat/linux/updates/8.0/en/os/noarch');

insert into rhnBeehivePathMap (path, beehive_path, ftp_path) values
   ('8.0/en/os/i386',
    'beehive/updates/dist/8.0/i386',
    'redhat/linux/updates/8.0/en/os/i386');

insert into rhnBeehivePathMap (path, beehive_path, ftp_path) values
   ('8.0/en/os/i586',
    'beehive/updates/dist/8.0/i586',
    'redhat/linux/updates/8.0/en/os/i586');

insert into rhnBeehivePathMap (path, beehive_path, ftp_path) values
   ('8.0/en/os/i686',
    'beehive/updates/dist/8.0/i686',
    'redhat/linux/updates/8.0/en/os/i686');

insert into rhnBeehivePathMap (path, beehive_path, ftp_path) values
   ('8.0/en/os/athlon',
    'beehive/updates/dist/8.0/athlon',
    'redhat/linux/updates/8.0/en/os/athlon');

insert into rhnBeehivePathMap (path, beehive_path, ftp_path) values
   ('8.0/en/os/SRPMS',
    'beehive/updates/dist/8.0/SRPMS',
    'redhat/linux/updates/8.0/en/os/SRPMS');

-- Red Hat 9 i386
insert into rhnBeehivePathMap (path, beehive_path, ftp_path) values
   ('9/en/os/noarch',
    'beehive/updates/dist/9/noarch',
    'redhat/linux/updates/9/en/os/noarch');

insert into rhnBeehivePathMap (path, beehive_path, ftp_path) values
   ('9/en/os/i386',
    'beehive/updates/dist/9/i386',
    'redhat/linux/updates/9/en/os/i386');

insert into rhnBeehivePathMap (path, beehive_path, ftp_path) values
   ('9/en/os/i586',
    'beehive/updates/dist/9/i586',
    'redhat/linux/updates/9/en/os/i586');

insert into rhnBeehivePathMap (path, beehive_path, ftp_path) values
   ('9/en/os/i686',
    'beehive/updates/dist/9/i686',
    'redhat/linux/updates/9/en/os/i686');

insert into rhnBeehivePathMap (path, beehive_path, ftp_path) values
   ('9/en/os/athlon',
    'beehive/updates/dist/9/athlon',
    'redhat/linux/updates/9/en/os/athlon');

insert into rhnBeehivePathMap (path, beehive_path, ftp_path) values
   ('9/en/os/SRPMS',
    'beehive/updates/dist/9/SRPMS',
    'redhat/linux/updates/9/en/os/SRPMS');


insert into rhnActionType values (9, 'reboot.reboot', 'System reboot');

insert into rhnActionType values (10, 'rollback.config', 'Enable or Disable RPM Transaction Rollback');
insert into rhnActionType values (11, 'rollback.listTransactions', 'Refresh server-side transaction list');
insert into rhnActionType values (12, 'rollback.rollback', 'RPM Transaction Rollback');
insert into rhnActionType values (13, 'packages.autoupdate', 'Automatic package installation');

commit;



alter table rhnServerProfilePackage drop constraint rhn_sprofile_spid_fk;
alter table rhnServerProfile drop constraint rhn_server_profile_id_pk;

alter table RHNPACKAGECONFLICTS drop constraint RHN_PKG_CONFLICTS_CAP_FK;
alter table RHNPACKAGEFILE drop constraint RHN_PACKAGE_FILE_CID_FK;
alter table RHNPACKAGEOBSOLETES drop constraint RHN_PKG_OBSOLETES_CAP_FK;
alter table RHNPACKAGEPROVIDES drop constraint RHN_PKG_PROVIDES_CAPABILITY_FK;
alter table RHNPACKAGEREQUIRES drop constraint RHN_PKG_REQUIRES_CAPABILITY_FK;


--
-- 95. RHNFAQCLASS  (Table) 
--
CREATE TABLE RHNFAQCLASS
(
  ID        NUMBER,
  NAME      VARCHAR2(128),
  LABEL     VARCHAR2(32),
  ORDERING  NUMBER
)
LOGGING 
NOCACHE
NOPARALLEL;

--
-- 134. RHN_FAQCLASS_LABEL_UQ  (Index) 
--
CREATE UNIQUE INDEX RHN_FAQCLASS_LABEL_UQ ON RHNFAQCLASS
(LABEL)
LOGGING
NOPARALLEL;

--
-- 135. RHN_FAQCLASS_OR_UQ  (Index) 
--
CREATE UNIQUE INDEX RHN_FAQCLASS_OR_UQ ON RHNFAQCLASS
(ORDERING)
LOGGING
NOPARALLEL;

--
-- 136. RHN_FAQ_CLASS_ID_PK  (Index) 
--
CREATE UNIQUE INDEX RHN_FAQ_CLASS_ID_PK ON RHNFAQCLASS
(ID)
LOGGING
NOPARALLEL;

--
-- 572. RHN_FAQ_CLASS_ID_NN  (Constraint) 
--
ALTER TABLE RHNFAQCLASS ADD CONSTRAINT RHN_FAQ_CLASS_ID_NN CHECK ("ID" IS NOT NULL);

--
-- 573. RHN_FAQ_CLASS_LABEL_NN  (Constraint) 
--
ALTER TABLE RHNFAQCLASS ADD CONSTRAINT RHN_FAQ_CLASS_LABEL_NN CHECK ("LABEL" IS NOT NULL);

--
-- 574. RHN_FAQ_CLASS_OR_NN  (Constraint) 
--
ALTER TABLE RHNFAQCLASS ADD CONSTRAINT RHN_FAQ_CLASS_OR_NN CHECK ("ORDERING" IS NOT NULL);

--
-- 575. RHN_FAQ_CLASS_ID_PK  (Constraint) 
--
ALTER TABLE RHNFAQCLASS ADD CONSTRAINT RHN_FAQ_CLASS_ID_PK PRIMARY KEY (ID);

CREATE TABLE RHNFAQ
(
  ID           NUMBER,
  CLASS_ID     NUMBER,
  SUBJECT      VARCHAR2(200),
  DETAILS      VARCHAR2(4000),
  PRIVATE      NUMBER                           DEFAULT (0),
  USAGE_COUNT  NUMBER                           DEFAULT (0),
  CREATED      DATE                             DEFAULT (sysdate),
  MODIFIED     DATE                             DEFAULT (sysdate)
)
LOGGING 
NOCACHE
NOPARALLEL;
CREATE UNIQUE INDEX RHN_FAQ_ID_PK ON RHNFAQ
(ID)
LOGGING
NOPARALLEL;
CREATE OR REPLACE TRIGGER RHN_FAQ_MOD_TRIG
BEFORE INSERT OR UPDATE ON RHNFAQ
FOR EACH ROW
begin
        :new.modified := sysdate;
end;
/
SHOW ERRORS;

ALTER TABLE RHNFAQ ADD CONSTRAINT RHN_FAQ_CREATED_NN CHECK ("CREATED" IS NOT NULL);

--
-- 802. RHN_FAQ_ID_NN  (Constraint) 
--
ALTER TABLE RHNFAQ ADD CONSTRAINT RHN_FAQ_ID_NN CHECK ("ID" IS NOT NULL);

--
-- 803. RHN_FAQ_MODIFIED_NN  (Constraint) 
--
ALTER TABLE RHNFAQ ADD CONSTRAINT RHN_FAQ_MODIFIED_NN CHECK ("MODIFIED" IS NOT NULL);

--
-- 804. RHN_FAQ_PRIVATE_NN  (Constraint) 
--
ALTER TABLE RHNFAQ ADD CONSTRAINT RHN_FAQ_PRIVATE_NN CHECK ("PRIVATE" IS NOT NULL);

--
-- 805. RHN_FAQ_USAGE_NN  (Constraint) 
--
ALTER TABLE RHNFAQ ADD CONSTRAINT RHN_FAQ_USAGE_NN CHECK ("USAGE_COUNT" IS NOT NULL);

--
-- 806. RHN_FAQ_ID_PK  (Constraint) 
--
ALTER TABLE RHNFAQ ADD CONSTRAINT RHN_FAQ_ID_PK PRIMARY KEY (ID);

--
-- 807. RHN_FAQ_CLASS_FK  (Constraint) 
--
ALTER TABLE RHNFAQ ADD CONSTRAINT RHN_FAQ_CLASS_FK FOREIGN KEY (CLASS_ID) 
    REFERENCES RHNFAQCLASS (ID);








--------------------------------------------------------------------------
-- Play this script in SATSCHEMA1@TESTDB2 to make it look like SATSCHEMA2@TESTDB2
--                                                                      --
-- Please review the script before using it to make sure it won't       --
-- cause any unacceptable data loss.                                    --
--                                                                      --
-- SATSCHEMA1@TESTDB2 Schema Extracted by User SATSCHEMA1 
-- SATSCHEMA2@TESTDB2 Schema Extracted by User SATSCHEMA2 
--------------------------------------------------------------------------
--
-- 1. RHN_CHANNEL_ARCH_NN  (Constraint) 
--
ALTER TABLE RHNCHANNEL DROP CONSTRAINT RHN_CHANNEL_ARCH_NN;

--
-- 2. RHN_CHANNEL_ARCH_FK  (Constraint) 
--
ALTER TABLE RHNCHANNEL DROP CONSTRAINT RHN_CHANNEL_ARCH_FK;

--
-- 3. RHN_DCM_ARCH_NN  (Constraint) 
--
ALTER TABLE RHNDISTCHANNELMAP DROP CONSTRAINT RHN_DCM_ARCH_NN;

--
-- 4. RHN_DCM_ARCH_FK  (Constraint) 
--
ALTER TABLE RHNDISTCHANNELMAP DROP CONSTRAINT RHN_DCM_ARCH_FK;

--
-- 5. RHN_PACKAGE_ARCH_NN  (Constraint) 
--
ALTER TABLE RHNPACKAGE DROP CONSTRAINT RHN_PACKAGE_ARCH_NN;

--
-- 6. RHN_PACKAGE_ARCH_FK  (Constraint) 
--
ALTER TABLE RHNPACKAGE DROP CONSTRAINT RHN_PACKAGE_ARCH_FK;

--
-- 7. WUCP_WUID_FK  (Constraint) 
--
ALTER TABLE WEB_USER_CONTACT_PERMISSION DROP CONSTRAINT WUCP_WUID_FK;

--
-- 8. WUPI_WUID_FK  (Constraint) 
--
ALTER TABLE WEB_USER_PERSONAL_INFO DROP CONSTRAINT WUPI_WUID_FK;

--
-- 9. RHN_ACTION_SCHEDULER_NN  (Constraint) 
--
ALTER TABLE RHNACTION DROP CONSTRAINT RHN_ACTION_SCHEDULER_NN;

--
-- 10. RHN_ACT_P_AID_FK  (Constraint) 
--
ALTER TABLE RHNACTIONPACKAGE DROP CONSTRAINT RHN_ACT_P_AID_FK;

--
-- 11. RHN_REG_TOKEN_USAGE_NN  (Constraint) 
--
ALTER TABLE RHNREGTOKEN DROP CONSTRAINT RHN_REG_TOKEN_USAGE_NN;

--
-- 12. RHN_SERVER_ARCH_NN  (Constraint) 
--
ALTER TABLE RHNSERVER DROP CONSTRAINT RHN_SERVER_ARCH_NN;

--
-- 13. RHN_SERVER_INFO_CREATOR_NN  (Constraint) 
--
ALTER TABLE RHNSERVER DROP CONSTRAINT RHN_SERVER_INFO_CREATOR_NN;

--
-- 14. RHN_SERVER_INFO_DELIVER_CK  (Constraint) 
--
ALTER TABLE RHNSERVER DROP CONSTRAINT RHN_SERVER_INFO_DELIVER_CK;

--
-- 15. RHN_SERVER_INFO_DELIVER_NN  (Constraint) 
--
ALTER TABLE RHNSERVER DROP CONSTRAINT RHN_SERVER_INFO_DELIVER_NN;

--
-- 16. RHN_SERVER_INFO_UPDATE_CK  (Constraint) 
--
ALTER TABLE RHNSERVER DROP CONSTRAINT RHN_SERVER_INFO_UPDATE_CK;

--
-- 17. RHN_SERVER_INFO_UPDATE_NN  (Constraint) 
--
ALTER TABLE RHNSERVER DROP CONSTRAINT RHN_SERVER_INFO_UPDATE_NN;

--
-- 18. RHN_SERVER_ARCH_FK  (Constraint) 
--
ALTER TABLE RHNSERVER DROP CONSTRAINT RHN_SERVER_ARCH_FK;

--
-- 19. RHN_SERVER_INFO_CREATOR_FK  (Constraint) 
--
ALTER TABLE RHNSERVER DROP CONSTRAINT RHN_SERVER_INFO_CREATOR_FK;

--
-- 20. RHN_SERVERGRP_NOTE_CREATOR_NN  (Constraint) 
--
ALTER TABLE RHNSERVERGROUPNOTES DROP CONSTRAINT RHN_SERVERGRP_NOTE_CREATOR_NN;

--
-- 21. RHN_SERVERNOTES_CREATOR_NN  (Constraint) 
--
ALTER TABLE RHNSERVERNOTES DROP CONSTRAINT RHN_SERVERNOTES_CREATOR_NN;

--
-- 22. RHN_CPU_ARCH_NN  (Constraint) 
--
ALTER TABLE RHNCPU DROP CONSTRAINT RHN_CPU_ARCH_NN;

--
-- 23. RHN_CPU_ARCH_FK  (Constraint) 
--
ALTER TABLE RHNCPU DROP CONSTRAINT RHN_CPU_ARCH_FK;

--
-- 24. WEB_CUSTOMER_NOTIFICATION  (Synonym) 
--
DROP SYNONYM WEB_CUSTOMER_NOTIFICATION;

--
-- 25. RHNAUTOMAILERRATAVIEW  (View) 
--
DROP VIEW RHNAUTOMAILERRATAVIEW;

--
-- 26. RHNARCHCOMPAT  (View) 
--
DROP VIEW RHNARCHCOMPAT;

--
-- 27. RHN_SERVER_PROFILE_OID_ID_IDX  (Index) 
--
DROP INDEX RHN_SERVER_PROFILE_OID_ID_IDX;

--
-- 28. RHN_SERVER_PROFILE_ID_PK  (Index) 
--
--DROP INDEX RHN_SERVER_PROFILE_ID_PK;

--
-- 29. RHN_SERVER_ARCH_IDX  (Index) 
--
DROP INDEX RHN_SERVER_ARCH_IDX;

--
-- 30. RHN_SERVERPREFS_SID_NAME_UQ  (Index) 
--
DROP INDEX RHN_SERVERPREFS_SID_NAME_UQ;

--
-- 31. RHN_SERVERPREFS_NAME_SID_IDX  (Index) 
--
DROP INDEX RHN_SERVERPREFS_NAME_SID_IDX;

--
-- 32. RHN_SATELLITE_INFO_SID_UNQ  (Index) 
--
DROP INDEX RHN_SATELLITE_INFO_SID_UNQ;

--
-- 33. RHN_PACKAGE_NID_EID_AID_OID_UQ  (Index) 
--
DROP INDEX RHN_PACKAGE_NID_EID_AID_OID_UQ;

--
-- 34. RHN_PACKAGE_ID_NID_ARCH_IDX  (Index) 
--
DROP INDEX RHN_PACKAGE_ID_NID_ARCH_IDX;

--
-- 35. RHN_ESTATE_LABEL_PK  (Index) 
--
--DROP INDEX RHN_ESTATE_LABEL_PK;

--
-- 36. RHN_DCM_OS_RELEASE_UQ  (Index) 
--
DROP INDEX RHN_DCM_OS_RELEASE_UQ;

--
-- 37. RHN_CAP_STAT_ID_PK  (Index) 
--
--DROP INDEX RHN_CAP_STAT_ID_PK;

--
-- 38. RHN_CAPABILITY_UNIQUE_COLUMNS  (Index) 
--
DROP INDEX RHN_CAPABILITY_UNIQUE_COLUMNS;

--
-- 39. RHN_CAPABILITY_ID_PK  (Index) 
--
--DROP INDEX RHN_CAPABILITY_ID_PK;

--
-- 40. RHN_ARCH_NAME_UQ  (Index) 
--
DROP INDEX RHN_ARCH_NAME_UQ;

--
-- 41. RHN_ARCH_ID_PK  (Index) 
--
--DROP INDEX RHN_ARCH_ID_PK;

--
-- 42. RHN_ARCH_FAM_GEN_UQ  (Index) 
--
DROP INDEX RHN_ARCH_FAM_GEN_UQ;

--
-- 43. RHN_ACT_EU_AID_IDX  (Index) 
--
DROP INDEX RHN_ACT_EU_AID_IDX;

--
-- 44. RHNSERVERPREFS  (Table) 
--
DROP TABLE RHNSERVERPREFS CASCADE CONSTRAINTS;

--
-- 45. RHNENTITLEMENTSTATE  (Table) 
--
ALTER TABLE RHNENTITLEMENTSTATE DROP PRIMARY KEY CASCADE;
DROP TABLE RHNENTITLEMENTSTATE CASCADE CONSTRAINTS;

--
-- 46. RHNCAPABILITYSTAT  (Table) 
--
ALTER TABLE RHNCAPABILITYSTAT DROP PRIMARY KEY CASCADE;
DROP TABLE RHNCAPABILITYSTAT CASCADE CONSTRAINTS;

--
-- 47. RHNCAPABILITY  (Table) 
--
ALTER TABLE RHNCAPABILITY DROP PRIMARY KEY CASCADE;
DROP TABLE RHNCAPABILITY CASCADE CONSTRAINTS;

--
-- 49. RHN_SPROFILE_PACKAGE_ID_SEQ  (Sequence) 
--
DROP SEQUENCE RHN_SPROFILE_PACKAGE_ID_SEQ;

--
-- 50. RHN_CAP_STAT_ID_SEQ  (Sequence) 
--
DROP SEQUENCE RHN_CAP_STAT_ID_SEQ;

--
-- 51. RHN_CAPABILITY_ID_SEQ  (Sequence) 
--
DROP SEQUENCE RHN_CAPABILITY_ID_SEQ;

--
-- 52. RHN_CHANNEL_ARCH_ID_SEQ  (Sequence) 
--
CREATE SEQUENCE RHN_CHANNEL_ARCH_ID_SEQ
  START WITH 520
  NOMAXVALUE
  MINVALUE 1
  NOCYCLE
  CACHE 20
  NOORDER;

--
-- 53. RHN_CPU_ARCH_ID_SEQ  (Sequence) 
--
CREATE SEQUENCE RHN_CPU_ARCH_ID_SEQ
  START WITH 220
  NOMAXVALUE
  MINVALUE 1
  NOCYCLE
  CACHE 20
  NOORDER;

--
-- 54. RHN_EADDRESS_ID_SEQ  (Sequence) 
--
CREATE SEQUENCE RHN_EADDRESS_ID_SEQ
  START WITH 1
  NOMAXVALUE
  MINVALUE 1
  NOCYCLE
  CACHE 20
  NOORDER;

--
-- 55. RHN_EASTATE_ID_SEQ  (Sequence) 
--
CREATE SEQUENCE RHN_EASTATE_ID_SEQ
  START WITH 21
  NOMAXVALUE
  MINVALUE 1
  NOCYCLE
  CACHE 20
  NOORDER;

--
-- 56. RHN_ERRATAFILE_ID_SEQ  (Sequence) 
--
CREATE SEQUENCE RHN_ERRATAFILE_ID_SEQ
  START WITH 1
  NOMAXVALUE
  MINVALUE 1
  NOCYCLE
  CACHE 20
  NOORDER;

--
-- 57. RHN_ERRATAFILE_TYPE_ID_SEQ  (Sequence) 
--
CREATE SEQUENCE RHN_ERRATAFILE_TYPE_ID_SEQ
  START WITH 21
  NOMAXVALUE
  MINVALUE 1
  NOCYCLE
  CACHE 20
  NOORDER;

--
-- 58. RHN_FAQ_CLASS_ID_SEQ  (Sequence) 
--
CREATE SEQUENCE RHN_FAQ_CLASS_ID_SEQ
  START WITH 1
  NOMAXVALUE
  MINVALUE 1
  NOCYCLE
  CACHE 20
  NOORDER;

--
-- 59. RHN_FAQ_ID_SEQ  (Sequence) 
--
CREATE SEQUENCE RHN_FAQ_ID_SEQ
  START WITH 1
  NOMAXVALUE
  MINVALUE 1
  NOCYCLE
  CACHE 20
  NOORDER;

--
-- 58. RHN_HWCLASS_ID_SEQ  (Sequence) 
--
CREATE SEQUENCE RHN_HWCLASS_ID_SEQ
  START WITH 1
  NOMAXVALUE
  MINVALUE 1
  NOCYCLE
  CACHE 20
  NOORDER;

--
-- 59. RHN_HWPNAME_ID_SEQ  (Sequence) 
--
CREATE SEQUENCE RHN_HWPNAME_ID_SEQ
  START WITH 100
  NOMAXVALUE
  MINVALUE 1
  NOCYCLE
  CACHE 20
  NOORDER;

--
-- 60. RHN_HWPVALUE_ID_SEQ  (Sequence) 
--
CREATE SEQUENCE RHN_HWPVALUE_ID_SEQ
  START WITH 2
  NOMAXVALUE
  MINVALUE 1
  NOCYCLE
  CACHE 20
  NOORDER;

--
-- 61. RHN_HW_ID_SEQ  (Sequence) 
--
CREATE SEQUENCE RHN_HW_ID_SEQ
  START WITH 1
  NOMAXVALUE
  MINVALUE 1
  NOCYCLE
  CACHE 20
  NOORDER;

--
-- 62. RHN_MONITORGRANULARITY_ID_SEQ  (Sequence) 
--
CREATE SEQUENCE RHN_MONITORGRANULARITY_ID_SEQ
  START WITH 21
  NOMAXVALUE
  MINVALUE 1
  NOCYCLE
  CACHE 20
  NOORDER;

--
-- 63. RHN_MONITOR_BID_SEQ  (Sequence) 
--
CREATE SEQUENCE RHN_MONITOR_BID_SEQ
  START WITH 1
  NOMAXVALUE
  MINVALUE 1
  NOCYCLE
  CACHE 20
  NOORDER;

--
-- 64. RHN_MT_ID_SEQ  (Sequence) 
--
CREATE SEQUENCE RHN_MT_ID_SEQ
  START WITH 21
  NOMAXVALUE
  MINVALUE 1
  NOCYCLE
  CACHE 20
  NOORDER;

--
-- 65. RHN_M_ID_SEQ  (Sequence) 
--
CREATE SEQUENCE RHN_M_ID_SEQ
  START WITH 1
  NOMAXVALUE
  MINVALUE 1
  NOCYCLE
  CACHE 20
  NOORDER;

--
-- 66. RHN_M_PRIORITY_ID_SEQ  (Sequence) 
--
CREATE SEQUENCE RHN_M_PRIORITY_ID_SEQ
  START WITH 21
  NOMAXVALUE
  MINVALUE 1
  NOCYCLE
  CACHE 20
  NOORDER;

--
-- 67. RHN_OASTATES_ID_SEQ  (Sequence) 
--
CREATE SEQUENCE RHN_OASTATES_ID_SEQ
  START WITH 21
  NOMAXVALUE
  MINVALUE 1
  NOCYCLE
  CACHE 20
  NOORDER;

--
-- 68. RHN_PACKAGE_ARCH_ID_SEQ  (Sequence) 
--
CREATE SEQUENCE RHN_PACKAGE_ARCH_ID_SEQ
  START WITH 120
  NOMAXVALUE
  MINVALUE 1
  NOCYCLE
  CACHE 20
  NOORDER;

--
-- 69. RHN_PRODUCT_ID_SEQ  (Sequence) 
--
CREATE SEQUENCE RHN_PRODUCT_ID_SEQ
  START WITH 101
  NOMAXVALUE
  MINVALUE 1
  NOCYCLE
  CACHE 20
  NOORDER;

--
-- 70. RHN_PROD_LINE_ID_SEQ  (Sequence) 
--
CREATE SEQUENCE RHN_PROD_LINE_ID_SEQ
  START WITH 101
  NOMAXVALUE
  MINVALUE 1
  NOCYCLE
  CACHE 20
  NOORDER;

--
-- 71. RHN_RELTYPE_ID_SEQ  (Sequence) 
--
CREATE SEQUENCE RHN_RELTYPE_ID_SEQ
  START WITH 21
  NOMAXVALUE
  MINVALUE 1
  NOCYCLE
  CACHE 20
  NOORDER;

--
-- 72. RHN_SAVEDSEARCH_ID_SEQ  (Sequence) 
--
CREATE SEQUENCE RHN_SAVEDSEARCH_ID_SEQ
  START WITH 1
  NOMAXVALUE
  MINVALUE 1
  NOCYCLE
  CACHE 20
  NOORDER;

--
-- 73. RHN_SERVER_ARCH_ID_SEQ  (Sequence) 
--
CREATE SEQUENCE RHN_SERVER_ARCH_ID_SEQ
  START WITH 1020
  NOMAXVALUE
  MINVALUE 1
  NOCYCLE
  CACHE 20
  NOORDER;

--
-- 74. RHN_SERVER_INSTALL_INFO_ID_SEQ  (Sequence) 
--
CREATE SEQUENCE RHN_SERVER_INSTALL_INFO_ID_SEQ
  START WITH 1
  NOMAXVALUE
  MINVALUE 1
  NOCYCLE
  CACHE 20
  NOORDER;

--
-- 75. RHN_SERVER_PROFILE_ID_SEQ  (Sequence) 
--
ALTER SEQUENCE RHN_SERVER_PROFILE_ID_SEQ 
  NOORDER;

--
-- 76. RHN_SE_ID_SEQ  (Sequence) 
--
CREATE SEQUENCE RHN_SE_ID_SEQ
  START WITH 1
  NOMAXVALUE
  MINVALUE 1
  NOCYCLE
  CACHE 20
  NOORDER;

--
-- 77. RHN_SQUESTION_ID_SEQ  (Sequence) 
--
CREATE SEQUENCE RHN_SQUESTION_ID_SEQ
  START WITH 1
  NOMAXVALUE
  MINVALUE 1
  NOCYCLE
  CACHE 20
  NOORDER;

--
-- 78. RHN_SSTYPE_ID_SEQ  (Sequence) 
--
CREATE SEQUENCE RHN_SSTYPE_ID_SEQ
  START WITH 21
  NOMAXVALUE
  MINVALUE 1
  NOCYCLE
  CACHE 20
  NOORDER;

--
-- 79. RHN_SURVEY_ID_SEQ  (Sequence) 
--
CREATE SEQUENCE RHN_SURVEY_ID_SEQ
  START WITH 1
  NOMAXVALUE
  MINVALUE 1
  NOCYCLE
  CACHE 20
  NOORDER;

--
-- 80. RHN_TEMPLATE_CAT_ID_SEQ  (Sequence) 
--
CREATE SEQUENCE RHN_TEMPLATE_CAT_ID_SEQ
  START WITH 1
  NOMAXVALUE
  MINVALUE 1
  NOCYCLE
  CACHE 20
  NOORDER;

--
-- 81. RHN_TEMPLATE_STR_ID_SEQ  (Sequence) 
--
CREATE SEQUENCE RHN_TEMPLATE_STR_ID_SEQ
  START WITH 1
  NOMAXVALUE
  MINVALUE 1
  NOCYCLE
  CACHE 20
  NOORDER;

--
-- 82. RHN_TRANSACTION_ID_SEQ  (Sequence) 
--
CREATE SEQUENCE RHN_TRANSACTION_ID_SEQ
  START WITH 1
  NOMAXVALUE
  MINVALUE 1
  NOCYCLE
  CACHE 20
  NOORDER;

--
-- 83. RHN_TRANSPACK_ID_SEQ  (Sequence) 
--
CREATE SEQUENCE RHN_TRANSPACK_ID_SEQ
  START WITH 1
  NOMAXVALUE
  MINVALUE 1
  NOCYCLE
  CACHE 20
  NOORDER;

--
-- 84. RHN_UM_STATUS_ID_SEQ  (Sequence) 
--
CREATE SEQUENCE RHN_UM_STATUS_ID_SEQ
  START WITH 21
  NOMAXVALUE
  MINVALUE 1
  NOCYCLE
  CACHE 20
  NOORDER;

--
-- 85. RHN_USURVEYSTYPE_ID_SEQ  (Sequence) 
--
CREATE SEQUENCE RHN_USURVEYSTYPE_ID_SEQ
  START WITH 21
  NOMAXVALUE
  MINVALUE 1
  NOCYCLE
  CACHE 20
  NOORDER;

--
-- 86. RHNCHANNELARCH  (Table) 
--
CREATE TABLE RHNCHANNELARCH
(
  ID        NUMBER,
  LABEL     VARCHAR2(16),
  NAME      VARCHAR2(64),
  CREATED   DATE                                DEFAULT (sysdate),
  MODIFIED  DATE                                DEFAULT (sysdate)
)
LOGGING 
NOCACHE
NOPARALLEL;

insert into rhnChannelArch (id, label, name) values
(rhn_channel_arch_id_seq.nextval, 'channel-ia32', 'ia32');

insert into rhnChannelArch (id, label, name) values
(rhn_channel_arch_id_seq.nextval, 'channel-ia64', 'ia64');

insert into rhnChannelArch (id, label, name) values
(rhn_channel_arch_id_seq.nextval, 'channel-sparc', 'sparc');

insert into rhnChannelArch (id, label, name) values
(rhn_channel_arch_id_seq.nextval, 'channel-alpha', 'alpha');

insert into rhnChannelArch (id, label, name) values
(rhn_channel_arch_id_seq.nextval, 'channel-s390', 's390');

insert into rhnChannelArch (id, label, name) values
(rhn_channel_arch_id_seq.nextval, 'channel-s390x', 's390x');

insert into rhnChannelArch (id, label, name) values
(rhn_channel_arch_id_seq.nextval, 'channel-iSeries', 'iSeries');

insert into rhnChannelArch (id, label, name) values
(rhn_channel_arch_id_seq.nextval, 'channel-pSeries', 'pSeries');

insert into rhnChannelArch (id, label, name) values
(rhn_channel_arch_id_seq.nextval, 'channel-x86_64', 'x86_64');

commit;

--
-- 87. RHNCPUARCH  (Table) 
--
CREATE TABLE RHNCPUARCH
(
  ID        NUMBER,
  LABEL     VARCHAR2(16),
  NAME      VARCHAR2(64),
  CREATED   DATE                                DEFAULT (sysdate),
  MODIFIED  DATE                                DEFAULT (sysdate)
)
LOGGING 
NOCACHE
NOPARALLEL;

insert into rhnCpuArch (id, label, name) values
(rhn_cpu_arch_id_seq.nextval, 'i386', 'i386');
insert into rhnCpuArch (id, label, name) values
(rhn_cpu_arch_id_seq.nextval, 'i486', 'i486');
insert into rhnCpuArch (id, label, name) values
(rhn_cpu_arch_id_seq.nextval, 'i586', 'i586');
insert into rhnCpuArch (id, label, name) values
(rhn_cpu_arch_id_seq.nextval, 'i686', 'i686');
insert into rhnCpuArch (id, label, name) values
(rhn_cpu_arch_id_seq.nextval, 'athlon', 'athlon');
insert into rhnCpuArch (id, label, name) values
(rhn_cpu_arch_id_seq.nextval, 'alpha', 'alpha');
insert into rhnCpuArch (id, label, name) values
(rhn_cpu_arch_id_seq.nextval, 'alphaev6', 'alphaev6');
insert into rhnCpuArch (id, label, name) values
(rhn_cpu_arch_id_seq.nextval, 'ia64', 'ia64');
insert into rhnCpuArch (id, label, name) values
(rhn_cpu_arch_id_seq.nextval, 'sparc', 'sparc');
insert into rhnCpuArch (id, label, name) values
(rhn_cpu_arch_id_seq.nextval, 'sparcv9', 'sparcv9');
insert into rhnCpuArch (id, label, name) values
(rhn_cpu_arch_id_seq.nextval, 'sparc64', 'sparc64');
insert into rhnCpuArch (id, label, name) values
(rhn_cpu_arch_id_seq.nextval, 's390', 's390');
insert into rhnCpuArch (id, label, name) values
(rhn_cpu_arch_id_seq.nextval, 's390x', 's390x');
insert into rhnCpuArch (id, label, name) values
(rhn_cpu_arch_id_seq.nextval, 'ppc', 'ppc');
insert into rhnCpuArch (id, label, name) values
(rhn_cpu_arch_id_seq.nextval, 'ppc64', 'ppc64');
insert into rhnCpuArch (id, label, name) values
(rhn_cpu_arch_id_seq.nextval, 'pSeries', 'pSeries');
insert into rhnCpuArch (id, label, name) values
(rhn_cpu_arch_id_seq.nextval, 'iSeries', 'iSeries');
insert into rhnCpuArch (id, label, name) values
(rhn_cpu_arch_id_seq.nextval, 'x86_64', 'x86_64');
commit;

--
-- 88. RHNDAEMONSTATE  (Table) 
--
CREATE TABLE RHNDAEMONSTATE
(
  LABEL      VARCHAR2(64),
  LAST_POLL  DATE
)
LOGGING 
NOCACHE
NOPARALLEL;

--
-- 89. RHNDOWNLOADGROUPS  (Table) 
--
CREATE TABLE RHNDOWNLOADGROUPS
(
  GROUP_NAME         VARCHAR2(32),
  DOWNLOAD_CATEGORY  VARCHAR2(128),
  ORDERING           NUMBER
)
LOGGING 
NOCACHE
NOPARALLEL;

--
-- 90. RHNEMAILADDRESSSTATE  (Table) 
--
CREATE TABLE RHNEMAILADDRESSSTATE
(
  ID        NUMBER,
  LABEL     VARCHAR2(32),
  CREATED   DATE                                DEFAULT (sysdate),
  MODIFIED  DATE                                DEFAULT (sysdate)
)
LOGGING 
NOCACHE
NOPARALLEL;

insert into rhnEmailAddressState ( id, label )
	values (rhn_eastate_id_seq.nextval, 'unverified');
insert into rhnEmailAddressState ( id, label )
	values (rhn_eastate_id_seq.nextval, 'pending');
insert into rhnEmailAddressState ( id, label )
	values (rhn_eastate_id_seq.nextval, 'pending_warned');
insert into rhnEmailAddressState ( id, label )
	values (rhn_eastate_id_seq.nextval, 'verified');
insert into rhnEmailAddressState ( id, label )
	values (rhn_eastate_id_seq.nextval, 'needs_verifying');
	
commit;

--
-- 91. RHNENTITLEMENTLOG  (Table) 
--
CREATE TABLE RHNENTITLEMENTLOG
(
  RUN_TIME  DATE                                DEFAULT (sysdate),
  BDATE     DATE,
  EDATE     DATE
)
LOGGING 
NOCACHE
NOPARALLEL;

--
-- 92. RHNERRATAFILETYPE  (Table) 
--
CREATE TABLE RHNERRATAFILETYPE
(
  ID     NUMBER,
  LABEL  VARCHAR2(128)
)
LOGGING 
NOCACHE
NOPARALLEL;

insert into rhnErrataFileType ( id, label )
	values ( rhn_erratafile_type_id_seq.nextval, 'RPM' );
insert into rhnErrataFileType ( id, label )
	values ( rhn_erratafile_type_id_seq.nextval, 'SRPM' );
insert into rhnErrataFileType ( id, label )
	values ( rhn_erratafile_type_id_seq.nextval, 'IMG' );

commit;

--
-- 93. RHNHARDWARECLASS  (Table) 
--
CREATE TABLE RHNHARDWARECLASS
(
  ID     NUMBER,
  LABEL  VARCHAR2(32),
  CLASS  VARCHAR2(32)
)
LOGGING 
NOCACHE
NOPARALLEL;

--
-- 94. RHNHARDWAREPROPNAME  (Table) 
--
CREATE TABLE RHNHARDWAREPROPNAME
(
  ID    NUMBER,
  NAME  VARCHAR2(32)
)
LOGGING 
NOCACHE
NOPARALLEL;


create or replace procedure
addname(
        id_in in number,
        name_in in varchar2
) is
begin
        insert into rhnHardwarePropName(id, name) values (id_in, name_in);
end addname;
/
 
exec addname(1,'bus');
exec addname(2,'detached');
exec addname(3,'device');
exec addname(4,'driver');
exec addname(5,'description');
exec addname(6,'physical');
exec addname(7,'logical');
exec addname(8,'pcitype');
exec addname(9,'dev_host');
exec addname(10,'dev_id');
exec addname(11,'dev_channel');
exec addname(12,'dev_lun');
exec addname(13,'vendor_id');
exec addname(14,'device_id');
exec addname(15,'subvendor_id');
exec addname(16,'subdevice_id');
 
commit;
drop procedure addname;


--
-- 95. RHNHARDWAREPROPVALUE  (Table) 
--
CREATE TABLE RHNHARDWAREPROPVALUE
(
  ID     NUMBER,
  VALUE  VARCHAR2(256)
)
LOGGING 
NOCACHE
NOPARALLEL;

insert into rhnHardwarePropValue(id,value) values (1, null);
commit;

--
-- 96. RHNMESSAGEPRIORITY  (Table) 
--
CREATE TABLE RHNMESSAGEPRIORITY
(
  ID     NUMBER,
  LABEL  VARCHAR2(48)
)
LOGGING 
NOCACHE
NOPARALLEL;

--
-- 97. RHNMESSAGETYPE  (Table) 
--
CREATE TABLE RHNMESSAGETYPE
(
  ID     NUMBER,
  LABEL  VARCHAR2(48),
  NAME   VARCHAR2(96)
)
LOGGING 
NOCACHE
NOPARALLEL;

--
-- 98. RHNMONITORGRANULARITY  (Table) 
--
CREATE TABLE RHNMONITORGRANULARITY
(
  ID     NUMBER,
  LABEL  VARCHAR2(16)
)
LOGGING 
NOCACHE
NOPARALLEL;

--
-- 99. RHNORGAVAILABLESTATES  (Table) 
--
CREATE TABLE RHNORGAVAILABLESTATES
(
  ID        NUMBER,
  LABEL     VARCHAR2(32),
  CREATED   DATE                                DEFAULT (sysdate),
  MODIFIED  DATE                                DEFAULT (sysdate)
)
LOGGING 
NOCACHE
NOPARALLEL;

insert into rhnOrgAvailableStates (ID, LABEL)
     values (rhn_oastates_id_seq.nextval, 'legacy_unclassified');
insert into rhnOrgAvailableStates (ID, LABEL)
     values (rhn_oastates_id_seq.nextval, 'legacy_web');
insert into rhnOrgAvailableStates (ID, LABEL)
     values (rhn_oastates_id_seq.nextval, 'legacy_rhn');

insert into rhnOrgAvailableStates (ID, LABEL)
     values (rhn_oastates_id_seq.nextval, 'paid');
insert into rhnOrgAvailableStates (ID, LABEL)
     values (rhn_oastates_id_seq.nextval, 'grace');

insert into rhnOrgAvailableStates (ID, LABEL)
     values (rhn_oastates_id_seq.nextval, 'freeloader');
insert into rhnOrgAvailableStates (ID, LABEL)
     values (rhn_oastates_id_seq.nextval, 'freeloader_warned');
insert into rhnOrgAvailableStates (ID, LABEL)
     values (rhn_oastates_id_seq.nextval, 'freeloader_survey_sent');

insert into rhnOrgAvailableStates (ID, LABEL)
     values (rhn_oastates_id_seq.nextval, 'disabled_freeloader');
insert into rhnOrgAvailableStates (ID, LABEL)
     values (rhn_oastates_id_seq.nextval, 'disabled_email');
insert into rhnOrgAvailableStates (ID, LABEL)
     values (rhn_oastates_id_seq.nextval, 'falling_from_grace');
commit;

--
-- 100. RHNORGSTATETRANSITIONS  (Table) 
--
CREATE TABLE RHNORGSTATETRANSITIONS
(
  FROM_STATE  NUMBER,
  TO_STATE    NUMBER
)
LOGGING 
NOCACHE
NOPARALLEL;

CREATE OR REPLACE PROCEDURE
add_org_state_transition(from_state_in IN varchar2, to_state_in IN varchar2)
IS
BEGIN
    INSERT INTO
    	rhnOrgStateTransitions (from_state, to_state)
    VALUES
    	((select id from rhnOrgAvailableStates where label = from_state_in),
    	 (select id from rhnOrgAvailableStates where label = to_state_in));
END;
/
declare
  cursor state_cursor is
    select label from rhnOrgAvailableStates where label <> 'paid';
begin

  for state_req in state_cursor
  loop
    add_org_state_transition(state_req.label, 'paid');
  end loop;

  add_org_state_transition('legacy_unclassified', 'legacy_rhn');
  add_org_state_transition('legacy_unclassified', 'legacy_web');
  add_org_state_transition('legacy_unclassified', 'falling_from_grace');
 
  add_org_state_transition('legacy_rhn', 'freeloader');
  add_org_state_transition('legacy_rhn', 'disabled_email');
  
  add_org_state_transition('legacy_web', 'grace');
  add_org_state_transition('legacy_web', 'legacy_unclassified');
  
  add_org_state_transition('grace', 'freeloader');  
  add_org_state_transition('grace', 'disabled_email');

  add_org_state_transition('freeloader', 'freeloader_survey_sent');
  
  add_org_state_transition('freeloader_survey_sent', 'freeloader_warned');
  add_org_state_transition('freeloader_survey_sent', 'freeloader');

  add_org_state_transition('freeloader_warned', 'disabled_freeloader');
  add_org_state_transition('freeloader_warned', 'freeloader');

  add_org_state_transition('disabled_freeloader', 'freeloader');

  add_org_state_transition('disabled_email', 'freeloader');
  
  add_org_state_transition('paid', 'falling_from_grace');

  add_org_state_transition('falling_from_grace', 'freeloader');
  add_org_state_transition('falling_from_grace', 'disabled_email');
      
end;
/
commit;

drop procedure add_org_state_transition;
--
-- 101. RHNPACKAGEARCH  (Table) 
--
CREATE TABLE RHNPACKAGEARCH
(
  ID        NUMBER,
  LABEL     VARCHAR2(16),
  NAME      VARCHAR2(64),
  CREATED   DATE                                DEFAULT (sysdate),
  MODIFIED  DATE                                DEFAULT (sysdate)
)
LOGGING 
NOCACHE
NOPARALLEL;

insert into rhnPackageArch (id, label, name) values
(rhn_package_arch_id_seq.nextval, 'noarch', 'noarch');
insert into rhnPackageArch (id, label, name) values
(rhn_package_arch_id_seq.nextval, 'i386', 'i386');
insert into rhnPackageArch (id, label, name) values
(rhn_package_arch_id_seq.nextval, 'i486', 'i486');
insert into rhnPackageArch (id, label, name) values
(rhn_package_arch_id_seq.nextval, 'i586', 'i586');
insert into rhnPackageArch (id, label, name) values
(rhn_package_arch_id_seq.nextval, 'i686', 'i686');
insert into rhnPackageArch (id, label, name) values
(rhn_package_arch_id_seq.nextval, 'alpha', 'alpha');
insert into rhnPackageArch (id, label, name) values
(rhn_package_arch_id_seq.nextval, 'alphaev6', 'alphaev6');
insert into rhnPackageArch (id, label, name) values
(rhn_package_arch_id_seq.nextval, 'ia64', 'ia64');
insert into rhnPackageArch (id, label, name) values
(rhn_package_arch_id_seq.nextval, 'sparc', 'sparc');
insert into rhnPackageArch (id, label, name) values
(rhn_package_arch_id_seq.nextval, 'sparcv9', 'sparcv9');
insert into rhnPackageArch (id, label, name) values
(rhn_package_arch_id_seq.nextval, 'sparc64', 'sparc64');
insert into rhnPackageArch (id, label, name) values
(rhn_package_arch_id_seq.nextval, 'src', 'src');
insert into rhnPackageArch (id, label, name) values
(rhn_package_arch_id_seq.nextval, 's390', 's390');
insert into rhnPackageArch (id, label, name) values
(rhn_package_arch_id_seq.nextval, 'athlon', 'athlon');
insert into rhnPackageArch (id, label, name) values
(rhn_package_arch_id_seq.nextval, 's390x', 's390x');
insert into rhnPackageArch (id, label, name) values
(rhn_package_arch_id_seq.nextval, 'ppc', 'ppc');
insert into rhnPackageArch (id, label, name) values
(rhn_package_arch_id_seq.nextval, 'ppc64', 'ppc64');
insert into rhnPackageArch (id, label, name) values
(rhn_package_arch_id_seq.nextval, 'pSeries', 'pSeries');
insert into rhnPackageArch (id, label, name) values
(rhn_package_arch_id_seq.nextval, 'iSeries', 'iSeries');
insert into rhnPackageArch (id, label, name) values
(rhn_package_arch_id_seq.nextval, 'x86_64', 'x86_64');
commit;

--
-- 102. RHNPAIDERRATATEMPCACHE  (Table) 
--
CREATE GLOBAL TEMPORARY TABLE RHNPAIDERRATATEMPCACHE
(
  ERRATA_ID  NUMBER,
  USER_ID    NUMBER,
  SERVER_ID  NUMBER
)
ON COMMIT PRESERVE ROWS;

--
-- 103. RHNPRODUCTLINE  (Table) 
--
CREATE TABLE RHNPRODUCTLINE
(
  ID             NUMBER,
  LABEL          VARCHAR2(128),
  NAME           VARCHAR2(128),
  LAST_MODIFIED  DATE                           DEFAULT (sysdate),
  CREATED        DATE                           DEFAULT (sysdate),
  MODIFIED       DATE                           DEFAULT (sysdate)
)
LOGGING 
NOCACHE
NOPARALLEL;

insert into rhnProductLine
(id, label, name)
values
(1, 'rhl', 'Red Hat Linux');

insert into rhnProductLine
(id, label, name)
values
(2, 'rhel', 'Red Hat Enterprise Linux');

insert into rhnProductLine
(id, label, name)
values
(3, 'rhdb', 'Red Hat Database');

insert into rhnProductLine
(id, label, name)
values
(4, 'stronghold', 'Stronghold');

commit;

--
-- 104. RHNRELATIONSHIPTYPE  (Table) 
--
CREATE TABLE RHNRELATIONSHIPTYPE
(
  ID           NUMBER,
  LABEL        VARCHAR2(32),
  DESCRIPTION  VARCHAR2(256),
  CREATED      DATE                             DEFAULT (sysdate),
  MODIFIED     DATE                             DEFAULT (sysdate)
)
LOGGING 
NOCACHE
NOPARALLEL;

insert into rhnRelationshipType ( id, label, description ) values (
	rhn_reltype_id_seq.nextval, 'cloned_from',
	'was cloned from'
);

--
-- 108. RHNSATELLITECERT  (Table) 
--
CREATE TABLE RHNSATELLITECERT
(
  CERT      VARCHAR2(4000),
  CREATED   DATE                                DEFAULT (sysdate),
  MODIFIED  DATE                                DEFAULT (sysdate)
)
LOGGING 
NOCACHE
NOPARALLEL;

--
-- 105. RHNSAVEDSEARCHTYPE  (Table) 
--
CREATE TABLE RHNSAVEDSEARCHTYPE
(
  ID        NUMBER,
  LABEL     VARCHAR2(8),
  CREATED   DATE                                DEFAULT (sysdate),
  MODIFIED  DATE                                DEFAULT (sysdate)
)
LOGGING 
NOCACHE
NOPARALLEL;

insert into rhnSavedSearchType (id, label)
	values (rhn_sstype_id_seq.nextval, 'system');
insert into rhnSavedSearchType (id, label)
	values (rhn_sstype_id_seq.nextval, 'package');
insert into rhnSavedSearchType (id, label)
	values (rhn_sstype_id_seq.nextval, 'errata');
commit;

--
-- 106. RHNSERVERARCH  (Table) 
--
CREATE TABLE RHNSERVERARCH
(
  ID        NUMBER,
  LABEL     VARCHAR2(32),
  NAME      VARCHAR2(64),
  CREATED   DATE                                DEFAULT (sysdate),
  MODIFIED  DATE                                DEFAULT (sysdate)
)
LOGGING 
NOCACHE
NOPARALLEL;

insert into rhnServerArch (id, label, name) values
(rhn_server_arch_id_seq.nextval, 'i386-redhat-linux', 'i386');
insert into rhnServerArch (id, label, name) values
(rhn_server_arch_id_seq.nextval, 'i486-redhat-linux', 'i486');
insert into rhnServerArch (id, label, name) values
(rhn_server_arch_id_seq.nextval, 'i586-redhat-linux', 'i586');
insert into rhnServerArch (id, label, name) values
(rhn_server_arch_id_seq.nextval, 'i686-redhat-linux', 'i686');
insert into rhnServerArch (id, label, name) values
(rhn_server_arch_id_seq.nextval, 'athlon-redhat-linux', 'athlon');
insert into rhnServerArch (id, label, name) values
(rhn_server_arch_id_seq.nextval, 'alpha-redhat-linux', 'alpha');
insert into rhnServerArch (id, label, name) values
(rhn_server_arch_id_seq.nextval, 'alphaev6-redhat-linux', 'alphaev6');
insert into rhnServerArch (id, label, name) values
(rhn_server_arch_id_seq.nextval, 'ia64-redhat-linux', 'ia64');
insert into rhnServerArch (id, label, name) values
(rhn_server_arch_id_seq.nextval, 'sparc-redhat-linux', 'sparc');
insert into rhnServerArch (id, label, name) values
(rhn_server_arch_id_seq.nextval, 'sparcv9-redhat-linux', 'sparcv9');
insert into rhnServerArch (id, label, name) values
(rhn_server_arch_id_seq.nextval, 'sparc64-redhat-linux', 'sparc64');
insert into rhnServerArch (id, label, name) values
(rhn_server_arch_id_seq.nextval, 's390-redhat-linux', 's390');
insert into rhnServerArch (id, label, name) values
(rhn_server_arch_id_seq.nextval, 's390x-redhat-linux', 's390x');
insert into rhnServerArch (id, label, name) values
(rhn_server_arch_id_seq.nextval, 'ppc-redhat-linux', 'ppc');
insert into rhnServerArch (id, label, name) values
(rhn_server_arch_id_seq.nextval, 'ppc64-redhat-linux', 'ppc64');
insert into rhnServerArch (id, label, name) values
(rhn_server_arch_id_seq.nextval, 'pSeries-redhat-linux', 'pSeries');
insert into rhnServerArch (id, label, name) values
(rhn_server_arch_id_seq.nextval, 'iSeries-redhat-linux', 'iSeries');
insert into rhnServerArch (id, label, name) values
(rhn_server_arch_id_seq.nextval, 'x86_64-redhat-linux', 'x86_64');
commit;

--
-- 199. LOOKUP_PACKAGE_ARCH  (Function) 
--
CREATE OR REPLACE FUNCTION
LOOKUP_PACKAGE_ARCH(label_in IN VARCHAR2)
RETURN NUMBER
DETERMINISTIC
IS
	PRAGMA AUTONOMOUS_TRANSACTION;
	package_arch_id		NUMBER;
BEGIN
	SELECT id
          INTO package_arch_id
          FROM rhnPackageArch
         WHERE label = label_in;
	RETURN package_arch_id;
EXCEPTION
        WHEN NO_DATA_FOUND THEN
            rhn_exception.raise_exception('package_arch_not_found');
END;
/

--
-- 201. LOOKUP_PACKAGE_NAME  (Function) 
--
CREATE OR REPLACE FUNCTION
LOOKUP_PACKAGE_NAME(name_in IN VARCHAR2, ignore_null in number := 0)
RETURN NUMBER
DETERMINISTIC
IS
	PRAGMA AUTONOMOUS_TRANSACTION;
	name_id		NUMBER;
BEGIN
	if ignore_null = 1 and name_in is null then
		return null;
	end if;
	SELECT id
          INTO name_id
          FROM rhnPackageName
         WHERE name = name_in;
	RETURN name_id;
EXCEPTION
        WHEN NO_DATA_FOUND THEN
            INSERT INTO rhnPackageName (id, name)
                VALUES (rhn_pkg_name_seq.nextval, name_in)
                RETURNING id INTO name_id;
            COMMIT;
	RETURN name_id;
END;
/

--
-- 194. LOOKUP_CHANNEL_ARCH  (Function) 
--
CREATE OR REPLACE FUNCTION
LOOKUP_CHANNEL_ARCH(label_in IN VARCHAR2)
RETURN NUMBER
DETERMINISTIC
IS
	PRAGMA AUTONOMOUS_TRANSACTION;
	channel_arch_id		NUMBER;
BEGIN
	SELECT id
          INTO channel_arch_id
          FROM rhnChannelArch
         WHERE label = label_in;
	RETURN channel_arch_id;
EXCEPTION
        WHEN NO_DATA_FOUND THEN
            rhn_exception.raise_exception('channel_arch_not_found');
END;
/

--
-- 202. LOOKUP_SERVER_ARCH  (Function) 
--
CREATE OR REPLACE FUNCTION
LOOKUP_SERVER_ARCH(label_in IN VARCHAR2)
RETURN NUMBER
DETERMINISTIC
IS
	PRAGMA AUTONOMOUS_TRANSACTION;
	server_arch_id		NUMBER;
BEGIN
	SELECT id
          INTO server_arch_id
          FROM rhnServerArch
         WHERE label = label_in;
	RETURN server_arch_id;
EXCEPTION
        WHEN NO_DATA_FOUND THEN
            rhn_exception.raise_exception('server_arch_not_found');
END;
/

--
-- 107. RHNSERVERCHANNELARCHCOMPAT  (Table) 
--
CREATE TABLE RHNSERVERCHANNELARCHCOMPAT
(
  SERVER_ARCH_ID   NUMBER,
  CHANNEL_ARCH_ID  NUMBER,
  CREATED          DATE                         DEFAULT (sysdate),
  MODIFIED         DATE                         DEFAULT (sysdate)
)
LOGGING 
NOCACHE
NOPARALLEL;

insert into rhnServerChannelArchCompat (server_arch_id, channel_arch_id) values
(LOOKUP_SERVER_ARCH('i386-redhat-linux'), LOOKUP_CHANNEL_ARCH('channel-ia32'));

insert into rhnServerChannelArchCompat (server_arch_id, channel_arch_id) values
(LOOKUP_SERVER_ARCH('i486-redhat-linux'), LOOKUP_CHANNEL_ARCH('channel-ia32'));

insert into rhnServerChannelArchCompat (server_arch_id, channel_arch_id) values
(LOOKUP_SERVER_ARCH('i586-redhat-linux'), LOOKUP_CHANNEL_ARCH('channel-ia32'));

insert into rhnServerChannelArchCompat (server_arch_id, channel_arch_id) values
(LOOKUP_SERVER_ARCH('i686-redhat-linux'), LOOKUP_CHANNEL_ARCH('channel-ia32'));

insert into rhnServerChannelArchCompat (server_arch_id, channel_arch_id) values
(LOOKUP_SERVER_ARCH('athlon-redhat-linux'), LOOKUP_CHANNEL_ARCH('channel-ia32'));

insert into rhnServerChannelArchCompat (server_arch_id, channel_arch_id) values
(LOOKUP_SERVER_ARCH('alpha-redhat-linux'), LOOKUP_CHANNEL_ARCH('channel-alpha'));

insert into rhnServerChannelArchCompat (server_arch_id, channel_arch_id) values
(LOOKUP_SERVER_ARCH('alphaev6-redhat-linux'), LOOKUP_CHANNEL_ARCH('channel-alpha'));

insert into rhnServerChannelArchCompat (server_arch_id, channel_arch_id) values
(LOOKUP_SERVER_ARCH('ia64-redhat-linux'), LOOKUP_CHANNEL_ARCH('channel-ia64'));

insert into rhnServerChannelArchCompat (server_arch_id, channel_arch_id) values
(LOOKUP_SERVER_ARCH('sparc-redhat-linux'), LOOKUP_CHANNEL_ARCH('channel-sparc'));

insert into rhnServerChannelArchCompat (server_arch_id, channel_arch_id) values
(LOOKUP_SERVER_ARCH('sparcv9-redhat-linux'), LOOKUP_CHANNEL_ARCH('channel-sparc'));

insert into rhnServerChannelArchCompat (server_arch_id, channel_arch_id) values
(LOOKUP_SERVER_ARCH('sparc64-redhat-linux'), LOOKUP_CHANNEL_ARCH('channel-sparc'));

insert into rhnServerChannelArchCompat (server_arch_id, channel_arch_id) values
(LOOKUP_SERVER_ARCH('s390-redhat-linux'), LOOKUP_CHANNEL_ARCH('channel-s390'));

insert into rhnServerChannelArchCompat (server_arch_id, channel_arch_id) values
(LOOKUP_SERVER_ARCH('s390x-redhat-linux'), LOOKUP_CHANNEL_ARCH('channel-s390x'));

insert into rhnServerChannelArchCompat (server_arch_id, channel_arch_id) values
(LOOKUP_SERVER_ARCH('pSeries-redhat-linux'), LOOKUP_CHANNEL_ARCH('channel-pSeries'));

insert into rhnServerChannelArchCompat (server_arch_id, channel_arch_id) values
(LOOKUP_SERVER_ARCH('iSeries-redhat-linux'), LOOKUP_CHANNEL_ARCH('channel-iSeries'));

insert into rhnServerChannelArchCompat (server_arch_id, channel_arch_id) values
(LOOKUP_SERVER_ARCH('x86_64-redhat-linux'), LOOKUP_CHANNEL_ARCH('channel-x86_64'));


commit;

CREATE OR REPLACE TRIGGER RHN_SATCERT_MOD_TRIG
BEFORE INSERT OR UPDATE ON RHNSATELLITECERT
FOR EACH ROW
begin
	:new.modified := sysdate;
end;
/
ALTER TABLE RHNSATELLITECERT ADD CONSTRAINT RHN_SATCERT_CERT_NN CHECK ("CERT" IS NOT NULL);
ALTER TABLE RHNSATELLITECERT ADD CONSTRAINT RHN_SATCERT_CREATED_NN CHECK ("CREATED" IS NOT NULL);
ALTER TABLE RHNSATELLITECERT ADD CONSTRAINT RHN_SATCERT_MODIFIED_NN CHECK ("MODIFIED" IS NOT NULL);


--
-- 108. RHNSERVERPACKAGEARCHCOMPAT  (Table) 
--
CREATE TABLE RHNSERVERPACKAGEARCHCOMPAT
(
  SERVER_ARCH_ID   NUMBER,
  PACKAGE_ARCH_ID  NUMBER,
  PREFERENCE       NUMBER,
  CREATED          DATE                         DEFAULT (sysdate),
  MODIFIED         DATE                         DEFAULT (sysdate)
)
LOGGING 
NOCACHE
NOPARALLEL;

insert into rhnServerPackageArchCompat
(server_arch_id, package_arch_id, preference) values
(LOOKUP_SERVER_ARCH('i486-redhat-linux'), LOOKUP_PACKAGE_ARCH('noarch'), 1000);

insert into rhnServerPackageArchCompat
(server_arch_id, package_arch_id, preference) values
(LOOKUP_SERVER_ARCH('i586-redhat-linux'), LOOKUP_PACKAGE_ARCH('i586'), 0);

insert into rhnServerPackageArchCompat
(server_arch_id, package_arch_id, preference) values
(LOOKUP_SERVER_ARCH('i586-redhat-linux'), LOOKUP_PACKAGE_ARCH('i486'), 10);

insert into rhnServerPackageArchCompat
(server_arch_id, package_arch_id, preference) values
(LOOKUP_SERVER_ARCH('i586-redhat-linux'), LOOKUP_PACKAGE_ARCH('i386'), 20);

insert into rhnServerPackageArchCompat
(server_arch_id, package_arch_id, preference) values
(LOOKUP_SERVER_ARCH('i586-redhat-linux'), LOOKUP_PACKAGE_ARCH('noarch'), 1000);

insert into rhnServerPackageArchCompat
(server_arch_id, package_arch_id, preference) values
(LOOKUP_SERVER_ARCH('i686-redhat-linux'), LOOKUP_PACKAGE_ARCH('i686'), 0);

insert into rhnServerPackageArchCompat
(server_arch_id, package_arch_id, preference) values
(LOOKUP_SERVER_ARCH('i686-redhat-linux'), LOOKUP_PACKAGE_ARCH('i586'), 10);

insert into rhnServerPackageArchCompat
(server_arch_id, package_arch_id, preference) values
(LOOKUP_SERVER_ARCH('i686-redhat-linux'), LOOKUP_PACKAGE_ARCH('i486'), 20);

insert into rhnServerPackageArchCompat
(server_arch_id, package_arch_id, preference) values
(LOOKUP_SERVER_ARCH('i686-redhat-linux'), LOOKUP_PACKAGE_ARCH('i386'), 30);

insert into rhnServerPackageArchCompat
(server_arch_id, package_arch_id, preference) values
(LOOKUP_SERVER_ARCH('i686-redhat-linux'), LOOKUP_PACKAGE_ARCH('noarch'), 1000);

insert into rhnServerPackageArchCompat
(server_arch_id, package_arch_id, preference) values
(LOOKUP_SERVER_ARCH('athlon-redhat-linux'), LOOKUP_PACKAGE_ARCH('athlon'), 0);

insert into rhnServerPackageArchCompat
(server_arch_id, package_arch_id, preference) values
(LOOKUP_SERVER_ARCH('athlon-redhat-linux'), LOOKUP_PACKAGE_ARCH('i686'), 10);

insert into rhnServerPackageArchCompat
(server_arch_id, package_arch_id, preference) values
(LOOKUP_SERVER_ARCH('athlon-redhat-linux'), LOOKUP_PACKAGE_ARCH('i586'), 20);

insert into rhnServerPackageArchCompat
(server_arch_id, package_arch_id, preference) values
(LOOKUP_SERVER_ARCH('athlon-redhat-linux'), LOOKUP_PACKAGE_ARCH('i486'), 30);

insert into rhnServerPackageArchCompat
(server_arch_id, package_arch_id, preference) values
(LOOKUP_SERVER_ARCH('athlon-redhat-linux'), LOOKUP_PACKAGE_ARCH('i386'), 40);

insert into rhnServerPackageArchCompat
(server_arch_id, package_arch_id, preference) values
(LOOKUP_SERVER_ARCH('athlon-redhat-linux'), LOOKUP_PACKAGE_ARCH('noarch'), 1000);

insert into rhnServerPackageArchCompat
(server_arch_id, package_arch_id, preference) values
(LOOKUP_SERVER_ARCH('alpha-redhat-linux'), LOOKUP_PACKAGE_ARCH('alpha'), 0);

insert into rhnServerPackageArchCompat
(server_arch_id, package_arch_id, preference) values
(LOOKUP_SERVER_ARCH('alpha-redhat-linux'), LOOKUP_PACKAGE_ARCH('noarch'), 1000);

insert into rhnServerPackageArchCompat
(server_arch_id, package_arch_id, preference) values
(LOOKUP_SERVER_ARCH('alphaev6-redhat-linux'), LOOKUP_PACKAGE_ARCH('alphaev6'), 0);

insert into rhnServerPackageArchCompat
(server_arch_id, package_arch_id, preference) values
(LOOKUP_SERVER_ARCH('alphaev6-redhat-linux'), LOOKUP_PACKAGE_ARCH('alpha'), 10);

insert into rhnServerPackageArchCompat
(server_arch_id, package_arch_id, preference) values
(LOOKUP_SERVER_ARCH('alphaev6-redhat-linux'), LOOKUP_PACKAGE_ARCH('noarch'), 1000);

insert into rhnServerPackageArchCompat
(server_arch_id, package_arch_id, preference) values
(LOOKUP_SERVER_ARCH('ia64-redhat-linux'), LOOKUP_PACKAGE_ARCH('ia64'), 0);

insert into rhnServerPackageArchCompat
(server_arch_id, package_arch_id, preference) values
(LOOKUP_SERVER_ARCH('ia64-redhat-linux'), LOOKUP_PACKAGE_ARCH('i386'), 100);

insert into rhnServerPackageArchCompat
(server_arch_id, package_arch_id, preference) values
(LOOKUP_SERVER_ARCH('ia64-redhat-linux'), LOOKUP_PACKAGE_ARCH('noarch'), 1000);

insert into rhnServerPackageArchCompat
(server_arch_id, package_arch_id, preference) values
(LOOKUP_SERVER_ARCH('sparc-redhat-linux'), LOOKUP_PACKAGE_ARCH('sparc'), 0);

insert into rhnServerPackageArchCompat
(server_arch_id, package_arch_id, preference) values
(LOOKUP_SERVER_ARCH('sparc-redhat-linux'), LOOKUP_PACKAGE_ARCH('noarch'), 1000);

insert into rhnServerPackageArchCompat
(server_arch_id, package_arch_id, preference) values
(LOOKUP_SERVER_ARCH('sparcv9-redhat-linux'), LOOKUP_PACKAGE_ARCH('sparcv9'), 0);

insert into rhnServerPackageArchCompat
(server_arch_id, package_arch_id, preference) values
(LOOKUP_SERVER_ARCH('sparcv9-redhat-linux'), LOOKUP_PACKAGE_ARCH('sparc'), 10);

insert into rhnServerPackageArchCompat
(server_arch_id, package_arch_id, preference) values
(LOOKUP_SERVER_ARCH('sparcv9-redhat-linux'), LOOKUP_PACKAGE_ARCH('noarch'), 1000);

insert into rhnServerPackageArchCompat
(server_arch_id, package_arch_id, preference) values
(LOOKUP_SERVER_ARCH('sparc64-redhat-linux'), LOOKUP_PACKAGE_ARCH('sparc64'), 0);

insert into rhnServerPackageArchCompat
(server_arch_id, package_arch_id, preference) values
(LOOKUP_SERVER_ARCH('sparc64-redhat-linux'), LOOKUP_PACKAGE_ARCH('sparcv9'), 10);

insert into rhnServerPackageArchCompat
(server_arch_id, package_arch_id, preference) values
(LOOKUP_SERVER_ARCH('sparc64-redhat-linux'), LOOKUP_PACKAGE_ARCH('sparc'), 20);

insert into rhnServerPackageArchCompat
(server_arch_id, package_arch_id, preference) values
(LOOKUP_SERVER_ARCH('sparc64-redhat-linux'), LOOKUP_PACKAGE_ARCH('noarch'), 1000);

insert into rhnServerPackageArchCompat
(server_arch_id, package_arch_id, preference) values
(LOOKUP_SERVER_ARCH('s390-redhat-linux'), LOOKUP_PACKAGE_ARCH('s390'), 0);

insert into rhnServerPackageArchCompat
(server_arch_id, package_arch_id, preference) values
(LOOKUP_SERVER_ARCH('s390-redhat-linux'), LOOKUP_PACKAGE_ARCH('noarch'), 1000);

insert into rhnServerPackageArchCompat
(server_arch_id, package_arch_id, preference) values
(LOOKUP_SERVER_ARCH('s390x-redhat-linux'), LOOKUP_PACKAGE_ARCH('s390x'), 0);

insert into rhnServerPackageArchCompat
(server_arch_id, package_arch_id, preference) values
(LOOKUP_SERVER_ARCH('s390x-redhat-linux'), LOOKUP_PACKAGE_ARCH('s390'), 10);

insert into rhnServerPackageArchCompat
(server_arch_id, package_arch_id, preference) values
(LOOKUP_SERVER_ARCH('s390x-redhat-linux'), LOOKUP_PACKAGE_ARCH('noarch'), 1000);

insert into rhnServerPackageArchCompat
(server_arch_id, package_arch_id, preference) values
(LOOKUP_SERVER_ARCH('ppc-redhat-linux'), LOOKUP_PACKAGE_ARCH('ppc'), 0);

insert into rhnServerPackageArchCompat
(server_arch_id, package_arch_id, preference) values
(LOOKUP_SERVER_ARCH('ppc-redhat-linux'), LOOKUP_PACKAGE_ARCH('noarch'), 1000);

insert into rhnServerPackageArchCompat
(server_arch_id, package_arch_id, preference) values
(LOOKUP_SERVER_ARCH('ppc64-redhat-linux'), LOOKUP_PACKAGE_ARCH('ppc64'), 0);

insert into rhnServerPackageArchCompat
(server_arch_id, package_arch_id, preference) values
(LOOKUP_SERVER_ARCH('ppc64-redhat-linux'), LOOKUP_PACKAGE_ARCH('ppc'), 10);

insert into rhnServerPackageArchCompat
(server_arch_id, package_arch_id, preference) values
(LOOKUP_SERVER_ARCH('ppc64-redhat-linux'), LOOKUP_PACKAGE_ARCH('noarch'), 1000);

insert into rhnServerPackageArchCompat
(server_arch_id, package_arch_id, preference) values
(LOOKUP_SERVER_ARCH('pSeries-redhat-linux'), LOOKUP_PACKAGE_ARCH('pSeries'), 0);

insert into rhnServerPackageArchCompat
(server_arch_id, package_arch_id, preference) values
(LOOKUP_SERVER_ARCH('pSeries-redhat-linux'), LOOKUP_PACKAGE_ARCH('ppc64'), 10);

insert into rhnServerPackageArchCompat
(server_arch_id, package_arch_id, preference) values
(LOOKUP_SERVER_ARCH('pSeries-redhat-linux'), LOOKUP_PACKAGE_ARCH('ppc'), 20);

insert into rhnServerPackageArchCompat
(server_arch_id, package_arch_id, preference) values
(LOOKUP_SERVER_ARCH('pSeries-redhat-linux'), LOOKUP_PACKAGE_ARCH('noarch'), 1000);

insert into rhnServerPackageArchCompat
(server_arch_id, package_arch_id, preference) values
(LOOKUP_SERVER_ARCH('iSeries-redhat-linux'), LOOKUP_PACKAGE_ARCH('iSeries'), 0);

insert into rhnServerPackageArchCompat
(server_arch_id, package_arch_id, preference) values
(LOOKUP_SERVER_ARCH('iSeries-redhat-linux'), LOOKUP_PACKAGE_ARCH('ppc64'), 10);

insert into rhnServerPackageArchCompat
(server_arch_id, package_arch_id, preference) values
(LOOKUP_SERVER_ARCH('iSeries-redhat-linux'), LOOKUP_PACKAGE_ARCH('ppc'), 20);

insert into rhnServerPackageArchCompat
(server_arch_id, package_arch_id, preference) values
(LOOKUP_SERVER_ARCH('iSeries-redhat-linux'), LOOKUP_PACKAGE_ARCH('noarch'), 1000);

insert into rhnServerPackageArchCompat
(server_arch_id, package_arch_id, preference) values
(LOOKUP_SERVER_ARCH('x86_64-redhat-linux'), LOOKUP_PACKAGE_ARCH('x86_64'), 0);

insert into rhnServerPackageArchCompat
(server_arch_id, package_arch_id, preference) values
(LOOKUP_SERVER_ARCH('x86_64-redhat-linux'), LOOKUP_PACKAGE_ARCH('athlon'), 100);

insert into rhnServerPackageArchCompat
(server_arch_id, package_arch_id, preference) values
(LOOKUP_SERVER_ARCH('x86_64-redhat-linux'), LOOKUP_PACKAGE_ARCH('i686'), 110);

insert into rhnServerPackageArchCompat
(server_arch_id, package_arch_id, preference) values
(LOOKUP_SERVER_ARCH('x86_64-redhat-linux'), LOOKUP_PACKAGE_ARCH('i586'), 120);

insert into rhnServerPackageArchCompat
(server_arch_id, package_arch_id, preference) values
(LOOKUP_SERVER_ARCH('x86_64-redhat-linux'), LOOKUP_PACKAGE_ARCH('i486'), 130);

insert into rhnServerPackageArchCompat
(server_arch_id, package_arch_id, preference) values
(LOOKUP_SERVER_ARCH('x86_64-redhat-linux'), LOOKUP_PACKAGE_ARCH('i386'), 140);

insert into rhnServerPackageArchCompat
(server_arch_id, package_arch_id, preference) values
(LOOKUP_SERVER_ARCH('x86_64-redhat-linux'), LOOKUP_PACKAGE_ARCH('noarch'), 1000);


commit;





commit;
create table tmp_arch_name_label 
    (
	name varchar2(64),
	label varchar2(64)
    ); 
insert into tmp_arch_name_label (name, label)
    values ('i386', 'ia32');
insert into tmp_arch_name_label (name, label)
    values ('ia64', 'ia64');
insert into tmp_arch_name_label (name, label)
    values ('sparc', 'sparc');
insert into tmp_arch_name_label (name, label)
    values ('alpha', 'alpha');
insert into tmp_arch_name_label (name, label)
    values ('s390', 's390');
insert into tmp_arch_name_label (name, label)
    values ('s390x', 's390x');
insert into tmp_arch_name_label (name, label)
    values ('iSeries', 'iSeries');
insert into tmp_arch_name_label (name, label)
    values ('pSeries', 'pSeries');

commit;




















--
-- 109. RHNSURVEY  (Table) 
--
CREATE TABLE RHNSURVEY
(
  ID        NUMBER,
  LABEL     VARCHAR2(64),
  CLASS     VARCHAR2(64),
  FILENAME  VARCHAR2(256),
  ACTIVE    CHAR(1)                             DEFAULT ('Y')
)
LOGGING 
NOCACHE
NOPARALLEL;

--
-- 110. RHNSURVEYQUESTION  (Table) 
--
CREATE TABLE RHNSURVEYQUESTION
(
  ID         NUMBER,
  SURVEY_ID  NUMBER,
  LABEL      VARCHAR2(64)
)
LOGGING 
NOCACHE
NOPARALLEL;

--
-- 111. RHNTEMPLATECATEGORY  (Table) 
--
CREATE TABLE RHNTEMPLATECATEGORY
(
  ID           NUMBER,
  LABEL        VARCHAR2(64),
  DESCRIPTION  VARCHAR2(512),
  CREATED      DATE                             DEFAULT (sysdate),
  MODIFIED     DATE                             DEFAULT (sysdate)
)
LOGGING 
NOCACHE
NOPARALLEL;

--
-- 112. RHNTEMPLATESTRING  (Table) 
--
CREATE TABLE RHNTEMPLATESTRING
(
  ID           NUMBER,
  CATEGORY_ID  NUMBER,
  LABEL        VARCHAR2(64),
  VALUE        VARCHAR2(4000),
  DESCRIPTION  VARCHAR2(512),
  CREATED      DATE                             DEFAULT (sysdate),
  MODIFIED     DATE                             DEFAULT (sysdate)
)
LOGGING 
NOCACHE
NOPARALLEL;

--
-- 113. RHNTRANSACTIONOPERATION  (Table) 
--
CREATE TABLE RHNTRANSACTIONOPERATION
(
  ID        NUMBER,
  LABEL     VARCHAR2(32),
  CREATED   DATE                                DEFAULT (sysdate),
  MODIFIED  DATE                                DEFAULT (sysdate)
)
LOGGING 
NOCACHE
NOPARALLEL;

insert into rhnTransactionOperation (id, label) values (1,'insert');
insert into rhnTransactionOperation (id, label) values (2,'delete');
commit;

--
-- 114. RHNTRANSACTIONPACKAGE  (Table) 
--
CREATE TABLE RHNTRANSACTIONPACKAGE
(
  ID               NUMBER,
  OPERATION        NUMBER,
  NAME_ID          NUMBER,
  EVR_ID           NUMBER,
  PACKAGE_ARCH_ID  NUMBER
)
LOGGING 
NOCACHE
NOPARALLEL;

--
-- 115. RHNUSERMESSAGESTATUS  (Table) 
--
CREATE TABLE RHNUSERMESSAGESTATUS
(
  ID     NUMBER,
  LABEL  VARCHAR2(48)
)
LOGGING 
NOCACHE
NOPARALLEL;

--
-- 116. RHNUSERMESSAGETYPE  (Table) 
--
CREATE TABLE RHNUSERMESSAGETYPE
(
  ID     NUMBER,
  LABEL  VARCHAR2(48),
  NAME   VARCHAR2(96)
)
LOGGING 
NOCACHE
NOPARALLEL;

--
-- 117. RHNUSERSURVEYSTATUSTYPE  (Table) 
--
CREATE TABLE RHNUSERSURVEYSTATUSTYPE
(
  ID     NUMBER,
  LABEL  VARCHAR2(32)
)
LOGGING 
NOCACHE
NOPARALLEL;

insert into rhnUserSurveyStatusType values
	( rhn_usurveystype_id_seq.nextval, 'viewed' );
insert into rhnUserSurveyStatusType values
	( rhn_usurveystype_id_seq.nextval, 'partial' );
insert into rhnUserSurveyStatusType values
	( rhn_usurveystype_id_seq.nextval, 'complete' );
insert into rhnUserSurveyStatusType values
	( rhn_usurveystype_id_seq.nextval, 'scheduled' );

commit;

--
-- 118. WEB_CUSTOMER_NOTIFICATION  (Table) 
--
CREATE TABLE WEB_CUSTOMER_NOTIFICATION
(
  ID                     NUMBER                 NOT NULL,
  ORG_ID                 NUMBER,
  CONTACT_EMAIL_ADDRESS  VARCHAR2(150)          NOT NULL,
  CREATION_DATE          DATE                   NOT NULL
)
LOGGING 
NOCACHE
NOPARALLEL;

--
-- 119. RHNPEC_U_IDX  (Index) 
--
CREATE INDEX RHNPEC_U_IDX ON RHNPAIDERRATATEMPCACHE
(USER_ID);

--
-- 120. RHN_CARCH_ID_L_N_IDX  (Index) 
--
CREATE INDEX RHN_CARCH_ID_L_N_IDX ON RHNCHANNELARCH
(ID, LABEL, NAME)
LOGGING
NOPARALLEL;
alter table rhnChannelArch add constraint rhn_carch_id_pk primary key (id);

--
-- 121. RHN_CARCH_L_ID_N_IDX  (Index) 
--
CREATE INDEX RHN_CARCH_L_ID_N_IDX ON RHNCHANNELARCH
(LABEL, ID, NAME)
LOGGING
NOPARALLEL;
alter table rhnChannelArch add constraint rhn_carch_label_uq unique ( label );

--
-- 122. RHN_CPUARCH_ID_L_N_IDX  (Index) 
--
CREATE INDEX RHN_CPUARCH_ID_L_N_IDX ON RHNCPUARCH
(ID, LABEL, NAME)
LOGGING
NOPARALLEL;
alter table rhnCpuArch add constraint rhn_cpuarch_id_pk primary key (id);

--
-- 123. RHN_CPUARCH_L_ID_N_IDX  (Index) 
--
CREATE INDEX RHN_CPUARCH_L_ID_N_IDX ON RHNCPUARCH
(LABEL, ID, NAME)
LOGGING
NOPARALLEL;
alter table rhnCpuArch add constraint rhn_cpuarch_label_uq unique ( label );

--
-- 124. RHN_DAEMONSTATE_LABEL_PK  (Index) 
--
CREATE UNIQUE INDEX RHN_DAEMONSTATE_LABEL_PK ON RHNDAEMONSTATE
(LABEL)
LOGGING
NOPARALLEL;

--
-- 125. RHN_DLGROUPS_NC_UQ  (Index) 
--
CREATE UNIQUE INDEX RHN_DLGROUPS_NC_UQ ON RHNDOWNLOADGROUPS
(GROUP_NAME, DOWNLOAD_CATEGORY)
LOGGING
NOPARALLEL;

--
-- 126. RHN_EASTATE_ID_LABEL_IDX  (Index) 
--
CREATE INDEX RHN_EASTATE_ID_LABEL_IDX ON RHNEMAILADDRESSSTATE
(ID, LABEL)
LOGGING
NOPARALLEL;

--
-- 127. RHN_EASTATE_LABEL_ID_IDX  (Index) 
--
CREATE INDEX RHN_EASTATE_LABEL_ID_IDX ON RHNEMAILADDRESSSTATE
(LABEL, ID)
LOGGING
NOPARALLEL;

--
-- 128. RHN_ERRATAFILE_TYPE_ID_IDX  (Index) 
--
CREATE INDEX RHN_ERRATAFILE_TYPE_ID_IDX ON RHNERRATAFILETYPE
(ID)
LOGGING
NOPARALLEL;

--
-- 129. RHN_ERRATAFILE_TYPE_LABEL_IDX  (Index) 
--
CREATE INDEX RHN_ERRATAFILE_TYPE_LABEL_IDX ON RHNERRATAFILETYPE
(LABEL)
LOGGING
NOPARALLEL;

--
-- 130. RHN_HWCLASS_ID_IDX  (Index) 
--
CREATE INDEX RHN_HWCLASS_ID_IDX ON RHNHARDWARECLASS
(ID)
LOGGING
NOPARALLEL;

--
-- 131. RHN_HWCLASS_LABEL_ID_IDX  (Index) 
--
CREATE INDEX RHN_HWCLASS_LABEL_ID_IDX ON RHNHARDWARECLASS
(LABEL, ID)
LOGGING
NOPARALLEL;

--
-- 132. RHN_HWPNAME_ID_IDX  (Index) 
--
CREATE INDEX RHN_HWPNAME_ID_IDX ON RHNHARDWAREPROPNAME
(ID)
LOGGING
NOPARALLEL;

--
-- 133. RHN_HWPNAME_NAME_ID_IDX  (Index) 
--
CREATE INDEX RHN_HWPNAME_NAME_ID_IDX ON RHNHARDWAREPROPNAME
(NAME, ID)
LOGGING
NOPARALLEL;

--
-- 134. RHN_HWPVALUE_ID_IDX  (Index) 
--
CREATE INDEX RHN_HWPVALUE_ID_IDX ON RHNHARDWAREPROPVALUE
(ID)
LOGGING
NOPARALLEL;

--
-- 135. RHN_HWPVALUE_VALUE_ID_IDX  (Index) 
--
CREATE INDEX RHN_HWPVALUE_VALUE_ID_IDX ON RHNHARDWAREPROPVALUE
(VALUE, ID)
LOGGING
NOPARALLEL;

--
-- 136. RHN_MONITORGRAN_ID_PK  (Index) 
--
CREATE UNIQUE INDEX RHN_MONITORGRAN_ID_PK ON RHNMONITORGRANULARITY
(ID)
LOGGING
NOPARALLEL;

--
-- 137. RHN_MONITORGRAN_LABEL_ID_IDX  (Index) 
--
CREATE INDEX RHN_MONITORGRAN_LABEL_ID_IDX ON RHNMONITORGRANULARITY
(LABEL, ID)
LOGGING
NOPARALLEL;

--
-- 138. RHN_MONITORGRAN_LABEL_UQ  (Index) 
--
CREATE UNIQUE INDEX RHN_MONITORGRAN_LABEL_UQ ON RHNMONITORGRANULARITY
(LABEL)
LOGGING
NOPARALLEL;

--
-- 139. RHN_M_PRIORITY_ID_PK  (Index) 
--
CREATE UNIQUE INDEX RHN_M_PRIORITY_ID_PK ON RHNMESSAGEPRIORITY
(ID)
LOGGING
NOPARALLEL;

--
-- 140. RHN_M_PRIORITY_LABEL_ID_IDX  (Index) 
--
CREATE INDEX RHN_M_PRIORITY_LABEL_ID_IDX ON RHNMESSAGEPRIORITY
(LABEL, ID)
LOGGING
NOPARALLEL;

--
-- 141. RHN_M_PRIORITY_LABEL_UQ  (Index) 
--
CREATE UNIQUE INDEX RHN_M_PRIORITY_LABEL_UQ ON RHNMESSAGEPRIORITY
(LABEL)
LOGGING
NOPARALLEL;

--
-- 142. RHN_M_TYPE_ID_PK  (Index) 
--
CREATE UNIQUE INDEX RHN_M_TYPE_ID_PK ON RHNMESSAGETYPE
(ID)
LOGGING
NOPARALLEL;

--
-- 143. RHN_M_TYPE_LABEL_ID_IDX  (Index) 
--
CREATE INDEX RHN_M_TYPE_LABEL_ID_IDX ON RHNMESSAGETYPE
(LABEL, ID)
LOGGING
NOPARALLEL;

--
-- 144. RHN_M_TYPE_LABEL_UQ  (Index) 
--
CREATE UNIQUE INDEX RHN_M_TYPE_LABEL_UQ ON RHNMESSAGETYPE
(LABEL)
LOGGING
NOPARALLEL;

--
-- 145. RHN_M_TYPE_NAME_UQ  (Index) 
--
CREATE UNIQUE INDEX RHN_M_TYPE_NAME_UQ ON RHNMESSAGETYPE
(NAME)
LOGGING
NOPARALLEL;

--
-- 146. RHN_OASTATES_ID_LABEL_IDX  (Index) 
--
CREATE INDEX RHN_OASTATES_ID_LABEL_IDX ON RHNORGAVAILABLESTATES
(ID, LABEL)
LOGGING
NOPARALLEL;

--
-- 147. RHN_OASTATES_LABEL_ID_IDX  (Index) 
--
CREATE INDEX RHN_OASTATES_LABEL_ID_IDX ON RHNORGAVAILABLESTATES
(LABEL, ID)
LOGGING
NOPARALLEL;

--
-- 148. RHN_OSTRANSITIONS_FS_TS_IDX  (Index) 
--
CREATE INDEX RHN_OSTRANSITIONS_FS_TS_IDX ON RHNORGSTATETRANSITIONS
(FROM_STATE, TO_STATE)
LOGGING
NOPARALLEL;

--
-- 149. RHN_PARCH_ID_L_N_IDX  (Index) 
--
CREATE INDEX RHN_PARCH_ID_L_N_IDX ON RHNPACKAGEARCH
(ID, LABEL, NAME)
LOGGING
NOPARALLEL;

alter table rhnPackageArch add constraint rhn_parch_id_pk primary key (id);

--
-- 150. RHN_PARCH_L_ID_N_IDX  (Index) 
--
CREATE INDEX RHN_PARCH_L_ID_N_IDX ON RHNPACKAGEARCH
(LABEL, ID, NAME)
LOGGING
NOPARALLEL;

alter table rhnPackageArch add constraint rhn_parch_label_uq unique ( label );

--
-- 151. RHN_PROD_LINE_ID_IDX  (Index) 
--
CREATE INDEX RHN_PROD_LINE_ID_IDX ON RHNPRODUCTLINE
(ID)
LOGGING
NOPARALLEL;

--
-- 152. RHN_PROD_LINE_LABEL_IDX  (Index) 
--
CREATE INDEX RHN_PROD_LINE_LABEL_IDX ON RHNPRODUCTLINE
(LABEL)
LOGGING
NOPARALLEL;

--
-- 153. RHN_PROD_LINE_NAME_IDX  (Index) 
--
CREATE INDEX RHN_PROD_LINE_NAME_IDX ON RHNPRODUCTLINE
(NAME)
LOGGING
NOPARALLEL;

--
-- 154. RHN_RELTYPE_ID_LABEL_IDX  (Index) 
--
CREATE INDEX RHN_RELTYPE_ID_LABEL_IDX ON RHNRELATIONSHIPTYPE
(ID, LABEL)
LOGGING
NOPARALLEL;

--
-- 155. RHN_RELTYPE_LABEL_ID_IDX  (Index) 
--
CREATE INDEX RHN_RELTYPE_LABEL_ID_IDX ON RHNRELATIONSHIPTYPE
(LABEL, ID)
LOGGING
NOPARALLEL;

--
-- 156. RHN_SARCH_ID_L_N_IDX  (Index) 
--
CREATE INDEX RHN_SARCH_ID_L_N_IDX ON RHNSERVERARCH
(ID, LABEL, NAME)
LOGGING
NOPARALLEL;
alter table rhnServerArch add constraint rhn_sarch_id_pk primary key (id);

--
-- 157. RHN_SARCH_L_ID_N_IDX  (Index) 
--
CREATE INDEX RHN_SARCH_L_ID_N_IDX ON RHNSERVERARCH
(LABEL, ID, NAME)
LOGGING
NOPARALLEL;
alter table rhnServerArch add constraint rhn_sarch_label_uq unique ( label );

--
-- 158. RHN_SC_AC_CAID_PAID  (Index) 
--
CREATE INDEX RHN_SC_AC_CAID_PAID ON RHNSERVERCHANNELARCHCOMPAT
(SERVER_ARCH_ID, CHANNEL_ARCH_ID)
LOGGING
NOPARALLEL;

--
-- 159. RHN_SC_AC_PAID_CAID  (Index) 
--
CREATE INDEX RHN_SC_AC_PAID_CAID ON RHNSERVERCHANNELARCHCOMPAT
(CHANNEL_ARCH_ID, SERVER_ARCH_ID)
LOGGING
NOPARALLEL;

--
-- 160. RHN_SC_AC_SAID_UQ  (Index) 
--
CREATE UNIQUE INDEX RHN_SC_AC_SAID_UQ ON RHNSERVERCHANNELARCHCOMPAT
(SERVER_ARCH_ID)
LOGGING
NOPARALLEL;

--
-- 161. RHN_SP_AC_PAID_SAID_PREF  (Index) 
--
CREATE INDEX RHN_SP_AC_PAID_SAID_PREF ON RHNSERVERPACKAGEARCHCOMPAT
(PACKAGE_ARCH_ID, SERVER_ARCH_ID, PREFERENCE)
LOGGING
NOPARALLEL;

--
-- 162. RHN_SP_AC_PREF_SAID_UQ  (Index) 
--
CREATE UNIQUE INDEX RHN_SP_AC_PREF_SAID_UQ ON RHNSERVERPACKAGEARCHCOMPAT
(PREFERENCE, SERVER_ARCH_ID)
LOGGING
NOPARALLEL;

--
-- 163. RHN_SP_AC_SAID_PAID_PREF  (Index) 
--
CREATE INDEX RHN_SP_AC_SAID_PAID_PREF ON RHNSERVERPACKAGEARCHCOMPAT
(SERVER_ARCH_ID, PACKAGE_ARCH_ID, PREFERENCE)
LOGGING
NOPARALLEL;

--
-- 164. RHN_SQUESTION_ID_PK  (Index) 
--
CREATE UNIQUE INDEX RHN_SQUESTION_ID_PK ON RHNSURVEYQUESTION
(ID)
LOGGING
NOPARALLEL;

--
-- 165. RHN_SQUESTION_LABEL_SID_ID_IDX  (Index) 
--
CREATE INDEX RHN_SQUESTION_LABEL_SID_ID_IDX ON RHNSURVEYQUESTION
(LABEL, SURVEY_ID, ID)
LOGGING
NOPARALLEL;

--
-- 166. RHN_SQUESTION_SID_ID_IDX  (Index) 
--
CREATE INDEX RHN_SQUESTION_SID_ID_IDX ON RHNSURVEYQUESTION
(SURVEY_ID, ID)
LOGGING
NOPARALLEL;

--
-- 167. RHN_SSTYPE_ID_LABEL_IDX  (Index) 
--
CREATE INDEX RHN_SSTYPE_ID_LABEL_IDX ON RHNSAVEDSEARCHTYPE
(ID, LABEL)
LOGGING
NOPARALLEL;

--
-- 168. RHN_SSTYPE_LABEL_ID_IDX  (Index) 
--
CREATE INDEX RHN_SSTYPE_LABEL_ID_IDX ON RHNSAVEDSEARCHTYPE
(LABEL, ID)
LOGGING
NOPARALLEL;

--
-- 169. RHN_SURVEY_ID_LABEL_IDX  (Index) 
--
CREATE INDEX RHN_SURVEY_ID_LABEL_IDX ON RHNSURVEY
(ID, LABEL)
LOGGING
NOPARALLEL;

--
-- 170. RHN_SURVEY_LABEL_ID_IDX  (Index) 
--
CREATE INDEX RHN_SURVEY_LABEL_ID_IDX ON RHNSURVEY
(LABEL, ID)
LOGGING
NOPARALLEL;

--
-- 171. RHN_TEMPLATE_CAT_ID_IDX  (Index) 
--
CREATE INDEX RHN_TEMPLATE_CAT_ID_IDX ON RHNTEMPLATECATEGORY
(ID)
LOGGING
NOPARALLEL;

--
-- 172. RHN_TEMPLATE_CAT_LABEL_ID_IDX  (Index) 
--
CREATE INDEX RHN_TEMPLATE_CAT_LABEL_ID_IDX ON RHNTEMPLATECATEGORY
(LABEL, ID)
LOGGING
NOPARALLEL;

--
-- 173. RHN_TEMPLATE_STR_CID_LABEL_IDX  (Index) 
--
CREATE INDEX RHN_TEMPLATE_STR_CID_LABEL_IDX ON RHNTEMPLATESTRING
(CATEGORY_ID, LABEL)
LOGGING
NOPARALLEL;

--
-- 174. RHN_TEMPLATE_STR_ICL_IDX  (Index) 
--
CREATE INDEX RHN_TEMPLATE_STR_ICL_IDX ON RHNTEMPLATESTRING
(ID, CATEGORY_ID, LABEL)
LOGGING
NOPARALLEL;

--
-- 175. RHN_TRANSOP_ID_PK  (Index) 
--
CREATE UNIQUE INDEX RHN_TRANSOP_ID_PK ON RHNTRANSACTIONOPERATION
(ID)
LOGGING
NOPARALLEL;

--
-- 176. RHN_TRANSOP_LABEL_ID_IDX  (Index) 
--
CREATE INDEX RHN_TRANSOP_LABEL_ID_IDX ON RHNTRANSACTIONOPERATION
(LABEL, ID)
LOGGING
NOPARALLEL;

--
-- 177. RHN_TRANSOP_LABEL_UQ  (Index) 
--
CREATE UNIQUE INDEX RHN_TRANSOP_LABEL_UQ ON RHNTRANSACTIONOPERATION
(LABEL)
LOGGING
NOPARALLEL;

--
-- 178. RHN_TRANSPACK_ID_PK  (Index) 
--
CREATE UNIQUE INDEX RHN_TRANSPACK_ID_PK ON RHNTRANSACTIONPACKAGE
(ID)
LOGGING
NOPARALLEL;

--
-- 179. RHN_TRANSPACK_ONEA_UQ  (Index) 
--
CREATE UNIQUE INDEX RHN_TRANSPACK_ONEA_UQ ON RHNTRANSACTIONPACKAGE
(OPERATION, NAME_ID, EVR_ID, PACKAGE_ARCH_ID)
LOGGING
NOPARALLEL;

--
-- 180. RHN_UM_STATUS_ID_PK  (Index) 
--
CREATE UNIQUE INDEX RHN_UM_STATUS_ID_PK ON RHNUSERMESSAGESTATUS
(ID)
LOGGING
NOPARALLEL;

--
-- 181. RHN_UM_STATUS_LABEL_ID_IDX  (Index) 
--
CREATE INDEX RHN_UM_STATUS_LABEL_ID_IDX ON RHNUSERMESSAGESTATUS
(LABEL, ID)
LOGGING
NOPARALLEL;

--
-- 182. RHN_UM_STATUS_LABEL_UQ  (Index) 
--
CREATE UNIQUE INDEX RHN_UM_STATUS_LABEL_UQ ON RHNUSERMESSAGESTATUS
(LABEL)
LOGGING
NOPARALLEL;

--
-- 183. RHN_UM_TYPE_LABEL_UQ  (Index) 
--
CREATE UNIQUE INDEX RHN_UM_TYPE_LABEL_UQ ON RHNUSERMESSAGETYPE
(LABEL)
LOGGING
NOPARALLEL;

--
-- 184. RHN_UM_TYPE_NAME_UQ  (Index) 
--
CREATE UNIQUE INDEX RHN_UM_TYPE_NAME_UQ ON RHNUSERMESSAGETYPE
(NAME)
LOGGING
NOPARALLEL;

--
-- 185. RHN_UM_TYPE_PK  (Index) 
--
CREATE UNIQUE INDEX RHN_UM_TYPE_PK ON RHNUSERMESSAGETYPE
(ID)
LOGGING
NOPARALLEL;

--
-- 186. RHN_USURVEYSTYPE_ID_LABEL_IDX  (Index) 
--
CREATE INDEX RHN_USURVEYSTYPE_ID_LABEL_IDX ON RHNUSERSURVEYSTATUSTYPE
(ID, LABEL)
LOGGING
NOPARALLEL;

--
-- 187. RHN_USURVEYSTYPE_LABEL_ID_IDX  (Index) 
--
CREATE INDEX RHN_USURVEYSTYPE_LABEL_ID_IDX ON RHNUSERSURVEYSTATUSTYPE
(LABEL, ID)
LOGGING
NOPARALLEL;

--
-- 188. WEB_CUSTOMER_NOTIF_ID_PK  (Index) 
--
CREATE UNIQUE INDEX WEB_CUSTOMER_NOTIF_ID_PK ON WEB_CUSTOMER_NOTIFICATION
(ID)
LOGGING
PARALLEL ( DEGREE 4 INSTANCES 1 );

--
-- 189. RHN_BEL  (Package) 
--
CREATE OR REPLACE package rhn_bel
is
	function find_state_of_org (
		org_id_in in number
	) return varchar2;
	function is_state_legacy_unclassified (
		org_id_in in number
	) return number;
	function is_org_paid (
		org_id_in in number
	) return number;
	function lookup_email_state (
		state_in in varchar2
	) return number;
	function lookup_org_state (
		state_in in varchar2
	) return number;
	procedure validate_org_state_change(
		from_state_in in number,
		to_state_in in number
	);
	procedure join_rhn (
		org_id_in in number
	);
	procedure set_org_paid(
		org_id_in in number
	);
	procedure set_org_unpaid(
		org_id_in in number
	);
end;
/

--
-- 190. RHN_DATE_MANIP  (Package) 
--
CREATE OR REPLACE package rhn_date_manip
is
	periods_ago number;
	function get_reporting_period_start return date;
	function get_reporting_period_end return date;
end rhn_date_manip;
/

--
-- 191. RHN_QOS  (Package) 
--
CREATE OR REPLACE package rhn_qos is
	function slot_count(org_id_in in number, label_in in varchar2) return number;
	function basic_slot_count(org_id_in in number) return number;
	function workgroup_slot_count(org_id_in in number) return number;
	function channel_slot_count(org_id_in in number, label_in in number) return number;
	function as_slot_count(org_id_in in number) return number;
end rhn_qos;
/

--
-- 192. RHN_DATE_MANIP  (Package Body) 
--
CREATE OR REPLACE package body rhn_date_manip
is
	function get_reporting_period_start
	return date is
		months_ago	number;
		weeks_ago	number;
		target_date	date;
		day_number	number;
	begin
		months_ago := rhn_date_manip.periods_ago/2;
		weeks_ago := mod(rhn_date_manip.periods_ago,2);
		target_date := trunc(add_months(sysdate,-months_ago)-(7*weeks_ago));
		day_number := to_char(target_date,'DD');
		if day_number > 16 then
			target_date := target_date - (day_number - 16);
		else
			target_date := target_date - (day_number - 1);
		end if;
		return target_date;
	end get_reporting_period_start;
	function get_reporting_period_end
	return date is
		months_ago	number;
		weeks_ago	number;
		target_date	date;
		day_number	number;
	begin
		months_ago := rhn_date_manip.periods_ago/2;
		weeks_ago := mod(rhn_date_manip.periods_ago,2);
		target_date := trunc(add_months(sysdate,-months_ago)-(7*weeks_ago));
		day_number := to_char(target_date,'DD');
		if day_number > 16 then
			target_date := last_day(target_date);
		else
			target_date := target_date + (-day_number + 15) + (1-1/86400);
		end if;
		return target_date;
	end get_reporting_period_end;
end rhn_date_manip;
/

--
-- 193. ADLER32  (Function) 
--
CREATE OR REPLACE function
adler32(
	buf in varchar2,
	adler in number := 1
) return number
deterministic
is
	s1 number;
	s2 number;
	signed boolean;
	currchar number;
	our_adler number;
begin
	our_adler := mod(adler,4294967296);
        if buf is null then
        	return our_adler;
        end if;
	if our_adler > 2147483647 then
		our_adler := our_adler - 2147483648;
		signed := true;
	else
		our_adler := our_adler;
		signed := false;
	end if;
	s1 := bitand(our_adler,65535);
	s2 := bitand(our_adler,2147418112) / 65536;
	if signed then
		s2 := s2 + 32768;
	end if;
	for n in 1..length(buf) loop
		currchar := ascii(substr(buf,n,1));
		s1 := mod((s1+currchar), 65521);
		s2 := mod((s2 + s1), 65521);
	end loop;
	return s2 * 65536 + s1;
end;
/

--
-- 195. LOOKUP_ERRATAFILE_TYPE  (Function) 
--
CREATE OR REPLACE function
lookup_erratafile_type (
	label_in in varchar2
) return number deterministic is
	pragma autonomous_transaction;
	erratafile_type_id number;
begin
	select	id
	into	erratafile_type_id
	from	rhnErrataFileType
	where	label = label_in;
	return erratafile_type_id;
exception
	when no_data_found then
		rhn_exception.raise_exception('erratafile_type_not_found');
end;
/

--
-- 196. LOOKUP_HW_CLASS  (Function) 
--
CREATE OR REPLACE function
lookup_hw_class(
	class_in in varchar2
) return number
deterministic
is
	pragma autonomous_transaction;
	class_id number;
begin
	select	id
	into	class_id
	from	rhnHardwareClass
	where	label = class_in;
	return class_id;
exception
	when no_data_found then
		insert into rhnHardwareClass ( id, label, class )
			values ( rhn_hwclass_id_seq.nextval, class_in, class_in)
			returning id
			into class_id;
		commit;
	return class_id;
end;
/

--
-- 197. LOOKUP_HW_PROP_NAME  (Function) 
--
CREATE OR REPLACE function
lookup_hw_prop_name(
	name_in in varchar2
) return number
deterministic
is
	pragma autonomous_transaction;
	name_id number;
begin
	select	id
	into	name_id
	from	rhnHardwarePropName
	where	name = name_in;
	return name_id;
exception
	when no_data_found then
		insert into rhnHardwarePropName ( id, name )
			values ( rhn_hwpname_id_seq.nextval, name_in )
			returning id
			into name_id;
	return name_id;
end;
/

--
-- 198. LOOKUP_HW_PROP_VALUE  (Function) 
--
CREATE OR REPLACE function
lookup_hw_prop_value(
	value_in in varchar2
) return number
deterministic
is
	pragma autonomous_transaction;
	value_id number;
begin
	if value_in is null then
		return 1;
	else
		select	id
		into	value_id
		from	rhnHardwarePropValue
		where	value = value_in;
	end if;
	return value_id;
exception
	when no_data_found then
		insert into rhnHardwarePropValue ( id, value )
			values ( rhn_hwpvalue_id_seq.nextval, value_in )
			returning id
			into value_id;
		commit;
	return value_id;
end;
/

--
-- 207. LOOKUP_PACKAGE_CAPABILITY  (Function) 
--
CREATE OR REPLACE FUNCTION
LOOKUP_PACKAGE_CAPABILITY(name_in IN VARCHAR2,
    version_in IN VARCHAR2 DEFAULT NULL)
RETURN NUMBER
DETERMINISTIC
IS
	PRAGMA AUTONOMOUS_TRANSACTION;
	name_id		NUMBER;
BEGIN
	IF version_in IS NULL THEN
		SELECT id
		  INTO name_id
		  FROM rhnPackageCapability
		 WHERE name = name_in
		   AND version IS NULL;
	ELSE
		SELECT id
		  INTO name_id
		  FROM rhnPackageCapability
		 WHERE name = name_in
		   AND version = version_in;
	END IF;
	RETURN name_id;
EXCEPTION
        WHEN NO_DATA_FOUND THEN
            INSERT INTO rhnPackageCapability (id, name, version)
                VALUES (rhn_pkg_capability_id_seq.nextval, name_in, version_in)
                RETURNING id INTO name_id;
            COMMIT;
	RETURN name_id;
END;
/

--
-- 203. RHN_CARCH_MOD_TRIG  (Trigger) 
--
CREATE OR REPLACE TRIGGER RHN_CARCH_MOD_TRIG
BEFORE INSERT OR UPDATE ON RHNCHANNELARCH
FOR EACH ROW
begin
        :new.modified := sysdate;
end;
/

--
-- 204. RHN_CPUARCH_MOD_TRIG  (Trigger) 
--
CREATE OR REPLACE TRIGGER RHN_CPUARCH_MOD_TRIG
BEFORE INSERT OR UPDATE ON RHNCPUARCH
FOR EACH ROW
begin
        :new.modified := sysdate;
end;
/

--
-- 205. RHN_EASTATE_MOD_TRIG  (Trigger) 
--
CREATE OR REPLACE TRIGGER RHN_EASTATE_MOD_TRIG
BEFORE INSERT OR UPDATE ON RHNEMAILADDRESSSTATE
FOR EACH ROW
begin
        :new.modified := sysdate;
end;
/

--
-- 206. RHN_OASTATES_MOD_TRIG  (Trigger) 
--
CREATE OR REPLACE TRIGGER RHN_OASTATES_MOD_TRIG
BEFORE INSERT OR UPDATE ON RHNORGAVAILABLESTATES
FOR EACH ROW
begin
	:new.modified := sysdate;
end;
/

--
-- 207. RHN_PARCH_MOD_TRIG  (Trigger) 
--
CREATE OR REPLACE TRIGGER RHN_PARCH_MOD_TRIG
BEFORE INSERT OR UPDATE ON RHNPACKAGEARCH
FOR EACH ROW
begin
        :new.modified := sysdate;
end;
/

--
-- 208. RHN_PROD_LINE_MOD_TRIG  (Trigger) 
--
CREATE OR REPLACE TRIGGER RHN_PROD_LINE_MOD_TRIG
BEFORE INSERT OR UPDATE ON RHNPRODUCTLINE
FOR EACH ROW
begin
	:new.modified := sysdate;
	:new.last_modified := sysdate;
end;
/

--
-- 209. RHN_RELTYPE_MOD_TRIG  (Trigger) 
--
CREATE OR REPLACE TRIGGER RHN_RELTYPE_MOD_TRIG
BEFORE INSERT OR UPDATE ON RHNRELATIONSHIPTYPE
FOR EACH ROW
begin
	:new.modified := sysdate;
end;
/


--
-- 210. RHN_SARCH_MOD_TRIG  (Trigger) 
--
CREATE OR REPLACE TRIGGER RHN_SARCH_MOD_TRIG
BEFORE INSERT OR UPDATE ON RHNSERVERARCH
FOR EACH ROW
begin
        :new.modified := sysdate;
end;
/


--
-- 211. RHN_SC_AC_MOD_TRIG  (Trigger) 
--
CREATE OR REPLACE TRIGGER RHN_SC_AC_MOD_TRIG
BEFORE INSERT OR UPDATE ON RHNSERVERCHANNELARCHCOMPAT
FOR EACH ROW
begin
        :new.modified := sysdate;
end;
/


--
-- 212. RHN_SP_AC_MOD_TRIG  (Trigger) 
--
CREATE OR REPLACE TRIGGER RHN_SP_AC_MOD_TRIG
BEFORE INSERT OR UPDATE ON RHNSERVERPACKAGEARCHCOMPAT
FOR EACH ROW
begin
        :new.modified := sysdate;
end;
/


--
-- 213. RHN_TEMPLATE_CAT_MOD_TRIG  (Trigger) 
--
CREATE OR REPLACE TRIGGER RHN_TEMPLATE_CAT_MOD_TRIG
BEFORE INSERT OR UPDATE ON RHNTEMPLATECATEGORY
FOR EACH ROW
begin
	:new.modified := sysdate;
end;
/


--
-- 214. RHN_TEMPLATE_STR_MOD_TRIG  (Trigger) 
--
CREATE OR REPLACE TRIGGER RHN_TEMPLATE_STR_MOD_TRIG
BEFORE INSERT OR UPDATE ON RHNTEMPLATESTRING
FOR EACH ROW
begin
	:new.modified := sysdate;
end;
/


--
-- 215. RHN_TRANSOP_MOD_TRIG  (Trigger) 
--
CREATE OR REPLACE TRIGGER RHN_TRANSOP_MOD_TRIG
BEFORE INSERT OR UPDATE ON RHNTRANSACTIONOPERATION
FOR EACH ROW
begin
	:new.modified := sysdate;
end;
/


--
-- 216. RHNBLACKLISTOBSOLETES  (Table) 
--
CREATE TABLE RHNBLACKLISTOBSOLETES
(
  NAME_ID          NUMBER,
  EVR_ID           NUMBER,
  PACKAGE_ARCH_ID  NUMBER,
  IGNORE_NAME_ID   NUMBER,
  CREATED          DATE                         DEFAULT (sysdate),
  MODIFIED         DATE                         DEFAULT (sysdate)
)
LOGGING 
NOCACHE
NOPARALLEL;

insert into rhnBlacklistObsoletes
  (name_id, evr_id, package_arch_id, ignore_name_id)
values (
    LOOKUP_PACKAGE_NAME('gated'), LOOKUP_EVR(NULL, '3.6', '12'), 
    LOOKUP_PACKAGE_ARCH('i386'), LOOKUP_PACKAGE_NAME('zebra')
);

insert into rhnBlacklistObsoletes
  (name_id, evr_id, package_arch_id, ignore_name_id)
values (
    LOOKUP_PACKAGE_NAME('zebra'), LOOKUP_EVR(NULL, '0.91a', '6'), 
    LOOKUP_PACKAGE_ARCH('i386'), LOOKUP_PACKAGE_NAME('gated')
);

-- 7.2 does not contain gated, so zebra obsoletes gated is valid there

insert into rhnBlacklistObsoletes
  (name_id, evr_id, package_arch_id, ignore_name_id)
select
    LOOKUP_PACKAGE_NAME('gated'), LOOKUP_EVR(NULL, '3.6', '10'), 
    pa.id, LOOKUP_PACKAGE_NAME('zebra')
from rhnPackageArch pa
where pa.label in ('i386', 'alpha');

insert into rhnBlacklistObsoletes
  (name_id, evr_id, package_arch_id, ignore_name_id)
select
    LOOKUP_PACKAGE_NAME('zebra'), LOOKUP_EVR(NULL, '0.91a', '3'), 
    pa.id, LOOKUP_PACKAGE_NAME('gated')
from rhnPackageArch pa
where pa.label in ('i386', 'alpha');

commit;

--
-- 217. CHANNEL_ARCH_ID  (Column) 
--
ALTER TABLE RHNCHANNEL ADD (CHANNEL_ARCH_ID  NUMBER);
update rhnChannel
set channel_arch_id = (select ca.id 
    from rhnChannelArch ca, rhnArch a, tmp_arch_name_label afnl
    where a.id = arch
    and a.name = afnl.name
    and ca.label = 'channel-' || afnl.label);
commit;

--
-- 218. GPG_KEY_URL  (Column) 
--
ALTER TABLE RHNCHANNEL ADD (GPG_KEY_URL  VARCHAR2(256));

--
-- 219. GPG_KEY_ID  (Column) 
--
ALTER TABLE RHNCHANNEL ADD (GPG_KEY_ID  VARCHAR2(14));

--
-- 220. GPG_KEY_FP  (Column) 
--
ALTER TABLE RHNCHANNEL ADD (GPG_KEY_FP  VARCHAR2(50));

--
-- 221. ARCH  (Column) 
--
ALTER TABLE RHNCHANNEL DROP COLUMN ARCH;

--
-- 222. RHNCHANNELFAMILYLICENSE  (Table) 
--
CREATE TABLE RHNCHANNELFAMILYLICENSE
(
  CHANNEL_FAMILY_ID  NUMBER,
  LICENSE_PATH       VARCHAR2(1000),
  CREATED            DATE                       DEFAULT (sysdate),
  MODIFIED           DATE                       DEFAULT (sysdate)
)
LOGGING 
NOCACHE
NOPARALLEL;

--
-- 223. RHNCHANNELNEWESTPACKAGEAUDIT  (Table) 
--
CREATE TABLE RHNCHANNELNEWESTPACKAGEAUDIT
(
  REFRESH_TIME  DATE                            DEFAULT sysdate,
  CHANNEL_ID    NUMBER,
  CALLER        VARCHAR2(256)
)
LOGGING 
NOCACHE
NOPARALLEL;

--
-- 224. RHNCHANNELPACKAGEARCHCOMPAT  (Table) 
--
CREATE TABLE RHNCHANNELPACKAGEARCHCOMPAT
(
  CHANNEL_ARCH_ID  NUMBER,
  PACKAGE_ARCH_ID  NUMBER,
  CREATED          DATE                         DEFAULT (sysdate),
  MODIFIED         DATE                         DEFAULT (sysdate)
)
LOGGING 
NOCACHE
NOPARALLEL;

insert into rhnChannelPackageArchCompat (channel_arch_id, package_arch_id)
values (LOOKUP_CHANNEL_ARCH('channel-ia32'), LOOKUP_PACKAGE_ARCH('noarch'));

insert into rhnChannelPackageArchCompat (channel_arch_id, package_arch_id)
values (LOOKUP_CHANNEL_ARCH('channel-ia32'), LOOKUP_PACKAGE_ARCH('i386'));

insert into rhnChannelPackageArchCompat (channel_arch_id, package_arch_id)
values (LOOKUP_CHANNEL_ARCH('channel-ia32'), LOOKUP_PACKAGE_ARCH('i486'));

insert into rhnChannelPackageArchCompat (channel_arch_id, package_arch_id)
values (LOOKUP_CHANNEL_ARCH('channel-ia32'), LOOKUP_PACKAGE_ARCH('i586'));

insert into rhnChannelPackageArchCompat (channel_arch_id, package_arch_id)
values (LOOKUP_CHANNEL_ARCH('channel-ia32'), LOOKUP_PACKAGE_ARCH('i686'));

insert into rhnChannelPackageArchCompat (channel_arch_id, package_arch_id)
values (LOOKUP_CHANNEL_ARCH('channel-ia32'), LOOKUP_PACKAGE_ARCH('src'));

insert into rhnChannelPackageArchCompat (channel_arch_id, package_arch_id)
values (LOOKUP_CHANNEL_ARCH('channel-ia32'), LOOKUP_PACKAGE_ARCH('athlon'));


insert into rhnChannelPackageArchCompat (channel_arch_id, package_arch_id)
values (LOOKUP_CHANNEL_ARCH('channel-ia64'), LOOKUP_PACKAGE_ARCH('noarch'));

insert into rhnChannelPackageArchCompat (channel_arch_id, package_arch_id)
values (LOOKUP_CHANNEL_ARCH('channel-ia64'), LOOKUP_PACKAGE_ARCH('i386'));

insert into rhnChannelPackageArchCompat (channel_arch_id, package_arch_id)
values (LOOKUP_CHANNEL_ARCH('channel-ia64'), LOOKUP_PACKAGE_ARCH('ia64'));

insert into rhnChannelPackageArchCompat (channel_arch_id, package_arch_id)
values (LOOKUP_CHANNEL_ARCH('channel-ia64'), LOOKUP_PACKAGE_ARCH('src'));


insert into rhnChannelPackageArchCompat (channel_arch_id, package_arch_id)
values (LOOKUP_CHANNEL_ARCH('channel-sparc'), LOOKUP_PACKAGE_ARCH('noarch'));

insert into rhnChannelPackageArchCompat (channel_arch_id, package_arch_id)
values (LOOKUP_CHANNEL_ARCH('channel-sparc'), LOOKUP_PACKAGE_ARCH('sparc'));

insert into rhnChannelPackageArchCompat (channel_arch_id, package_arch_id)
values (LOOKUP_CHANNEL_ARCH('channel-sparc'), LOOKUP_PACKAGE_ARCH('sparcv9'));

insert into rhnChannelPackageArchCompat (channel_arch_id, package_arch_id)
values (LOOKUP_CHANNEL_ARCH('channel-sparc'), LOOKUP_PACKAGE_ARCH('sparc64'));

insert into rhnChannelPackageArchCompat (channel_arch_id, package_arch_id)
values (LOOKUP_CHANNEL_ARCH('channel-sparc'), LOOKUP_PACKAGE_ARCH('src'));


insert into rhnChannelPackageArchCompat (channel_arch_id, package_arch_id)
values (LOOKUP_CHANNEL_ARCH('channel-alpha'), LOOKUP_PACKAGE_ARCH('noarch'));

insert into rhnChannelPackageArchCompat (channel_arch_id, package_arch_id)
values (LOOKUP_CHANNEL_ARCH('channel-alpha'), LOOKUP_PACKAGE_ARCH('alpha'));

insert into rhnChannelPackageArchCompat (channel_arch_id, package_arch_id)
values (LOOKUP_CHANNEL_ARCH('channel-alpha'), LOOKUP_PACKAGE_ARCH('alphaev6'));

insert into rhnChannelPackageArchCompat (channel_arch_id, package_arch_id)
values (LOOKUP_CHANNEL_ARCH('channel-alpha'), LOOKUP_PACKAGE_ARCH('src'));


insert into rhnChannelPackageArchCompat (channel_arch_id, package_arch_id)
values (LOOKUP_CHANNEL_ARCH('channel-s390'), LOOKUP_PACKAGE_ARCH('noarch'));

insert into rhnChannelPackageArchCompat (channel_arch_id, package_arch_id)
values (LOOKUP_CHANNEL_ARCH('channel-s390'), LOOKUP_PACKAGE_ARCH('s390'));

insert into rhnChannelPackageArchCompat (channel_arch_id, package_arch_id)
values (LOOKUP_CHANNEL_ARCH('channel-s390'), LOOKUP_PACKAGE_ARCH('src'));


insert into rhnChannelPackageArchCompat (channel_arch_id, package_arch_id)
values (LOOKUP_CHANNEL_ARCH('channel-s390x'), LOOKUP_PACKAGE_ARCH('noarch'));

insert into rhnChannelPackageArchCompat (channel_arch_id, package_arch_id)
values (LOOKUP_CHANNEL_ARCH('channel-s390x'), LOOKUP_PACKAGE_ARCH('s390'));

insert into rhnChannelPackageArchCompat (channel_arch_id, package_arch_id)
values (LOOKUP_CHANNEL_ARCH('channel-s390x'), LOOKUP_PACKAGE_ARCH('s390x'));

insert into rhnChannelPackageArchCompat (channel_arch_id, package_arch_id)
values (LOOKUP_CHANNEL_ARCH('channel-s390x'), LOOKUP_PACKAGE_ARCH('src'));


insert into rhnChannelPackageArchCompat (channel_arch_id, package_arch_id)
values (LOOKUP_CHANNEL_ARCH('channel-iSeries'), LOOKUP_PACKAGE_ARCH('noarch'));

insert into rhnChannelPackageArchCompat (channel_arch_id, package_arch_id)
values (LOOKUP_CHANNEL_ARCH('channel-iSeries'), LOOKUP_PACKAGE_ARCH('s390x'));

insert into rhnChannelPackageArchCompat (channel_arch_id, package_arch_id)
values (LOOKUP_CHANNEL_ARCH('channel-iSeries'), LOOKUP_PACKAGE_ARCH('ppc'));

insert into rhnChannelPackageArchCompat (channel_arch_id, package_arch_id)
values (LOOKUP_CHANNEL_ARCH('channel-iSeries'), LOOKUP_PACKAGE_ARCH('ppc64'));

insert into rhnChannelPackageArchCompat (channel_arch_id, package_arch_id)
values (LOOKUP_CHANNEL_ARCH('channel-iSeries'), LOOKUP_PACKAGE_ARCH('src'));


insert into rhnChannelPackageArchCompat (channel_arch_id, package_arch_id)
values (LOOKUP_CHANNEL_ARCH('channel-pSeries'), LOOKUP_PACKAGE_ARCH('noarch'));

insert into rhnChannelPackageArchCompat (channel_arch_id, package_arch_id)
values (LOOKUP_CHANNEL_ARCH('channel-pSeries'), LOOKUP_PACKAGE_ARCH('ppc'));

insert into rhnChannelPackageArchCompat (channel_arch_id, package_arch_id)
values (LOOKUP_CHANNEL_ARCH('channel-pSeries'), LOOKUP_PACKAGE_ARCH('ppc64'));

insert into rhnChannelPackageArchCompat (channel_arch_id, package_arch_id)
values (LOOKUP_CHANNEL_ARCH('channel-pSeries'), LOOKUP_PACKAGE_ARCH('src'));


insert into rhnChannelPackageArchCompat (channel_arch_id, package_arch_id)
values (LOOKUP_CHANNEL_ARCH('channel-x86_64'), LOOKUP_PACKAGE_ARCH('noarch'));

insert into rhnChannelPackageArchCompat (channel_arch_id, package_arch_id)
values (LOOKUP_CHANNEL_ARCH('channel-x86_64'), LOOKUP_PACKAGE_ARCH('i386'));

insert into rhnChannelPackageArchCompat (channel_arch_id, package_arch_id)
values (LOOKUP_CHANNEL_ARCH('channel-x86_64'), LOOKUP_PACKAGE_ARCH('i486'));

insert into rhnChannelPackageArchCompat (channel_arch_id, package_arch_id)
values (LOOKUP_CHANNEL_ARCH('channel-x86_64'), LOOKUP_PACKAGE_ARCH('i586'));

insert into rhnChannelPackageArchCompat (channel_arch_id, package_arch_id)
values (LOOKUP_CHANNEL_ARCH('channel-x86_64'), LOOKUP_PACKAGE_ARCH('i686'));

insert into rhnChannelPackageArchCompat (channel_arch_id, package_arch_id)
values (LOOKUP_CHANNEL_ARCH('channel-x86_64'), LOOKUP_PACKAGE_ARCH('athlon'));

insert into rhnChannelPackageArchCompat (channel_arch_id, package_arch_id)
values (LOOKUP_CHANNEL_ARCH('channel-x86_64'), LOOKUP_PACKAGE_ARCH('x86_64'));

insert into rhnChannelPackageArchCompat (channel_arch_id, package_arch_id)
values (LOOKUP_CHANNEL_ARCH('channel-x86_64'), LOOKUP_PACKAGE_ARCH('src'));


commit;

--
-- 225. RHNCHANNELRELATIONSHIP  (Table) 
--
CREATE TABLE RHNCHANNELRELATIONSHIP
(
  FROM_CHANNEL_ID  NUMBER,
  TO_CHANNEL_ID    NUMBER,
  REL_TYPE_ID      NUMBER,
  CREATED          DATE                         DEFAULT (sysdate),
  MODIFIED         DATE                         DEFAULT (sysdate)
)
LOGGING 
NOCACHE
NOPARALLEL;

--
-- 226. RHNDAILYSUMMARYQUEUE  (Table) 
--
CREATE TABLE RHNDAILYSUMMARYQUEUE
(
  ORG_ID    NUMBER,
  CREATED   DATE                                DEFAULT (sysdate),
  MODIFIED  DATE                                DEFAULT (sysdate)
)
LOGGING 
NOCACHE
NOPARALLEL;

--
-- 227. CHANNEL_ARCH_ID  (Column) 
--
ALTER TABLE RHNDISTCHANNELMAP ADD (CHANNEL_ARCH_ID  NUMBER);
update rhnDistChannelMap 
set channel_arch_id = (select ca.id 
    from rhnChannelArch ca, rhnArch a, tmp_arch_name_label afnl
    where a.id = arch
    and a.name = afnl.name
    and ca.label = 'channel-' || afnl.label);
commit;

--
-- 228. ARCH  (Column) 
--
ALTER TABLE RHNDISTCHANNELMAP DROP COLUMN ARCH;

--
-- 229. PRODUCT  (Column) 
--
ALTER TABLE RHNERRATA MODIFY (PRODUCT VARCHAR2(64));

--
-- 230. RHNERRATAFILE  (Table) 
--
CREATE TABLE RHNERRATAFILE
(
  ID         NUMBER,
  ERRATA_ID  NUMBER,
  TYPE       NUMBER,
  MD5SUM     VARCHAR2(64),
  FILENAME   VARCHAR2(128),
  CREATED    DATE                               DEFAULT (sysdate),
  MODIFIED   DATE                               DEFAULT (sysdate)
)
LOGGING 
NOCACHE
NOPARALLEL;

--
-- 231. RHNERRATAFILECHANNEL  (Table) 
--
CREATE TABLE RHNERRATAFILECHANNEL
(
  CHANNEL_ID      NUMBER,
  ERRATA_FILE_ID  NUMBER,
  CREATED         DATE                          DEFAULT (sysdate),
  MODIFIED        DATE                          DEFAULT (sysdate)
)
LOGGING 
NOCACHE
NOPARALLEL;

--
-- 232. RHNERRATANOTIFICATIONQUEUE  (Table) 
--
CREATE TABLE RHNERRATANOTIFICATIONQUEUE
(
  ERRATA_ID    NUMBER,
  ORG_ID       NUMBER,
  NEXT_ACTION  DATE,
  CREATED      DATE                             DEFAULT (sysdate),
  MODIFIED     DATE                             DEFAULT (sysdate)
)
LOGGING 
NOCACHE
NOPARALLEL;

--
-- 233. RHNERRATAQUEUE  (Table) 
--
CREATE TABLE RHNERRATAQUEUE
(
  ERRATA_ID    NUMBER,
  NEXT_ACTION  DATE,
  CREATED      DATE                             DEFAULT (sysdate),
  MODIFIED     DATE                             DEFAULT (sysdate)
)
LOGGING 
NOCACHE
NOPARALLEL;

--
-- 234. RHNERRATARELATIONSHIP  (Table) 
--
CREATE TABLE RHNERRATARELATIONSHIP
(
  FROM_ERRATA_ID  NUMBER,
  TO_ERRATA_ID    NUMBER,
  REL_TYPE_ID     NUMBER,
  CREATED         DATE                          DEFAULT (sysdate),
  MODIFIED        DATE                          DEFAULT (sysdate)
)
LOGGING 
NOCACHE
NOPARALLEL;

--
-- 235. RHNFILELOCATION  (Table) 
--
CREATE TABLE RHNFILELOCATION
(
  FILE_ID   NUMBER,
  LOCATION  VARCHAR2(128)
)
LOGGING 
NOCACHE
NOPARALLEL;

--
-- 236. RHNHARDWARE  (Table) 
--
CREATE TABLE RHNHARDWARE
(
  ID        NUMBER,
  CLASS_ID  NUMBER
)
LOGGING 
NOCACHE
NOPARALLEL;

--
-- 237. RHNHARDWAREPROPERTIES  (Table) 
--
CREATE TABLE RHNHARDWAREPROPERTIES
(
  HARDWARE_ID  NUMBER,
  NAME_ID      NUMBER,
  VALUE_ID     NUMBER
)
LOGGING 
NOCACHE
NOPARALLEL;

--
-- 238. RHNMESSAGE  (Table) 
--
CREATE TABLE RHNMESSAGE
(
  ID            NUMBER,
  MESSAGE_TYPE  NUMBER,
  PRIORITY      NUMBER                          DEFAULT 0,
  CREATED       DATE                            DEFAULT (sysdate),
  MODIFIED      DATE                            DEFAULT (sysdate)
)
LOGGING 
NOCACHE
NOPARALLEL;

--
-- 239. RHNORGSTATE  (Table) 
--
CREATE TABLE RHNORGSTATE
(
  ORG_ID       NUMBER,
  STATE_ID     NUMBER,
  NEXT_ACTION  DATE,
  CREATED      DATE                             DEFAULT (sysdate),
  MODIFIED     DATE                             DEFAULT (sysdate)
)
LOGGING 
NOCACHE
NOPARALLEL;

--
-- 240. RHNORGSTATELOG  (Table) 
--
CREATE TABLE RHNORGSTATELOG
(
  ORG_ID        NUMBER,
  OLD_STATE_ID  NUMBER,
  NEW_STATE_ID  NUMBER,
  REASON        VARCHAR2(4000),
  CREATED       DATE                            DEFAULT (sysdate)
)
LOGGING 
NOCACHE
NOPARALLEL;

--
-- 241. PACKAGE_ARCH_ID  (Column) 
--
ALTER TABLE RHNPACKAGE ADD (PACKAGE_ARCH_ID  NUMBER);
update rhnPackage
set package_arch_id = (select pa.id 
    from rhnPackageArch pa, rhnArch a
    where arch = a.id
    and a.name = pa.label);
commit;

--
-- 242. LAST_MODIFIED  (Column) 
--
ALTER TABLE RHNPACKAGE ADD (LAST_MODIFIED  DATE                           DEFAULT (sysdate));

--
-- 243. ARCH  (Column) 
--
ALTER TABLE RHNPACKAGE DROP COLUMN ARCH;

--
-- 244. LAST_MODIFIED  (Column) 
--
ALTER TABLE RHNPACKAGESOURCE ADD (LAST_MODIFIED  DATE                           DEFAULT (sysdate));

--
-- 245. RHNPAYLOADERCONVERSION  (Table) 
--
CREATE TABLE RHNPAYLOADERCONVERSION
(
  ORG_ID   NUMBER,
  REASON   VARCHAR2(256),
  CREATED  DATE                                 DEFAULT (sysdate)
)
LOGGING 
NOCACHE
NOPARALLEL;

--
-- 246. RHNPRODUCT  (Table) 
--
CREATE TABLE RHNPRODUCT
(
  ID               NUMBER,
  LABEL            VARCHAR2(128),
  NAME             VARCHAR2(128),
  PRODUCT_LINE_ID  NUMBER,
  LAST_MODIFIED    DATE                         DEFAULT (sysdate),
  CREATED          DATE                         DEFAULT (sysdate),
  MODIFIED         DATE                         DEFAULT (sysdate)
)
LOGGING 
NOCACHE
NOPARALLEL;

--
-- 247. RHNPRODUCTCHANNEL  (Table) 
--
CREATE TABLE RHNPRODUCTCHANNEL
(
  CHANNEL_ID  NUMBER,
  PRODUCT_ID  NUMBER,
  CREATED     DATE                              DEFAULT (sysdate),
  MODIFIED    DATE                              DEFAULT (sysdate)
)
LOGGING 
NOCACHE
NOPARALLEL;

--
-- 248. RHNTEXTMESSAGE  (Table) 
--
CREATE TABLE RHNTEXTMESSAGE
(
  MESSAGE_ID    NUMBER,
  MESSAGE_BODY  VARCHAR2(4000),
  CREATED       DATE                            DEFAULT (sysdate),
  MODIFIED      DATE                            DEFAULT (sysdate)
)
LOGGING 
NOCACHE
NOPARALLEL;

--
-- 249. EMAIL_UC  (Column) 
--
ALTER TABLE WEB_USER_PERSONAL_INFO ADD (EMAIL_UC  VARCHAR2(128));

--
-- 250. EMAIL_UC  (Column) 
--
ALTER TABLE WEB_USER_SITE_INFO ADD (EMAIL_UC  VARCHAR2(128));

--
-- 251. RHN_BL_OBS_NEPI_IDX  (Index) 
--
CREATE INDEX RHN_BL_OBS_NEPI_IDX ON RHNBLACKLISTOBSOLETES
(NAME_ID, EVR_ID, PACKAGE_ARCH_ID, IGNORE_NAME_ID)
LOGGING
NOPARALLEL;

--
-- 252. RHN_CF_LICENSE_CFID_UQ  (Index) 
--
CREATE UNIQUE INDEX RHN_CF_LICENSE_CFID_UQ ON RHNCHANNELFAMILYLICENSE
(CHANNEL_FAMILY_ID)
LOGGING
NOPARALLEL;

--
-- 253. RHN_CHANNELREL_FCID_TCID_IDX  (Index) 
--
CREATE INDEX RHN_CHANNELREL_FCID_TCID_IDX ON RHNCHANNELRELATIONSHIP
(FROM_CHANNEL_ID, TO_CHANNEL_ID)
LOGGING
NOPARALLEL;

--
-- 254. RHN_CHANNELREL_TCID_FCID_IDX  (Index) 
--
CREATE INDEX RHN_CHANNELREL_TCID_FCID_IDX ON RHNCHANNELRELATIONSHIP
(TO_CHANNEL_ID, FROM_CHANNEL_ID)
LOGGING
NOPARALLEL;

--
-- 255. RHN_CNP_A_T_ALL_IDX  (Index) 
--
CREATE INDEX RHN_CNP_A_T_ALL_IDX ON RHNCHANNELNEWESTPACKAGEAUDIT
(CHANNEL_ID, REFRESH_TIME, CALLER)
LOGGING
NOPARALLEL;

--
-- 256. RHN_CP_AC_CAID_PAID  (Index) 
--
CREATE INDEX RHN_CP_AC_CAID_PAID ON RHNCHANNELPACKAGEARCHCOMPAT
(CHANNEL_ARCH_ID, PACKAGE_ARCH_ID)
LOGGING
NOPARALLEL;

--
-- 257. RHN_CP_AC_PAID_CAID  (Index) 
--
CREATE INDEX RHN_CP_AC_PAID_CAID ON RHNCHANNELPACKAGEARCHCOMPAT
(PACKAGE_ARCH_ID, CHANNEL_ARCH_ID)
LOGGING
NOPARALLEL;

--
-- 258. RHN_DCM_OS_RELEASE_CAID_IDX  (Index) 
--
CREATE INDEX RHN_DCM_OS_RELEASE_CAID_IDX ON RHNDISTCHANNELMAP
(OS, RELEASE, CHANNEL_ARCH_ID)
LOGGING
NOPARALLEL;

--
-- 259. RHN_DSQUEUE_OID_IDX  (Index) 
--
CREATE INDEX RHN_DSQUEUE_OID_IDX ON RHNDAILYSUMMARYQUEUE
(ORG_ID)
LOGGING
NOPARALLEL;

--
-- 260. RHN_EFILEC_CID_EFID_IDX  (Index) 
--
CREATE INDEX RHN_EFILEC_CID_EFID_IDX ON RHNERRATAFILECHANNEL
(CHANNEL_ID, ERRATA_FILE_ID)
LOGGING
NOPARALLEL;

--
-- 261. RHN_EFILEC_EFID_CID_IDX  (Index) 
--
CREATE INDEX RHN_EFILEC_EFID_CID_IDX ON RHNERRATAFILECHANNEL
(ERRATA_FILE_ID, CHANNEL_ID)
LOGGING
NOPARALLEL;

--
-- 262. RHN_ENQUEUE_EID_IDX  (Index) 
--
CREATE INDEX RHN_ENQUEUE_EID_IDX ON RHNERRATANOTIFICATIONQUEUE
(ERRATA_ID, ORG_ID)
LOGGING
NOPARALLEL;

--
-- 263. RHN_ENQUEUE_NA_EID_IDX  (Index) 
--
CREATE INDEX RHN_ENQUEUE_NA_EID_IDX ON RHNERRATANOTIFICATIONQUEUE
(NEXT_ACTION, ERRATA_ID)
LOGGING
NOPARALLEL;

--
-- 264. RHN_EQUEUE_EID_IDX  (Index) 
--
CREATE INDEX RHN_EQUEUE_EID_IDX ON RHNERRATAQUEUE
(ERRATA_ID)
LOGGING
NOPARALLEL;

--
-- 265. RHN_EQUEUE_NA_EID_IDX  (Index) 
--
CREATE INDEX RHN_EQUEUE_NA_EID_IDX ON RHNERRATAQUEUE
(NEXT_ACTION, ERRATA_ID)
LOGGING
NOPARALLEL;

--
-- 266. RHN_ERRATAFILE_EID_FILE_IDX  (Index) 
--
CREATE INDEX RHN_ERRATAFILE_EID_FILE_IDX ON RHNERRATAFILE
(ERRATA_ID, FILENAME)
LOGGING
NOPARALLEL;

--
-- 267. RHN_ERRATAFILE_ID_IDX  (Index) 
--
CREATE INDEX RHN_ERRATAFILE_ID_IDX ON RHNERRATAFILE
(ID)
LOGGING
NOPARALLEL;

--
-- 268. RHN_ERRATAREL_FEID_TEID_IDX  (Index) 
--
CREATE INDEX RHN_ERRATAREL_FEID_TEID_IDX ON RHNERRATARELATIONSHIP
(FROM_ERRATA_ID, TO_ERRATA_ID)
LOGGING
NOPARALLEL;

--
-- 269. RHN_ERRATAREL_TEID_FEID_IDX  (Index) 
--
CREATE INDEX RHN_ERRATAREL_TEID_FEID_IDX ON RHNERRATARELATIONSHIP
(TO_ERRATA_ID, FROM_ERRATA_ID)
LOGGING
NOPARALLEL;

--
-- 270. RHN_FILELOC_FILE_LOC_UQ  (Index) 
--
CREATE UNIQUE INDEX RHN_FILELOC_FILE_LOC_UQ ON RHNFILELOCATION
(FILE_ID, LOCATION)
LOGGING
NOPARALLEL;

--
-- 271. RHN_HWPROPS_HID_NID_IDX  (Index) 
--
CREATE INDEX RHN_HWPROPS_HID_NID_IDX ON RHNHARDWAREPROPERTIES
(HARDWARE_ID, NAME_ID)
LOGGING
NOPARALLEL;

--
-- 272. RHN_HW_CLASS_ID_IDX  (Index) 
--
CREATE INDEX RHN_HW_CLASS_ID_IDX ON RHNHARDWARE
(CLASS_ID, ID)
LOGGING
NOPARALLEL;

--
-- 273. RHN_HW_ID_IDX  (Index) 
--
CREATE INDEX RHN_HW_ID_IDX ON RHNHARDWARE
(ID)
LOGGING
NOPARALLEL;

--
-- 274. RHN_M_ID_PK  (Index) 
--
CREATE UNIQUE INDEX RHN_M_ID_PK ON RHNMESSAGE
(ID)
LOGGING
NOPARALLEL;

--
-- 275. RHN_OSTATELOG_CREATED_IDX  (Index) 
--
CREATE INDEX RHN_OSTATELOG_CREATED_IDX ON RHNORGSTATELOG
(CREATED)
LOGGING
NOPARALLEL;

--
-- 276. RHN_OSTATELOG_OID_IDX  (Index) 
--
CREATE INDEX RHN_OSTATELOG_OID_IDX ON RHNORGSTATELOG
(ORG_ID)
LOGGING
NOPARALLEL;

--
-- 277. RHN_OSTATE_NA_OID_SID  (Index) 
--
CREATE INDEX RHN_OSTATE_NA_OID_SID ON RHNORGSTATE
(NEXT_ACTION, ORG_ID, STATE_ID)
LOGGING
NOPARALLEL;

--
-- 278. RHN_OSTATE_OID_SID_IDX  (Index) 
--
CREATE INDEX RHN_OSTATE_OID_SID_IDX ON RHNORGSTATE
(ORG_ID, STATE_ID)
LOGGING
NOPARALLEL;

--
-- 279. RHN_PACKAGE_ID_NID_PAID_IDX  (Index) 
--
CREATE INDEX RHN_PACKAGE_ID_NID_PAID_IDX ON RHNPACKAGE
(ID, NAME_ID, PACKAGE_ARCH_ID)
NOLOGGING
NOPARALLEL;

--
-- 280. RHN_PACKAGE_N_E_PA_O_UQ  (Index) 
--
CREATE UNIQUE INDEX RHN_PACKAGE_N_E_PA_O_UQ ON RHNPACKAGE
(NAME_ID, EVR_ID, PACKAGE_ARCH_ID, ORG_ID)
LOGGING
NOPARALLEL;

--
-- 281. RHN_PC_CID_PID_IDX  (Index) 
--
CREATE INDEX RHN_PC_CID_PID_IDX ON RHNPRODUCTCHANNEL
(CHANNEL_ID, PRODUCT_ID)
LOGGING
NOPARALLEL;

--
-- 282. RHN_PC_PID_CID_IDX  (Index) 
--
CREATE INDEX RHN_PC_PID_CID_IDX ON RHNPRODUCTCHANNEL
(PRODUCT_ID, CHANNEL_ID)
LOGGING
NOPARALLEL;

--
-- 283. RHN_PLCONV_OID_IDX  (Index) 
--
CREATE INDEX RHN_PLCONV_OID_IDX ON RHNPAYLOADERCONVERSION
(ORG_ID)
LOGGING
NOPARALLEL;

--
-- 284. RHN_PRODUCT_ID_IDX  (Index) 
--
CREATE INDEX RHN_PRODUCT_ID_IDX ON RHNPRODUCT
(ID)
LOGGING
NOPARALLEL;

--
-- 285. RHN_PRODUCT_LABEL_IDX  (Index) 
--
CREATE INDEX RHN_PRODUCT_LABEL_IDX ON RHNPRODUCT
(LABEL)
LOGGING
NOPARALLEL;

--
-- 286. RHN_PRODUCT_NAME_IDX  (Index) 
--
CREATE INDEX RHN_PRODUCT_NAME_IDX ON RHNPRODUCT
(NAME)
LOGGING
NOPARALLEL;

--
-- 287. RHN_SERVER_PROFILE_O_ID_BC_IDX  (Index) 
--
CREATE INDEX RHN_SERVER_PROFILE_O_ID_BC_IDX ON RHNSERVERPROFILE
(ORG_ID, ID, BASE_CHANNEL)
NOLOGGING
NOPARALLEL;

--
-- 288. RHN_SPROFILE_ID_OID_BC_IDX  (Index) 
--
CREATE INDEX RHN_SPROFILE_ID_OID_BC_IDX ON RHNSERVERPROFILE
(ID, ORG_ID, BASE_CHANNEL)
LOGGING
NOPARALLEL;

--
-- 289. WUPI_EMAIL_UC_IDX  (Index) 
--
CREATE INDEX WUPI_EMAIL_UC_IDX ON WEB_USER_PERSONAL_INFO
(EMAIL_UC)
LOGGING
NOPARALLEL;

--
-- 290. WUSI_EMAIL_UC_IDX  (Index) 
--
CREATE INDEX WUSI_EMAIL_UC_IDX ON WEB_USER_SITE_INFO
(EMAIL_UC)
LOGGING
NOPARALLEL;

--
-- 291. RHN_ORG  (Package) 
--
CREATE OR REPLACE PACKAGE rhn_org
IS
    CURSOR server_group_by_label(org_id_in NUMBER, group_label_in VARCHAR2) IS
    	   SELECT SG.*
	     FROM rhnServerGroupType SGT,
	     	  rhnServerGroup SG
	    WHERE SG.group_type = SGT.id
	      AND SGT.label = group_label_in
	      AND SG.org_id = org_id_in;
    FUNCTION find_server_group_by_type(org_id_in NUMBER, group_label_in VARCHAR2) RETURN NUMBER;
    PROCEDURE update_errata_cache(org_id_in NUMBER, threshold_in NUMBER);
	procedure delete_user(user_id_in number);
END rhn_org;
/


--
-- 292. RHN_QOS  (Package Body) 
--
CREATE OR REPLACE package body rhn_qos is
	function slot_count(org_id_in in number, label_in in varchar2) return number is
		tally		number;
	begin
		select	max_members
		into	tally
		from	rhnServerGroupType	rsgt,
				rhnServerGroup		rsg
		where	1=1
				and rsgt.label = label_in
				and rsgt.id = rsg.group_type
				and rsg.org_id = org_id_in;
		return tally;
	exception
		when no_data_found then
			return 0;
	end slot_count;
	function basic_slot_count(org_id_in in number) return number is
	begin
		return slot_count(org_id_in, 'sw_mgr_entitled');
	end basic_slot_count;
	function workgroup_slot_count(org_id_in in number) return number is
	begin
		return slot_count(org_id_in, 'enterprise_entitled');
	end workgroup_slot_count;
	function channel_slot_count(org_id_in in number, label_in in number) return number is
		tally		number;
	begin
		select	max_members
		into	tally
		from	rhnChannelFamily			rcf,
				rhnChannelFamilyPermissions rcfp
		where	1=1
				and rcf.label = label_in
				and rcf.id = rcfp.channel_family_id
				and rcfp.org_id = org_id_in;
		return tally;
	exception
		when no_data_found then
			return 0;
	end channel_slot_count;
	function as_slot_count(org_id_in in number) return number is
	begin
		return channel_slot_count(org_id_in, 'rh-advanced-server');
	end as_slot_count;
end rhn_qos;
/


--
-- 293. ADD_HARDWARE_PROPERTY  (Procedure) 
--
CREATE OR REPLACE procedure
add_hardware_property (
	hardware_id_in in number,
	name_in in varchar2,
	value_in in varchar2
) is
begin
	insert into rhnHardwareProperties (
		hardware_id, name_id, value_id
	) values (
		hardware_id_in,
		lookup_hw_prop_name(name_in),
		lookup_hw_prop_value(value_in)
	);
end add_hardware_property;
/


--
-- 294. CHECK_EMAIL_UNIQUENESS  (Function) 
--
CREATE OR REPLACE function
check_email_uniqueness (
	email_in in varchar2
)
return number
is
	cursor sources(email_cin in varchar2) is
		select	1
		from	web_user_personal_info	wupi
		where	wupi.email = email_cin;
begin
	for source in sources(email_in)
	loop
		return 0;
	end loop;
	return 1;
end;
/


--
-- 295. IS_SATELLITE  (Function) 
--
CREATE OR REPLACE function
is_satellite
return number
is
	cursor schemas is
		select	1
		from	rhnVersionInfo
		where	label = 'schema'
		and	name_id = lookup_package_name('rhn-satellite-schema');
begin
	for schema in schemas loop return 1; end loop;
	return 0;
end is_satellite;
/


--
-- 296. LOOKUP_CD_DEVICE  (Function) 
--
CREATE OR REPLACE function
lookup_cd_device(
	class_in in varchar2,
	bus_in in varchar2,
	detached_in in number,
	device_in in varchar2,
	driver_in in varchar2,
	description_in in varchar2,
	dev_host_in in varchar2,
	dev_id_in in varchar2,
	dev_channel_in in varchar2,
	dev_lun_in in varchar2,
	pcitype_in in varchar2
) return number is
	hardware_id	number;
begin
	select	h.id
	into	hardware_id
	from
		rhnHardwareProperties	hp11,
		rhnHardwareProperties	hp10,
		rhnHardwareProperties	hp9,
		rhnHardwareProperties	hp8,
		rhnHardwareProperties	hp7,
		rhnHardwareProperties	hp6,
		rhnHardwareProperties	hp5,
		rhnHardwareProperties	hp4,
		rhnHardwareProperties	hp3,
		rhnHardwareProperties	hp2,
		rhnHardwareProperties	hp1,
		rhnHardwareProperties	hp0,
		rhnHardware		h,
		rhnHardwareClass	hc
	where	1=1
		and class_in = hc.label
		and hc.id = h.class_id
		and h.id = hp0.hardware_id
		and hp0.name_id = 1
		and hp0.value_id = lookup_hw_prop_value(bus_in)
		and hp0.hardware_id = hp1.hardware_id
		and hp1.name_id = 2
		and hp1.value_id = lookup_hw_prop_value(detached_in)
		and hp1.hardware_id = hp2.hardware_id
		and hp2.name_id = 3
		and hp2.value_id = lookup_hw_prop_value(device_in)
		and hp2.hardware_id = hp3.hardware_id
		and hp3.name_id = 4
		and hp3.value_id = lookup_hw_prop_value(driver_in)
		and hp3.hardware_id = hp4.hardware_id
		and hp4.name_id = 5
		and hp4.value_id = lookup_hw_prop_value(description_in)
		and hp4.hardware_id = hp5.hardware_id
		and hp5.name_id = 9
		and hp5.value_id = lookup_hw_prop_value(dev_host_in)
		and hp5.hardware_id = hp6.hardware_id
		and hp6.name_id = 10
		and hp6.value_id = lookup_hw_prop_value(dev_id_in)
		and hp6.hardware_id = hp7.hardware_id
		and hp7.name_id = 11
		and hp7.value_id = lookup_hw_prop_value(dev_channel_in)
		and hp7.hardware_id = hp8.hardware_id
		and hp8.name_id = 12
		and hp8.value_id = lookup_hw_prop_value(dev_lun_in)
		and hp8.hardware_id = hp9.hardware_id
		and hp9.name_id = 8
		and hp9.value_id = lookup_hw_prop_value(pcitype_in);
	return hardware_id;
exception
	when no_data_found then
		select	rhn_hw_id_seq.nextval
		into	hardware_id
		from	dual;
		insert into rhnHardware ( id, class_id ) (
			select	hardware_id,
				hc.id
			from	rhnHardwareClass	hc
			where	hc.class = class_in
		);
		add_hardware_property(hardware_id, 'bus', bus_in);
		add_hardware_property(hardware_id, 'detached', detached_in);
		add_hardware_property(hardware_id, 'device', device_in);
		add_hardware_property(hardware_id, 'driver', driver_in);
		add_hardware_property(hardware_id, 'description', description_in);
		add_hardware_property(hardware_id, 'dev_host',dev_host_in);
		add_hardware_property(hardware_id, 'dev_id',dev_id_in);
		add_hardware_property(hardware_id, 'dev_channel',dev_channel_in);
		add_hardware_property(hardware_id, 'dev_lun',dev_lun_in);
		add_hardware_property(hardware_id, 'pcitype', pcitype_in);
		return hardware_id;
end lookup_cd_device;
/


--
-- 297. LOOKUP_DISK_DEVICE  (Function) 
--
CREATE OR REPLACE function
lookup_disk_device(
	class_in in varchar2,
	bus_in in varchar2,
	detached_in in number,
	device_in in varchar2,
	driver_in in varchar2,
	description_in in varchar2,
	physical_in in varchar2,
	logical_in in varchar2,
	pcitype_in in varchar2
) return number is
	hardware_id	number;
begin
	select	h.id
	into	hardware_id
	from
		rhnHardwareProperties	hp7,
		rhnHardwareProperties	hp6,
		rhnHardwareProperties	hp5,
		rhnHardwareProperties	hp4,
		rhnHardwareProperties	hp3,
		rhnHardwareProperties	hp2,
		rhnHardwareProperties	hp1,
		rhnHardwareProperties	hp0,
		rhnHardware		h,
		rhnHardwareClass	hc
	where	1=1
		and class_in = hc.label
		and hc.id = h.class_id
		and h.id = hp0.hardware_id
		and hp0.name_id = 1
		and hp0.value_id = lookup_hw_prop_value(bus_in)
		and hp0.hardware_id = hp1.hardware_id
		and hp1.name_id = 2
		and hp1.value_id = lookup_hw_prop_value(detached_in)
		and hp1.hardware_id = hp2.hardware_id
		and hp2.name_id = 3
		and hp2.value_id = lookup_hw_prop_value(device_in)
		and hp2.hardware_id = hp3.hardware_id
		and hp3.name_id = 4
		and hp3.value_id = lookup_hw_prop_value(driver_in)
		and hp3.hardware_id = hp4.hardware_id
		and hp4.name_id = 5
		and hp4.value_id = lookup_hw_prop_value(description_in)
		and hp4.hardware_id = hp5.hardware_id
		and hp5.name_id = 6
		and hp5.value_id = lookup_hw_prop_value(physical_in)
		and hp5.hardware_id = hp6.hardware_id
		and hp6.name_id = 7
		and hp6.value_id = lookup_hw_prop_value(logical_in)
		and hp6.hardware_id = hp7.hardware_id
		and hp7.name_id = 8
		and hp7.value_id = lookup_hw_prop_value(pcitype_in);
	return hardware_id;
exception
	when no_data_found then
		select	rhn_hw_id_seq.nextval
		into	hardware_id
		from	dual;
		insert into rhnHardware ( id, class_id ) (
			select	hardware_id,
				hc.id
			from	rhnHardwareClass	hc
			where	hc.class = class_in
		);
		add_hardware_property(hardware_id, 'bus', bus_in);
		add_hardware_property(hardware_id, 'detached', detached_in);
		add_hardware_property(hardware_id, 'device', device_in);
		add_hardware_property(hardware_id, 'driver', driver_in);
		add_hardware_property(hardware_id, 'description', description_in);
		add_hardware_property(hardware_id, 'physical', physical_in);
		add_hardware_property(hardware_id, 'logical', logical_in);
		add_hardware_property(hardware_id, 'pcitype', pcitype_in);
		return hardware_id;
end lookup_disk_device;
/


--
-- 298. LOOKUP_HW_DEVICE  (Function) 
--
CREATE OR REPLACE function
lookup_hw_device(
	class_in in varchar2,
	bus_in in varchar2,
	detached_in in number,
	device_in in varchar2,
	driver_in in varchar2,
	description_in in varchar2,
	vendor_id_in in varchar2,
	device_id_in in varchar2,
	subvendor_id_in in varchar2,
	subdevice_id_in in varchar2,
	pcitype_in in varchar2
) return number is
	hardware_id	number;
begin
	select	h.id
	into	hardware_id
	from
		rhnHardwareProperties	hp9,
		rhnHardwareProperties	hp8,
		rhnHardwareProperties	hp7,
		rhnHardwareProperties	hp6,
		rhnHardwareProperties	hp5,
		rhnHardwareProperties	hp4,
		rhnHardwareProperties	hp3,
		rhnHardwareProperties	hp2,
		rhnHardwareProperties	hp1,
		rhnHardwareProperties	hp0,
		rhnHardware		h,
		rhnHardwareClass	hc
	where	1=1
		and class_in = hc.label
		and hc.id = h.class_id
		and h.id = hp0.hardware_id
		and hp0.name_id = 1
		and hp0.value_id = lookup_hw_prop_value(bus_in)
		and hp0.hardware_id = hp1.hardware_id
		and hp1.name_id = 2
		and hp1.value_id = lookup_hw_prop_value(detached_in)
		and hp1.hardware_id = hp2.hardware_id
		and hp2.name_id = 3
		and hp2.value_id = lookup_hw_prop_value(device_in)
		and hp2.hardware_id = hp3.hardware_id
		and hp3.name_id = 4
		and hp3.value_id = lookup_hw_prop_value(driver_in)
		and hp3.hardware_id = hp4.hardware_id
		and hp4.name_id = 5
		and hp4.value_id = lookup_hw_prop_value(description_in)
		and hp4.hardware_id = hp5.hardware_id
		and hp5.name_id = 13
		and hp5.value_id = lookup_hw_prop_value(vendor_id_in)
		and hp5.hardware_id = hp6.hardware_id
		and hp6.name_id = 14
		and hp6.value_id = lookup_hw_prop_value(device_id_in)
		and hp6.hardware_id = hp7.hardware_id
		and hp7.name_id = 15
		and hp7.value_id = lookup_hw_prop_value(subvendor_id_in)
		and hp7.hardware_id = hp8.hardware_id
		and hp8.name_id = 16
		and hp8.value_id = lookup_hw_prop_value(subdevice_id_in)
		and hp8.hardware_id = hp9.hardware_id
		and hp9.name_id = 8
		and hp9.value_id = lookup_hw_prop_value(pcitype_in);
	return hardware_id;
exception
	when no_data_found then
		select	rhn_hw_id_seq.nextval
		into	hardware_id
		from	dual;
		insert into rhnHardware ( id, class_id ) (
			select	hardware_id,
				hc.id
			from	rhnHardwareClass	hc
			where	hc.class = class_in
		);
		add_hardware_property(hardware_id, 'bus', bus_in);
		add_hardware_property(hardware_id, 'detached', detached_in);
		add_hardware_property(hardware_id, 'device', device_in);
		add_hardware_property(hardware_id, 'driver', driver_in);
		add_hardware_property(hardware_id, 'description', description_in);
		add_hardware_property(hardware_id, 'vendor_id', vendor_id_in);
		add_hardware_property(hardware_id, 'device_id', device_id_in);
		add_hardware_property(hardware_id, 'subvendor_id', subvendor_id_in);
		add_hardware_property(hardware_id, 'subdevice_id', subdevice_id_in);
		add_hardware_property(hardware_id, 'pcitype', pcitype_in);
		return hardware_id;
end lookup_hw_device;
/


--
-- 299. XXRH_CONTACT_DEL_CHECK  (Function) 
--
CREATE OR REPLACE function
xxrh_contact_del_check(
	pin_web_contact_id in number
) return boolean
is
begin
	if is_satellite() = 1 then
		return true;
	end if;
	return false;
end xxrh_contact_del_check;
/


--
-- 300. XXRH_CONTACT_DEL_CHECK_NUM  (Function) 
--
CREATE OR REPLACE function
xxrh_contact_del_check_num(
	contact_id_in in number
) return number
is
begin
	if xxrh_contact_del_check(contact_id_in) = true then
		return 1;
	end if;
	return 0;
end xxrh_contact_del_check_num;
/


--
-- 301. RHNCHANNELTREEVIEW  (View) 
--
CREATE OR REPLACE FORCE VIEW RHNCHANNELTREEVIEW
(ID, DEPTH, NAME, PADDED_NAME, CHANNEL_ARCH_ID, 
 LAST_MODIFIED, LABEL, PARENT_OR_SELF_LABEL)
AS 
SELECT
             id,
             (CASE WHEN parent_channel IS NULL THEN 1 ELSE 2 END) depth,
	     name,
             (CASE WHEN parent_channel IS NULL THEN '  ' ELSE '' END) || name,
	     channel_arch_id,
             last_modified,
             label,
	     (CASE WHEN parent_channel IS NULL THEN label ELSE (select c2.label from rhnChannel c2 where c2.id = c.parent_channel) END)
        FROM rhnChannel C
  ORDER BY (CASE WHEN parent_channel IS NULL THEN label ELSE (select c2.label from rhnChannel c2 where c2.id = c.parent_channel) END), parent_channel NULLS FIRST;

--
-- 302. RHNPAIDORGS  (View) 
--
CREATE OR REPLACE FORCE VIEW RHNPAIDORGS
(ORG_ID)
AS 
select	org_id
from	rhnServerGroup
where	group_type = 3
	and max_members > 0
union all
select	org_id
from	rhnServerGroup
where	group_type = 2
	and max_members > 1;

--
-- 303. RHN_BL_OBS_MOD_TRIG  (Trigger) 
--
CREATE OR REPLACE TRIGGER RHN_BL_OBS_MOD_TRIG
BEFORE INSERT OR UPDATE ON RHNBLACKLISTOBSOLETES
FOR EACH ROW
begin
	:new.modified := sysdate;
end;
/


--
-- 304. RHN_CF_LICENSE_MOD_TRIG  (Trigger) 
--
CREATE OR REPLACE TRIGGER RHN_CF_LICENSE_MOD_TRIG
BEFORE INSERT OR UPDATE ON RHNCHANNELFAMILYLICENSE
FOR EACH ROW
begin
        :new.modified := sysdate;
end;
/


--
-- 305. RHN_CHANNELREL_MOD_TRIG  (Trigger) 
--
CREATE OR REPLACE TRIGGER RHN_CHANNELREL_MOD_TRIG
BEFORE INSERT OR UPDATE ON RHNCHANNELRELATIONSHIP
FOR EACH ROW
begin
	:new.modified := sysdate;
end;
/


--
-- 306. RHN_CHANNEL_MOD_TRIG  (Trigger) 
--
CREATE OR REPLACE TRIGGER RHN_CHANNEL_MOD_TRIG
BEFORE INSERT OR UPDATE ON RHNCHANNEL
FOR EACH ROW
begin
	:new.last_modified := sysdate;
	if updating then
		if (:old.id != :new.id) or
		  (:old.parent_channel != :new.parent_channel) or
		  (:old.org_id != :new.org_id) or
		  (:old.channel_arch_id != :new.channel_arch_id) or
		  (:old.label != :new.label) or
		  (:old.basedir != :new.basedir) or
		  (:old.name != :new.name) or
		  (:old.summary != :new.summary) or
		  (:old.description != :new.description) then
			:new.modified := sysdate;
		end if;
	end if;
end;
/


--
-- 307. RHN_CP_AC_MOD_TRIG  (Trigger) 
--
CREATE OR REPLACE TRIGGER RHN_CP_AC_MOD_TRIG
BEFORE INSERT OR UPDATE ON RHNCHANNELPACKAGEARCHCOMPAT
FOR EACH ROW
begin
        :new.modified := sysdate;
end;
/


--
-- 308. RHN_EFILEC_MOD_TRIG  (Trigger) 
--
CREATE OR REPLACE TRIGGER RHN_EFILEC_MOD_TRIG
BEFORE INSERT OR UPDATE ON RHNERRATAFILECHANNEL
FOR EACH ROW
begin
	:new.modified := sysdate;
end;
/


--
-- 309. RHN_ENQUEUE_MOD_TRIG  (Trigger) 
--
CREATE OR REPLACE TRIGGER RHN_ENQUEUE_MOD_TRIG
BEFORE INSERT OR UPDATE ON RHNERRATANOTIFICATIONQUEUE
FOR EACH ROW
begin
	:new.modified := sysdate;
end;
/


--
-- 310. RHN_ERRATAFILE_MOD_TRIG  (Trigger) 
--
CREATE OR REPLACE TRIGGER RHN_ERRATAFILE_MOD_TRIG
BEFORE INSERT OR UPDATE ON RHNERRATAFILE
FOR EACH ROW
begin
        :new.modified := sysdate;
end;
/


--
-- 311. RHN_ERRATAREL_MOD_TRIG  (Trigger) 
--
CREATE OR REPLACE TRIGGER RHN_ERRATAREL_MOD_TRIG
BEFORE INSERT OR UPDATE ON RHNERRATARELATIONSHIP
FOR EACH ROW
begin
	:new.modified := sysdate;
end;
/


--
-- 312. RHN_M_MOD_TRIG  (Trigger) 
--
CREATE OR REPLACE TRIGGER RHN_M_MOD_TRIG
BEFORE INSERT OR UPDATE ON RHNMESSAGE
FOR EACH ROW
begin
	:new.modified := sysdate;
end;
/


--
-- 313. RHN_OSTATE_MOD_TRIG  (Trigger) 
--
CREATE OR REPLACE TRIGGER RHN_OSTATE_MOD_TRIG
BEFORE INSERT OR UPDATE ON RHNORGSTATE
FOR EACH ROW
begin
        :new.modified := sysdate;
	if :old.state_id <> :new.state_id then
		rhn_bel.validate_org_state_change(:old.state_id, :new.state_id);
	end if;
end;
/


--
-- 314. RHN_PACKAGEFILE_MOD_TRIG  (Trigger) 
--
CREATE OR REPLACE TRIGGER RHN_PACKAGEFILE_MOD_TRIG
BEFORE INSERT OR UPDATE ON RHNPACKAGEFILE
FOR EACH ROW
begin
	:new.modified := sysdate;
	update rhnPackage set last_modified = sysdate
		where id = :new.package_id;
end;
/


--
-- 315. RHN_PACKAGE_CHANGELOG_MOD_TRIG  (Trigger) 
--
CREATE OR REPLACE TRIGGER RHN_PACKAGE_CHANGELOG_MOD_TRIG
BEFORE INSERT OR UPDATE ON RHNPACKAGECHANGELOG
FOR EACH ROW
begin
        :new.modified := sysdate;
	update rhnPackage set last_modified = sysdate
		where id = :new.package_id;
end;
/


--
-- 316. RHN_PACKAGE_MOD_TRIG  (Trigger) 
--
CREATE OR REPLACE TRIGGER RHN_PACKAGE_MOD_TRIG
BEFORE INSERT OR UPDATE ON RHNPACKAGE
FOR EACH ROW
begin
        :new.modified := sysdate;
	:new.last_modified := sysdate;
end;
/


--
-- 317. RHN_PACKAGE_SIG_MOD_TRIG  (Trigger) 
--
CREATE OR REPLACE TRIGGER RHN_PACKAGE_SIG_MOD_TRIG
BEFORE INSERT OR UPDATE ON RHNPACKAGESIGNATURE
FOR EACH ROW
begin
        :new.modified := sysdate;
	update rhnPackage set last_modified = sysdate
		where id = :new.package_id;
end;
/


--
-- 318. RHN_PKGSRC_MOD_TRIG  (Trigger) 
--
CREATE OR REPLACE TRIGGER RHN_PKGSRC_MOD_TRIG
BEFORE INSERT OR UPDATE ON RHNPACKAGESOURCE
FOR EACH ROW
begin
        :new.modified := sysdate;
	:new.last_modified := sysdate;
end;
/


--
-- 319. RHN_PKG_CONFLICTS_MOD_TRIG  (Trigger) 
--
CREATE OR REPLACE TRIGGER RHN_PKG_CONFLICTS_MOD_TRIG
BEFORE INSERT OR UPDATE ON RHNPACKAGECONFLICTS
FOR EACH ROW
begin
        :new.modified := sysdate;
	update rhnPackage set last_modified = sysdate
		where id = :new.package_id;
end;
/


--
-- 320. RHN_PKG_OBSOLETES_MOD_TRIG  (Trigger) 
--
CREATE OR REPLACE TRIGGER RHN_PKG_OBSOLETES_MOD_TRIG
BEFORE INSERT OR UPDATE ON RHNPACKAGEOBSOLETES
FOR EACH ROW
begin
        :new.modified := sysdate;
	update rhnPackage set last_modified = sysdate
		where id = :new.package_id;
end;
/


--
-- 321. RHN_PKG_PROVIDES_MOD_TRIG  (Trigger) 
--
CREATE OR REPLACE TRIGGER RHN_PKG_PROVIDES_MOD_TRIG
BEFORE INSERT OR UPDATE ON RHNPACKAGEPROVIDES
FOR EACH ROW
begin
        :new.modified := sysdate;
	update rhnPackage set last_modified = sysdate
		where id = :new.package_id;
end;
/


--
-- 322. RHN_PKG_REQUIRES_MOD_TRIG  (Trigger) 
--
CREATE OR REPLACE TRIGGER RHN_PKG_REQUIRES_MOD_TRIG
BEFORE INSERT OR UPDATE ON RHNPACKAGEREQUIRES
FOR EACH ROW
begin
        :new.modified := sysdate;
	update rhnPackage set last_modified = sysdate
		where id = :new.package_id;
end;
/


--
-- 323. RHN_PRODUCT_MOD_TRIG  (Trigger) 
--
CREATE OR REPLACE TRIGGER RHN_PRODUCT_MOD_TRIG
BEFORE INSERT OR UPDATE ON RHNPRODUCT
FOR EACH ROW
begin
	:new.modified := sysdate;
	:new.last_modified := sysdate;
end;
/


--
-- 324. RHN_TM_MOD_TRIG  (Trigger) 
--
CREATE OR REPLACE TRIGGER RHN_TM_MOD_TRIG
BEFORE INSERT OR UPDATE ON RHNTEXTMESSAGE
FOR EACH ROW
begin
	:new.modified := sysdate;
end;
/


--
-- 325. WEB_USER_SI_TIMESTAMP  (Trigger) 
--
CREATE OR REPLACE TRIGGER WEB_USER_SI_TIMESTAMP
BEFORE INSERT OR UPDATE ON WEB_USER_SITE_INFO
FOR EACH ROW
begin
  :new.email_uc := upper(:new.email);
  :new.modified := sysdate;
end;
/


--
-- 326. RHNUSER  (Synonym) 
--
DROP SYNONYM RHNUSER;
CREATE SYNONYM RHNUSER FOR WEB_CONTACT;

--
-- 327. PACKAGE_ARCH_ID  (Column) 
--
ALTER TABLE RHNACTIONPACKAGE ADD (PACKAGE_ARCH_ID  NUMBER);
update rhnActionPackage
set package_arch_id = (
    select LOOKUP_PACKAGE_ARCH(a.name)
    from rhnArch a
    where a.id = arch_id
);
commit;

--
-- 328. ARCH_ID  (Column) 
--
ALTER TABLE RHNACTIONPACKAGE DROP COLUMN ARCH_ID;

--
-- 329. RHNCHANNELNEWESTPACKAGE  (Table) 
--
CREATE TABLE RHNCHANNELNEWESTPACKAGE
(
  CHANNEL_ID       NUMBER,
  NAME_ID          NUMBER,
  EVR_ID           NUMBER,
  PACKAGE_ARCH_ID  NUMBER,
  PACKAGE_ID       NUMBER
)
LOGGING 
NOCACHE
NOPARALLEL;

--
-- 330. RHNEMAILADDRESS  (Table) 
--
CREATE TABLE RHNEMAILADDRESS
(
  ID           NUMBER,
  ADDRESS      VARCHAR2(128),
  USER_ID      NUMBER,
  STATE_ID     NUMBER,
  NEXT_ACTION  DATE,
  CREATED      DATE                             DEFAULT (sysdate),
  MODIFIED     DATE                             DEFAULT (sysdate)
)
LOGGING 
NOCACHE
NOPARALLEL;

--
-- 331. RHNEMAILADDRESSLOG  (Table) 
--
CREATE TABLE RHNEMAILADDRESSLOG
(
  USER_ID  NUMBER,
  ADDRESS  VARCHAR2(128),
  REASON   VARCHAR2(4000),
  CREATED  DATE                                 DEFAULT (sysdate)
)
LOGGING 
NOCACHE
NOPARALLEL;

--
-- 332. RHNERRATAFILEPACKAGE  (Table) 
--
CREATE TABLE RHNERRATAFILEPACKAGE
(
  PACKAGE_ID      NUMBER,
  ERRATA_FILE_ID  NUMBER,
  CREATED         DATE                          DEFAULT (sysdate),
  MODIFIED        DATE                          DEFAULT (sysdate)
)
LOGGING 
NOCACHE
NOPARALLEL;

--
-- 333. RHNERRATAFILEPACKAGESOURCE  (Table) 
--
CREATE TABLE RHNERRATAFILEPACKAGESOURCE
(
  PACKAGE_ID      NUMBER,
  ERRATA_FILE_ID  NUMBER,
  CREATED         DATE                          DEFAULT (sysdate),
  MODIFIED        DATE                          DEFAULT (sysdate)
)
LOGGING 
NOCACHE
NOPARALLEL;

--
-- 334. RHNERRATAFILETMP  (Table) 
--
CREATE TABLE RHNERRATAFILETMP
(
  ID         NUMBER,
  ERRATA_ID  NUMBER,
  TYPE       NUMBER,
  MD5SUM     VARCHAR2(64),
  FILENAME   VARCHAR2(128),
  CREATED    DATE                               DEFAULT (sysdate),
  MODIFIED   DATE                               DEFAULT (sysdate)
)
LOGGING 
NOCACHE
NOPARALLEL;

--
-- 335. RHNERRATARELATIONSHIPTMP  (Table) 
--
CREATE TABLE RHNERRATARELATIONSHIPTMP
(
  FROM_ERRATA_ID  NUMBER,
  TO_ERRATA_ID    NUMBER,
  REL_TYPE_ID     NUMBER,
  CREATED         DATE                          DEFAULT (sysdate),
  MODIFIED        DATE                          DEFAULT (sysdate)
)
LOGGING 
NOCACHE
NOPARALLEL;

--
-- 336. RHNFILEDOWNLOAD  (Table) 
--
CREATE TABLE RHNFILEDOWNLOAD
(
  FILE_ID       NUMBER,
  LOCATION      VARCHAR2(2000),
  TOKEN         VARCHAR2(48),
  REQUESTOR_IP  VARCHAR2(15),
  START_TIME    DATE                            DEFAULT (sysdate),
  USER_ID       NUMBER
)
LOGGING 
NOCACHE
NOPARALLEL;

--
-- 337. RHNSAVEDSEARCH  (Table) 
--
CREATE TABLE RHNSAVEDSEARCH
(
  ID              NUMBER,
  WEB_CONTACT_ID  NUMBER,
  NAME            VARCHAR2(16),
  TYPE            NUMBER,
  SEARCH_STRING   VARCHAR2(4000),
  SEARCH_SET      VARCHAR2(16),
  SEARCH_FIELD    VARCHAR2(128),
  INVERT          CHAR(1)                       DEFAULT ('N')
)
LOGGING 
NOCACHE
NOPARALLEL;

--
-- 338. SERVER_ARCH_ID  (Column) 
--
ALTER TABLE RHNSERVER ADD (SERVER_ARCH_ID  NUMBER);
UPDATE rhnServer
set server_arch_id = (select sa.id
    from rhnServerArch sa, rhnArch a
    where a.id = arch
    and sa.label = a.name || '-redhat-linux');
commit;

--
-- 339. ARCH  (Column) 
--
ALTER TABLE RHNSERVER DROP COLUMN ARCH;

--
-- 340. REMAINING_TRIES  (Column) 
--
ALTER TABLE RHNSERVERACTION ADD (REMAINING_TRIES  NUMBER                       DEFAULT (5));

--
-- 341. RHNSERVEREVENT  (Table) 
--
CREATE TABLE RHNSERVEREVENT
(
  ID         NUMBER,
  SERVER_ID  NUMBER,
  DETAILS    VARCHAR2(4000),
  CREATED    DATE                               DEFAULT (sysdate),
  MODIFIED   DATE                               DEFAULT (sysdate)
)
LOGGING 
NOCACHE
NOPARALLEL;

--
-- 342. RHNSERVERHARDWARE  (Table) 
--
CREATE TABLE RHNSERVERHARDWARE
(
  SERVER_ID    NUMBER,
  HARDWARE_ID  NUMBER,
  CREATED      DATE                             DEFAULT (sysdate),
  MODIFIED     DATE                             DEFAULT (sysdate)
)
LOGGING 
NOCACHE
NOPARALLEL;

--
-- 343. RHNSERVERINSTALLINFO  (Table) 
--
CREATE TABLE RHNSERVERINSTALLINFO
(
  ID              NUMBER,
  SERVER_ID       NUMBER,
  INSTALL_METHOD  VARCHAR2(32),
  ISO_STATUS      NUMBER,
  MEDIASUM        VARCHAR2(64),
  CREATED         DATE                          DEFAULT (sysdate),
  MODIFIED        DATE                          DEFAULT (sysdate)
)
LOGGING 
NOCACHE
NOPARALLEL;

--
-- 344. RHNSERVERMESSAGE  (Table) 
--
CREATE TABLE RHNSERVERMESSAGE
(
  SERVER_ID     NUMBER,
  MESSAGE_ID    NUMBER,
  SERVER_EVENT  NUMBER,
  CREATED       DATE                            DEFAULT (sysdate),
  MODIFIED      DATE                            DEFAULT (sysdate)
)
LOGGING 
NOCACHE
NOPARALLEL;

--
-- 345. RHNSERVERNETINTERFACE  (Table) 
--
CREATE TABLE RHNSERVERNETINTERFACE
(
  SERVER_ID  NUMBER,
  NAME       VARCHAR2(32),
  IP_ADDR    VARCHAR2(64),
  NETMASK    VARCHAR2(64),
  BROADCAST  VARCHAR2(64),
  HW_ADDR    VARCHAR2(18),
  MODULE     VARCHAR2(128),
  CREATED    DATE                               DEFAULT sysdate,
  MODIFIED   DATE                               DEFAULT sysdate
)
LOGGING 
NOCACHE
NOPARALLEL;

--
-- 346. RHNSURVEYQUESTIONRESPONSE  (Table) 
--
CREATE TABLE RHNSURVEYQUESTIONRESPONSE
(
  QUESTION_ID  NUMBER,
  USER_ID      NUMBER,
  RESPONSE     VARCHAR2(4000)
)
LOGGING 
NOCACHE
NOPARALLEL;

--
-- 347. RHNTRANSACTION  (Table) 
--
CREATE TABLE RHNTRANSACTION
(
  ID            NUMBER,
  SERVER_ID     NUMBER,
  TIMESTAMP     DATE,
  RPM_TRANS_ID  NUMBER,
  LABEL         VARCHAR2(32),
  CREATED       DATE                            DEFAULT (sysdate),
  MODIFIED      DATE                            DEFAULT (sysdate)
)
LOGGING 
NOCACHE
NOPARALLEL;

--
-- 348. RHNTRANSACTIONELEMENT  (Table) 
--
CREATE TABLE RHNTRANSACTIONELEMENT
(
  TRANSACTION_ID          NUMBER,
  TRANSACTION_PACKAGE_ID  NUMBER
)
LOGGING 
NOCACHE
NOPARALLEL;

--
-- 349. SHOW_SYSTEM_GROUP_LIST  (Column) 
--
ALTER TABLE RHNUSERINFO ADD (SHOW_SYSTEM_GROUP_LIST  CHAR(1)               DEFAULT ('N'));

--
-- 350. AGREED_TO_ASDE_TERMS  (Column) 
--
ALTER TABLE RHNUSERINFO ADD (AGREED_TO_ASDE_TERMS  CHAR(1)                 DEFAULT ('N'));

--
-- 351. AGREED_TO_WS_TERMS  (Column) 
--
ALTER TABLE RHNUSERINFO ADD (AGREED_TO_WS_TERMS  CHAR(1));

--
-- 352. AGREED_TO_ES_TERMS  (Column) 
--
ALTER TABLE RHNUSERINFO ADD (AGREED_TO_ES_TERMS  CHAR(1));

--
-- 353. LAST_LOGGED_IN  (Column) 
--
ALTER TABLE RHNUSERINFO ADD (LAST_LOGGED_IN  DATE);

--
-- 354. CREATED  (Column) 
--
ALTER TABLE RHNUSERINFO ADD (CREATED  DATE                                 DEFAULT (sysdate));

--
-- 355. MODIFIED  (Column) 
--
ALTER TABLE RHNUSERINFO ADD (MODIFIED  DATE                                DEFAULT (sysdate));

--
-- 356. RHNUSERMESSAGE  (Table) 
--
CREATE TABLE RHNUSERMESSAGE
(
  USER_ID     NUMBER,
  MESSAGE_ID  NUMBER,
  STATUS      NUMBER
)
LOGGING 
NOCACHE
NOPARALLEL;

--
-- 357. RHNUSERSURVEYSTATUS  (Table) 
--
CREATE TABLE RHNUSERSURVEYSTATUS
(
  USER_ID    NUMBER,
  SURVEY_ID  NUMBER,
  STATUS     NUMBER
)
LOGGING 
NOCACHE
NOPARALLEL;

--
-- 358. RHN_ACTION_SCHEDULER_IDX  (Index) 
--
CREATE INDEX RHN_ACTION_SCHEDULER_IDX ON RHNACTION
(SCHEDULER)
NOLOGGING
NOPARALLEL;

--
-- 359. RHN_ACT_EU_AID_EID_IDX  (Index) 
--
CREATE INDEX RHN_ACT_EU_AID_EID_IDX ON RHNACTIONERRATAUPDATE
(ACTION_ID, ERRATA_ID)
LOGGING
NOPARALLEL;

--
-- 360. RHN_CNP_CNEP_IDX  (Index) 
--
CREATE INDEX RHN_CNP_CNEP_IDX ON RHNCHANNELNEWESTPACKAGE
(CHANNEL_ID, NAME_ID, PACKAGE_ARCH_ID, EVR_ID, PACKAGE_ID)
LOGGING
NOPARALLEL;

--
-- 361. RHN_CNP_NECP_IDX  (Index) 
--
CREATE INDEX RHN_CNP_NECP_IDX ON RHNCHANNELNEWESTPACKAGE
(NAME_ID, EVR_ID, CHANNEL_ID, PACKAGE_ID)
LOGGING
NOPARALLEL;

--
-- 362. RHN_CNP_PID_IDX  (Index) 
--
CREATE INDEX RHN_CNP_PID_IDX ON RHNCHANNELNEWESTPACKAGE
(PACKAGE_ID)
LOGGING
NOPARALLEL;

--
-- 363. RHN_EADDRESSLOG_A_IDX  (Index) 
--
CREATE INDEX RHN_EADDRESSLOG_A_IDX ON RHNEMAILADDRESSLOG
(ADDRESS)
LOGGING
NOPARALLEL;

--
-- 364. RHN_EADDRESSLOG_CREATED_IDX  (Index) 
--
CREATE INDEX RHN_EADDRESSLOG_CREATED_IDX ON RHNEMAILADDRESSLOG
(CREATED)
LOGGING
NOPARALLEL;

--
-- 365. RHN_EADDRESSLOG_UID_IDX  (Index) 
--
CREATE INDEX RHN_EADDRESSLOG_UID_IDX ON RHNEMAILADDRESSLOG
(USER_ID)
LOGGING
NOPARALLEL;

--
-- 366. RHN_EADDRESS_ID_IDX  (Index) 
--
CREATE INDEX RHN_EADDRESS_ID_IDX ON RHNEMAILADDRESS
(ID)
LOGGING
NOPARALLEL;

--
-- 367. RHN_EADDRESS_NIUSA_IDX  (Index) 
--
CREATE INDEX RHN_EADDRESS_NIUSA_IDX ON RHNEMAILADDRESS
(NEXT_ACTION, ID, USER_ID, STATE_ID, ADDRESS)
LOGGING
NOPARALLEL;

--
-- 368. RHN_EADDRESS_UID_SID_IDX  (Index) 
--
CREATE INDEX RHN_EADDRESS_UID_SID_IDX ON RHNEMAILADDRESS
(USER_ID, STATE_ID)
LOGGING
NOPARALLEL;

--
-- 369. RHN_EFILEPS_EFID_PID_IDX  (Index) 
--
CREATE INDEX RHN_EFILEPS_EFID_PID_IDX ON RHNERRATAFILEPACKAGESOURCE
(ERRATA_FILE_ID, PACKAGE_ID)
LOGGING
NOPARALLEL;

--
-- 370. RHN_EFILEP_EFID_PID_IDX  (Index) 
--
CREATE INDEX RHN_EFILEP_EFID_PID_IDX ON RHNERRATAFILEPACKAGE
(ERRATA_FILE_ID, PACKAGE_ID)
LOGGING
NOPARALLEL;

--
-- 371. RHN_EFILEP_PID_IDX  (Index) 
--
CREATE INDEX RHN_EFILEP_PID_IDX ON RHNERRATAFILEPACKAGE
(PACKAGE_ID)
LOGGING
NOPARALLEL;

--
-- 372. RHN_ERELTMP_FEID_TEID_IDX  (Index) 
--
CREATE INDEX RHN_ERELTMP_FEID_TEID_IDX ON RHNERRATARELATIONSHIPTMP
(FROM_ERRATA_ID, TO_ERRATA_ID)
LOGGING
NOPARALLEL;

--
-- 373. RHN_ERELTMP_TEID_FEID_IDX  (Index) 
--
CREATE INDEX RHN_ERELTMP_TEID_FEID_IDX ON RHNERRATARELATIONSHIPTMP
(TO_ERRATA_ID, FROM_ERRATA_ID)
LOGGING
NOPARALLEL;

--
-- 374. RHN_ERRATAFILETMP_EID_FILE_IDX  (Index) 
--
CREATE INDEX RHN_ERRATAFILETMP_EID_FILE_IDX ON RHNERRATAFILETMP
(ERRATA_ID, FILENAME)
LOGGING
NOPARALLEL;

--
-- 375. RHN_ERRATAFILETMP_ID_IDX  (Index) 
--
CREATE INDEX RHN_ERRATAFILETMP_ID_IDX ON RHNERRATAFILETMP
(ID)
LOGGING
NOPARALLEL;

--
-- 376. RHN_FILEDL_TOKEN_IDX  (Index) 
--
CREATE INDEX RHN_FILEDL_TOKEN_IDX ON RHNFILEDOWNLOAD
(TOKEN)
LOGGING
NOPARALLEL;

--
-- 377. RHN_FILEDL_UID_FID_IDX  (Index) 
--
CREATE INDEX RHN_FILEDL_UID_FID_IDX ON RHNFILEDOWNLOAD
(USER_ID, FILE_ID)
LOGGING
NOPARALLEL;

--
-- 378. RHN_REG_TOKEN_UID_IDX  (Index) 
--
CREATE INDEX RHN_REG_TOKEN_UID_IDX ON RHNREGTOKEN
(USER_ID)
NOLOGGING
NOPARALLEL;

--
-- 379. RHN_SAVEDSEARCH_ID_WCID_IDX  (Index) 
--
CREATE INDEX RHN_SAVEDSEARCH_ID_WCID_IDX ON RHNSAVEDSEARCH
(ID, WEB_CONTACT_ID)
LOGGING
NOPARALLEL;

--
-- 380. RHN_SAVEDSEARCH_NAME_WCID_IDX  (Index) 
--
CREATE INDEX RHN_SAVEDSEARCH_NAME_WCID_IDX ON RHNSAVEDSEARCH
(NAME, WEB_CONTACT_ID)
LOGGING
NOPARALLEL;

--
-- 381. RHN_SAVEDSEARCH_WCID_ID_IDX  (Index) 
--
CREATE INDEX RHN_SAVEDSEARCH_WCID_ID_IDX ON RHNSAVEDSEARCH
(WEB_CONTACT_ID, ID)
LOGGING
NOPARALLEL;

--
-- 382. RHN_SERVERGRP_NOTE_CREATOR_IDX  (Index) 
--
CREATE INDEX RHN_SERVERGRP_NOTE_CREATOR_IDX ON RHNSERVERGROUPNOTES
(CREATOR)
NOLOGGING
NOPARALLEL;

--
-- 383. RHN_SERVERHW_SID_HID_IDX  (Index) 
--
CREATE INDEX RHN_SERVERHW_SID_HID_IDX ON RHNSERVERHARDWARE
(SERVER_ID, HARDWARE_ID)
LOGGING
NOPARALLEL;

--
-- 384. RHN_SERVERNOTES_CREATOR_IDX  (Index) 
--
CREATE INDEX RHN_SERVERNOTES_CREATOR_IDX ON RHNSERVERNOTES
(CREATOR)
NOLOGGING
NOPARALLEL;

--
-- 385. RHN_SERVER_CREATED_ID_IDX  (Index) 
--
CREATE INDEX RHN_SERVER_CREATED_ID_IDX ON RHNSERVER
(CREATED, ID)
NOLOGGING
NOPARALLEL;

--
-- 386. RHN_SERVER_CREATOR_IDX  (Index) 
--
CREATE INDEX RHN_SERVER_CREATOR_IDX ON RHNSERVER
(CREATOR_ID)
NOLOGGING
NOPARALLEL;

--
-- 387. RHN_SERVER_INSTALL_INFO_ID_PK  (Index) 
--
CREATE UNIQUE INDEX RHN_SERVER_INSTALL_INFO_ID_PK ON RHNSERVERINSTALLINFO
(ID)
LOGGING
NOPARALLEL;

--
-- 388. RHN_SERVER_INSTALL_INFO_SID_UQ  (Index) 
--
CREATE UNIQUE INDEX RHN_SERVER_INSTALL_INFO_SID_UQ ON RHNSERVERINSTALLINFO
(SERVER_ID)
LOGGING
NOPARALLEL;

--
-- 389. RHN_SE_IDX  (Index) 
--
CREATE INDEX RHN_SE_IDX ON RHNSERVEREVENT
(SERVER_ID)
LOGGING
NOPARALLEL;

--
-- 390. RHN_SE_ID_PK  (Index) 
--
CREATE UNIQUE INDEX RHN_SE_ID_PK ON RHNSERVEREVENT
(ID)
LOGGING
NOPARALLEL;

--
-- 391. RHN_SM_MI_SID_UQ  (Index) 
--
CREATE UNIQUE INDEX RHN_SM_MI_SID_UQ ON RHNSERVERMESSAGE
(MESSAGE_ID, SERVER_ID)
LOGGING
NOPARALLEL;

--
-- 392. RHN_SM_UQ  (Index) 
--
CREATE UNIQUE INDEX RHN_SM_UQ ON RHNSERVERMESSAGE
(SERVER_ID, MESSAGE_ID)
LOGGING
NOPARALLEL;

--
-- 393. RHN_SQRESPONSE_QID_UID_IDX  (Index) 
--
CREATE INDEX RHN_SQRESPONSE_QID_UID_IDX ON RHNSURVEYQUESTIONRESPONSE
(QUESTION_ID, USER_ID)
LOGGING
NOPARALLEL;

--
-- 394. RHN_SQRESPONSE_UID_IDX  (Index) 
--
CREATE INDEX RHN_SQRESPONSE_UID_IDX ON RHNSURVEYQUESTIONRESPONSE
(USER_ID)
NOLOGGING
NOPARALLEL;

--
-- 395. RHN_SRV_NET_IFACE_SID_NAME_IDX  (Index) 
--
CREATE INDEX RHN_SRV_NET_IFACE_SID_NAME_IDX ON RHNSERVERNETINTERFACE
(SERVER_ID, NAME)
LOGGING
NOPARALLEL;

--
-- 396. RHN_S_INST_INFO_SID_IM_IDX  (Index) 
--
CREATE INDEX RHN_S_INST_INFO_SID_IM_IDX ON RHNSERVERINSTALLINFO
(SERVER_ID, INSTALL_METHOD)
LOGGING
NOPARALLEL;

--
-- 397. RHN_TRANSELEM_TID_TPID_UQ  (Index) 
--
CREATE UNIQUE INDEX RHN_TRANSELEM_TID_TPID_UQ ON RHNTRANSACTIONELEMENT
(TRANSACTION_ID, TRANSACTION_PACKAGE_ID)
LOGGING
NOPARALLEL;

--
-- 398. RHN_TRANS_ID_SID_TS_RTID_IDX  (Index) 
--
CREATE INDEX RHN_TRANS_ID_SID_TS_RTID_IDX ON RHNTRANSACTION
(ID, SERVER_ID, TIMESTAMP, RPM_TRANS_ID)
LOGGING
NOPARALLEL;

--
-- 399. RHN_TRANS_SID_RTI_UNQ  (Index) 
--
CREATE UNIQUE INDEX RHN_TRANS_SID_RTI_UNQ ON RHNTRANSACTION
(SERVER_ID, RPM_TRANS_ID)
LOGGING
NOPARALLEL;

--
-- 400. RHN_UM_UID_MID_UQ  (Index) 
--
CREATE UNIQUE INDEX RHN_UM_UID_MID_UQ ON RHNUSERMESSAGE
(USER_ID, MESSAGE_ID)
LOGGING
NOPARALLEL;

--
-- 401. RHN_USPREFS_SID_UID_N_IDX  (Index) 
--
CREATE INDEX RHN_USPREFS_SID_UID_N_IDX ON RHNUSERSERVERPREFS
(SERVER_ID, USER_ID, NAME)
NOLOGGING
NOPARALLEL;

--
-- 402. RHN_USURVEYSTATUS_SSU_IDX  (Index) 
--
CREATE INDEX RHN_USURVEYSTATUS_SSU_IDX ON RHNUSERSURVEYSTATUS
(SURVEY_ID, STATUS, USER_ID)
LOGGING
NOPARALLEL;

--
-- 403. RHN_USURVEYSTATUS_UID_SID_IDX  (Index) 
--
CREATE INDEX RHN_USURVEYSTATUS_UID_SID_IDX ON RHNUSERSURVEYSTATUS
(USER_ID, SURVEY_ID)
LOGGING
NOPARALLEL;

--
-- 404. RHN_CHANNEL  (Package) 
--
CREATE OR REPLACE PACKAGE rhn_channel
IS
    CURSOR server_base_subscriptions(server_id_in NUMBER) IS
    	   SELECT C.id
	     FROM rhnChannel C, rhnServerChannel SC
	    WHERE C.id = SC.channel_id
	      AND SC.server_id = server_id_in
	      AND C.parent_channel IS NULL;
    CURSOR check_server_subscription(server_id_in NUMBER, channel_id_in NUMBER) IS
           SELECT channel_id
	     FROM rhnServerChannel
	    WHERE server_id = server_id_in
	      AND channel_id = channel_id_in;
    CURSOR check_server_parent_membership(server_id_in NUMBER, channel_id_in NUMBER) IS
    	   SELECT C.id
	     FROM rhnChannel C, rhnServerChannel SC
	    WHERE C.parent_channel = channel_id_in
	      AND C.id = SC.channel_id
	      AND SC.server_id = server_id_in;
    CURSOR channel_family_perm_cursor(channel_family_id_in NUMBER, org_id_in NUMBER) IS
           SELECT *
	     FROM rhnChannelFamilyPermissions
	    WHERE channel_family_id = channel_family_id_in
	      AND (org_id = org_id_in OR org_id IS NULL);
    PROCEDURE license_consent(channel_id_in IN NUMBER, user_id_in IN NUMBER, server_id_in IN NUMBER);
    FUNCTION get_license_path(channel_id_in IN NUMBER) RETURN VARCHAR2;
    PROCEDURE unsubscribe_server(server_id_in IN NUMBER, channel_id_in NUMBER, immediate_in NUMBER := 1, unsubscribe_children_in number := 0);
    PROCEDURE subscribe_server(server_id_in IN NUMBER, channel_id_in NUMBER, immediate_in NUMBER := 1);
    FUNCTION guess_server_base(server_id_in IN NUMBER) RETURN NUMBER;
    PROCEDURE bulk_subscribe_server(channel_id_in IN NUMBER, set_label_in IN VARCHAR2, set_uid_in IN NUMBER);
    PROCEDURE bulk_unsubscribe_server(channel_id_in IN NUMBER, set_label_in IN VARCHAR2, set_uid_in IN NUMBER);
    PROCEDURE bulk_server_base_change(channel_id_in IN NUMBER, set_label_in IN VARCHAR2, set_uid_in IN NUMBER);
    procedure bulk_server_basechange_from(
	set_label_in in varchar2,
	set_uid_in in number,
	old_channel_id_in in number,
	new_channel_id_in in number);
    procedure bulk_guess_server_base(
	set_label_in in varchar2,
	set_uid_in in number);
    procedure bulk_guess_server_base_from(
	set_label_in in varchar2,
	set_uid_in in number,
	channel_id_in in number);
    PROCEDURE clear_subscriptions(server_id_in IN NUMBER);
    FUNCTION subscription_count(channel_id_in NUMBER) RETURN VARCHAR2;
    FUNCTION available_family_subscriptions(channel_family_id_in IN NUMBER, org_id_in IN NUMBER) RETURN NUMBER;
    PROCEDURE update_family_counts(channel_family_id_in IN NUMBER, org_id_in IN NUMBER);
    FUNCTION family_for_channel(channel_id_in IN NUMBER) RETURN NUMBER;
    FUNCTION available_chan_subscriptions(channel_id_in IN NUMBER, org_id_in IN NUMBER) RETURN NUMBER;
    procedure entitle_customer(customer_id_in in number, channel_family_id_in in number, quantity_in in number);
    procedure set_family_maxmembers(customer_id_in in number, channel_family_id_in in number, quantity_in in number);
    procedure unsubscribe_server_from_family(server_id_in in number, channel_family_id_in in number);
	procedure delete_server_channels(server_id_in in number);
    procedure refresh_newest_package(channel_id_in in number, caller_in in varchar2 := '(unknown)');
END rhn_channel;
/


--
-- 405. RHN_BEL  (Package Body) 
--
CREATE OR REPLACE package body rhn_bel
is
	function find_state_of_org (
		org_id_in in number
	) return varchar2 is
		state_label rhnOrgAvailableStates.label%TYPE;
	begin
		select oas.label into state_label
		from    rhnOrgAvailableStates oas,
			rhnOrgState os
		where   os.org_id = org_id_in
			and os.state_id = oas.id;
		return state_label;
	end find_state_of_org;
	function is_state_legacy_unclassified (
		org_id_in in number
	) return number is
		cursor states is
			select	1
			from	rhnOrgAvailableStates oas,
					rhnOrgState os
			where	os.org_id = org_id_in
				and os.state_id = oas.id
					and oas.label = 'legacy_unclassified';
	begin
		for x in states loop return 1; end loop;
		return 0;
	end is_state_legacy_unclassified;
	function is_org_paid (
		org_id_in in number
	) return number is
		cursor paids is
			select	1
			from	rhnPaidOrgs
			where	org_id = org_id_in;
	begin
		for paid in paids loop return 1; end loop;
		return 0;
	end;
	function lookup_email_state (
		state_in in varchar2
	) return number is
		retval number;
	begin
		select id into retval from rhnEmailAddressState where label = state_in;
		return retval;
	exception
			when no_data_found then
				rhn_exception.raise_exception('invalid_state');
	end lookup_email_state;
	procedure check_org_state (
		state_id_in in number
	) is
		ignore number;
	begin
		select id into ignore from rhnOrgAvailableStates where id = state_id_in;
	exception
			when no_data_found then
				rhn_exception.raise_exception('invalid_state');
	end check_org_state;
	function lookup_org_state (
		state_in in varchar2
	) return number is
		retval number;
	begin
		select id into retval from rhnOrgAvailableStates where label = state_in;
		return retval;
	exception
			when no_data_found then
				rhn_exception.raise_exception('invalid_state');
	end lookup_org_state;
	procedure validate_org_state_change (
		from_state_in in number,
		to_state_in in number
	) is
		ignore	number;
	begin
		select	1
		into	ignore
		from	rhnOrgStateTransitions	rost
		where	1=1
			and rost.from_state = from_state_in
			and rost.to_state = to_state_in;
	exception
		when no_data_found then
			rhn_exception.raise_exception('invalid_state_transition');
	end;
	procedure join_rhn (
		org_id_in in number
	) is
		state_label	rhnOrgAvailableStates.label%TYPE;
	begin
	    	select OAS.label into state_label
		  from rhnOrgAvailableStates OAS,
		       rhnOrgState OS
		 where OS.state_id = OAS.id
		   and OS.org_id = org_id_in;
		if state_label = 'legacy_web'
		then
		    update rhnOrgState
		       set state_id = rhn_bel.lookup_org_state('legacy_unclassified'),
		           next_action = sysdate
		     where org_id = org_id_in;
    	    	    insert into rhnOrgStateLog
    	    	      (org_id, old_state_id, new_state_id, reason)
    	    	    values
    	    	      (org_id_in,
    	    	       (select state_id from rhnOrgState where org_id = org_id_in),
    	    	        rhn_bel.lookup_org_state('legacy_unclassified'),
    	    	        'rhn_bel.join_rhn package method');
		end if;
	end;
	procedure set_org_paid(
		org_id_in in number
	) is
	begin
    	insert into rhnOrgStateLog (
			org_id, old_state_id, new_state_id, reason
		) values (
			org_id_in,
			(select state_id from rhnOrgState where org_id = org_id_in),
    	    rhn_bel.lookup_org_state('paid'),
    	    'rhn_bel.set_org_paid'
		);
		update	rhnOrgState
		set		state_id =
				(select id from rhnOrgAvailableStates where label = 'paid'),
				next_action = NULL
		where	org_id = org_id_in;
    end set_org_paid;
	procedure set_org_unpaid (
		org_id_in in number
	) is
	begin
		update	rhnOrgState
		set		state_id = (select id from rhnOrgAvailableStates where label = 'falling_from_grace'),
				next_action = sysdate
		where	org_id = org_id_in;
    	    	insert into rhnOrgStateLog
    	    	  (org_id, old_state_id, new_state_id, reason)
    	    	values
    	    	  (org_id_in,
    	    	   (select state_id from rhnOrgState where org_id = org_id_in),
    	    	   rhn_bel.lookup_org_state('falling_from_grace'),
    	    	   'rhn_bel.set_org_unpaid');
	end set_org_unpaid;
end;
/


--
-- 406. DELETE_CHANNEL  (Procedure) 
--
CREATE OR REPLACE procedure delete_channel (
	channel_id_in in number
) is
begin
        delete from rhnChannelPackage where channel_id = channel_id_in;
        delete from rhnChannelErrata where channel_id = channel_id_in;
        delete from rhnServerChannel where channel_id = channel_id_in;
        delete from rhnRegTokenChannels where channel_id = channel_id_in;
        delete from rhnDistChannelMap where channel_id = channel_id_in;
        delete from rhnChannelFamilyMembers where channel_id = channel_id_in;
        delete from rhnServerProfilePackage where server_profile_id in (
            select id from rhnServerProfile where base_channel = channel_id_in
        );
        delete from rhnServerProfile where base_channel = channel_id_in;
        delete from rhnChannel where id = channel_id_in;
end;
/


--
-- 407. DELETE_SERVER  (Procedure) 
--
CREATE OR REPLACE procedure delete_server (
	server_id_in in number
) is
begin
	rhn_channel.delete_server_channels(server_id_in);
	delete
	from	rhnSet
	where	1=1
		and user_id in (
			select	wc.id
			from	rhnServer rs,
				web_contact wc
			where	rs.id = server_id_in
				and rs.org_id = wc.org_id
		)
		and label = 'system_list'
		and element = server_id_in;
	delete
	from	rhnServer
		where id = server_id_in;
end;
/


--
-- 408. RHNHISTORYVIEW_PKGLIST  (Function) 
--
CREATE OR REPLACE function
rhnHistoryView_pkglist(action_id IN NUMBER, separator IN VARCHAR2 DEFAULT chr(10))
return VARCHAR2
is
    store_var  VARCHAR2(4000);
    store_tmp  VARCHAR2(4000);
    select_sql VARCHAR2(4000);
    trimmed NUMBER;
    cursor pkg_cursor(action_id_in IN NUMBER)
    is
       select
           pn.name||'-'||pevr.version||'-'||pevr.release||'.'||pa.name
       from
           rhnPackageName pn, rhnPackageEVR pevr, rhnPackageArch pa,
	   rhnActionPackage ap
       where
               ap.name_id = pn.id
	   and ap.evr_id = pevr.id
	   and ap.package_arch_id = pa.id(+)
	   and ap.action_id = action_id_in;
begin
    store_var := NULL;
    trimmed := 0;
    open pkg_cursor(action_id);
    loop
	fetch pkg_cursor into store_tmp;
	exit when pkg_cursor%NOTFOUND;
	if store_var is NULL then
	   store_var := store_tmp;
	else
	   trimmed := 1;
	   exit when length(store_var) + length(separator) + length(store_tmp) > 3700;
	   store_var := store_var || separator || store_tmp;
	   trimmed := 0;
	end if;
    end loop;
    close pkg_cursor;
    if trimmed <> 0 then
        store_var := store_var || separator || '...';
    end if;
    return store_var;
end;
/



CREATE OR REPLACE FORCE VIEW RHNACTIONOVERVIEW
(ORG_ID, ACTION_ID, TYPE_ID, TYPE_NAME, NAME, 
 SCHEDULER_LOGIN, EARLIEST_ACTION, TOTAL_COUNT, SUCCESSFUL_COUNT, FAILED_COUNT, 
 IN_PROGRESS_COUNT, ARCHIVED)
AS 
SELECT    A.org_id,
	  A.id,
	  AT.id,
	  AT.name,
	  A.name,
	  U.login,
	  A.earliest_action,
	  (SELECT COUNT(*) FROM rhnServerAction WHERE action_id = A.id),
	  (SELECT COUNT(*) FROM rhnServerAction WHERE action_id = A.id AND status = 2),
	  (SELECT COUNT(*) FROM rhnServerAction WHERE action_id = A.id AND status = 3),
	  (SELECT COUNT(*) FROM rhnServerAction WHERE action_id = A.id AND status NOT IN (2, 3)),
	  A.archived
FROM
	  web_contact U,
	  rhnActionType AT,
	  rhnAction A
WHERE	  A.scheduler = U.id(+)
AND	  A.action_type = AT.id
ORDER BY  A.earliest_action;

--
-- 410. RHNAVAILABLECHANNELS  (View) 
--
CREATE OR REPLACE FORCE VIEW RHNAVAILABLECHANNELS
(ORG_ID, CHANNEL_ID, CHANNEL_DEPTH, CHANNEL_NAME, CHANNEL_ARCH_ID, 
 PADDED_NAME, CURRENT_MEMBERS, AVAILABLE_MEMBERS, LAST_MODIFIED, CHANNEL_LABEL, 
 PARENT_OR_SELF_LABEL)
AS 
select
     o.id,
     cperm.channel_id,
     CT.depth,
     CT.name,
     CT.channel_arch_id,
     CT.padded_name,
     (SELECT COUNT(1)
        FROM rhnServer S
       WHERE S.org_id = o.id
         AND EXISTS (SELECT 1 FROM rhnServerChannel WHERE channel_id = cperm.channel_id AND server_id = S.id)),
     rhn_channel.available_chan_subscriptions(cperm.channel_id, o.id),
     CT.last_modified,
     CT.label,
     CT.parent_or_self_label
from
     web_customer O,
     rhnChannelTreeView CT,
     rhnChannelPermissions CPerm
where
    CT.id = CPerm.channel_id
and (o.id = cperm.org_id
 or cperm.org_id is null);

--
-- 411. RHNCHANNELNEWESTPACKAGEVIEW  (View) 
--
CREATE OR REPLACE FORCE VIEW RHNCHANNELNEWESTPACKAGEVIEW
(CHANNEL_ID, NAME_ID, EVR_ID, PACKAGE_ARCH_ID, PACKAGE_ID)
AS 
select  cp.channel_id		channel_id,
		p.name_id			name_id,
		p.evr_id			evr_id,
		p.package_arch_id	package_arch_id,
		p.id				package_id
from	rhnPackageEVR		pe,
		rhnPackage			p,
		rhnChannelPackage	cp
where	cp.package_id = p.id
		and p.evr_id = pe.id
		and pe.evr = (
			select	max(sq_pe.evr)
			from	rhnChannelPackage sq_cp,
					rhnPackage sq_p,
					rhnPackageEVR sq_pe
			where	1=1
				and sq_cp.channel_id = cp.channel_id
				and sq_cp.package_id = sq_p.id
				and sq_p.name_id = p.name_id
				and sq_pe.id = sq_p.evr_id
		);

--
-- 412. RHNENTITLEDSERVERS  (View) 
--
CREATE OR REPLACE FORCE VIEW RHNENTITLEDSERVERS
(ID, ORG_ID, DIGITAL_SERVER_ID, SERVER_ARCH_ID, OS, 
 RELEASE, NAME, DESCRIPTION, INFO, SECRET)
AS 
select distinct
    S.id,
    S.org_id,
    S.digital_server_id,
    S.server_arch_id,
    S.os,
    S.release,
    S.name,
    S.description,
    S.info,
    S.secret
from
    rhnServerGroup SG,
    rhnServerGroupType SGT,
    rhnServerGroupMembers SGM,
    rhnServer S
where
    S.id = SGM.server_id
and SG.id = SGM.server_group_id
and (SGT.label = 'sw_mgr_entitled' OR SGT.label = 'enterprise_entitled')
and SG.group_type = SGT.id
and SG.org_id = S.org_id;

create or replace view
rhnFreeErrataMail as
select
	w.login login, 
	w.login_uc login_uc,
	ea.address email,
	w.id user_id,
	s.id server_id,  
	w.org_id org_id, 
	s.name server_name,  
	sa.name server_arch,  
	s.release server_release,  
	ce.errata_id errata_id,
	e.advisory advisory
from
	rhnChannelErrata ce,
	rhnServerChannel sc,
	rhnServerGroupMembers sgm,
	rhnOrgState os,
	rhnServerGroup sg,
	rhnServer s,
	web_contact w, 
	rhnEmailAddress ea,
	rhnUserInfo ui,
	rhnErrata e,
	rhnServerArch sa
where	1=1
	-- errata applies to server
	and ce.channel_id = sc.channel_id
	and sc.server_id = sgm.server_id
	-- and server is in a group that's paid for
	and sgm.server_group_id = sg.id
	-- use sg so that we don't need rhnServer for selection, just
	-- results
	and sg.org_id = w.org_id
	-- filter out users who don't want mail about this server
	-- they get an entry if they _don't_ want mail
	and not exists (
		select	usprefs.server_id 
            	from	rhnUserServerPrefs usprefs
	   	where	1=1
	      		and usprefs.name = 'receive_notifications'
			and w.id = usprefs.user_id 
	      		and sc.server_id = usprefs.server_id 
	)
	and ea.state_id = 4
	and w.id = ea.user_id
	-- filter out users who don't want/can't get email
	and w.id = ui.user_id
    	and ui.email_notify = 1
	and os.state_id in (5, 6, 7, 8, 11)
	and sg.org_id = os.org_id
	-- we're not checking for org_admin group or userservergroupperms
	-- this is a free customer, he gets no such cpu or disk io from us.
	--
	-- below here isn't needed except for output
	--
	-- find the server, so we can do s.arch comparisons
	and s.server_arch_id = sa.id
	and sc.server_id = s.id
	and ce.errata_id = e.id
/

--
-- 414. RHNHISTORYVIEW_REFRESH  (View) 
--
CREATE OR REPLACE FORCE VIEW RHNHISTORYVIEW_REFRESH
(EVENT_ID, SERVER_ID, SUMMARY, DETAILS, CREATED, 
 MODIFIED)
AS 
select
    sa.action_id event_id,
    sa.server_id,
    at.name || ' scheduled by ' || contact.login || ' (' || astat.name || ')' summary,
    'This action will be executed after ' ||
        to_char(a.earliest_action, 'YYYY-MM-DD HH24:MI:SS') || ' EST' || chr(10) || chr(10) ||
	'The current action status is: ' || astat.name || chr(10) ||
	nvl2(sa.pickup_time,
	    'The client picked up this action on ' ||
	        to_char(sa.pickup_time, 'YYYY-MM-DD HH24:MI:SS') || ' EST',
	    'This action has not been picked up') || chr(10) ||
	nvl2(sa.completion_time,
	    'The client reported completion on execution on ' ||
	        to_char(sa.completion_time, 'YYYY-MM-DD HH24:MI:SS') || ' EST',
	    'This action has not been fully executed') || chr(10) ||
	nvl2(sa.result_code,
	    'Client execution returned code '||to_char(sa.result_code)||
	        ' ('||nvl(sa.result_msg, 'SUCCESS')||')',
	    '') ||
	chr(10) ||
	'' details,
    a.created,
    sa.modified
from
    rhnAction a, rhnServerAction sa,
    rhnActionType at, rhnActionStatus astat,
    web_contact contact
where
    sa.action_id = a.id
and a.action_type = at.id
and a.scheduler = contact.id
and sa.status = astat.id
and at.label in ('packages.refresh_list', 'hardware.refresh_list', 'reboot.reboot', 'rollback.rollback')
with
    read only;

--
-- 415. RHNORGPACKAGEOVERVIEW  (View) 
--
CREATE OR REPLACE FORCE VIEW RHNORGPACKAGEOVERVIEW
(ORG_ID, CHANNEL_ARCH_ID, PACKAGE_ID, PACKAGE_NVREA)
AS 
select
    p.org_id org_id,
    cpac.channel_arch_id,
    p.id package_id,
    rhn_package.canonical_name(p_name.name, p_evr.evr, pa.name) package_nvrea
from
    rhnPackageName p_name,
    rhnPackageEVR p_evr,
    rhnPackageArch pa,
    rhnChannelPackageArchCompat cpac,
    rhnPackage p
where
        p_name.id = p.name_id
    and p_evr.id = p.evr_id
    and cpac.package_arch_id = p.package_arch_id
    and p.package_arch_id = pa.id
order by package_nvrea, p.created;

create or replace view
rhnPaidErrataMail as
select
	w.login login, 
	w.login_uc login_uc,
	ea.address email,
	w.id user_id,
	s.id server_id,  
	w.org_id org_id, 
	s.name server_name,  
	sa.name server_arch,  
	s.release server_release,  
	ce.errata_id errata_id,
	e.advisory advisory
from
	rhnChannelErrata ce,
	rhnServerChannel sc,
	rhnServerGroupMembers sgm,
	rhnOrgState os,
	rhnServerGroup sg,
	rhnServer s,
	web_contact w, 
	rhnEmailAddress ea,
	rhnUserInfo ui,
	rhnErrata e,
	rhnServerArch sa
where	1=1
	-- errata applies to server
	and ce.channel_id = sc.channel_id
	and sc.server_id = sgm.server_id
	-- and server is in a group that's paid for
	and sgm.server_group_id = sg.id
	and os.state_id = 4
	and sg.org_id = os.org_id
	-- use sg so that we don't need rhnServer for selection, just
	-- results
	and sg.org_id = w.org_id
	and ea.state_id = 4
	and w.id = ea.user_id
	-- filter out users who don't want mail about this server
	-- they get an entry if they _don't_ want mail
	and not exists (
		select	usprefs.server_id 
            	from	rhnUserServerPrefs usprefs
	   	where	1=1
	      		and usprefs.name = 'receive_notifications'
			and w.id = usprefs.user_id 
	      		and sc.server_id = usprefs.server_id 
	)
	-- filter out users who don't want/can't get email
	and w.id = ui.user_id
    	and ui.email_notify = 1
    	-- check permissions. For this query being an org admin is the
    	-- most common thing, so we test for that first
	and exists (
		select	1
		from	
			rhnUserGroupType	ugt,
			rhnUserGroup		ug,
			rhnUserGroupMembers	ugm
		where	1=1
			and ugt.label = 'org_admin'
			and ugt.id = ug.group_type
			and ug.id = ugm.user_group_id
			and ugm.user_id = w.id
		union all
		select	1
		from
			rhnServerGroupMembers	sq_sgm,
			rhnUserServerGroupPerms	usg
		where	sc.server_id = sq_sgm.server_id
			and sq_sgm.server_group_id = usg.server_group_id
			and usg.user_id = w.id
	)
	-- find the server, so we can do s.arch comparisons
	and sc.server_id = s.id
    	and exists (
        	select 1
		from
	    		rhnPackageEVR			p_evr,
	    		rhnPackageEVR			sp_evr,
	    		rhnServerPackage 		sp,
	    		rhnChannelPackage		cp,
	    		rhnPackage			p,
	    		rhnErrataPackage		ep,
	    		rhnServerPackageArchCompat	spac
		where	1=1
			-- packages from channels this server is subscribed to
			and sc.channel_id = cp.channel_id
			and cp.package_id = p.id
			-- part of an errata
			and ce.errata_id = ep.errata_id
			and ep.package_id = p.id
			-- and that errata maps back to the server channel
			and sc.channel_id = ce.channel_id
			and ce.errata_id = ep.errata_id
			-- also installed on this server
			and sc.server_id = sp.server_id
			and sp.name_id = p.name_id
			and sp.evr_id = sp_evr.id
			-- different evr
			and p.evr_id = p_evr.id
			and sp.evr_id != p.evr_id
			-- and newer evr
			and sp_evr.evr < p_evr.evr
			-- compat arch
			and p.package_arch_id = spac.package_arch_id
			and s.server_arch_id = spac.server_arch_id
	)
	-- below here isn't needed except for output
	and s.server_arch_id = sa.id
	and ce.errata_id = e.id
/

create or replace view
rhnPrivateErrataMail
as
select
	w.login, 
	w.login_uc,
	wpi.email,  
	w.id user_id,
	s.id server_id,  
	-- use sg here so we can start with org and work to errata from there
	w.org_id org_id, 
	s.name server_name,  
	sa.name server_arch,  
	s.release server_release,  
	ce.errata_id errata_id,
	e.advisory
from
	rhnServer s,
	web_user_personal_info wpi,
	rhnUserInfo ui,
	rhnErrata e,
	rhnServerArch sa,
	rhnChannelErrata ce,
	web_contact w, 
	rhnServerChannel sc,
	rhnServerGroupMembers sgm,
	rhnServerGroup sg
where	1=1
	-- we plan on starting with org_id, and server group is the 
	-- best place to find that that's near servers
	and sg.id = sgm.server_group_id
	and sgm.server_id = sc.server_id
	-- then find the contacts, because permission checking is next
	and sg.org_id = w.org_id
	-- filter out users who don't want mail about this server
	-- they get an entry if they _don't_ want mail
	and not exists (
		select	usprefs.server_id 
            	from	rhnUserServerPrefs usprefs
	   	where	1=1
			and w.id = usprefs.user_id 
	      		and sc.server_id = usprefs.server_id 
	      		and usprefs.name = 'receive_notifications'
	)
	-- filter out users who don't want/can't get email
	and w.id = wpi.web_user_id
	and wpi.email is not null
	and w.id = ui.user_id
    	and ui.email_notify = 1
    	-- check permissions. For this query being an org admin is the
    	-- most common thing, so we test for that first
	and exists (
		select	1
		from	
			rhnUserGroupType	ugt,
			rhnUserGroup		ug,
			rhnUserGroupMembers	ugm
		where	1=1
			and ugt.label = 'org_admin'
			and ugt.id = ug.group_type
			and ug.id = ugm.user_group_id
			and ugm.user_id = w.id
		union all
		select	1
		from
			rhnServerGroupMembers	sq_sgm,
			rhnUserServerGroupPerms	usg
		where	sc.server_id = sq_sgm.server_id
			and sq_sgm.server_group_id = usg.server_group_id
			and usg.user_id = w.id
	)
	-- filter out servers that aren't in useful channels
	and sc.channel_id = ce.channel_id
	-- find the server, so we can do s.arch comparisons
	and sc.server_id = s.id
    	and exists (
        	select 1
		from
	    		rhnPackageEVR			p_evr,
	    		rhnPackageEVR			sp_evr,
	    		rhnServerPackage 		sp,
	    		rhnChannelPackage		cp,
	    		rhnPackage			p,
	    		rhnErrataPackage		ep,
	    		rhnServerPackageArchCompat	spac
		where	1=1
			-- packages from channels this server is subscribed to
			and sc.channel_id = cp.channel_id
			and cp.package_id = p.id
			-- part of an errata
			and ce.errata_id = ep.errata_id
			and ep.package_id = p.id
			-- and that errata maps back to the server channel
			and sc.channel_id = ce.channel_id
			and ce.errata_id = ep.errata_id
			-- also installed on this server
			and sc.server_id = sp.server_id
			and sp.name_id = p.name_id
			and sp.evr_id = sp_evr.id
			-- different evr
			and p.evr_id = p_evr.id
			and sp.evr_id != p.evr_id
			-- and newer evr
			and sp_evr.evr < p_evr.evr
			and sp_evr.evr = (
				select	max(sq2_pe.evr)
				from	rhnServerPackage	sq2_sp,
					rhnPackageEVR		sq2_pe
				where	sp.server_id = sq2_sp.server_id
					and sp.name_id = sq2_sp.name_id
					and sq2_sp.evr_id = sq2_pe.id
			)
			-- compat arch
			and p.package_arch_id = spac.package_arch_id
			and s.server_arch_id = spac.server_arch_id
	)
	-- below here isn't needed except for output
	and s.server_arch_id = sa.id
	and ce.errata_id = e.id
/

--
-- 418. RHNSERVERGROUPOVLITEHELPER  (View) 
--
CREATE OR REPLACE FORCE VIEW RHNSERVERGROUPOVLITEHELPER
(SERVER_GROUP_ID, ADVISORY_TYPE)
AS 
select	sgm.server_group_id						server_group_id,
		e.advisory_type							advisory_type
from	rhnErrata								e,
		rhnServerNeededPackageCache				snpc,
		rhnServerGroupMembers					sgm
where   1=1
	and sgm.server_id = snpc.server_id
	and snpc.errata_id = e.id;

--
-- 419. RHNSERVERNEEDEDPACKAGEVIEW  (View) 
--
CREATE OR REPLACE FORCE VIEW RHNSERVERNEEDEDPACKAGEVIEW
(ORG_ID, SERVER_ID, ERRATA_ID, PACKAGE_ID)
AS 
SELECT   S.org_id, S.id, EP.errata_id, P.id
FROM
	 rhnPackage P,
	 rhnServerPackageArchCompat SPAC,
	 rhnPackageEVR P_EVR,
	 rhnPackageEVR SP_EVR,
	 rhnErrataPackage EP,
	 rhnServerPackage SP,
	 rhnChannelPackage CP,
	 rhnServerChannel SC,
         rhnServer S
WHERE
    	 SC.server_id = S.id
  AND  	 SC.channel_id = CP.channel_id
  AND    CP.package_id = P.id
  AND    p.package_arch_id = spac.package_arch_id
  AND    spac.server_arch_id = s.server_arch_id
  AND    P.id = EP.package_id(+)
  AND    SP_EVR.id = SP.evr_id
  AND    P_EVR.id = P.evr_id
  AND    SP.server_id = S.id
  AND    SP.name_id = P.name_id
  AND    SP.evr_id != P.evr_id
  AND    SP_EVR.evr < P_EVR.evr
  AND    SP_EVR.evr = (SELECT MAX(PE.evr) FROM rhnServerPackage SP2, rhnPackageEvr PE WHERE PE.id = SP2.evr_id AND SP2.server_id = SP.server_id AND SP2.name_id = SP.name_id)
  AND    (   EP.errata_id IS NULL
          OR EXISTS (SELECT 1 FROM rhnChannelErrata CE, rhnServerChannel SC2 WHERE CE.errata_id = EP.errata_id AND CE.channel_id = SC2.channel_id AND SC2.server_id = S.id));

--
-- 420. RHNVISSERVERGROUPOVERVIEWLITE  (View) 
--
CREATE OR REPLACE FORCE VIEW RHNVISSERVERGROUPOVERVIEWLITE
(ORG_ID, SECURITY_ERRATA, BUG_ERRATA, ENHANCEMENT_ERRATA, GROUP_ID, 
 GROUP_NAME, GROUP_ADMINS, SERVER_COUNT, NOTE_COUNT, MODIFIED, 
 MAX_MEMBERS)
AS 
select	sg.org_id					org_id,
		case when exists (
			select	1
			from	rhnServerGroupOVLiteHelper
			where	server_group_id = sg.id
				and advisory_type = 'Security Advisory'
			)
			then 1
			else 0
			end						security_errata,
		case when exists (
			select	1
			from	rhnServerGroupOVLiteHelper
			where	server_group_id = sg.id
				and advisory_type = 'Bug Fix Advisory'
			)
			then 1
			else 0
			end						bug_errata,
		case when exists (
			select	1
			from	rhnServerGroupOVLiteHelper
			where	server_group_id = sg.id
				and advisory_type = 'Product Enhancement Advisory'
			)
			then 1
			else 0
			end						enhancement_errata,
		sg.id						group_id,
		sg.name						group_name,
		(	select	count(*)
			from	rhnUserManagedServerGroups	umsg
			where	umsg.server_group_id = sg.id
		)							group_admins,
		(	select	count(*)
			from	rhnServerGroupMembers		sgm
			where	sgm.server_group_id = sg.id
		)							server_count,
		0							note_count,
		sysdate						modified,
		max_members					max_members
from	rhnVisibleServerGroup		sg;

--
-- 421. RHN_BL_OBS_CHAN_LAST_MOD_TRIG  (Trigger) 
--
CREATE OR REPLACE TRIGGER RHN_BL_OBS_CHAN_LAST_MOD_TRIG
BEFORE INSERT OR UPDATE OR DELETE ON RHNBLACKLISTOBSOLETES
FOR EACH ROW
begin
	update rhnChannel
	set last_modified = greatest(sysdate, last_modified + 1/86400)
        where id in (
            select cp.channel_id
            from rhnChannelPackage cp, rhnPackage p
            where cp.package_id = p.id
            and p.name_id = :old.name_id
            and p.evr_id = :old.evr_id
            and p.package_arch_id = :old.package_arch_id
        );
end;
/


--
-- 422. RHN_EADDRESS_MOD_TRIG  (Trigger) 
--
CREATE OR REPLACE TRIGGER RHN_EADDRESS_MOD_TRIG
BEFORE INSERT OR UPDATE ON RHNEMAILADDRESS
FOR EACH ROW
begin
	:new.modified := sysdate;
end;
/


--
-- 423. RHN_EFILEPS_MOD_TRIG  (Trigger) 
--
CREATE OR REPLACE TRIGGER RHN_EFILEPS_MOD_TRIG
BEFORE INSERT OR UPDATE ON RHNERRATAFILEPACKAGESOURCE
FOR EACH ROW
begin
	:new.modified := sysdate;
end;
/


--
-- 424. RHN_EFILEP_MOD_TRIG  (Trigger) 
--
CREATE OR REPLACE TRIGGER RHN_EFILEP_MOD_TRIG
BEFORE INSERT OR UPDATE ON RHNERRATAFILEPACKAGE
FOR EACH ROW
begin
	:new.modified := sysdate;
end;
/


--
-- 425. RHN_ERELTMP_MOD_TRIG  (Trigger) 
--
CREATE OR REPLACE TRIGGER RHN_ERELTMP_MOD_TRIG
BEFORE INSERT OR UPDATE ON RHNERRATARELATIONSHIPTMP
FOR EACH ROW
begin
	:new.modified := sysdate;
end;
/


--
-- 426. RHN_ERRATAFILETMP_MOD_TRIG  (Trigger) 
--
CREATE OR REPLACE TRIGGER RHN_ERRATAFILETMP_MOD_TRIG
BEFORE INSERT OR UPDATE ON RHNERRATAFILETMP
FOR EACH ROW
begin
        :new.modified := sysdate;
end;
/


--
-- 427. RHN_SERVERHW_MOD_TRIG  (Trigger) 
--
CREATE OR REPLACE TRIGGER RHN_SERVERHW_MOD_TRIG
BEFORE INSERT OR UPDATE ON RHNSERVERHARDWARE
FOR EACH ROW
begin
        :new.modified := sysdate;
end;
/


--
-- 428. RHN_SE_MOD_TRIG  (Trigger) 
--
CREATE OR REPLACE TRIGGER RHN_SE_MOD_TRIG
BEFORE INSERT OR UPDATE ON RHNSERVEREVENT
FOR EACH ROW
begin
	:new.modified := sysdate;
end;
/


--
-- 429. RHN_SM_MOD_TRIG  (Trigger) 
--
CREATE OR REPLACE TRIGGER RHN_SM_MOD_TRIG
BEFORE INSERT OR UPDATE ON RHNSERVERMESSAGE
FOR EACH ROW
begin
	:new.modified := sysdate;
end;
/


--
-- 430. RHN_SRV_NET_IFACE_MOD_TRIG  (Trigger) 
--
CREATE OR REPLACE TRIGGER RHN_SRV_NET_IFACE_MOD_TRIG
BEFORE INSERT OR UPDATE ON RHNSERVERNETINTERFACE
FOR EACH ROW
begin
        :new.modified := sysdate;
end;
/


--
-- 431. RHN_S_INST_INFO_MOD_TRIG  (Trigger) 
--
CREATE OR REPLACE TRIGGER RHN_S_INST_INFO_MOD_TRIG
BEFORE INSERT OR UPDATE ON RHNSERVERINSTALLINFO
FOR EACH ROW
begin
	:new.modified := sysdate;
end;
/


--
-- 432. RHN_TRANS_MOD_TRIG  (Trigger) 
--
CREATE OR REPLACE TRIGGER RHN_TRANS_MOD_TRIG
BEFORE INSERT OR UPDATE ON RHNTRANSACTION
FOR EACH ROW
begin
	:new.modified := sysdate;
end;
/


--
-- 433. RHN_USER_INFO_MOD_TRIG  (Trigger) 
--
CREATE OR REPLACE TRIGGER RHN_USER_INFO_MOD_TRIG
BEFORE INSERT OR UPDATE ON RHNUSERINFO
FOR EACH ROW
begin
	:new.modified := sysdate;
end;
/


--
-- 434. RHNACTIONPACKAGEREMOVALFAILURE  (Table) 
--
CREATE TABLE RHNACTIONPACKAGEREMOVALFAILURE
(
  SERVER_ID      NUMBER,
  ACTION_ID      NUMBER,
  NAME_ID        NUMBER,
  EVR_ID         NUMBER,
  CAPABILITY_ID  NUMBER,
  FLAGS          NUMBER,
  SUGGESTED      NUMBER,
  SENSE          NUMBER
)
LOGGING 
NOCACHE
NOPARALLEL;

--
-- 435. RHNACTIONTRANSACTIONS  (Table) 
--
CREATE TABLE RHNACTIONTRANSACTIONS
(
  ACTION_ID      NUMBER,
  FROM_TRANS_ID  NUMBER,
  TO_TRANS_ID    NUMBER
)
LOGGING 
NOCACHE
NOPARALLEL;

--
-- 436. RHNCHANNELFAMILYLICENSECONSENT  (Table) 
--
CREATE TABLE RHNCHANNELFAMILYLICENSECONSENT
(
  CHANNEL_FAMILY_ID  NUMBER,
  USER_ID            NUMBER,
  SERVER_ID          NUMBER,
  CREATED            DATE                       DEFAULT (sysdate),
  MODIFIED           DATE                       DEFAULT (sysdate)
)
LOGGING 
NOCACHE
NOPARALLEL;

--
-- 437. CPU_ARCH_ID  (Column) 
--
ALTER TABLE RHNCPU ADD (CPU_ARCH_ID  NUMBER);
update rhnCpu
set cpu_arch_id = (
    select ca.id from rhnCpuArch ca, rhnArch a
    where a.name = ca.label and a.id = arch);
commit;

--
-- 48. RHNARCH  (Table) 
--
ALTER TABLE RHNARCH DROP PRIMARY KEY CASCADE;
DROP TABLE RHNARCH CASCADE CONSTRAINTS;



--
-- 438. ARCH  (Column) 
--
ALTER TABLE RHNCPU DROP COLUMN ARCH;

--
-- 439. RHNMONITOR  (Table) 
--
CREATE TABLE RHNMONITOR
(
  BATCH_ID     NUMBER,
  SERVER_ID    NUMBER,
  PROBE_ID     NUMBER,
  COMPONENT    VARCHAR2(128),
  FIELD        VARCHAR2(128),
  TIMESTAMP    DATE,
  GRANULARITY  NUMBER,
  VALUE        VARCHAR2(4000)
)
LOGGING 
NOCACHE
NOPARALLEL;

--
-- 440. RHNSATELLITECHANNELFAMILY  (Table) 
--
CREATE TABLE RHNSATELLITECHANNELFAMILY
(
  SERVER_ID          NUMBER,
  CHANNEL_FAMILY_ID  NUMBER,
  QUANTITY           NUMBER,
  CREATED            DATE                       DEFAULT (sysdate),
  MODIFIED           DATE                       DEFAULT (sysdate)
)
LOGGING 
NOCACHE
NOPARALLEL;

--
-- 441. PRODUCT  (Column) 
--
ALTER TABLE RHNSATELLITEINFO ADD (PRODUCT  VARCHAR2(256));

--
-- 442. OWNER  (Column) 
--
ALTER TABLE RHNSATELLITEINFO ADD (OWNER  VARCHAR2(256));

--
-- 443. ISSUED_STRING  (Column) 
--
ALTER TABLE RHNSATELLITEINFO ADD (ISSUED_STRING  VARCHAR2(256));

--
-- 444. EXPIRATION_STRING  (Column) 
--
ALTER TABLE RHNSATELLITEINFO ADD (EXPIRATION_STRING  VARCHAR2(256));

--
-- 445. ENTERPRISE_SLOTS  (Column) 
--
ALTER TABLE RHNSATELLITEINFO ADD (ENTERPRISE_SLOTS  NUMBER);

--
-- 446. CREATED  (Column) 
--
ALTER TABLE RHNSATELLITEINFO ADD (CREATED  DATE                                 DEFAULT (sysdate));

--
-- 447. MODIFIED  (Column) 
--
ALTER TABLE RHNSATELLITEINFO ADD (MODIFIED  DATE                                DEFAULT (sysdate));

--
-- 448. RHN_APR_FAILURE_AID_SID_IDX  (Index) 
--
CREATE INDEX RHN_APR_FAILURE_AID_SID_IDX ON RHNACTIONPACKAGEREMOVALFAILURE
(ACTION_ID, SERVER_ID)
LOGGING
NOPARALLEL;

--
-- 449. RHN_AT_AID_FTID_TTID_UQ  (Index) 
--
CREATE UNIQUE INDEX RHN_AT_AID_FTID_TTID_UQ ON RHNACTIONTRANSACTIONS
(ACTION_ID, FROM_TRANS_ID, TO_TRANS_ID)
LOGGING
NOPARALLEL;

--
-- 450. RHN_CFL_CONSENT_CF_S_UQ  (Index) 
--
CREATE UNIQUE INDEX RHN_CFL_CONSENT_CF_S_UQ ON RHNCHANNELFAMILYLICENSECONSENT
(CHANNEL_FAMILY_ID, SERVER_ID)
LOGGING
NOPARALLEL;

--
-- 451. RHN_CFL_CONSENT_UID_IDX  (Index) 
--
CREATE INDEX RHN_CFL_CONSENT_UID_IDX ON RHNCHANNELFAMILYLICENSECONSENT
(USER_ID)
NOLOGGING
NOPARALLEL;

--
-- 452. RHN_MONITOR_BID_IDX  (Index) 
--
CREATE INDEX RHN_MONITOR_BID_IDX ON RHNMONITOR
(BATCH_ID)
LOGGING
NOPARALLEL;

--
-- 453. RHN_MONITOR_IDX  (Index) 
--
CREATE UNIQUE INDEX RHN_MONITOR_IDX ON RHNMONITOR
(SERVER_ID, PROBE_ID, GRANULARITY, TIMESTAMP, COMPONENT, 
FIELD)
LOGGING
NOPARALLEL;

--
-- 454. RHN_SATELLITE_INFO_SID_IDX  (Index) 
--
CREATE INDEX RHN_SATELLITE_INFO_SID_IDX ON RHNSATELLITEINFO
(SERVER_ID)
LOGGING
NOPARALLEL;

--
-- 455. RHN_SAT_CF_CFID_SID_IDX  (Index) 
--
CREATE INDEX RHN_SAT_CF_CFID_SID_IDX ON RHNSATELLITECHANNELFAMILY
(CHANNEL_FAMILY_ID, SERVER_ID)
LOGGING
NOPARALLEL;

--
-- 456. RHN_SAT_CF_SID_CFID_IDX  (Index) 
--
CREATE INDEX RHN_SAT_CF_SID_CFID_IDX ON RHNSATELLITECHANNELFAMILY
(SERVER_ID, CHANNEL_FAMILY_ID)
LOGGING
NOPARALLEL;

--
-- 457. RHN_ORG  (Package Body) 
--
CREATE OR REPLACE PACKAGE BODY rhn_org
IS
    FUNCTION find_server_group_by_type(org_id_in NUMBER, group_label_in VARCHAR2)
    RETURN NUMBER
    IS
	server_group       server_group_by_label%ROWTYPE;
    BEGIN
    	OPEN server_group_by_label(org_id_in, group_label_in);
	FETCH server_group_by_label INTO server_group;
	CLOSE server_group_by_label;
	RETURN server_group.id;
    END find_server_group_by_type;
    PROCEDURE update_errata_cache(org_id_in NUMBER, threshold_in NUMBER)
    IS
    	records_present NUMBER;
    BEGIN
    	SELECT NVL(SUM(server_count), 0) INTO records_present
	  FROM rhnOrgErrataCacheQueue
	 WHERE org_id = org_id_in
	   AND processed = 0;
	IF records_present < 1 OR records_present > threshold_in
	THEN
	    RETURN;
	END IF;
    	DELETE FROM rhnOrgErrataCacheQueue WHERE org_id = org_id_in;
	DELETE FROM rhnServerNeededPackageCache
	      WHERE server_id IN (SELECT id
	      	    	    	    FROM rhnServer
				   WHERE org_id = org_id_in);
        INSERT INTO rhnServerNeededPackageCache
        SELECT *
	  FROM rhnServerNeededPackageView
	 WHERE server_id IN (SELECT id
	    	    	       FROM rhnServer
			      WHERE org_id = org_id_in);
    END update_errata_cache;
	procedure delete_user(user_id_in in number) is
		cursor is_admin is
			select	1
			from	rhnUserGroupType	ugt,
					rhnUserGroup		ug,
					rhnUserGroupMembers	ugm
			where	ugm.user_id = user_id_in
				and ugm.user_group_id = ug.id
				and ug.group_type = ugt.id
				and ugt.label = 'org_admin';
		cursor servergroups_needing_admins is
			select	usgp.server_group_id	server_group_id
			from	rhnUserServerGroupPerms	usgp
			where	1=1
				and usgp.user_id = user_id_in
				and not exists (
					select	1
					from	rhnUserServerGroupPerms	sq_usgp
					where	1=1
						and sq_usgp.server_group_id = usgp.server_group_id
						and	sq_usgp.user_id != user_id_in
				);
		cursor messages is
			select	message_id id
			from	rhnUserMessage
			where	user_id = user_id_in;
		users			number;
		our_org_id		number;
		del_check_ok	number;
		other_users		number;
		other_org_admin	number;
	begin
		select	wc.org_id, xxrh_contact_del_check_num(user_id_in)
		into	our_org_id, del_check_ok
		from	web_contact wc
		where	id = user_id_in;
		if del_check_ok != 1 then
			rhn_exception.raise_exception('cannot_delete_user');
			return;
		end if;
		begin
			select	1
			into	other_users
			from	web_contact
			where	1=1
				and org_id = our_org_id
				and id != user_id_in
				and rownum = 1;
		exception
			when no_data_found then
				other_users := 0;
		end;
		if other_users != 0 then
			for ignore in is_admin loop
				begin
					select	new_ugm.user_id
					into	other_org_admin
					from	rhnUserGroupMembers	new_ugm,
							rhnUserGroupType	ugt,
							rhnUserGroup		ug,
							rhnUserGroupMembers	ugm
					where	ugm.user_id = user_id_in
						and ugm.user_group_id = ug.id
						and ug.group_type = ugt.id
						and ugt.label = 'org_admin'
						and ug.id = new_ugm.user_group_id
						and new_ugm.user_id != user_id_in
						and rownum = 1;
				exception
					when no_data_found then
						rhn_exception.raise_exception('cannot_delete_user');
				end;
				for sg in servergroups_needing_admins loop
					insert into rhnUserServerGroupPerms
						( user_id , server_group_id )
						values ( other_org_admin, sg.server_group_id );
				end loop;
			end loop;
		end if;
		for message in messages loop
			delete
				from	rhnUserMessage
				where	user_id = user_id_in
					and message_id = message.id;
			begin
				select	1
				into	users
				from	rhnUserMessage
				where	message_id = message.id
					and rownum = 1;
				delete
					from	rhnMessage
					where	id = message.id;
			exception
				when no_data_found then
					null;
			end;
		end loop;
		if other_users != 0 then
			update		rhnRegToken
				set		user_id = other_org_admin
				where	org_id = our_org_id
					and user_id = user_id_in;
			delete from web_contact where id = user_id_in;
		else
			delete from web_contact where id = user_id_in;
			delete from rhnServerGroupMembers
				where server_group_id in (
					select id from rhnServerGroup where org_id = our_org_id
				);
			update rhnServerGroup set group_type = null
				where org_id = our_org_id;
			delete from web_customer where id = our_org_id;
		end if;
		return;
	end delete_user;
END rhn_org;
/


--
-- 458. RHNSERVERGROUPOVERVIEWLITE  (View) 
--
CREATE OR REPLACE FORCE VIEW RHNSERVERGROUPOVERVIEWLITE
(ORG_ID, SECURITY_ERRATA, BUG_ERRATA, ENHANCEMENT_ERRATA, GROUP_ID, 
 GROUP_NAME, GROUP_ADMINS, SERVER_COUNT, NOTE_COUNT, MODIFIED, 
 MAX_MEMBERS)
AS 
select	sg.org_id					org_id,
		case when exists (
			select	1
			from	rhnServerGroupOVLiteHelper
			where	server_group_id = sg.id
				and advisory_type = 'Security Advisory'
			)
			then 1
			else 0
			end						security_errata,
		case when exists (
			select	1
			from	rhnServerGroupOVLiteHelper
			where	server_group_id = sg.id
				and advisory_type = 'Bug Fix Advisory'
			)
			then 1
			else 0
			end						bug_errata,
		case when exists (
			select	1
			from	rhnServerGroupOVLiteHelper
			where	server_group_id = sg.id
				and advisory_type = 'Product Enhancement Advisory'
			)
			then 1
			else 0
			end						enhancement_errata,
		sg.id						group_id,
		sg.name						group_name,
		(	select	count(*)
			from	rhnUserManagedServerGroups	umsg
			where	umsg.server_group_id = sg.id
		)							group_admins,
		(	select	count(*)
			from	rhnServerGroupMembers		sgm
			where	sgm.server_group_id = sg.id
		)							server_count,
		0							note_count,
		sysdate						modified,
		max_members					max_members
from	rhnServerGroup				sg;

--
-- 459. RHN_CFL_CONSENT_MOD_TRIG  (Trigger) 
--
CREATE OR REPLACE TRIGGER RHN_CFL_CONSENT_MOD_TRIG
BEFORE INSERT OR UPDATE ON RHNCHANNELFAMILYLICENSECONSENT
FOR EACH ROW
begin
        :new.modified := sysdate;
end;
/


--
-- 460. RHN_SATELLITE_INFO_MOD_TRIG  (Trigger) 
--
CREATE OR REPLACE TRIGGER RHN_SATELLITE_INFO_MOD_TRIG
BEFORE INSERT OR UPDATE ON RHNSATELLITEINFO
FOR EACH ROW
begin
    :new.modified := sysdate;
end;
/


--
-- 461. RHN_SAT_CF_MOD_TRIG  (Trigger) 
--
CREATE OR REPLACE TRIGGER RHN_SAT_CF_MOD_TRIG
BEFORE INSERT OR UPDATE ON RHNSATELLITECHANNELFAMILY
FOR EACH ROW
begin
    :new.modified := sysdate;
end;
/


--
-- 462. RHN_CHANNEL  (Package Body) 
--
CREATE OR REPLACE PACKAGE BODY rhn_channel
IS
    FUNCTION get_license_path(channel_id_in IN NUMBER)
    RETURN VARCHAR2
    IS
    	license_val VARCHAR2(1000);
    BEGIN
    	SELECT CFL.license_path INTO license_val
	  FROM rhnChannelFamilyLicense CFL, rhnChannelFamilyMembers CFM
	 WHERE CFM.channel_id = channel_id_in
	   AND CFM.channel_family_id = CFL.channel_family_id;
    	RETURN license_val;
    EXCEPTION
    	WHEN NO_DATA_FOUND
	    THEN
	    RETURN NULL;
    END get_license_path;
    PROCEDURE license_consent(channel_id_in IN NUMBER, user_id_in IN NUMBER, server_id_in IN NUMBER)
    IS
    	channel_family_id_val NUMBER;
    BEGIN
    	channel_family_id_val := rhn_channel.family_for_channel(channel_id_in);
	IF channel_family_id_val IS NULL
	THEN
	    rhn_exception.raise_exception('channel_subscribe_no_family');
	END IF;
	IF rhn_channel.get_license_path(channel_id_in) IS NULL
	THEN
	    rhn_exception.raise_exception('channel_consent_no_license');
	END IF;
	INSERT INTO rhnChannelFamilyLicenseConsent (channel_family_id, user_id, server_id)
	VALUES (channel_family_id_val, user_id_in, server_id_in);
    END license_consent;
    PROCEDURE subscribe_server(server_id_in IN NUMBER, channel_id_in NUMBER, immediate_in NUMBER := 1)
    IS
        channel_parent_val      rhnChannel.parent_channel%TYPE;
        parent_subscribed       BOOLEAN;
        server_has_base_chan    BOOLEAN;
	server_already_in_chan  BOOLEAN;
	channel_family_id_val   NUMBER;
	server_org_id_val       NUMBER;
	available_subscriptions NUMBER;
	consenting_user         NUMBER;
    BEGIN
        SELECT parent_channel INTO channel_parent_val FROM rhnChannel WHERE id = channel_id_in;
        IF channel_parent_val IS NOT NULL
        THEN
            parent_subscribed := FALSE;
            FOR check_subscription IN check_server_subscription(server_id_in, channel_parent_val)
            LOOP
                parent_subscribed := TRUE;
            END LOOP check_subscription;
            IF NOT parent_subscribed
            THEN
    	    	RETURN;
            END IF;
        ELSE
            server_has_base_chan := FALSE;
            FOR base IN server_base_subscriptions(server_id_in)
            LOOP
                server_has_base_chan := TRUE;
            END LOOP base;
            IF server_has_base_chan
            THEN
                rhn_exception.raise_exception('channel_server_one_base');
            END IF;
        END IF;
        FOR check_subscription IN check_server_subscription(server_id_in, channel_id_in)
        LOOP
            server_already_in_chan := TRUE;
        END LOOP check_subscription;
        IF server_already_in_chan
        THEN
    	    RETURN;
        END IF;
	channel_family_id_val := rhn_channel.family_for_channel(channel_id_in);
	IF channel_family_id_val IS NULL
	THEN
	    rhn_exception.raise_exception('channel_subscribe_no_family');
	END IF;
	SELECT org_id INTO server_org_id_val
	  FROM rhnServer
	 WHERE id = server_id_in;
	available_subscriptions := rhn_channel.available_family_subscriptions(channel_family_id_val, server_org_id_val);
	IF available_subscriptions IS NULL OR available_subscriptions > 0
	THEN
	    IF rhn_channel.get_license_path(channel_id_in) IS NOT NULL
	    THEN
	    	BEGIN
	    	SELECT user_id INTO consenting_user
		  FROM rhnChannelFamilyLicenseConsent
		 WHERE channel_family_id = channel_family_id_val
		   AND server_id = server_id_in;
		EXCEPTION
    	    	    WHEN NO_DATA_FOUND
		    	THEN
			    rhn_exception.raise_exception('channel_subscribe_no_consent');
		END;
	    END IF;
            INSERT INTO rhnServerChannel (server_id, channel_id) VALUES (server_id_in, channel_id_in);
    	    rhn_channel.update_family_counts(channel_family_id_val, server_org_id_val);
    	    queue_server(server_id_in, immediate_in);
	ELSE
	    rhn_exception.raise_exception('channel_family_no_subscriptions');
	END IF;
    END subscribe_server;
    PROCEDURE bulk_subscribe_server(channel_id_in IN NUMBER, set_label_in IN VARCHAR2, set_uid_in IN NUMBER)
    IS
    BEGIN
        FOR server IN rhn_set.set_iterator(set_label_in, set_uid_in)
        LOOP
            rhn_channel.subscribe_server(server.element, channel_id_in, 0);
        END LOOP server;
    END bulk_subscribe_server;
    PROCEDURE bulk_server_base_change(channel_id_in IN NUMBER, set_label_in IN VARCHAR2, set_uid_in IN NUMBER)
    IS
		cursor is_changeable(server_id_in in number) is
			select	server_id_in id
			from	dual
			where	not exists (select 1 from rhnSatelliteInfo where server_id = server_id_in)
				and not exists (select 1 from rhnProxyInfo where server_id = server_id_in);
    BEGIN
        FOR server IN rhn_set.set_iterator(set_label_in, set_uid_in)
        LOOP
			for s in is_changeable(server.element) loop
            	rhn_channel.clear_subscriptions(TO_NUMBER(s.id));
            	rhn_channel.subscribe_server(s.id, channel_id_in, 0);
			end loop;
        END LOOP server;
    END bulk_server_base_change;
    procedure bulk_server_basechange_from(
	set_label_in in varchar2,
	set_uid_in in number,
	old_channel_id_in in number,
	new_channel_id_in in number
    ) is
	cursor channels(server_id_in in number) is
	    select	rsc.channel_id
	    from	rhnServerChannel rsc,
			rhnChannel rc
	    where	server_id_in = rsc.server_id
			and rsc.channel_id = rc.id
			and rc.parent_channel is null;
    begin
	for server in rhn_set.set_iterator(set_label_in, set_uid_in)
	loop
	    for channel in channels(server.element)
	    loop
		if channel.channel_id = old_channel_id_in
		then
		    insert into rhnSet (user_id, label, element) values (set_uid_in, set_label_in || 'basechange', server.element);
		end if;
	    end loop channel;
	end loop server;
	bulk_server_base_change(new_channel_id_in, set_label_in||'basechange',set_uid_in);
	delete from rhnSet where label = set_label_in||'basechange' and user_id = set_uid_in;
    end;
    procedure bulk_guess_server_base(
	set_label_in in varchar2,
	set_uid_in in number
    ) is
	channel_id number;
    begin
	for server in rhn_set.set_iterator(set_label_in, set_uid_in)
	loop
    	    channel_id := guess_server_base(TO_NUMBER(server.element));
	    rhn_channel.clear_subscriptions(TO_NUMBER(server.element));
	    rhn_channel.subscribe_server(TO_NUMBER(server.element), channel_id, 0);
	end loop server;
    end;
    function guess_server_base(
    	server_id_in in number
    ) RETURN number is
    	channel number;
    begin
    	select	id
	into	channel
	from (
		select	rc.id
		from
			rhnChannelPermissions rcp,
			rhnChannel rc,
			rhnServerChannelArchCompat scac,
			rhnDistChannelMap rdcm,
			rhnServer rs
		where	rs.id = server_id_in
			and rdcm.os IN (rs.os, 'Red Hat Linux Advanced Server', 'Red Hat Advanced Server')
			and rs.release = rdcm.release
			and rdcm.channel_id = rc.id
			and rs.server_arch_id = scac.server_arch_id
			and scac.channel_arch_id = rdcm.channel_arch_id
			and rdcm.channel_id = rcp.channel_id
			and (rcp.org_id is null or
				rcp.org_id = rs.org_id)
			and rdcm.channel_id = rc.id
			and rc.parent_channel is null
		order by rc.parent_channel
	) where rownum = 1;
	return channel;
    exception
	when no_data_found
	then
	    null;
    end;
    procedure bulk_guess_server_base_from(
	set_label_in in varchar2,
	set_uid_in in number,
	channel_id_in in number
    ) is
	cursor channels(server_id_in in number) is
	    select	rsc.channel_id
	    from	rhnServerChannel rsc,
			rhnChannel rc
	    where	server_id_in = rsc.server_id
			and rsc.channel_id = rc.id
			and rc.parent_channel is null;
    begin
	for server in rhn_set.set_iterator(set_label_in, set_uid_in)
	loop
	    for channel in channels(server.element)
	    loop
		if channel.channel_id = channel_id_in
		then
		    insert into rhnSet (user_id, label, element) values (set_uid_in, set_label_in || 'baseguess', server.element);
		end if;
	    end loop channel;
	end loop server;
	bulk_guess_server_base(set_label_in||'baseguess',set_uid_in);
	delete from rhnSet where label = set_label_in||'baseguess' and user_id = set_uid_in;
    end;
    PROCEDURE clear_subscriptions(server_id_in IN NUMBER)
    IS
    	cursor server_channels(server_id_in in number) is
		select	s.org_id, sc.channel_id, cfm.channel_family_id
		from	rhnServer s,
			rhnServerChannel sc,
			rhnChannelFamilyMembers cfm
		where	s.id = server_id_in
			and s.id = sc.server_id
			and sc.channel_id = cfm.channel_id;
    BEGIN
    	for channel in server_channels(server_id_in)
	loop
		delete from rhnServerChannel where server_id = server_id_in and channel_id = channel.channel_id;
		rhn_channel.update_family_counts(channel.channel_family_id, channel.org_id);
	end loop channel;
    END clear_subscriptions;
    PROCEDURE unsubscribe_server(server_id_in IN NUMBER, channel_id_in NUMBER, immediate_in NUMBER := 1, unsubscribe_children_in number := 0)
    IS
	channel_family_id_val   NUMBER;
	server_org_id_val       NUMBER;
	available_subscriptions NUMBER;
	server_already_in_chan  BOOLEAN;
    BEGIN
        FOR child IN check_server_parent_membership(server_id_in, channel_id_in)
        LOOP
	    if unsubscribe_children_in = 1 then
	    	unsubscribe_server(server_id_in => server_id_in,
								channel_id_in => child.id,
								immediate_in => immediate_in,
								unsubscribe_children_in => unsubscribe_children_in);
	    else
	    	rhn_exception.raise_exception('channel_unsubscribe_child_exists');
	    end if;
        END LOOP child;
	server_already_in_chan := FALSE;
        FOR check_subscription IN check_server_subscription(server_id_in, channel_id_in)
        LOOP
            server_already_in_chan := TRUE;
        END LOOP check_subscription;
        IF NOT server_already_in_chan
        THEN
    	    RETURN;
        END IF;
        DELETE FROM rhnServerChannel WHERE server_id = server_id_in AND channel_id = channel_id_in;
    	queue_server(server_id_in, immediate_in);
	channel_family_id_val := rhn_channel.family_for_channel(channel_id_in);
	IF channel_family_id_val IS NULL
	THEN
	    rhn_exception.raise_exception('channel_unsubscribe_no_family');
	END IF;
	DELETE FROM rhnChannelFamilyLicenseConsent
	 WHERE channel_family_id = channel_family_id_val
	   AND server_id = server_id_in;
	SELECT org_id INTO server_org_id_val
	  FROM rhnServer
	 WHERE id = server_id_in;
	rhn_channel.update_family_counts(channel_family_id_val, server_org_id_val);
    END unsubscribe_server;
    PROCEDURE bulk_unsubscribe_server(channel_id_in IN NUMBER, set_label_in IN VARCHAR2, set_uid_in IN NUMBER)
    IS
    BEGIN
        FOR server IN rhn_set.set_iterator(set_label_in, set_uid_in)
        LOOP
            rhn_channel.unsubscribe_server(server.element, channel_id_in, 0);
        END LOOP server;
    END bulk_unsubscribe_server;
    FUNCTION subscription_count(channel_id_in NUMBER)
    RETURN VARCHAR2
    IS
    	sub_count_val NUMBER;
	null_org    NUMBER;
    BEGIN
        SELECT COUNT(*) INTO sub_count_val FROM rhnChannelPermissions WHERE channel_id = channel_id_in;
	IF sub_count_val = 1
	THEN
	    SELECT org_id INTO null_org FROM rhnChannelPermissions WHERE channel_id = channel_id_in AND org_id IS NULL;
	    IF null_org IS NULL
	    THEN
	    	RETURN '(public)';
	    END IF;
	END IF;
	RETURN sub_count_val;
    EXCEPTION
        WHEN NO_DATA_FOUND
	THEN
	    RETURN 1;
    END subscription_count;
    FUNCTION family_for_channel(channel_id_in IN NUMBER)
    RETURN NUMBER
    IS
    	channel_family_id_val NUMBER;
    BEGIN
    	SELECT channel_family_id INTO channel_family_id_val
	  FROM rhnChannelFamilyMembers
         WHERE channel_id = channel_id_in;
	RETURN channel_family_id_val;
    EXCEPTION
        WHEN NO_DATA_FOUND
	THEN
	    RETURN NULL;
    END family_for_channel;
    FUNCTION available_family_subscriptions(channel_family_id_in IN NUMBER, org_id_in IN NUMBER)
    RETURN NUMBER
    IS
    	cfp channel_family_perm_cursor%ROWTYPE;
    	current_members_val NUMBER;
	max_members_val     NUMBER;
	found               NUMBER;
    BEGIN
	IF NOT channel_family_perm_cursor%ISOPEN
	THEN
	    OPEN channel_family_perm_cursor(channel_family_id_in, org_id_in);
	END IF;
	FETCH channel_family_perm_cursor INTO cfp;
	WHILE channel_family_perm_cursor%FOUND
    	LOOP
	    found := 1;
	    current_members_val := cfp.current_members;
	    max_members_val := cfp.max_members;
	    FETCH channel_family_perm_cursor INTO cfp;
	END LOOP;
	IF channel_family_perm_cursor%ISOPEN
	THEN
	    CLOSE channel_family_perm_cursor;
	END IF;
	IF found IS NULL
	THEN
	    RETURN 0;
	END IF;
	IF max_members_val IS NULL
	THEN
	    RETURN NULL;
	END IF;
	RETURN max_members_val - current_members_val;
    END available_family_subscriptions;
    PROCEDURE update_family_counts(channel_family_id_in IN NUMBER, org_id_in IN NUMBER)
    IS
    BEGIN
    	UPDATE rhnChannelFamilyPermissions
	   SET current_members = (SELECT COUNT(server_id)
	                            FROM rhnServerChannel
				   WHERE channel_id IN (SELECT channel_id FROM rhnChannelFamilyMembers
				                         WHERE channel_family_id = channel_family_id_in)
				     AND server_id IN (SELECT id FROM rhnServer WHERE org_id = org_id_in))
	 WHERE channel_family_id = channel_family_id_in
	   AND org_id = org_id_in;
    END update_family_counts;
    FUNCTION available_chan_subscriptions(channel_id_in IN NUMBER, org_id_in IN NUMBER)
    RETURN NUMBER
    IS
	channel_family_id_val NUMBER;
    BEGIN
    	SELECT channel_family_id INTO channel_family_id_val
	  FROM rhnChannelFamilyMembers
	 WHERE channel_id = channel_id_in;
	 RETURN rhn_channel.available_family_subscriptions(channel_family_id_val, org_id_in);
    END available_chan_subscriptions;
    procedure entitle_customer(customer_id_in in number, channel_family_id_in in number, quantity_in in number)
    is
		cursor permissions is
			select	1
			from	rhnChannelFamilyPermissions rcfp
			where	rcfp.org_id = customer_id_in
				and	rcfp.channel_family_id = channel_family_id_in;
    begin
		for perm in permissions loop
			set_family_maxmembers(
				customer_id_in,
				channel_family_id_in,
				quantity_in
			);
			rhn_channel.update_family_counts(
				channel_family_id_in,
				customer_id_in
			);
			return;
		end loop;
		insert
        into    rhnChannelFamilyPermissions
               (channel_family_id, org_id, max_members, current_members)
        values  (channel_family_id_in, customer_id_in, quantity_in, 0);
    end;
    procedure set_family_maxmembers(customer_id_in in number, channel_family_id_in in number, quantity_in in number)
    is
	cursor servers is
	    select  server_id from (
		select	rownum row_number, server_id, modified from (
		    select  rcfs.server_id,
			    rcfs.modified
		    from    rhnChannelFamilyServers rcfs
		    where   rcfs.customer_id = customer_id_in
			    and rcfs.channel_family_id = channel_family_id_in
		    order by modified
		)
		where rownum > quantity_in
	    );
    begin
	for server in servers
	loop
	    rhn_channel.unsubscribe_server_from_family(server.server_id, channel_family_id_in);
	end loop;
	update	rhnChannelFamilyPermissions rcfp
	set	rcfp.max_members = quantity_in
	where	rcfp.channel_family_id = channel_family_id_in
		and rcfp.org_id = customer_id_in;
    end;
    procedure unsubscribe_server_from_family(server_id_in in number, channel_family_id_in in number)
    is
    begin
	delete
	from	rhnServerChannel rsc
	where	rsc.server_id = server_id_in
		and channel_id in (
			select	rcfm.channel_id
			from	rhnChannelFamilyMembers rcfm
			where	rcfm.channel_family_id = channel_family_id_in);
    end;
    procedure delete_server_channels(server_id_in in number)
    is
    begin
	update	rhnChannelFamilyPermissions
	set	current_members = current_members -1
	where	org_id in (
			select	org_id
			from	rhnServer
			where	id = server_id_in
		)
		and channel_family_id in (
			select	rcfm.channel_family_id
			from	rhnChannelFamilyMembers rcfm,
				rhnServerChannel rsc
			where	rsc.server_id = server_id_in
				and rsc.channel_id = rcfm.channel_id
		);
    end;
	procedure refresh_newest_package(channel_id_in in number, caller_in in varchar2 := '(unknown)')
	is
	begin
		delete from rhnChannelNewestPackage where channel_id = channel_id_in;
		insert into rhnChannelNewestPackage
			( channel_id, name_id, evr_id, package_id, package_arch_id )
			(	select	channel_id,
						name_id, evr_id,
						package_id, package_arch_id
				from	rhnChannelNewestPackageView
				where	channel_id = channel_id_in
			);
                insert into rhnChannelNewestPackageAudit (channel_id, caller)
                    values (channel_id_in, caller_in);
                update rhnChannel
                    set last_modified = greatest(sysdate, last_modified + 1/86400)
                    where id = channel_id_in;
	end;
END rhn_channel;
/

-- before anything references rhn_entitlements, we want this.
create or replace
package rhn_entitlements
is
	function lookup_entitlement_group (
		org_id_in in number,
		type_label_in in varchar2 := 'sw_mgr_entitled'
	) return number;

	function create_entitlement_group (
		org_id_in in number,
		type_label_in in varchar2 := 'sw_mgr_entitled'
	) return number;

	procedure entitle_server (
		server_id_in in number,
		type_label_in in varchar2 := 'sw_mgr_entitled'
	);

	procedure unentitle_server (
		server_id_in in number,
		type_label_in in varchar2 := 'sw_mgr_entitled'
	);

	function get_server_entitlement (
		server_id_in in number
	) return varchar2;

    procedure set_customer_enterprise (
		customer_id in number
	);

    procedure unset_customer_enterprise (
		customer_id in number
	);

    procedure set_group_count (
		customer_id_in in number,	-- customer_id
		type_in in char,			-- 'U' or 'S'
		group_type_in in number,	-- rhn[User|Server]GroupType.id
		quantity_in in number		-- quantity
    );

    procedure set_family_count (
		customer_id_in in number,		-- customer_id
		channel_family_id_in in number,	-- 246
		quantity_in in number			-- 3
    );

    -- this makes NO checks that the quantity is within max,
    -- so we should NEVER run this unless we KNOW that we won't be
    -- violating the max
    procedure entitle_last_modified_servers (
		customer_id_in in number,	-- customer_id
		type_label_in in varchar2,	-- 'enterprise_entitled'
		quantity_in in number		-- 3
    );

	procedure prune_everything (
		customer_id_in in number
	);
end rhn_entitlements;
/
show errors

--
-- 463. RHNSERVEROVERVIEW  (View) 
--
CREATE OR REPLACE FORCE VIEW RHNSERVEROVERVIEW
(ORG_ID, SERVER_ID, SERVER_NAME, NOTE_COUNT, MODIFIED, 
 SERVER_ADMINS, GROUP_COUNT, CHANNEL_LABELS, HISTORY_COUNT, SECURITY_ERRATA, 
 BUG_ERRATA, ENHANCEMENT_ERRATA, OUTDATED_PACKAGES, ENTITLEMENT_LEVEL, LAST_CHECKIN_DAYS_AGO, 
 LAST_CHECKIN, PENDING_UPDATES, OS, RELEASE, SERVER_ARCH_NAME)
AS 
select
    s.org_id, s.id, s.name, 0, s.modified,
    ( select count(user_id) from rhnUserServerPerms ap
      where server_id = s.id ),
    ( select count(server_group_id) from rhnVisibleServerGroupMembers
      where server_id = s.id ),
    NVL(( select C.name
        from rhnChannel C,
	     rhnServerChannel SC
       where SC.server_id = S.id
         and SC.channel_id = C.id
	 and C.parent_channel IS NULL), '(none)'),
    ( select count(id) from rhnServerHistory
      where
            server_id = S.id),
    ( select count(*) from rhnServerErrataTypeView sev
      where
            sev.server_id = s.id
        and sev.errata_type = 'Security Advisory'),
    ( select count(*) from rhnServerErrataTypeView sev
      where
            sev.server_id = s.id
        and sev.errata_type = 'Bug Fix Advisory'),
    ( select count(*) from rhnServerErrataTypeView sev
      where
            sev.server_id = s.id
        and sev.errata_type = 'Product Enhancement Advisory'),
    ( select count(distinct p.name_id) from rhnPackage p, rhnServerNeededPackageCache snpc
      where
             snpc.server_id = S.id
	 and p.id = snpc.package_id
	 ),
    rhn_entitlements.get_server_entitlement(S.id),
    ( select sysdate - checkin from rhnServerInfo where server_id = S.id ),
    ( select TO_CHAR(checkin, 'YYYY-MM-DD HH24:MI:SS') from rhnServerInfo where server_id = S.id ),
    ( select count(1)
        from rhnServerAction
       where server_id = S.id
         and status in (0, 1)),
    os,
    release,
    ( select name from rhnServerArch where id = s.server_arch_id)
from
    rhnServer S;

--
-- 471. RHNUSERACTIONOVERVIEW  (View) 
--

CREATE OR REPLACE FORCE VIEW RHNUSERACTIONOVERVIEW
(ORG_ID, USER_ID, ID, TYPE_NAME, EARLIEST_ACTION, 
 ACTION_NAME, ACTION_STATUS_ID, ACTION_STATUS, TALLY, ARCHIVED)
AS 
select	ao.org_id                                       org_id,
	uspd.user_id                                    user_id,
    	ao.action_id                                    id,
	ao.type_name                                    type_name,
	ao.earliest_action                              earliest_action,
	decode(ao.name, null, ao.type_name, ao.name)	action_name,
	sa.status					action_status_id,
	astat.name                                      action_status,
	count(sa.action_id)				tally,
	ao.archived                                     archived
from	rhnActionStatus            astat,
    	rhnUserServerPermsDupes    uspd,
	rhnServerAction            sa,
	rhnActionOverview	   ao
where	ao.action_id = sa.action_id
  and   sa.server_id = uspd.server_id
  and   sa.status = astat.id
group by ao.org_id,
	 uspd.user_id,
	 ao.action_id,
	 ao.type_name,
	 ao.earliest_action,
	 decode(ao.name, null, ao.type_name, ao.name),
	 sa.status,
	 astat.name,
	 ao.archived
order by earliest_action;

--
-- 464. RHN_CHANNEL_CAID_NN  (Constraint) 
--
ALTER TABLE RHNCHANNEL ADD CONSTRAINT RHN_CHANNEL_CAID_NN CHECK ("CHANNEL_ARCH_ID" IS NOT NULL);

--
-- 465. RHN_CHANNEL_CAID_FK  (Constraint) 
--
ALTER TABLE RHNCHANNEL ADD CONSTRAINT RHN_CHANNEL_CAID_FK FOREIGN KEY (CHANNEL_ARCH_ID) 
    REFERENCES RHNCHANNELARCH (ID);

--
-- 466. RHN_CHANNEL_FAMILY_ORG_FK  (Constraint) 
--
ALTER TABLE RHNCHANNELFAMILY DROP CONSTRAINT RHN_CHANNEL_FAMILY_ORG_FK;
ALTER TABLE RHNCHANNELFAMILY ADD CONSTRAINT RHN_CHANNEL_FAMILY_ORG_FK FOREIGN KEY (ORG_ID) 
    REFERENCES WEB_CUSTOMER (ID)
    ON DELETE CASCADE;

--
-- 467. RHN_CFPERM_OID_FK  (Constraint) 
--
ALTER TABLE RHNCHANNELFAMILYPERMISSIONS DROP CONSTRAINT RHN_CFPERM_OID_FK;
ALTER TABLE RHNCHANNELFAMILYPERMISSIONS ADD CONSTRAINT RHN_CFPERM_OID_FK FOREIGN KEY (ORG_ID) 
    REFERENCES WEB_CUSTOMER (ID)
    ON DELETE CASCADE;

--
-- 468. RHN_DCM_CAID_NN  (Constraint) 
--
ALTER TABLE RHNDISTCHANNELMAP ADD CONSTRAINT RHN_DCM_CAID_NN CHECK ("CHANNEL_ARCH_ID" IS NOT NULL);

--
-- 469. RHN_DCM_OS_RELEASE_CAID_UQ  (Constraint) 
--
ALTER TABLE RHNDISTCHANNELMAP ADD CONSTRAINT RHN_DCM_OS_RELEASE_CAID_UQ UNIQUE (OS, RELEASE, CHANNEL_ARCH_ID);

--
-- 470. RHN_DCM_CAID_FK  (Constraint) 
--
ALTER TABLE RHNDISTCHANNELMAP ADD CONSTRAINT RHN_DCM_CAID_FK FOREIGN KEY (CHANNEL_ARCH_ID) 
    REFERENCES RHNCHANNELARCH (ID);

--
-- 471. RHN_ERRATA_OID_FK  (Constraint) 
--
ALTER TABLE RHNERRATA DROP CONSTRAINT RHN_ERRATA_OID_FK;
ALTER TABLE RHNERRATA ADD CONSTRAINT RHN_ERRATA_OID_FK FOREIGN KEY (ORG_ID) 
    REFERENCES WEB_CUSTOMER (ID)
    ON DELETE CASCADE;

--
-- 472. RHN_ERRATATMP_OID_FK  (Constraint) 
--
ALTER TABLE RHNERRATATMP DROP CONSTRAINT RHN_ERRATATMP_OID_FK;
ALTER TABLE RHNERRATATMP ADD CONSTRAINT RHN_ERRATATMP_OID_FK FOREIGN KEY (ORG_ID) 
    REFERENCES WEB_CUSTOMER (ID)
    ON DELETE CASCADE;

--
-- 473. RHN_FILE_OID_FK  (Constraint) 
--
ALTER TABLE RHNFILE DROP CONSTRAINT RHN_FILE_OID_FK;
ALTER TABLE RHNFILE ADD CONSTRAINT RHN_FILE_OID_FK FOREIGN KEY (ORG_ID) 
    REFERENCES WEB_CUSTOMER (ID)
    ON DELETE CASCADE;

--
-- 474. RHN_ORG_ENT_FK  (Constraint) 
--
ALTER TABLE RHNORGENTITLEMENTS DROP CONSTRAINT RHN_ORG_ENT_FK;
ALTER TABLE RHNORGENTITLEMENTS ADD CONSTRAINT RHN_ORG_ENT_FK FOREIGN KEY (ORG_ID) 
    REFERENCES WEB_CUSTOMER (ID)
    ON DELETE CASCADE;

--
-- 475. RHN_PACKAGE_LM_NN  (Constraint) 
--
ALTER TABLE RHNPACKAGE ADD CONSTRAINT RHN_PACKAGE_LM_NN CHECK ("LAST_MODIFIED" IS NOT NULL);

--
-- 476. RHN_PACKAGE_PAID_NN  (Constraint) 
--
ALTER TABLE RHNPACKAGE ADD CONSTRAINT RHN_PACKAGE_PAID_NN CHECK ("PACKAGE_ARCH_ID" IS NOT NULL);

--
-- 477. RHN_PACKAGE_OID_FK  (Constraint) 
--
ALTER TABLE RHNPACKAGE DROP CONSTRAINT RHN_PACKAGE_OID_FK;
ALTER TABLE RHNPACKAGE ADD CONSTRAINT RHN_PACKAGE_OID_FK FOREIGN KEY (ORG_ID) 
    REFERENCES WEB_CUSTOMER (ID)
    ON DELETE CASCADE;

--
-- 478. RHN_PACKAGE_PAID_FK  (Constraint) 
--
ALTER TABLE RHNPACKAGE ADD CONSTRAINT RHN_PACKAGE_PAID_FK FOREIGN KEY (PACKAGE_ARCH_ID) 
    REFERENCES RHNPACKAGEARCH (ID);

--
-- 479. RHN_PKGSRC_LM_NN  (Constraint) 
--
ALTER TABLE RHNPACKAGESOURCE ADD CONSTRAINT RHN_PKGSRC_LM_NN CHECK ("LAST_MODIFIED" IS NOT NULL);

--
-- 480. RHN_PKGSRC_OID_FK  (Constraint) 
--
ALTER TABLE RHNPACKAGESOURCE DROP CONSTRAINT RHN_PKGSRC_OID_FK;
ALTER TABLE RHNPACKAGESOURCE ADD CONSTRAINT RHN_PKGSRC_OID_FK FOREIGN KEY (ORG_ID) 
    REFERENCES WEB_CUSTOMER (ID)
    ON DELETE CASCADE;

--
-- 481. RHN_SERVERGROUP_OID_FK  (Constraint) 
--
ALTER TABLE RHNSERVERGROUP DROP CONSTRAINT RHN_SERVERGROUP_OID_FK;
ALTER TABLE RHNSERVERGROUP ADD CONSTRAINT RHN_SERVERGROUP_OID_FK FOREIGN KEY (ORG_ID) 
    REFERENCES WEB_CUSTOMER (ID)
    ON DELETE CASCADE;

--
-- 482. RHN_SERVER_PROFILE_OID_FK  (Constraint) 
--
ALTER TABLE RHNSERVERPROFILE DROP CONSTRAINT RHN_SERVER_PROFILE_OID_FK;
ALTER TABLE RHNSERVERPROFILE ADD CONSTRAINT RHN_SERVER_PROFILE_OID_FK FOREIGN KEY (ORG_ID) 
    REFERENCES WEB_CUSTOMER (ID)
    ON DELETE CASCADE;

--
-- 483. RHN_TASK_QUEUE_ORG_ID_FK  (Constraint) 
--
ALTER TABLE RHNTASKQUEUE DROP CONSTRAINT RHN_TASK_QUEUE_ORG_ID_FK;
ALTER TABLE RHNTASKQUEUE ADD CONSTRAINT RHN_TASK_QUEUE_ORG_ID_FK FOREIGN KEY (ORG_ID) 
    REFERENCES WEB_CUSTOMER (ID)
    ON DELETE CASCADE;

--
-- 484. RHN_USER_GROUP_ORG_FK  (Constraint) 
--
ALTER TABLE RHNUSERGROUP DROP CONSTRAINT RHN_USER_GROUP_ORG_FK;
ALTER TABLE RHNUSERGROUP ADD CONSTRAINT RHN_USER_GROUP_ORG_FK FOREIGN KEY (ORG_ID) 
    REFERENCES WEB_CUSTOMER (ID)
    ON DELETE CASCADE;

--
-- 485. CONTPERM_WBUSERID_FK  (Constraint) 
--
ALTER TABLE WEB_USER_CONTACT_PERMISSION ADD CONSTRAINT CONTPERM_WBUSERID_FK FOREIGN KEY (WEB_USER_ID) 
    REFERENCES WEB_CONTACT (ID)
    ON DELETE CASCADE;

--
-- 486. PERSONAL_INFO_WEB_USER_ID_FK  (Constraint) 
--
ALTER TABLE WEB_USER_PERSONAL_INFO ADD CONSTRAINT PERSONAL_INFO_WEB_USER_ID_FK FOREIGN KEY (WEB_USER_ID) 
    REFERENCES WEB_CONTACT (ID)
    ON DELETE CASCADE;

--
-- 487. WUSI_WUID_FK  (Constraint) 
--
ALTER TABLE WEB_USER_SITE_INFO DROP CONSTRAINT WUSI_WUID_FK;
ALTER TABLE WEB_USER_SITE_INFO ADD CONSTRAINT WUSI_WUID_FK FOREIGN KEY (WEB_USER_ID) 
    REFERENCES WEB_CONTACT (ID)
    ON DELETE CASCADE;

--
-- 488. PXTSESSIONS_USER  (Constraint) 
--
ALTER TABLE PXTSESSIONS DROP CONSTRAINT PXTSESSIONS_USER;
ALTER TABLE PXTSESSIONS ADD CONSTRAINT PXTSESSIONS_USER FOREIGN KEY (WEB_USER_ID) 
    REFERENCES WEB_CONTACT (ID)
    ON DELETE CASCADE;

--
-- 489. RHN_ACTION_OID_FK  (Constraint) 
--
ALTER TABLE RHNACTION DROP CONSTRAINT RHN_ACTION_OID_FK;
ALTER TABLE RHNACTION ADD CONSTRAINT RHN_ACTION_OID_FK FOREIGN KEY (ORG_ID) 
    REFERENCES WEB_CUSTOMER (ID)
    ON DELETE CASCADE;

--
-- 490. RHN_ACTION_SCHEDULER_FK  (Constraint) 
--
ALTER TABLE RHNACTION DROP CONSTRAINT RHN_ACTION_SCHEDULER_FK;
ALTER TABLE RHNACTION ADD CONSTRAINT RHN_ACTION_SCHEDULER_FK FOREIGN KEY (SCHEDULER) 
    REFERENCES WEB_CONTACT (ID)
    ON DELETE SET NULL;

--
-- 491. RHN_ACT_P_PAID_FK  (Constraint) 
--
ALTER TABLE RHNACTIONPACKAGE ADD CONSTRAINT RHN_ACT_P_PAID_FK FOREIGN KEY (PACKAGE_ARCH_ID) 
    REFERENCES RHNPACKAGEARCH (ID);

--
-- 492. RHN_GRAIL_COMP_CH_USER_FK  (Constraint) 
--
ALTER TABLE RHNGRAILCOMPONENTCHOICES DROP CONSTRAINT RHN_GRAIL_COMP_CH_USER_FK;
ALTER TABLE RHNGRAILCOMPONENTCHOICES ADD CONSTRAINT RHN_GRAIL_COMP_CH_USER_FK FOREIGN KEY (USER_ID) 
    REFERENCES WEB_CONTACT (ID)
    ON DELETE CASCADE;

--
-- 493. RHN_REG_TOKEN_EL_NN  (Constraint) 
--
ALTER TABLE RHNREGTOKEN ADD CONSTRAINT RHN_REG_TOKEN_EL_NN CHECK ("ENTITLEMENT_LEVEL" IS NOT NULL);

--
-- 494. RHN_REG_TOKEN_OID_FK  (Constraint) 
--
ALTER TABLE RHNREGTOKEN DROP CONSTRAINT RHN_REG_TOKEN_OID_FK;
ALTER TABLE RHNREGTOKEN ADD CONSTRAINT RHN_REG_TOKEN_OID_FK FOREIGN KEY (ORG_ID) 
    REFERENCES WEB_CUSTOMER (ID)
    ON DELETE CASCADE;

--
-- 495. RHN_SERVER_AUTO_DELIVER_NN  (Constraint) 
--
ALTER TABLE RHNSERVER ADD CONSTRAINT RHN_SERVER_AUTO_DELIVER_NN CHECK ("AUTO_DELIVER" IS NOT NULL);

--
-- 496. RHN_SERVER_AUTO_UPDATE_NN  (Constraint) 
--
ALTER TABLE RHNSERVER ADD CONSTRAINT RHN_SERVER_AUTO_UPDATE_NN CHECK ("AUTO_UPDATE" IS NOT NULL);

--
-- 497. RHN_SERVER_DELIVER_CK  (Constraint) 
--
ALTER TABLE RHNSERVER ADD CONSTRAINT RHN_SERVER_DELIVER_CK CHECK (auto_deliver in ('Y', 'N'));

--
-- 498. RHN_SERVER_SAID_NN  (Constraint) 
--
ALTER TABLE RHNSERVER ADD CONSTRAINT RHN_SERVER_SAID_NN CHECK ("SERVER_ARCH_ID" IS NOT NULL);

--
-- 499. RHN_SERVER_UPDATE_CK  (Constraint) 
--
ALTER TABLE RHNSERVER ADD CONSTRAINT RHN_SERVER_UPDATE_CK CHECK (auto_update in ('Y', 'N'));

--
-- 500. RHN_SERVER_CREATOR_FK  (Constraint) 
--
ALTER TABLE RHNSERVER ADD CONSTRAINT RHN_SERVER_CREATOR_FK FOREIGN KEY (CREATOR_ID) 
    REFERENCES WEB_CONTACT (ID)
    ON DELETE SET NULL;

--
-- 501. RHN_SERVER_OID_FK  (Constraint) 
--
ALTER TABLE RHNSERVER DROP CONSTRAINT RHN_SERVER_OID_FK;
ALTER TABLE RHNSERVER ADD CONSTRAINT RHN_SERVER_OID_FK FOREIGN KEY (ORG_ID) 
    REFERENCES WEB_CUSTOMER (ID)
    ON DELETE CASCADE;

--
-- 502. RHN_SERVER_SAID_FK  (Constraint) 
--
ALTER TABLE RHNSERVER ADD CONSTRAINT RHN_SERVER_SAID_FK FOREIGN KEY (SERVER_ARCH_ID) 
    REFERENCES RHNSERVERARCH (ID);

--
-- 503. RHN_SERVER_ACTION_REMAINING_NN  (Constraint) 
--
ALTER TABLE RHNSERVERACTION ADD CONSTRAINT RHN_SERVER_ACTION_REMAINING_NN CHECK ("REMAINING_TRIES" IS NOT NULL);

--
-- 504. RHN_SERVERGRP_NOTE_CREATOR_FK  (Constraint) 
--
ALTER TABLE RHNSERVERGROUPNOTES DROP CONSTRAINT RHN_SERVERGRP_NOTE_CREATOR_FK;
ALTER TABLE RHNSERVERGROUPNOTES ADD CONSTRAINT RHN_SERVERGRP_NOTE_CREATOR_FK FOREIGN KEY (CREATOR) 
    REFERENCES WEB_CONTACT (ID)
    ON DELETE SET NULL;

--
-- 505. RHN_SERVERNOTES_CREATOR_FK  (Constraint) 
--
ALTER TABLE RHNSERVERNOTES DROP CONSTRAINT RHN_SERVERNOTES_CREATOR_FK;
ALTER TABLE RHNSERVERNOTES ADD CONSTRAINT RHN_SERVERNOTES_CREATOR_FK FOREIGN KEY (CREATOR) 
    REFERENCES WEB_CONTACT (ID)
    ON DELETE SET NULL;

--
-- 506. RHN_SET_USER_FK  (Constraint) 
--
ALTER TABLE RHNSET DROP CONSTRAINT RHN_SET_USER_FK;
ALTER TABLE RHNSET ADD CONSTRAINT RHN_SET_USER_FK FOREIGN KEY (USER_ID) 
    REFERENCES WEB_CONTACT (ID)
    ON DELETE CASCADE;

--
-- 507. RHN_UGMEMBERS_UID_FK  (Constraint) 
--
ALTER TABLE RHNUSERGROUPMEMBERS DROP CONSTRAINT RHN_UGMEMBERS_UID_FK;
ALTER TABLE RHNUSERGROUPMEMBERS ADD CONSTRAINT RHN_UGMEMBERS_UID_FK FOREIGN KEY (USER_ID) 
    REFERENCES WEB_CONTACT (ID)
    ON DELETE CASCADE;

--
-- 508. RHN_USER_INFO_ASDE_CK  (Constraint) 
--
ALTER TABLE RHNUSERINFO ADD CONSTRAINT RHN_USER_INFO_ASDE_CK CHECK (agreed_to_asde_terms in ('Y','N'));

--
-- 508. RHN_REG_TOKEN_UID_FK  (Constraint) 
--
ALTER TABLE RHNREGTOKEN DROP CONSTRAINT RHN_REG_TOKEN_UID_FK;
ALTER TABLE RHNREGTOKEN ADD CONSTRAINT RHN_REG_TOKEN_UID_FK FOREIGN KEY (USER_ID) 
    REFERENCES WEB_CONTACT (ID)
    ON DELETE CASCADE;

--
-- 509. RHN_USER_INFO_ASDE_NN  (Constraint) 
--
ALTER TABLE RHNUSERINFO ADD CONSTRAINT RHN_USER_INFO_ASDE_NN CHECK ("AGREED_TO_ASDE_TERMS" IS NOT NULL);

--
-- 510. RHN_USER_INFO_CREATED_NN  (Constraint) 
--
ALTER TABLE RHNUSERINFO ADD CONSTRAINT RHN_USER_INFO_CREATED_NN CHECK ("CREATED" IS NOT NULL);

--
-- 511. RHN_USER_INFO_ES_CK  (Constraint) 
--
ALTER TABLE RHNUSERINFO ADD CONSTRAINT RHN_USER_INFO_ES_CK CHECK (agreed_to_es_terms is null or agreed_to_es_terms in ('Y','N'));

--
-- 512. RHN_USER_INFO_MODIFIED_NN  (Constraint) 
--
ALTER TABLE RHNUSERINFO ADD CONSTRAINT RHN_USER_INFO_MODIFIED_NN CHECK ("MODIFIED" IS NOT NULL);

--
-- 513. RHN_USER_INFO_SSGL_CK  (Constraint) 
--
ALTER TABLE RHNUSERINFO ADD CONSTRAINT RHN_USER_INFO_SSGL_CK CHECK (show_system_group_list in ('Y','N'));

--
-- 514. RHN_USER_INFO_SSGL_NN  (Constraint) 
--
ALTER TABLE RHNUSERINFO ADD CONSTRAINT RHN_USER_INFO_SSGL_NN CHECK ("SHOW_SYSTEM_GROUP_LIST" IS NOT NULL);

--
-- 515. RHN_USER_INFO_WS_CK  (Constraint) 
--
ALTER TABLE RHNUSERINFO ADD CONSTRAINT RHN_USER_INFO_WS_CK CHECK (agreed_to_ws_terms is null or agreed_to_ws_terms in ('Y','N'));

--
-- 516. RHN_USERSERVERPREFS_UID_FK  (Constraint) 
--
ALTER TABLE RHNUSERSERVERPREFS DROP CONSTRAINT RHN_USERSERVERPREFS_UID_FK;
ALTER TABLE RHNUSERSERVERPREFS ADD CONSTRAINT RHN_USERSERVERPREFS_UID_FK FOREIGN KEY (USER_ID) 
    REFERENCES WEB_CONTACT (ID)
    ON DELETE CASCADE;

--
-- 517. RHN_CPU_CAID_NN  (Constraint) 
--
ALTER TABLE RHNCPU ADD CONSTRAINT RHN_CPU_CAID_NN CHECK ("CPU_ARCH_ID" IS NOT NULL);

--
-- 518. RHN_CPU_CAID_FK  (Constraint) 
--
ALTER TABLE RHNCPU ADD CONSTRAINT RHN_CPU_CAID_FK FOREIGN KEY (CPU_ARCH_ID) 
    REFERENCES RHNCPUARCH (ID);

--
-- 519. RHN_SATELLITE_INFO_CREATED_NN  (Constraint) 
--
ALTER TABLE RHNSATELLITEINFO ADD CONSTRAINT RHN_SATELLITE_INFO_CREATED_NN CHECK ("CREATED" IS NOT NULL);

--
-- 520. RHN_SATELLITE_INFO_ES_NN  (Constraint) 
--
ALTER TABLE RHNSATELLITEINFO ADD CONSTRAINT RHN_SATELLITE_INFO_ES_NN CHECK ("ENTERPRISE_SLOTS" IS NOT NULL);

--
-- 521. RHN_SATELLITE_INFO_MODIFIED_NN  (Constraint) 
--
ALTER TABLE RHNSATELLITEINFO ADD CONSTRAINT RHN_SATELLITE_INFO_MODIFIED_NN CHECK ("MODIFIED" IS NOT NULL);

--
-- 522. RHN_SATELLITE_INFO_OWNER_NN  (Constraint) 
--
ALTER TABLE RHNSATELLITEINFO ADD CONSTRAINT RHN_SATELLITE_INFO_OWNER_NN CHECK ("OWNER" IS NOT NULL);

--
-- 523. RHN_SATELLITE_INFO_PRODUCT_NN  (Constraint) 
--
ALTER TABLE RHNSATELLITEINFO ADD CONSTRAINT RHN_SATELLITE_INFO_PRODUCT_NN CHECK ("PRODUCT" IS NOT NULL);

--
-- 524. RHN_SATELLITE_INFO_SID_UQ  (Constraint) 
--
ALTER TABLE RHNSATELLITEINFO ADD CONSTRAINT RHN_SATELLITE_INFO_SID_UQ UNIQUE (SERVER_ID);

--
-- 525. RHN_CARCH_CREATED_NN  (Constraint) 
--
ALTER TABLE RHNCHANNELARCH ADD CONSTRAINT RHN_CARCH_CREATED_NN CHECK ("CREATED" IS NOT NULL);

--
-- 526. RHN_CARCH_ID_NN  (Constraint) 
--
ALTER TABLE RHNCHANNELARCH ADD CONSTRAINT RHN_CARCH_ID_NN CHECK ("ID" IS NOT NULL);

--
-- 527. RHN_CARCH_LABEL_NN  (Constraint) 
--
ALTER TABLE RHNCHANNELARCH ADD CONSTRAINT RHN_CARCH_LABEL_NN CHECK ("LABEL" IS NOT NULL);

--
-- 528. RHN_CARCH_MODIFIED_NN  (Constraint) 
--
ALTER TABLE RHNCHANNELARCH ADD CONSTRAINT RHN_CARCH_MODIFIED_NN CHECK ("MODIFIED" IS NOT NULL);

--
-- 529. RHN_CARCH_NAME_NN  (Constraint) 
--
ALTER TABLE RHNCHANNELARCH ADD CONSTRAINT RHN_CARCH_NAME_NN CHECK ("NAME" IS NOT NULL);

--
-- 530. RHN_CARCH_ID_PK  (Constraint) 
--
--ALTER TABLE RHNCHANNELARCH ADD CONSTRAINT RHN_CARCH_ID_PK PRIMARY KEY (ID);

--
-- 531. RHN_CARCH_LABEL_UQ  (Constraint) 
--
--ALTER TABLE RHNCHANNELARCH ADD CONSTRAINT RHN_CARCH_LABEL_UQ UNIQUE (LABEL);

--
-- 532. RHN_CPUARCH_CREATED_NN  (Constraint) 
--
ALTER TABLE RHNCPUARCH ADD CONSTRAINT RHN_CPUARCH_CREATED_NN CHECK ("CREATED" IS NOT NULL);

--
-- 533. RHN_CPUARCH_ID_NN  (Constraint) 
--
ALTER TABLE RHNCPUARCH ADD CONSTRAINT RHN_CPUARCH_ID_NN CHECK ("ID" IS NOT NULL);

--
-- 534. RHN_CPUARCH_LABEL_NN  (Constraint) 
--
ALTER TABLE RHNCPUARCH ADD CONSTRAINT RHN_CPUARCH_LABEL_NN CHECK ("LABEL" IS NOT NULL);

--
-- 535. RHN_CPUARCH_MODIFIED_NN  (Constraint) 
--
ALTER TABLE RHNCPUARCH ADD CONSTRAINT RHN_CPUARCH_MODIFIED_NN CHECK ("MODIFIED" IS NOT NULL);

--
-- 536. RHN_CPUARCH_NAME_NN  (Constraint) 
--
ALTER TABLE RHNCPUARCH ADD CONSTRAINT RHN_CPUARCH_NAME_NN CHECK ("NAME" IS NOT NULL);

--
-- 537. RHN_CPUARCH_ID_PK  (Constraint) 
--
--ALTER TABLE RHNCPUARCH ADD CONSTRAINT RHN_CPUARCH_ID_PK PRIMARY KEY (ID);

--
-- 538. RHN_CPUARCH_LABEL_UQ  (Constraint) 
--
--ALTER TABLE RHNCPUARCH ADD CONSTRAINT RHN_CPUARCH_LABEL_UQ UNIQUE (LABEL);

--
-- 539. RHN_DAEMONSTATE_LABEL_NN  (Constraint) 
--
ALTER TABLE RHNDAEMONSTATE ADD CONSTRAINT RHN_DAEMONSTATE_LABEL_NN CHECK ("LABEL" IS NOT NULL);

--
-- 540. RHN_DAEMONSTATE_LP_NN  (Constraint) 
--
ALTER TABLE RHNDAEMONSTATE ADD CONSTRAINT RHN_DAEMONSTATE_LP_NN CHECK ("LAST_POLL" IS NOT NULL);

--
-- 541. RHN_DAEMONSTATE_LABEL_PK  (Constraint) 
--
ALTER TABLE RHNDAEMONSTATE ADD CONSTRAINT RHN_DAEMONSTATE_LABEL_PK PRIMARY KEY (LABEL);

--
-- 542. RHN_DLT_CAT_NN  (Constraint) 
--
ALTER TABLE RHNDOWNLOADGROUPS ADD CONSTRAINT RHN_DLT_CAT_NN CHECK ("DOWNLOAD_CATEGORY" IS NOT NULL);

--
-- 543. RHN_DLT_NAME_NN  (Constraint) 
--
ALTER TABLE RHNDOWNLOADGROUPS ADD CONSTRAINT RHN_DLT_NAME_NN CHECK ("GROUP_NAME" IS NOT NULL);

--
-- 544. RHN_DLT_ORD_NN  (Constraint) 
--
ALTER TABLE RHNDOWNLOADGROUPS ADD CONSTRAINT RHN_DLT_ORD_NN CHECK ("ORDERING" IS NOT NULL);

--
-- 545. RHN_EASTATE_CREATED_NN  (Constraint) 
--
ALTER TABLE RHNEMAILADDRESSSTATE ADD CONSTRAINT RHN_EASTATE_CREATED_NN CHECK ("CREATED" IS NOT NULL);

--
-- 546. RHN_EASTATE_ID_NN  (Constraint) 
--
ALTER TABLE RHNEMAILADDRESSSTATE ADD CONSTRAINT RHN_EASTATE_ID_NN CHECK ("ID" IS NOT NULL);

--
-- 547. RHN_EASTATE_LABEL_NN  (Constraint) 
--
ALTER TABLE RHNEMAILADDRESSSTATE ADD CONSTRAINT RHN_EASTATE_LABEL_NN CHECK ("LABEL" IS NOT NULL);

--
-- 548. RHN_EASTATE_MODIFIED_NN  (Constraint) 
--
ALTER TABLE RHNEMAILADDRESSSTATE ADD CONSTRAINT RHN_EASTATE_MODIFIED_NN CHECK ("MODIFIED" IS NOT NULL);

--
-- 549. RHN_EASTATE_ID_PK  (Constraint) 
--
ALTER TABLE RHNEMAILADDRESSSTATE ADD CONSTRAINT RHN_EASTATE_ID_PK PRIMARY KEY (ID);

--
-- 550. RHN_EASTATE_LABEL_UQ  (Constraint) 
--
ALTER TABLE RHNEMAILADDRESSSTATE ADD CONSTRAINT RHN_EASTATE_LABEL_UQ UNIQUE (LABEL);

--
-- 551. RHN_ENTITLEMENT_LOG_BDATE_NN  (Constraint) 
--
ALTER TABLE RHNENTITLEMENTLOG ADD CONSTRAINT RHN_ENTITLEMENT_LOG_BDATE_NN CHECK ("BDATE" IS NOT NULL);

--
-- 552. RHN_ENTITLEMENT_LOG_EDATE_NN  (Constraint) 
--
ALTER TABLE RHNENTITLEMENTLOG ADD CONSTRAINT RHN_ENTITLEMENT_LOG_EDATE_NN CHECK ("EDATE" IS NOT NULL);

--
-- 553. RHN_ENTITLEMENT_LOG_RT_NN  (Constraint) 
--
ALTER TABLE RHNENTITLEMENTLOG ADD CONSTRAINT RHN_ENTITLEMENT_LOG_RT_NN CHECK ("RUN_TIME" IS NOT NULL);

--
-- 554. RHN_ERRATAFILE_TYPE_ID_NN  (Constraint) 
--
ALTER TABLE RHNERRATAFILETYPE ADD CONSTRAINT RHN_ERRATAFILE_TYPE_ID_NN CHECK ("ID" IS NOT NULL);

--
-- 555. RHN_ERRATAFILE_TYPE_LABEL_NN  (Constraint) 
--
ALTER TABLE RHNERRATAFILETYPE ADD CONSTRAINT RHN_ERRATAFILE_TYPE_LABEL_NN CHECK ("LABEL" IS NOT NULL);

--
-- 556. RHN_ERRATAFILE_TYPE_ID_PK  (Constraint) 
--
ALTER TABLE RHNERRATAFILETYPE ADD CONSTRAINT RHN_ERRATAFILE_TYPE_ID_PK PRIMARY KEY (ID);

--
-- 557. RHN_ERRATAFILE_TYPE_LABEL_UQ  (Constraint) 
--
ALTER TABLE RHNERRATAFILETYPE ADD CONSTRAINT RHN_ERRATAFILE_TYPE_LABEL_UQ UNIQUE (LABEL);

--
-- 558. RHN_HWCLASS_CLASS_NN  (Constraint) 
--
ALTER TABLE RHNHARDWARECLASS ADD CONSTRAINT RHN_HWCLASS_CLASS_NN CHECK ("CLASS" IS NOT NULL);

--
-- 559. RHN_HWCLASS_ID_NN  (Constraint) 
--
ALTER TABLE RHNHARDWARECLASS ADD CONSTRAINT RHN_HWCLASS_ID_NN CHECK ("ID" IS NOT NULL);

--
-- 560. RHN_HWCLASS_LABEL_NN  (Constraint) 
--
ALTER TABLE RHNHARDWARECLASS ADD CONSTRAINT RHN_HWCLASS_LABEL_NN CHECK ("LABEL" IS NOT NULL);

--
-- 561. RHN_HWCLASS_ID_PK  (Constraint) 
--
ALTER TABLE RHNHARDWARECLASS ADD CONSTRAINT RHN_HWCLASS_ID_PK PRIMARY KEY (ID);

--
-- 562. RHN_HWCLASS_LABEL_UQ  (Constraint) 
--
ALTER TABLE RHNHARDWARECLASS ADD CONSTRAINT RHN_HWCLASS_LABEL_UQ UNIQUE (LABEL);

--
-- 563. RHN_HWPNAME_ID_NN  (Constraint) 
--
ALTER TABLE RHNHARDWAREPROPNAME ADD CONSTRAINT RHN_HWPNAME_ID_NN CHECK ("ID" IS NOT NULL);

--
-- 564. RHN_HWPNAME_NAME_NN  (Constraint) 
--
ALTER TABLE RHNHARDWAREPROPNAME ADD CONSTRAINT RHN_HWPNAME_NAME_NN CHECK ("NAME" IS NOT NULL);

--
-- 565. RHN_HWPNAME_ID_PK  (Constraint) 
--
ALTER TABLE RHNHARDWAREPROPNAME ADD CONSTRAINT RHN_HWPNAME_ID_PK PRIMARY KEY (ID);

--
-- 566. RHN_HWPNAME_NAME_UQ  (Constraint) 
--
ALTER TABLE RHNHARDWAREPROPNAME ADD CONSTRAINT RHN_HWPNAME_NAME_UQ UNIQUE (NAME);

--
-- 567. RHN_HWPVALUE_ID_NN  (Constraint) 
--
ALTER TABLE RHNHARDWAREPROPVALUE ADD CONSTRAINT RHN_HWPVALUE_ID_NN CHECK ("ID" IS NOT NULL);

--
-- 568. RHN_HWPVALUE_ID_PK  (Constraint) 
--
ALTER TABLE RHNHARDWAREPROPVALUE ADD CONSTRAINT RHN_HWPVALUE_ID_PK PRIMARY KEY (ID);

--
-- 569. RHN_HWPVALUE_VALUE_UQ  (Constraint) 
--
ALTER TABLE RHNHARDWAREPROPVALUE ADD CONSTRAINT RHN_HWPVALUE_VALUE_UQ UNIQUE (VALUE);

--
-- 570. RHN_M_PRIORITY_ID_NN  (Constraint) 
--
ALTER TABLE RHNMESSAGEPRIORITY ADD CONSTRAINT RHN_M_PRIORITY_ID_NN CHECK ("ID" IS NOT NULL);

--
-- 571. RHN_M_PRIORITY_LABEL_NN  (Constraint) 
--
ALTER TABLE RHNMESSAGEPRIORITY ADD CONSTRAINT RHN_M_PRIORITY_LABEL_NN CHECK ("LABEL" IS NOT NULL);

--
-- 572. RHN_M_PRIORITY_ID_PK  (Constraint) 
--
ALTER TABLE RHNMESSAGEPRIORITY ADD CONSTRAINT RHN_M_PRIORITY_ID_PK PRIMARY KEY (ID);

--
-- 573. RHN_M_TYPE_ID_NN  (Constraint) 
--
ALTER TABLE RHNMESSAGETYPE ADD CONSTRAINT RHN_M_TYPE_ID_NN CHECK ("ID" IS NOT NULL);

--
-- 574. RHN_M_TYPE_LABEL_NN  (Constraint) 
--
ALTER TABLE RHNMESSAGETYPE ADD CONSTRAINT RHN_M_TYPE_LABEL_NN CHECK ("LABEL" IS NOT NULL);

--
-- 575. RHN_M_TYPE_NAME_NN  (Constraint) 
--
ALTER TABLE RHNMESSAGETYPE ADD CONSTRAINT RHN_M_TYPE_NAME_NN CHECK ("NAME" IS NOT NULL);

--
-- 576. RHN_M_TYPE_ID_PK  (Constraint) 
--
ALTER TABLE RHNMESSAGETYPE ADD CONSTRAINT RHN_M_TYPE_ID_PK PRIMARY KEY (ID);

--
-- 577. RHN_MONITORGRAN_ID_NN  (Constraint) 
--
ALTER TABLE RHNMONITORGRANULARITY ADD CONSTRAINT RHN_MONITORGRAN_ID_NN CHECK ("ID" IS NOT NULL);

--
-- 578. RHN_MONITORGRAN_LABEL_NN  (Constraint) 
--
ALTER TABLE RHNMONITORGRANULARITY ADD CONSTRAINT RHN_MONITORGRAN_LABEL_NN CHECK ("LABEL" IS NOT NULL);

--
-- 579. RHN_MONITORGRAN_ID_PK  (Constraint) 
--
ALTER TABLE RHNMONITORGRANULARITY ADD CONSTRAINT RHN_MONITORGRAN_ID_PK PRIMARY KEY (ID);

--
-- 580. RHN_OASTATES_CREATED_NN  (Constraint) 
--
ALTER TABLE RHNORGAVAILABLESTATES ADD CONSTRAINT RHN_OASTATES_CREATED_NN CHECK ("CREATED" IS NOT NULL);

--
-- 581. RHN_OASTATES_ID_NN  (Constraint) 
--
ALTER TABLE RHNORGAVAILABLESTATES ADD CONSTRAINT RHN_OASTATES_ID_NN CHECK ("ID" IS NOT NULL);

--
-- 582. RHN_OASTATES_LABEL_NN  (Constraint) 
--
ALTER TABLE RHNORGAVAILABLESTATES ADD CONSTRAINT RHN_OASTATES_LABEL_NN CHECK ("LABEL" IS NOT NULL);

--
-- 583. RHN_OASTATES_MODIFIED_NN  (Constraint) 
--
ALTER TABLE RHNORGAVAILABLESTATES ADD CONSTRAINT RHN_OASTATES_MODIFIED_NN CHECK ("MODIFIED" IS NOT NULL);

--
-- 584. RHN_OASTATIS_ID_PK  (Constraint) 
--
ALTER TABLE RHNORGAVAILABLESTATES ADD CONSTRAINT RHN_OASTATIS_ID_PK PRIMARY KEY (ID);

--
-- 585. RHN_OASTATES_LABEL_UQ  (Constraint) 
--
ALTER TABLE RHNORGAVAILABLESTATES ADD CONSTRAINT RHN_OASTATES_LABEL_UQ UNIQUE (LABEL);

--
-- 586. RHN_OSTRANSITIONS_FROM_NN  (Constraint) 
--
ALTER TABLE RHNORGSTATETRANSITIONS ADD CONSTRAINT RHN_OSTRANSITIONS_FROM_NN CHECK ("FROM_STATE" IS NOT NULL);

--
-- 587. RHN_OSTRANSITIONS_TO_NN  (Constraint) 
--
ALTER TABLE RHNORGSTATETRANSITIONS ADD CONSTRAINT RHN_OSTRANSITIONS_TO_NN CHECK ("TO_STATE" IS NOT NULL);

--
-- 588. RHN_OSTRANSITIONS_FS_TS_UQ  (Constraint) 
--
ALTER TABLE RHNORGSTATETRANSITIONS ADD CONSTRAINT RHN_OSTRANSITIONS_FS_TS_UQ UNIQUE (FROM_STATE, TO_STATE);

--
-- 589. RHN_OSTRANSITIONS_FROM_FK  (Constraint) 
--
ALTER TABLE RHNORGSTATETRANSITIONS ADD CONSTRAINT RHN_OSTRANSITIONS_FROM_FK FOREIGN KEY (FROM_STATE) 
    REFERENCES RHNORGAVAILABLESTATES (ID);

--
-- 590. RHN_OSTRANSITIONS_TO_FK  (Constraint) 
--
ALTER TABLE RHNORGSTATETRANSITIONS ADD CONSTRAINT RHN_OSTRANSITIONS_TO_FK FOREIGN KEY (TO_STATE) 
    REFERENCES RHNORGAVAILABLESTATES (ID);

--
-- 591. RHN_PARCH_CREATED_NN  (Constraint) 
--
ALTER TABLE RHNPACKAGEARCH ADD CONSTRAINT RHN_PARCH_CREATED_NN CHECK ("CREATED" IS NOT NULL);

--
-- 592. RHN_PARCH_ID_NN  (Constraint) 
--
ALTER TABLE RHNPACKAGEARCH ADD CONSTRAINT RHN_PARCH_ID_NN CHECK ("ID" IS NOT NULL);

--
-- 593. RHN_PARCH_LABEL_NN  (Constraint) 
--
ALTER TABLE RHNPACKAGEARCH ADD CONSTRAINT RHN_PARCH_LABEL_NN CHECK ("LABEL" IS NOT NULL);

--
-- 594. RHN_PARCH_MODIFIED_NN  (Constraint) 
--
ALTER TABLE RHNPACKAGEARCH ADD CONSTRAINT RHN_PARCH_MODIFIED_NN CHECK ("MODIFIED" IS NOT NULL);

--
-- 595. RHN_PARCH_NAME_NN  (Constraint) 
--
ALTER TABLE RHNPACKAGEARCH ADD CONSTRAINT RHN_PARCH_NAME_NN CHECK ("NAME" IS NOT NULL);

--
-- 596. RHN_PARCH_ID_PK  (Constraint) 
--
--ALTER TABLE RHNPACKAGEARCH ADD CONSTRAINT RHN_PARCH_ID_PK PRIMARY KEY (ID);

--
-- 597. RHN_PARCH_LABEL_UQ  (Constraint) 
--
--ALTER TABLE RHNPACKAGEARCH ADD CONSTRAINT RHN_PARCH_LABEL_UQ UNIQUE (LABEL);

--
-- 598. RHN_PROD_LINE_CREATED_NN  (Constraint) 
--
ALTER TABLE RHNPRODUCTLINE ADD CONSTRAINT RHN_PROD_LINE_CREATED_NN CHECK ("CREATED" IS NOT NULL);

--
-- 599. RHN_PROD_LINE_ID_NN  (Constraint) 
--
ALTER TABLE RHNPRODUCTLINE ADD CONSTRAINT RHN_PROD_LINE_ID_NN CHECK ("ID" IS NOT NULL);

--
-- 600. RHN_PROD_LINE_LABEL_NN  (Constraint) 
--
ALTER TABLE RHNPRODUCTLINE ADD CONSTRAINT RHN_PROD_LINE_LABEL_NN CHECK ("LABEL" IS NOT NULL);

--
-- 601. RHN_PROD_LINE_LM_NN  (Constraint) 
--
ALTER TABLE RHNPRODUCTLINE ADD CONSTRAINT RHN_PROD_LINE_LM_NN CHECK ("LAST_MODIFIED" IS NOT NULL);

--
-- 602. RHN_PROD_LINE_MODIFIED_NN  (Constraint) 
--
ALTER TABLE RHNPRODUCTLINE ADD CONSTRAINT RHN_PROD_LINE_MODIFIED_NN CHECK ("MODIFIED" IS NOT NULL);

--
-- 603. RHN_PROD_LINE_NAME_NN  (Constraint) 
--
ALTER TABLE RHNPRODUCTLINE ADD CONSTRAINT RHN_PROD_LINE_NAME_NN CHECK ("NAME" IS NOT NULL);

--
-- 604. RHN_PROD_LINE_ID_PK  (Constraint) 
--
ALTER TABLE RHNPRODUCTLINE ADD CONSTRAINT RHN_PROD_LINE_ID_PK PRIMARY KEY (ID);

--
-- 605. RHN_PROD_LINE_LABEL_UQ  (Constraint) 
--
ALTER TABLE RHNPRODUCTLINE ADD CONSTRAINT RHN_PROD_LINE_LABEL_UQ UNIQUE (LABEL);

--
-- 606. RHN_PROD_LINE_NAME_UQ  (Constraint) 
--
ALTER TABLE RHNPRODUCTLINE ADD CONSTRAINT RHN_PROD_LINE_NAME_UQ UNIQUE (NAME);

--
-- 607. RHN_RELTYPE_CREATED_NN  (Constraint) 
--
ALTER TABLE RHNRELATIONSHIPTYPE ADD CONSTRAINT RHN_RELTYPE_CREATED_NN CHECK ("CREATED" IS NOT NULL);

--
-- 608. RHN_RELTYPE_ID_NN  (Constraint) 
--
ALTER TABLE RHNRELATIONSHIPTYPE ADD CONSTRAINT RHN_RELTYPE_ID_NN CHECK ("ID" IS NOT NULL);

--
-- 609. RHN_RELTYPE_LABEL_NN  (Constraint) 
--
ALTER TABLE RHNRELATIONSHIPTYPE ADD CONSTRAINT RHN_RELTYPE_LABEL_NN CHECK ("LABEL" IS NOT NULL);

--
-- 610. RHN_RELTYPE_MODIFIED_NN  (Constraint) 
--
ALTER TABLE RHNRELATIONSHIPTYPE ADD CONSTRAINT RHN_RELTYPE_MODIFIED_NN CHECK ("MODIFIED" IS NOT NULL);

--
-- 611. RHN_RELTYPE_ID_PK  (Constraint) 
--
ALTER TABLE RHNRELATIONSHIPTYPE ADD CONSTRAINT RHN_RELTYPE_ID_PK PRIMARY KEY (ID);

--
-- 612. RHN_RELTYPE_LABEL_UQ  (Constraint) 
--
ALTER TABLE RHNRELATIONSHIPTYPE ADD CONSTRAINT RHN_RELTYPE_LABEL_UQ UNIQUE (LABEL);

--
-- 613. RHN_SSTYPE_CREATED_NN  (Constraint) 
--
ALTER TABLE RHNSAVEDSEARCHTYPE ADD CONSTRAINT RHN_SSTYPE_CREATED_NN CHECK ("CREATED" IS NOT NULL);

--
-- 614. RHN_SSTYPE_ID_NN  (Constraint) 
--
ALTER TABLE RHNSAVEDSEARCHTYPE ADD CONSTRAINT RHN_SSTYPE_ID_NN CHECK ("ID" IS NOT NULL);

--
-- 615. RHN_SSTYPE_LABEL_NN  (Constraint) 
--
ALTER TABLE RHNSAVEDSEARCHTYPE ADD CONSTRAINT RHN_SSTYPE_LABEL_NN CHECK ("LABEL" IS NOT NULL);

--
-- 616. RHN_SSTYPE_MODIFIED_NN  (Constraint) 
--
ALTER TABLE RHNSAVEDSEARCHTYPE ADD CONSTRAINT RHN_SSTYPE_MODIFIED_NN CHECK ("MODIFIED" IS NOT NULL);

--
-- 617. RHN_SSTYPE_ID_PK  (Constraint) 
--
ALTER TABLE RHNSAVEDSEARCHTYPE ADD CONSTRAINT RHN_SSTYPE_ID_PK PRIMARY KEY (ID);

--
-- 618. RHN_SSTYPE_LABEL_UQ  (Constraint) 
--
ALTER TABLE RHNSAVEDSEARCHTYPE ADD CONSTRAINT RHN_SSTYPE_LABEL_UQ UNIQUE (LABEL);

--
-- 619. RHN_SARCH_CREATED_NN  (Constraint) 
--
ALTER TABLE RHNSERVERARCH ADD CONSTRAINT RHN_SARCH_CREATED_NN CHECK ("CREATED" IS NOT NULL);

--
-- 620. RHN_SARCH_ID_NN  (Constraint) 
--
ALTER TABLE RHNSERVERARCH ADD CONSTRAINT RHN_SARCH_ID_NN CHECK ("ID" IS NOT NULL);

--
-- 621. RHN_SARCH_LABEL_NN  (Constraint) 
--
ALTER TABLE RHNSERVERARCH ADD CONSTRAINT RHN_SARCH_LABEL_NN CHECK ("LABEL" IS NOT NULL);

--
-- 622. RHN_SARCH_MODIFIED_NN  (Constraint) 
--
ALTER TABLE RHNSERVERARCH ADD CONSTRAINT RHN_SARCH_MODIFIED_NN CHECK ("MODIFIED" IS NOT NULL);

--
-- 623. RHN_SARCH_NAME_NN  (Constraint) 
--
ALTER TABLE RHNSERVERARCH ADD CONSTRAINT RHN_SARCH_NAME_NN CHECK ("NAME" IS NOT NULL);

--
-- 624. RHN_SARCH_ID_PK  (Constraint) 
--
--ALTER TABLE RHNSERVERARCH ADD CONSTRAINT RHN_SARCH_ID_PK PRIMARY KEY (ID);

--
-- 625. RHN_SARCH_LABEL_UQ  (Constraint) 
--
--ALTER TABLE RHNSERVERARCH ADD CONSTRAINT RHN_SARCH_LABEL_UQ UNIQUE (LABEL);

--
-- 626. RHN_SC_AC_CAID_NN  (Constraint) 
--
ALTER TABLE RHNSERVERCHANNELARCHCOMPAT ADD CONSTRAINT RHN_SC_AC_CAID_NN CHECK ("CHANNEL_ARCH_ID" IS NOT NULL);

--
-- 627. RHN_SC_AC_CREATED_NN  (Constraint) 
--
ALTER TABLE RHNSERVERCHANNELARCHCOMPAT ADD CONSTRAINT RHN_SC_AC_CREATED_NN CHECK ("CREATED" IS NOT NULL);

--
-- 628. RHN_SC_AC_MODIFIED_NN  (Constraint) 
--
ALTER TABLE RHNSERVERCHANNELARCHCOMPAT ADD CONSTRAINT RHN_SC_AC_MODIFIED_NN CHECK ("MODIFIED" IS NOT NULL);

--
-- 629. RHN_SC_AC_SAID_NN  (Constraint) 
--
ALTER TABLE RHNSERVERCHANNELARCHCOMPAT ADD CONSTRAINT RHN_SC_AC_SAID_NN CHECK ("SERVER_ARCH_ID" IS NOT NULL);

--
-- 630. RHN_SC_AC_SAID_UQ  (Constraint) 
--
ALTER TABLE RHNSERVERCHANNELARCHCOMPAT ADD CONSTRAINT RHN_SC_AC_SAID_UQ UNIQUE (SERVER_ARCH_ID);

--
-- 631. RHN_SC_AC_CAID_FK  (Constraint) 
--
ALTER TABLE RHNSERVERCHANNELARCHCOMPAT ADD CONSTRAINT RHN_SC_AC_CAID_FK FOREIGN KEY (CHANNEL_ARCH_ID) 
    REFERENCES RHNCHANNELARCH (ID);

--
-- 632. RHN_SC_AC_SAID_FK  (Constraint) 
--
ALTER TABLE RHNSERVERCHANNELARCHCOMPAT ADD CONSTRAINT RHN_SC_AC_SAID_FK FOREIGN KEY (SERVER_ARCH_ID) 
    REFERENCES RHNSERVERARCH (ID);

--
-- 633. RHN_SP_AC_CREATED_NN  (Constraint) 
--
ALTER TABLE RHNSERVERPACKAGEARCHCOMPAT ADD CONSTRAINT RHN_SP_AC_CREATED_NN CHECK ("CREATED" IS NOT NULL);

--
-- 634. RHN_SP_AC_MODIFIED_NN  (Constraint) 
--
ALTER TABLE RHNSERVERPACKAGEARCHCOMPAT ADD CONSTRAINT RHN_SP_AC_MODIFIED_NN CHECK ("MODIFIED" IS NOT NULL);

--
-- 635. RHN_SP_AC_PAID_NN  (Constraint) 
--
ALTER TABLE RHNSERVERPACKAGEARCHCOMPAT ADD CONSTRAINT RHN_SP_AC_PAID_NN CHECK ("PACKAGE_ARCH_ID" IS NOT NULL);

--
-- 636. RHN_SP_AC_PREF_NN  (Constraint) 
--
ALTER TABLE RHNSERVERPACKAGEARCHCOMPAT ADD CONSTRAINT RHN_SP_AC_PREF_NN CHECK ("PREFERENCE" IS NOT NULL);

--
-- 637. RHN_SP_AC_SAID_NN  (Constraint) 
--
ALTER TABLE RHNSERVERPACKAGEARCHCOMPAT ADD CONSTRAINT RHN_SP_AC_SAID_NN CHECK ("SERVER_ARCH_ID" IS NOT NULL);

--
-- 638. RHN_SP_AC_PREF_SAID_UQ  (Constraint) 
--
ALTER TABLE RHNSERVERPACKAGEARCHCOMPAT ADD CONSTRAINT RHN_SP_AC_PREF_SAID_UQ UNIQUE (PREFERENCE, SERVER_ARCH_ID);

--
-- 639. RHN_SP_AC_SAID_PAID_UQ  (Constraint) 
--
ALTER TABLE RHNSERVERPACKAGEARCHCOMPAT ADD CONSTRAINT RHN_SP_AC_SAID_PAID_UQ UNIQUE (SERVER_ARCH_ID, PACKAGE_ARCH_ID);

--
-- 640. RHN_SP_AC_PAID_FK  (Constraint) 
--
ALTER TABLE RHNSERVERPACKAGEARCHCOMPAT ADD CONSTRAINT RHN_SP_AC_PAID_FK FOREIGN KEY (PACKAGE_ARCH_ID) 
    REFERENCES RHNPACKAGEARCH (ID);

--
-- 641. RHN_SP_AC_SAID_FK  (Constraint) 
--
ALTER TABLE RHNSERVERPACKAGEARCHCOMPAT ADD CONSTRAINT RHN_SP_AC_SAID_FK FOREIGN KEY (SERVER_ARCH_ID) 
    REFERENCES RHNSERVERARCH (ID);

--
-- 642. RHN_SURVEY_ACTIVE_CK  (Constraint) 
--
ALTER TABLE RHNSURVEY ADD CONSTRAINT RHN_SURVEY_ACTIVE_CK CHECK (active in ('Y','N'));

--
-- 643. RHN_SURVEY_ACTIVE_NN  (Constraint) 
--
ALTER TABLE RHNSURVEY ADD CONSTRAINT RHN_SURVEY_ACTIVE_NN CHECK ("ACTIVE" IS NOT NULL);

--
-- 644. RHN_SURVEY_CLASS_NN  (Constraint) 
--
ALTER TABLE RHNSURVEY ADD CONSTRAINT RHN_SURVEY_CLASS_NN CHECK ("CLASS" IS NOT NULL);

--
-- 645. RHN_SURVEY_ID_NN  (Constraint) 
--
ALTER TABLE RHNSURVEY ADD CONSTRAINT RHN_SURVEY_ID_NN CHECK ("ID" IS NOT NULL);

--
-- 646. RHN_SURVEY_LABEL_NN  (Constraint) 
--
ALTER TABLE RHNSURVEY ADD CONSTRAINT RHN_SURVEY_LABEL_NN CHECK ("LABEL" IS NOT NULL);

--
-- 647. RHN_SURVEY_ID_PK  (Constraint) 
--
ALTER TABLE RHNSURVEY ADD CONSTRAINT RHN_SURVEY_ID_PK PRIMARY KEY (ID);

--
-- 648. RHN_SURVEY_LABEL_UQ  (Constraint) 
--
ALTER TABLE RHNSURVEY ADD CONSTRAINT RHN_SURVEY_LABEL_UQ UNIQUE (LABEL);

--
-- 649. RHN_SQUESTION_ID_NN  (Constraint) 
--
ALTER TABLE RHNSURVEYQUESTION ADD CONSTRAINT RHN_SQUESTION_ID_NN CHECK ("ID" IS NOT NULL);

--
-- 650. RHN_SQUESTION_LABEL_NN  (Constraint) 
--
ALTER TABLE RHNSURVEYQUESTION ADD CONSTRAINT RHN_SQUESTION_LABEL_NN CHECK ("LABEL" IS NOT NULL);

--
-- 651. RHN_SQUESTION_SID_NN  (Constraint) 
--
ALTER TABLE RHNSURVEYQUESTION ADD CONSTRAINT RHN_SQUESTION_SID_NN CHECK ("SURVEY_ID" IS NOT NULL);

--
-- 652. RHN_SQUESTION_ID_PK  (Constraint) 
--
ALTER TABLE RHNSURVEYQUESTION ADD CONSTRAINT RHN_SQUESTION_ID_PK PRIMARY KEY (ID);

--
-- 653. RHN_SQUESTION_LABEL_SID_UQ  (Constraint) 
--
ALTER TABLE RHNSURVEYQUESTION ADD CONSTRAINT RHN_SQUESTION_LABEL_SID_UQ UNIQUE (LABEL, SURVEY_ID);

--
-- 654. RHN_SQUESTION_SID_FK  (Constraint) 
--
ALTER TABLE RHNSURVEYQUESTION ADD CONSTRAINT RHN_SQUESTION_SID_FK FOREIGN KEY (SURVEY_ID) 
    REFERENCES RHNSURVEY (ID);

--
-- 655. RHN_TEMPLATE_CAT_CREATED_NN  (Constraint) 
--
ALTER TABLE RHNTEMPLATECATEGORY ADD CONSTRAINT RHN_TEMPLATE_CAT_CREATED_NN CHECK ("CREATED" IS NOT NULL);

--
-- 656. RHN_TEMPLATE_CAT_DESC_NN  (Constraint) 
--
ALTER TABLE RHNTEMPLATECATEGORY ADD CONSTRAINT RHN_TEMPLATE_CAT_DESC_NN CHECK ("DESCRIPTION" IS NOT NULL);

--
-- 657. RHN_TEMPLATE_CAT_ID_NN  (Constraint) 
--
ALTER TABLE RHNTEMPLATECATEGORY ADD CONSTRAINT RHN_TEMPLATE_CAT_ID_NN CHECK ("ID" IS NOT NULL);

--
-- 658. RHN_TEMPLATE_CAT_LABEL_NN  (Constraint) 
--
ALTER TABLE RHNTEMPLATECATEGORY ADD CONSTRAINT RHN_TEMPLATE_CAT_LABEL_NN CHECK ("LABEL" IS NOT NULL);

--
-- 659. RHN_TEMPLATE_CAT_MODIFIED_NN  (Constraint) 
--
ALTER TABLE RHNTEMPLATECATEGORY ADD CONSTRAINT RHN_TEMPLATE_CAT_MODIFIED_NN CHECK ("MODIFIED" IS NOT NULL);

--
-- 660. RHN_TEMPLATE_CAT_ID_PK  (Constraint) 
--
ALTER TABLE RHNTEMPLATECATEGORY ADD CONSTRAINT RHN_TEMPLATE_CAT_ID_PK PRIMARY KEY (ID);

--
-- 661. RHN_TEMPLATE_CAT_LABEL_UQ  (Constraint) 
--
ALTER TABLE RHNTEMPLATECATEGORY ADD CONSTRAINT RHN_TEMPLATE_CAT_LABEL_UQ UNIQUE (LABEL);

--
-- 662. RHN_TEMPLATE_STR_CID_NN  (Constraint) 
--
ALTER TABLE RHNTEMPLATESTRING ADD CONSTRAINT RHN_TEMPLATE_STR_CID_NN CHECK ("CATEGORY_ID" IS NOT NULL);

--
-- 663. RHN_TEMPLATE_STR_CREATED_NN  (Constraint) 
--
ALTER TABLE RHNTEMPLATESTRING ADD CONSTRAINT RHN_TEMPLATE_STR_CREATED_NN CHECK ("CREATED" IS NOT NULL);

--
-- 664. RHN_TEMPLATE_STR_DESC_NN  (Constraint) 
--
ALTER TABLE RHNTEMPLATESTRING ADD CONSTRAINT RHN_TEMPLATE_STR_DESC_NN CHECK ("DESCRIPTION" IS NOT NULL);

--
-- 665. RHN_TEMPLATE_STR_ID_NN  (Constraint) 
--
ALTER TABLE RHNTEMPLATESTRING ADD CONSTRAINT RHN_TEMPLATE_STR_ID_NN CHECK ("ID" IS NOT NULL);

--
-- 666. RHN_TEMPLATE_STR_KEY_NN  (Constraint) 
--
ALTER TABLE RHNTEMPLATESTRING ADD CONSTRAINT RHN_TEMPLATE_STR_KEY_NN CHECK ("LABEL" IS NOT NULL);

--
-- 667. RHN_TEMPLATE_STR_MODIFIED_NN  (Constraint) 
--
ALTER TABLE RHNTEMPLATESTRING ADD CONSTRAINT RHN_TEMPLATE_STR_MODIFIED_NN CHECK ("MODIFIED" IS NOT NULL);

--
-- 668. RHN_TEMPLATE_STR_ID_PK  (Constraint) 
--
ALTER TABLE RHNTEMPLATESTRING ADD CONSTRAINT RHN_TEMPLATE_STR_ID_PK PRIMARY KEY (ID);

--
-- 669. RHN_TEMPLATE_STR_CID_LABEL_UQ  (Constraint) 
--
ALTER TABLE RHNTEMPLATESTRING ADD CONSTRAINT RHN_TEMPLATE_STR_CID_LABEL_UQ UNIQUE (CATEGORY_ID, LABEL);

--
-- 670. RHN_TEMPLATE_STR_CID_FK  (Constraint) 
--
ALTER TABLE RHNTEMPLATESTRING ADD CONSTRAINT RHN_TEMPLATE_STR_CID_FK FOREIGN KEY (CATEGORY_ID) 
    REFERENCES RHNTEMPLATECATEGORY (ID);

--
-- 671. RHN_TRANSOP_CREATED_NN  (Constraint) 
--
ALTER TABLE RHNTRANSACTIONOPERATION ADD CONSTRAINT RHN_TRANSOP_CREATED_NN CHECK ("CREATED" IS NOT NULL);

--
-- 672. RHN_TRANSOP_ID_NN  (Constraint) 
--
ALTER TABLE RHNTRANSACTIONOPERATION ADD CONSTRAINT RHN_TRANSOP_ID_NN CHECK ("ID" IS NOT NULL);

--
-- 673. RHN_TRANSOP_LABEL_NN  (Constraint) 
--
ALTER TABLE RHNTRANSACTIONOPERATION ADD CONSTRAINT RHN_TRANSOP_LABEL_NN CHECK ("LABEL" IS NOT NULL);

--
-- 674. RHN_TRANSOP_MODIFIED_NN  (Constraint) 
--
ALTER TABLE RHNTRANSACTIONOPERATION ADD CONSTRAINT RHN_TRANSOP_MODIFIED_NN CHECK ("MODIFIED" IS NOT NULL);

--
-- 675. RHN_TRANSOP_ID_PK  (Constraint) 
--
ALTER TABLE RHNTRANSACTIONOPERATION ADD CONSTRAINT RHN_TRANSOP_ID_PK PRIMARY KEY (ID);

--
-- 676. RHN_TRANSOP_LABEL_UQ  (Constraint) 
--
ALTER TABLE RHNTRANSACTIONOPERATION ADD CONSTRAINT RHN_TRANSOP_LABEL_UQ UNIQUE (LABEL);

--
-- 677. RHN_TRANSPACK_EID_NN  (Constraint) 
--
ALTER TABLE RHNTRANSACTIONPACKAGE ADD CONSTRAINT RHN_TRANSPACK_EID_NN CHECK ("EVR_ID" IS NOT NULL);

--
-- 678. RHN_TRANSPACK_ID_NN  (Constraint) 
--
ALTER TABLE RHNTRANSACTIONPACKAGE ADD CONSTRAINT RHN_TRANSPACK_ID_NN CHECK ("ID" IS NOT NULL);

--
-- 679. RHN_TRANSPACK_NID_NN  (Constraint) 
--
ALTER TABLE RHNTRANSACTIONPACKAGE ADD CONSTRAINT RHN_TRANSPACK_NID_NN CHECK ("NAME_ID" IS NOT NULL);

--
-- 680. RHN_TRANSPACK_OP_NN  (Constraint) 
--
ALTER TABLE RHNTRANSACTIONPACKAGE ADD CONSTRAINT RHN_TRANSPACK_OP_NN CHECK ("OPERATION" IS NOT NULL);

--
-- 681. RHN_TRANSPACK_PAID_NN  (Constraint) 
--
ALTER TABLE RHNTRANSACTIONPACKAGE ADD CONSTRAINT RHN_TRANSPACK_PAID_NN CHECK ("PACKAGE_ARCH_ID" IS NOT NULL);

--
-- 682. RHN_TRANSPACK_ID_PK  (Constraint) 
--
ALTER TABLE RHNTRANSACTIONPACKAGE ADD CONSTRAINT RHN_TRANSPACK_ID_PK PRIMARY KEY (ID);

--
-- 683. RHN_TRANSPACK_EID_FK  (Constraint) 
--
ALTER TABLE RHNTRANSACTIONPACKAGE ADD CONSTRAINT RHN_TRANSPACK_EID_FK FOREIGN KEY (EVR_ID) 
    REFERENCES RHNPACKAGEEVR (ID);

--
-- 684. RHN_TRANSPACK_NID_FK  (Constraint) 
--
ALTER TABLE RHNTRANSACTIONPACKAGE ADD CONSTRAINT RHN_TRANSPACK_NID_FK FOREIGN KEY (NAME_ID) 
    REFERENCES RHNPACKAGENAME (ID);

--
-- 685. RHN_TRANSPACK_OP_FK  (Constraint) 
--
ALTER TABLE RHNTRANSACTIONPACKAGE ADD CONSTRAINT RHN_TRANSPACK_OP_FK FOREIGN KEY (OPERATION) 
    REFERENCES RHNTRANSACTIONOPERATION (ID);

--
-- 686. RHN_TRANSPACK_PAID_FK  (Constraint) 
--
ALTER TABLE RHNTRANSACTIONPACKAGE ADD CONSTRAINT RHN_TRANSPACK_PAID_FK FOREIGN KEY (PACKAGE_ARCH_ID) 
    REFERENCES RHNPACKAGEARCH (ID);

--
-- 687. RHN_UM_STATUS_ID_NN  (Constraint) 
--
ALTER TABLE RHNUSERMESSAGESTATUS ADD CONSTRAINT RHN_UM_STATUS_ID_NN CHECK ("ID" IS NOT NULL);

--
-- 688. RHN_UM_STATUS_LABEL_NN  (Constraint) 
--
ALTER TABLE RHNUSERMESSAGESTATUS ADD CONSTRAINT RHN_UM_STATUS_LABEL_NN CHECK ("LABEL" IS NOT NULL);

--
-- 689. RHN_UM_STATUS_ID_PK  (Constraint) 
--
ALTER TABLE RHNUSERMESSAGESTATUS ADD CONSTRAINT RHN_UM_STATUS_ID_PK PRIMARY KEY (ID);

--
-- 690. RHN_UM_TYPE_ID_NN  (Constraint) 
--
ALTER TABLE RHNUSERMESSAGETYPE ADD CONSTRAINT RHN_UM_TYPE_ID_NN CHECK ("ID" IS NOT NULL);

--
-- 691. RHN_UM_TYPE_LABEL_NN  (Constraint) 
--
ALTER TABLE RHNUSERMESSAGETYPE ADD CONSTRAINT RHN_UM_TYPE_LABEL_NN CHECK ("LABEL" IS NOT NULL);

--
-- 692. RHN_UM_TYPE_NAME_NN  (Constraint) 
--
ALTER TABLE RHNUSERMESSAGETYPE ADD CONSTRAINT RHN_UM_TYPE_NAME_NN CHECK ("NAME" IS NOT NULL);

--
-- 693. RHN_UM_TYPE_PK  (Constraint) 
--
ALTER TABLE RHNUSERMESSAGETYPE ADD CONSTRAINT RHN_UM_TYPE_PK PRIMARY KEY (ID);

--
-- 694. RHN_USURVEYSTYPE_ID_NN  (Constraint) 
--
ALTER TABLE RHNUSERSURVEYSTATUSTYPE ADD CONSTRAINT RHN_USURVEYSTYPE_ID_NN CHECK ("ID" IS NOT NULL);

--
-- 695. RHN_USURVEYSTYPE_LABEL_NN  (Constraint) 
--
ALTER TABLE RHNUSERSURVEYSTATUSTYPE ADD CONSTRAINT RHN_USURVEYSTYPE_LABEL_NN CHECK ("LABEL" IS NOT NULL);

--
-- 696. RHN_USURVEYSTYPE_ID_PK  (Constraint) 
--
ALTER TABLE RHNUSERSURVEYSTATUSTYPE ADD CONSTRAINT RHN_USURVEYSTYPE_ID_PK PRIMARY KEY (ID);

--
-- 697. RHN_USURVEYSTYPE_LABEL_UQ  (Constraint) 
--
ALTER TABLE RHNUSERSURVEYSTATUSTYPE ADD CONSTRAINT RHN_USURVEYSTYPE_LABEL_UQ UNIQUE (LABEL);

--
-- 698. WEB_CUST_NOT_OID_NN  (Constraint) 
--
ALTER TABLE WEB_CUSTOMER_NOTIFICATION ADD CONSTRAINT WEB_CUST_NOT_OID_NN CHECK ("ORG_ID" IS NOT NULL);

--
-- 699. WEB_CUST_NOT_OID_FK  (Constraint) 
--
ALTER TABLE WEB_CUSTOMER_NOTIFICATION ADD CONSTRAINT WEB_CUST_NOT_OID_FK FOREIGN KEY (ORG_ID) 
    REFERENCES WEB_CUSTOMER (ID)
    ON DELETE CASCADE;

--
-- 700. RHN_BL_OBS_CREATED_NN  (Constraint) 
--
ALTER TABLE RHNBLACKLISTOBSOLETES ADD CONSTRAINT RHN_BL_OBS_CREATED_NN CHECK ("CREATED" IS NOT NULL);

--
-- 701. RHN_BL_OBS_EID_NN  (Constraint) 
--
ALTER TABLE RHNBLACKLISTOBSOLETES ADD CONSTRAINT RHN_BL_OBS_EID_NN CHECK ("EVR_ID" IS NOT NULL);

--
-- 702. RHN_BL_OBS_INID_NN  (Constraint) 
--
ALTER TABLE RHNBLACKLISTOBSOLETES ADD CONSTRAINT RHN_BL_OBS_INID_NN CHECK ("IGNORE_NAME_ID" IS NOT NULL);

--
-- 703. RHN_BL_OBS_MODIFIED_NN  (Constraint) 
--
ALTER TABLE RHNBLACKLISTOBSOLETES ADD CONSTRAINT RHN_BL_OBS_MODIFIED_NN CHECK ("MODIFIED" IS NOT NULL);

--
-- 704. RHN_BL_OBS_NID_NN  (Constraint) 
--
ALTER TABLE RHNBLACKLISTOBSOLETES ADD CONSTRAINT RHN_BL_OBS_NID_NN CHECK ("NAME_ID" IS NOT NULL);

--
-- 705. RHN_BL_OBS_PAID_NN  (Constraint) 
--
ALTER TABLE RHNBLACKLISTOBSOLETES ADD CONSTRAINT RHN_BL_OBS_PAID_NN CHECK ("PACKAGE_ARCH_ID" IS NOT NULL);

--
-- 706. RHN_BL_OBS_NEPI_UQ  (Constraint) 
--
ALTER TABLE RHNBLACKLISTOBSOLETES ADD CONSTRAINT RHN_BL_OBS_NEPI_UQ UNIQUE (NAME_ID, EVR_ID, PACKAGE_ARCH_ID, IGNORE_NAME_ID);

--
-- 707. RHN_BL_OBS_EID_FK  (Constraint) 
--
ALTER TABLE RHNBLACKLISTOBSOLETES ADD CONSTRAINT RHN_BL_OBS_EID_FK FOREIGN KEY (EVR_ID) 
    REFERENCES RHNPACKAGEEVR (ID);

--
-- 708. RHN_BL_OBS_INID_FK  (Constraint) 
--
ALTER TABLE RHNBLACKLISTOBSOLETES ADD CONSTRAINT RHN_BL_OBS_INID_FK FOREIGN KEY (IGNORE_NAME_ID) 
    REFERENCES RHNPACKAGENAME (ID);

--
-- 709. RHN_BL_OBS_NID_FK  (Constraint) 
--
ALTER TABLE RHNBLACKLISTOBSOLETES ADD CONSTRAINT RHN_BL_OBS_NID_FK FOREIGN KEY (NAME_ID) 
    REFERENCES RHNPACKAGENAME (ID);

--
-- 710. RHN_BL_OBS_PAID_FK  (Constraint) 
--
ALTER TABLE RHNBLACKLISTOBSOLETES ADD CONSTRAINT RHN_BL_OBS_PAID_FK FOREIGN KEY (PACKAGE_ARCH_ID) 
    REFERENCES RHNPACKAGEARCH (ID);

--
-- 711. RHN_CFL_CFID_NN  (Constraint) 
--
ALTER TABLE RHNCHANNELFAMILYLICENSE ADD CONSTRAINT RHN_CFL_CFID_NN CHECK ("CHANNEL_FAMILY_ID" IS NOT NULL);

--
-- 712. RHN_CFL_CREATED_NN  (Constraint) 
--
ALTER TABLE RHNCHANNELFAMILYLICENSE ADD CONSTRAINT RHN_CFL_CREATED_NN CHECK ("CREATED" IS NOT NULL);

--
-- 713. RHN_CFL_LICENSE_NN  (Constraint) 
--
ALTER TABLE RHNCHANNELFAMILYLICENSE ADD CONSTRAINT RHN_CFL_LICENSE_NN CHECK ("LICENSE_PATH" IS NOT NULL);

--
-- 714. RHN_CFL_MODIFIED_NN  (Constraint) 
--
ALTER TABLE RHNCHANNELFAMILYLICENSE ADD CONSTRAINT RHN_CFL_MODIFIED_NN CHECK ("MODIFIED" IS NOT NULL);

--
-- 715. RHN_CFL_CFID_FK  (Constraint) 
--
ALTER TABLE RHNCHANNELFAMILYLICENSE ADD CONSTRAINT RHN_CFL_CFID_FK FOREIGN KEY (CHANNEL_FAMILY_ID) 
    REFERENCES RHNCHANNELFAMILY (ID)
    ON DELETE CASCADE;

--
-- 716. RHN_CNP_AT_CALLER_NN  (Constraint) 
--
ALTER TABLE RHNCHANNELNEWESTPACKAGEAUDIT ADD CONSTRAINT RHN_CNP_AT_CALLER_NN CHECK ("CALLER" IS NOT NULL);

--
-- 717. RHN_CNP_AT_CID_NN  (Constraint) 
--
ALTER TABLE RHNCHANNELNEWESTPACKAGEAUDIT ADD CONSTRAINT RHN_CNP_AT_CID_NN CHECK ("CHANNEL_ID" IS NOT NULL);

--
-- 718. RHN_CNP_AT_RT_NN  (Constraint) 
--
ALTER TABLE RHNCHANNELNEWESTPACKAGEAUDIT ADD CONSTRAINT RHN_CNP_AT_RT_NN CHECK ("REFRESH_TIME" IS NOT NULL);

--
-- 719. RHN_CNP_AT_CID_FK  (Constraint) 
--
ALTER TABLE RHNCHANNELNEWESTPACKAGEAUDIT ADD CONSTRAINT RHN_CNP_AT_CID_FK FOREIGN KEY (CHANNEL_ID) 
    REFERENCES RHNCHANNEL (ID)
    ON DELETE CASCADE;

--
-- 720. RHN_CP_AC_CAID_NN  (Constraint) 
--
ALTER TABLE RHNCHANNELPACKAGEARCHCOMPAT ADD CONSTRAINT RHN_CP_AC_CAID_NN CHECK ("CHANNEL_ARCH_ID" IS NOT NULL);

--
-- 721. RHN_CP_AC_CREATED_NN  (Constraint) 
--
ALTER TABLE RHNCHANNELPACKAGEARCHCOMPAT ADD CONSTRAINT RHN_CP_AC_CREATED_NN CHECK ("CREATED" IS NOT NULL);

--
-- 722. RHN_CP_AC_MODIFIED_NN  (Constraint) 
--
ALTER TABLE RHNCHANNELPACKAGEARCHCOMPAT ADD CONSTRAINT RHN_CP_AC_MODIFIED_NN CHECK ("MODIFIED" IS NOT NULL);

--
-- 723. RHN_CP_AC_PAID_NN  (Constraint) 
--
ALTER TABLE RHNCHANNELPACKAGEARCHCOMPAT ADD CONSTRAINT RHN_CP_AC_PAID_NN CHECK ("PACKAGE_ARCH_ID" IS NOT NULL);

--
-- 724. RHN_CP_AC_CAID_PAID_UQ  (Constraint) 
--
ALTER TABLE RHNCHANNELPACKAGEARCHCOMPAT ADD CONSTRAINT RHN_CP_AC_CAID_PAID_UQ UNIQUE (CHANNEL_ARCH_ID, PACKAGE_ARCH_ID);

--
-- 725. RHN_CP_AC_CAID_FK  (Constraint) 
--
ALTER TABLE RHNCHANNELPACKAGEARCHCOMPAT ADD CONSTRAINT RHN_CP_AC_CAID_FK FOREIGN KEY (CHANNEL_ARCH_ID) 
    REFERENCES RHNCHANNELARCH (ID);

--
-- 726. RHN_CP_AC_PAID_FK  (Constraint) 
--
ALTER TABLE RHNCHANNELPACKAGEARCHCOMPAT ADD CONSTRAINT RHN_CP_AC_PAID_FK FOREIGN KEY (PACKAGE_ARCH_ID) 
    REFERENCES RHNPACKAGEARCH (ID);

--
-- 727. RHN_CHANNELREL_CREATED_NN  (Constraint) 
--
ALTER TABLE RHNCHANNELRELATIONSHIP ADD CONSTRAINT RHN_CHANNELREL_CREATED_NN CHECK ("CREATED" IS NOT NULL);

--
-- 728. RHN_CHANNELREL_FCID_NN  (Constraint) 
--
ALTER TABLE RHNCHANNELRELATIONSHIP ADD CONSTRAINT RHN_CHANNELREL_FCID_NN CHECK ("FROM_CHANNEL_ID" IS NOT NULL);

--
-- 729. RHN_CHANNELREL_MODIFIED_NN  (Constraint) 
--
ALTER TABLE RHNCHANNELRELATIONSHIP ADD CONSTRAINT RHN_CHANNELREL_MODIFIED_NN CHECK ("MODIFIED" IS NOT NULL);

--
-- 730. RHN_CHANNELREL_RTID_NN  (Constraint) 
--
ALTER TABLE RHNCHANNELRELATIONSHIP ADD CONSTRAINT RHN_CHANNELREL_RTID_NN CHECK ("REL_TYPE_ID" IS NOT NULL);

--
-- 731. RHN_CHANNELREL_TCID_NN  (Constraint) 
--
ALTER TABLE RHNCHANNELRELATIONSHIP ADD CONSTRAINT RHN_CHANNELREL_TCID_NN CHECK ("TO_CHANNEL_ID" IS NOT NULL);

--
-- 732. RHN_CHANNELREL_FCID_TCID_UQ  (Constraint) 
--
ALTER TABLE RHNCHANNELRELATIONSHIP ADD CONSTRAINT RHN_CHANNELREL_FCID_TCID_UQ UNIQUE (FROM_CHANNEL_ID, TO_CHANNEL_ID);

--
-- 733. RHN_CHANNELREL_FCID_FK  (Constraint) 
--
ALTER TABLE RHNCHANNELRELATIONSHIP ADD CONSTRAINT RHN_CHANNELREL_FCID_FK FOREIGN KEY (FROM_CHANNEL_ID) 
    REFERENCES RHNCHANNEL (ID)
    ON DELETE CASCADE;

--
-- 734. RHN_CHANNELREL_RTID_FK  (Constraint) 
--
ALTER TABLE RHNCHANNELRELATIONSHIP ADD CONSTRAINT RHN_CHANNELREL_RTID_FK FOREIGN KEY (REL_TYPE_ID) 
    REFERENCES RHNRELATIONSHIPTYPE (ID);

--
-- 735. RHN_CHANNELREL_TCID_FK  (Constraint) 
--
ALTER TABLE RHNCHANNELRELATIONSHIP ADD CONSTRAINT RHN_CHANNELREL_TCID_FK FOREIGN KEY (TO_CHANNEL_ID) 
    REFERENCES RHNCHANNEL (ID)
    ON DELETE CASCADE;

--
-- 736. RHN_DSQUEUE_CREATED_NN  (Constraint) 
--
ALTER TABLE RHNDAILYSUMMARYQUEUE ADD CONSTRAINT RHN_DSQUEUE_CREATED_NN CHECK ("CREATED" IS NOT NULL);

--
-- 737. RHN_DSQUEUE_MODIFIED_NN  (Constraint) 
--
ALTER TABLE RHNDAILYSUMMARYQUEUE ADD CONSTRAINT RHN_DSQUEUE_MODIFIED_NN CHECK ("MODIFIED" IS NOT NULL);

--
-- 738. RHN_DSQUEUE_OID_NN  (Constraint) 
--
ALTER TABLE RHNDAILYSUMMARYQUEUE ADD CONSTRAINT RHN_DSQUEUE_OID_NN CHECK ("ORG_ID" IS NOT NULL);

--
-- 739. RHN_DSQUEUE_OID_UQ  (Constraint) 
--
ALTER TABLE RHNDAILYSUMMARYQUEUE ADD CONSTRAINT RHN_DSQUEUE_OID_UQ UNIQUE (ORG_ID);

--
-- 740. RHN_DSQUEUE_OID_FK  (Constraint) 
--
ALTER TABLE RHNDAILYSUMMARYQUEUE ADD CONSTRAINT RHN_DSQUEUE_OID_FK FOREIGN KEY (ORG_ID) 
    REFERENCES WEB_CUSTOMER (ID);

--
-- 741. RHN_ERRATAFILE_CREATED_NN  (Constraint) 
--
ALTER TABLE RHNERRATAFILE ADD CONSTRAINT RHN_ERRATAFILE_CREATED_NN CHECK ("CREATED" IS NOT NULL);

--
-- 742. RHN_ERRATAFILE_ERRATA_NN  (Constraint) 
--
ALTER TABLE RHNERRATAFILE ADD CONSTRAINT RHN_ERRATAFILE_ERRATA_NN CHECK ("ERRATA_ID" IS NOT NULL);

--
-- 743. RHN_ERRATAFILE_ID_NN  (Constraint) 
--
ALTER TABLE RHNERRATAFILE ADD CONSTRAINT RHN_ERRATAFILE_ID_NN CHECK ("ID" IS NOT NULL);

--
-- 744. RHN_ERRATAFILE_MD5_NN  (Constraint) 
--
ALTER TABLE RHNERRATAFILE ADD CONSTRAINT RHN_ERRATAFILE_MD5_NN CHECK ("MD5SUM" IS NOT NULL);

--
-- 745. RHN_ERRATAFILE_MODIFIED_NN  (Constraint) 
--
ALTER TABLE RHNERRATAFILE ADD CONSTRAINT RHN_ERRATAFILE_MODIFIED_NN CHECK ("MODIFIED" IS NOT NULL);

--
-- 746. RHN_ERRATAFILE_NAME_NN  (Constraint) 
--
ALTER TABLE RHNERRATAFILE ADD CONSTRAINT RHN_ERRATAFILE_NAME_NN CHECK ("FILENAME" IS NOT NULL);

--
-- 747. RHN_ERRATAFILE_TYPE_NN  (Constraint) 
--
ALTER TABLE RHNERRATAFILE ADD CONSTRAINT RHN_ERRATAFILE_TYPE_NN CHECK ("TYPE" IS NOT NULL);

--
-- 748. RHN_ERRATAFILE_ID_PK  (Constraint) 
--
ALTER TABLE RHNERRATAFILE ADD CONSTRAINT RHN_ERRATAFILE_ID_PK PRIMARY KEY (ID);

--
-- 749. RHN_ERRATAFILE_EID_FILE_UQ  (Constraint) 
--
ALTER TABLE RHNERRATAFILE ADD CONSTRAINT RHN_ERRATAFILE_EID_FILE_UQ UNIQUE (ERRATA_ID, FILENAME);

--
-- 750. RHN_ERRATAFILE_ERRATA_FK  (Constraint) 
--
ALTER TABLE RHNERRATAFILE ADD CONSTRAINT RHN_ERRATAFILE_ERRATA_FK FOREIGN KEY (ERRATA_ID) 
    REFERENCES RHNERRATA (ID);

--
-- 751. RHN_ERRATAFILE_TYPE_FK  (Constraint) 
--
ALTER TABLE RHNERRATAFILE ADD CONSTRAINT RHN_ERRATAFILE_TYPE_FK FOREIGN KEY (TYPE) 
    REFERENCES RHNERRATAFILETYPE (ID);

--
-- 752. RHN_EFILEC_CID_NN  (Constraint) 
--
ALTER TABLE RHNERRATAFILECHANNEL ADD CONSTRAINT RHN_EFILEC_CID_NN CHECK ("CHANNEL_ID" IS NOT NULL);

--
-- 753. RHN_EFILEC_CREATED_NN  (Constraint) 
--
ALTER TABLE RHNERRATAFILECHANNEL ADD CONSTRAINT RHN_EFILEC_CREATED_NN CHECK ("CREATED" IS NOT NULL);

--
-- 754. RHN_EFILEC_EID_NN  (Constraint) 
--
ALTER TABLE RHNERRATAFILECHANNEL ADD CONSTRAINT RHN_EFILEC_EID_NN CHECK ("ERRATA_FILE_ID" IS NOT NULL);

--
-- 755. RHN_EFILEC_MODIFIED_NN  (Constraint) 
--
ALTER TABLE RHNERRATAFILECHANNEL ADD CONSTRAINT RHN_EFILEC_MODIFIED_NN CHECK ("MODIFIED" IS NOT NULL);

--
-- 756. RHN_EFILEC_EFID_CID_UQ  (Constraint) 
--
ALTER TABLE RHNERRATAFILECHANNEL ADD CONSTRAINT RHN_EFILEC_EFID_CID_UQ UNIQUE (ERRATA_FILE_ID, CHANNEL_ID);

--
-- 757. RHN_EFILEC_CID_FK  (Constraint) 
--
ALTER TABLE RHNERRATAFILECHANNEL ADD CONSTRAINT RHN_EFILEC_CID_FK FOREIGN KEY (CHANNEL_ID) 
    REFERENCES RHNCHANNEL (ID)
    ON DELETE CASCADE;

--
-- 758. RHN_EFILEC_EID_FK  (Constraint) 
--
ALTER TABLE RHNERRATAFILECHANNEL ADD CONSTRAINT RHN_EFILEC_EID_FK FOREIGN KEY (ERRATA_FILE_ID) 
    REFERENCES RHNERRATAFILE (ID)
    ON DELETE CASCADE;

--
-- 759. RHN_ENQUEUE_CREATED_NN  (Constraint) 
--
ALTER TABLE RHNERRATANOTIFICATIONQUEUE ADD CONSTRAINT RHN_ENQUEUE_CREATED_NN CHECK ("CREATED" IS NOT NULL);

--
-- 760. RHN_ENQUEUE_EID_NN  (Constraint) 
--
ALTER TABLE RHNERRATANOTIFICATIONQUEUE ADD CONSTRAINT RHN_ENQUEUE_EID_NN CHECK ("ERRATA_ID" IS NOT NULL);

--
-- 761. RHN_ENQUEUE_MODIFIED_NN  (Constraint) 
--
ALTER TABLE RHNERRATANOTIFICATIONQUEUE ADD CONSTRAINT RHN_ENQUEUE_MODIFIED_NN CHECK ("MODIFIED" IS NOT NULL);

--
-- 762. RHN_ENQUEUE_OID_NN  (Constraint) 
--
ALTER TABLE RHNERRATANOTIFICATIONQUEUE ADD CONSTRAINT RHN_ENQUEUE_OID_NN CHECK ("ORG_ID" IS NOT NULL);

--
-- 763. RHN_ENQUEUE_EOID_UQ  (Constraint) 
--
ALTER TABLE RHNERRATANOTIFICATIONQUEUE ADD CONSTRAINT RHN_ENQUEUE_EOID_UQ UNIQUE (ERRATA_ID, ORG_ID);

--
-- 764. RHN_ENQUEUE_EID_FK  (Constraint) 
--
ALTER TABLE RHNERRATANOTIFICATIONQUEUE ADD CONSTRAINT RHN_ENQUEUE_EID_FK FOREIGN KEY (ERRATA_ID) 
    REFERENCES RHNERRATA (ID);

--
-- 765. RHN_ENQUEUE_OID_FK  (Constraint) 
--
ALTER TABLE RHNERRATANOTIFICATIONQUEUE ADD CONSTRAINT RHN_ENQUEUE_OID_FK FOREIGN KEY (ORG_ID) 
    REFERENCES WEB_CUSTOMER (ID)
    ON DELETE CASCADE;

--
-- 766. RHN_EQUEUE_CREATED_NN  (Constraint) 
--
ALTER TABLE RHNERRATAQUEUE ADD CONSTRAINT RHN_EQUEUE_CREATED_NN CHECK ("CREATED" IS NOT NULL);

--
-- 767. RHN_EQUEUE_EID_NN  (Constraint) 
--
ALTER TABLE RHNERRATAQUEUE ADD CONSTRAINT RHN_EQUEUE_EID_NN CHECK ("ERRATA_ID" IS NOT NULL);

--
-- 768. RHN_EQUEUE_MODIFIED_NN  (Constraint) 
--
ALTER TABLE RHNERRATAQUEUE ADD CONSTRAINT RHN_EQUEUE_MODIFIED_NN CHECK ("MODIFIED" IS NOT NULL);

--
-- 769. RHN_EQUEUE_EOID_UQ  (Constraint) 
--
ALTER TABLE RHNERRATAQUEUE ADD CONSTRAINT RHN_EQUEUE_EOID_UQ UNIQUE (ERRATA_ID);

--
-- 770. RHN_EQUEUE_EID_FK  (Constraint) 
--
ALTER TABLE RHNERRATAQUEUE ADD CONSTRAINT RHN_EQUEUE_EID_FK FOREIGN KEY (ERRATA_ID) 
    REFERENCES RHNERRATA (ID);

--
-- 771. RHN_ERRATAREL_CREATED_NN  (Constraint) 
--
ALTER TABLE RHNERRATARELATIONSHIP ADD CONSTRAINT RHN_ERRATAREL_CREATED_NN CHECK ("CREATED" IS NOT NULL);

--
-- 772. RHN_ERRATAREL_FEID_NN  (Constraint) 
--
ALTER TABLE RHNERRATARELATIONSHIP ADD CONSTRAINT RHN_ERRATAREL_FEID_NN CHECK ("FROM_ERRATA_ID" IS NOT NULL);

--
-- 773. RHN_ERRATAREL_MODIFIED_NN  (Constraint) 
--
ALTER TABLE RHNERRATARELATIONSHIP ADD CONSTRAINT RHN_ERRATAREL_MODIFIED_NN CHECK ("MODIFIED" IS NOT NULL);

--
-- 774. RHN_ERRATAREL_RTID_NN  (Constraint) 
--
ALTER TABLE RHNERRATARELATIONSHIP ADD CONSTRAINT RHN_ERRATAREL_RTID_NN CHECK ("REL_TYPE_ID" IS NOT NULL);

--
-- 775. RHN_ERRATAREL_TEID_NN  (Constraint) 
--
ALTER TABLE RHNERRATARELATIONSHIP ADD CONSTRAINT RHN_ERRATAREL_TEID_NN CHECK ("TO_ERRATA_ID" IS NOT NULL);

--
-- 776. RHN_ERRATAREL_FEID_TEID_UQ  (Constraint) 
--
ALTER TABLE RHNERRATARELATIONSHIP ADD CONSTRAINT RHN_ERRATAREL_FEID_TEID_UQ UNIQUE (FROM_ERRATA_ID, TO_ERRATA_ID);

--
-- 777. RHN_ERRATAREL_FEID_FK  (Constraint) 
--
ALTER TABLE RHNERRATARELATIONSHIP ADD CONSTRAINT RHN_ERRATAREL_FEID_FK FOREIGN KEY (FROM_ERRATA_ID) 
    REFERENCES RHNERRATA (ID)
    ON DELETE CASCADE;

--
-- 778. RHN_ERRATAREL_RTID_FK  (Constraint) 
--
ALTER TABLE RHNERRATARELATIONSHIP ADD CONSTRAINT RHN_ERRATAREL_RTID_FK FOREIGN KEY (REL_TYPE_ID) 
    REFERENCES RHNRELATIONSHIPTYPE (ID);

--
-- 779. RHN_ERRATAREL_TEID_FK  (Constraint) 
--
ALTER TABLE RHNERRATARELATIONSHIP ADD CONSTRAINT RHN_ERRATAREL_TEID_FK FOREIGN KEY (TO_ERRATA_ID) 
    REFERENCES RHNERRATA (ID)
    ON DELETE CASCADE;

--
-- 780. RHN_FILELOC_FID_NN  (Constraint) 
--
ALTER TABLE RHNFILELOCATION ADD CONSTRAINT RHN_FILELOC_FID_NN CHECK ("FILE_ID" IS NOT NULL);

--
-- 781. RHN_FILELOC_LOC_NN  (Constraint) 
--
ALTER TABLE RHNFILELOCATION ADD CONSTRAINT RHN_FILELOC_LOC_NN CHECK ("LOCATION" IS NOT NULL);

--
-- 782. RHN_FILELOC_FID_FK  (Constraint) 
--
ALTER TABLE RHNFILELOCATION ADD CONSTRAINT RHN_FILELOC_FID_FK FOREIGN KEY (FILE_ID) 
    REFERENCES RHNFILE (ID);

--
-- 783. RHN_HW_CID_NN  (Constraint) 
--
ALTER TABLE RHNHARDWARE ADD CONSTRAINT RHN_HW_CID_NN CHECK ("CLASS_ID" IS NOT NULL);

--
-- 784. RHN_HW_ID_NN  (Constraint) 
--
ALTER TABLE RHNHARDWARE ADD CONSTRAINT RHN_HW_ID_NN CHECK ("ID" IS NOT NULL);

--
-- 785. RHN_HW_ID_PK  (Constraint) 
--
ALTER TABLE RHNHARDWARE ADD CONSTRAINT RHN_HW_ID_PK PRIMARY KEY (ID);

--
-- 786. RHN_HW_CID_FK  (Constraint) 
--
ALTER TABLE RHNHARDWARE ADD CONSTRAINT RHN_HW_CID_FK FOREIGN KEY (CLASS_ID) 
    REFERENCES RHNHARDWARECLASS (ID);

--
-- 787. RHN_HWPROPS_HID_NN  (Constraint) 
--
ALTER TABLE RHNHARDWAREPROPERTIES ADD CONSTRAINT RHN_HWPROPS_HID_NN CHECK ("HARDWARE_ID" IS NOT NULL);

--
-- 788. RHN_HWPROPS_NID_NN  (Constraint) 
--
ALTER TABLE RHNHARDWAREPROPERTIES ADD CONSTRAINT RHN_HWPROPS_NID_NN CHECK ("NAME_ID" IS NOT NULL);

--
-- 789. RHN_HWPROPS_VID_NN  (Constraint) 
--
ALTER TABLE RHNHARDWAREPROPERTIES ADD CONSTRAINT RHN_HWPROPS_VID_NN CHECK ("VALUE_ID" IS NOT NULL);

--
-- 790. RHN_HWPROPS_HID_FK  (Constraint) 
--
ALTER TABLE RHNHARDWAREPROPERTIES ADD CONSTRAINT RHN_HWPROPS_HID_FK FOREIGN KEY (HARDWARE_ID) 
    REFERENCES RHNHARDWARE (ID);

--
-- 791. RHN_HWPROPS_NID_FK  (Constraint) 
--
ALTER TABLE RHNHARDWAREPROPERTIES ADD CONSTRAINT RHN_HWPROPS_NID_FK FOREIGN KEY (NAME_ID) 
    REFERENCES RHNHARDWAREPROPNAME (ID);

--
-- 792. RHN_HWPROPS_VID_FK  (Constraint) 
--
ALTER TABLE RHNHARDWAREPROPERTIES ADD CONSTRAINT RHN_HWPROPS_VID_FK FOREIGN KEY (VALUE_ID) 
    REFERENCES RHNHARDWAREPROPVALUE (ID);

--
-- 793. RHN_M_CREATED_NN  (Constraint) 
--
ALTER TABLE RHNMESSAGE ADD CONSTRAINT RHN_M_CREATED_NN CHECK ("CREATED" IS NOT NULL);

--
-- 794. RHN_M_ID_NN  (Constraint) 
--
ALTER TABLE RHNMESSAGE ADD CONSTRAINT RHN_M_ID_NN CHECK ("ID" IS NOT NULL);

--
-- 795. RHN_M_MODIFIED_NN  (Constraint) 
--
ALTER TABLE RHNMESSAGE ADD CONSTRAINT RHN_M_MODIFIED_NN CHECK ("MODIFIED" IS NOT NULL);

--
-- 796. RHN_M_MT_NN  (Constraint) 
--
ALTER TABLE RHNMESSAGE ADD CONSTRAINT RHN_M_MT_NN CHECK ("MESSAGE_TYPE" IS NOT NULL);

--
-- 797. RHN_M_PRIORITY_NN  (Constraint) 
--
ALTER TABLE RHNMESSAGE ADD CONSTRAINT RHN_M_PRIORITY_NN CHECK ("PRIORITY" IS NOT NULL);

--
-- 798. RHN_M_ID_PK  (Constraint) 
--
ALTER TABLE RHNMESSAGE ADD CONSTRAINT RHN_M_ID_PK PRIMARY KEY (ID);

--
-- 799. RHN_M_MT_FK  (Constraint) 
--
ALTER TABLE RHNMESSAGE ADD CONSTRAINT RHN_M_MT_FK FOREIGN KEY (MESSAGE_TYPE) 
    REFERENCES RHNMESSAGETYPE (ID);

--
-- 800. RHN_M_PRIORITY_FK  (Constraint) 
--
ALTER TABLE RHNMESSAGE ADD CONSTRAINT RHN_M_PRIORITY_FK FOREIGN KEY (PRIORITY) 
    REFERENCES RHNMESSAGEPRIORITY (ID);

--
-- 801. RHN_OSTATE_CREATED_NN  (Constraint) 
--
ALTER TABLE RHNORGSTATE ADD CONSTRAINT RHN_OSTATE_CREATED_NN CHECK ("CREATED" IS NOT NULL);

--
-- 802. RHN_OSTATE_MODIFIED_NN  (Constraint) 
--
ALTER TABLE RHNORGSTATE ADD CONSTRAINT RHN_OSTATE_MODIFIED_NN CHECK ("MODIFIED" IS NOT NULL);

--
-- 803. RHN_OSTATE_OID_NN  (Constraint) 
--
ALTER TABLE RHNORGSTATE ADD CONSTRAINT RHN_OSTATE_OID_NN CHECK ("ORG_ID" IS NOT NULL);

--
-- 804. RHN_OSTATE_SID_NN  (Constraint) 
--
ALTER TABLE RHNORGSTATE ADD CONSTRAINT RHN_OSTATE_SID_NN CHECK ("STATE_ID" IS NOT NULL);

--
-- 805. RHN_OSTATE_OID_UQ  (Constraint) 
--
ALTER TABLE RHNORGSTATE ADD CONSTRAINT RHN_OSTATE_OID_UQ UNIQUE (ORG_ID);

--
-- 806. RHN_OSTATE_OID_FK  (Constraint) 
--
ALTER TABLE RHNORGSTATE ADD CONSTRAINT RHN_OSTATE_OID_FK FOREIGN KEY (ORG_ID) 
    REFERENCES WEB_CUSTOMER (ID)
    ON DELETE CASCADE;

--
-- 807. RHN_OSTATE_SID_FK  (Constraint) 
--
ALTER TABLE RHNORGSTATE ADD CONSTRAINT RHN_OSTATE_SID_FK FOREIGN KEY (STATE_ID) 
    REFERENCES RHNORGAVAILABLESTATES (ID);

--
-- 808. RHN_OSTATELOG_CREATED_NN  (Constraint) 
--
ALTER TABLE RHNORGSTATELOG ADD CONSTRAINT RHN_OSTATELOG_CREATED_NN CHECK ("CREATED" IS NOT NULL);

--
-- 809. RHN_OSTATELOG_NSID_NN  (Constraint) 
--
ALTER TABLE RHNORGSTATELOG ADD CONSTRAINT RHN_OSTATELOG_NSID_NN CHECK ("NEW_STATE_ID" IS NOT NULL);

--
-- 810. RHN_OSTATELOG_OID_NN  (Constraint) 
--
ALTER TABLE RHNORGSTATELOG ADD CONSTRAINT RHN_OSTATELOG_OID_NN CHECK ("ORG_ID" IS NOT NULL);

--
-- 811. RHN_OSTATELOG_OSID_NN  (Constraint) 
--
ALTER TABLE RHNORGSTATELOG ADD CONSTRAINT RHN_OSTATELOG_OSID_NN CHECK ("OLD_STATE_ID" IS NOT NULL);

--
-- 812. RHN_OSTATELOG_NSID_FK  (Constraint) 
--
ALTER TABLE RHNORGSTATELOG ADD CONSTRAINT RHN_OSTATELOG_NSID_FK FOREIGN KEY (NEW_STATE_ID) 
    REFERENCES RHNORGAVAILABLESTATES (ID);

--
-- 813. RHN_OSTATELOG_OID_FK  (Constraint) 
--
ALTER TABLE RHNORGSTATELOG ADD CONSTRAINT RHN_OSTATELOG_OID_FK FOREIGN KEY (ORG_ID) 
    REFERENCES WEB_CUSTOMER (ID)
    ON DELETE CASCADE;

--
-- 814. RHN_OSTATELOG_OSID_FK  (Constraint) 
--
ALTER TABLE RHNORGSTATELOG ADD CONSTRAINT RHN_OSTATELOG_OSID_FK FOREIGN KEY (OLD_STATE_ID) 
    REFERENCES RHNORGAVAILABLESTATES (ID);

--
-- 815. RHN_PLCONV_CREATED_NN  (Constraint) 
--
ALTER TABLE RHNPAYLOADERCONVERSION ADD CONSTRAINT RHN_PLCONV_CREATED_NN CHECK ("CREATED" IS NOT NULL);

--
-- 816. RHN_PLCONV_OID_NN  (Constraint) 
--
ALTER TABLE RHNPAYLOADERCONVERSION ADD CONSTRAINT RHN_PLCONV_OID_NN CHECK ("ORG_ID" IS NOT NULL);

--
-- 817. RHN_PLCONV_REASON_NN  (Constraint) 
--
ALTER TABLE RHNPAYLOADERCONVERSION ADD CONSTRAINT RHN_PLCONV_REASON_NN CHECK ("REASON" IS NOT NULL);

--
-- 818. RHN_PLCONV_OID_FK  (Constraint) 
--
ALTER TABLE RHNPAYLOADERCONVERSION ADD CONSTRAINT RHN_PLCONV_OID_FK FOREIGN KEY (ORG_ID) 
    REFERENCES WEB_CUSTOMER (ID)
    ON DELETE CASCADE;

--
-- 819. RHN_PRODUCT_CAT_NN  (Constraint) 
--
ALTER TABLE RHNPRODUCT ADD CONSTRAINT RHN_PRODUCT_CAT_NN CHECK ("PRODUCT_LINE_ID" IS NOT NULL);

--
-- 820. RHN_PRODUCT_CREATED_NN  (Constraint) 
--
ALTER TABLE RHNPRODUCT ADD CONSTRAINT RHN_PRODUCT_CREATED_NN CHECK ("CREATED" IS NOT NULL);

--
-- 821. RHN_PRODUCT_ID_NN  (Constraint) 
--
ALTER TABLE RHNPRODUCT ADD CONSTRAINT RHN_PRODUCT_ID_NN CHECK ("ID" IS NOT NULL);

--
-- 822. RHN_PRODUCT_LABEL_NN  (Constraint) 
--
ALTER TABLE RHNPRODUCT ADD CONSTRAINT RHN_PRODUCT_LABEL_NN CHECK ("LABEL" IS NOT NULL);

--
-- 823. RHN_PRODUCT_LM_NN  (Constraint) 
--
ALTER TABLE RHNPRODUCT ADD CONSTRAINT RHN_PRODUCT_LM_NN CHECK ("LAST_MODIFIED" IS NOT NULL);

--
-- 824. RHN_PRODUCT_MODIFIED_NN  (Constraint) 
--
ALTER TABLE RHNPRODUCT ADD CONSTRAINT RHN_PRODUCT_MODIFIED_NN CHECK ("MODIFIED" IS NOT NULL);

--
-- 825. RHN_PRODUCT_NAME_NN  (Constraint) 
--
ALTER TABLE RHNPRODUCT ADD CONSTRAINT RHN_PRODUCT_NAME_NN CHECK ("NAME" IS NOT NULL);

--
-- 826. RHN_PRODUCT_ID_PK  (Constraint) 
--
ALTER TABLE RHNPRODUCT ADD CONSTRAINT RHN_PRODUCT_ID_PK PRIMARY KEY (ID);

--
-- 827. RHN_PRODUCT_LABEL_UQ  (Constraint) 
--
ALTER TABLE RHNPRODUCT ADD CONSTRAINT RHN_PRODUCT_LABEL_UQ UNIQUE (LABEL);

--
-- 828. RHN_PRODUCT_NAME_UQ  (Constraint) 
--
ALTER TABLE RHNPRODUCT ADD CONSTRAINT RHN_PRODUCT_NAME_UQ UNIQUE (NAME);

--
-- 829. RHN_PRODUCT_CAT_FK  (Constraint) 
--
ALTER TABLE RHNPRODUCT ADD CONSTRAINT RHN_PRODUCT_CAT_FK FOREIGN KEY (PRODUCT_LINE_ID) 
    REFERENCES RHNPRODUCTLINE (ID)
    ON DELETE CASCADE;

--
-- 830. RHN_PC_CID_NN  (Constraint) 
--
ALTER TABLE RHNPRODUCTCHANNEL ADD CONSTRAINT RHN_PC_CID_NN CHECK ("CHANNEL_ID" IS NOT NULL);

--
-- 831. RHN_PC_CREATED_NN  (Constraint) 
--
ALTER TABLE RHNPRODUCTCHANNEL ADD CONSTRAINT RHN_PC_CREATED_NN CHECK ("CREATED" IS NOT NULL);

--
-- 832. RHN_PC_MODIFIED_NN  (Constraint) 
--
ALTER TABLE RHNPRODUCTCHANNEL ADD CONSTRAINT RHN_PC_MODIFIED_NN CHECK ("MODIFIED" IS NOT NULL);

--
-- 833. RHN_PC_PID_NN  (Constraint) 
--
ALTER TABLE RHNPRODUCTCHANNEL ADD CONSTRAINT RHN_PC_PID_NN CHECK ("PRODUCT_ID" IS NOT NULL);

--
-- 834. RHN_PC_CID_PID_IDX  (Constraint) 
--
ALTER TABLE RHNPRODUCTCHANNEL ADD CONSTRAINT RHN_PC_CID_PID_IDX UNIQUE (CHANNEL_ID, PRODUCT_ID);

--
-- 835. RHN_PC_CID_FK  (Constraint) 
--
ALTER TABLE RHNPRODUCTCHANNEL ADD CONSTRAINT RHN_PC_CID_FK FOREIGN KEY (CHANNEL_ID) 
    REFERENCES RHNCHANNEL (ID)
    ON DELETE CASCADE;

--
-- 836. RHN_PC_PID_FK  (Constraint) 
--
ALTER TABLE RHNPRODUCTCHANNEL ADD CONSTRAINT RHN_PC_PID_FK FOREIGN KEY (PRODUCT_ID) 
    REFERENCES RHNPRODUCT (ID);

--
-- 837. RHN_TM_CREATED_NN  (Constraint) 
--
ALTER TABLE RHNTEXTMESSAGE ADD CONSTRAINT RHN_TM_CREATED_NN CHECK ("CREATED" IS NOT NULL);

--
-- 838. RHN_TM_MESSAGE_BODY_NN  (Constraint) 
--
ALTER TABLE RHNTEXTMESSAGE ADD CONSTRAINT RHN_TM_MESSAGE_BODY_NN CHECK ("MESSAGE_BODY" IS NOT NULL);

--
-- 839. RHN_TM_MESSAGE_ID_NN  (Constraint) 
--
ALTER TABLE RHNTEXTMESSAGE ADD CONSTRAINT RHN_TM_MESSAGE_ID_NN CHECK ("MESSAGE_ID" IS NOT NULL);

--
-- 840. RHN_TM_MODIFIED_NN  (Constraint) 
--
ALTER TABLE RHNTEXTMESSAGE ADD CONSTRAINT RHN_TM_MODIFIED_NN CHECK ("MODIFIED" IS NOT NULL);

--
-- 841. RHN_TM_MESSAGE_ID_FK  (Constraint) 
--
ALTER TABLE RHNTEXTMESSAGE ADD CONSTRAINT RHN_TM_MESSAGE_ID_FK FOREIGN KEY (MESSAGE_ID) 
    REFERENCES RHNMESSAGE (ID)
    ON DELETE CASCADE;

--
-- 842. RHN_CNP_CID_NN  (Constraint) 
--
ALTER TABLE RHNCHANNELNEWESTPACKAGE ADD CONSTRAINT RHN_CNP_CID_NN CHECK ("CHANNEL_ID" IS NOT NULL);

--
-- 843. RHN_CNP_EID_NN  (Constraint) 
--
ALTER TABLE RHNCHANNELNEWESTPACKAGE ADD CONSTRAINT RHN_CNP_EID_NN CHECK ("EVR_ID" IS NOT NULL);

--
-- 844. RHN_CNP_NID_NN  (Constraint) 
--
ALTER TABLE RHNCHANNELNEWESTPACKAGE ADD CONSTRAINT RHN_CNP_NID_NN CHECK ("NAME_ID" IS NOT NULL);

--
-- 845. RHN_CNP_PAID_NN  (Constraint) 
--
ALTER TABLE RHNCHANNELNEWESTPACKAGE ADD CONSTRAINT RHN_CNP_PAID_NN CHECK ("PACKAGE_ARCH_ID" IS NOT NULL);

--
-- 846. RHN_CNP_PID_NN  (Constraint) 
--
ALTER TABLE RHNCHANNELNEWESTPACKAGE ADD CONSTRAINT RHN_CNP_PID_NN CHECK ("PACKAGE_ID" IS NOT NULL);

--
-- 847. RHN_CNP_CID_NID_UQ  (Constraint) 
--
ALTER TABLE RHNCHANNELNEWESTPACKAGE ADD CONSTRAINT RHN_CNP_CID_NID_UQ UNIQUE (CHANNEL_ID, NAME_ID, PACKAGE_ARCH_ID);

--
-- 848. RHN_CNP_CID_FK  (Constraint) 
--
ALTER TABLE RHNCHANNELNEWESTPACKAGE ADD CONSTRAINT RHN_CNP_CID_FK FOREIGN KEY (CHANNEL_ID) 
    REFERENCES RHNCHANNEL (ID)
    ON DELETE CASCADE;

--
-- 849. RHN_CNP_EID_FK  (Constraint) 
--
ALTER TABLE RHNCHANNELNEWESTPACKAGE ADD CONSTRAINT RHN_CNP_EID_FK FOREIGN KEY (EVR_ID) 
    REFERENCES RHNPACKAGEEVR (ID);

--
-- 850. RHN_CNP_NID_FK  (Constraint) 
--
ALTER TABLE RHNCHANNELNEWESTPACKAGE ADD CONSTRAINT RHN_CNP_NID_FK FOREIGN KEY (NAME_ID) 
    REFERENCES RHNPACKAGENAME (ID);

--
-- 851. RHN_CNP_PAID_FK  (Constraint) 
--
ALTER TABLE RHNCHANNELNEWESTPACKAGE ADD CONSTRAINT RHN_CNP_PAID_FK FOREIGN KEY (PACKAGE_ARCH_ID) 
    REFERENCES RHNPACKAGEARCH (ID);

--
-- 852. RHN_CNP_PID_FK  (Constraint) 
--
ALTER TABLE RHNCHANNELNEWESTPACKAGE ADD CONSTRAINT RHN_CNP_PID_FK FOREIGN KEY (PACKAGE_ID) 
    REFERENCES RHNPACKAGE (ID)
    ON DELETE CASCADE;

--
-- 853. RHN_EADDRESS_A_NN  (Constraint) 
--
ALTER TABLE RHNEMAILADDRESS ADD CONSTRAINT RHN_EADDRESS_A_NN CHECK ("ADDRESS" IS NOT NULL);

--
-- 854. RHN_EADDRESS_CREATED_NN  (Constraint) 
--
ALTER TABLE RHNEMAILADDRESS ADD CONSTRAINT RHN_EADDRESS_CREATED_NN CHECK ("CREATED" IS NOT NULL);

--
-- 855. RHN_EADDRESS_ID_NN  (Constraint) 
--
ALTER TABLE RHNEMAILADDRESS ADD CONSTRAINT RHN_EADDRESS_ID_NN CHECK ("ID" IS NOT NULL);

--
-- 856. RHN_EADDRESS_MODIFIED_NN  (Constraint) 
--
ALTER TABLE RHNEMAILADDRESS ADD CONSTRAINT RHN_EADDRESS_MODIFIED_NN CHECK ("MODIFIED" IS NOT NULL);

--
-- 857. RHN_EADDRESS_SID_NN  (Constraint) 
--
ALTER TABLE RHNEMAILADDRESS ADD CONSTRAINT RHN_EADDRESS_SID_NN CHECK ("STATE_ID" IS NOT NULL);

--
-- 858. RHN_EADDRESS_UID_NN  (Constraint) 
--
ALTER TABLE RHNEMAILADDRESS ADD CONSTRAINT RHN_EADDRESS_UID_NN CHECK ("USER_ID" IS NOT NULL);

--
-- 859. RHN_EADDRESS_ID_PK  (Constraint) 
--
ALTER TABLE RHNEMAILADDRESS ADD CONSTRAINT RHN_EADDRESS_ID_PK PRIMARY KEY (ID);

--
-- 860. RHN_EADDRESS_UID_SID_UQ  (Constraint) 
--
ALTER TABLE RHNEMAILADDRESS ADD CONSTRAINT RHN_EADDRESS_UID_SID_UQ UNIQUE (USER_ID, STATE_ID);

--
-- 861. RHN_EADDRESS_SID_FK  (Constraint) 
--
ALTER TABLE RHNEMAILADDRESS ADD CONSTRAINT RHN_EADDRESS_SID_FK FOREIGN KEY (STATE_ID) 
    REFERENCES RHNEMAILADDRESSSTATE (ID);

--
-- 862. RHN_EADDRESS_UID_FK  (Constraint) 
--
ALTER TABLE RHNEMAILADDRESS ADD CONSTRAINT RHN_EADDRESS_UID_FK FOREIGN KEY (USER_ID) 
    REFERENCES WEB_CONTACT (ID)
    ON DELETE CASCADE;

--
-- 863. RHN_EADDRESSLOG_A_NN  (Constraint) 
--
ALTER TABLE RHNEMAILADDRESSLOG ADD CONSTRAINT RHN_EADDRESSLOG_A_NN CHECK ("ADDRESS" IS NOT NULL);

--
-- 864. RHN_EADDRESSLOG_CREATED_NN  (Constraint) 
--
ALTER TABLE RHNEMAILADDRESSLOG ADD CONSTRAINT RHN_EADDRESSLOG_CREATED_NN CHECK ("CREATED" IS NOT NULL);

--
-- 865. RHN_EADDRESSLOG_UID_NN  (Constraint) 
--
ALTER TABLE RHNEMAILADDRESSLOG ADD CONSTRAINT RHN_EADDRESSLOG_UID_NN CHECK ("USER_ID" IS NOT NULL);

--
-- 866. RHN_EADDRESSLOG_UID_FK  (Constraint) 
--
ALTER TABLE RHNEMAILADDRESSLOG ADD CONSTRAINT RHN_EADDRESSLOG_UID_FK FOREIGN KEY (USER_ID) 
    REFERENCES WEB_CONTACT (ID)
    ON DELETE CASCADE;

--
-- 867. RHN_EFILEP_CREATED_NN  (Constraint) 
--
ALTER TABLE RHNERRATAFILEPACKAGE ADD CONSTRAINT RHN_EFILEP_CREATED_NN CHECK ("CREATED" IS NOT NULL);

--
-- 868. RHN_EFILEP_FILEID_NN  (Constraint) 
--
ALTER TABLE RHNERRATAFILEPACKAGE ADD CONSTRAINT RHN_EFILEP_FILEID_NN CHECK ("ERRATA_FILE_ID" IS NOT NULL);

--
-- 869. RHN_EFILEP_MODIFIED_NN  (Constraint) 
--
ALTER TABLE RHNERRATAFILEPACKAGE ADD CONSTRAINT RHN_EFILEP_MODIFIED_NN CHECK ("MODIFIED" IS NOT NULL);

--
-- 870. RHN_EFILEP_PID_NN  (Constraint) 
--
ALTER TABLE RHNERRATAFILEPACKAGE ADD CONSTRAINT RHN_EFILEP_PID_NN CHECK ("PACKAGE_ID" IS NOT NULL);

--
-- 871. RHN_EFILEP_EFID_UQ  (Constraint) 
--
ALTER TABLE RHNERRATAFILEPACKAGE ADD CONSTRAINT RHN_EFILEP_EFID_UQ UNIQUE (ERRATA_FILE_ID);

--
-- 872. RHN_EFILEP_FILEID_FK  (Constraint) 
--
ALTER TABLE RHNERRATAFILEPACKAGE ADD CONSTRAINT RHN_EFILEP_FILEID_FK FOREIGN KEY (ERRATA_FILE_ID) 
    REFERENCES RHNERRATAFILE (ID)
    ON DELETE CASCADE;

--
-- 873. RHN_EFILEP_PID_FK  (Constraint) 
--
ALTER TABLE RHNERRATAFILEPACKAGE ADD CONSTRAINT RHN_EFILEP_PID_FK FOREIGN KEY (PACKAGE_ID) 
    REFERENCES RHNPACKAGE (ID)
    ON DELETE CASCADE;

--
-- 874. RHN_EFILEPS_CREATED_NN  (Constraint) 
--
ALTER TABLE RHNERRATAFILEPACKAGESOURCE ADD CONSTRAINT RHN_EFILEPS_CREATED_NN CHECK ("CREATED" IS NOT NULL);

--
-- 875. RHN_EFILEPS_FILEID_NN  (Constraint) 
--
ALTER TABLE RHNERRATAFILEPACKAGESOURCE ADD CONSTRAINT RHN_EFILEPS_FILEID_NN CHECK ("ERRATA_FILE_ID" IS NOT NULL);

--
-- 876. RHN_EFILEPS_MODIFIED_NN  (Constraint) 
--
ALTER TABLE RHNERRATAFILEPACKAGESOURCE ADD CONSTRAINT RHN_EFILEPS_MODIFIED_NN CHECK ("MODIFIED" IS NOT NULL);

--
-- 877. RHN_EFILEPS_PID_NN  (Constraint) 
--
ALTER TABLE RHNERRATAFILEPACKAGESOURCE ADD CONSTRAINT RHN_EFILEPS_PID_NN CHECK ("PACKAGE_ID" IS NOT NULL);

--
-- 878. RHN_EFILEPS_EFID_UQ  (Constraint) 
--
ALTER TABLE RHNERRATAFILEPACKAGESOURCE ADD CONSTRAINT RHN_EFILEPS_EFID_UQ UNIQUE (ERRATA_FILE_ID);

--
-- 879. RHN_EFILEPS_FILEID_FK  (Constraint) 
--
ALTER TABLE RHNERRATAFILEPACKAGESOURCE ADD CONSTRAINT RHN_EFILEPS_FILEID_FK FOREIGN KEY (ERRATA_FILE_ID) 
    REFERENCES RHNERRATAFILE (ID)
    ON DELETE CASCADE;

--
-- 880. RHN_EFILEPS_PID_FK  (Constraint) 
--
ALTER TABLE RHNERRATAFILEPACKAGESOURCE ADD CONSTRAINT RHN_EFILEPS_PID_FK FOREIGN KEY (PACKAGE_ID) 
    REFERENCES RHNPACKAGESOURCE (ID)
    ON DELETE CASCADE;

--
-- 881. RHN_ERRATAFILETMP_CREATED_NN  (Constraint) 
--
ALTER TABLE RHNERRATAFILETMP ADD CONSTRAINT RHN_ERRATAFILETMP_CREATED_NN CHECK ("CREATED" IS NOT NULL);

--
-- 882. RHN_ERRATAFILETMP_ERRATA_NN  (Constraint) 
--
ALTER TABLE RHNERRATAFILETMP ADD CONSTRAINT RHN_ERRATAFILETMP_ERRATA_NN CHECK ("ERRATA_ID" IS NOT NULL);

--
-- 883. RHN_ERRATAFILETMP_ID_NN  (Constraint) 
--
ALTER TABLE RHNERRATAFILETMP ADD CONSTRAINT RHN_ERRATAFILETMP_ID_NN CHECK ("ID" IS NOT NULL);

--
-- 884. RHN_ERRATAFILETMP_MD5_NN  (Constraint) 
--
ALTER TABLE RHNERRATAFILETMP ADD CONSTRAINT RHN_ERRATAFILETMP_MD5_NN CHECK ("MD5SUM" IS NOT NULL);

--
-- 885. RHN_ERRATAFILETMP_MODIFIED_NN  (Constraint) 
--
ALTER TABLE RHNERRATAFILETMP ADD CONSTRAINT RHN_ERRATAFILETMP_MODIFIED_NN CHECK ("MODIFIED" IS NOT NULL);

--
-- 886. RHN_ERRATAFILETMP_NAME_NN  (Constraint) 
--
ALTER TABLE RHNERRATAFILETMP ADD CONSTRAINT RHN_ERRATAFILETMP_NAME_NN CHECK ("FILENAME" IS NOT NULL);

--
-- 887. RHN_ERRATAFILETMP_TYPE_NN  (Constraint) 
--
ALTER TABLE RHNERRATAFILETMP ADD CONSTRAINT RHN_ERRATAFILETMP_TYPE_NN CHECK ("TYPE" IS NOT NULL);

--
-- 888. RHN_ERRATAFILETMP_ID_PK  (Constraint) 
--
ALTER TABLE RHNERRATAFILETMP ADD CONSTRAINT RHN_ERRATAFILETMP_ID_PK PRIMARY KEY (ID);

--
-- 889. RHN_ERRATAFILETMP_EID_FILE_UQ  (Constraint) 
--
ALTER TABLE RHNERRATAFILETMP ADD CONSTRAINT RHN_ERRATAFILETMP_EID_FILE_UQ UNIQUE (ERRATA_ID, FILENAME);

--
-- 890. RHN_ERRATAFILETMP_ERRATA_FK  (Constraint) 
--
ALTER TABLE RHNERRATAFILETMP ADD CONSTRAINT RHN_ERRATAFILETMP_ERRATA_FK FOREIGN KEY (ERRATA_ID) 
    REFERENCES RHNERRATATMP (ID);

--
-- 891. RHN_ERRATAFILETMP_TYPE_FK  (Constraint) 
--
ALTER TABLE RHNERRATAFILETMP ADD CONSTRAINT RHN_ERRATAFILETMP_TYPE_FK FOREIGN KEY (TYPE) 
    REFERENCES RHNERRATAFILETYPE (ID);

--
-- 892. RHN_ERELTMP_CREATED_NN  (Constraint) 
--
ALTER TABLE RHNERRATARELATIONSHIPTMP ADD CONSTRAINT RHN_ERELTMP_CREATED_NN CHECK ("CREATED" IS NOT NULL);

--
-- 893. RHN_ERELTMP_FEID_NN  (Constraint) 
--
ALTER TABLE RHNERRATARELATIONSHIPTMP ADD CONSTRAINT RHN_ERELTMP_FEID_NN CHECK ("FROM_ERRATA_ID" IS NOT NULL);

--
-- 894. RHN_ERELTMP_MODIFIED_NN  (Constraint) 
--
ALTER TABLE RHNERRATARELATIONSHIPTMP ADD CONSTRAINT RHN_ERELTMP_MODIFIED_NN CHECK ("MODIFIED" IS NOT NULL);

--
-- 895. RHN_ERELTMP_RTID_NN  (Constraint) 
--
ALTER TABLE RHNERRATARELATIONSHIPTMP ADD CONSTRAINT RHN_ERELTMP_RTID_NN CHECK ("REL_TYPE_ID" IS NOT NULL);

--
-- 896. RHN_ERELTMP_TEID_NN  (Constraint) 
--
ALTER TABLE RHNERRATARELATIONSHIPTMP ADD CONSTRAINT RHN_ERELTMP_TEID_NN CHECK ("TO_ERRATA_ID" IS NOT NULL);

--
-- 897. RHN_ERELTMP_FEID_TEID_UQ  (Constraint) 
--
ALTER TABLE RHNERRATARELATIONSHIPTMP ADD CONSTRAINT RHN_ERELTMP_FEID_TEID_UQ UNIQUE (FROM_ERRATA_ID, TO_ERRATA_ID);

--
-- 898. RHN_ERELTMP_FEID_FK  (Constraint) 
--
ALTER TABLE RHNERRATARELATIONSHIPTMP ADD CONSTRAINT RHN_ERELTMP_FEID_FK FOREIGN KEY (FROM_ERRATA_ID) 
    REFERENCES RHNERRATA (ID)
    ON DELETE CASCADE;

--
-- 899. RHN_ERELTMP_RTID_FK  (Constraint) 
--
ALTER TABLE RHNERRATARELATIONSHIPTMP ADD CONSTRAINT RHN_ERELTMP_RTID_FK FOREIGN KEY (REL_TYPE_ID) 
    REFERENCES RHNRELATIONSHIPTYPE (ID);

--
-- 900. RHN_ERELTMP_TEID_FK  (Constraint) 
--
ALTER TABLE RHNERRATARELATIONSHIPTMP ADD CONSTRAINT RHN_ERELTMP_TEID_FK FOREIGN KEY (TO_ERRATA_ID) 
    REFERENCES RHNERRATATMP (ID)
    ON DELETE CASCADE;

--
-- 901. RHN_FILEDL_FID_NN  (Constraint) 
--
ALTER TABLE RHNFILEDOWNLOAD ADD CONSTRAINT RHN_FILEDL_FID_NN CHECK ("FILE_ID" IS NOT NULL);

--
-- 902. RHN_FILEDL_LOCATION_NN  (Constraint) 
--
ALTER TABLE RHNFILEDOWNLOAD ADD CONSTRAINT RHN_FILEDL_LOCATION_NN CHECK ("LOCATION" IS NOT NULL);

--
-- 903. RHN_FILEDL_RIP_NN  (Constraint) 
--
ALTER TABLE RHNFILEDOWNLOAD ADD CONSTRAINT RHN_FILEDL_RIP_NN CHECK ("REQUESTOR_IP" IS NOT NULL);

--
-- 904. RHN_FILEDL_START_NN  (Constraint) 
--
ALTER TABLE RHNFILEDOWNLOAD ADD CONSTRAINT RHN_FILEDL_START_NN CHECK ("START_TIME" IS NOT NULL);

--
-- 905. RHN_FILEDL_FID_FK  (Constraint) 
--
ALTER TABLE RHNFILEDOWNLOAD ADD CONSTRAINT RHN_FILEDL_FID_FK FOREIGN KEY (FILE_ID) 
    REFERENCES RHNFILE (ID);

--
-- 906. RHN_FILEDL_UID_FK  (Constraint) 
--
ALTER TABLE RHNFILEDOWNLOAD ADD CONSTRAINT RHN_FILEDL_UID_FK FOREIGN KEY (USER_ID) 
    REFERENCES WEB_CONTACT (ID)
    ON DELETE SET NULL;

--
-- 907. RHN_SAVEDSEARCH_ID_NN  (Constraint) 
--
ALTER TABLE RHNSAVEDSEARCH ADD CONSTRAINT RHN_SAVEDSEARCH_ID_NN CHECK ("ID" IS NOT NULL);

--
-- 908. RHN_SAVEDSEARCH_INVERT_CK  (Constraint) 
--
ALTER TABLE RHNSAVEDSEARCH ADD CONSTRAINT RHN_SAVEDSEARCH_INVERT_CK CHECK (invert in ('Y','N'));

--
-- 909. RHN_SAVEDSEARCH_INVERT_NN  (Constraint) 
--
ALTER TABLE RHNSAVEDSEARCH ADD CONSTRAINT RHN_SAVEDSEARCH_INVERT_NN CHECK ("INVERT" IS NOT NULL);

--
-- 910. RHN_SAVEDSEARCH_NAME_NN  (Constraint) 
--
ALTER TABLE RHNSAVEDSEARCH ADD CONSTRAINT RHN_SAVEDSEARCH_NAME_NN CHECK ("NAME" IS NOT NULL);

--
-- 911. RHN_SAVEDSEARCH_SFIELD_NN  (Constraint) 
--
ALTER TABLE RHNSAVEDSEARCH ADD CONSTRAINT RHN_SAVEDSEARCH_SFIELD_NN CHECK ("SEARCH_FIELD" IS NOT NULL);

--
-- 912. RHN_SAVEDSEARCH_SSET_CK  (Constraint) 
--
ALTER TABLE RHNSAVEDSEARCH ADD CONSTRAINT RHN_SAVEDSEARCH_SSET_CK CHECK ( search_set in ('all','system_list'));

--
-- 913. RHN_SAVEDSEARCH_SSET_NN  (Constraint) 
--
ALTER TABLE RHNSAVEDSEARCH ADD CONSTRAINT RHN_SAVEDSEARCH_SSET_NN CHECK ("SEARCH_SET" IS NOT NULL);

--
-- 914. RHN_SAVEDSEARCH_SSTRING_NN  (Constraint) 
--
ALTER TABLE RHNSAVEDSEARCH ADD CONSTRAINT RHN_SAVEDSEARCH_SSTRING_NN CHECK ("SEARCH_STRING" IS NOT NULL);

--
-- 915. RHN_SAVEDSEARCH_TYPE_NN  (Constraint) 
--
ALTER TABLE RHNSAVEDSEARCH ADD CONSTRAINT RHN_SAVEDSEARCH_TYPE_NN CHECK ("TYPE" IS NOT NULL);

--
-- 916. RHN_SAVEDSEARCH_WCID_NN  (Constraint) 
--
ALTER TABLE RHNSAVEDSEARCH ADD CONSTRAINT RHN_SAVEDSEARCH_WCID_NN CHECK ("WEB_CONTACT_ID" IS NOT NULL);

--
-- 917. RHN_SAVEDSEARCH_ID_PK  (Constraint) 
--
ALTER TABLE RHNSAVEDSEARCH ADD CONSTRAINT RHN_SAVEDSEARCH_ID_PK PRIMARY KEY (ID);

--
-- 918. RHN_SAVEDSEARCH_NAME_WCID_UQ  (Constraint) 
--
ALTER TABLE RHNSAVEDSEARCH ADD CONSTRAINT RHN_SAVEDSEARCH_NAME_WCID_UQ UNIQUE (NAME, WEB_CONTACT_ID);

--
-- 919. RHN_SAVEDSEARCH_TYPE_FK  (Constraint) 
--
ALTER TABLE RHNSAVEDSEARCH ADD CONSTRAINT RHN_SAVEDSEARCH_TYPE_FK FOREIGN KEY (TYPE) 
    REFERENCES RHNSAVEDSEARCHTYPE (ID);

--
-- 920. RHN_SAVEDSEARCH_WCID_FK  (Constraint) 
--
ALTER TABLE RHNSAVEDSEARCH ADD CONSTRAINT RHN_SAVEDSEARCH_WCID_FK FOREIGN KEY (WEB_CONTACT_ID) 
    REFERENCES WEB_CONTACT (ID)
    ON DELETE CASCADE;

--
-- 921. RHN_SE_CREATED_NN  (Constraint) 
--
ALTER TABLE RHNSERVEREVENT ADD CONSTRAINT RHN_SE_CREATED_NN CHECK ("CREATED" IS NOT NULL);

--
-- 922. RHN_SE_DETAILS_NN  (Constraint) 
--
ALTER TABLE RHNSERVEREVENT ADD CONSTRAINT RHN_SE_DETAILS_NN CHECK ("DETAILS" IS NOT NULL);

--
-- 923. RHN_SE_ID_NN  (Constraint) 
--
ALTER TABLE RHNSERVEREVENT ADD CONSTRAINT RHN_SE_ID_NN CHECK ("ID" IS NOT NULL);

--
-- 924. RHN_SE_MODIFIED_NN  (Constraint) 
--
ALTER TABLE RHNSERVEREVENT ADD CONSTRAINT RHN_SE_MODIFIED_NN CHECK ("MODIFIED" IS NOT NULL);

--
-- 925. RHN_SE_SERVER_ID_NN  (Constraint) 
--
ALTER TABLE RHNSERVEREVENT ADD CONSTRAINT RHN_SE_SERVER_ID_NN CHECK ("SERVER_ID" IS NOT NULL);

--
-- 926. RHN_SE_ID_PK  (Constraint) 
--
ALTER TABLE RHNSERVEREVENT ADD CONSTRAINT RHN_SE_ID_PK PRIMARY KEY (ID);

--
-- 927. RHN_SE_SERVER_ID_FK  (Constraint) 
--
ALTER TABLE RHNSERVEREVENT ADD CONSTRAINT RHN_SE_SERVER_ID_FK FOREIGN KEY (SERVER_ID) 
    REFERENCES RHNSERVER (ID)
    ON DELETE CASCADE;

--
-- 928. RHN_SERVERHW_CREATED_NN  (Constraint) 
--
ALTER TABLE RHNSERVERHARDWARE ADD CONSTRAINT RHN_SERVERHW_CREATED_NN CHECK ("CREATED" IS NOT NULL);

--
-- 929. RHN_SERVERHW_HID_NN  (Constraint) 
--
ALTER TABLE RHNSERVERHARDWARE ADD CONSTRAINT RHN_SERVERHW_HID_NN CHECK ("HARDWARE_ID" IS NOT NULL);

--
-- 930. RHN_SERVERHW_MODIFIED_NN  (Constraint) 
--
ALTER TABLE RHNSERVERHARDWARE ADD CONSTRAINT RHN_SERVERHW_MODIFIED_NN CHECK ("MODIFIED" IS NOT NULL);

--
-- 931. RHN_SERVERHW_SID_NN  (Constraint) 
--
ALTER TABLE RHNSERVERHARDWARE ADD CONSTRAINT RHN_SERVERHW_SID_NN CHECK ("SERVER_ID" IS NOT NULL);

--
-- 932. RHN_SERVERHW_HID_FK  (Constraint) 
--
ALTER TABLE RHNSERVERHARDWARE ADD CONSTRAINT RHN_SERVERHW_HID_FK FOREIGN KEY (HARDWARE_ID) 
    REFERENCES RHNHARDWARE (ID);

--
-- 933. RHN_SERVERHW_SID_FK  (Constraint) 
--
ALTER TABLE RHNSERVERHARDWARE ADD CONSTRAINT RHN_SERVERHW_SID_FK FOREIGN KEY (SERVER_ID) 
    REFERENCES RHNSERVER (ID);

--
-- 934. RHN_SERVER_INSTALL_INFO_CR_NN  (Constraint) 
--
ALTER TABLE RHNSERVERINSTALLINFO ADD CONSTRAINT RHN_SERVER_INSTALL_INFO_CR_NN CHECK ("CREATED" IS NOT NULL);

--
-- 935. RHN_SERVER_INSTALL_INFO_ID_NN  (Constraint) 
--
ALTER TABLE RHNSERVERINSTALLINFO ADD CONSTRAINT RHN_SERVER_INSTALL_INFO_ID_NN CHECK ("ID" IS NOT NULL);

--
-- 936. RHN_SERVER_INSTALL_INFO_IM_NN  (Constraint) 
--
ALTER TABLE RHNSERVERINSTALLINFO ADD CONSTRAINT RHN_SERVER_INSTALL_INFO_IM_NN CHECK ("INSTALL_METHOD" IS NOT NULL);

--
-- 937. RHN_SERVER_INSTALL_INFO_MD_NN  (Constraint) 
--
ALTER TABLE RHNSERVERINSTALLINFO ADD CONSTRAINT RHN_SERVER_INSTALL_INFO_MD_NN CHECK ("MODIFIED" IS NOT NULL);

--
-- 938. RHN_SERVER_INSTAL_INFO_SID_NN  (Constraint) 
--
ALTER TABLE RHNSERVERINSTALLINFO ADD CONSTRAINT RHN_SERVER_INSTAL_INFO_SID_NN CHECK ("SERVER_ID" IS NOT NULL);

--
-- 939. RHN_SERVER_INSTALL_INFO_ID_PK  (Constraint) 
--
ALTER TABLE RHNSERVERINSTALLINFO ADD CONSTRAINT RHN_SERVER_INSTALL_INFO_ID_PK PRIMARY KEY (ID);

--
-- 940. RHN_SERVER_INSTALL_INFO_SID_UQ  (Constraint) 
--
ALTER TABLE RHNSERVERINSTALLINFO ADD CONSTRAINT RHN_SERVER_INSTALL_INFO_SID_UQ UNIQUE (SERVER_ID);

--
-- 941. RHN_SERVER_INSTALL_INFO_SID_FK  (Constraint) 
--
ALTER TABLE RHNSERVERINSTALLINFO ADD CONSTRAINT RHN_SERVER_INSTALL_INFO_SID_FK FOREIGN KEY (SERVER_ID) 
    REFERENCES RHNSERVER (ID)
    ON DELETE CASCADE;

--
-- 942. RHN_SM_CREATED_NN  (Constraint) 
--
ALTER TABLE RHNSERVERMESSAGE ADD CONSTRAINT RHN_SM_CREATED_NN CHECK ("CREATED" IS NOT NULL);

--
-- 943. RHN_SM_MESSAGE_ID_NN  (Constraint) 
--
ALTER TABLE RHNSERVERMESSAGE ADD CONSTRAINT RHN_SM_MESSAGE_ID_NN CHECK ("MESSAGE_ID" IS NOT NULL);

--
-- 944. RHN_SM_MODIFIED_NN  (Constraint) 
--
ALTER TABLE RHNSERVERMESSAGE ADD CONSTRAINT RHN_SM_MODIFIED_NN CHECK ("MODIFIED" IS NOT NULL);

--
-- 945. RHN_SM_SERVER_ID_NN  (Constraint) 
--
ALTER TABLE RHNSERVERMESSAGE ADD CONSTRAINT RHN_SM_SERVER_ID_NN CHECK ("SERVER_ID" IS NOT NULL);

--
-- 946. RHN_SM_MESSAGE_ID_FK  (Constraint) 
--
ALTER TABLE RHNSERVERMESSAGE ADD CONSTRAINT RHN_SM_MESSAGE_ID_FK FOREIGN KEY (MESSAGE_ID) 
    REFERENCES RHNMESSAGE (ID)
    ON DELETE CASCADE;

--
-- 947. RHN_SM_SERVER_ID_FK  (Constraint) 
--
ALTER TABLE RHNSERVERMESSAGE ADD CONSTRAINT RHN_SM_SERVER_ID_FK FOREIGN KEY (SERVER_ID) 
    REFERENCES RHNSERVER (ID)
    ON DELETE CASCADE;

--
-- 948. RHN_SM_SE_FK  (Constraint) 
--
ALTER TABLE RHNSERVERMESSAGE ADD CONSTRAINT RHN_SM_SE_FK FOREIGN KEY (SERVER_EVENT) 
    REFERENCES RHNSERVEREVENT (ID)
    ON DELETE CASCADE;

--
-- 949. RHN_SRV_NET_IFACE_CREATED_NN  (Constraint) 
--
ALTER TABLE RHNSERVERNETINTERFACE ADD CONSTRAINT RHN_SRV_NET_IFACE_CREATED_NN CHECK ("CREATED" IS NOT NULL);

--
-- 950. RHN_SRV_NET_IFACE_MODIFIED_NN  (Constraint) 
--
ALTER TABLE RHNSERVERNETINTERFACE ADD CONSTRAINT RHN_SRV_NET_IFACE_MODIFIED_NN CHECK ("MODIFIED" IS NOT NULL);

--
-- 951. RHN_SRV_NET_IFACE_NAME_NN  (Constraint) 
--
ALTER TABLE RHNSERVERNETINTERFACE ADD CONSTRAINT RHN_SRV_NET_IFACE_NAME_NN CHECK ("NAME" IS NOT NULL);

--
-- 952. RHN_SRV_NET_IFACE_SID_NN  (Constraint) 
--
ALTER TABLE RHNSERVERNETINTERFACE ADD CONSTRAINT RHN_SRV_NET_IFACE_SID_NN CHECK ("SERVER_ID" IS NOT NULL);

--
-- 953. RHN_SRV_NET_IFACE_SID_NAME_UQ  (Constraint) 
--
ALTER TABLE RHNSERVERNETINTERFACE ADD CONSTRAINT RHN_SRV_NET_IFACE_SID_NAME_UQ UNIQUE (SERVER_ID, NAME);

--
-- 954. RHN_SRV_NET_IFACE_SID_FK  (Constraint) 
--
ALTER TABLE RHNSERVERNETINTERFACE ADD CONSTRAINT RHN_SRV_NET_IFACE_SID_FK FOREIGN KEY (SERVER_ID) 
    REFERENCES RHNSERVER (ID)
    ON DELETE CASCADE;

--
-- 955. RHN_SQRESPONSE_QID_NN  (Constraint) 
--
ALTER TABLE RHNSURVEYQUESTIONRESPONSE ADD CONSTRAINT RHN_SQRESPONSE_QID_NN CHECK ("QUESTION_ID" IS NOT NULL);

--
-- 956. RHN_SQRESPONSE_UID_NN  (Constraint) 
--
ALTER TABLE RHNSURVEYQUESTIONRESPONSE ADD CONSTRAINT RHN_SQRESPONSE_UID_NN CHECK ("USER_ID" IS NOT NULL);

--
-- 957. RHN_SQRESPONSE_QID_FK  (Constraint) 
--
ALTER TABLE RHNSURVEYQUESTIONRESPONSE ADD CONSTRAINT RHN_SQRESPONSE_QID_FK FOREIGN KEY (QUESTION_ID) 
    REFERENCES RHNSURVEYQUESTION (ID)
    ON DELETE CASCADE;

--
-- 958. RHN_SQRESPONSE_UID_FK  (Constraint) 
--
ALTER TABLE RHNSURVEYQUESTIONRESPONSE ADD CONSTRAINT RHN_SQRESPONSE_UID_FK FOREIGN KEY (USER_ID) 
    REFERENCES WEB_CONTACT (ID)
    ON DELETE CASCADE;

--
-- 959. RHN_TRANS_CREATED_NN  (Constraint) 
--
ALTER TABLE RHNTRANSACTION ADD CONSTRAINT RHN_TRANS_CREATED_NN CHECK ("CREATED" IS NOT NULL);

--
-- 960. RHN_TRANS_ID_NN  (Constraint) 
--
ALTER TABLE RHNTRANSACTION ADD CONSTRAINT RHN_TRANS_ID_NN CHECK ("ID" IS NOT NULL);

--
-- 961. RHN_TRANS_MODIFIED_NN  (Constraint) 
--
ALTER TABLE RHNTRANSACTION ADD CONSTRAINT RHN_TRANS_MODIFIED_NN CHECK ("MODIFIED" IS NOT NULL);

--
-- 962. RHN_TRANS_RTI_NN  (Constraint) 
--
ALTER TABLE RHNTRANSACTION ADD CONSTRAINT RHN_TRANS_RTI_NN CHECK ("RPM_TRANS_ID" IS NOT NULL);

--
-- 963. RHN_TRANS_SID_NN  (Constraint) 
--
ALTER TABLE RHNTRANSACTION ADD CONSTRAINT RHN_TRANS_SID_NN CHECK ("SERVER_ID" IS NOT NULL);

--
-- 964. RHN_TRANS_TS_NN  (Constraint) 
--
ALTER TABLE RHNTRANSACTION ADD CONSTRAINT RHN_TRANS_TS_NN CHECK ("TIMESTAMP" IS NOT NULL);

--
-- 965. RHN_TRANS_ID_PK  (Constraint) 
--
ALTER TABLE RHNTRANSACTION ADD CONSTRAINT RHN_TRANS_ID_PK PRIMARY KEY (ID);

--
-- 966. RHN_TRANS_SID_RTI_UNQ  (Constraint) 
--
ALTER TABLE RHNTRANSACTION ADD CONSTRAINT RHN_TRANS_SID_RTI_UNQ UNIQUE (SERVER_ID, RPM_TRANS_ID);

--
-- 967. RHN_TRANS_SID_FK  (Constraint) 
--
ALTER TABLE RHNTRANSACTION ADD CONSTRAINT RHN_TRANS_SID_FK FOREIGN KEY (SERVER_ID) 
    REFERENCES RHNSERVER (ID)
    ON DELETE CASCADE;

--
-- 968. RHN_TRANSELEM_TID_NN  (Constraint) 
--
ALTER TABLE RHNTRANSACTIONELEMENT ADD CONSTRAINT RHN_TRANSELEM_TID_NN CHECK ("TRANSACTION_ID" IS NOT NULL);

--
-- 969. RHN_TRANSELEM_TPID_NN  (Constraint) 
--
ALTER TABLE RHNTRANSACTIONELEMENT ADD CONSTRAINT RHN_TRANSELEM_TPID_NN CHECK ("TRANSACTION_PACKAGE_ID" IS NOT NULL);

--
-- 970. RHN_TRANSELEM_TID_FK  (Constraint) 
--
ALTER TABLE RHNTRANSACTIONELEMENT ADD CONSTRAINT RHN_TRANSELEM_TID_FK FOREIGN KEY (TRANSACTION_ID) 
    REFERENCES RHNTRANSACTION (ID)
    ON DELETE CASCADE;

--
-- 971. RHN_TRANSELEM_TPID_FK  (Constraint) 
--
ALTER TABLE RHNTRANSACTIONELEMENT ADD CONSTRAINT RHN_TRANSELEM_TPID_FK FOREIGN KEY (TRANSACTION_PACKAGE_ID) 
    REFERENCES RHNTRANSACTIONPACKAGE (ID);

--
-- 972. RHN_UM_MESSAGE_ID_NN  (Constraint) 
--
ALTER TABLE RHNUSERMESSAGE ADD CONSTRAINT RHN_UM_MESSAGE_ID_NN CHECK ("MESSAGE_ID" IS NOT NULL);

--
-- 973. RHN_UM_STATUS_NN  (Constraint) 
--
ALTER TABLE RHNUSERMESSAGE ADD CONSTRAINT RHN_UM_STATUS_NN CHECK ("STATUS" IS NOT NULL);

--
-- 974. RHN_UM_USER_ID_NN  (Constraint) 
--
ALTER TABLE RHNUSERMESSAGE ADD CONSTRAINT RHN_UM_USER_ID_NN CHECK ("USER_ID" IS NOT NULL);

--
-- 975. RHN_UM_MESSAGE_ID_FK  (Constraint) 
--
ALTER TABLE RHNUSERMESSAGE ADD CONSTRAINT RHN_UM_MESSAGE_ID_FK FOREIGN KEY (MESSAGE_ID) 
    REFERENCES RHNMESSAGE (ID)
    ON DELETE CASCADE;

--
-- 976. RHN_UM_STATUS_FK  (Constraint) 
--
ALTER TABLE RHNUSERMESSAGE ADD CONSTRAINT RHN_UM_STATUS_FK FOREIGN KEY (STATUS) 
    REFERENCES RHNUSERMESSAGESTATUS (ID);

--
-- 977. RHN_UM_USER_ID_FK  (Constraint) 
--
ALTER TABLE RHNUSERMESSAGE ADD CONSTRAINT RHN_UM_USER_ID_FK FOREIGN KEY (USER_ID) 
    REFERENCES WEB_CONTACT (ID);

--
-- 978. RHN_USURVEYSTATUS_SID_NN  (Constraint) 
--
ALTER TABLE RHNUSERSURVEYSTATUS ADD CONSTRAINT RHN_USURVEYSTATUS_SID_NN CHECK ("SURVEY_ID" IS NOT NULL);

--
-- 979. RHN_USURVEYSTATUS_STATUS_NN  (Constraint) 
--
ALTER TABLE RHNUSERSURVEYSTATUS ADD CONSTRAINT RHN_USURVEYSTATUS_STATUS_NN CHECK ("STATUS" IS NOT NULL);

--
-- 980. RHN_USURVEYSTATUS_UID_NN  (Constraint) 
--
ALTER TABLE RHNUSERSURVEYSTATUS ADD CONSTRAINT RHN_USURVEYSTATUS_UID_NN CHECK ("USER_ID" IS NOT NULL);

--
-- 981. RHN_USURVEYSTATUS_UID_SID_UQ  (Constraint) 
--
ALTER TABLE RHNUSERSURVEYSTATUS ADD CONSTRAINT RHN_USURVEYSTATUS_UID_SID_UQ UNIQUE (USER_ID, SURVEY_ID);

--
-- 982. RHN_USURVEYSTATUS_SID_FK  (Constraint) 
--
ALTER TABLE RHNUSERSURVEYSTATUS ADD CONSTRAINT RHN_USURVEYSTATUS_SID_FK FOREIGN KEY (SURVEY_ID) 
    REFERENCES RHNSURVEY (ID)
    ON DELETE CASCADE;

--
-- 983. RHN_USURVEYSTATUS_STATUS_FK  (Constraint) 
--
ALTER TABLE RHNUSERSURVEYSTATUS ADD CONSTRAINT RHN_USURVEYSTATUS_STATUS_FK FOREIGN KEY (STATUS) 
    REFERENCES RHNUSERSURVEYSTATUSTYPE (ID);

--
-- 984. RHN_USURVEYSTATUS_UID_FK  (Constraint) 
--
ALTER TABLE RHNUSERSURVEYSTATUS ADD CONSTRAINT RHN_USURVEYSTATUS_UID_FK FOREIGN KEY (USER_ID) 
    REFERENCES WEB_CONTACT (ID)
    ON DELETE CASCADE;

--
-- 985. RHN_APR_FAILURE_AID_NN  (Constraint) 
--
ALTER TABLE RHNACTIONPACKAGEREMOVALFAILURE ADD CONSTRAINT RHN_APR_FAILURE_AID_NN CHECK ("ACTION_ID" IS NOT NULL);

--
-- 986. RHN_APR_FAILURE_CAPID_NN  (Constraint) 
--
ALTER TABLE RHNACTIONPACKAGEREMOVALFAILURE ADD CONSTRAINT RHN_APR_FAILURE_CAPID_NN CHECK ("CAPABILITY_ID" IS NOT NULL);

--
-- 987. RHN_APR_FAILURE_EID_NN  (Constraint) 
--
ALTER TABLE RHNACTIONPACKAGEREMOVALFAILURE ADD CONSTRAINT RHN_APR_FAILURE_EID_NN CHECK ("EVR_ID" IS NOT NULL);

--
-- 988. RHN_APR_FAILURE_FLAGS_NN  (Constraint) 
--
ALTER TABLE RHNACTIONPACKAGEREMOVALFAILURE ADD CONSTRAINT RHN_APR_FAILURE_FLAGS_NN CHECK ("FLAGS" IS NOT NULL);

--
-- 989. RHN_APR_FAILURE_NID_NN  (Constraint) 
--
ALTER TABLE RHNACTIONPACKAGEREMOVALFAILURE ADD CONSTRAINT RHN_APR_FAILURE_NID_NN CHECK ("NAME_ID" IS NOT NULL);

--
-- 990. RHN_APR_FAILURE_SENSE_NN  (Constraint) 
--
ALTER TABLE RHNACTIONPACKAGEREMOVALFAILURE ADD CONSTRAINT RHN_APR_FAILURE_SENSE_NN CHECK ("SENSE" IS NOT NULL);

--
-- 991. RHN_APR_FAILURE_SID_NN  (Constraint) 
--
ALTER TABLE RHNACTIONPACKAGEREMOVALFAILURE ADD CONSTRAINT RHN_APR_FAILURE_SID_NN CHECK ("SERVER_ID" IS NOT NULL);

--
-- 992. RHN_APR_FAILURE_AID_FK  (Constraint) 
--
ALTER TABLE RHNACTIONPACKAGEREMOVALFAILURE ADD CONSTRAINT RHN_APR_FAILURE_AID_FK FOREIGN KEY (ACTION_ID) 
    REFERENCES RHNACTION (ID);

--
-- 993. RHN_APR_FAILURE_CAPID_FK  (Constraint) 
--
ALTER TABLE RHNACTIONPACKAGEREMOVALFAILURE ADD CONSTRAINT RHN_APR_FAILURE_CAPID_FK FOREIGN KEY (CAPABILITY_ID) 
    REFERENCES RHNPACKAGECAPABILITY (ID);

--
-- 994. RHN_APR_FAILURE_EID_FK  (Constraint) 
--
ALTER TABLE RHNACTIONPACKAGEREMOVALFAILURE ADD CONSTRAINT RHN_APR_FAILURE_EID_FK FOREIGN KEY (EVR_ID) 
    REFERENCES RHNPACKAGEEVR (ID);

--
-- 995. RHN_APR_FAILURE_NID_FK  (Constraint) 
--
ALTER TABLE RHNACTIONPACKAGEREMOVALFAILURE ADD CONSTRAINT RHN_APR_FAILURE_NID_FK FOREIGN KEY (NAME_ID) 
    REFERENCES RHNPACKAGENAME (ID);

--
-- 996. RHN_APR_FAILURE_SID_FK  (Constraint) 
--
ALTER TABLE RHNACTIONPACKAGEREMOVALFAILURE ADD CONSTRAINT RHN_APR_FAILURE_SID_FK FOREIGN KEY (SERVER_ID) 
    REFERENCES RHNSERVER (ID)
    ON DELETE CASCADE;

--
-- 997. RHN_APR_FAILURE_SUGGESTED_FK  (Constraint) 
--
ALTER TABLE RHNACTIONPACKAGEREMOVALFAILURE ADD CONSTRAINT RHN_APR_FAILURE_SUGGESTED_FK FOREIGN KEY (SUGGESTED) 
    REFERENCES RHNPACKAGENAME (ID);

--
-- 998. RHN_AT_AID_NN  (Constraint) 
--
ALTER TABLE RHNACTIONTRANSACTIONS ADD CONSTRAINT RHN_AT_AID_NN CHECK ("ACTION_ID" IS NOT NULL);

--
-- 999. RHN_AT_FTID_NN  (Constraint) 
--
ALTER TABLE RHNACTIONTRANSACTIONS ADD CONSTRAINT RHN_AT_FTID_NN CHECK ("FROM_TRANS_ID" IS NOT NULL);

--
-- 1000. RHN_AT_TTID_NN  (Constraint) 
--
ALTER TABLE RHNACTIONTRANSACTIONS ADD CONSTRAINT RHN_AT_TTID_NN CHECK ("TO_TRANS_ID" IS NOT NULL);

--
-- 1001. RHN_AT_AID_FK  (Constraint) 
--
ALTER TABLE RHNACTIONTRANSACTIONS ADD CONSTRAINT RHN_AT_AID_FK FOREIGN KEY (ACTION_ID) 
    REFERENCES RHNACTION (ID);

--
-- 1002. RHN_AT_FTID_FK  (Constraint) 
--
ALTER TABLE RHNACTIONTRANSACTIONS ADD CONSTRAINT RHN_AT_FTID_FK FOREIGN KEY (FROM_TRANS_ID) 
    REFERENCES RHNTRANSACTION (ID);

--
-- 1003. RHN_AT_TTID_FK  (Constraint) 
--
ALTER TABLE RHNACTIONTRANSACTIONS ADD CONSTRAINT RHN_AT_TTID_FK FOREIGN KEY (TO_TRANS_ID) 
    REFERENCES RHNTRANSACTION (ID);

--
-- 1004. RHN_CFL_CONSENT_CFID_NN  (Constraint) 
--
ALTER TABLE RHNCHANNELFAMILYLICENSECONSENT ADD CONSTRAINT RHN_CFL_CONSENT_CFID_NN CHECK ("CHANNEL_FAMILY_ID" IS NOT NULL);

--
-- 1005. RHN_CFL_CONSENT_CREATED_NN  (Constraint) 
--
ALTER TABLE RHNCHANNELFAMILYLICENSECONSENT ADD CONSTRAINT RHN_CFL_CONSENT_CREATED_NN CHECK ("CREATED" IS NOT NULL);

--
-- 1006. RHN_CFL_CONSENT_MODIFIED_NN  (Constraint) 
--
ALTER TABLE RHNCHANNELFAMILYLICENSECONSENT ADD CONSTRAINT RHN_CFL_CONSENT_MODIFIED_NN CHECK ("MODIFIED" IS NOT NULL);

--
-- 1007. RHN_CFL_CONSENT_SID_NN  (Constraint) 
--
ALTER TABLE RHNCHANNELFAMILYLICENSECONSENT ADD CONSTRAINT RHN_CFL_CONSENT_SID_NN CHECK ("SERVER_ID" IS NOT NULL);

--
-- 1008. RHN_CFL_CONSENT_UID_NN  (Constraint) 
--
ALTER TABLE RHNCHANNELFAMILYLICENSECONSENT ADD CONSTRAINT RHN_CFL_CONSENT_UID_NN CHECK ("USER_ID" IS NOT NULL);

--
-- 1009. RHN_CFL_CONSENT_CFID_FK  (Constraint) 
--
ALTER TABLE RHNCHANNELFAMILYLICENSECONSENT ADD CONSTRAINT RHN_CFL_CONSENT_CFID_FK FOREIGN KEY (CHANNEL_FAMILY_ID) 
    REFERENCES RHNCHANNELFAMILY (ID)
    ON DELETE CASCADE;

--
-- 1010. RHN_CFL_CONSENT_SID_FK  (Constraint) 
--
ALTER TABLE RHNCHANNELFAMILYLICENSECONSENT ADD CONSTRAINT RHN_CFL_CONSENT_SID_FK FOREIGN KEY (SERVER_ID) 
    REFERENCES RHNSERVER (ID)
    ON DELETE CASCADE;

--
-- 1011. RHN_CFL_CONSENT_UID_FK  (Constraint) 
--
ALTER TABLE RHNCHANNELFAMILYLICENSECONSENT ADD CONSTRAINT RHN_CFL_CONSENT_UID_FK FOREIGN KEY (USER_ID) 
    REFERENCES WEB_CONTACT (ID)
    ON DELETE CASCADE;

--
-- 1012. RHN_MONITOR_BID_NN  (Constraint) 
--
ALTER TABLE RHNMONITOR ADD CONSTRAINT RHN_MONITOR_BID_NN CHECK ("BATCH_ID" IS NOT NULL);

--
-- 1013. RHN_MONITOR_GRANULARITY_NN  (Constraint) 
--
ALTER TABLE RHNMONITOR ADD CONSTRAINT RHN_MONITOR_GRANULARITY_NN CHECK ("GRANULARITY" IS NOT NULL);

--
-- 1014. RHN_MONITOR_PROBE_NN  (Constraint) 
--
ALTER TABLE RHNMONITOR ADD CONSTRAINT RHN_MONITOR_PROBE_NN CHECK ("PROBE_ID" IS NOT NULL);

--
-- 1015. RHN_MONITOR_SID_NN  (Constraint) 
--
ALTER TABLE RHNMONITOR ADD CONSTRAINT RHN_MONITOR_SID_NN CHECK ("SERVER_ID" IS NOT NULL);

--
-- 1016. RHN_MONITOR_TS_NN  (Constraint) 
--
ALTER TABLE RHNMONITOR ADD CONSTRAINT RHN_MONITOR_TS_NN CHECK ("TIMESTAMP" IS NOT NULL);

--
-- 1017. RHN_MONITOR_GRANULARITY_FK  (Constraint) 
--
ALTER TABLE RHNMONITOR ADD CONSTRAINT RHN_MONITOR_GRANULARITY_FK FOREIGN KEY (GRANULARITY) 
    REFERENCES RHNMONITORGRANULARITY (ID);

--
-- 1018. RHN_MONITOR_SID_FK  (Constraint) 
--
ALTER TABLE RHNMONITOR ADD CONSTRAINT RHN_MONITOR_SID_FK FOREIGN KEY (SERVER_ID) 
    REFERENCES RHNSERVER (ID)
    ON DELETE CASCADE;

--
-- 1019. RHN_SAT_CF_CFID_NN  (Constraint) 
--
ALTER TABLE RHNSATELLITECHANNELFAMILY ADD CONSTRAINT RHN_SAT_CF_CFID_NN CHECK ("CHANNEL_FAMILY_ID" IS NOT NULL);

--
-- 1020. RHN_SAT_CF_CREATED_NN  (Constraint) 
--
ALTER TABLE RHNSATELLITECHANNELFAMILY ADD CONSTRAINT RHN_SAT_CF_CREATED_NN CHECK ("CREATED" IS NOT NULL);

--
-- 1021. RHN_SAT_CF_MODIFIED_NN  (Constraint) 
--
ALTER TABLE RHNSATELLITECHANNELFAMILY ADD CONSTRAINT RHN_SAT_CF_MODIFIED_NN CHECK ("MODIFIED" IS NOT NULL);

--
-- 1022. RHN_SAT_CF_SID_NN  (Constraint) 
--
ALTER TABLE RHNSATELLITECHANNELFAMILY ADD CONSTRAINT RHN_SAT_CF_SID_NN CHECK ("SERVER_ID" IS NOT NULL);

--
-- 1023. RHN_SAT_CF_SID_CFID_UQ  (Constraint) 
--
ALTER TABLE RHNSATELLITECHANNELFAMILY ADD CONSTRAINT RHN_SAT_CF_SID_CFID_UQ UNIQUE (SERVER_ID, CHANNEL_FAMILY_ID);

--
-- 1024. RHN_SAT_CF_CFID_FK  (Constraint) 
--
ALTER TABLE RHNSATELLITECHANNELFAMILY ADD CONSTRAINT RHN_SAT_CF_CFID_FK FOREIGN KEY (CHANNEL_FAMILY_ID) 
    REFERENCES RHNCHANNELFAMILY (ID)
    ON DELETE CASCADE;

--
-- 1025. RHN_SAT_CF_SID_FK  (Constraint) 
--
ALTER TABLE RHNSATELLITECHANNELFAMILY ADD CONSTRAINT RHN_SAT_CF_SID_FK FOREIGN KEY (SERVER_ID) 
    REFERENCES RHNSERVER (ID)
    ON DELETE CASCADE;

drop table tmp_arch_name_label;

insert into rhnOrgState
select id, rhn_bel.lookup_org_state('paid'), NULL, sysdate, sysdate FROM web_customer
/

begin
    for channel IN (select id from rhnChannel)
    loop
      rhn_channel.refresh_newest_package(channel.id, 'Titan Conversion Script');
    end loop;
end;
/
    
commit;

--
-- 28. RHN_PKG_CONFLICTS_CAP_FK  (Constraint) 
--
ALTER TABLE RHNPACKAGECONFLICTS ADD CONSTRAINT RHN_PKG_CONFLICTS_CAP_FK FOREIGN KEY (CAPABILITY_ID) 
    REFERENCES RHNPACKAGECAPABILITY (ID);

--
-- 29. RHN_PACKAGE_FILE_CID_FK  (Constraint) 
--
ALTER TABLE RHNPACKAGEFILE ADD CONSTRAINT RHN_PACKAGE_FILE_CID_FK FOREIGN KEY (CAPABILITY_ID) 
    REFERENCES RHNPACKAGECAPABILITY (ID);

--
-- 30. RHN_PKG_OBSOLETES_CAP_FK  (Constraint) 
--
ALTER TABLE RHNPACKAGEOBSOLETES ADD CONSTRAINT RHN_PKG_OBSOLETES_CAP_FK FOREIGN KEY (CAPABILITY_ID) 
    REFERENCES RHNPACKAGECAPABILITY (ID);

--
-- 31. RHN_PKG_PROVIDES_CAPABILITY_FK  (Constraint) 
--
ALTER TABLE RHNPACKAGEPROVIDES ADD CONSTRAINT RHN_PKG_PROVIDES_CAPABILITY_FK FOREIGN KEY (CAPABILITY_ID) 
    REFERENCES RHNPACKAGECAPABILITY (ID);

--
-- 32. RHN_PKG_REQUIRES_CAPABILITY_FK  (Constraint) 
--
ALTER TABLE RHNPACKAGEREQUIRES ADD CONSTRAINT RHN_PKG_REQUIRES_CAPABILITY_FK FOREIGN KEY (CAPABILITY_ID) 
    REFERENCES RHNPACKAGECAPABILITY (ID);

--
-- 33. RHN_SERVER_PROFILE_ID_PK  (Constraint) 
--
ALTER TABLE RHNSERVERPROFILE ADD CONSTRAINT RHN_SERVER_PROFILE_ID_PK PRIMARY KEY (ID);

--
-- 34. RHN_SPROFILE_SPID_FK  (Constraint) 
--
ALTER TABLE RHNSERVERPROFILEPACKAGE ADD CONSTRAINT RHN_SPROFILE_SPID_FK FOREIGN KEY (SERVER_PROFILE_ID) 
    REFERENCES RHNSERVERPROFILE (ID);

CREATE OR REPLACE procedure
create_first_org
(
	name_in in varchar2,
	password_in in varchar2
) is
	ug_type			number;
	group_val		number;
begin
	insert into web_customer (
		id, name, password,
		oracle_customer_id, oracle_customer_number,
		customer_type
	) values (
		1, name_in, password_in,
		1, 1, 'B'
	);
	select rhn_user_group_id_seq.nextval into group_val from dual;
	select	id
	into	ug_type
	from	rhnUserGroupType
	where	label = 'org_admin';
	insert into rhnUserGroup (
		id, name,
		description,
		max_members, group_type, org_id
	) values (
		group_val, 'Organization Admins',
		'Organization Admins for Org ' || name_in || ' (1)',
		NULL, ug_type, 1
	);
	select rhn_user_group_id_seq.nextval into group_val from dual;
	select	id
	into	ug_type
	from	rhnUserGroupType
	where	label = 'org_applicant';
	insert into rhnUserGroup (
		id, name,
		description,
		max_members, group_type, org_id
	) values (
		group_val, 'Organization Applicants',
		'Organization Applicants for Org ' || name_in || ' (1)',
		NULL, ug_type, 1
	);
	select rhn_user_group_id_seq.nextval into group_val from dual;
	select	id
	into	ug_type
	from	rhnUserGroupType
	where	label = 'channel_admin';
	insert into rhnUserGroup (
		id, name,
		description,
		max_members, group_type, org_id
	) values (
		group_val, 'Channel Administrator',
		'Channel Administrator for Org ' || name_in || ' (1)',
		NULL, ug_type, 1
	);
	insert into rhnOrgState (org_id, state_id)
	select 1, id
	  from rhnOrgAvailableStates
	 where label = 'paid';
        insert into rhnServerGroup
		( id, name, description, max_members, group_type, org_id )
		select rhn_server_group_id_seq.nextval, sgt.name, sgt.name,
			0, sgt.id, 1
		from rhnServerGroupType sgt
		where sgt.label = 'sw_mgr_entitled';
end;
/

ALTER TABLE RHNCHANNELFAMILY DROP CONSTRAINT RHN_CHANNEL_FAMILY_PURCH_NN;
ALTER TABLE RHNREGTOKEN DROP CONSTRAINT RHN_REG_TOKEN_UID_NN;
ALTER PACKAGE RHN_PACKAGE COMPILE BODY;
ALTER TABLE RHNCHANNELFAMILY DROP COLUMN PURCHASABLE;

CREATE OR REPLACE FORCE VIEW RHNCHANNELFAMILYOVERVIEW
(ORG_ID, ID, NAME, URL, CURRENT_MEMBERS, 
 MAX_MEMBERS, HAS_SUBSCRIPTION)
AS 
SELECT WC.id,
       CF.id,
       CF.name,
       CF.product_url,
       NVL((SELECT CFP.current_members
          FROM rhnChannelFamilyPermissions CFP
	 WHERE CFP.channel_family_id = CF.id
	   AND CFP.org_id = WC.id), 0),
       (SELECT CFP.max_members
          FROM rhnChannelFamilyPermissions CFP
	 WHERE CFP.channel_family_id = CF.id
	   AND CFP.org_id = WC.id),
       NVL((SELECT 1
          FROM rhnChannelFamilyPermissions CFP
	 WHERE CFP.channel_family_id = CF.id
	   AND CFP.org_id = WC.id), 0)
  FROM web_customer WC,
       rhnChannelFamily CF
 WHERE EXISTS (SELECT 1 FROM rhnChannelFamilyPermissions WHERE org_id = WC.id AND channel_family_id = CF.id);

CREATE OR REPLACE FORCE VIEW RHNCHANNELTREEVIEW
(ID, DEPTH, NAME, PADDED_NAME, CHANNEL_ARCH_ID, 
 LAST_MODIFIED, LABEL, PARENT_OR_SELF_LABEL)
AS 
SELECT
             id,
             (CASE WHEN parent_channel IS NULL THEN 1 ELSE 2 END) depth,
	     name,
             (CASE WHEN parent_channel IS NULL THEN '  ' ELSE '' END) || name,
	     channel_arch_id,
             last_modified,
             label,
	     (CASE WHEN parent_channel IS NULL THEN label ELSE (select c2.label from rhnChannel c2 where c2.id = c.parent_channel) END)
        FROM rhnChannel C
  ORDER BY (CASE WHEN parent_channel IS NULL THEN label ELSE (select c2.label from rhnChannel c2 where c2.id = c.parent_channel) END), parent_channel NULLS FIRST;

DROP SYNONYM RHNUSER;
CREATE SYNONYM RHNUSER FOR WEB_CONTACT;
ALTER PROCEDURE NEW_USER_POSTOP COMPILE;
ALTER FUNCTION CREATE_NEW_USER COMPILE;
ALTER FUNCTION RHNHISTORYVIEW_ERRATALIST COMPILE;

CREATE OR REPLACE FORCE VIEW RHNAVAILABLECHANNELS
(ORG_ID, CHANNEL_ID, CHANNEL_DEPTH, CHANNEL_NAME, CHANNEL_ARCH_ID, 
 PADDED_NAME, CURRENT_MEMBERS, AVAILABLE_MEMBERS, LAST_MODIFIED, CHANNEL_LABEL, 
 PARENT_OR_SELF_LABEL)
AS 
select
     o.id,
     cperm.channel_id,
     CT.depth,
     CT.name,
     CT.channel_arch_id,
     CT.padded_name,
     (SELECT COUNT(1)
        FROM rhnServer S
       WHERE S.org_id = o.id
         AND EXISTS (SELECT 1 FROM rhnServerChannel WHERE channel_id = cperm.channel_id AND server_id = S.id)),
     rhn_channel.available_chan_subscriptions(cperm.channel_id, o.id),
     CT.last_modified,
     CT.label,
     CT.parent_or_self_label
from
     web_customer O,
     rhnChannelTreeView CT,
     rhnChannelPermissions CPerm
where
    CT.id = CPerm.channel_id
and (o.id = cperm.org_id
 or cperm.org_id is null);

CREATE OR REPLACE FORCE VIEW RHNCHANNELFAMILYSERVERS
(CUSTOMER_ID, CHANNEL_FAMILY_ID, SERVER_ID, CREATED, MODIFIED)
AS 
select	rs.org_id			customer_id,
		rcfm.channel_family_id		channel_family_id,
		rsc.server_id			server_id,
		rsc.created			created,
		rsc.modified			modified
	from	rhnChannelFamilyMembers		rcfm,
		rhnChannelFamily		rcf,
		rhnServerChannel		rsc,
		rhnServer			rs
	where
		rcfm.channel_id = rsc.channel_id
		and rcfm.channel_family_id = rcf.id
		and rsc.server_id = rs.id;

CREATE OR REPLACE FORCE VIEW RHNCHANNELNEWESTPACKAGEVIEW
(CHANNEL_ID, NAME_ID, EVR_ID, PACKAGE_ARCH_ID, PACKAGE_ID)
AS 
select  cp.channel_id		channel_id,
		p.name_id			name_id,
		p.evr_id			evr_id,
		p.package_arch_id	package_arch_id,
		p.id				package_id
from	rhnPackageEVR		pe,
		rhnPackage			p,
		rhnChannelPackage	cp
where	cp.package_id = p.id
		and p.evr_id = pe.id
		and pe.evr = (
			select	max(sq_pe.evr)
			from	rhnChannelPackage sq_cp,
					rhnPackage sq_p,
					rhnPackageEVR sq_pe
			where	1=1
				and sq_cp.channel_id = cp.channel_id
				and sq_cp.package_id = sq_p.id
				and sq_p.name_id = p.name_id
				and sq_pe.id = sq_p.evr_id
		);

CREATE OR REPLACE FORCE VIEW RHNENTITLEDSERVERS
(ID, ORG_ID, DIGITAL_SERVER_ID, SERVER_ARCH_ID, OS, 
 RELEASE, NAME, DESCRIPTION, INFO, SECRET)
AS 
select distinct
    S.id,
    S.org_id,
    S.digital_server_id,
    S.server_arch_id,
    S.os,
    S.release,
    S.name,
    S.description,
    S.info,
    S.secret
from
    rhnServerGroup SG,
    rhnServerGroupType SGT,
    rhnServerGroupMembers SGM,
    rhnServer S
where
    S.id = SGM.server_id
and SG.id = SGM.server_group_id
and (SGT.label = 'sw_mgr_entitled' OR SGT.label = 'enterprise_entitled')
and SG.group_type = SGT.id
and SG.org_id = S.org_id;


CREATE OR REPLACE FORCE VIEW RHNORGPACKAGEOVERVIEW
(ORG_ID, CHANNEL_ARCH_ID, PACKAGE_ID, PACKAGE_NVREA)
AS 
select
    p.org_id org_id,
    cpac.channel_arch_id,
    p.id package_id,
    rhn_package.canonical_name(p_name.name, p_evr.evr, pa.name) package_nvrea
from
    rhnPackageName p_name,
    rhnPackageEVR p_evr,
    rhnPackageArch pa,
    rhnChannelPackageArchCompat cpac,
    rhnPackage p
where
        p_name.id = p.name_id
    and p_evr.id = p.evr_id
    and cpac.package_arch_id = p.package_arch_id
    and p.package_arch_id = pa.id
order by package_nvrea, p.created;

CREATE OR REPLACE FORCE VIEW RHNPRIVATEERRATAMAIL
(LOGIN, LOGIN_UC, EMAIL, USER_ID, SERVER_ID, 
 ORG_ID, SERVER_NAME, SERVER_ARCH, SERVER_RELEASE, ERRATA_ID, 
 ADVISORY)
AS 
select
	w.login,
	w.login_uc,
	wpi.email,
	w.id user_id,
	s.id server_id,
	w.org_id org_id,
	s.name server_name,
	sa.name server_arch,
	s.release server_release,
	ce.errata_id errata_id,
	e.advisory
from
	rhnServer s,
	web_user_personal_info wpi,
	rhnUserInfo ui,
	rhnErrata e,
	rhnServerArch sa,
	rhnChannelErrata ce,
	web_contact w,
	rhnServerChannel sc,
	rhnServerGroupMembers sgm,
	rhnServerGroup sg
where	1=1
	and sg.id = sgm.server_group_id
	and sgm.server_id = sc.server_id
	and sg.org_id = w.org_id
	and not exists (
		select	usprefs.server_id
            	from	rhnUserServerPrefs usprefs
	   	where	1=1
			and w.id = usprefs.user_id
	      		and sc.server_id = usprefs.server_id
	      		and usprefs.name = 'receive_notifications'
	)
	and w.id = wpi.web_user_id
	and wpi.email is not null
	and w.id = ui.user_id
    	and ui.email_notify = 1
	and exists (
		select	1
		from
			rhnUserGroupType	ugt,
			rhnUserGroup		ug,
			rhnUserGroupMembers	ugm
		where	1=1
			and ugt.label = 'org_admin'
			and ugt.id = ug.group_type
			and ug.id = ugm.user_group_id
			and ugm.user_id = w.id
		union all
		select	1
		from
			rhnServerGroupMembers	sq_sgm,
			rhnUserServerGroupPerms	usg
		where	sc.server_id = sq_sgm.server_id
			and sq_sgm.server_group_id = usg.server_group_id
			and usg.user_id = w.id
	)
	and sc.channel_id = ce.channel_id
	and sc.server_id = s.id
    	and exists (
        	select 1
		from
	    		rhnPackageEVR			p_evr,
	    		rhnPackageEVR			sp_evr,
	    		rhnServerPackage 		sp,
	    		rhnChannelPackage		cp,
	    		rhnPackage			p,
	    		rhnErrataPackage		ep,
	    		rhnServerPackageArchCompat	spac
		where	1=1
			and sc.channel_id = cp.channel_id
			and cp.package_id = p.id
			and ce.errata_id = ep.errata_id
			and ep.package_id = p.id
			and sc.channel_id = ce.channel_id
			and ce.errata_id = ep.errata_id
			and sc.server_id = sp.server_id
			and sp.name_id = p.name_id
			and sp.evr_id = sp_evr.id
			and p.evr_id = p_evr.id
			and sp.evr_id != p.evr_id
			and sp_evr.evr < p_evr.evr
			and sp_evr.evr = (
				select	max(sq2_pe.evr)
				from	rhnServerPackage	sq2_sp,
					rhnPackageEVR		sq2_pe
				where	sp.server_id = sq2_sp.server_id
					and sp.name_id = sq2_sp.name_id
					and sq2_sp.evr_id = sq2_pe.id
			)
			and p.package_arch_id = spac.package_arch_id
			and s.server_arch_id = spac.server_arch_id
	)
	and s.server_arch_id = sa.id
	and ce.errata_id = e.id;

ALTER PROCEDURE PROCESS_ERRATA_CACHE_QUEUE COMPILE;

ALTER TABLE RHNREGTOKENCHANNELS DROP CONSTRAINT RHN_REG_TOK_CHN_ID_FK;
ALTER TABLE RHNREGTOKENCHANNELS ADD CONSTRAINT RHN_REG_TOK_CHN_ID_FK FOREIGN KEY (TOKEN_ID) 
    REFERENCES RHNREGTOKEN (ID)
    ON DELETE CASCADE;

ALTER TABLE RHNREGTOKENGROUPS DROP CONSTRAINT RHN_REG_TOK_GRP_ID_FK;
ALTER TABLE RHNREGTOKENGROUPS ADD CONSTRAINT RHN_REG_TOK_GRP_ID_FK FOREIGN KEY (TOKEN_ID) 
    REFERENCES RHNREGTOKEN (ID)
    ON DELETE CASCADE;

ALTER TABLE RHNSERVERTOKENREGS DROP CONSTRAINT RHN_SRV_REG_TOK_TID_FK;
ALTER TABLE RHNSERVERTOKENREGS ADD CONSTRAINT RHN_SRV_REG_TOK_TID_FK FOREIGN KEY (TOKEN_ID) 
    REFERENCES RHNREGTOKEN (ID)
    ON DELETE CASCADE;


ALTER TABLE RHNSATELLITECERT ADD (LABEL  VARCHAR2(64), VERSION NUMBER);
CREATE UNIQUE INDEX RHN_SATCERT_LABEL_VERSION_UQ ON RHNSATELLITECERT
(LABEL, VERSION)
LOGGING
NOPARALLEL;

ALTER TABLE RHNSATELLITECERT ADD CONSTRAINT RHN_SATCERT_LABEL_NN CHECK ("LABEL" IS NOT NULL);



INSERT INTO RHNFAQCLASS ( ID, NAME, LABEL, ORDERING ) VALUES ( 
1, 'General', 'general', 100); 
INSERT INTO RHNFAQCLASS ( ID, NAME, LABEL, ORDERING ) VALUES ( 
2, 'Account Management', 'account_management', 120); 
INSERT INTO RHNFAQCLASS ( ID, NAME, LABEL, ORDERING ) VALUES ( 
3, 'Getting Started', 'getting_started', 140); 
INSERT INTO RHNFAQCLASS ( ID, NAME, LABEL, ORDERING ) VALUES ( 
4, 'Service Levels', 'service_levels', 160); 
INSERT INTO RHNFAQCLASS ( ID, NAME, LABEL, ORDERING ) VALUES ( 
5, 'Using RHN', 'using_rhn', 180); 
INSERT INTO RHNFAQCLASS ( ID, NAME, LABEL, ORDERING ) VALUES ( 
6, 'Technical Questions', 'technical_questions', 200); 
INSERT INTO RHNFAQCLASS ( ID, NAME, LABEL, ORDERING ) VALUES ( 
7, 'Enterprise Service', 'enterprise_service', 220); 
INSERT INTO RHNFAQCLASS ( ID, NAME, LABEL, ORDERING ) VALUES ( 
8, 'Privacy/Legal', 'legal', 240); 
INSERT INTO RHNFAQCLASS ( ID, NAME, LABEL, ORDERING ) VALUES ( 
9, 'Policies', 'policy', 260); 
INSERT INTO RHNFAQCLASS ( ID, NAME, LABEL, ORDERING ) VALUES ( 
11, 'Definitions', 'definitions', 270); 
COMMIT;

SET SQLBLANKLINES ON
SET SCAN OFF

delete from rhnfaq;
INSERT INTO RHNFAQ ( ID, SUBJECT, DETAILS, PRIVATE, CREATED, MODIFIED, USAGE_COUNT,
CLASS_ID ) VALUES ( 
64, 'pvt: This message is being forwarded to customerservice@redhat.com', 'This message has been forwarded to customerservice@redhat.com.  That group handles all billing and purchasing related questions.'
, 1,  TO_Date( '10/02/2002 12:00:00 AM', 'MM/DD/YYYY HH:MI:SS AM'),  TO_Date( '05/12/2003 10:18:24 PM', 'MM/DD/YYYY HH:MI:SS AM')
, 22, 1); 
INSERT INTO RHNFAQ ( ID, SUBJECT, DETAILS, PRIVATE, CREATED, MODIFIED, USAGE_COUNT,
CLASS_ID ) VALUES ( 
65, 'I''m having trouble registering my Red Hat Enterprise Linux product.  Why?', 'Enterprise entitlements are required for use with Red Hat Enterprise Linux.

A customer who registers an Enterprise Linux system with RHN without having any Enterprise Linux entitlements will receive an error message similar to:

"No public channels available for ("2.1AS'', ''i686'')"

In order to register your system, you first need to activate your RHN Enterprise Linux entitlements at:

http://www.redhat.com/support

Use the product ID that came with your Red Hat Enterprise Linux product.
'
, 0,  TO_Date( '10/02/2002 12:00:00 AM', 'MM/DD/YYYY HH:MI:SS AM'),  TO_Date( '03/31/2003 09:26:12 AM', 'MM/DD/YYYY HH:MI:SS AM')
, 13, 7); 
INSERT INTO RHNFAQ ( ID, SUBJECT, DETAILS, PRIVATE, CREATED, MODIFIED, USAGE_COUNT,
CLASS_ID ) VALUES ( 
66, 'pvt: I bought service with RHN, but it won''t let me use Priority FTP access.  Why not?vp'
, 'Instant ISO access is not the same as Priority FTP access; they are separate entities.  Customers who purchase Red Hat Network service have Instant ISO access only.  Priority FTP access is available only to legacy users, and is in the process of being phased out.
'
, 1,  TO_Date( '10/02/2002 12:00:00 AM', 'MM/DD/YYYY HH:MI:SS AM'),  TO_Date( '04/24/2003 09:34:56 PM', 'MM/DD/YYYY HH:MI:SS AM')
, 6, 1); 
INSERT INTO RHNFAQ ( ID, SUBJECT, DETAILS, PRIVATE, CREATED, MODIFIED, USAGE_COUNT,
CLASS_ID ) VALUES ( 
67, 'How do I register a system for RHN service on Red Hat Linux?', 'To register a system for RHN service on Red Hat Linux please run "rhn_register". Refer to the RHN User Guide (also available through the Help link at the RHN website) for additional instructions.

Note: for Red Hat Linux 8.0 and later, please run "up2date --register" instead of "rhn_register".
'
, 0,  TO_Date( '10/02/2002 12:00:00 AM', 'MM/DD/YYYY HH:MI:SS AM'),  TO_Date( '04/16/2003 09:09:30 PM', 'MM/DD/YYYY HH:MI:SS AM')
, 19, 3); 
INSERT INTO RHNFAQ ( ID, SUBJECT, DETAILS, PRIVATE, CREATED, MODIFIED, USAGE_COUNT,
CLASS_ID ) VALUES ( 
25, 'The RHN website and up2date do not agree on what errata is needed for my system.'
, 'You can refresh the profile package list by running "up2date -p" on the machine itself.  Alternatively, you can schedule this from the website by clicking on the system in the System List, choosing the Packages tab, and then clicking on the "Update Package List" button at the bottom of the page.
'
, 0,  TO_Date( '06/14/2002 12:00:00 AM', 'MM/DD/YYYY HH:MI:SS AM'),  TO_Date( '04/14/2003 09:24:01 PM', 'MM/DD/YYYY HH:MI:SS AM')
, 10, 6); 
INSERT INTO RHNFAQ ( ID, SUBJECT, DETAILS, PRIVATE, CREATED, MODIFIED, USAGE_COUNT,
CLASS_ID ) VALUES ( 
26, 'I had to re-install my system. How do I re-register and get my entitlement back?'
, 'You''ll need to re-register the client system if you haven''t already, and then move an entitlement to the new profile.

* Log into our website at:  https://rhn.redhat.com.
* Click on "Systems" in the top navigation bar, then the name of the old system in the System List.
* Click "delete system" on the top-right corner of the page.
* As root at the command line, delete the file /etc/sysconfig/rhn/systemid from your system.
* Run "rhn_register" (Red Hat Linux 7.x) or "up2date --register" (Red Hat Linux 8.0 and newer) on your system.
* Once the system is registered, log in at https://rhn.redhat.com.
* Click "Systems" in the top navigation bar, then "System Entitlements" on the left.
* Select the appropriate entitlement level for the new system and click "Update Entitlements."'
, 0,  TO_Date( '06/14/2002 12:00:00 AM', 'MM/DD/YYYY HH:MI:SS AM'),  TO_Date( '05/18/2003 09:42:55 PM', 'MM/DD/YYYY HH:MI:SS AM')
, 411, 5); 
INSERT INTO RHNFAQ ( ID, SUBJECT, DETAILS, PRIVATE, CREATED, MODIFIED, USAGE_COUNT,
CLASS_ID ) VALUES ( 
27, 'How can I request a new feature or improvement for the Red Hat Network?', 'For technical requests, you can make a "Request for Enhancement" (RFE) at http://bugzilla.redhat.com/bugzilla.  The product is "Red Hat Network" and the various components are prefaced by "RHN/".  Please put "[RFE]" at the beginning of the summary line of your request.

If you would like to provide non-technical feedback to Red Hat Network, please go to https://rhn.redhat.com/help/contact.pxt and follow the directions for "feedback".
'
, 0,  TO_Date( '06/14/2002 12:00:00 AM', 'MM/DD/YYYY HH:MI:SS AM'),  TO_Date( '05/18/2003 09:56:14 PM', 'MM/DD/YYYY HH:MI:SS AM')
, 74, 9); 
INSERT INTO RHNFAQ ( ID, SUBJECT, DETAILS, PRIVATE, CREATED, MODIFIED, USAGE_COUNT,
CLASS_ID ) VALUES ( 
28, 'Where do I report a bug in the RHN website or update agent?', 'Bugs can be reported at http://bugzilla.redhat.com/bugzilla -- the product is "Red Hat Network", and the various components are prefixed with "RHN/".

Please be sure to read the FAQ and review all of the open bugs before submitting your bug.
'
, 0,  TO_Date( '06/14/2002 12:00:00 AM', 'MM/DD/YYYY HH:MI:SS AM'),  TO_Date( '05/15/2003 10:47:49 PM', 'MM/DD/YYYY HH:MI:SS AM')
, 45, 9); 
INSERT INTO RHNFAQ ( ID, SUBJECT, DETAILS, PRIVATE, CREATED, MODIFIED, USAGE_COUNT,
CLASS_ID ) VALUES ( 
30, 'What is the difference between i386, i586, and i686 packages?', 'i386 is a generic designation for all processors backwardly compatible with the Intel 80386; i586 is for all processors backwardly compatible with the Intel Pentium; and i686 is for Intel processors backwardly compatible with the Pentium Pro chip (Pentium II, III, IV, etc).  Only the kernel has i586 and i686 versions, and glibc has an i686 version.  up2date should automatically determine which versions of the kernel and glibc packages are appropriate for your systems.
'
, 0,  TO_Date( '06/14/2002 12:00:00 AM', 'MM/DD/YYYY HH:MI:SS AM'),  TO_Date( '04/15/2003 10:33:49 PM', 'MM/DD/YYYY HH:MI:SS AM')
, 8, 11); 
INSERT INTO RHNFAQ ( ID, SUBJECT, DETAILS, PRIVATE, CREATED, MODIFIED, USAGE_COUNT,
CLASS_ID ) VALUES ( 
1, 'What is Red Hat Network?', 'Red Hat Network is a systems support and management environment for Red Hat Linux systems and networks. For more information, please see the Red Hat Network product information page:
http://www.redhat.com/software/rhn/offerings/

For individual systems and small networks, see http://www.redhat.com/software/rhn

For enterprise deployments, see http://www.redhat.com/software/rhen
'
, 0,  TO_Date( '03/07/2002 12:00:00 AM', 'MM/DD/YYYY HH:MI:SS AM'),  TO_Date( '05/14/2003 05:00:08 AM', 'MM/DD/YYYY HH:MI:SS AM')
, 26, 1); 
INSERT INTO RHNFAQ ( ID, SUBJECT, DETAILS, PRIVATE, CREATED, MODIFIED, USAGE_COUNT,
CLASS_ID ) VALUES ( 
3, 'Does Red Hat Network only work on Linux? Which versions?', 'Yes. Red Hat Network currently only supports versions of Red Hat Linux and Red Hat Enterprise Linux that are still active (have not yet reached End of Life status). For a list of currently maintained Red Hat versions, please go to http://www.redhat.com/apps/support/errata/

Please note that Red Hat''s Enterprise Network Monitoring Module does support different platforms. For more information, please go to http://www.redhat.com/software/rhen/system_mgmt/
'
, 0,  TO_Date( '03/07/2002 12:00:00 AM', 'MM/DD/YYYY HH:MI:SS AM'),  TO_Date( '03/31/2003 09:26:12 AM', 'MM/DD/YYYY HH:MI:SS AM')
, 4, 1); 
INSERT INTO RHNFAQ ( ID, SUBJECT, DETAILS, PRIVATE, CREATED, MODIFIED, USAGE_COUNT,
CLASS_ID ) VALUES ( 
5, 'I can''t find the Red Hat Network Registration Client.  What is it and where do I find it?'
, 'The Red Hat Network Registration Client steps you through the process of creating a user account if you do not already have one and registering your system by creating a System Profile. It can be started by using one of the following methods:

* On the GNOME desktop, go to the Main Menu Button (on the Panel) => Programs => System => Red Hat Network.
* On the KDE desktop, go to the Main Menu Button (on the Panel) => System => Red Hat Network
* At a shell prompt, type the command "rhn_register".

In Red Hat Linux 8.0 and newer, rhn_register exists as a mode of the up2date client, so:

* On the GNOME and KDE desktops, go to the Main Menu Button (on the Panel) => System Tools => Red Hat Network. (If the system is unregistered, it will automatically launch in registration mode.)
* At a shell prompt (for example, an xterm or gnome-terminal), type the command "up2date --register".
'
, 0,  TO_Date( '03/07/2002 12:00:00 AM', 'MM/DD/YYYY HH:MI:SS AM'),  TO_Date( '05/19/2003 01:31:52 AM', 'MM/DD/YYYY HH:MI:SS AM')
, 126, 5); 
INSERT INTO RHNFAQ ( ID, SUBJECT, DETAILS, PRIVATE, CREATED, MODIFIED, USAGE_COUNT,
CLASS_ID ) VALUES ( 
7, 'I forgot my username and password. How do I access my account?', 'From the front page, click on the "Lost Password?" link, enter your username and email address, and then click the "Send Password" button.

If you have neither your username nor your password, enter your email address in the second field provided, and then click the "Send Account List" button.

If the email address matches the email address on file for your account, your information will be sent to you. If this does not work for you, please call our customer service desk at 1-866-2-RedHat.
'
, 0,  TO_Date( '03/07/2002 12:00:00 AM', 'MM/DD/YYYY HH:MI:SS AM'),  TO_Date( '04/16/2003 09:14:22 PM', 'MM/DD/YYYY HH:MI:SS AM')
, 16, 2); 
INSERT INTO RHNFAQ ( ID, SUBJECT, DETAILS, PRIVATE, CREATED, MODIFIED, USAGE_COUNT,
CLASS_ID ) VALUES ( 
8, 'What are the service levels for Red Hat Network?', 'Red Hat Network currently offers three levels of service: RHN Demo Service, RHN Basic Service and RHN Enterprise Service.  For more details, go to http://www.redhat.com/software/rhn/offerings
'
, 0,  TO_Date( '03/07/2002 12:00:00 AM', 'MM/DD/YYYY HH:MI:SS AM'),  TO_Date( '05/08/2003 03:43:45 AM', 'MM/DD/YYYY HH:MI:SS AM')
, 50, 4); 
INSERT INTO RHNFAQ ( ID, SUBJECT, DETAILS, PRIVATE, CREATED, MODIFIED, USAGE_COUNT,
CLASS_ID ) VALUES ( 
69, 'pvt: You are sending packets to my machine! (Firewall log attached)', 'As you can see, the packets you are seeing are response packets coming from our host and port 443 to your machine.

These packets have the SYN/ACK flags set up. These types of packets are sent only in response to a connection request from your computer.

TCP uses a three-way handshake protocol to establish a connection:
* the client sends a SYN packet to the server requesting a connection
* the server acknowledges the request and sends back a SYN/ACK packet
* the client responds back with an ACK packet and the connection is established

Your firewall rules are not allowing the server responses to pass through.  The rhnsd daemon is initiating these requests. You have 2 choices:

* fix the firewall rules so you allow the reply packets to pass through and therefore allow your host to connect outside; or
* disable the rhnsd daemon: service rhnsd stop
'
, 1,  TO_Date( '10/02/2002 12:00:00 AM', 'MM/DD/YYYY HH:MI:SS AM'),  TO_Date( '03/31/2003 09:26:11 AM', 'MM/DD/YYYY HH:MI:SS AM')
, 3, 1); 
INSERT INTO RHNFAQ ( ID, SUBJECT, DETAILS, PRIVATE, CREATED, MODIFIED, USAGE_COUNT,
CLASS_ID ) VALUES ( 
125, 'pvt: no RHL support at rhn-help', 'This address is intended for support questions related only to Red Hat
Network. General Red Hat Linux support is not available from this address.

If you have not already done so, you can activate your product and receive advanced support at:

https://www.redhat.com/apps/support/

Even if you are not registered with Red Hat Support, you are welcome to browse
our documentation and online resources available at:

https://www.redhat.com/docs/

You may also get access to Tips, FAQs, and online HOWTOs to guide you through
Linux-related tasks if you start looking from our Support Resources Home Page
available at:

https://www.redhat.com/apps/support/resources/

The Red Hat mailing lists are also good venues for finding answers to your
questions. For more information on the Red Hat mailing lists, please see:

http://www.redhat.com/mailing-lists/

If you would like to report a bug or a problem with a component of the Red Hat Linux distribution, we encourage you to visit our bug tracking system and file a bug report at:

http://bugzilla.redhat.com/bugzilla
'
, 1,  TO_Date( '12/11/2002 12:00:00 AM', 'MM/DD/YYYY HH:MI:SS AM'),  TO_Date( '03/31/2003 09:26:12 AM', 'MM/DD/YYYY HH:MI:SS AM')
, 288, 1); 
INSERT INTO RHNFAQ ( ID, SUBJECT, DETAILS, PRIVATE, CREATED, MODIFIED, USAGE_COUNT,
CLASS_ID ) VALUES ( 
126, 'How do I change my RHN password?', 'To change your password:

* Log in to the Red Hat Network website with your existing username and password.
* If you are not at Your RHN page, click its link in the top navigation bar.
* Click "Your Account" in the left navigation bar.
* Type your new password in both the Password and Password Confirmation fields.
* Click the "Update" button.
'
, 0,  TO_Date( '12/12/2002 12:00:00 AM', 'MM/DD/YYYY HH:MI:SS AM'),  TO_Date( '03/31/2003 09:26:12 AM', 'MM/DD/YYYY HH:MI:SS AM')
, 9, 2); 
INSERT INTO RHNFAQ ( ID, SUBJECT, DETAILS, PRIVATE, CREATED, MODIFIED, USAGE_COUNT,
CLASS_ID ) VALUES ( 
13, 'What is "rhnsd" and why is it running on my system?', '"rhnsd" is the Red Hat Network Daemon. Every other hour, it sends a request to Red Hat Network asking for any notifications or updates and works in coordination with Red Hat Network to schedule automated tasks. It sends information to Red Hat Network only requested by you. If you add a new system using the Red Hat Network web interface, the next time the Red Hat Network Daemon probes Red Hat Network it receives a request to return the information you requested as part of your System Profile, such as what package versions are installed on your system.
'
, 0,  TO_Date( '03/07/2002 12:00:00 AM', 'MM/DD/YYYY HH:MI:SS AM'),  TO_Date( '04/08/2003 10:52:29 PM', 'MM/DD/YYYY HH:MI:SS AM')
, 9, 6); 
INSERT INTO RHNFAQ ( ID, SUBJECT, DETAILS, PRIVATE, CREATED, MODIFIED, USAGE_COUNT,
CLASS_ID ) VALUES ( 
15, 'My systems are not checking in.  What does that mean?', 'When the RHN client connects to RHN to see if there are any updates available, or if any actions have been scheduled, this is considered a checkin.

If you are seeing a message indicating that checkins are not happening, it means that the RHN client on your system is not successfully reaching Red Hat Network for some reason. Things to check:
* Make certain that your client is configured correctly.
* Make sure that your system can communicate with RHN via SSL (port 443).  You may test this by running the following command from a shell prompt: telnet xmlrpc.rhn.redhat.com 443
* Make sure that the rhnsd daemon is activated and running.  You may ensure this by running the following commands:
chkconfig --level 345 rhnsd on
service rhnsd start

If these settings are correct and your system still is not checking in, the ''Repairing a corrupt rpm database'' faq at http://rhn.redhat.com/help/faq/technical_questions.pxt#227 , or get in touch with our technical support team.
'
, 0,  TO_Date( '03/07/2002 12:00:00 AM', 'MM/DD/YYYY HH:MI:SS AM'),  TO_Date( '05/14/2003 05:04:29 AM', 'MM/DD/YYYY HH:MI:SS AM')
, 151, 5); 
INSERT INTO RHNFAQ ( ID, SUBJECT, DETAILS, PRIVATE, CREATED, MODIFIED, USAGE_COUNT,
CLASS_ID ) VALUES ( 
17, 'Can I use Red Hat Network to upgrade my Red Hat Linux kernel?', 'Yes. You must use Red Hat Update Agent version 2.5.4 or higher. If you choose the kernel packages and allow Red Hat Network to install them to your system, it will modify your LILO or GRUB configuration file so that your system boots the new kernel the next time it is rebooted.
'
, 0,  TO_Date( '03/07/2002 12:00:00 AM', 'MM/DD/YYYY HH:MI:SS AM'),  TO_Date( '03/31/2003 09:26:12 AM', 'MM/DD/YYYY HH:MI:SS AM')
, 11, 5); 
INSERT INTO RHNFAQ ( ID, SUBJECT, DETAILS, PRIVATE, CREATED, MODIFIED, USAGE_COUNT,
CLASS_ID ) VALUES ( 
41, 'pvt: Updates to newer versions recommended by third-party security advisories.'
, 'We have released fixes for all known vulnerabilities you are mentioning.  Red Hat does not usually update to a new code base for the core applications and libraries if we have other options available. In the cases you have mentioned we choose to backport the security fixes to the code base we initially shipped to our customers. We do this in order to minimize the impact on the stability and the QA resources that both we and the customers invest in qualifying a particular release for a particular task.

The latest versions of those packages provided by Red Hat are not vulnerable to the issues you mention.
'
, 1,  TO_Date( '10/01/2002 12:00:00 AM', 'MM/DD/YYYY HH:MI:SS AM'),  TO_Date( '04/13/2003 11:31:22 PM', 'MM/DD/YYYY HH:MI:SS AM')
, 10, 1); 
INSERT INTO RHNFAQ ( ID, SUBJECT, DETAILS, PRIVATE, CREATED, MODIFIED, USAGE_COUNT,
CLASS_ID ) VALUES ( 
62, 'Is Red Hat Technical Support available in other languages besides English?', 'At this time, Red Hat Network technical support is English only.
'
, 0,  TO_Date( '10/02/2002 12:00:00 AM', 'MM/DD/YYYY HH:MI:SS AM'),  TO_Date( '04/27/2003 10:32:41 PM', 'MM/DD/YYYY HH:MI:SS AM')
, 26, 4); 
INSERT INTO RHNFAQ ( ID, SUBJECT, DETAILS, PRIVATE, CREATED, MODIFIED, USAGE_COUNT,
CLASS_ID ) VALUES ( 
63, 'How do I download RPMs for a system without using up2date?', 'It is possible for Red Hat Network users to download updated packages directly from the RHN website without using up2date.

To download them:

* Log in to the RHN web site.
* Click "Software" in the top navigation bar.
* Click the appropriate channel name.
* On the Channel Details page, click the "Packages" tab.
* Select the RPMs you want and click the "Download" button. You will be presented with a confirmation screen.
* Click "Download Selected Packages Now!"
* You will then be asked for the location to save the tar archive containing all the packages you selected.
* To extract the packages once the download is complete, run: tar -xvf rhn-packages.tar
'
, 0,  TO_Date( '10/02/2002 12:00:00 AM', 'MM/DD/YYYY HH:MI:SS AM'),  TO_Date( '03/31/2003 09:26:12 AM', 'MM/DD/YYYY HH:MI:SS AM')
, 9, 5); 
INSERT INTO RHNFAQ ( ID, SUBJECT, DETAILS, PRIVATE, CREATED, MODIFIED, USAGE_COUNT,
CLASS_ID ) VALUES ( 
12, 'My RHN subscriptions have expired.  What should I do to renew them?', 'Paid subscriptions are annual and renew automatically each year.  You will receive notification of this renewal within 30 days of its occurrence.  If you choose not to renew, you may call Red Hat customer service at 1-888-REDHAT1 to cancel (or your Regional Headquarters, if you''re outside the U.S.).

Trial subscriptions are fixed in length and are not renewable.  You may purchase annual subscriptions to replace the trial subscriptions; refer to https://rhn.redhat.com/network/sales/index.pxt for details on how to purchase Red Hat Network subscriptions.
'
, 0,  TO_Date( '03/07/2002 12:00:00 AM', 'MM/DD/YYYY HH:MI:SS AM'),  TO_Date( '03/31/2003 09:26:12 AM', 'MM/DD/YYYY HH:MI:SS AM')
, 3, 2); 
INSERT INTO RHNFAQ ( ID, SUBJECT, DETAILS, PRIVATE, CREATED, MODIFIED, USAGE_COUNT,
CLASS_ID ) VALUES ( 
31, 'The update agent wants to install an older version of a package.  Why?', 'This is probably because of the epoch number of the package.  RPM checks three things when it tries to determine whether a package is newer: epoch, version, and release, in that order.  A higher epoch number trumps both version and release.  To see the epoch number on an installed package, use the command:

rpm -q --queryformat "%{NAME}-%{VERSION}-%{RELEASE}:%{EPOCH}\n" packagename

The epoch is the number after the colon.  On the RHN website, you can also see the epoch for the package on the Installed Packages list for the system, (again, the number after the colon).

Epoch numbers are used to preserve RPM''s concept of "newer" when package versions are changed inconveniently. The classic example of the need for an epoch is perl, which changed from version 5.00503 to 5.6, thereby breaking rpm''s segmented version comparison (i.e the integer 6 < 503, rather than 5.6 > 5.00503).

To keep the update agent from trying to update your package, add it to the package skip list (pkgSkipList) in your up2date configuration:

up2date --configure --nox

However, the package will still show up on your list of applicable errata.
'
, 0,  TO_Date( '06/14/2002 12:00:00 AM', 'MM/DD/YYYY HH:MI:SS AM'),  TO_Date( '04/06/2003 10:26:15 PM', 'MM/DD/YYYY HH:MI:SS AM')
, 7, 6); 
INSERT INTO RHNFAQ ( ID, SUBJECT, DETAILS, PRIVATE, CREATED, MODIFIED, USAGE_COUNT,
CLASS_ID ) VALUES ( 
32, 'pvt: Red Hat Linux support', 'This address is intended for support questions related only to Red Hat Network. General Red Hat Linux support is not available from this address.  If you are registered with Red Hat Support, you may address your questions at:
http://www.redhat.com/support

If you have not already done so, you can activate your product and receive advanced support at:

https://www.redhat.com/apps/support/

Even if you are not registered with Red Hat Support, you are welcome to browse
our documentation and online resources available at:

https://www.redhat.com/docs/

You may also get access to Tips, FAQs, and online HOWTOs to guide you through
Linux-related tasks if you start looking from our Support Resources Home Page
available at:

https://www.redhat.com/apps/support/resources/

The Red Hat mailing lists are also good venues for finding answers to your
questions. For more information on the Red Hat mailing lists, please see:

http://www.redhat.com/mailing-lists/

If you would like to report a bug or a problem with a component of the Red Hat Linux distribution, we encourage you to visit our bug tracking system and file a bug report at:

http://bugzilla.redhat.com/bugzilla
'
, 1,  TO_Date( '06/22/2002 12:00:00 AM', 'MM/DD/YYYY HH:MI:SS AM'),  TO_Date( '05/19/2003 01:13:04 AM', 'MM/DD/YYYY HH:MI:SS AM')
, 768, 1); 
INSERT INTO RHNFAQ ( ID, SUBJECT, DETAILS, PRIVATE, CREATED, MODIFIED, USAGE_COUNT,
CLASS_ID ) VALUES ( 
33, 'How do I delete System Profiles?', 'In order to delete System Profiles from Red Hat Network, you need to log in to the RHN website at https://rhn.redhat.com.  Once logged in, click on the "Systems" link in the top navigation bar, which will take you to a list of the profiles you have registered with RHN. (If you instead see System Groups, click "View Systems" near the top of the page.)

Click on the name of the profile you wish to delete from the service. This will bring up its System Details page. Click the "delete system" button at the top-right corner of the page. Then confirm that you wish to delete the profile.

The profile will be removed after confirmation.
'
, 0,  TO_Date( '06/24/2002 12:00:00 AM', 'MM/DD/YYYY HH:MI:SS AM'),  TO_Date( '05/12/2003 10:57:15 PM', 'MM/DD/YYYY HH:MI:SS AM')
, 89, 7); 
INSERT INTO RHNFAQ ( ID, SUBJECT, DETAILS, PRIVATE, CREATED, MODIFIED, USAGE_COUNT,
CLASS_ID ) VALUES ( 
36, 'pvt: Educational Channel', 'The educational channel and Red Hat educational initiative is currently undergoing some changes (all for the positive). Please stay tuned and periodically check the following websites for more information:

www.redhat.com
www.redhat.com/index2.html
www.redhat.com/software/rhn
'
, 1,  TO_Date( '08/20/2002 12:00:00 AM', 'MM/DD/YYYY HH:MI:SS AM'),  TO_Date( '03/31/2003 09:26:13 AM', 'MM/DD/YYYY HH:MI:SS AM')
, 14, 1); 
INSERT INTO RHNFAQ ( ID, SUBJECT, DETAILS, PRIVATE, CREATED, MODIFIED, USAGE_COUNT,
CLASS_ID ) VALUES ( 
35, 'An errata install fails with dependency errors, but dependencies are satisfied.  Why?'
, 'Sometimes the application of an errata from the RHN web site will fail because the errata applies to packages that are set to be skipped in the local skip list for a system''s up2date client.  The error message in the history log will incorrectly cite a dependency problem.

To fix this problem, run:

up2date --configure

...as root from the client system, and remove the relevant packages from the skip list.  Rescheduling the errata should then work as expected.
'
, 0,  TO_Date( '08/20/2002 12:00:00 AM', 'MM/DD/YYYY HH:MI:SS AM'),  TO_Date( '05/13/2003 10:24:11 PM', 'MM/DD/YYYY HH:MI:SS AM')
, 23, 6); 
INSERT INTO RHNFAQ ( ID, SUBJECT, DETAILS, PRIVATE, CREATED, MODIFIED, USAGE_COUNT,
CLASS_ID ) VALUES ( 
249, 'Where can I see a copy of the SLA (Service Level Agreement) for RHN Technical Support?'
, 'This can be viewed online at the following site:

http://www.redhat.com/services/techsupport/production/RHN_basic.html'
, 0,  TO_Date( '03/31/2003 11:55:25 AM', 'MM/DD/YYYY HH:MI:SS AM'),  TO_Date( '04/09/2003 11:00:32 PM', 'MM/DD/YYYY HH:MI:SS AM')
, 6, 4); 
INSERT INTO RHNFAQ ( ID, SUBJECT, DETAILS, PRIVATE, CREATED, MODIFIED, USAGE_COUNT,
CLASS_ID ) VALUES ( 
288, 'My system''s IP address and hostname have changed, but RHN doesn''t reflect this. What should I do?'
, 'RHN stores a profile for each registered system. In addition to properties set by the user during registration, this profile may contain various kinds of information about the system''s hardware, including processor type, networking addresses, and storage devices. This information can be found in the RHN website:

1. Once logged in, click on Systems in the top navigation bar.
2. Click on the name of a system in one of the lists. (This may require leaving a System Groups view.)
3. In the System Details page, click the Hardware subtab. All of the hardware information RHN has collected about your system will appear on the resulting page.
4. To update this information, click the Schedule Hardware Refresh button. The hardware profile will be updated at the system''s next connection to RHN.'
, 0,  TO_Date( '04/22/2003 04:00:05 PM', 'MM/DD/YYYY HH:MI:SS AM'),  TO_Date( '04/23/2003 09:45:57 AM', 'MM/DD/YYYY HH:MI:SS AM')
, 0, 6); 
INSERT INTO RHNFAQ ( ID, SUBJECT, DETAILS, PRIVATE, CREATED, MODIFIED, USAGE_COUNT,
CLASS_ID ) VALUES ( 
289, 'Can I change my company name?', 'Yes, but you must do it through redhat.com. Go to https://www.redhat.com/ and click the "Account" link near the top-right corner. Sign in if you are not already logged in, and then click the "Account Details" link.

In the Edit Account Details page, replace your company name in the appropriate field and click the "Finish" button at the bottom. The change will appear in the RHN website immediately.'
, 0,  TO_Date( '04/22/2003 05:34:54 PM', 'MM/DD/YYYY HH:MI:SS AM'),  TO_Date( '04/24/2003 07:40:33 PM', 'MM/DD/YYYY HH:MI:SS AM')
, 0, 2); 
INSERT INTO RHNFAQ ( ID, SUBJECT, DETAILS, PRIVATE, CREATED, MODIFIED, USAGE_COUNT,
CLASS_ID ) VALUES ( 
290, 'Why does up2date tell me "Your system is fully updated" when the RHN website lists updates for my system?'
, 'This error is likely caused by one of two problems: Either the system''s package profile on RHN is out of date or up2date''s package exceptions list is preventing the updates from occurring.

Since updating the package profile is simplest, try this first. Log into the RHN website, click "Systems" in the top navigation bar, and then click the name of the system. In the System Details page, click the "Packages" tab and then click the "Update Package List" button. The profile will be updated when the system next connects to RHN. This should either remove the updates listed for your system or allow you to conduct the updates if they remain.

If this still does not resolve the error, check your package exceptions list, which enables you to identify packages to be exempt from updates. To ensure your settings are not preventing the updates, launch the Update Agent Configuration Tool by running the command:

up2date-config

In the tool, click the "Package Exceptions" tab and look for the packages listed as requiring updating.
To check the package skip list in the up2date configuration file, open the file /etc/sysconfig/rhn/up2date and look for the package entries under the pkgSkipList setting. To override the package exceptions and force an update of the entire system, run the command:

up2date -uf

If the packages aren''t updated, the RHN website will continue to list them as outdated, regardless of their inclusion in the system''s package exceptions list.'
, 0,  TO_Date( '04/22/2003 06:32:03 PM', 'MM/DD/YYYY HH:MI:SS AM'),  TO_Date( '04/25/2003 08:04:45 PM', 'MM/DD/YYYY HH:MI:SS AM')
, 0, 6); 
INSERT INTO RHNFAQ ( ID, SUBJECT, DETAILS, PRIVATE, CREATED, MODIFIED, USAGE_COUNT,
CLASS_ID ) VALUES ( 
291, 'Why does Apache fail to restart after I update my RHN Satellite Server?', 'Apache RPMs do not restart the httpd service upon installation. Therefore, after conducting a full update of an RHN Satellite Server (such as with the command up2date -uf), Apache fails. The error will look something like:

[Mon Feb 10 11:50:12 2003] [notice] SIGHUP received.  Attempting to restart
Syntax error on line 214 of /etc/httpd/conf/httpd.conf: Cannot load /etc/httpd/modules/mod_log_config.so into server: /etc/httpd/modules/mod_log_config.so: undefined symbol: ap_escape_logitem

To resolve this, restart the httpd service.'
, 0,  TO_Date( '04/22/2003 08:27:51 PM', 'MM/DD/YYYY HH:MI:SS AM'),  TO_Date( '04/23/2003 09:48:30 AM', 'MM/DD/YYYY HH:MI:SS AM')
, 0, 7); 
INSERT INTO RHNFAQ ( ID, SUBJECT, DETAILS, PRIVATE, CREATED, MODIFIED, USAGE_COUNT,
CLASS_ID ) VALUES ( 
308, 'How do I resolve dropped connections during ISO downloads?', 'Red Hat recommends using the Curl open source tool for downloading ISO images. This tool enables you to resume downloads that have been interrupted. If you use RHN and don''t currently have Curl, you may install it by running the command "up2date curl" from a shell prompt.

Once Curl is installed, at a shell prompt, cut and paste the URL for the ISO into the Curl command as follows:

[user@localhost home]$ curl -C - -O ''very_long_url''

The URL, which can be derived from the Easy ISOs page of the RHN website, is very long because it contains session authentication information. Be sure to include the single quotation marks around it. The ''-C -'' option allows you to continue the download if it is interrupted, such as by a lost connection. The ''-O'' (the letter ''O'', not a zero) option will save the file with the same name as on the RHN Servers.'
, 0,  TO_Date( '04/30/2003 07:02:36 PM', 'MM/DD/YYYY HH:MI:SS AM'),  TO_Date( '05/02/2003 11:41:21 AM', 'MM/DD/YYYY HH:MI:SS AM')
, 0, 5); 
INSERT INTO RHNFAQ ( ID, SUBJECT, DETAILS, PRIVATE, CREATED, MODIFIED, USAGE_COUNT,
CLASS_ID ) VALUES ( 
309, 'Does purchasing Enterprise entitlements give me access to Red Hat Enterprise Linux?'
, 'No, Enterprise entitlement is the level of service from Red Hat Network. Customers purchasing the $96 Enterprise entitlement from Red Hat Network get access to advanced functionality, such as package profile comparison, searching systems, system grouping, multiple administrators, and use of the System Set Manager for batch processing.

Enterprise entitlement also grants you access to Red Hat Linux software channels, but not those for Red Hat Enterprise Linux. Purchasing Enterprise entitlements DOES NOT provide users with access to the Red Hat Enterprise Linux ISOs or channels.

Please note, however, the reverse is true. Enterprise entitlements to RHN come standard with Red Hat Enterprise Linux subscriptions. If you would like to obtain or renew Red Hat Enterprise Linux, you will need to purchase a subscription. Click here http://www.redhat.com/software/rhel/purchase/ for more information.'
, 0,  TO_Date( '05/01/2003 04:13:12 PM', 'MM/DD/YYYY HH:MI:SS AM'),  TO_Date( '05/02/2003 11:40:46 AM', 'MM/DD/YYYY HH:MI:SS AM')
, 0, 7); 
INSERT INTO RHNFAQ ( ID, SUBJECT, DETAILS, PRIVATE, CREATED, MODIFIED, USAGE_COUNT,
CLASS_ID ) VALUES ( 
310, 'Why does the registration process prompt me for an organization ID if I don''t need one to register?'
, 'The organization ID is legacy from the days in which RHN allowed users to request addition to an existing organization, which then required an Organization Administrator to approve the new user.

Now, the RHN website allows Organization Administrators to create user accounts directly. Unfortunately, older versions of the registration tools (both rhn_register and up2date) still contain organization ID and password fields. You may disregard them.'
, 0,  TO_Date( '05/02/2003 08:51:09 PM', 'MM/DD/YYYY HH:MI:SS AM'),  TO_Date( '05/03/2003 09:07:56 AM', 'MM/DD/YYYY HH:MI:SS AM')
, 0, 3); 
INSERT INTO RHNFAQ ( ID, SUBJECT, DETAILS, PRIVATE, CREATED, MODIFIED, USAGE_COUNT,
CLASS_ID ) VALUES ( 
221, 'How do I get more legal information?', 'Please go to http://www.redhat.com/software/rhn/legal'
, 0,  TO_Date( '03/27/2003 06:47:21 PM', 'MM/DD/YYYY HH:MI:SS AM'),  TO_Date( '03/31/2003 09:26:11 AM', 'MM/DD/YYYY HH:MI:SS AM')
, 0, 8); 
INSERT INTO RHNFAQ ( ID, SUBJECT, DETAILS, PRIVATE, CREATED, MODIFIED, USAGE_COUNT,
CLASS_ID ) VALUES ( 
222, 'How do I delete my account?', 'If you no longer want to receive the services of Red Hat Network, you can delete your account. To do so, you will need to sign in to the RHN website, click on "Your RHN" in the top navigation bar then "Your Account" and "Account Deactivation" on the left.

You will then be presented with options for manual deletion or instructions for contacting Customer Service, depending on your level of service. Deletion of account should occur within one business week.'
, 0,  TO_Date( '03/28/2003 11:12:02 AM', 'MM/DD/YYYY HH:MI:SS AM'),  TO_Date( '05/15/2003 01:10:55 AM', 'MM/DD/YYYY HH:MI:SS AM')
, 30, 2); 
INSERT INTO RHNFAQ ( ID, SUBJECT, DETAILS, PRIVATE, CREATED, MODIFIED, USAGE_COUNT,
CLASS_ID ) VALUES ( 
223, 'How do I change my username?', 'Any change to your username must be done manually by Red Hat Network.

If you are a demo customer, we request that you simply delete your existing account and re-register with a new demo account.

If you are a paid customer, please contact customerservice@redhat.com for assistance.'
, 0,  TO_Date( '03/28/2003 11:14:43 AM', 'MM/DD/YYYY HH:MI:SS AM'),  TO_Date( '04/29/2003 12:10:30 AM', 'MM/DD/YYYY HH:MI:SS AM')
, 4, 2); 
INSERT INTO RHNFAQ ( ID, SUBJECT, DETAILS, PRIVATE, CREATED, MODIFIED, USAGE_COUNT,
CLASS_ID ) VALUES ( 
224, 'What is an ISO?', 'An ISO is an image file of the contents of a CD.

For example, by downloading the Red Hat Linux ISOs to your system, you can then burn a CD that will be identical to the Red Hat Linux CDs that are available in retail stores.'
, 0,  TO_Date( '03/28/2003 11:22:00 AM', 'MM/DD/YYYY HH:MI:SS AM'),  TO_Date( '04/16/2003 09:07:32 PM', 'MM/DD/YYYY HH:MI:SS AM')
, 0, 11); 
INSERT INTO RHNFAQ ( ID, SUBJECT, DETAILS, PRIVATE, CREATED, MODIFIED, USAGE_COUNT,
CLASS_ID ) VALUES ( 
225, 'What is Errata?', 'An Errata is a message about new updates for your system, usually accompanied by updated packages.

Red Hat Network is a tool to update your system with these errata packages.'
, 0,  TO_Date( '03/28/2003 11:25:25 AM', 'MM/DD/YYYY HH:MI:SS AM'),  TO_Date( '04/16/2003 09:08:17 PM', 'MM/DD/YYYY HH:MI:SS AM')
, 0, 11); 
INSERT INTO RHNFAQ ( ID, SUBJECT, DETAILS, PRIVATE, CREATED, MODIFIED, USAGE_COUNT,
CLASS_ID ) VALUES ( 
226, 'How do I download ISOs from Red Hat Network?', 'Once you have signed in, click on the "Software" tab (on top of page), click "Easy ISOs" on the right, and then follow directions for download.'
, 0,  TO_Date( '03/28/2003 11:29:31 AM', 'MM/DD/YYYY HH:MI:SS AM'),  TO_Date( '04/21/2003 12:06:49 PM', 'MM/DD/YYYY HH:MI:SS AM')
, 0, 5); 
INSERT INTO RHNFAQ ( ID, SUBJECT, DETAILS, PRIVATE, CREATED, MODIFIED, USAGE_COUNT,
CLASS_ID ) VALUES ( 
227, 'How do I repair a corrupt RPM database?', 'Occasionally, the RPM database on a Red Hat Linux machine will become corrupt.  This usually happens when an RPM transaction is interrupted at a critical time.  Symptoms of this problem include one of the following programs not responding or freezing:

* up2date
* The RHN alert notification tool (applet in the Gnome or KDE panel)
* rhn_check
* rpm

This problem can also cause a system to stop checking in with RHN.

To fix this problem, run the following commands as root:

* kill all RPM processes (rhn_check, up2date, rpm, rhn-applet):
     $ ps -axwww | grep rhn_check
In the list of processes, the first number on each line is the PID.  For all PIDs listed except for the one associated with grep:
     $ kill -9 <PID>
Repeat the above steps for each of the programs listed.

* remove any RPM lock files (/var/lib/rpm/__db*):
     $ rm -rf /var/lib/rpm/__db*

* rebuild the rpm database:
     $ rpm --rebuilddb

If the above steps do not work, please contact technical support for more assistance.'
, 0,  TO_Date( '03/28/2003 11:34:34 AM', 'MM/DD/YYYY HH:MI:SS AM'),  TO_Date( '05/07/2003 11:31:57 PM', 'MM/DD/YYYY HH:MI:SS AM')
, 2, 6); 
INSERT INTO RHNFAQ ( ID, SUBJECT, DETAILS, PRIVATE, CREATED, MODIFIED, USAGE_COUNT,
CLASS_ID ) VALUES ( 
231, 'How do I move my Red Hat Network entitlement to another machine?', 'All of the systems that you want to entitle, or un-entitle, must be registered with Red Hat Network. Please see the FAQ question relating to registering new systems.

First Step - unentitle old system

1) Sign in with Red Hat Network
2) Click on "Systems"
3) Click on "Systems Entitlements"
4) Change entitlement of old system to "none"
5) Click "Update Entitlements"

Next Step - entitle new system

From same screen, change the entitlement on the new system to the entitlement you would like to have. Click "Update Entitlements".'
, 0,  TO_Date( '03/28/2003 12:07:10 PM', 'MM/DD/YYYY HH:MI:SS AM'),  TO_Date( '05/14/2003 09:33:40 PM', 'MM/DD/YYYY HH:MI:SS AM')
, 2, 5); 
INSERT INTO RHNFAQ ( ID, SUBJECT, DETAILS, PRIVATE, CREATED, MODIFIED, USAGE_COUNT,
CLASS_ID ) VALUES ( 
230, 'I just upgraded my system. How do I re-register it with Red Hat Network?', 'If you are running a version of Red Hat Linux 7.3 (or prior release), do the following:

1) Log in as root
2) Type "rhn_register"

If you are running a version of Red Hat Linux 8.0 (or later release), do the following:

1) Log in as root
2) Type "up2date --register"'
, 0,  TO_Date( '03/28/2003 12:01:49 PM', 'MM/DD/YYYY HH:MI:SS AM'),  TO_Date( '04/24/2003 10:47:23 PM', 'MM/DD/YYYY HH:MI:SS AM')
, 2, 5); 
INSERT INTO RHNFAQ ( ID, SUBJECT, DETAILS, PRIVATE, CREATED, MODIFIED, USAGE_COUNT,
CLASS_ID ) VALUES ( 
232, 'How do I get copies of the latest release notes for Red Hat Network?', 'Click on the Help button in the upper right hand corner. Then click on Release Notes listed on the navigation bar on the left.'
, 0,  TO_Date( '03/28/2003 12:16:19 PM', 'MM/DD/YYYY HH:MI:SS AM'),  TO_Date( '03/31/2003 09:26:11 AM', 'MM/DD/YYYY HH:MI:SS AM')
, 0, 5); 
INSERT INTO RHNFAQ ( ID, SUBJECT, DETAILS, PRIVATE, CREATED, MODIFIED, USAGE_COUNT,
CLASS_ID ) VALUES ( 
70, 'pvt: Updating kernel and config files', 'Because of the wide range of changes and setups involved in the scenarios you describe we have chosen the conservative path in the default configuration.

We recommend that you upgrade the kernel on the boxes while you can observe the process (ie, running "up2date --force kernel" from the command line). The same goes for the packages which have config files DBmodified - please check the results of the upgrade process to make sure you will not have an interruption of service due to changed config files.

Once you have been through this process a few times and get a better feel for how RHN handles your particular setup, you can decide to let RHN perform these updates for you automatically.
'
, 1,  TO_Date( '10/02/2002 12:00:00 AM', 'MM/DD/YYYY HH:MI:SS AM'),  TO_Date( '04/14/2003 10:30:31 PM', 'MM/DD/YYYY HH:MI:SS AM')
, 26, 1); 
INSERT INTO RHNFAQ ( ID, SUBJECT, DETAILS, PRIVATE, CREATED, MODIFIED, USAGE_COUNT,
CLASS_ID ) VALUES ( 
73, 'pvt: I can''t get into ftp.redhat.com. Why?', '
Due to the popularity of Red Hat Linux 8.0, our ftp servers are currently heavily loaded, and are at their capacity. We apologize for any inconvenience this may cause.

If you are not able to log into the ftp.redhat.com ftp site, it is probably because the servers are serving the maximum number of users currently. You can try later, or better yet, try one of the many Red Hat mirror sites. They are listed at:

https://www.redhat.com/download/mirror.html
  '
, 1,  TO_Date( '10/02/2002 12:00:00 AM', 'MM/DD/YYYY HH:MI:SS AM'),  TO_Date( '04/24/2003 09:35:36 PM', 'MM/DD/YYYY HH:MI:SS AM')
, 3, 1); 
INSERT INTO RHNFAQ ( ID, SUBJECT, DETAILS, PRIVATE, CREATED, MODIFIED, USAGE_COUNT,
CLASS_ID ) VALUES ( 
81, 'I just bought new entitlements, but the system says they will expire in 2 days?'
, 'It takes a little while for the backend systems to validate the charge on your credit card. The expiration date will be updated shortly once that process is completed on our backend systems.

If this problem persists for more than two hours, please contact customer service at customerservice@redhat.com
'
, 0,  TO_Date( '10/03/2002 12:00:00 AM', 'MM/DD/YYYY HH:MI:SS AM'),  TO_Date( '03/31/2003 09:26:11 AM', 'MM/DD/YYYY HH:MI:SS AM')
, 10, 3); 
INSERT INTO RHNFAQ ( ID, SUBJECT, DETAILS, PRIVATE, CREATED, MODIFIED, USAGE_COUNT,
CLASS_ID ) VALUES ( 
82, 'Red Hat''s "GPG Key" - what is it and how do I install it?', 'The first time you run the graphical version of the Red Hat Update Agent, it prompts you to install the Red Hat GPG key. This key is required to authenticate the packages downloaded from Red Hat Network. If you run the command line version the first time you start Red Hat Update Agent, you need to install the Red Hat GPG key manually; follow the instructions that up2date displays.'
, 0,  TO_Date( '10/17/2002 12:00:00 AM', 'MM/DD/YYYY HH:MI:SS AM'),  TO_Date( '05/06/2003 11:15:40 PM', 'MM/DD/YYYY HH:MI:SS AM')
, 10, 6); 
INSERT INTO RHNFAQ ( ID, SUBJECT, DETAILS, PRIVATE, CREATED, MODIFIED, USAGE_COUNT,
CLASS_ID ) VALUES ( 
124, 'pvt: no RHL support at rhn-feedback', 'This address is intended for feedback related only to Red Hat
Network. General Red Hat Linux support is not available from this address.
If you are registered with Red Hat Support, you may address your questions
at:
http://www.redhat.com/support

Even if you are not registered with Red Hat Support, you are welcome to browse
our documentation and online resources available at:

https://www.redhat.com/docs/

You may also get access to Tips, FAQs, and online HOWTOs to guide you through
Linux-related tasks if you start looking from our Support Resources Home Page
available at:

https://www.redhat.com/apps/support/resources/

The Red Hat mailing lists are also good venues for finding answers to your
questions. For more information on the Red Hat mailing lists, please see:

http://www.redhat.com/mailing-lists/

If you would like to report a bug or a problem with a component of the Red Hat Linux distribution, we encourage you to visit our bug tracking system and file a bug report at:

http://bugzilla.redhat.com/bugzilla'
, 1,  TO_Date( '12/11/2002 12:00:00 AM', 'MM/DD/YYYY HH:MI:SS AM'),  TO_Date( '03/31/2003 09:26:11 AM', 'MM/DD/YYYY HH:MI:SS AM')
, 10, 1); 
INSERT INTO RHNFAQ ( ID, SUBJECT, DETAILS, PRIVATE, CREATED, MODIFIED, USAGE_COUNT,
CLASS_ID ) VALUES ( 
191, 'pvt: I want to unsubscribe from the maillist !', 'To stop receiving mails from RHN , please see below:

Use your RHN account to login, then go to "Your RHN"==>"Your preferences" .

The Your Preferences page allows you to configure Red Hat Network options, including:

      Errata Email Notification — Determine whether you want to receive email every time an Errata Alert is applicable to one or more systems in your RHN account.

      RHN List Page Size — Maximum number of items that will appear in a list on a single page. If more items are in the list, clicking the Next button will display the next group of items. This preference applies to system lists, Errata lists, package lists, and so on.

      Time Zone — Set your time zone so that scheduled actions are scheduled according to the time in your time zone.

      Red Hat Contact Options — Identify what ways (email, phone, fax, or mail) Red Hat may contact you.

After making changes to any of these options, click the Save Preferences button on the bottom right-hand corner.
'
, 1,  TO_Date( '02/19/2003 08:20:46 PM', 'MM/DD/YYYY HH:MI:SS AM'),  TO_Date( '04/27/2003 11:53:51 PM', 'MM/DD/YYYY HH:MI:SS AM')
, 89, 1); 
INSERT INTO RHNFAQ ( ID, SUBJECT, DETAILS, PRIVATE, CREATED, MODIFIED, USAGE_COUNT,
CLASS_ID ) VALUES ( 
209, 'I can''t log in with my username or password.  What should I do?', 'First, please check to see if you are using the correct username and password (see answers to questions in this section). If you are using the correct username and password, please call customer service at 1-866-2-RedHat or contact them at customerservice@redhat.com'
, 0,  TO_Date( '03/27/2003 03:57:30 PM', 'MM/DD/YYYY HH:MI:SS AM'),  TO_Date( '03/31/2003 09:26:10 AM', 'MM/DD/YYYY HH:MI:SS AM')
, 0, 2); 
INSERT INTO RHNFAQ ( ID, SUBJECT, DETAILS, PRIVATE, CREATED, MODIFIED, USAGE_COUNT,
CLASS_ID ) VALUES ( 
228, 'pvt: How can I subscribe for Red Hat 9 now?', 'Red Hat Linux 9 ISOs will be available to paid subscribers starting March 31, 2003--a week before they will be available on redhat.com, in stores, or on Red Hat FTP. A paid subscription also gets you access to RHN technical support, errata updates, priority access during peak times, and immediate email notification. It''s the quickest way to get Red Hat Linux 9.

Note: Red Hat Network does not include printed documentation or Red Hat Linux Installation Support. If that''s what you''re looking for,  you can purchase Red Hat Linux 9 at redhat.com or at retail stores, available April 7, 2003. Red Hat Linux 9 or Red Hat Linux 9 Professional includes source code and documentation CDs, printed documentation manuals, installation support, and 1- or 2- month Basic Subscription to Red Hat Network.

For more informations please visit this page:
http://www.redhat.com/mktg/rh9iso/
'
, 1,  TO_Date( '03/25/2003 03:09:59 AM', 'MM/DD/YYYY HH:MI:SS AM'),  TO_Date( '04/06/2003 09:07:11 PM', 'MM/DD/YYYY HH:MI:SS AM')
, 9, 1); 
INSERT INTO RHNFAQ ( ID, SUBJECT, DETAILS, PRIVATE, CREATED, MODIFIED, USAGE_COUNT,
CLASS_ID ) VALUES ( 
208, 'I am new to Red Hat Network. How do I create an account?', 'Go to http://rhn.redhat.com and click on the link that says "Create Account". From here, please follow the directions.'
, 0,  TO_Date( '03/27/2003 03:55:40 PM', 'MM/DD/YYYY HH:MI:SS AM'),  TO_Date( '03/31/2003 09:26:11 AM', 'MM/DD/YYYY HH:MI:SS AM')
, 0, 3); 
INSERT INTO RHNFAQ ( ID, SUBJECT, DETAILS, PRIVATE, CREATED, MODIFIED, USAGE_COUNT,
CLASS_ID ) VALUES ( 
210, 'How do I login to Red Hat Network?', 'Go to http://rhn.redhat.com

From this page, enter in your username and password in the box. If you do not have your username and password, please see the FAQ relating to this.'
, 0,  TO_Date( '03/27/2003 03:59:43 PM', 'MM/DD/YYYY HH:MI:SS AM'),  TO_Date( '03/31/2003 09:26:11 AM', 'MM/DD/YYYY HH:MI:SS AM')
, 0, 3); 
INSERT INTO RHNFAQ ( ID, SUBJECT, DETAILS, PRIVATE, CREATED, MODIFIED, USAGE_COUNT,
CLASS_ID ) VALUES ( 
211, 'How do I purchase Red Hat Network?', 'Our purchasing guidelines can be found at http://www.redhat.com/software/rhn/purchase'
, 0,  TO_Date( '03/27/2003 04:00:44 PM', 'MM/DD/YYYY HH:MI:SS AM'),  TO_Date( '04/01/2003 01:58:22 AM', 'MM/DD/YYYY HH:MI:SS AM')
, 2, 1); 
INSERT INTO RHNFAQ ( ID, SUBJECT, DETAILS, PRIVATE, CREATED, MODIFIED, USAGE_COUNT,
CLASS_ID ) VALUES ( 
212, 'How do I contact Red Hat Network?', 'To contact Red Hat Network, please go to: http://www.redhat.com/software/rhn/contact'
, 0,  TO_Date( '03/27/2003 04:02:07 PM', 'MM/DD/YYYY HH:MI:SS AM'),  TO_Date( '03/31/2003 09:26:11 AM', 'MM/DD/YYYY HH:MI:SS AM')
, 0, 1); 
INSERT INTO RHNFAQ ( ID, SUBJECT, DETAILS, PRIVATE, CREATED, MODIFIED, USAGE_COUNT,
CLASS_ID ) VALUES ( 
213, 'How do I buy without using a credit card?', 'If your order is greater than $2,000 and you do not want to use a credit card, please contact Red Hat Inside Sales at 1-866-2-RedHat. If your purchase is less than $2,000 and you cannot use a credit card, please contact customerservice@redhat.com for more information.

If you choose to email Customer Service, please be sure to indicate your username and the number and levels of entitlements you desire.'
, 0,  TO_Date( '03/27/2003 04:05:02 PM', 'MM/DD/YYYY HH:MI:SS AM'),  TO_Date( '04/24/2003 07:27:09 PM', 'MM/DD/YYYY HH:MI:SS AM')
, 0, 1); 
INSERT INTO RHNFAQ ( ID, SUBJECT, DETAILS, PRIVATE, CREATED, MODIFIED, USAGE_COUNT,
CLASS_ID ) VALUES ( 
214, 'I don''t live in the United States - can I buy locally?', 'Because Red Hat Network is a global service administered through the web, there are no geographic resellers. All purchases take place through Red Hat Network''s online store or by calling Inside Sales at 1-866-2-RedHat.

If you are interested in purchasing Red Hat Enterprise Network, please contact your local sales office. More information can be found at:

https://www.redhat.com/about/corporate/worldwide/'
, 0,  TO_Date( '03/27/2003 04:19:42 PM', 'MM/DD/YYYY HH:MI:SS AM'),  TO_Date( '03/31/2003 09:26:11 AM', 'MM/DD/YYYY HH:MI:SS AM')
, 0, 1); 
INSERT INTO RHNFAQ ( ID, SUBJECT, DETAILS, PRIVATE, CREATED, MODIFIED, USAGE_COUNT,
CLASS_ID ) VALUES ( 
215, 'How do I know when I need to update my system?', 'Once your system is registered on Red Hat Network, a small icon will appear on your tool bar (Red Hat Linux 7.3 and higher). The icon will display either an exclamation point with red background (meaning that there is an update waiting to be downloaded) or a check mark with blue background (meaning that there are no updates waiting). If your icon portrays a question mark, it means that Red Hat Network is not able to see your system.

By double clicking on the icon, this will activate Red Hat Network update tool.'
, 0,  TO_Date( '03/27/2003 04:27:48 PM', 'MM/DD/YYYY HH:MI:SS AM'),  TO_Date( '03/31/2003 09:26:11 AM', 'MM/DD/YYYY HH:MI:SS AM')
, 0, 1); 
INSERT INTO RHNFAQ ( ID, SUBJECT, DETAILS, PRIVATE, CREATED, MODIFIED, USAGE_COUNT,
CLASS_ID ) VALUES ( 
216, 'I bought a Red Hat Linux box product. How can my account be a Demo Account?'
, 'When you purchase a Red Hat Linux box product, it comes with a 30, 60, or 90 day trial to Red Hat Network Basic Service. This service begins the moment that you register your product with Red Hat. Most likely, your trial subscription to Red Hat Network has expired and your status changed from Basic to Demo. If you feel that this is incorrect, please contact Customer Service at customerservice@redhat.com.'
, 0,  TO_Date( '03/27/2003 04:36:48 PM', 'MM/DD/YYYY HH:MI:SS AM'),  TO_Date( '04/16/2003 09:16:06 PM', 'MM/DD/YYYY HH:MI:SS AM')
, 0, 4); 
INSERT INTO RHNFAQ ( ID, SUBJECT, DETAILS, PRIVATE, CREATED, MODIFIED, USAGE_COUNT,
CLASS_ID ) VALUES ( 
217, 'Can I use Red Hat Network to upgrade to a newer version of Red Hat Linux?', 'No. While Red Hat Network always supports the latest version of Red Hat Linux, Red Hat Network cannot be used today to upgrade your system from one version of Red Hat Linux to the next. You will need to do a CD based install. However, if you are a paid subscriber to Red Hat Network (Basic or Enterprise), you have access to the new Red Hat Linux ISOs the moment they are made available. For more information, see http://www.redhat.com/software/rhn/offerings
'
, 0,  TO_Date( '03/27/2003 04:39:01 PM', 'MM/DD/YYYY HH:MI:SS AM'),  TO_Date( '03/31/2003 09:26:11 AM', 'MM/DD/YYYY HH:MI:SS AM')
, 0, 5); 
INSERT INTO RHNFAQ ( ID, SUBJECT, DETAILS, PRIVATE, CREATED, MODIFIED, USAGE_COUNT,
CLASS_ID ) VALUES ( 
219, 'What are the terms and conditions of Red Hat Network?', 'To see a copy of the Red Hat Network Terms and Conditions, please go to http://www.redhat.com/licenses/rhn.html'
, 0,  TO_Date( '03/27/2003 06:03:20 PM', 'MM/DD/YYYY HH:MI:SS AM'),  TO_Date( '03/31/2003 09:26:11 AM', 'MM/DD/YYYY HH:MI:SS AM')
, 0, 8); 
INSERT INTO RHNFAQ ( ID, SUBJECT, DETAILS, PRIVATE, CREATED, MODIFIED, USAGE_COUNT,
CLASS_ID ) VALUES ( 
220, 'Will my personal data from the user surveys ever be given to a third party?'
, 'No - Red Hat will never sell or give your personal information to another party. If this policy ever changes, Red Hat will make sure to make the new policy explicitly clear to you BEFORE you provide us with data.'
, 0,  TO_Date( '03/27/2003 06:05:13 PM', 'MM/DD/YYYY HH:MI:SS AM'),  TO_Date( '03/31/2003 09:26:11 AM', 'MM/DD/YYYY HH:MI:SS AM')
, 0, 8); 
INSERT INTO RHNFAQ ( ID, SUBJECT, DETAILS, PRIVATE, CREATED, MODIFIED, USAGE_COUNT,
CLASS_ID ) VALUES ( 
23, 'How do I remove a pending action?', 'A pending action will be removed when there are no longer any systems scheduled for it.  For Demo or Basic entitlements this will always be done on a per system basis:

* Log into the RHN website.
* Click "Schedule" on the top navigation bar, then "Pending Actions" in the left navigation bar.
* Click on the numeral in the "In Progress" column of the row for the action you want to remove.
* Click on the desired system name.
* Click on the "Events" tab in the System Details navigation.
* Click on the "Pending" subtab.
* Select the event you wish to cancel, and click "Cancel Events"
* Click the "Cancel Selected Events" on the confirmation page.

For systems with Enterprise entitlements, simply remove the systems from the action:

* Click "Schedule" on the top navigation bar, then "Pending Actions" in the left navigation bar.
* Click on the numeral in the "In Progress" column of the row for the action you want to remove.
* Select the systems for removal from the action and then click on the "Unschedule Action" button.
'
, 0,  TO_Date( '06/14/2002 12:00:00 AM', 'MM/DD/YYYY HH:MI:SS AM'),  TO_Date( '05/18/2003 09:53:59 PM', 'MM/DD/YYYY HH:MI:SS AM')
, 14, 7); 
INSERT INTO RHNFAQ ( ID, SUBJECT, DETAILS, PRIVATE, CREATED, MODIFIED, USAGE_COUNT,
CLASS_ID ) VALUES ( 
24, 'Why do scheduled kernel errata fail to install?', 'By default, the kernel packages are marked to be skipped by the update agent.  You can change this configuration by running:

up2date --configure --nox

...and changing or clearing the "pkgSkipList" parameter.  You should then be able to schedule your kernel update.
'
, 0,  TO_Date( '06/14/2002 12:00:00 AM', 'MM/DD/YYYY HH:MI:SS AM'),  TO_Date( '04/30/2003 04:21:47 AM', 'MM/DD/YYYY HH:MI:SS AM')
, 11, 6); 
INSERT INTO RHNFAQ ( ID, SUBJECT, DETAILS, PRIVATE, CREATED, MODIFIED, USAGE_COUNT,
CLASS_ID ) VALUES ( 
131, 'pvt: openssl packages', 'The latest releases of the OpenSSL packages from Red Hat include fixes for all known security vulnerabilities, including the various types of worms that float around.

Please remember that just upgrading the packages is not sufficient. You will have to restart at least your Apache server in order for the new libraries to be loaded by the running Apache process.

More details about the applicable OpenSSL errata can be found at:

https://rhn.redhat.com/errata/RHSA-2002-160.html
and
https://rhn.redhat.com/network/errata/errata_details.pxt?eid=1143
'
, 1,  TO_Date( '12/19/2002 07:33:20 PM', 'MM/DD/YYYY HH:MI:SS AM'),  TO_Date( '03/31/2003 09:26:10 AM', 'MM/DD/YYYY HH:MI:SS AM')
, 4, 1); 
INSERT INTO RHNFAQ ( ID, SUBJECT, DETAILS, PRIVATE, CREATED, MODIFIED, USAGE_COUNT,
CLASS_ID ) VALUES ( 
148, 'pvt: delayed response', 'Due to significant interest & volume in Red Hat Network services, we have been unable to respond to your question in a timely manner.  We apologize for the delay and any inconvenience this delay may have caused you.  In response to your question, below is a response to your question.  If this solution does not resolve your issue, please resubmit with additional information.
'
, 1,  TO_Date( '02/05/2003 12:41:33 PM', 'MM/DD/YYYY HH:MI:SS AM'),  TO_Date( '04/03/2003 11:24:13 PM', 'MM/DD/YYYY HH:MI:SS AM')
, 39, 1); 
INSERT INTO RHNFAQ ( ID, SUBJECT, DETAILS, PRIVATE, CREATED, MODIFIED, USAGE_COUNT,
CLASS_ID ) VALUES ( 
168, 'pvt: New To Linux', 'This address is intended for support questions from paid subscribers and is related only to Red Hat Network. General Red Hat Linux support is not available from this address.  If you are registered with Red Hat Support, you may address your questions at:
http://www.redhat.com/support

If you have not already done so, you can activate your product and receive advanced support at:

https://www.redhat.com/apps/support/

Even if you are not registered with Red Hat Support, you are welcome to browse
our documentation and online resources available at:

https://www.redhat.com/docs/

You may also get access to Tips, FAQs, and online HOWTOs to guide you through
Linux-related tasks if you start looking from our Support Resources Home Page
available at:

https://www.redhat.com/apps/support/resources/

The Red Hat mailing lists are also good venues for finding answers to your
questions. For more information on the Red Hat mailing lists, please see:

http://www.redhat.com/mailing-lists/

If you would like to report a bug or a problem with a component of the Red Hat Linux distribution, we encourage you to visit our bug tracking system and file a bug report at:

http://bugzilla.redhat.com/bugzilla
'
, 1,  TO_Date( '02/13/2003 04:23:15 AM', 'MM/DD/YYYY HH:MI:SS AM'),  TO_Date( '03/31/2003 09:26:10 AM', 'MM/DD/YYYY HH:MI:SS AM')
, 6, 1); 
INSERT INTO RHNFAQ ( ID, SUBJECT, DETAILS, PRIVATE, CREATED, MODIFIED, USAGE_COUNT,
CLASS_ID ) VALUES ( 
169, 'How do I change my email address?', 'To change your email:

* Log in to the Red Hat Network website with your existing username and password.
* If you are not at Your RHN page, click its link in the top navigation bar.
* Click "Your Account" in the left navigation bar.
* Click "Change Email"
* Type your new email in field.
* Click the "Send Verification" or "Update" button.'
, 0,  TO_Date( '02/13/2003 10:03:56 PM', 'MM/DD/YYYY HH:MI:SS AM'),  TO_Date( '04/13/2003 09:15:55 PM', 'MM/DD/YYYY HH:MI:SS AM')
, 16, 2); 
INSERT INTO RHNFAQ ( ID, SUBJECT, DETAILS, PRIVATE, CREATED, MODIFIED, USAGE_COUNT,
CLASS_ID ) VALUES ( 
170, 'pvt: How to entitle system in my RHN', '* Once the system is registered, log in at https://rhn.redhat.com.
* Click "Systems" in the top navigation bar, then "System Entitlements" on the left.
* Select the appropriate entitlement level for the new system and click "Update Entitlements."'
, 1,  TO_Date( '02/13/2003 10:36:28 PM', 'MM/DD/YYYY HH:MI:SS AM'),  TO_Date( '05/15/2003 09:36:58 PM', 'MM/DD/YYYY HH:MI:SS AM')
, 54, 1); 
INSERT INTO RHNFAQ ( ID, SUBJECT, DETAILS, PRIVATE, CREATED, MODIFIED, USAGE_COUNT,
CLASS_ID ) VALUES ( 
188, 'pvt: system on a closed net , but still want to update', 'RHN Satellite Server provides for local management of system profiles, thus allowing for completely disconnected operation from external networks.
More information, please follow this link:
https://rhn.redhat.com/info/purchase_info.pxt
'
, 1,  TO_Date( '02/18/2003 09:35:22 PM', 'MM/DD/YYYY HH:MI:SS AM'),  TO_Date( '04/07/2003 11:03:00 PM', 'MM/DD/YYYY HH:MI:SS AM')
, 8, 1); 
INSERT INTO RHNFAQ ( ID, SUBJECT, DETAILS, PRIVATE, CREATED, MODIFIED, USAGE_COUNT,
CLASS_ID ) VALUES ( 
189, 'What are the differences between Basic, Enterprise, and Demo Accounts?', 'Basic service level subscriptions to Red Hat Network allow individuals to register one or more systems, manage these systems independently, receive priority access to Red Hat Network, and download Easy ISOs (full versions of Red Hat Linux). Basic subscriptions are $60 per system and renew annually. Customers may receive also limited time (less than one year) Basic subscriptions with the Red Hat Linux distribution products.

Enterprise service level subscriptions to Red Hat Network allow organizations to manage multiple systems, individually or in groups of systems. Enterprise subscriptions efficiently combine the power and flexibility of fine-grained control with the scalability to support thousands of systems.

Demo refers to our complimentary service level. Any user may receive one Demo account with Red Hat Network to receive notifications and system updates. Demo users are asked to take a short survey every 60 days in order to provide Red Hat with valued customer input and to validate that the account is still active. Please note that there can be only one demo account per email address.

Note: A Demo account does not provide guaranteed access to errata or bandwidth allocation during peak times, as these resources are reserved for paying subscribers. For this reason, Red Hat strongly recommends purchasing at least a Basic service level if you are using your Linux system for home or business production use.

For more information, please follow this link:
http://www.redhat.com/software/rhn/offerings'
, 0,  TO_Date( '02/18/2003 10:53:18 PM', 'MM/DD/YYYY HH:MI:SS AM'),  TO_Date( '04/21/2003 12:08:01 PM', 'MM/DD/YYYY HH:MI:SS AM')
, 48, 4); 
INSERT INTO RHNFAQ ( ID, SUBJECT, DETAILS, PRIVATE, CREATED, MODIFIED, USAGE_COUNT,
CLASS_ID ) VALUES ( 
190, 'pvt:How can i delete my account in RHN?', 'Sorry,you can not delete your account in RHN now. But your account will be disabled if you do not accept the survey per 60 days.'
, 1,  TO_Date( '02/19/2003 04:22:18 AM', 'MM/DD/YYYY HH:MI:SS AM'),  TO_Date( '03/31/2003 09:26:10 AM', 'MM/DD/YYYY HH:MI:SS AM')
, 25, 1); 
COMMIT;

select count(*) from rhnfaq;

CREATE TABLE RHNPACKAGEFILEDELETEQUEUE
(
  PATH     VARCHAR2(1000),
  CREATED  DATE                                 DEFAULT (sysdate)
)
LOGGING 
NOCACHE
NOPARALLEL;

CREATE UNIQUE INDEX RHN_PFDQUEUE_PATH_UQ ON RHNPACKAGEFILEDELETEQUEUE
(PATH)
LOGGING
NOPARALLEL;

CREATE OR REPLACE procedure delete_server_bulk (
	user_id_in in number
) is
	cursor systems(uid_in in number) is
		select	s.element server_id
		from	rhnSet s
		where	s.label = 'system_list'
			and s.user_id = uid_in;
begin
	for system in systems(user_id_in)
	loop
		rhn_channel.clear_subscriptions(system.server_id);
	end loop;
	delete from rhnServer where id in (
		select	s.element
		from	rhnSet s
		where 	s.label = 'system_list'
			and s.user_id = user_id_in
	);
	delete from rhnSet s where s.label = 'system_list' and s.user_id = user_id_in;
end;
/

ALTER TABLE RHNPACKAGEFILEDELETEQUEUE ADD CONSTRAINT RHN_PFDQUEUE_CREATED_NN CHECK ("CREATED" IS NOT NULL);

ALTER TABLE RHNPACKAGEFILEDELETEQUEUE ADD CONSTRAINT RHN_PFDQUEUE_PATH_UQ UNIQUE (PATH);

declare
	cursor servers is
		select	sgm.server_id id,
			sgm.server_group_id server_group_id
		from	rhnServerGroupMembers sgm,
			rhnServerGroup sg
		where	sg.group_type = 2
			and sg.id = sgm.server_group_id;
begin
	for server in servers loop
		-- neither of these affects channels at all, so we
		-- should be safe doing it this way
		begin
			rhn_entitlements.unentitle_server(server.id);
			rhn_entitlements.entitle_server(server.id,'enterprise_entitled');
		exception
			when others then
				null;
		end;
	end loop;
	update	rhnServerGroup
	set	max_members = 0
	where	group_type in (select id from rhnServerGroupType where label = 'sw_mgr_entitled');
end;
/
show errors

create or replace trigger
web_contact_mod_trig
before insert or update on web_contact
for each row
begin
        :new.modified := sysdate;
        :new.login_uc := UPPER(:new.login);
        IF :new.password <> :old.password THEN
                :new.old_password := :old.password;
        END IF;
end;
/
show errors

DROP INDEX RHN_USER_INFO_UID_UNQ;
DROP INDEX RHN_USER_INFO_EMAIL_IDX;
DROP INDEX RHN_USERGROUPTYPE_LABEL_UQ;
alter table rhnEmailAddress drop constraint rhn_eaddress_uid_sid_uq;
DROP INDEX RHN_EADDRESS_UID_SID_IDX;
CREATE INDEX RHN_USERGROUPTYPE_LABEL_ID_IDX ON RHNUSERGROUPTYPE
(LABEL, ID)
LOGGING
NOPARALLEL;

CREATE INDEX RHN_OSTATE_SID_OID_IDX ON RHNORGSTATE
(STATE_ID, ORG_ID)
LOGGING
NOPARALLEL;

CREATE INDEX RHN_EADDRESS_UID_SID_ADDR_IDX ON RHNEMAILADDRESS
(USER_ID, STATE_ID, ADDRESS)
LOGGING
NOPARALLEL;
CREATE INDEX RHN_EADDRESS_UID_SID_IDX ON RHNEMAILADDRESS
(USER_ID, STATE_ID)
LOGGING
NOPARALLEL;
alter table rhnEmailAddress add
        constraint rhn_eaddress_uid_sid_uq unique ( user_id, state_id );

CREATE UNIQUE INDEX RHN_SERVERLOCATION_SID_UQ ON RHNSERVERLOCATION
(SERVER_ID)
LOGGING
NOPARALLEL;

CREATE INDEX RHN_USER_INFO_UID_EMAIL_IDX ON RHNUSERINFO
(USER_ID, EMAIL_NOTIFY)
LOGGING
NOPARALLEL;

ALTER TABLE RHNUSERGROUPTYPE ADD CONSTRAINT RHN_USERGROUPTYPE_LABEL_UQ UNIQUE (LABEL);

ALTER TABLE RHNUSERINFO ADD CONSTRAINT RHN_USER_INFO_UID_UQ UNIQUE (USER_ID);


-- previous emails are considered validated
insert into rhnemailaddress select rhn_eaddress_id_seq.nextval, wupi.email, wupi.web_user_id, rhn_bel.lookup_email_state('verified'), NULL, sysdate, sysdate from web_user_personal_info wupi where email is not null;
commit;


-- set up initial rhnTemplateCategory's
INSERT INTO rhnTemplateCategory (id, label, description) 
     VALUES (rhn_template_cat_id_seq.nextval, 'org_strings', 'Organization specific strings.');

INSERT INTO rhnTemplateCategory (id, label, description)
     VALUES (rhn_template_cat_id_seq.nextval, 'email_strings', 'Strings appearing in e-mail sent to users.');



-- set up initial rhnTemplateStrings
SET SQLBLANKLINES ON
SET SCAN OFF

INSERT INTO rhnTemplateString (id, category_id, label, value, description) 
     VALUES (rhn_template_str_id_seq.nextval,
             (SELECT TC.id 
                FROM rhnTemplateCategory TC
	       WHERE TC.label = 'email_strings'),
	     'email_footer', '-' || '-the Red Hat Network Team', 'Footer for RHN e-mail');

INSERT INTO rhnTemplateString (id, category_id, label, value, description) 
     VALUES (rhn_template_str_id_seq.nextval,
             (SELECT TC.id 
                FROM rhnTemplateCategory TC
	       WHERE TC.label = 'email_strings'),
	     'email_account_info', '
Account Information:
  Your RHN login:         <login />
  Your RHN email address: <email-address />', 'Account info lines for RHN e-mail');

CREATE OR REPLACE VIEW
rhnServerNeededPackageView
(
    org_id,
    server_id,
    errata_id,
    package_id
)
AS
SELECT   S.org_id,
         S.id,
	  (SELECT EP.errata_id
	     FROM rhnErrataPackage EP,
	          rhnChannelErrata CE,
		  rhnServerChannel SC
	    WHERE SC.server_id = S.id
	      AND SC.channel_id = CE.channel_id
	      AND CE.errata_id = EP.errata_id
	      AND EP.package_id = P.id
	      AND ROWNUM = 1),
	 P.id
FROM
	 rhnPackage P,
	 rhnServerPackageArchCompat SPAC,
	 rhnPackageEVR P_EVR,
	 rhnPackageEVR SP_EVR,
	 rhnServerPackage SP,
	 rhnChannelPackage CP,
	 rhnServerChannel SC,
         rhnServer S
WHERE
    	 SC.server_id = S.id
  AND  	 SC.channel_id = CP.channel_id
  AND    CP.package_id = P.id
  AND    p.package_arch_id = spac.package_arch_id
  AND    spac.server_arch_id = s.server_arch_id
  AND    SP_EVR.id = SP.evr_id
  AND    P_EVR.id = P.evr_id
  AND    SP.server_id = S.id
  AND    SP.name_id = P.name_id
  AND    SP.evr_id != P.evr_id
  AND    SP_EVR.evr < P_EVR.evr
  AND    SP_EVR.evr = (SELECT MAX(PE.evr) FROM rhnServerPackage SP2, rhnPackageEvr PE WHERE PE.id = SP2.evr_id AND SP2.server_id = SP.server_id AND SP2.name_id = SP.name_id)
/



--
-- 1. RHN_EADDRESS_UID_SID_IDX  (Index) 
--
DROP INDEX RHN_EADDRESS_UID_SID_IDX;

--
-- 2. RHN_PACKAGEDELTA_ID_SEQ  (Sequence) 
--
CREATE SEQUENCE RHN_PACKAGEDELTA_ID_SEQ
  START WITH 1
  NOMAXVALUE
  MINVALUE 1
  NOCYCLE
  CACHE 20
  NOORDER;

--
-- 3. VERSION  (Column) 
--
ALTER TABLE RHNPACKAGECAPABILITY
MODIFY(VERSION VARCHAR2(64 BYTE));


--
-- 4. RHNPACKAGEDELTA  (Table) 
--
CREATE TABLE RHNPACKAGEDELTA
(
  ID        NUMBER CONSTRAINT RHN_PACKAGEDELTA_ID_NN NOT NULL,
  LABEL     VARCHAR2(32 BYTE) CONSTRAINT RHN_PACKAGEDELTA_LABEL_NN NOT NULL,
  CREATED   DATE                                DEFAULT (sysdate) CONSTRAINT RHN_PACKAGEDELTA_CREATED_NN NOT NULL,
  MODIFIED  DATE                                DEFAULT (sysdate) CONSTRAINT RHN_PACKAGEDELTA_MODIFIED_NN NOT NULL
)
LOGGING 
NOCACHE
NOPARALLEL;

--
-- 5. RHNSATELLITECERT  (Table) 
--
-- Difference : Column Order (No action taken) 

--
-- 6. RHN_PACKAGEDELTA_ID_PK  (Index) 
--
CREATE UNIQUE INDEX RHN_PACKAGEDELTA_ID_PK ON RHNPACKAGEDELTA
(ID)
LOGGING
NOPARALLEL;

--
-- 7. RHN_PACKAGEDELTA_LABEL_ID_IDX  (Index) 
--
CREATE INDEX RHN_PACKAGEDELTA_LABEL_ID_IDX ON RHNPACKAGEDELTA
(LABEL, ID)
LOGGING
NOPARALLEL;

--
-- 8. RHN_CHANNEL  (Package Body) 
--
CREATE OR REPLACE PACKAGE BODY rhn_channel
IS
    FUNCTION get_license_path(channel_id_in IN NUMBER)
    RETURN VARCHAR2
    IS
    	license_val VARCHAR2(1000);
    BEGIN
    	SELECT CFL.license_path INTO license_val
	  FROM rhnChannelFamilyLicense CFL, rhnChannelFamilyMembers CFM
	 WHERE CFM.channel_id = channel_id_in
	   AND CFM.channel_family_id = CFL.channel_family_id;
    	RETURN license_val;
    EXCEPTION
    	WHEN NO_DATA_FOUND
	    THEN
	    RETURN NULL;
    END get_license_path;
    PROCEDURE license_consent(channel_id_in IN NUMBER, user_id_in IN NUMBER, server_id_in IN NUMBER)
    IS
    	channel_family_id_val NUMBER;
    BEGIN
    	channel_family_id_val := rhn_channel.family_for_channel(channel_id_in);
	IF channel_family_id_val IS NULL
	THEN
	    rhn_exception.raise_exception('channel_subscribe_no_family');
	END IF;
	IF rhn_channel.get_license_path(channel_id_in) IS NULL
	THEN
	    rhn_exception.raise_exception('channel_consent_no_license');
	END IF;
	INSERT INTO rhnChannelFamilyLicenseConsent (channel_family_id, user_id, server_id)
	VALUES (channel_family_id_val, user_id_in, server_id_in);
    END license_consent;
    PROCEDURE subscribe_server(server_id_in IN NUMBER, channel_id_in NUMBER, immediate_in NUMBER := 1)
    IS
        channel_parent_val      rhnChannel.parent_channel%TYPE;
        parent_subscribed       BOOLEAN;
        server_has_base_chan    BOOLEAN;
	server_already_in_chan  BOOLEAN;
	channel_family_id_val   NUMBER;
	server_org_id_val       NUMBER;
	available_subscriptions NUMBER;
	consenting_user         NUMBER;
    BEGIN
        SELECT parent_channel INTO channel_parent_val FROM rhnChannel WHERE id = channel_id_in;
        IF channel_parent_val IS NOT NULL
        THEN
            parent_subscribed := FALSE;
            FOR check_subscription IN check_server_subscription(server_id_in, channel_parent_val)
            LOOP
                parent_subscribed := TRUE;
            END LOOP check_subscription;
            IF NOT parent_subscribed
            THEN
    	    	RETURN;
            END IF;
        ELSE
            server_has_base_chan := FALSE;
            FOR base IN server_base_subscriptions(server_id_in)
            LOOP
                server_has_base_chan := TRUE;
            END LOOP base;
            IF server_has_base_chan
            THEN
                rhn_exception.raise_exception('channel_server_one_base');
            END IF;
        END IF;
        FOR check_subscription IN check_server_subscription(server_id_in, channel_id_in)
        LOOP
            server_already_in_chan := TRUE;
        END LOOP check_subscription;
        IF server_already_in_chan
        THEN
    	    RETURN;
        END IF;
	channel_family_id_val := rhn_channel.family_for_channel(channel_id_in);
	IF channel_family_id_val IS NULL
	THEN
	    rhn_exception.raise_exception('channel_subscribe_no_family');
	END IF;
	SELECT org_id INTO server_org_id_val
	  FROM rhnServer
	 WHERE id = server_id_in;
	available_subscriptions := rhn_channel.available_family_subscriptions(channel_family_id_val, server_org_id_val);
	IF available_subscriptions IS NULL OR available_subscriptions > 0
	THEN
	    IF rhn_channel.get_license_path(channel_id_in) IS NOT NULL
	    THEN
	    	BEGIN
	    	SELECT user_id INTO consenting_user
		  FROM rhnChannelFamilyLicenseConsent
		 WHERE channel_family_id = channel_family_id_val
		   AND server_id = server_id_in;
		EXCEPTION
    	    	    WHEN NO_DATA_FOUND
		    	THEN
			    rhn_exception.raise_exception('channel_subscribe_no_consent');
		END;
	    END IF;
            INSERT INTO rhnServerChannel (server_id, channel_id) VALUES (server_id_in, channel_id_in);
    	    rhn_channel.update_family_counts(channel_family_id_val, server_org_id_val);
    	    queue_server(server_id_in, immediate_in);
	ELSE
	    rhn_exception.raise_exception('channel_family_no_subscriptions');
	END IF;
    END subscribe_server;
    PROCEDURE bulk_subscribe_server(channel_id_in IN NUMBER, set_label_in IN VARCHAR2, set_uid_in IN NUMBER)
    IS
    BEGIN
        FOR server IN rhn_set.set_iterator(set_label_in, set_uid_in)
        LOOP
            rhn_channel.subscribe_server(server.element, channel_id_in, 0);
        END LOOP server;
    END bulk_subscribe_server;
    PROCEDURE bulk_server_base_change(channel_id_in IN NUMBER, set_label_in IN VARCHAR2, set_uid_in IN NUMBER)
    IS
		cursor is_changeable(server_id_in in number) is
			select	server_id_in id
			from	dual
			where	not exists (select 1 from rhnSatelliteInfo where server_id = server_id_in)
				and not exists (select 1 from rhnProxyInfo where server_id = server_id_in);
    BEGIN
        FOR server IN rhn_set.set_iterator(set_label_in, set_uid_in)
        LOOP
			for s in is_changeable(server.element) loop
            	rhn_channel.clear_subscriptions(TO_NUMBER(s.id));
            	rhn_channel.subscribe_server(s.id, channel_id_in, 0);
			end loop;
        END LOOP server;
    END bulk_server_base_change;
    procedure bulk_server_basechange_from(
	set_label_in in varchar2,
	set_uid_in in number,
	old_channel_id_in in number,
	new_channel_id_in in number
    ) is
	cursor channels(server_id_in in number) is
	    select	rsc.channel_id
	    from	rhnServerChannel rsc,
			rhnChannel rc
	    where	server_id_in = rsc.server_id
			and rsc.channel_id = rc.id
			and rc.parent_channel is null;
    begin
	for server in rhn_set.set_iterator(set_label_in, set_uid_in)
	loop
	    for channel in channels(server.element)
	    loop
		if channel.channel_id = old_channel_id_in
		then
		    insert into rhnSet (user_id, label, element) values (set_uid_in, set_label_in || 'basechange', server.element);
		end if;
	    end loop channel;
	end loop server;
	bulk_server_base_change(new_channel_id_in, set_label_in||'basechange',set_uid_in);
	delete from rhnSet where label = set_label_in||'basechange' and user_id = set_uid_in;
    end;
    procedure bulk_guess_server_base(
	set_label_in in varchar2,
	set_uid_in in number
    ) is
	channel_id number;
    begin
	for server in rhn_set.set_iterator(set_label_in, set_uid_in)
	loop
	    begin
    	        channel_id := guess_server_base(TO_NUMBER(server.element));
	    	rhn_channel.clear_subscriptions(TO_NUMBER(server.element));
	    	rhn_channel.subscribe_server(TO_NUMBER(server.element), channel_id, 0);
	    exception when others then
	    	null;
	    end;
	end loop server;
    end;
    function guess_server_base(
    	server_id_in in number
    ) RETURN number is
    	channel number;
    begin
    	select	id
	into	channel
	from (
		select	rc.id
		from
			rhnChannelPermissions rcp,
			rhnChannel rc,
			rhnServerChannelArchCompat scac,
			rhnDistChannelMap rdcm,
			rhnServer rs
		where	rs.id = server_id_in
			and rdcm.os IN (rs.os, 'Red Hat Linux Advanced Server', 'Red Hat Advanced Server')
			and rs.release = rdcm.release
			and rdcm.channel_id = rc.id
			and rs.server_arch_id = scac.server_arch_id
			and scac.channel_arch_id = rdcm.channel_arch_id
			and rdcm.channel_id = rcp.channel_id
			and (rcp.org_id is null or
				rcp.org_id = rs.org_id)
			and rdcm.channel_id = rc.id
			and rc.parent_channel is null
		order by rc.parent_channel
	) where rownum = 1;
	return channel;
    exception
	when no_data_found
	then
	    null;
    end;
    procedure bulk_guess_server_base_from(
	set_label_in in varchar2,
	set_uid_in in number,
	channel_id_in in number
    ) is
	cursor channels(server_id_in in number) is
	    select	rsc.channel_id
	    from	rhnServerChannel rsc,
			rhnChannel rc
	    where	server_id_in = rsc.server_id
			and rsc.channel_id = rc.id
			and rc.parent_channel is null;
    begin
	for server in rhn_set.set_iterator(set_label_in, set_uid_in)
	loop
	    for channel in channels(server.element)
	    loop
		if channel.channel_id = channel_id_in
		then
		    insert into rhnSet (user_id, label, element) values (set_uid_in, set_label_in || 'baseguess', server.element);
		end if;
	    end loop channel;
	end loop server;
	bulk_guess_server_base(set_label_in||'baseguess',set_uid_in);
	delete from rhnSet where label = set_label_in||'baseguess' and user_id = set_uid_in;
    end;
    PROCEDURE clear_subscriptions(server_id_in IN NUMBER)
    IS
    	cursor server_channels(server_id_in in number) is
		select	s.org_id, sc.channel_id, cfm.channel_family_id
		from	rhnServer s,
			rhnServerChannel sc,
			rhnChannelFamilyMembers cfm
		where	s.id = server_id_in
			and s.id = sc.server_id
			and sc.channel_id = cfm.channel_id;
    BEGIN
    	for channel in server_channels(server_id_in)
	loop
		unsubscribe_server(server_id_in, channel.channel_id, 1, 1);
		rhn_channel.update_family_counts(channel.channel_family_id, channel.org_id);
	end loop channel;
    END clear_subscriptions;
    PROCEDURE unsubscribe_server(server_id_in IN NUMBER, channel_id_in NUMBER, immediate_in NUMBER := 1, unsubscribe_children_in number := 0)
    IS
	channel_family_id_val   NUMBER;
	server_org_id_val       NUMBER;
	available_subscriptions NUMBER;
	server_already_in_chan  BOOLEAN;
	cursor	channel_family_is_proxy(channel_family_id_in in number) is
		select	1
		from	rhnChannelFamily
		where	id = channel_family_id_in
		    and label = 'rhn-proxy';
	cursor	channel_family_is_satellite(channel_family_id_in in number) is
		select	1
		from	rhnChannelFamily
		where	id = channel_family_id_in
		    and label = 'rhn-satellite';
	cursor local_chk_server_parent_memb (
			server_id_in number,
			channel_id_in number ) is
		select	c.id
		from	rhnChannel			c,
				rhnServerChannel	sc
		where	1=1
			and c.parent_channel = channel_id_in
			and c.id = sc.channel_id
			and sc.server_id = server_id_in;
    BEGIN
        FOR child IN local_chk_server_parent_memb(server_id_in, channel_id_in)
        LOOP
	    if unsubscribe_children_in = 1 then
	    	unsubscribe_server(server_id_in => server_id_in,
								channel_id_in => child.id,
								immediate_in => immediate_in,
								unsubscribe_children_in => unsubscribe_children_in);
	    else
	    	rhn_exception.raise_exception('channel_unsubscribe_child_exists');
	    end if;
        END LOOP child;
	server_already_in_chan := FALSE;
        FOR check_subscription IN check_server_subscription(server_id_in, channel_id_in)
        LOOP
            server_already_in_chan := TRUE;
        END LOOP check_subscription;
        IF NOT server_already_in_chan
        THEN
    	    RETURN;
        END IF;
        DELETE FROM rhnServerChannel WHERE server_id = server_id_in AND channel_id = channel_id_in;
    	queue_server(server_id_in, immediate_in);
	channel_family_id_val := rhn_channel.family_for_channel(channel_id_in);
	IF channel_family_id_val IS NULL
	THEN
	    rhn_exception.raise_exception('channel_unsubscribe_no_family');
	END IF;
	for ignore in channel_family_is_satellite(channel_family_id_val) loop
		delete from rhnSatelliteInfo where server_id = server_id_in;
		delete from rhnSatelliteChannelFamily where server_id = server_id_in;
	end loop;
	for ignore in channel_family_is_proxy(channel_family_id_val) loop
		delete from rhnProxyInfo where server_id = server_id_in;
	end loop;
	DELETE FROM rhnChannelFamilyLicenseConsent
	 WHERE channel_family_id = channel_family_id_val
	   AND server_id = server_id_in;
	SELECT org_id INTO server_org_id_val
	  FROM rhnServer
	 WHERE id = server_id_in;
	rhn_channel.update_family_counts(channel_family_id_val, server_org_id_val);
    END unsubscribe_server;
    PROCEDURE bulk_unsubscribe_server(channel_id_in IN NUMBER, set_label_in IN VARCHAR2, set_uid_in IN NUMBER)
    IS
    BEGIN
        FOR server IN rhn_set.set_iterator(set_label_in, set_uid_in)
        LOOP
            rhn_channel.unsubscribe_server(server.element, channel_id_in, 0);
        END LOOP server;
    END bulk_unsubscribe_server;
    FUNCTION subscription_count(channel_id_in NUMBER)
    RETURN VARCHAR2
    IS
    	sub_count_val NUMBER;
	null_org    NUMBER;
    BEGIN
        SELECT COUNT(*) INTO sub_count_val FROM rhnChannelPermissions WHERE channel_id = channel_id_in;
	IF sub_count_val = 1
	THEN
	    SELECT org_id INTO null_org FROM rhnChannelPermissions WHERE channel_id = channel_id_in AND org_id IS NULL;
	    IF null_org IS NULL
	    THEN
	    	RETURN '(public)';
	    END IF;
	END IF;
	RETURN sub_count_val;
    EXCEPTION
        WHEN NO_DATA_FOUND
	THEN
	    RETURN 1;
    END subscription_count;
    FUNCTION family_for_channel(channel_id_in IN NUMBER)
    RETURN NUMBER
    IS
    	channel_family_id_val NUMBER;
    BEGIN
    	SELECT channel_family_id INTO channel_family_id_val
	  FROM rhnChannelFamilyMembers
         WHERE channel_id = channel_id_in;
	RETURN channel_family_id_val;
    EXCEPTION
        WHEN NO_DATA_FOUND
	THEN
	    RETURN NULL;
    END family_for_channel;
    FUNCTION available_family_subscriptions(channel_family_id_in IN NUMBER, org_id_in IN NUMBER)
    RETURN NUMBER
    IS
    	cfp channel_family_perm_cursor%ROWTYPE;
    	current_members_val NUMBER;
	max_members_val     NUMBER;
	found               NUMBER;
    BEGIN
	IF NOT channel_family_perm_cursor%ISOPEN
	THEN
	    OPEN channel_family_perm_cursor(channel_family_id_in, org_id_in);
	END IF;
	FETCH channel_family_perm_cursor INTO cfp;
	WHILE channel_family_perm_cursor%FOUND
    	LOOP
	    found := 1;
	    current_members_val := cfp.current_members;
	    max_members_val := cfp.max_members;
	    FETCH channel_family_perm_cursor INTO cfp;
	END LOOP;
	IF channel_family_perm_cursor%ISOPEN
	THEN
	    CLOSE channel_family_perm_cursor;
	END IF;
	IF found IS NULL
	THEN
	    RETURN 0;
	END IF;
	IF max_members_val IS NULL
	THEN
	    RETURN NULL;
	END IF;
	RETURN max_members_val - current_members_val;
    END available_family_subscriptions;
    PROCEDURE update_family_counts(channel_family_id_in IN NUMBER, org_id_in IN NUMBER)
    IS
    BEGIN
    	UPDATE rhnChannelFamilyPermissions
	   SET current_members = (SELECT COUNT(server_id)
	                            FROM rhnServerChannel
				   WHERE channel_id IN (SELECT channel_id FROM rhnChannelFamilyMembers
				                         WHERE channel_family_id = channel_family_id_in)
				     AND server_id IN (SELECT id FROM rhnServer WHERE org_id = org_id_in))
	 WHERE channel_family_id = channel_family_id_in
	   AND org_id = org_id_in;
    END update_family_counts;
    FUNCTION available_chan_subscriptions(channel_id_in IN NUMBER, org_id_in IN NUMBER)
    RETURN NUMBER
    IS
	channel_family_id_val NUMBER;
    BEGIN
    	SELECT channel_family_id INTO channel_family_id_val
	  FROM rhnChannelFamilyMembers
	 WHERE channel_id = channel_id_in;
	 RETURN rhn_channel.available_family_subscriptions(channel_family_id_val, org_id_in);
    END available_chan_subscriptions;
    procedure entitle_customer(customer_id_in in number, channel_family_id_in in number, quantity_in in number)
    is
		cursor permissions is
			select	1
			from	rhnChannelFamilyPermissions rcfp
			where	rcfp.org_id = customer_id_in
				and	rcfp.channel_family_id = channel_family_id_in;
    begin
		for perm in permissions loop
			set_family_maxmembers(
				customer_id_in,
				channel_family_id_in,
				quantity_in
			);
			rhn_channel.update_family_counts(
				channel_family_id_in,
				customer_id_in
			);
			return;
		end loop;
		insert
        into    rhnChannelFamilyPermissions
               (channel_family_id, org_id, max_members, current_members)
        values  (channel_family_id_in, customer_id_in, quantity_in, 0);
    end;
    procedure set_family_maxmembers(customer_id_in in number, channel_family_id_in in number, quantity_in in number)
    is
	cursor servers is
	    select  server_id from (
		select	rownum row_number, server_id, modified from (
		    select  rcfs.server_id,
			    rcfs.modified
		    from    rhnChannelFamilyServers rcfs
		    where   rcfs.customer_id = customer_id_in
			    and rcfs.channel_family_id = channel_family_id_in
		    order by modified
		)
		where rownum > quantity_in
	    );
    begin
	for server in servers
	loop
	    rhn_channel.unsubscribe_server_from_family(server.server_id, channel_family_id_in);
	end loop;
	update	rhnChannelFamilyPermissions rcfp
	set	rcfp.max_members = quantity_in
	where	rcfp.channel_family_id = channel_family_id_in
		and rcfp.org_id = customer_id_in;
    end;
    procedure unsubscribe_server_from_family(server_id_in in number, channel_family_id_in in number)
    is
    begin
	delete
	from	rhnServerChannel rsc
	where	rsc.server_id = server_id_in
		and channel_id in (
			select	rcfm.channel_id
			from	rhnChannelFamilyMembers rcfm
			where	rcfm.channel_family_id = channel_family_id_in);
    end;
    procedure delete_server_channels(server_id_in in number)
    is
    begin
	update	rhnChannelFamilyPermissions
	set	current_members = current_members -1
	where	org_id in (
			select	org_id
			from	rhnServer
			where	id = server_id_in
		)
		and channel_family_id in (
			select	rcfm.channel_family_id
			from	rhnChannelFamilyMembers rcfm,
				rhnServerChannel rsc
			where	rsc.server_id = server_id_in
				and rsc.channel_id = rcfm.channel_id
		);
    end;
	procedure refresh_newest_package(channel_id_in in number, caller_in in varchar2 := '(unknown)')
	is
	begin
		delete from rhnChannelNewestPackage where channel_id = channel_id_in;
		insert into rhnChannelNewestPackage
			( channel_id, name_id, evr_id, package_id, package_arch_id )
			(	select	channel_id,
						name_id, evr_id,
						package_id, package_arch_id
				from	rhnChannelNewestPackageView
				where	channel_id = channel_id_in
			);
                insert into rhnChannelNewestPackageAudit (channel_id, caller)
                    values (channel_id_in, caller_in);
                update rhnChannel
                    set last_modified = greatest(sysdate, last_modified + 1/86400)
                    where id = channel_id_in;
	end;
END rhn_channel;
/

SHOW ERRORS;

--
-- 9. RHN_ENTITLEMENTS  (Package Body) 
--
CREATE OR REPLACE package body rhn_entitlements
is
	function lookup_entitlement_group (
		org_id_in in number,
		type_label_in in varchar2 := 'sw_mgr_entitled'
	) return number is
		cursor server_groups is
			select	sg.id				server_group_id
			from	rhnServerGroup		sg,
					rhnServerGroupType	sgt
			where	sgt.label = type_label_in
				and sgt.id = sg.group_type
				and sg.org_id = org_id_in;
	begin
		for sg in server_groups loop
			return sg.server_group_id;
		end loop;
		return rhn_entitlements.create_entitlement_group(
				org_id_in,
				type_label_in
			);
	end lookup_entitlement_group;
	function create_entitlement_group (
		org_id_in in number,
		type_label_in in varchar2 := 'sw_mgr_entitled'
	) return number is
		sg_id_val number;
	begin
		insert into rhnServerGroup (
				id, name, description, max_members, current_members,
				group_type, org_id
			) (
				select	rhn_server_group_id_seq.nextval, sgt.label, sgt.label,
						0, 0, sgt.id, org_id_in
				from	rhnServerGroupType sgt
				where	sgt.label = type_label_in
			);
		select	rhn_server_group_id_seq.currval
		into	sg_id_val
		from	dual;
		return sg_id_val;
	end create_entitlement_group;
	function get_server_entitlement (
		server_id_in in number
	) return varchar2 is
		cursor server_groups is
			select	sgt.label
			from	rhnServerGroupType		sgt,
					rhnServerGroup			sg,
					rhnServerGroupMembers	sgm
			where	1=1
				and sgm.server_id = server_id_in
				and sg.id = sgm.server_group_id
				and sgt.id = sg.group_type
				and sgt.label in ('sw_mgr_entitled','enterprise_entitled');
	begin
		for sg in server_groups loop
			return sg.label;
		end loop;
		return 'none';
	end get_server_entitlement;
	procedure unentitle_server (
		server_id_in in number,
		type_label_in in varchar2 := 'sw_mgr_entitled'
	) is
		org_id_val number;
		e_type varchar2(30);
	begin
		select	org_id
		into	org_id_val
		from	rhnServer
		where	id = server_id_in;
		delete	from	rhnServerGroupMembers
				where	1=1
					and server_id = server_id_in
					and server_group_id =
						rhn_entitlements.lookup_entitlement_group(
							org_id_val, type_label_in
						);
	end unentitle_server;
	procedure entitle_server (
		server_id_in in number,
		type_label_in in varchar2 := 'sw_mgr_entitled'
	) is
		sg_id_val number;
		org_id_val number;
		previous_ent rhnServerGroupType.label%TYPE;
	begin
		select	org_id
		into	org_id_val
		from	rhnServer
		where	id = server_id_in;
		previous_ent := rhn_entitlements.get_server_entitlement(server_id_in);
		if previous_ent != 'none' then
			rhn_exception.raise_exception('no_server_multiple_swmgr_entitlements');
		end if;
		sg_id_val := lookup_entitlement_group(org_id_val, type_label_in);
		insert into rhnServerGroupMembers (
				server_id, server_group_id
			) values (
				server_id_in, sg_id_val
		);
	end entitle_server;
	procedure set_customer_enterprise (
		customer_id in number
	) is
		entitlement_type_id number;
		status number;
	begin
		select	roet.id, roe.org_id
		into	entitlement_type_id, status
		from	rhnOrgEntitlementType	roet,
				rhnOrgEntitlements		roe
		where	1=1
			and roet.label = 'sw_mgr_enterprise'
			and roet.id = roe.entitlement_id(+)
			and roe.org_id(+) = customer_id;
		if status is null then
			insert into rhnOrgEntitlements (
					org_id, entitlement_id
				) values (
					customer_id, entitlement_type_id
			);
		end if;
		update		rhnUserGroup
			set		max_members = null
			where	1=1
				and org_id = customer_id
				and group_type in (
					select	id
					from	rhnUserGroupType
					where	label in ('org_admin', 'org_applicant')
				);
	end set_customer_enterprise;
	procedure unset_customer_enterprise (
		customer_id in number
	) is
	begin
		delete	from	rhnOrgEntitlements
				where	1=1
					and org_id = customer_id
					and entitlement_id in (
						select	id
						from	rhnOrgEntitlementType
						where	label = 'sw_mgr_enterprise'
					);
		update		rhnUserGroup
			set		max_members = null
			where	1=1
				and org_id = customer_id
				and group_type in (
					select	id
					from	rhnUserGroupType
					where	label in ('org_admin', 'org_applicant')
				);
	end unset_customer_enterprise;
	procedure prune_group (
		group_id_in in number,
		type_in in char,
		quantity_in in number
	) is
		cursor usergroups is
			select	user_id, user_group_id, ugt.label
			from	rhnUserGroupType	ugt,
					rhnUserGroup		ug,
					rhnUserGroupMembers	ugm
			where	1=1
				and ugm.user_group_id = group_id_in
				and ugm.user_id in (
					select	user_id
					from	(
						select	rownum row_number,
								user_id,
								time
						from	(
							select	user_id,
									modified time
							from	rhnUserGroupMembers
							where	user_group_id = group_id_in
							order by time asc
						)
					)
					where	row_number > quantity_in
				)
				and ugm.user_group_id = ug.id
				and ug.group_type = ugt.id;
		cursor servergroups is
			select	server_id, server_group_id, sgt.label
			from	rhnServerGroupType		sgt,
					rhnServerGroup			sg,
					rhnServerGroupMembers	sgm
			where	1=1
				and sgm.server_group_id = group_id_in
				and sgm.server_id in (
					select	server_id
					from	(
						select	rownum row_number,
								server_id,
								time
						from	(
							select	server_id,
									modified time
							from	rhnServerGroupMembers
							where	server_group_id = group_id_in
							order by time asc
						)
					)
					where	row_number > quantity_in
				)
				and sgm.server_group_id = sg.id
				and sg.group_type = sgt.id;
	begin
		if type_in = 'U' then
			update		rhnUserGroup
				set		max_members = quantity_in
				where	id = group_id_in;
			for ug in usergroups loop
				delete
					from	rhnUserGroupMembers
					where	user_group_id = ug.user_group_id
						and user_id = ug.user_id;
			end loop;
		elsif type_in = 'S' then
			update		rhnServerGroup
				set		max_members = quantity_in
				where	id = group_id_in;
			for sg in servergroups loop
				unentitle_server(sg.server_id, sg.label);
				rhn_channel.clear_subscriptions(sg.server_id);
			end loop;
		end if;
	end prune_group;
	procedure set_group_count (
		customer_id_in in number,
		type_in in char,
		group_type_in in number,
		quantity_in in number
	) is
		group_id number;
	begin
		if type_in = 'U' then
			select	rug.id
			into	group_id
			from	rhnUserGroup rug
			where	1=1
				and rug.org_id = customer_id_in
				and rug.group_type = group_type_in;
		elsif type_in = 'S' then
			select	rsg.id
			into	group_id
			from	rhnServerGroup rsg
			where	1=1
				and rsg.org_id = customer_id_in
				and rsg.group_type = group_type_in;
		end if;
		rhn_entitlements.prune_group(
			group_id,
			type_in,
			quantity_in
		);
	exception
		when no_data_found then
			if type_in = 'U' then
				insert into rhnUserGroup (
						id, name, description, max_members, current_members,
						group_type, org_id, created, modified
					) (
						select	rhn_user_group_id_seq.nextval, name, name,
								quantity_in, 0, id, customer_id_in, sysdate, sysdate
						from	rhnUserGroupType
						where	id = group_type_in
				);
			elsif type_in = 'S' then
				insert into rhnServerGroup (
						id, name, description, max_members, current_members,
						group_type, org_id, created, modified
					) (
						select	rhn_server_group_id_seq.nextval, name, name,
								quantity_in, 0, id, customer_id_in, sysdate, sysdate
						from	rhnServerGroupType
						where	id = group_type_in
				);
			end if;
	end set_group_count;
	procedure prune_family (
		customer_id_in in number,
		channel_family_id_in in number,
		quantity_in in number
	) is
		cursor serverchannels is
			select	sc.server_id,
					sc.channel_id
			from	rhnServerChannel sc,
					rhnChannelFamilyMembers cfm
			where	1=1
				and cfm.channel_family_id = channel_family_id_in
				and cfm.channel_id = sc.channel_id
				and server_id in (
					select	server_id
					from	(
						select	server_id,
								time,
								rownum row_number
						from	(
							select	rs.id					server_id,
									rcfm.modified			time
							from	rhnServer				rs,
									rhnServerChannel		rsc,
									rhnChannelFamilyMembers	rcfm
							where	1=1
								and rs.org_id = customer_id_in
								and rs.id = rsc.server_id
								and rsc.channel_id = rcfm.channel_id
								and rcfm.channel_family_id = channel_family_id_in
							order by time asc
						)
					)
					where row_number > quantity_in
				);
	begin
		if customer_id_in is null then
			return;
		end if;
		update		rhnChannelFamilyPermissions
			set		max_members = quantity_in
			where	1=1
				and org_id = customer_id_in
				and channel_family_id = channel_family_id_in;
		for sc in serverchannels loop
			rhn_channel.unsubscribe_server(sc.server_id, sc.channel_id, 1, 1);
		end loop;
	end prune_family;
	procedure set_family_count (
		customer_id_in in number,
		channel_family_id_in in number,
		quantity_in in number
	) is
		perm_exists number;
	begin
		select	1
		into	perm_exists
		from	rhnChannelFamilyPermissions
		where	1=1
			and channel_family_id = channel_family_id_in
			and (org_id = customer_id_in or
				(org_id is null and customer_id_in is null));
		rhn_entitlements.prune_family(
				customer_id_in,
				channel_family_id_in,
				quantity_in
			);
	exception
		when no_data_found then
			insert into rhnChannelFamilyPermissions (
					channel_family_id, org_id, max_members, current_members
				) values (
					channel_family_id_in, customer_id_in, quantity_in, 0
				);
	end set_family_count;
	procedure entitle_last_modified_servers (
		customer_id_in in number,
		type_label_in in varchar2,
		quantity_in in number
	) is
		cursor	servers(cid_in in number, quant_in in number) is
			select	server_id
			from	(
						select	rownum row_number,
								server_id
						from	(
									select	rs.id server_iD
									from	rhnServer rs
									where	1=1
										and rs.org_id = cid_in
										and not exists (
											select	1
											from	rhnServerGroupMembers rsgm
											where	rsgm.server_id = rs.id
										)
									order by modified desc
								)
					)
			where	row_number <= quant_in;
	begin
		for server in servers(customer_id_in, quantity_in) loop
			rhn_entitlements.entitle_server(server.server_id, type_label_in);
		end loop;
	end entitle_last_modified_servers;
	procedure prune_everything (
		customer_id_in in number
	) is
		cursor everything is
			select	sg.id					id,
					'S'						type,
					sg.max_members			quantity
			from	rhnServerGroup			sg
			where	sg.org_id = customer_id_in
			union
			select	ug.id					id,
					'U'						type,
					ug.max_members 			quantity
			from	rhnUserGroup			ug
			where	ug.org_id = customer_id_in
			union (
			select	cfp.channel_family_id	id,
					'C'						type,
					cfp.max_members			quantity
			from	rhnChannelFamilyPermissions cfp
			where	cfp.org_id = customer_id_in
				or	cfp.org_id is null
			union
			select	cfm.channel_family_id	id,
					'C'						type,
					0						quantity
			from	rhnChannelFamily		cf,
					rhnChannelFamilyMembers	cfm,
					rhnServerChannel		sc,
					rhnServer				s
			where	s.org_id = customer_id_in
				and s.id = sc.server_id
				and sc.channel_id = cfm.channel_id
				and not exists (
					select	1
					from	rhnChannelFamilyPermissions cfp
					where	(cfp.org_id = customer_id_in or cfp.org_id is null)
					)
				and cfm.channel_family_id = cf.id
				and cf.org_id is not null
				and cf.org_id != customer_id_in
			);
	begin
		for one in everything loop
			if one.type in ('U','S') then
				prune_group(one.id, one.type, one.quantity);
			else
				prune_family(customer_id_in, one.id, one.quantity);
			end if;
		end loop;
	end prune_everything;
end rhn_entitlements;
/

SHOW ERRORS;

--
-- 10. RHN_QOS  (Package Body) 
--
ALTER PACKAGE RHN_QOS COMPILE BODY;

--
-- 11. RHN_PACKAGEDELTA_MOD_TRIG  (Trigger) 
--
CREATE OR REPLACE TRIGGER RHN_PACKAGEDELTA_MOD_TRIG
BEFORE INSERT OR UPDATE ON RHNPACKAGEDELTA
FOR EACH ROW
begin
	:new.modified := sysdate;
end;
/
SHOW ERRORS;


--
-- 12. RHN_SATCERT_MOD_TRIG  (Trigger) 
--
ALTER TRIGGER RHN_SATCERT_MOD_TRIG COMPILE;

--
-- 13. RHNCHANNEL  (Table) 
--
-- Difference : Column Order (No action taken) 

--
-- 14. RHNDISTCHANNELMAP  (Table) 
--
-- Difference : Column Order (No action taken) 

--
-- 15. RHNPACKAGE  (Table) 
--
-- Difference : Column Order (No action taken) 

--
-- 16. SENSE  (Column) 
--
--
-- 17. RHNPACKAGEDELTAELEMENT  (Table) 
--
CREATE TABLE RHNPACKAGEDELTAELEMENT
(
  PACKAGE_DELTA_ID        NUMBER CONSTRAINT RHN_PDELEMENT_PDID_NN NOT NULL,
  TRANSACTION_PACKAGE_ID  NUMBER CONSTRAINT RHN_PDELEMENT_TPID_NN NOT NULL
)
LOGGING 
NOCACHE
NOPARALLEL;

--
-- 18. SENSE  (Column) 
--
ALTER TABLE RHNPACKAGEOBSOLETES
MODIFY(SENSE  DEFAULT (0));

--
-- 19. SENSE  (Column) 
--
ALTER TABLE RHNPACKAGEPROVIDES
MODIFY(SENSE  DEFAULT (0));

--
-- 20. SENSE  (Column) 
--
ALTER TABLE RHNPACKAGEREQUIRES
MODIFY(SENSE  DEFAULT (0));

--
-- 21. RHNPACKAGESOURCE  (Table) 
--
-- Difference : Column Order (No action taken) 

--
-- 22. PROCESSED  (Column) 
--
ALTER TABLE RHNSNPERRATAQUEUE
MODIFY(PROCESSED  DEFAULT (0));

--
-- 23. WEB_USER_PERSONAL_INFO  (Table) 
--
-- Difference : Column Order (No action taken) 

--
-- 24. WEB_USER_SITE_INFO  (Table) 
--
-- Difference : Column Order (No action taken) 

--
-- 25. RHN_PDELEMENT_PDID_TPID_UQ  (Index) 
--
CREATE UNIQUE INDEX RHN_PDELEMENT_PDID_TPID_UQ ON RHNPACKAGEDELTAELEMENT
(PACKAGE_DELTA_ID, TRANSACTION_PACKAGE_ID)
LOGGING
NOPARALLEL;

--
-- 26. RHN_CHANNEL_FAMILY_MOD_TRIG  (Trigger) 
--
ALTER TRIGGER RHN_CHANNEL_FAMILY_MOD_TRIG COMPILE;

--
-- 27. RHN_ERRATA_MOD_TRIG  (Trigger) 
--
ALTER TRIGGER RHN_ERRATA_MOD_TRIG COMPILE;

--
-- 28. WEB_USER_PI_TIMESTAMP  (Trigger) 
--
ALTER TRIGGER WEB_USER_PI_TIMESTAMP COMPILE;

--
-- 29. RHNACTIONPACKAGEDELTA  (Table) 
--
CREATE TABLE RHNACTIONPACKAGEDELTA
(
  ACTION_ID         NUMBER CONSTRAINT RHN_ACT_PD_AID_NN NOT NULL,
  PACKAGE_DELTA_ID  NUMBER CONSTRAINT RHN_ACT_PD_PDID_NN NOT NULL
)
LOGGING 
NOCACHE
NOPARALLEL;

--
-- 30. RHNSERVER  (Table) 
--
-- Difference : Column Order (No action taken) 

--
-- 31. RHNSERVERACTION  (Table) 
--
-- Difference : Column Order (No action taken) 

--
-- 32. RHNUSERINFO  (Table) 
--
-- Difference : Column Order (No action taken) 

--
-- 33. RHN_ACT_PD_AID_PDID_IDX  (Index) 
--
CREATE UNIQUE INDEX RHN_ACT_PD_AID_PDID_IDX ON RHNACTIONPACKAGEDELTA
(ACTION_ID, PACKAGE_DELTA_ID)
NOLOGGING
NOPARALLEL;

--
-- 34. RHNACTIONOVERVIEW  (View) 
--
CREATE OR REPLACE FORCE VIEW RHNACTIONOVERVIEW
(ORG_ID, ACTION_ID, TYPE_ID, TYPE_NAME, NAME, 
 SCHEDULER_LOGIN, EARLIEST_ACTION, TOTAL_COUNT, SUCCESSFUL_COUNT, FAILED_COUNT, 
 IN_PROGRESS_COUNT, ARCHIVED)
AS 
SELECT    A.org_id,
	  A.id,
	  AT.id,
	  AT.name,
	  A.name,
	  U.login,
	  A.earliest_action,
	  (SELECT COUNT(*) FROM rhnServerAction WHERE action_id = A.id),
	  (SELECT COUNT(*) FROM rhnServerAction WHERE action_id = A.id AND status = 2), -- XXX: don''t hard code status here :)
	  (SELECT COUNT(*) FROM rhnServerAction WHERE action_id = A.id AND status = 3),
	  (SELECT COUNT(*) FROM rhnServerAction WHERE action_id = A.id AND status NOT IN (2, 3)),
	  A.archived
FROM
	  web_contact U,
	  rhnActionType AT,
	  rhnAction A
WHERE	  A.scheduler = U.id(+)
AND	  A.action_type = AT.id
ORDER BY  A.earliest_action;

--
-- 35. RHNFREEERRATAMAIL  (View) 
--
CREATE OR REPLACE FORCE VIEW RHNFREEERRATAMAIL
(LOGIN, LOGIN_UC, EMAIL, USER_ID, SERVER_ID, 
 ORG_ID, SERVER_NAME, SERVER_ARCH, SERVER_RELEASE, ERRATA_ID, 
 ADVISORY)
AS 
select
	w.login login,
	w.login_uc login_uc,
	ea.address email,
	w.id user_id,
	s.id server_id,
	w.org_id org_id,
	s.name server_name,
	sa.name server_arch,
	s.release server_release,
	ce.errata_id errata_id,
	e.advisory advisory
from
	rhnChannelErrata ce,
	rhnServerChannel sc,
	rhnServerGroupMembers sgm,
	rhnOrgState os,
	rhnServerGroup sg,
	rhnServer s,
	web_contact w,
	rhnEmailAddress ea,
	rhnUserInfo ui,
	rhnErrata e,
	rhnServerArch sa
where	1=1
	and ce.channel_id = sc.channel_id
	and sc.server_id = sgm.server_id
	and sgm.server_group_id = sg.id
	and sg.org_id = w.org_id
	and not exists (
		select	usprefs.server_id
            	from	rhnUserServerPrefs usprefs
	   	where	1=1
	      		and usprefs.name = 'receive_notifications'
			and w.id = usprefs.user_id
	      		and sc.server_id = usprefs.server_id
	)
	and ea.state_id = 4
	and w.id = ea.user_id
	and w.id = ui.user_id
    	and ui.email_notify = 1
	and os.state_id in (5, 6, 7, 8, 11)
	and sg.org_id = os.org_id
	and s.server_arch_id = sa.id
	and sc.server_id = s.id
	and ce.errata_id = e.id;

--
-- 36. RHNPAIDERRATAMAIL  (View) 
--
CREATE OR REPLACE FORCE VIEW RHNPAIDERRATAMAIL
(LOGIN, LOGIN_UC, EMAIL, USER_ID, SERVER_ID, 
 ORG_ID, SERVER_NAME, SERVER_ARCH, SERVER_RELEASE, ERRATA_ID, 
 ADVISORY)
AS 
select
	w.login login,
	w.login_uc login_uc,
	ea.address email,
	w.id user_id,
	s.id server_id,
	w.org_id org_id,
	s.name server_name,
	sa.name server_arch,
	s.release server_release,
	ce.errata_id errata_id,
	e.advisory advisory
from
	rhnChannelErrata ce,
	rhnServerChannel sc,
	rhnServerGroupMembers sgm,
	rhnOrgState os,
	rhnServerGroup sg,
	rhnServer s,
	web_contact w,
	rhnEmailAddress ea,
	rhnUserInfo ui,
	rhnErrata e,
	rhnServerArch sa
where	1=1
	and ce.channel_id = sc.channel_id
	and sc.server_id = sgm.server_id
	and sgm.server_group_id = sg.id
	and os.state_id = 4
	and sg.org_id = os.org_id
	and sg.org_id = w.org_id
	and ea.state_id = 4
	and w.id = ea.user_id
	and not exists (
		select	usprefs.server_id
            	from	rhnUserServerPrefs usprefs
	   	where	1=1
	      		and usprefs.name = 'receive_notifications'
			and w.id = usprefs.user_id
	      		and sc.server_id = usprefs.server_id
	)
	and w.id = ui.user_id
    	and ui.email_notify = 1
	and exists (
		select	1
		from
			rhnUserGroupType	ugt,
			rhnUserGroup		ug,
			rhnUserGroupMembers	ugm
		where	1=1
			and ugt.label = 'org_admin'
			and ugt.id = ug.group_type
			and ug.id = ugm.user_group_id
			and ugm.user_id = w.id
		union all
		select	1
		from
			rhnServerGroupMembers	sq_sgm,
			rhnUserServerGroupPerms	usg
		where	sc.server_id = sq_sgm.server_id
			and sq_sgm.server_group_id = usg.server_group_id
			and usg.user_id = w.id
	)
	and sc.server_id = s.id
    	and exists (
        	select 1
		from
	    		rhnPackageEVR			p_evr,
	    		rhnPackageEVR			sp_evr,
	    		rhnServerPackage 		sp,
	    		rhnChannelPackage		cp,
	    		rhnPackage			p,
	    		rhnErrataPackage		ep,
	    		rhnServerPackageArchCompat	spac
		where	1=1
			and sc.channel_id = cp.channel_id
			and cp.package_id = p.id
			and ce.errata_id = ep.errata_id
			and ep.package_id = p.id
			and sc.channel_id = ce.channel_id
			and ce.errata_id = ep.errata_id
			and sc.server_id = sp.server_id
			and sp.name_id = p.name_id
			and sp.evr_id = sp_evr.id
			and p.evr_id = p_evr.id
			and sp.evr_id != p.evr_id
			and sp_evr.evr < p_evr.evr
			and p.package_arch_id = spac.package_arch_id
			and s.server_arch_id = spac.server_arch_id
	)
	and s.server_arch_id = sa.id
	and ce.errata_id = e.id;

--
-- 37. RHNSERVERNEEDEDPACKAGEVIEW  (View) 
--
CREATE OR REPLACE FORCE VIEW RHNSERVERNEEDEDPACKAGEVIEW
(ORG_ID, SERVER_ID, ERRATA_ID, PACKAGE_ID)
AS 
SELECT   S.org_id, S.id, EP.errata_id, P.id
FROM
	 rhnPackage P,
	 rhnServerPackageArchCompat SPAC,
	 rhnPackageEVR P_EVR,
	 rhnPackageEVR SP_EVR,
	 rhnErrataPackage EP,
	 rhnServerPackage SP,
	 rhnChannelPackage CP,
	 rhnServerChannel SC,
         rhnServer S
WHERE
    	 SC.server_id = S.id
  AND  	 SC.channel_id = CP.channel_id
  AND    CP.package_id = P.id
  AND    p.package_arch_id = spac.package_arch_id
  AND    spac.server_arch_id = s.server_arch_id
  AND    P.id = EP.package_id(+)
  AND    SP_EVR.id = SP.evr_id
  AND    P_EVR.id = P.evr_id
  AND    SP.server_id = S.id
  AND    SP.name_id = P.name_id
  AND    SP.evr_id != P.evr_id
  AND    SP_EVR.evr < P_EVR.evr
  AND    SP_EVR.evr = (SELECT MAX(PE.evr) FROM rhnServerPackage SP2, rhnPackageEvr PE WHERE PE.id = SP2.evr_id AND SP2.server_id = SP.server_id AND SP2.name_id = SP.name_id)
  AND    (   EP.errata_id IS NULL
          OR EXISTS (SELECT 1 FROM rhnChannelErrata CE, rhnServerChannel SC2 WHERE CE.errata_id = EP.errata_id AND CE.channel_id = SC2.channel_id AND SC2.server_id = S.id));

--
-- 38. RHN_CHANNEL_PACKAGE_DEL_TRIG  (Trigger) 
--
ALTER TRIGGER RHN_CHANNEL_PACKAGE_DEL_TRIG COMPILE;

--
-- 39. RHN_CHANNEL_PACKAGE_MOD_TRIG  (Trigger) 
--
ALTER TRIGGER RHN_CHANNEL_PACKAGE_MOD_TRIG COMPILE;

--
-- 40. RHN_SERVER_ACTION_MOD_TRIG  (Trigger) 
--
ALTER TRIGGER RHN_SERVER_ACTION_MOD_TRIG COMPILE;

--
-- 41. RHN_SERVER_GROUP_ORG_MAPPING  (Trigger) 
--
ALTER TRIGGER RHN_SERVER_GROUP_ORG_MAPPING COMPILE;

--
-- 42. RHN_SERVER_MOD_TRIG  (Trigger) 
--
ALTER TRIGGER RHN_SERVER_MOD_TRIG COMPILE;

--
-- 43. RHNCPU  (Table) 
--
-- Difference : Column Order (No action taken) 

--
-- 44. RHN_CPU_MOD_TRIG  (Trigger) 
--
ALTER TRIGGER RHN_CPU_MOD_TRIG COMPILE;

--
-- 45. RHN_ENTITLEMENTS  (Package) 
--
CREATE OR REPLACE package rhn_entitlements
is
	function lookup_entitlement_group (
		org_id_in in number,
		type_label_in in varchar2 := 'sw_mgr_entitled'
	) return number;
	function create_entitlement_group (
		org_id_in in number,
		type_label_in in varchar2 := 'sw_mgr_entitled'
	) return number;
	procedure entitle_server (
		server_id_in in number,
		type_label_in in varchar2 := 'sw_mgr_entitled'
	);
	procedure unentitle_server (
		server_id_in in number,
		type_label_in in varchar2 := 'sw_mgr_entitled'
	);
	function get_server_entitlement (
		server_id_in in number
	) return varchar2;
    procedure set_customer_enterprise (
		customer_id in number
	);
    procedure unset_customer_enterprise (
		customer_id in number
	);
    procedure set_group_count (
		customer_id_in in number,	-- customer_id
		type_in in char,			-- 'U' or 'S'
		group_type_in in number,	-- rhn[User|Server]GroupType.id
		quantity_in in number		-- quantity
    );
    procedure set_family_count (
		customer_id_in in number,		-- customer_id
		channel_family_id_in in number,	-- 246
		quantity_in in number			-- 3
    );
    procedure entitle_last_modified_servers (
		customer_id_in in number,	-- customer_id
		type_label_in in varchar2,	-- 'enterprise_entitled'
		quantity_in in number		-- 3
    );
	procedure prune_everything (
		customer_id_in in number
	);
end rhn_entitlements;
/

SHOW ERRORS;

--
-- 46. RHN_EADDRESS_UID_FK  (Constraint) 
--
ALTER TABLE RHNEMAILADDRESS DROP CONSTRAINT RHN_EADDRESS_UID_FK;
ALTER TABLE RHNEMAILADDRESS ADD CONSTRAINT RHN_EADDRESS_UID_FK FOREIGN KEY (USER_ID) 
    REFERENCES WEB_CONTACT (ID);

--
-- 47. RHN_PACKAGEDELTA_ID_PK  (Constraint) 
--
ALTER TABLE RHNPACKAGEDELTA ADD CONSTRAINT RHN_PACKAGEDELTA_ID_PK PRIMARY KEY (ID);

--
-- 48. RHN_PDELEMENT_PDID_FK  (Constraint) 
--
ALTER TABLE RHNPACKAGEDELTAELEMENT ADD CONSTRAINT RHN_PDELEMENT_PDID_FK FOREIGN KEY (PACKAGE_DELTA_ID) 
    REFERENCES RHNPACKAGEDELTA (ID)
    ON DELETE CASCADE;

--
-- 49. RHN_PDELEMENT_TPID_FK  (Constraint) 
--
ALTER TABLE RHNPACKAGEDELTAELEMENT ADD CONSTRAINT RHN_PDELEMENT_TPID_FK FOREIGN KEY (TRANSACTION_PACKAGE_ID) 
    REFERENCES RHNTRANSACTIONPACKAGE (ID);

--
-- 50. RHN_ACT_PD_AID_FK  (Constraint) 
--
ALTER TABLE RHNACTIONPACKAGEDELTA ADD CONSTRAINT RHN_ACT_PD_AID_FK FOREIGN KEY (ACTION_ID) 
    REFERENCES RHNACTION (ID)
    ON DELETE CASCADE;

-----------------------------------------------------

--------------------------------------------------------------------------
-- Play this script in TAW02@TAW02 to make it look like TAW01@TAW01
--                                                                      --
-- Please review the script before using it to make sure it won't       --
-- cause any unacceptable data loss.                                    --
--                                                                      --
-- TAW02@TAW02 Schema Extracted by User TAW02 
-- TAW01@TAW01 Schema Extracted by User TAW01 
--------------------------------------------------------------------------
--
-- 1. LABEL  (Column) 
--
ALTER TABLE RHNCHANNELARCH
MODIFY(LABEL  NOT NULL);


--
-- 2. NAME  (Column) 
--
ALTER TABLE RHNCHANNELARCH
MODIFY(NAME  NOT NULL);


--
-- 3. CREATED  (Column) 
--
ALTER TABLE RHNCHANNELARCH
MODIFY(CREATED  NOT NULL);


--
-- 4. MODIFIED  (Column) 
--
ALTER TABLE RHNCHANNELARCH
MODIFY(MODIFIED  NOT NULL);


--
-- 5. LABEL  (Column) 
--
ALTER TABLE RHNCPUARCH
MODIFY(LABEL  NOT NULL);


--
-- 6. NAME  (Column) 
--
ALTER TABLE RHNCPUARCH
MODIFY(NAME  NOT NULL);


--
-- 7. CREATED  (Column) 
--
ALTER TABLE RHNCPUARCH
MODIFY(CREATED  NOT NULL);


--
-- 8. MODIFIED  (Column) 
--
ALTER TABLE RHNCPUARCH
MODIFY(MODIFIED  NOT NULL);


--
-- 9. LAST_POLL  (Column) 
--
ALTER TABLE RHNDAEMONSTATE
MODIFY(LAST_POLL  NOT NULL);


--
-- 10. GROUP_NAME  (Column) 
--
ALTER TABLE RHNDOWNLOADGROUPS
MODIFY(GROUP_NAME  NOT NULL);


--
-- 11. DOWNLOAD_CATEGORY  (Column) 
--
ALTER TABLE RHNDOWNLOADGROUPS
MODIFY(DOWNLOAD_CATEGORY  NOT NULL);


--
-- 12. ORDERING  (Column) 
--
ALTER TABLE RHNDOWNLOADGROUPS
MODIFY(ORDERING  NOT NULL);


--
-- 13. LABEL  (Column) 
--
ALTER TABLE RHNEMAILADDRESSSTATE
MODIFY(LABEL  NOT NULL);


--
-- 14. CREATED  (Column) 
--
ALTER TABLE RHNEMAILADDRESSSTATE
MODIFY(CREATED  NOT NULL);


--
-- 15. MODIFIED  (Column) 
--
ALTER TABLE RHNEMAILADDRESSSTATE
MODIFY(MODIFIED  NOT NULL);


--
-- 16. RUN_TIME  (Column) 
--
ALTER TABLE RHNENTITLEMENTLOG
MODIFY(RUN_TIME  NOT NULL);


--
-- 17. BDATE  (Column) 
--
ALTER TABLE RHNENTITLEMENTLOG
MODIFY(BDATE  NOT NULL);


--
-- 18. EDATE  (Column) 
--
ALTER TABLE RHNENTITLEMENTLOG
MODIFY(EDATE  NOT NULL);


--
-- 19. LABEL  (Column) 
--
ALTER TABLE RHNERRATAFILETYPE
MODIFY(LABEL  NOT NULL);


--
-- 20. LABEL  (Column) 
--
ALTER TABLE RHNFAQCLASS
MODIFY(LABEL  NOT NULL);


--
-- 21. ORDERING  (Column) 
--
ALTER TABLE RHNFAQCLASS
MODIFY(ORDERING  NOT NULL);


--
-- 22. LABEL  (Column) 
--
ALTER TABLE RHNHARDWARECLASS
MODIFY(LABEL  NOT NULL);


--
-- 23. CLASS  (Column) 
--
ALTER TABLE RHNHARDWARECLASS
MODIFY(CLASS  NOT NULL);


--
-- 24. NAME  (Column) 
--
ALTER TABLE RHNHARDWAREPROPNAME
MODIFY(NAME  NOT NULL);


--
-- 25. LABEL  (Column) 
--
ALTER TABLE RHNMESSAGEPRIORITY
MODIFY(LABEL  NOT NULL);


--
-- 26. LABEL  (Column) 
--
ALTER TABLE RHNMESSAGETYPE
MODIFY(LABEL  NOT NULL);


--
-- 27. NAME  (Column) 
--
ALTER TABLE RHNMESSAGETYPE
MODIFY(NAME  NOT NULL);


--
-- 28. LABEL  (Column) 
--
ALTER TABLE RHNMONITORGRANULARITY
MODIFY(LABEL  NOT NULL);


--
-- 29. LABEL  (Column) 
--
ALTER TABLE RHNORGAVAILABLESTATES
MODIFY(LABEL  NOT NULL);


--
-- 30. CREATED  (Column) 
--
ALTER TABLE RHNORGAVAILABLESTATES
MODIFY(CREATED  NOT NULL);


--
-- 31. MODIFIED  (Column) 
--
ALTER TABLE RHNORGAVAILABLESTATES
MODIFY(MODIFIED  NOT NULL);


--
-- 32. FROM_STATE  (Column) 
--
ALTER TABLE RHNORGSTATETRANSITIONS
MODIFY(FROM_STATE  NOT NULL);


--
-- 33. TO_STATE  (Column) 
--
ALTER TABLE RHNORGSTATETRANSITIONS
MODIFY(TO_STATE  NOT NULL);


--
-- 34. LABEL  (Column) 
--
ALTER TABLE RHNPACKAGEARCH
MODIFY(LABEL  NOT NULL);


--
-- 35. NAME  (Column) 
--
ALTER TABLE RHNPACKAGEARCH
MODIFY(NAME  NOT NULL);


--
-- 36. CREATED  (Column) 
--
ALTER TABLE RHNPACKAGEARCH
MODIFY(CREATED  NOT NULL);


--
-- 37. MODIFIED  (Column) 
--
ALTER TABLE RHNPACKAGEARCH
MODIFY(MODIFIED  NOT NULL);


--
-- 38. CREATED  (Column) 
--
ALTER TABLE RHNPACKAGEFILEDELETEQUEUE
MODIFY(CREATED  NOT NULL);


--
-- 39. LABEL  (Column) 
--
ALTER TABLE RHNPRODUCTLINE
MODIFY(LABEL  NOT NULL);


--
-- 40. NAME  (Column) 
--
ALTER TABLE RHNPRODUCTLINE
MODIFY(NAME  NOT NULL);


--
-- 41. LAST_MODIFIED  (Column) 
--
ALTER TABLE RHNPRODUCTLINE
MODIFY(LAST_MODIFIED  NOT NULL);


--
-- 42. CREATED  (Column) 
--
ALTER TABLE RHNPRODUCTLINE
MODIFY(CREATED  NOT NULL);


--
-- 43. MODIFIED  (Column) 
--
ALTER TABLE RHNPRODUCTLINE
MODIFY(MODIFIED  NOT NULL);


--
-- 44. LABEL  (Column) 
--
ALTER TABLE RHNRELATIONSHIPTYPE
MODIFY(LABEL  NOT NULL);


--
-- 45. CREATED  (Column) 
--
ALTER TABLE RHNRELATIONSHIPTYPE
MODIFY(CREATED  NOT NULL);


--
-- 46. MODIFIED  (Column) 
--
ALTER TABLE RHNRELATIONSHIPTYPE
MODIFY(MODIFIED  NOT NULL);


--
-- 47. LABEL  (Column) 
--
ALTER TABLE RHNSATELLITECERT
MODIFY(LABEL  NOT NULL);


--
-- 48. CERT  (Column) 
--
ALTER TABLE RHNSATELLITECERT
MODIFY(CERT  NOT NULL);


--
-- 49. CREATED  (Column) 
--
ALTER TABLE RHNSATELLITECERT
MODIFY(CREATED  NOT NULL);


--
-- 50. MODIFIED  (Column) 
--
ALTER TABLE RHNSATELLITECERT
MODIFY(MODIFIED  NOT NULL);


--
-- 51. RHNSATELLITECERT  (Table) 
--
-- Difference : Column Order (No action taken) 

--
-- 52. LABEL  (Column) 
--
ALTER TABLE RHNSAVEDSEARCHTYPE
MODIFY(LABEL  NOT NULL);


--
-- 53. CREATED  (Column) 
--
ALTER TABLE RHNSAVEDSEARCHTYPE
MODIFY(CREATED  NOT NULL);


--
-- 54. MODIFIED  (Column) 
--
ALTER TABLE RHNSAVEDSEARCHTYPE
MODIFY(MODIFIED  NOT NULL);


--
-- 55. LABEL  (Column) 
--
ALTER TABLE RHNSERVERARCH
MODIFY(LABEL  NOT NULL);


--
-- 56. NAME  (Column) 
--
ALTER TABLE RHNSERVERARCH
MODIFY(NAME  NOT NULL);


--
-- 57. CREATED  (Column) 
--
ALTER TABLE RHNSERVERARCH
MODIFY(CREATED  NOT NULL);


--
-- 58. MODIFIED  (Column) 
--
ALTER TABLE RHNSERVERARCH
MODIFY(MODIFIED  NOT NULL);


--
-- 59. SERVER_ARCH_ID  (Column) 
--
ALTER TABLE RHNSERVERCHANNELARCHCOMPAT
MODIFY(SERVER_ARCH_ID  NOT NULL);


--
-- 60. CHANNEL_ARCH_ID  (Column) 
--
ALTER TABLE RHNSERVERCHANNELARCHCOMPAT
MODIFY(CHANNEL_ARCH_ID  NOT NULL);


--
-- 61. CREATED  (Column) 
--
ALTER TABLE RHNSERVERCHANNELARCHCOMPAT
MODIFY(CREATED  NOT NULL);


--
-- 62. MODIFIED  (Column) 
--
ALTER TABLE RHNSERVERCHANNELARCHCOMPAT
MODIFY(MODIFIED  NOT NULL);


--
-- 63. SERVER_ARCH_ID  (Column) 
--
ALTER TABLE RHNSERVERPACKAGEARCHCOMPAT
MODIFY(SERVER_ARCH_ID  NOT NULL);


--
-- 64. PACKAGE_ARCH_ID  (Column) 
--
ALTER TABLE RHNSERVERPACKAGEARCHCOMPAT
MODIFY(PACKAGE_ARCH_ID  NOT NULL);


--
-- 65. PREFERENCE  (Column) 
--
ALTER TABLE RHNSERVERPACKAGEARCHCOMPAT
MODIFY(PREFERENCE  NOT NULL);


--
-- 66. CREATED  (Column) 
--
ALTER TABLE RHNSERVERPACKAGEARCHCOMPAT
MODIFY(CREATED  NOT NULL);


--
-- 67. MODIFIED  (Column) 
--
ALTER TABLE RHNSERVERPACKAGEARCHCOMPAT
MODIFY(MODIFIED  NOT NULL);


--
-- 68. LABEL  (Column) 
--
ALTER TABLE RHNSURVEY
MODIFY(LABEL  NOT NULL);


--
-- 69. CLASS  (Column) 
--
ALTER TABLE RHNSURVEY
MODIFY(CLASS  NOT NULL);


--
-- 70. ACTIVE  (Column) 
--
ALTER TABLE RHNSURVEY
MODIFY(ACTIVE  NOT NULL);


--
-- 71. SURVEY_ID  (Column) 
--
ALTER TABLE RHNSURVEYQUESTION
MODIFY(SURVEY_ID  NOT NULL);


--
-- 72. LABEL  (Column) 
--
ALTER TABLE RHNSURVEYQUESTION
MODIFY(LABEL  NOT NULL);


--
-- 73. LABEL  (Column) 
--
ALTER TABLE RHNTEMPLATECATEGORY
MODIFY(LABEL  NOT NULL);


--
-- 74. DESCRIPTION  (Column) 
--
ALTER TABLE RHNTEMPLATECATEGORY
MODIFY(DESCRIPTION  NOT NULL);


--
-- 75. CREATED  (Column) 
--
ALTER TABLE RHNTEMPLATECATEGORY
MODIFY(CREATED  NOT NULL);


--
-- 76. MODIFIED  (Column) 
--
ALTER TABLE RHNTEMPLATECATEGORY
MODIFY(MODIFIED  NOT NULL);


--
-- 77. CATEGORY_ID  (Column) 
--
ALTER TABLE RHNTEMPLATESTRING
MODIFY(CATEGORY_ID  NOT NULL);


--
-- 78. LABEL  (Column) 
--
ALTER TABLE RHNTEMPLATESTRING
MODIFY(LABEL  NOT NULL);


--
-- 79. DESCRIPTION  (Column) 
--
ALTER TABLE RHNTEMPLATESTRING
MODIFY(DESCRIPTION  NOT NULL);


--
-- 80. CREATED  (Column) 
--
ALTER TABLE RHNTEMPLATESTRING
MODIFY(CREATED  NOT NULL);


--
-- 81. MODIFIED  (Column) 
--
ALTER TABLE RHNTEMPLATESTRING
MODIFY(MODIFIED  NOT NULL);


--
-- 82. LABEL  (Column) 
--
ALTER TABLE RHNTRANSACTIONOPERATION
MODIFY(LABEL  NOT NULL);


--
-- 83. CREATED  (Column) 
--
ALTER TABLE RHNTRANSACTIONOPERATION
MODIFY(CREATED  NOT NULL);


--
-- 84. MODIFIED  (Column) 
--
ALTER TABLE RHNTRANSACTIONOPERATION
MODIFY(MODIFIED  NOT NULL);


--
-- 85. OPERATION  (Column) 
--
ALTER TABLE RHNTRANSACTIONPACKAGE
MODIFY(OPERATION  NOT NULL);


--
-- 86. NAME_ID  (Column) 
--
ALTER TABLE RHNTRANSACTIONPACKAGE
MODIFY(NAME_ID  NOT NULL);


--
-- 87. EVR_ID  (Column) 
--
ALTER TABLE RHNTRANSACTIONPACKAGE
MODIFY(EVR_ID  NOT NULL);


--
-- 88. PACKAGE_ARCH_ID  (Column) 
--
ALTER TABLE RHNTRANSACTIONPACKAGE
MODIFY(PACKAGE_ARCH_ID  NOT NULL);


--
-- 89. LABEL  (Column) 
--
ALTER TABLE RHNUSERMESSAGESTATUS
MODIFY(LABEL  NOT NULL);


--
-- 90. LABEL  (Column) 
--
ALTER TABLE RHNUSERMESSAGETYPE
MODIFY(LABEL  NOT NULL);


--
-- 91. NAME  (Column) 
--
ALTER TABLE RHNUSERMESSAGETYPE
MODIFY(NAME  NOT NULL);


--
-- 92. LABEL  (Column) 
--
ALTER TABLE RHNUSERSURVEYSTATUSTYPE
MODIFY(LABEL  NOT NULL);


--
-- 93. ORG_ID  (Column) 
--
ALTER TABLE WEB_CUSTOMER_NOTIFICATION
MODIFY(ORG_ID  NOT NULL);


--
-- 94. RHN_ENTITLEMENTS  (Package Body) 
--
ALTER PACKAGE RHN_ENTITLEMENTS COMPILE BODY;

--
-- 95. LOOKUP_PACKAGE_CAPABILITY  (Function) 
--
ALTER FUNCTION LOOKUP_PACKAGE_CAPABILITY COMPILE;

--
-- 96. NAME_ID  (Column) 
--
ALTER TABLE RHNBLACKLISTOBSOLETES
MODIFY(NAME_ID  NOT NULL);


--
-- 97. EVR_ID  (Column) 
--
ALTER TABLE RHNBLACKLISTOBSOLETES
MODIFY(EVR_ID  NOT NULL);


--
-- 98. PACKAGE_ARCH_ID  (Column) 
--
ALTER TABLE RHNBLACKLISTOBSOLETES
MODIFY(PACKAGE_ARCH_ID  NOT NULL);


--
-- 99. IGNORE_NAME_ID  (Column) 
--
ALTER TABLE RHNBLACKLISTOBSOLETES
MODIFY(IGNORE_NAME_ID  NOT NULL);


--
-- 100. CREATED  (Column) 
--
ALTER TABLE RHNBLACKLISTOBSOLETES
MODIFY(CREATED  NOT NULL);


--
-- 101. MODIFIED  (Column) 
--
ALTER TABLE RHNBLACKLISTOBSOLETES
MODIFY(MODIFIED  NOT NULL);


--
-- 102. CHANNEL_ARCH_ID  (Column) 
--
ALTER TABLE RHNCHANNEL
MODIFY(CHANNEL_ARCH_ID  NOT NULL);


--
-- 103. RHNCHANNEL  (Table) 
--
-- Difference : Column Order (No action taken) 

--
-- 104. CHANNEL_FAMILY_ID  (Column) 
--
ALTER TABLE RHNCHANNELFAMILYLICENSE
MODIFY(CHANNEL_FAMILY_ID  NOT NULL);


--
-- 105. LICENSE_PATH  (Column) 
--
ALTER TABLE RHNCHANNELFAMILYLICENSE
MODIFY(LICENSE_PATH  NOT NULL);


--
-- 106. CREATED  (Column) 
--
ALTER TABLE RHNCHANNELFAMILYLICENSE
MODIFY(CREATED  NOT NULL);


--
-- 107. MODIFIED  (Column) 
--
ALTER TABLE RHNCHANNELFAMILYLICENSE
MODIFY(MODIFIED  NOT NULL);


--
-- 108. REFRESH_TIME  (Column) 
--
ALTER TABLE RHNCHANNELNEWESTPACKAGEAUDIT
MODIFY(REFRESH_TIME  NOT NULL);


--
-- 109. CHANNEL_ID  (Column) 
--
ALTER TABLE RHNCHANNELNEWESTPACKAGEAUDIT
MODIFY(CHANNEL_ID  NOT NULL);


--
-- 110. CALLER  (Column) 
--
ALTER TABLE RHNCHANNELNEWESTPACKAGEAUDIT
MODIFY(CALLER  NOT NULL);


--
-- 111. CHANNEL_ARCH_ID  (Column) 
--
ALTER TABLE RHNCHANNELPACKAGEARCHCOMPAT
MODIFY(CHANNEL_ARCH_ID  NOT NULL);


--
-- 112. PACKAGE_ARCH_ID  (Column) 
--
ALTER TABLE RHNCHANNELPACKAGEARCHCOMPAT
MODIFY(PACKAGE_ARCH_ID  NOT NULL);


--
-- 113. CREATED  (Column) 
--
ALTER TABLE RHNCHANNELPACKAGEARCHCOMPAT
MODIFY(CREATED  NOT NULL);


--
-- 114. MODIFIED  (Column) 
--
ALTER TABLE RHNCHANNELPACKAGEARCHCOMPAT
MODIFY(MODIFIED  NOT NULL);


--
-- 115. ORG_ID  (Column) 
--
ALTER TABLE RHNDAILYSUMMARYQUEUE
MODIFY(ORG_ID  NOT NULL);


--
-- 116. CREATED  (Column) 
--
ALTER TABLE RHNDAILYSUMMARYQUEUE
MODIFY(CREATED  NOT NULL);


--
-- 117. MODIFIED  (Column) 
--
ALTER TABLE RHNDAILYSUMMARYQUEUE
MODIFY(MODIFIED  NOT NULL);


--
-- 118. CHANNEL_ARCH_ID  (Column) 
--
ALTER TABLE RHNDISTCHANNELMAP
MODIFY(CHANNEL_ARCH_ID  NOT NULL);


--
-- 119. RHNDISTCHANNELMAP  (Table) 
--
-- Difference : Column Order (No action taken) 

--
-- 120. ERRATA_ID  (Column) 
--
ALTER TABLE RHNERRATAFILE
MODIFY(ERRATA_ID  NOT NULL);


--
-- 121. TYPE  (Column) 
--
ALTER TABLE RHNERRATAFILE
MODIFY(TYPE  NOT NULL);


--
-- 122. MD5SUM  (Column) 
--
ALTER TABLE RHNERRATAFILE
MODIFY(MD5SUM  NOT NULL);


--
-- 123. FILENAME  (Column) 
--
ALTER TABLE RHNERRATAFILE
MODIFY(FILENAME  NOT NULL);


--
-- 124. CREATED  (Column) 
--
ALTER TABLE RHNERRATAFILE
MODIFY(CREATED  NOT NULL);


--
-- 125. MODIFIED  (Column) 
--
ALTER TABLE RHNERRATAFILE
MODIFY(MODIFIED  NOT NULL);


--
-- 126. CHANNEL_ID  (Column) 
--
ALTER TABLE RHNERRATAFILECHANNEL
MODIFY(CHANNEL_ID  NOT NULL);


--
-- 127. ERRATA_FILE_ID  (Column) 
--
ALTER TABLE RHNERRATAFILECHANNEL
MODIFY(ERRATA_FILE_ID  NOT NULL);


--
-- 128. CREATED  (Column) 
--
ALTER TABLE RHNERRATAFILECHANNEL
MODIFY(CREATED  NOT NULL);


--
-- 129. MODIFIED  (Column) 
--
ALTER TABLE RHNERRATAFILECHANNEL
MODIFY(MODIFIED  NOT NULL);


--
-- 130. ERRATA_ID  (Column) 
--
ALTER TABLE RHNERRATANOTIFICATIONQUEUE
MODIFY(ERRATA_ID  NOT NULL);


--
-- 131. ORG_ID  (Column) 
--
ALTER TABLE RHNERRATANOTIFICATIONQUEUE
MODIFY(ORG_ID  NOT NULL);


--
-- 132. CREATED  (Column) 
--
ALTER TABLE RHNERRATANOTIFICATIONQUEUE
MODIFY(CREATED  NOT NULL);


--
-- 133. MODIFIED  (Column) 
--
ALTER TABLE RHNERRATANOTIFICATIONQUEUE
MODIFY(MODIFIED  NOT NULL);


--
-- 134. ERRATA_ID  (Column) 
--
ALTER TABLE RHNERRATAQUEUE
MODIFY(ERRATA_ID  NOT NULL);


--
-- 135. CREATED  (Column) 
--
ALTER TABLE RHNERRATAQUEUE
MODIFY(CREATED  NOT NULL);


--
-- 136. MODIFIED  (Column) 
--
ALTER TABLE RHNERRATAQUEUE
MODIFY(MODIFIED  NOT NULL);


--
-- 137. FROM_ERRATA_ID  (Column) 
--
ALTER TABLE RHNERRATARELATIONSHIP
MODIFY(FROM_ERRATA_ID  NOT NULL);


--
-- 138. TO_ERRATA_ID  (Column) 
--
ALTER TABLE RHNERRATARELATIONSHIP
MODIFY(TO_ERRATA_ID  NOT NULL);


--
-- 139. REL_TYPE_ID  (Column) 
--
ALTER TABLE RHNERRATARELATIONSHIP
MODIFY(REL_TYPE_ID  NOT NULL);


--
-- 140. CREATED  (Column) 
--
ALTER TABLE RHNERRATARELATIONSHIP
MODIFY(CREATED  NOT NULL);


--
-- 141. MODIFIED  (Column) 
--
ALTER TABLE RHNERRATARELATIONSHIP
MODIFY(MODIFIED  NOT NULL);


--
-- 142. PRIVATE  (Column) 
--
ALTER TABLE RHNFAQ
MODIFY(PRIVATE  NOT NULL);


--
-- 143. USAGE_COUNT  (Column) 
--
ALTER TABLE RHNFAQ
MODIFY(USAGE_COUNT  NOT NULL);


--
-- 144. CREATED  (Column) 
--
ALTER TABLE RHNFAQ
MODIFY(CREATED  NOT NULL);


--
-- 145. MODIFIED  (Column) 
--
ALTER TABLE RHNFAQ
MODIFY(MODIFIED  NOT NULL);


--
-- 146. FILE_ID  (Column) 
--
ALTER TABLE RHNFILELOCATION
MODIFY(FILE_ID  NOT NULL);


--
-- 147. LOCATION  (Column) 
--
ALTER TABLE RHNFILELOCATION
MODIFY(LOCATION  NOT NULL);


--
-- 148. CLASS_ID  (Column) 
--
ALTER TABLE RHNHARDWARE
MODIFY(CLASS_ID  NOT NULL);


--
-- 149. HARDWARE_ID  (Column) 
--
ALTER TABLE RHNHARDWAREPROPERTIES
MODIFY(HARDWARE_ID  NOT NULL);


--
-- 150. NAME_ID  (Column) 
--
ALTER TABLE RHNHARDWAREPROPERTIES
MODIFY(NAME_ID  NOT NULL);


--
-- 151. VALUE_ID  (Column) 
--
ALTER TABLE RHNHARDWAREPROPERTIES
MODIFY(VALUE_ID  NOT NULL);


--
-- 152. MESSAGE_TYPE  (Column) 
--
ALTER TABLE RHNMESSAGE
MODIFY(MESSAGE_TYPE  NOT NULL);


--
-- 153. PRIORITY  (Column) 
--
ALTER TABLE RHNMESSAGE
MODIFY(PRIORITY  NOT NULL);


--
-- 154. CREATED  (Column) 
--
ALTER TABLE RHNMESSAGE
MODIFY(CREATED  NOT NULL);


--
-- 155. MODIFIED  (Column) 
--
ALTER TABLE RHNMESSAGE
MODIFY(MODIFIED  NOT NULL);


--
-- 156. ORG_ID  (Column) 
--
ALTER TABLE RHNORGSTATE
MODIFY(ORG_ID  NOT NULL);


--
-- 157. STATE_ID  (Column) 
--
ALTER TABLE RHNORGSTATE
MODIFY(STATE_ID  NOT NULL);


--
-- 158. CREATED  (Column) 
--
ALTER TABLE RHNORGSTATE
MODIFY(CREATED  NOT NULL);


--
-- 159. MODIFIED  (Column) 
--
ALTER TABLE RHNORGSTATE
MODIFY(MODIFIED  NOT NULL);


--
-- 160. ORG_ID  (Column) 
--
ALTER TABLE RHNORGSTATELOG
MODIFY(ORG_ID  NOT NULL);


--
-- 161. OLD_STATE_ID  (Column) 
--
ALTER TABLE RHNORGSTATELOG
MODIFY(OLD_STATE_ID  NOT NULL);


--
-- 162. NEW_STATE_ID  (Column) 
--
ALTER TABLE RHNORGSTATELOG
MODIFY(NEW_STATE_ID  NOT NULL);


--
-- 163. CREATED  (Column) 
--
ALTER TABLE RHNORGSTATELOG
MODIFY(CREATED  NOT NULL);


--
-- 164. PACKAGE_ARCH_ID  (Column) 
--
ALTER TABLE RHNPACKAGE
MODIFY(PACKAGE_ARCH_ID  NOT NULL);


--
-- 165. LAST_MODIFIED  (Column) 
--
ALTER TABLE RHNPACKAGE
MODIFY(LAST_MODIFIED  NOT NULL);


--
-- 171. LAST_MODIFIED  (Column) 
--
ALTER TABLE RHNPACKAGESOURCE
MODIFY(LAST_MODIFIED  NOT NULL);


--
-- 172. RHNPACKAGESOURCE  (Table) 
--
-- Difference : Column Order (No action taken) 

--
-- 173. ORG_ID  (Column) 
--
ALTER TABLE RHNPAYLOADERCONVERSION
MODIFY(ORG_ID  NOT NULL);


--
-- 174. REASON  (Column) 
--
ALTER TABLE RHNPAYLOADERCONVERSION
MODIFY(REASON  NOT NULL);


--
-- 175. CREATED  (Column) 
--
ALTER TABLE RHNPAYLOADERCONVERSION
MODIFY(CREATED  NOT NULL);


--
-- 176. LABEL  (Column) 
--
ALTER TABLE RHNPRODUCT
MODIFY(LABEL  NOT NULL);


--
-- 177. NAME  (Column) 
--
ALTER TABLE RHNPRODUCT
MODIFY(NAME  NOT NULL);


--
-- 178. PRODUCT_LINE_ID  (Column) 
--
ALTER TABLE RHNPRODUCT
MODIFY(PRODUCT_LINE_ID  NOT NULL);


--
-- 179. LAST_MODIFIED  (Column) 
--
ALTER TABLE RHNPRODUCT
MODIFY(LAST_MODIFIED  NOT NULL);


--
-- 180. CREATED  (Column) 
--
ALTER TABLE RHNPRODUCT
MODIFY(CREATED  NOT NULL);


--
-- 181. MODIFIED  (Column) 
--
ALTER TABLE RHNPRODUCT
MODIFY(MODIFIED  NOT NULL);


--
-- 182. CHANNEL_ID  (Column) 
--
ALTER TABLE RHNPRODUCTCHANNEL
MODIFY(CHANNEL_ID  NOT NULL);


--
-- 183. PRODUCT_ID  (Column) 
--
ALTER TABLE RHNPRODUCTCHANNEL
MODIFY(PRODUCT_ID  NOT NULL);


--
-- 184. CREATED  (Column) 
--
ALTER TABLE RHNPRODUCTCHANNEL
MODIFY(CREATED  NOT NULL);


--
-- 185. MODIFIED  (Column) 
--
ALTER TABLE RHNPRODUCTCHANNEL
MODIFY(MODIFIED  NOT NULL);


--
-- 186. PROCESSED  (Column) 
--
ALTER TABLE RHNSNPERRATAQUEUE
MODIFY(PROCESSED  DEFAULT (0));

--
-- 187. MESSAGE_ID  (Column) 
--
ALTER TABLE RHNTEXTMESSAGE
MODIFY(MESSAGE_ID  NOT NULL);


--
-- 188. MESSAGE_BODY  (Column) 
--
ALTER TABLE RHNTEXTMESSAGE
MODIFY(MESSAGE_BODY  NOT NULL);


--
-- 189. CREATED  (Column) 
--
ALTER TABLE RHNTEXTMESSAGE
MODIFY(CREATED  NOT NULL);


--
-- 190. MODIFIED  (Column) 
--
ALTER TABLE RHNTEXTMESSAGE
MODIFY(MODIFIED  NOT NULL);


--
-- 191. WEB_USER_PERSONAL_INFO  (Table) 
--
-- Difference : Column Order (No action taken) 

--
-- 192. WEB_USER_SITE_INFO  (Table) 
--
-- Difference : Column Order (No action taken) 

--
-- 193. QUEUE_ERRATA  (Procedure) 
--
ALTER PROCEDURE QUEUE_ERRATA COMPILE;


--
-- 195. RHN_PKG_CONFLICTS_MOD_TRIG  (Trigger) 
--
ALTER TRIGGER RHN_PKG_CONFLICTS_MOD_TRIG COMPILE;

--
-- 196. RHN_PKG_OBSOLETES_MOD_TRIG  (Trigger) 
--
ALTER TRIGGER RHN_PKG_OBSOLETES_MOD_TRIG COMPILE;

--
-- 197. RHN_PKG_PROVIDES_MOD_TRIG  (Trigger) 
--
ALTER TRIGGER RHN_PKG_PROVIDES_MOD_TRIG COMPILE;

--
-- 198. RHN_PKG_REQUIRES_MOD_TRIG  (Trigger) 
--
ALTER TRIGGER RHN_PKG_REQUIRES_MOD_TRIG COMPILE;

--
-- 199. CHANNEL_ID  (Column) 
--
ALTER TABLE RHNCHANNELNEWESTPACKAGE
MODIFY(CHANNEL_ID  NOT NULL);


--
-- 200. NAME_ID  (Column) 
--
ALTER TABLE RHNCHANNELNEWESTPACKAGE
MODIFY(NAME_ID  NOT NULL);


--
-- 201. EVR_ID  (Column) 
--
ALTER TABLE RHNCHANNELNEWESTPACKAGE
MODIFY(EVR_ID  NOT NULL);


--
-- 202. PACKAGE_ARCH_ID  (Column) 
--
ALTER TABLE RHNCHANNELNEWESTPACKAGE
MODIFY(PACKAGE_ARCH_ID  NOT NULL);


--
-- 203. PACKAGE_ID  (Column) 
--
ALTER TABLE RHNCHANNELNEWESTPACKAGE
MODIFY(PACKAGE_ID  NOT NULL);


--
-- 204. ADDRESS  (Column) 
--
ALTER TABLE RHNEMAILADDRESS
MODIFY(ADDRESS  NOT NULL);


--
-- 205. USER_ID  (Column) 
--
ALTER TABLE RHNEMAILADDRESS
MODIFY(USER_ID  NOT NULL);


--
-- 206. STATE_ID  (Column) 
--
ALTER TABLE RHNEMAILADDRESS
MODIFY(STATE_ID  NOT NULL);


--
-- 207. CREATED  (Column) 
--
ALTER TABLE RHNEMAILADDRESS
MODIFY(CREATED  NOT NULL);


--
-- 208. MODIFIED  (Column) 
--
ALTER TABLE RHNEMAILADDRESS
MODIFY(MODIFIED  NOT NULL);


--
-- 209. USER_ID  (Column) 
--
ALTER TABLE RHNEMAILADDRESSLOG
MODIFY(USER_ID  NOT NULL);


--
-- 210. ADDRESS  (Column) 
--
ALTER TABLE RHNEMAILADDRESSLOG
MODIFY(ADDRESS  NOT NULL);


--
-- 211. CREATED  (Column) 
--
ALTER TABLE RHNEMAILADDRESSLOG
MODIFY(CREATED  NOT NULL);


--
-- 212. PACKAGE_ID  (Column) 
--
ALTER TABLE RHNERRATAFILEPACKAGE
MODIFY(PACKAGE_ID  NOT NULL);


--
-- 213. ERRATA_FILE_ID  (Column) 
--
ALTER TABLE RHNERRATAFILEPACKAGE
MODIFY(ERRATA_FILE_ID  NOT NULL);


--
-- 214. CREATED  (Column) 
--
ALTER TABLE RHNERRATAFILEPACKAGE
MODIFY(CREATED  NOT NULL);


--
-- 215. MODIFIED  (Column) 
--
ALTER TABLE RHNERRATAFILEPACKAGE
MODIFY(MODIFIED  NOT NULL);


--
-- 216. PACKAGE_ID  (Column) 
--
ALTER TABLE RHNERRATAFILEPACKAGESOURCE
MODIFY(PACKAGE_ID  NOT NULL);


--
-- 217. ERRATA_FILE_ID  (Column) 
--
ALTER TABLE RHNERRATAFILEPACKAGESOURCE
MODIFY(ERRATA_FILE_ID  NOT NULL);


--
-- 218. CREATED  (Column) 
--
ALTER TABLE RHNERRATAFILEPACKAGESOURCE
MODIFY(CREATED  NOT NULL);


--
-- 219. MODIFIED  (Column) 
--
ALTER TABLE RHNERRATAFILEPACKAGESOURCE
MODIFY(MODIFIED  NOT NULL);


--
-- 220. ERRATA_ID  (Column) 
--
ALTER TABLE RHNERRATAFILETMP
MODIFY(ERRATA_ID  NOT NULL);


--
-- 221. TYPE  (Column) 
--
ALTER TABLE RHNERRATAFILETMP
MODIFY(TYPE  NOT NULL);


--
-- 222. MD5SUM  (Column) 
--
ALTER TABLE RHNERRATAFILETMP
MODIFY(MD5SUM  NOT NULL);


--
-- 223. FILENAME  (Column) 
--
ALTER TABLE RHNERRATAFILETMP
MODIFY(FILENAME  NOT NULL);


--
-- 224. CREATED  (Column) 
--
ALTER TABLE RHNERRATAFILETMP
MODIFY(CREATED  NOT NULL);


--
-- 225. MODIFIED  (Column) 
--
ALTER TABLE RHNERRATAFILETMP
MODIFY(MODIFIED  NOT NULL);


--
-- 226. FROM_ERRATA_ID  (Column) 
--
ALTER TABLE RHNERRATARELATIONSHIPTMP
MODIFY(FROM_ERRATA_ID  NOT NULL);


--
-- 227. TO_ERRATA_ID  (Column) 
--
ALTER TABLE RHNERRATARELATIONSHIPTMP
MODIFY(TO_ERRATA_ID  NOT NULL);


--
-- 228. REL_TYPE_ID  (Column) 
--
ALTER TABLE RHNERRATARELATIONSHIPTMP
MODIFY(REL_TYPE_ID  NOT NULL);


--
-- 229. CREATED  (Column) 
--
ALTER TABLE RHNERRATARELATIONSHIPTMP
MODIFY(CREATED  NOT NULL);


--
-- 230. MODIFIED  (Column) 
--
ALTER TABLE RHNERRATARELATIONSHIPTMP
MODIFY(MODIFIED  NOT NULL);


--
-- 231. FILE_ID  (Column) 
--
ALTER TABLE RHNFILEDOWNLOAD
MODIFY(FILE_ID  NOT NULL);


--
-- 232. LOCATION  (Column) 
--
ALTER TABLE RHNFILEDOWNLOAD
MODIFY(LOCATION  NOT NULL);


--
-- 233. REQUESTOR_IP  (Column) 
--
ALTER TABLE RHNFILEDOWNLOAD
MODIFY(REQUESTOR_IP  NOT NULL);


--
-- 234. START_TIME  (Column) 
--
ALTER TABLE RHNFILEDOWNLOAD
MODIFY(START_TIME  NOT NULL);


--
-- 235. ENTITLEMENT_LEVEL  (Column) 
--
ALTER TABLE RHNREGTOKEN
MODIFY(ENTITLEMENT_LEVEL  NOT NULL);


--
-- 236. WEB_CONTACT_ID  (Column) 
--
ALTER TABLE RHNSAVEDSEARCH
MODIFY(WEB_CONTACT_ID  NOT NULL);


--
-- 237. NAME  (Column) 
--
ALTER TABLE RHNSAVEDSEARCH
MODIFY(NAME  NOT NULL);


--
-- 238. TYPE  (Column) 
--
ALTER TABLE RHNSAVEDSEARCH
MODIFY(TYPE  NOT NULL);


--
-- 239. SEARCH_STRING  (Column) 
--
ALTER TABLE RHNSAVEDSEARCH
MODIFY(SEARCH_STRING  NOT NULL);


--
-- 240. SEARCH_SET  (Column) 
--
ALTER TABLE RHNSAVEDSEARCH
MODIFY(SEARCH_SET  NOT NULL);


--
-- 241. SEARCH_FIELD  (Column) 
--
ALTER TABLE RHNSAVEDSEARCH
MODIFY(SEARCH_FIELD  NOT NULL);


--
-- 242. INVERT  (Column) 
--
ALTER TABLE RHNSAVEDSEARCH
MODIFY(INVERT  NOT NULL);


--
-- 243. SERVER_ARCH_ID  (Column) 
--
ALTER TABLE RHNSERVER
MODIFY(SERVER_ARCH_ID  NOT NULL);


--
-- 244. AUTO_DELIVER  (Column) 
--
ALTER TABLE RHNSERVER
MODIFY(AUTO_DELIVER  NOT NULL);


--
-- 245. AUTO_UPDATE  (Column) 
--
ALTER TABLE RHNSERVER
MODIFY(AUTO_UPDATE  NOT NULL);


--
-- 246. RHNSERVER  (Table) 
--
-- Difference : Column Order (No action taken) 

--
-- 247. REMAINING_TRIES  (Column) 
--
ALTER TABLE RHNSERVERACTION
MODIFY(REMAINING_TRIES  NOT NULL);


--
-- 248. RHNSERVERACTION  (Table) 
--
-- Difference : Column Order (No action taken) 

--
-- 249. SERVER_ID  (Column) 
--
ALTER TABLE RHNSERVEREVENT
MODIFY(SERVER_ID  NOT NULL);


--
-- 250. DETAILS  (Column) 
--
ALTER TABLE RHNSERVEREVENT
MODIFY(DETAILS  NOT NULL);


--
-- 251. CREATED  (Column) 
--
ALTER TABLE RHNSERVEREVENT
MODIFY(CREATED  NOT NULL);


--
-- 252. MODIFIED  (Column) 
--
ALTER TABLE RHNSERVEREVENT
MODIFY(MODIFIED  NOT NULL);


--
-- 253. SERVER_ID  (Column) 
--
ALTER TABLE RHNSERVERHARDWARE
MODIFY(SERVER_ID  NOT NULL);


--
-- 254. HARDWARE_ID  (Column) 
--
ALTER TABLE RHNSERVERHARDWARE
MODIFY(HARDWARE_ID  NOT NULL);


--
-- 255. CREATED  (Column) 
--
ALTER TABLE RHNSERVERHARDWARE
MODIFY(CREATED  NOT NULL);


--
-- 256. MODIFIED  (Column) 
--
ALTER TABLE RHNSERVERHARDWARE
MODIFY(MODIFIED  NOT NULL);


--
-- 257. SERVER_ID  (Column) 
--
ALTER TABLE RHNSERVERINSTALLINFO
MODIFY(SERVER_ID  NOT NULL);


--
-- 258. INSTALL_METHOD  (Column) 
--
ALTER TABLE RHNSERVERINSTALLINFO
MODIFY(INSTALL_METHOD  NOT NULL);


--
-- 259. CREATED  (Column) 
--
ALTER TABLE RHNSERVERINSTALLINFO
MODIFY(CREATED  NOT NULL);


--
-- 260. MODIFIED  (Column) 
--
ALTER TABLE RHNSERVERINSTALLINFO
MODIFY(MODIFIED  NOT NULL);


--
-- 261. SERVER_ID  (Column) 
--
ALTER TABLE RHNSERVERMESSAGE
MODIFY(SERVER_ID  NOT NULL);


--
-- 262. MESSAGE_ID  (Column) 
--
ALTER TABLE RHNSERVERMESSAGE
MODIFY(MESSAGE_ID  NOT NULL);


--
-- 263. CREATED  (Column) 
--
ALTER TABLE RHNSERVERMESSAGE
MODIFY(CREATED  NOT NULL);


--
-- 264. MODIFIED  (Column) 
--
ALTER TABLE RHNSERVERMESSAGE
MODIFY(MODIFIED  NOT NULL);


--
-- 265. SERVER_ID  (Column) 
--
ALTER TABLE RHNSERVERNETINTERFACE
MODIFY(SERVER_ID  NOT NULL);


--
-- 266. NAME  (Column) 
--
ALTER TABLE RHNSERVERNETINTERFACE
MODIFY(NAME  NOT NULL);


--
-- 267. CREATED  (Column) 
--
ALTER TABLE RHNSERVERNETINTERFACE
MODIFY(CREATED  NOT NULL);


--
-- 268. MODIFIED  (Column) 
--
ALTER TABLE RHNSERVERNETINTERFACE
MODIFY(MODIFIED  NOT NULL);


--
-- 269. QUESTION_ID  (Column) 
--
ALTER TABLE RHNSURVEYQUESTIONRESPONSE
MODIFY(QUESTION_ID  NOT NULL);


--
-- 270. USER_ID  (Column) 
--
ALTER TABLE RHNSURVEYQUESTIONRESPONSE
MODIFY(USER_ID  NOT NULL);


--
-- 271. SERVER_ID  (Column) 
--
ALTER TABLE RHNTRANSACTION
MODIFY(SERVER_ID  NOT NULL);


--
-- 272. TIMESTAMP  (Column) 
--
ALTER TABLE RHNTRANSACTION
MODIFY(TIMESTAMP  NOT NULL);


--
-- 273. RPM_TRANS_ID  (Column) 
--
ALTER TABLE RHNTRANSACTION
MODIFY(RPM_TRANS_ID  NOT NULL);


--
-- 274. CREATED  (Column) 
--
ALTER TABLE RHNTRANSACTION
MODIFY(CREATED  NOT NULL);


--
-- 275. MODIFIED  (Column) 
--
ALTER TABLE RHNTRANSACTION
MODIFY(MODIFIED  NOT NULL);


--
-- 276. TRANSACTION_ID  (Column) 
--
ALTER TABLE RHNTRANSACTIONELEMENT
MODIFY(TRANSACTION_ID  NOT NULL);


--
-- 277. TRANSACTION_PACKAGE_ID  (Column) 
--
ALTER TABLE RHNTRANSACTIONELEMENT
MODIFY(TRANSACTION_PACKAGE_ID  NOT NULL);


--
-- 278. SHOW_SYSTEM_GROUP_LIST  (Column) 
--
ALTER TABLE RHNUSERINFO
MODIFY(SHOW_SYSTEM_GROUP_LIST  NOT NULL);


--
-- 279. AGREED_TO_ASDE_TERMS  (Column) 
--
ALTER TABLE RHNUSERINFO
MODIFY(AGREED_TO_ASDE_TERMS  NOT NULL);


--
-- 280. CREATED  (Column) 
--
ALTER TABLE RHNUSERINFO
MODIFY(CREATED  NOT NULL);


--
-- 281. MODIFIED  (Column) 
--
ALTER TABLE RHNUSERINFO
MODIFY(MODIFIED  NOT NULL);


--
-- 282. RHNUSERINFO  (Table) 
--
-- Difference : Column Order (No action taken) 

--
-- 283. USER_ID  (Column) 
--
ALTER TABLE RHNUSERMESSAGE
MODIFY(USER_ID  NOT NULL);


--
-- 284. MESSAGE_ID  (Column) 
--
ALTER TABLE RHNUSERMESSAGE
MODIFY(MESSAGE_ID  NOT NULL);


--
-- 285. STATUS  (Column) 
--
ALTER TABLE RHNUSERMESSAGE
MODIFY(STATUS  NOT NULL);


--
-- 286. USER_ID  (Column) 
--
ALTER TABLE RHNUSERSURVEYSTATUS
MODIFY(USER_ID  NOT NULL);


--
-- 287. SURVEY_ID  (Column) 
--
ALTER TABLE RHNUSERSURVEYSTATUS
MODIFY(SURVEY_ID  NOT NULL);


--
-- 288. STATUS  (Column) 
--
ALTER TABLE RHNUSERSURVEYSTATUS
MODIFY(STATUS  NOT NULL);


--
-- 295. SERVER_ID  (Column) 
--
ALTER TABLE RHNACTIONPACKAGEREMOVALFAILURE
MODIFY(SERVER_ID  NOT NULL);


--
-- 296. ACTION_ID  (Column) 
--
ALTER TABLE RHNACTIONPACKAGEREMOVALFAILURE
MODIFY(ACTION_ID  NOT NULL);


--
-- 297. NAME_ID  (Column) 
--
ALTER TABLE RHNACTIONPACKAGEREMOVALFAILURE
MODIFY(NAME_ID  NOT NULL);


--
-- 298. EVR_ID  (Column) 
--
ALTER TABLE RHNACTIONPACKAGEREMOVALFAILURE
MODIFY(EVR_ID  NOT NULL);


--
-- 299. CAPABILITY_ID  (Column) 
--
ALTER TABLE RHNACTIONPACKAGEREMOVALFAILURE
MODIFY(CAPABILITY_ID  NOT NULL);


--
-- 300. FLAGS  (Column) 
--
ALTER TABLE RHNACTIONPACKAGEREMOVALFAILURE
MODIFY(FLAGS  NOT NULL);


--
-- 301. SENSE  (Column) 
--
ALTER TABLE RHNACTIONPACKAGEREMOVALFAILURE
MODIFY(SENSE  NOT NULL);


--
-- 302. ACTION_ID  (Column) 
--
ALTER TABLE RHNACTIONTRANSACTIONS
MODIFY(ACTION_ID  NOT NULL);


--
-- 303. FROM_TRANS_ID  (Column) 
--
ALTER TABLE RHNACTIONTRANSACTIONS
MODIFY(FROM_TRANS_ID  NOT NULL);


--
-- 304. TO_TRANS_ID  (Column) 
--
ALTER TABLE RHNACTIONTRANSACTIONS
MODIFY(TO_TRANS_ID  NOT NULL);


--
-- 305. CHANNEL_FAMILY_ID  (Column) 
--
ALTER TABLE RHNCHANNELFAMILYLICENSECONSENT
MODIFY(CHANNEL_FAMILY_ID  NOT NULL);


--
-- 306. USER_ID  (Column) 
--
ALTER TABLE RHNCHANNELFAMILYLICENSECONSENT
MODIFY(USER_ID  NOT NULL);


--
-- 307. SERVER_ID  (Column) 
--
ALTER TABLE RHNCHANNELFAMILYLICENSECONSENT
MODIFY(SERVER_ID  NOT NULL);


--
-- 308. CREATED  (Column) 
--
ALTER TABLE RHNCHANNELFAMILYLICENSECONSENT
MODIFY(CREATED  NOT NULL);


--
-- 309. MODIFIED  (Column) 
--
ALTER TABLE RHNCHANNELFAMILYLICENSECONSENT
MODIFY(MODIFIED  NOT NULL);


--
-- 310. CPU_ARCH_ID  (Column) 
--
ALTER TABLE RHNCPU
MODIFY(CPU_ARCH_ID  NOT NULL);


--
-- 311. RHNCPU  (Table) 
--
-- Difference : Column Order (No action taken) 

--
-- 312. BATCH_ID  (Column) 
--
ALTER TABLE RHNMONITOR
MODIFY(BATCH_ID  NOT NULL);


--
-- 313. SERVER_ID  (Column) 
--
ALTER TABLE RHNMONITOR
MODIFY(SERVER_ID  NOT NULL);


--
-- 314. PROBE_ID  (Column) 
--
ALTER TABLE RHNMONITOR
MODIFY(PROBE_ID  NOT NULL);


--
-- 315. TIMESTAMP  (Column) 
--
ALTER TABLE RHNMONITOR
MODIFY(TIMESTAMP  NOT NULL);


--
-- 316. GRANULARITY  (Column) 
--
ALTER TABLE RHNMONITOR
MODIFY(GRANULARITY  NOT NULL);


--
-- 317. SERVER_ID  (Column) 
--
ALTER TABLE RHNSATELLITECHANNELFAMILY
MODIFY(SERVER_ID  NOT NULL);


--
-- 318. CHANNEL_FAMILY_ID  (Column) 
--
ALTER TABLE RHNSATELLITECHANNELFAMILY
MODIFY(CHANNEL_FAMILY_ID  NOT NULL);


--
-- 319. CREATED  (Column) 
--
ALTER TABLE RHNSATELLITECHANNELFAMILY
MODIFY(CREATED  NOT NULL);


--
-- 320. MODIFIED  (Column) 
--
ALTER TABLE RHNSATELLITECHANNELFAMILY
MODIFY(MODIFIED  NOT NULL);


--
-- 321. PRODUCT  (Column) 
--
ALTER TABLE RHNSATELLITEINFO
MODIFY(PRODUCT  NOT NULL);


--
-- 322. OWNER  (Column) 
--
ALTER TABLE RHNSATELLITEINFO
MODIFY(OWNER  NOT NULL);


--
-- 323. ENTERPRISE_SLOTS  (Column) 
--
ALTER TABLE RHNSATELLITEINFO
MODIFY(ENTERPRISE_SLOTS  NOT NULL);


--
-- 324. CREATED  (Column) 
--
ALTER TABLE RHNSATELLITEINFO
MODIFY(CREATED  NOT NULL);


--
-- 325. MODIFIED  (Column) 
--
ALTER TABLE RHNSATELLITEINFO
MODIFY(MODIFIED  NOT NULL);


--
-- 326. PROCESS_ERRATA_CACHE_QUEUE  (Procedure) 
--
ALTER PROCEDURE PROCESS_ERRATA_CACHE_QUEUE COMPILE;

-----------------------
--------------------------------------------------------------------------
-- Play this script in TAW02@TAW02 to make it look like TAW01@TAW01
--                                                                      --
-- Please review the script before using it to make sure it won't       --
-- cause any unacceptable data loss.                                    --
--                                                                      --
-- TAW02@TAW02 Schema Extracted by User TAW02 
-- TAW01@TAW01 Schema Extracted by User TAW01 
--------------------------------------------------------------------------
--
-- 1. RHNSATELLITECERT  (Table) 
--
-- Difference : Column Order (No action taken) 

--
-- 2. RHNCHANNEL  (Table) 
--
-- Difference : Column Order (No action taken) 

--
-- 3. FROM_CHANNEL_ID  (Column) 
--
ALTER TABLE RHNCHANNELRELATIONSHIP
MODIFY(FROM_CHANNEL_ID  NOT NULL);


--
-- 4. TO_CHANNEL_ID  (Column) 
--
ALTER TABLE RHNCHANNELRELATIONSHIP
MODIFY(TO_CHANNEL_ID  NOT NULL);


--
-- 5. REL_TYPE_ID  (Column) 
--
ALTER TABLE RHNCHANNELRELATIONSHIP
MODIFY(REL_TYPE_ID  NOT NULL);


--
-- 6. CREATED  (Column) 
--
ALTER TABLE RHNCHANNELRELATIONSHIP
MODIFY(CREATED  NOT NULL);


--
-- 7. MODIFIED  (Column) 
--
ALTER TABLE RHNCHANNELRELATIONSHIP
MODIFY(MODIFIED  NOT NULL);


---------------------- patches from the 66 to 72 builds
-- revision 1.10
CREATE OR REPLACE VIEW
rhnServerNeededPackageView
(
    org_id,
    server_id,
    errata_id,
    package_id
)
AS
SELECT   S.org_id,
         S.id,
	  (SELECT EP.errata_id
	     FROM rhnErrataPackage EP,
	          rhnChannelErrata CE,
		  rhnServerChannel SC
	    WHERE SC.server_id = S.id
	      AND SC.channel_id = CE.channel_id
	      AND CE.errata_id = EP.errata_id
	      AND EP.package_id = P.id
	      AND ROWNUM = 1),
	 P.id
FROM
	 rhnPackage P,
	 rhnServerPackageArchCompat SPAC,
	 rhnPackageEVR P_EVR,
	 rhnPackageEVR SP_EVR,
	 rhnServerPackage SP,
	 rhnChannelPackage CP,
	 rhnServerChannel SC,
         rhnServer S
WHERE
    	 SC.server_id = S.id
  AND  	 SC.channel_id = CP.channel_id
  AND    CP.package_id = P.id
  AND    p.package_arch_id = spac.package_arch_id
  AND    spac.server_arch_id = s.server_arch_id
  AND    SP_EVR.id = SP.evr_id
  AND    P_EVR.id = P.evr_id
  AND    SP.server_id = S.id
  AND    SP.name_id = P.name_id
  AND    SP.evr_id != P.evr_id
  AND    SP_EVR.evr < P_EVR.evr
  AND    SP_EVR.evr = (SELECT MAX(PE.evr) FROM rhnServerPackage SP2, rhnPackageEvr PE WHERE PE.id = SP2.evr_id AND SP2.server_id = SP.server_id AND SP2.name_id = SP.name_id)
/

alter table rhnEmailAddress drop constraint rhn_eaddress_uid_fk;
alter table rhnEmailAddress
        add constraint rhn_eaddress_uid_fk
        foreign key ( user_id )
        references web_contact(id) on delete cascade;

UPDATE rhnVersionInfo
   SET evr_id = lookup_evr(NULL, '2.5', '91')
 WHERE name_id = lookup_package_name('rhn-satellite-schema');
                                                                                                                                  
commit;

